#!/usr/bin/python
"""
Copyright 2014 Andrew Russell

This file is part of PotionWars.
PotionWars is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

PotionWars is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with PotionWars.  If not, see <http://www.gnu.org/licenses/>.
"""
from pygame.locals import *
from universal import *
import sp_rpg_engine as eng
import townmode
from townmode import offStage
from townmode import Room
from conversation import Node
import spells_PotionWars
import conversation
import person as p
from person import himher, HimHer, hisher, HisHer, heshe, HeShe, himselfherself, HimselfHerself, mistermiss, MisterMiss, manwoman, ManWoman, hishers, HisHers, boygirl,\
        BoyGirl,\
        manlady, ManLady, kingqueen, KingQueen, lordlady, LordLady, brothersister, pigcow, PigCow, BrotherSister, menwomen, MenWomen, sirmaam, SirMaam, bastardbitch,\
        BastardBitch
import episode
import itemspotionwars
from items import emptyItem, emptyWeapon, emptyUpperArmor, emptyLowerArmor, emptyUnderwear
import items
from shopmode import shop_mode
import music
import combat
import universal

import titleScreen
import os
import dungeonmode
import positions
import random
import copy
import pwenemies
import sys

universal.set_author('Andrew Russell')
universal.set_programmer('Andrew Russell')
universal.set_author_email('sprpgs@gmail.com')
universal.set_programmer_email('sprpgs@gmail.com')
universal.set_author_email_bugs(universal.authorEmail + '+PWBugs')
universal.set_programmer_email_bugs(universal.programmerEmail + '+PWBugs')
universal.set_name('Potion Wars')
titleScreen.title('Pandemonium Cycle')
titleScreen.subtitle('The Potion Wars')
titleScreen.set_title_image(universal.resource_path('PotionWarsTitleScreen'), 'png', 6)


def spanked_episode_1():
    return one_in_keywords(['Ildri_spanked_you_unjustly', 'spanked_by_Airell', 'spanked_by_Cosima', 'Maria_spanked_you', 'spectral_caned', 'met_Mai', 
        'spanked_by_Necia'])

def name():
    return p.PC.name

def nickname():
    return p.PC.nickname

def names():
    return name() + "'s"

def add_keyword(keyword):
    p.PC.add_keyword(keyword)

def remove_keyword(keyword):
    if keyword in keywords():
        keywords().remove(keyword)

def keywords():
    return p.PC.keywords

def one_in_keywords(keywordList):
    return reduce(lambda x, y : x or y, [x in keywords() for x in keywordList])

def many_in_keywords(keywordList):
    return len([x for x in keywordList if x in keywords()]) > 1

def skirt_or_dress(lowerClothing=None):
    if lowerClothing is None:
        lowerClothing = p.PC.clothing_below_the_waist()
    return lowerClothing.armorType == items.Skirt.armorType or lowerClothing.armorType == items.Dress.armorType

def skirt_or_pants(lowerClothing=None):
    if lowerClothing is None:
        lowerClothing = p.PC.clothing_below_the_waist()
    return lowerClothing.armorType == items.Skirt.armorType or lowerClothing.armorType == items.Pants.armorType

def pants(lowerClothing=None):
    if lowerClothing is None:
        lowerClothing = p.PC.clothing_below_the_waist()
    return lowerClothing.armorType == items.Pants.armorType

def skirt(lowerClothing=None):
    if lowerClothing is None:
        lowerClothing = p.PC.clothing_below_the_waist()
    return lowerClothing.armorType == items.Skirt.armorType

def dress(lowerClothing=None):
    if lowerClothing is None:
        lowerClothing = p.PC.clothing_below_the_waist()
    return lowerClothing.armorType == items.Dress.armorType

def wearing_underwear():
    return p.PC.underwear().name != items.emptyUnderwear.name

def inventory():
    return p.PC.inventory

def increment_spankings_taken():
    p.PC.numSpankings += 1

def increment_spankings_given():
    p.PC.numSpankingsGiven += 1

def lower_clothing():
    return p.PC.lower_clothing()
def underwear():
    return p.PC.underwear()
def shirt():
    return p.PC.shirt()
def weapon():
    return p.PC.weapon()

def no_pants():
    return p.PC.lower_clothing().name == items.emptyLowerArmor.name

def no_underwear():
    return p.PC.underwear().name == items.emptyUnderwear.name

def baring_underwear():
    return p.PC.underwear().baring

def wearing_pants():
    return p.PC.lower_clothing().armorType == items.Pants.armorType

def wearing_skirt():
    return p.PC.lower_clothing().armorType == items.Skirt.armorType

def wearing_dress():
    return p.PC.lower_clothing().armorType == items.Dress.armorType

def wearing_skirt_or_pants():
    return wearing_pants() or wearing_skirt()

def wearing_skirt_or_dress():
    return wearing_skirt() or wearing_dress()

def wearing_skirt_or_dress_or_pants():
    return wearing_skirt() or wearing_dress() or wearing_pants()

def no_shirt():
    return p.PC.shirt().name == items.emptyUpperArmor.name
#-------------------------------------Music Files----------------------------------------
CHURCH = music.decrypt(universal.resource_path('POL-apparition-long.wav'))
GUARDS = music.decrypt(universal.resource_path('POL-war-victims-long.wav'))
TAIRONAN = music.decrypt(universal.resource_path('POL-holy-forest-long.wav'))
LIGHT_HEARTED = music.decrypt(universal.resource_path('POL-jesu-long.wav'))
INTENSE = music.decrypt(universal.resource_path('POL-hurry-up-long.wav'))
SADISTIC_GAME = music.decrypt(universal.resource_path('POL-sadistic-game-long.wav'))
VENGADOR = music.decrypt(universal.resource_path('POL-antique-market-long.wav'))
OMINOUS = music.decrypt(universal.resource_path('POL-bridge-over-darkness-long.wav'))
CARLITA = music.decrypt(universal.resource_path('POL-goodbye-long.wav'))
MARIA = music.decrypt(universal.resource_path('POL-moonlight-long.wav'))
ROLAND = music.decrypt(universal.resource_path('POL-risky-plan-long.wav'))
ELISE = music.decrypt(universal.resource_path('POL-land-of-peace-long.wav'))
CATALIN = music.decrypt(universal.resource_path('POL-sadistic-game-long.wav'))
CARRIE = music.decrypt(universal.resource_path('POL-smart-ideas-long.wav'))
PETER = music.decrypt(universal.resource_path('POL-telekinesis-long.wav'))
COMBAT = music.decrypt(universal.resource_path('POL-chase-long.wav'))
DEFEAT = music.decrypt(universal.resource_path('POL-graveyard-lord-long.wav'))
music.set_combat(universal.resource_path('POL-chase-long.wav'))
music.set_boss(universal.resource_path('POL-last-duel-long.wav'))
music.set_town(universal.resource_path('POL-spiritual-path-long.wav'))
music.set_theme(universal.resource_path('POL-the-challenge-long.wav'))
music.set_defeated(universal.resource_path('POL-graveyard-lord-long.wav'))
music.set_victory(universal.resource_path('POL-the-challenge-long.wav'))
titleScreen.set_opening_crawl(CHURCH)


#--------------------------------------------Rooms-----------------------------------------------------------------------------------
#Characters and other things go here when I want to remove them from play.
#offStage.add_character(p.PC)
edgeOfAvaricum = Room('Edge of Avaricum', "The road is overflowing with people, mostly merchants and farmers bringing their goods to market. Scattered amongst them is a much sadder crowd: Taironan refugees fleeing the strife of the Potion Riots. Many stumble down the road with dead eyes and ragged clothing, hunched under the weight of their children and few precious possessions. Just down the road is the city of Avaricum, the most powerful Carnutian city-state in this region of the One-Thousand-Twenty-Four. Several guards stand on either side of the road studying the people making their way into the Outer City.", bgMusic=VENGADOR)

def enterLeft(character, room):
    offStage.remove_character(character)
    room.add_character(character)

def exitLeft(character, room):
    room.remove_character(character)
    offStage.add_character(character)


avaricumSquare = Room('Avaricum Square', "Avaricum Square is the center of daily life for the commoners living in Avaricum. Men and women (and even a handful of elves) of all shapes and sizes arrive from every direction and leave towards every other. Hawkers wander the crowds, shouting their wares at the top of their lungs. Corner entertainers juggle, dance to silent music, or create little sparkling butterflies with bits of magic. Children sprint around and between the legs of adults. A massive sundial dominates the center of the square.")

avaricumSquare.add_adjacent(edgeOfAvaricum)

shrine = Room('Shrine', '''Despite the size of the cathedral, the actual place of worship is tiny, no more than a shrine with with four pews, each of which could seat five people if they didn't mind being friendly. At the back of the shrine is an equallly small altar. Sitting on the center of the altar is a brightly painted wooden idol of the Mother. Behind the altar is a straight-backed, armless oaken chair. There is a sign carved into the wood of the vestibule: "Although the Avaricum Cathedral is open to all who seek help in any form, because of the small size of the shrine, only Sisters are allowed to attend the weekly worship."''', bgMusic=CHURCH)

def shrine_before_arrival():
    if p.PC.currentEpisode == episode1 and p.PC.currentEpisode.currentSceneIndex == 0 and 'second_hand_tragedy' in p.PC.keywords:
        universal.say(universal.format_line([name(), 'has no interest in going to the Matirian Church again any time soon.']))
        return False
    elif p.PC.currentEpisode == episode1 and p.PC.currentEpisode.currentSceneIndex == 2 and 'finished_night_on_town' in keywords():
        universal.say(universal.format_line([name(), '''has nothing more to do in the Shrine.''', HeShe(), '''should probably find a bed.''']), justification=0)
    else:
        return True
shrine.before_arrival = shrine_before_arrival
        


shrine.add_adjacent(avaricumSquare) 

orphanage = Room('Orphanage', universal.format_line(["The orphanage is a dizzying maze of twisting hallways. Children sprint through the hallways, gasping and laughing, playing hide and seek, tag, and countless other games. About a dozen Younger Brothers and Sisters in light blue, and students in light grey run after the children. In the center of the orphanage is a large dining hall. Two dozen or so children are crowded around an older woman sitting in the corner telling a story. Sitting in the center of the hall is a woman in her mid forties. She is wearing a dark red robe, which denotes her rank as a Sister of the Spectral Persuasion. She has light brown shoulder-length hair with a hint of grey, and pale skin. Her hair is pulled back into a complex braid. She is of average height, but carries herself with a level of",
                '''confidence and conviction that makes her appear taller. Crows feet spread out from her blue eyes. Her eyes flick all over the dining room, keeping an eye on the children and Younger Brothers and Sisters both. At the same time, she braids the hair of a young girl to match her own.''']), bgMusic=LIGHT_HEARTED)

orphanage.add_adjacent(shrine)

hospital = Room('Hospital', "The hospital is a busy, but somber place. People aflicted with various diseases and injuries (crookedly healed bones appearing to be the most common) sit waiting to be treated. Brothers and Sisters in white walk back and forth, some disappearing into the patient rooms in the back, others speaking with those waiting, still others handing off paperwork to each other. Sitting behind a large desk at the back of the room is a woman about Elise's age. She is wearing the light grey robes of a student, and is hunched over some parchment, her forehead wrinkled in thought.", bgMusic=CHURCH)

hospital.add_adjacent(shrine)
hospital.add_adjacent(orphanage)

craftmansCorridor = Room("Craftman's Corridor", '''The Craftman's Corridor is almost as bustling as the main square, though the people here tend to be better dressed. Shops line the street on both sides, but only three of them are of any interest: the Adventurer's Guild, a weapons and armor shop, and a tailor. The road continues to the northeast, snakes around the base of the hill upon which the Inner City sits, and eventually leads into the slums on the far eastern side.''') 
        
avaricumSquare.add_adjacent(craftmansCorridor)

wesleyAndAnnesArmorShop = Room("Wesley and Anne's Weapons and Armor", "", 
        bgMusic=PETER) 
def update_armor_shop_description():
    wesleyAndAnnesArmorShop.description = universal.format_line(['''The shop consists of a single small room. A counter runs the length of the far wall. Hanging on the left wall is a small collection of weapons, while on the right side are a few pieces of armor. What really catches''', p.PC.name + "'s", '''attention is a 'suit' of chanmail hanging on the wall above the counter.''', universal.format_line(['''The armor is a two piece affair. The top looks like to be barely big enough to cover (for a sufficiently loose definition of 'cover')''', p.PC.name + "'s", '''breasts, while the bottom is a thong. A thong made out of chainmail.''' if p.PC.is_female() else '''The armor is a single, small thong, which is made out of chainmail.'''])])
def armor_shop_after_arrival():
    wesleyAndAnnesArmorShop.description = universal.format_line(['''The shop consists of a single small room. A counter runs the length of the far wall. Hanging on the left wall is a small collection of weapons, while on the right side are a few pieces of armor. What really catches''', p.PC.name + "'s", '''attention is a 'suit' of chanmail hanging on the wall above the counter.''', universal.format_line(['''The armor is a two piece affair. The top looks like to be barely big enough to cover (for a sufficiently loose definition of 'cover')''', p.PC.name + "'s", '''breasts, while the bottom is a thong. A thong made out of chainmail.''' if p.PC.is_female() else '''The armor is a single, small thong, which is made out of chainmail.'''])])
    if "visited_blacksmith" not in p.PC.keywords:
        wesleyAndAnnesArmorShop.description = (
            universal.format_text([wesleyAndAnnesArmorShop.description, [p.PC.name, 
                '''stares at the piece for a few seconds, trying to process''', 
                '''just how or why anyone would ever make something so''', 
                '''patently useless out of valuable steel. Then, remembering''',
                '''a lecture given to''', himher(p.PC), 
                '''by Nana about trusting just''', hisher(p.PC), '''eyes,''', 
                heshe(p.PC), '''studies it with''', hisher(p.PC), 
                '''more magical senses.''', HisHer(p.PC), 
                '''eyes widen. Useless nothing, the enchantments on that armor''',
                '''make it as protective as a chain cuirass, and a hundredth as''',
                '''heavy. Whoever made that was cursed good at enchanting''', 
                '''equipment.'''],
                ['''However, there is something odd about the enchantment.''', 
                '''Peering more closely,''', p.PC.name, '''realizes that the''', 
                '''strength of the enchantment is based on the force of a blow.''',
                '''If the force being exerted is enough to break skin,''', 
                '''bones, etc. (basically enough to trigger one's health)''', 
                '''then the enchantment springs into full force. If the''',
                '''force of the blow would only cause a little bruising, then''',
                '''the enchantment remains dormant. Basically, the magic would''',
                '''protect''', 
                p.PC.name, '''from a spear thrust, but not a spanking. Which''', 
                '''is unfortunate, because if Nana ever caught''', p.PC.name, 
                '''wearing such an absurd suit of armor, she'd put the young''',
                '''Taironan over her knee so fast it'd double as the invention''',
                '''of a new haste spell.''']]))
        wesleyAndAnnesArmorShop.description = universal.format_text([wesleyAndAnnesArmorShop.description, 
            ['''The proprietor of the shop hussles out of the backroom.''' 
            '''He is also clearly the smith; he's six feet tall, and has more muscles in one arm than''', 
            p.PC.name, '''has in''', hisher(p.PC), '''entire body. He has light skin,''',
            '''short-cropped''',
            '''dark brown hair, a trimmed beard, and blue eyes. He is wearing''',
            '''a thick leather apron, and a pair of heavily patched trousers.''']])
    townmode.town_mode()
def armor_shop_before_arrival():
    if 'flirting_with_Peter' in keywords() and p.PC.currentEpisode == episode1:
        universal.say('''Peter's shop is currently closed.''', justification=0)
        return False
    return True
wesleyAndAnnesArmorShop.before_arrival = armor_shop_before_arrival
wesleyAndAnnesArmorShop.after_arrival = armor_shop_after_arrival
wesleyAndAnnesArmorShop.add_adjacent(craftmansCorridor)

theresesTailors = Room("Therese's Tailors", "")
def thereses_tailors_after_arrival():
    if 'visited_tailors' not in p.PC.keywords:
        theresesTailors.description = universal.format_text([[p.PC.name + "'s", '''eyes widen when''', 
            heshe(p.PC), '''enters the tailors.''', HeShe(p.PC) + "'d", 
            '''expected to find a small, mostly bare shop with a''', 
            '''couple of tailors taking custom orders, and maybe a few pieces of clothing''', 
            '''for demonstration purposes. What''', heshe(p.PC), '''finds instead is''',
            '''a large, open room with racks of clothing of all shapes and sizes.''', 
            '''Tunics and trousers hang on racks in the middle of the room. Dresses''',
            '''and skirts line the walls.''', p.PC.name, '''even notices in the back''',
            '''what appears to be a display rack for underwear of all sorts.''', 
            '''A variety of people, mostly women, move about the clothing racks.''', 
            '''They riffle through them, occasionally pulling something''', 
            '''off the shelves and holding it against themselves or their''', 
            '''companion.''', p.PC.name, '''also notices several people who appear to''',
            '''be workers. They move about the racks, reorganizing, and''',
            '''rehanging clothing, while keeping an eye on the various customers.''',
            '''One in particular, a woman about''', p.PC.name + "'s", '''age, watches''',
            p.PC.name, '''out of the corner of her eye.'''], 
            ['''The young woman has light brown hair pulled back into a single long''',
                '''braid, and light brown eyes. She is wearing a light red tunic''',
                '''emblazoned on the right chest with a pair of crossed needles, and''',
                '''a matching knee-length skirt.''']])
    else:
        theresesTailors.description = universal.format_line([
            '''Tunics and trousers hang on racks in the middle of the room. Dresses''',
            '''and skirts line the walls.''', p.PC.name, '''even notices in the back''',
            '''what appears to be a display rack for underwear of all sorts.''', 
            '''A variety of people, mostly women, move about the clothing racks.''', 
            '''They riffle through them, occasionally pulling something''', 
            '''off the shelves and holding it against themselves or their''', 
            '''companion.''', p.PC.name, '''also notices several people who appear to''',
            '''be workers. They move about the racks, reorganizing, and''',
            '''rehanging clothing, while keeping an eye on the various customers.''',
            '''One in particular, a woman about''', p.PC.name + "'s", '''age, watches''',
            p.PC.name, '''out of the corner of her eye.'''])
    townmode.town_mode()
theresesTailors.after_arrival = thereses_tailors_after_arrival  
theresesTailors.add_adjacent(craftmansCorridor)

carol_greeting = Node(233)
carol = p.Person('Carol', p.FEMALE, carol_greeting, carol_greeting, universal.format_line(['''A woman in her''', 
        '''mid-twenties. She has light brown hair pulled back into a single''',
        '''long braid, and light brown eyes. She is wearing a light red''', 
        '''tunic''',
        '''emblazoned on the right chest with a pair of crossed needles, and''',
        '''a matching knee-length skirt.''']), printedName='Shopclerk')
offStage.add_character(carol)

carol_first_greeting = Node(151)
carol.litany = carol_first_greeting
carol_buy = Node(152)
carol_work = Node(153) 
carol_make = Node(154) 
carol_leave = Node(156)
carolRootChildren = [carol_make, carol_work, carol_buy, carol_leave]
carol_first_greeting.children = carolRootChildren
def carol_first_greeting_quip_function():
    carol_first_greeting.quip = universal.format_line(['''"Hello," says the young woman,''',
        '''her eyes flicking over''', p.PC.name + ".", 
        '''She smiles, but there's a hint of uneasiness about it.''',
        '''"My name is Carol. How can I help you today?"'''])
    carol.printedName = "Carol"
carol_first_greeting.quip_function = carol_first_greeting_quip_function

def carol_greeting_qf():
    carol_greeting.quip = universal.format_line(['''Carol flashes a professional, toothy''',
        '''smile. "Welcome back. How can I help you today?"'''])
    if 'asked_Carol_about_work' in p.PC.keywords:
        try:
            carolRootChildren.remove(carol_work)
        except ValueError:
            return
    if 'asked_Carol_about_clothing' in p.PC.keywords:
        try:
            carolRootChildren.remove(carol_make)
        except ValueError:
            return
carol_greeting.quip_function = carol_greeting_qf
        
carol_greeting.children = carolRootChildren


carol_buy.comment = '''"I'd like to buy or sell something."'''
def carol_buy_quip_function():
    carol_buy.quip = ''
    carol.litany = carol_greeting
    return (shop_mode, [carol])
carol_buy.quip_function = carol_buy_quip_function
    
carol_work.comment = '''"Are you hiring?"'''
def carol_work_quip_function():
    p.PC.add_keyword('asked_Carol_about_work')
    carol_work.quip = universal.format_line(['''Carol grimaces, and gives''', p.PC.name, 
        '''a quick''', 
        '''look-over. "I'm sorry, but we're not currently hiring now. Is there''', 
        '''anything else I can do for you?"'''])
    try:
        carol_greeting.children.remove(carol_work)
    except ValueError:
        return
carol_work.quip_function = carol_work_quip_function
carol_work.children = carol_greeting.children

carol_make.comment = '''"This is amazing! How did you make all this? Surely not by hand."'''
def carol_make_quip_function():
    p.PC.add_keyword('asked_Carol_about_clothing')
    carol_make.quip = '''Carol smiles conspiratorially. "That's our little secret. All I'm allowed to say is that a bit of magic's involved."'''
    try:
        carol_greeting.children.remove(carol_make)
    except ValueError:
        return
carol_make.children = carol_greeting.children
carol_make.quip_function = carol_make_quip_function

carol_leave.comment = '''"I think I'll be going now."'''
carol_leave.quip = '''"Well, have  a nice day. I hope to see you again."'''
def carol_leave_quip_function():
    carol.litany = carol_greeting
carol_leave.quip_function = carol_leave_quip_function

carol.inventory = [itemspotionwars.thong, itemspotionwars.lacyUnderwear, itemspotionwars.boyShorts, itemspotionwars.underShorts, itemspotionwars.shorts, 
    itemspotionwars.shortShorts, itemspotionwars.plainSkirt, itemspotionwars.miniSkirt, itemspotionwars.blackDress, itemspotionwars.sunDress, itemspotionwars.vNeckTunic, 
    itemspotionwars.qualityVNeckTunic, itemspotionwars.qualityTunic]


restfulRoad = Room("Restful Road", "Place holder")
avaricumSquare.add_adjacent(restfulRoad)

slums = Room("Slums", "", bgMusic=TAIRONAN)

def slums_after_arrival():
    slums.description = universal.format_text([[p.PC.name, 
        '''can't help but tense slightly as''',
        heshe(p.PC), '''enters the slums. The roads have been churned into mud by''',
        '''the steps of hundreds, perhaps even thousands, of feet. The wooden''',
        '''buildings seem''', 
        '''to sag beneath the weight of age and creeper vines. Men, women,''',
        '''and children mill about. They're dressed in worn, holey clothing''',
        '''at best, rags at worst. Most chat congenially amongst themselves''', 
        '''while repairing clothing, cleaning clothing, or cooking a meal.''', 
        '''However,''', p.PC.name, '''also notices more than a few women''', 
        '''wearing clothing fitted to emphasize certain bits of their anatomy.''',
        '''They chat and laugh amongst themselves, while flashing inviting''',
        '''smiles at any men that may walk by. Periodically, one of them will''',
        '''disengage from the group, and take a brief stroll.''',
        '''Beggars huddle against the crumbling buildings, crude bowls sitting''',
        '''on the ground in front of them.'''],
        ['''However, it's not the folk chatting, or the children playing in''',
        '''the muddy streets, or the prostitutes that make''', p.PC.name, 
        '''tense. There is also a disturbingly large number''',
        '''of young Taironans, male and female, milling about and trying''', 
        '''to look as tough as possible. Many of them eye''', p.PC.name, 
        '''carefully as''', heshe(p.PC), '''enters the slums, likely''', 
        '''considering just how rich a mark''', heshe(p.PC), '''might make,''', 
        '''with''', hisher(p.PC), '''whole clothing and well-made weapon.'''],
        ['''Every single person here has the caramel skin of a Taironan. Many''', 
        '''are wrapped in the fogged-eye bliss of Potion addicts enjoying a fix.''',
        '''Looking more closely,''', p.PC.name, '''notices several individuals''',
        '''mingling with the various groups, and showing them something in''',
        '''a small satchel.''']])
    townmode.town_mode()
slums.after_arrival = slums_after_arrival
slums.add_adjacent(craftmansCorridor)

class Bedroom(Room):
    def __init__(self, name, description="", adjacent=None, characters=None, before_arrival=None, bgMusic=None, punishment=None, punisher=None, weeklyTasks=None,
            after_arrival=None):
        super(Bedroom, self).__init__(name, description, adjacent, characters, self.after_arrival, bgMusic, before_arrival)
        self.dayNum = 0
        self.dirtiness = 0
        self.numTransgressions = 0
        self.punisher = punisher
        #punishment is the function that should be invoked if the player's space is too dirty.
        self.punishment = punishment
        self.weeklyTasks = weeklyTasks
        self.after_after_arrival = after_arrival
        self.boarding = False

    def after_arrival(self):
        universal.say_title('Bedroom')
        if self.after_after_arrival is not None:
            self.after_after_arrival()
        universal.say(self.description)
        if self.boarding:
            universal.set_commands(['(P)arty', '(G)o', '(S)ave', '(Q)uick Save', '(T)alk', '(L)oad', '(Esc)Quit', '(C)lean', '(R)est'])
            universal.set_command_interpreter(bedroom_interpreter)
        else:
            townmode.town_mode()

    def sleep(self):
        try:
            self.punisher = self.punisher()
        except TypeError:
            pass
        if p.PC.currentEpisode == episode1:
            if 'taking_Carrie_home' in keywords():
                ep1_carrie_sex()
            else:
                ep1_catalin()
        else:
            if self.dayNum % 7 == 0:
                if self.tooDirty():
                    self.numTransgressions += 1
                    self.punishment()
                else:
                    universal.say(universal.format_text([['''"Inspection time," says''', punisher.name(), '''appearing besides''', name() + "."],
                        [name(), '''looks up groggily. "Hmm. Is it Chiday already?"'''],
                        ['''"Yup," says''', punisher.name() + ".", HeShe(), '''walks around''', names(), '''space for a moment, checking the ground underneath the bedding, checking''', names(),
                            '''bedding, and studying the floor.'''],
                        [HeShe(), '''nods in satisfaction.''', '''"Excellent," says''', punisher.name() + "."],
                        [name(), '''nods. "Can I go to bed now?"'''],
                        ['''"Of course," says''', punisher.name + " with a smile."]]), justification=0)
            universal.say(universal.format_text([[name(), '''plops down in''', hisher(), '''nice bed, and sleeps the night away.''']]), justification=0)
            if self.dayNum %7 == 0:
                self.weeklyTasks()
            p.PC.restores()
        self.dayNum += 1
        self.dirtiness += 1

    def tooDirty(self):
        return self.dirtiness > 3

    def clean(self):
        if p.PC.current_health() < p.PC.health() // 2 or p.PC.current_mana() < p.PC.mana() // 2:
            universal.say(universal.format_text([[name(), '''considers taking some time to clean, but plops down on''', hisher(), '''bed instead.''', HeShe(), '''is too darn tired to clean.''']]), justification=0)
        else:
            universal.say(universal.format_text([[name(), '''takes some time to do some cleaning.''', HeShe(), '''cleans dirty clothing, scrapes the mud off''', hisher(), '''boots, washes''', hisher(), 
                '''linens, and makes sure''', hisher(), '''equipment is in good condition.''']]), justification=0)
            self.dirtiness = 0

def marias_home_before_arrival():
    if not 'Marias_home' in keywords():
        universal.say(universal.format_text([['''While''', name(), '''would like to find Maria's home,''', heshe(), '''has no idea where it is.''']]), justification=0)
        return False
    elif 'grudge_against_Maria' in keywords() and p.PC.currentEpisode == episode1:
        universal.say(universal.format_text([[name(), '''has no interest in speaking to Maria right now.''']]), justification=0)
        return False
    return True
def marias_home_after_arrival():
    universal.say_title("Maria's Home")
    if mariasHome.has(maria) and p.PC.currentEpisode == episode1:
        mariasHome.description = format_text([mariasHomeDesc, ['''Maria is hunched over the small firepit, making some stew. She glances up as''', name(), 
            '''enters.''']])
    if 'boarding_with_Maria' in keywords() and p.PC.currentEpisode == episode1:
        mariasHome.description = universal.format_text([['''Maria lives in a dinky little room with barely enough room for two people to lie down comfortably. The''',
    '''floor is packed dirt, and the old wooden walls sag, seeming on the verge of collapse at any moment. A small, stone-circled firepit sits in the''',
    '''center, just below a small hole in the ceiling. A small collection of wooden bowls, plates, and  skewers lie next to the pit. A pile of ragged''',
    '''blankets is crumpled up in the corner. A few additional blankets are spread out next to the firepit.''']])
        if 'Elise_shows_you_around' in keywords():
            mariasHome.description = universal.format_text([mariasHome.description, ['''There is a small note written in the dirt. It reads:''',
    '''"Went for a walk. Your blankets are spread out next to the pit. We'll look for a better place tomorrow. Maria"''']])
        mariasHome.description = format_text([mariasHome.description, [''' If''', name(), '''wishes,''', heshe(), 
            '''can Rest, and put an end to this seemingly neverending day.''']])

mariasHomeDesc = universal.format_line(['''Maria lives in a dinky little room with barely enough room for two people to lie down comfortably. The''',
    '''floor is packed dirt, and the old wooden walls sag, seeming on the verge of collapse at any moment. A small, stone-circled firepit sits in the''',
    '''center, just below a small hole in the ceiling. A small collection of wooden bowls, plates, and  skewers lie next to the pit. A pile of ragged''',
    '''blankets is crumpled up in the corner.'''])
mariasHome = Bedroom("Maria's Home", description=mariasHomeDesc, bgMusic=TAIRONAN, before_arrival=marias_home_before_arrival, after_arrival=marias_home_after_arrival)
mariasHome.add_adjacent(slums)
slums.add_adjacent(mariasHome)

class AdventurersGuild(Room):
    def get_description(self):
        if 'visited_adventurers_guild' not in p.PC.keywords:
            p.PC.add_keyword('visited_adventurers_guild')
            adventurersGuild.description = universal.format_text([['''The main room of the guild is very''',
'''large, well-lit and exceptionally clean. Chairs line the walls, while in the center are about half a dozen round tables that could sit about six''',
'''people each. About four very rough people sit at the central table. They are dirty, unkempt, and every one of them is armed. They all give''', p.PC.name, '''a wary look before returning to a game of craps. Each roll is accompanied by boisterous laughter and vicious swearing in half a dozen different languages.'''], 
['''At the far end of the room is a long, thick wooden counter. Standing behind the counter is an impeccably clean, immaculately''',
'''dressed, middle-aged man. He waves''', p.PC.name, '''forward. There is a door set into the corner of the northern wall, flush against the end of the counter.''']])
        elif p.PC.currentEpisode == episode1 and 'first_dungeon_done' in keywords():
            adventurersGuild.description = universal.format_text([['''The main room is empty, save for Adrian at the back. The tables have all been split in two or more pieces, and the chairs are shattered. The''',
            '''counter at the back has been split down the middle, with both ends sloping downwards. The floor is covered in shredded, and ground up parchment.''']])
        else:
            adventurersGuild.description = universal.format_text([['''The main room of the guild is very''',
'''large, well-lit and exceptionally clean. Chairs line the walls, while in the center are about half a dozen round tables that could sit about six''',
'''people each. About four very rough people sit at the central table. They are dirty, unkempt, and every one of them is armed. They all give''', p.PC.name, '''a wary look before returning to a large game of dice. Each roll is accompanied by boisterous laughter and vicious swearing in half a dozen different languages.''']]) 
        return adventurersGuild.description

adventurersGuild = AdventurersGuild("Adventurer's Guild", bgMusic=LIGHT_HEARTED)
adventurersGuild.add_adjacent(craftmansCorridor)
infirmary = Room("Infirmary", description=universal.format_line(['''A large, open room filled with cots, and the sharp, irritating smell of poultices, alcohol,''',
'''and other medical supplies.''']), bgMusic=LIGHT_HEARTED)

def bedroom_interpreter(keyEvent):
    room = guildBedroom if 'boarding_with_Adrian' in keywords() else mariasHome
    if keyEvent.key == K_c:
        room.clean()
    elif keyEvent.key == K_r:
        room.sleep()
    else:
        townmode.town_mode_interpreter(keyEvent)


def ildri_or_adrian():
    return ildri if p.PC.is_female() else adrian
               
def guild_bedroom_before_arrival():
    if not 'boarding_with_Adrian' in keywords():
        universal.say(universal.format_text[[name(), '''isn't currently living in the Guild.''']])
        return False
    return True

def guild_bedroom_after_arrival():
    if p.PC.currentEpisode == episode1 and p.PC.currentEpisode.currentSceneIndex == 2:
        guildBedroom.description = universal.format_text([guildBedroom.description, universal.format_line(['''If''', name(), '''wishes,''', heshe(), 
            '''can rest, and put an end to this seemingly neverending day.'''])])

guildBedroom = Bedroom("Bedroom", description=universal.format_line(['''A small, bare room containing four beds in two stacks of two. The beds are feather-beds, complete with pillows and a few blankets. Adrian's''',
'''obscene''',
    '''wealth continues to boggle the brain.''']), bgMusic=LIGHT_HEARTED, punisher=ildri_or_adrian, before_arrival=guild_bedroom_before_arrival, 
    after_arrival=guild_bedroom_after_arrival)
guildBedroom.add_adjacent(adventurersGuild)


        
            
    
#--------------------------------------------Episode 1: Tension------------------------------------

#------------------------------------------Episode 1 Scenes----------------------------------------
#-----------------------------------------Episode 1 Scene 1---------------------------------------
    #-----------------Node name structure: charname_dialogueTreePos_scene_episode

    #So for a character named Alice, a dialogue tree:
    #       1
    #   2       3
    # scene 3 and episode 1, we would have the nodes:
    # alice_1_3_1
    # alice_1p2_3_1
    # alice_1p3_3_1


#----------------------------------------End Episode 1 Scenes--------------------------------------

#------------------------------------------Characters introduced in Episode 1----------------------
#---------------------------------------South Guard-------------------------------
too_busy = Node(2)
guard_greeting_1_1 = Node(1)
southGuard = p.Person('Guard', p.MALE, too_busy, guard_greeting_1_1, 'The guard is leaning on his spear, watching the refugees. If any attempt to enter the city, he pulls them aside, and asks them a few questions. Then he points to the northeast, and lets them through.')
offStage.add_character(southGuard)

southGuard.litany = too_busy

too_busy.quip = "The guard is too busy studying the people coming and going to talk to you."

#---------------------------------------Paloma----------------------------------------------------
palomaDefault = Node(218)
palomaDefault.quip = "Hi! Hope you don't mind if I don't stop and chat. I've got a lot of work to do."
paloma = p.Person('Paloma', p.FEMALE, palomaDefault, palomaDefault) 
offStage.add_character(paloma)
#------------------------------------Maria--------------------------------------

class Maria(p.Person):
    def __init__(self, defaultLitany, litany):
        super(Maria, self).__init__('Maria', p.FEMALE, defaultLitany, litany, "A tall, willowy woman in her early thirties. She has the dark eyes and hair of a Taironan, along with the tell-tale bronze skin. Her hair is also cut very short. In fact, between her height, her slim build, and her short hair, she could easily pass for a young man. As if to counteract this, she wears a short skirt that draws attention to her smooth, slender legs.  A large, wicked looking dagger rests on her hip.")
        self.set_copy()
    def reset_stats(self, episode=None):
        return Maria(self.defaultLitany)

maria_greeting_1_1 = Node(26) 
maria = Maria(None, maria_greeting_1_1) 
offStage.add_character(maria)
#---------------------------------------Elise---------------------------------------------------
class Elise(p.Person):
    def __init__(self, defaultLitany, litany):
        super(Elise, self).__init__('Elise', p.FEMALE, defaultLitany, litany, "She's in her early twenties. She has shoulder-length brown hair (currently pulled back into a ponytail to keep it out of the way) and brown eyes. She is also fairly short. She's wearing a blue dress that obscures much of her figure. If her humming is any indication, she has a beautiful singing voice.")
        self.set_copy()
    def reset_stats(self, episode=None):
        return Elise(self.defaultLitany, self.litany)


elise_default = Node(68)
def elise_default_quip_function():
    if "insulted_Sister_Beatrice" in p.PC.keywords:
        elise_default.quip = universal.format_text([['''Elise ignores''', p.PC.name + "."]])
    else:
        elise_default.quip = universal.format_text([['''Elise grins and waves. "Sorry, I can't talk right now. Cleaning. You know how it is."''']])
elise_default.quip_function = elise_default_quip_function
elise_greeting_1_1 = Node(69)
elise = Elise(elise_default, elise_greeting_1_1)
elise.set_all_stats(grapple=2)
offStage.add_character(elise)

class Carrie(p.Person):
    def __init__(self, defaultLitany, litany):
        super(Carrie, self).__init__('Carrie', p.FEMALE, defaultLitany, litany, universal.format_line(['''She's in her early twenties. She has a tall, slender''',
        '''build, and light brown, curly hair. Her eyes are a fierce, blue, and her mouth seems perpetually turned up in a small, sly smile. She is''',
        '''wearing a tan dress that obscures much of her figure, the mark of a Sister-in-Training.''']))
    def reset_stats(self, episode=None):
        return Carrie(self.defaultLitany, self.litany)

carrie = Carrie(None, None)
offStage.add_character(carrie)
        

#-----------------------------------------Adrian------------------------------
adrian_default = Node(175)
adrian_default.quip = '''"Can't talk now," says Adrian, not looking up from a massive stack of forms. "Busy."'''

class Adrian(p.Person):
    def __init__(self, name, gender, defaultLitany, litany, description="", printedName=None, coins=20, specialization=universal.BALANCED):
        super(Adrian, self).__init__(name, gender, defaultLitany, litany, description, printedName, coins, specialization)
        self.myPrice = 15
        self.set_copy()
    def reset_stats(self, episode=None):            
        return Adrian(self.name, self.gender, self.defaultLitany, self.description, 
                self.printedName)
    def _save(self):
        saveData = super(Adrian, self)._save()
        saveData = saveData.split('\n')
        saveData.insert(-1,'myPrice= ' + str(self.myPrice))
        return '\n'.join(saveData)

    @staticmethod
    def _load(dataList):
        adrian = super(Adrian, self)._load(dataList)
        for line in dataList:
            line = line.split()
            if line[0] == 'myPrice= ':
                adrian.myPrice = int(line[1])
        adrian.set_copy()
        return adrian

            
adrian = Adrian("Adrian", p.MALE, adrian_default, adrian_default)
ildri = p.Person("Ildri", p.FEMALE, None, None)
offStage.add_character(adrian)
offStage.add_character(ildri)

class Carlita(p.Person):
    def __init__(self, defaultLitany, litany, description="A short, painfully thin young woman with a nicked dagger and battered breastplate.", 
            printedName=None, coins=20, specialization=universal.WILLPOWER):
            super(Carlita, self).__init__("Carlita", p.FEMALE, defaultLitany, litany,
                        description, printedName, coins, specialization, p.sixth_order)
            self.spankingPositions = [positions.overTheKnee, positions.underarm, positions.reverseRiding]
            self.level = 0
            self.set_copy()


    def had_spanking_reversed_by(self, person, position):
        return self.spanking_reversal_text(person, self, position)

    def spanking_reversal_text(self, top, bottom, position):
        T = top
        Tname = T.printedName
        B = bottom
        Bname = B.printedName
        reversalPhrases = []
        if position == positions.overTheKnee:
            reversalPhrases.append(universal.format_text([[Bname, '''falls to one knee. However, rather than taking the bait,''', Tname, '''instead steps back, and wrenches''',
                Bname, '''forward onto''', hisher(B), '''hands and knees. Then,''', Tname, '''sweeps''', Bname + "'s", '''hands out from underneath''', himher(B) + ".",
                '''While''', Bname, '''faceplants,''', Tname, '''sits down on''', hisher(T), '''own heels, grabs''', Bname + "'s", '''wrists, and yanks''', himher(B), 
                '''onto''', hisher(T), '''lap.''', HisHer(T), '''hand arcs through the air and''',
                '''cracks hard against''', B.clad_bottom(True) + ".", Bname + "'s", '''hands flail through the air around''', hisher(B), '''bottom in a desperate attempt to''',
                '''block''', Tname + "'s", '''hand.''', Tname, '''catches''', Bname + "'s", '''hands, pins them against the small of''', hisher(B), '''back, and proceeds''',
                '''to administer a vigorous spanking,''', hisher(T), '''hand quickly making''', Bname + "'s", '''bottom dance.'''],
            [Bname, '''yelps and squeals with each blow,''', hisher(B), '''hips wiggling around on''', Tname + "'s", '''lap. Eventually,''', heshe(B),
            '''manages to wiggle right off of''', Tname + "'s", '''lap.''', HeShe(B), '''quickly scrambles away, before''', Tname, '''can yank''', himher(B), '''back.'''],
            [Bname, '''snatches up''', hisher(B), '''dropped weapon, and spins to face''', Tname + ",", 'though', heshe(B), '''can't quite resist the urge to give''',
            hisher(B), '''bottom a quick rub. Then''', Tname, '''grabs''', himher(B), '''again, and''', heshe(B), '''forgets all about''', hisher(B), '''sore tushy.''']]))
        elif position == positions.underarm:
            reversalPhrases.append(universal.format_text([[Bname, 'hooks', hisher(B), 'arm around', Tname + "'s", 'neck, and tries to force', himher(T), 'to bend over.', Tname, 
                'bends slightly, grabs', Bname + "'s", 'arm with one hand, and wraps', hisher(T), 'other arm around', Bname + "'s", 'waist. The two struggle for a moment,',
                'neither gaining ground. Then,', Tname, 'manages to pry', Bname + "'s", 'arm off of', hisher(T), 'neck.', HeShe(T), 'presses', hisher(T), 'elbow against', 
                Bname + "'s", 'back and snaps up, forcing', Bname, 'to bend over.', Tname, 'raises', hisher(T), 'hand and gives', Bname + "'s", 
                'bottom a stinging smack.'],
            [Bname, 'yelps and tries to break free, but', Tname, 'has too firm a hold.', Tname, 'begins to rapidly thrash', Bname + ",", 'making the other combatant kick',
            'and squeal.'],
            ['More through sheer luck than anything else,', Bname + "'s", 'stomping foot comes down hard on', Tname + "'s", 'foot.', Tname, 'reflexively lets go of', Bname, 
            'and hops backward, clutching at', hisher(T), 'stinging toes.', Bname, 'snatches up', hisher(B), 'weapon and faces', Tname + ",", hisher(B), 
            'face bright red.']]))  
        elif position == positions.reverseRiding:
            reversalPhrases.append(universal.format_text([[Bname, 'sweeps', Tname + "'s", 'legs out from under', himher(T) + ",", 'and flips', himher(T), 'over onto', hisher(T), 
                'front. Then,', Bname, 'starts to sit down on', Tname + "'s", 'back. However,', Tname, 'manages to get', hisher(T), 'hands knees underneath', 
                himselfherself(T), 'and snaps upward.', HisHer(T), 'back smacks into', Bname + "'s", 'bottom and sends', himher(B), 'stumbling.', Tname, 'spins, grabs', 
                Bname + "'s", 'ankles, and gives them a vicious tug.', Bname, 'barely manages to keep', hisher(B), 'face from smacking into the ground.', Tname, 
                'quickly clambers on top of', Bname, 'and puts', hisher(T), 'full weight on', Bname + "'s", 'back, making sure to face', hisher(B), 'bottom.'],
            [Tname, 'raises', hisher(T), 'hand, and snaps it across', B.clad_bottom() + ".", Bname, 'twists uselessly underneath', Tname + ".", Tname, 'smacks', 
                Bname + "'s",'bottom again. And again, and again, and again.', Tname, 'paddles', Bname, "quickly and without mercy, and it isn't long before", Bname, 
                'is kicking and', 'yelping.'],
            ['Eventually, fueled by desperation,', Bname, 'manages to heave', himselfherself(B), 'up, throwing', Tname, 'off of', himher(T) + ".", Bname, 'scrambles to', 
            hisher(B), 'feet, one hand clutching at', hisher(B), 'throbbing bottom, the other snatching up', hisher(B), 'fallen weapon, just as', Tname, 'grabs', himher(B),
            'again.']]))
        if B == carlita:
            p.PC.add_keyword('spanked_young_insurgent')
        elif B == p.PC:
            p.PC.add_keyword('spanked_by_young_insurgent')
        return reversalPhrases[random.randrange(0, len(reversalPhrases))]

    def reversed_spanking_of(self, person, position):
        return self.spanking_reversal_text(self, person, position)
    #abstractmethod
    def spanked_by(self, person, position):
        T = person
        Tname = person.printedName
        B = self
        Bname = self.printedName
        p.PC.add_keyword('spanked_young_insurgent')
        if p.PC.currentEpisode == episode1:
            spankText = []
            if position == positions.overTheKnee:
                return universal.format_text([[Tname, 'falls onto', hisher(T), 'right knee, and into a lunge position.', Bname + ',', 'thinking', heshe(B), 
                    'has the advantage, tries to drive', Tname, 'into the ground. But then', Tname, 'twists, folds', hisher(T), 'left leg back underneath', hisher(T), 
                    'torso, and sits on', hisher(T), 'heels. As', heshe(T), 'twists,', heshe(T), 'yanks on', Bname + "'s", 'wrists. Caught off-balance,', Bname, 
                    'sprawls face-down across', Tname + "'s", 'lap.', Tname, 'yanks', hisher(T), 'own left hand free, and presses firmly on the small of', Bname + "'s",
                    'back.'],
            [Bname, 'squirms uselessly in', Tname + "'s", '''grip. "Hey, what're you doing?"'''],
            ['''"It should be obvious," says''', Tname + ".",  HeShe(T), 'snaps', hisher(T), 'right hand against', Bname + "'s", 'right bum cheek.', Bname, 'squeals,', 
            hisher(B), '''thin trousers clearly not providing much protection.'''],
            [Tname, 'begins to spank', Bname, "with quick, sharp slaps.", Bname, 'yelps and twists,', hisher(B), 'hips bucking against', Tname + "'s", 'lap.'],
            ['"Hey, hey come on," wails', Bname + ".", '''"This is absurd! Everyone around us is fighting for their lives, and you're spanking meee!"'''],
            ['"Poor', boygirl(B) + ',"', '''says''', Tname + ",", '''as''', hisher(T), '''hand continues to mercilessly pound''', Bname + "'s", '''small, bouncing''',
            '''bottom.'''],
            ['''Finally,''', Bname, '''manages to roll off of''', Tname  + "'s", '''lap.''', HeShe(B), '''crawls frantically away, scrambling for''', hisher(B), 
                '''dropped''', B.weapon().name + ".", '''Then,''', heshe(B), '''spins to face''', Tname + ".", '''"You'll pay for that,"''', heshe(B), '''growls.''']])
            elif position == positions.underarm:
                return universal.format_text([[Tname, '''hooks''', hisher(T), '''right arm around''', Bname + "'s", '''neck, and forces''', himher(B), '''to bend over.''',
                    Tname, '''wraps''', hisher(), '''arm around''', Bname + "'s", '''lower back, and holds''', himher(B), '''tight against''', hisher(T), '''hip.'''],
                    ['''"Hey, hey what're you doing?" cries''', Bname, '''as''', Tname, '''lightly taps''', Bname + "'s", '''left cheek.'''],
                    ['''"Targeting," says''', Tname + "."],
                    ['''"Targetin' for-oww!"''', Bname, '''yelps as''', Tname + "'s", '''hand cracks against''', hisher(B), '''left butt cheek.'''],
                    ['''"Your spanking of course," says''', Tname + ".", '''"Thought that was obvious."'''],
                    ['''"This is absurd!" cries''', Bname + ",", hisher(B), 
                        '''voice rising into a whine. "I'm supposed to be fighting to help my people, not getting spanked''',
                    '''by one of them!"'''],
                    ['''"Funny how life works," says''', Tname + ".", HisHer(T), 
                        '''hand starts to rise and fall, and the slightly muffled smack of hand against thinly-trousered''',
                    '''bottom joins the cacophany of steel on steel, and hisses of firebolts.'''],
                    [Bname, '''stomps the ground and yelps with each smack,''', hisher(B), '''bottom bouncing vigorously.'''],
                    ['''"Stop it, stop it!"''', heshe(B), '''cries. "Or so help me, I'll gut you! I swear I'll-owwwww!"'''],
                    [Tname, '''ignores''', Bname + "'s", '''carrying on, and lays it on good and hard.'''],
                    ['''Then,''', Bname, '''manages to ram''', hisher(B), '''fist into''', Tname + "'s", '''funny bone.''', Tname + "'s", 
                        '''arm involuntarily jerks away from''',
                    '''the blow, tingling terribly.''', Bname, '''wiggles out of''', Tname + "'s", '''grip.''', HeShe(B), '''crouches and snatches up''', hisher(B), 
                    '''fallen weapon, and turns back to face''', Tname + "."]])
            elif position == positions.reverseRiding:
                return universal.format_text([[Tname, '''pivots to the side, and sweeps''', Bname + "'s", '''feet out from under''', himher(B) + ".", Bname, '''yelps, and hits the''',
                    '''ground face-first. Before''', heshe(B), '''can get up,''', Tname, '''plops down on top of''', himher(B) + ",", '''facing''', hisher(B), 
                    '''legs and bottom.'''],
                ['''"Get off me," says''', Bname + ",", '''squirming.'''],
                ['''"Now why would I do a crazy thing like that?"''', Tname + "'s", '''hand arcs through the air and strikes''', Bname + "'s", 
                    '''right cheek.'''], 
                    [Bname, '''yelps, more from surprise than pain, and wiggles''', hisher(B), '''bottom in a vain effort to get it away from''', Tname + "'s", 
                        '''inevitable next blow.'''],
                ['''Taking advantage of the fact that''', heshe(T), '''has both hands available,''', Tname,  '''begins to smack''', Bname + "'s", 
                    '''bouncing bottom with both hands, playing''', hisher(B), '''cheeks like a drum.'''],
                [Bname, '''yelps, and kicks''', hisher(B), '''feet vainly against the floor, while''', Tname, "'plays'", hisher(B), '''bottom. Eventually,''', Bname, 
                '''gains the presence of mind to get''', hisher(B), '''elbows underneath''', himselfherself(B) + ".", '''Bracing''', hisher(B), '''knees against the''',
                '''ground, and giving a mighty heave,''', Bname, '''manages to throw''', Tname, '''off of''', himher(B) + ".", '''Then,''', heshe(B), 
                '''scrambles to''', hisher(B), '''feet, one hand sneaking back to rub''', hisher(B), '''stinging bottom, while the other snatches up''', hisher(B), 
                '''dropped weapon.''']])

    def spanks(self, person, position):
        T = self
        Tname = self.printedName
        B = person
        Bname = person.printedName
        p.PC.add_keyword('spanked_by_young_insurgent')
        if position == positions.overTheKnee:
            return universal.format_text([[Tname, '''kicks''', Bname, '''in the shin.''', Bname, '''cries out and hops backward, clutching at''', hisher(B), '''leg.''', Tname, 
            '''dashes forward, and grabs''', Bname, '''by the hair.''', HeShe(T), '''half falls, half sits down onto''', hisher(T), '''heels, yanking''', Bname, 
            '''by the hair across''', hisher(T), '''lap.'''],
                ['''"Oww!" says''', Bname + ",", '''clutching at''', hisher(B), '''hair. "You miserable brat!"'''],
                [Tname, '''presses''', Bname, '''against''', hisher(T), '''lap with''', hisher(T), '''left hand, raises''', hisher(T), '''right hand, and cracks it''',
                    '''against''', ((B.underwear().armorType + '-clad' if B.underwear() != itemspotionwars.emptyUnderwear else B.underwear().armorType) + ' bottom' 
                        if B.lower_clothing().name == emptyLowerArmor.name else 
                    universal.format_line(['''the seat of''', Bname  + "'s", B.lower_clothing().armorType])) + "."],
                [Bname, '''yelps. "Hey, stop this! Let go of me!"'''],
                ['''"No," says''', Tname + ",", '''beginning to slap''', Bname + "'s", '''bottom with quick, but rather light slaps. "You're helping our''',
                '''opressors. You deserve this."'''],
                [Bname, '''reaches back and grabs''', Tname + "'s", '''hand. With a sudden wrench,''', heshe(B), '''yanks one of''', Tname + "'s", '''fingers back.''',
                Tname, '''yelps, and snatches''', hisher(T), '''hand away.''', Bname + ",", '''now free, rolls off of''', Tname + "'s", '''lap and back onto''', hisher(B),
                '''feet, snatching up''', hisher(B), '''weapon.'''],
                ['''"Brat," says''', Bname + ".", '''"You're going to pay dearly for that, I promise you."'''],
                [Tname, '''scrambles to''', hisher(T), '''feet, looking very nervous.''']])
        elif position == positions.underarm:
            return universal.format_text([[Tname, '''punches''', Bname, '''in the gut, hard enough to knock the wind out of''', himher(T) + ".", Bname, '''hunches, and clutches at''',
            hisher(T), '''gut.''', Tname, '''hooks''', hisher(T), '''arm around''', Bname + "'s", '''waist, grabs the back of''', Bname + "'s", B.worn_lower_clothing(), 
            '''and pulls''', Bname, '''more fully under''', hisher(T), '''arm.''', Tname, '''gives''', Bname + "'s", '''bottom a light rub, then after a slight''',
            '''hesitation, smacks''', Bname + "'s", '''bottom.'''],
            [Bname, '''stiffens. "What do you think you're doing?" asks''', Bname, '''in a firm voice.'''],
            ['''"S-spanking you," says''', Tname + ".", '''As''', heshe(T), '''speaks,''', hisher(T), '''voice grows firmer. "You should be helping us, not fighting us."'''],
            ['''"You must be kidding me," says''', Bname + ".", HeShe(B), '''struggles against''', Tname + "'s", '''grip. However, despite''', hisher(T), '''hesitancy,''',
            Tname + "'s", '''grip is firm.'''],
            [Tname, '''begins spanking''', Bname, '''with quick, light smacks. Though they aren't particularly hard, they're fast enough that a burning starts to build in''',
            Bname + "'s", '''bottom.'''],
            [Bname, '''twists and kicks''', hisher(B), '''feet. Not because the spanking hurts (of course not), but in an effort to get free. Still,''', Tname + "'s", 
            '''stronger than''', heshe(T), '''looks, and the burn in''', Bname + "'s", '''bottom continues to build. Finally,''', Bname, '''gets a hold of a bit of cloth''',
            '''from''', Tname + "'s", '''mask.''', Bname, '''gives it a jerk, yanking''', Tname + "'s", '''head back. As''', heshe(T), '''stumbles,''', hisher(T), 
            '''grip loosens enough for''', Bname, '''to break free and pick up''', hisher(B), '''weapon.''']]) 
        elif position == positions.reverseRiding:
            return universal.format_text([[Tname, '''pivots, and sweeps''', hisher(T), '''legs around behind''', Bname + "'s", '''legs, knocking''', Bname, '''on''', hisher(B), 
            '''butt. Before''', Bname, '''can react,''', Tname, 'rolls', Bname, 'onto', hisher(B), '''chest. Then,''', Tname, 'sits down on the middle of', hisher(B), 
            'back.'],
            [Bname, 'tries to push off the ground, but', Tname, 'reaches back, grabs one of', hisher(B), 'arms, and pulls it out from under', himher(B) + "."],
            ['"Let me up!" snarls', Bname + ",", '''pounding''', hisher(T), '''fist against the ground.'''],
            ['In response,', Tname, 'raises', hisher(T), 'free hand, and smacks', B.clad_bottom() + "."],
            [Bname, 'freezes.'],
            [Tname, 'starts quickly slapping', Bname + "'s", 'bottom,', hisher(T), 'hand alternating rapidly between cheeks. "You should be helping us , not',
            '"fighting us."'],
            [Bname, 'squirms desperately, as the sting in', hisher(B), 'backside builds into a burn. "You have until the count of -ow!-three to let me-aggh!"'],
            ['''"What's that?" says''', Tname + ",", 'giving', Bname, '''a particularly sharp smack. "I couldn't hear you over all your cryin'."'''],
            ['''"I'm not crying," snarls''', Bname + ".", '''With a mighty heave,''', Bname, '''throws''', Tname, '''off, and wrenches''', hisher(B), '''arm free.'''],
            [Tname, '''goes sprawling across the ground, before quickly scrambling to''', hisher(T), '''feet, and spinning to face''', Bname + "."],
            [Bname, 'gets to', hisher(B), 'feet, rubbing', hisher(B), 'bottom.', HeShe(B), 'glares at', Tname + ",", '''who starts to look nervous.' "I promise you'll''',
            'pay dearly for that."''']])

    def avoided_spanking_by(self, person, position):
        return self.spanking_missed_text(person, self, position)

    def spanking_missed_text(self, top, bottom, position):              
        T = top
        Tname = T.printedName
        B = bottom
        Bname = B.printedName
        missPhrases = []
        if position == positions.overTheKnee:
            missPhrases.append(universal.format_text([[T.printedName, '''falls to one knee.''', B.printedName, 'thinking', heshe(B), 'has the advantage, pushes down on', 
                T.printedName,
            'hands, trying to drive', himher(T), 'all the way to the ground. But then', T.printedName, 'twists, bringing', hisher(T), 'other knee back and sitting on',
            hisher(T), 'heels. As', heshe(T), 'comes down,', heshe(T), 'gives', B.printedName, 'a savage yank.', B.printedName, 'sways dangerously, but manages to keep',
            hisher(B), 'feet.', 'So instead,', T.printedName, 'shoves', B.printedName, 'a few steps backwards, giving', himher(T), 'a chance to regain', hisher(T), 'feet.']]))
        elif position == positions.underarm:
            missPhrases.append(universal.format_text([[T.printedName, 'hooks', hisher(T), 'arm around', B.printedName + "'s", 'neck. Before', heshe(T), 'can get a good hold,', 
            B.printedName, 'jerks backward, and slips out of', T.printedName + "'s", 'grip']]))
        elif position == position.reverseRiding:
            missPhrases.append(universal.format_text([[Tname, "pivots to the side, sweeping", hisher(T), 'leg at', Bname + "'s", 'feet. But', Bname + "'s", 'own foot lashes out and',
            'catches', hisher(T), 'leg. The two balance precariously. Finally,', Tname, 'steps back, and the two regain their footing.']]))
        return missPhrases[random.randrange(0, len(missPhrases))]

    def failed_to_spank(self, person, position):
        return self.spanking_missed_text(self, person, position)

    #def reset_stats(self, episode=None):
    #    carlita = Carlita(self.litany, coins=self.coins, printedName=self.printedName)
    #    carlita.set_default_stats()
    #    carlita.equip(itemspotionwars.batteredDagger)
    #    carlita.equip(itemspotionwars.batteredLeatherBreastplate)
    #    carlita.equip(itemspotionwars.holeyTrousers)
    #    return carlita

    def set_default_stats(self):
        self.set_all_stats(warfare=0, grapple=1, stealth=0, willpower=3, magic=1, health=3, mana=10)



carlita_default = Node(193)
carlita_default.quip = "This is Carlita's default quip."
spankCarlita = Node(195)
carlita = Carlita(carlita_default, spankCarlita, coins=0, printedName='Young Vengador')
offStage.add_character(carlita)
carlita.level = 0
carlita.equip(itemspotionwars.batteredDagger)
carlita.equip(itemspotionwars.holeyTrousers)
carlita.equip(itemspotionwars.batteredLeatherBreastplate)



#-----------------------------------------------------------------------Necia-------------------------------------------------------------------

class Necia(p.Person):
    def __init__(self, defaultLitany, litany, description="A short, painfully thin young woman with a wicked dagger and well-made leather breastplate.", 
            printedName=None, coins=20, specialization=universal.WARFARE):
            super(Necia, self).__init__("Necia", p.FEMALE, defaultLitany, litany,
                        description, printedName, coins, specialization, p.second_order)
            self.spankingPositions = [positions.overOneKnee, positions.waistBetweenLegs, positions.headBetweenLegs]
            self.level = 0
            self.set_copy()

    def had_spanking_reversed_by(self, person, position):
        return self.spanking_reversal_text(person, self, position)

    def spanking_reversal_text(self, top, bottom, position):
        T = top.printedName
        B = bottom.printedName
        if position == positions.overOneKnee:
            reversalText = universal.format_text([[T, '''grabs''', B + "'s", '''face and tries to ram it into''', hisher(top), '''knee. However,''', B, '''grabs''', T  + "'s", 
                '''knee,''',
                '''and stops it dead. Then,''', heshe(bottom), '''drives''', hisher(bottom), '''fist into''', T + "'s", '''gut, wraps''', hisher(bottom), '''arm around''',
                T + "'s", '''waist, pivots, and hauls''', T, '''over''', B + "'s", '''proffered knee.\n\n''']])
            if top.name == 'Necia':
                reversalText += universal.format_text([['''The woman growls, and twists around, trying to smack''', name(), '''in the face.''', name(), 
                    '''easily dodges the flailing hand,''',
                    '''catches it, and pins it against the woman's back. Then,''', heshe(), '''begins sharply slapping the woman's vulnerable bottom.'''],
                    ['''Much to''', names(), '''chagrin, the woman takes the blows stoically, neither peeping nor twitching as''', names(), '''hand rains blow after blow''',
                    '''to her round, trousers-clad bottom.'''],
                    [name(), '''grabs the waistband of the woman's trousers, but before''', heshe(), '''could yank them down, the Vengador's free hand snaps back, and''',
                        '''grabs''', names(), '''fingers, and gives them a sharp wrench.''', name(), '''cries out and clutches at''', hisher(), '''throbbing fingers.''',
                        '''With neither hand holding the woman down, she easily falls off of''', names(), '''knee and rolls to her feet.'''],
                    ['''Though she says nothing, her rage is obvious.''']])
            else:
                reversalText += universal.format_text([[name(), '''squirms nervously,''', hisher(), '''face flushing. This is not going according to plan.'''],
                    ['''The woman chuckles, and smacks''', T + "'s", '''bottom.'''],
                    ['''Not at all.'''],
                    ['''The woman lands half a dozen hard smacks to''', top.clad_bottom() + "."],
                    [name(), '''starts to squirm uneasily, as the heat in''', hisher(), '''bottom builds.''', HeShe(), '''tries several times to roll off of the woman's''',
                        '''lap, but between the woman's strong grip, and''', names(), '''awkward position,''', heshe(), '''just can't get free.'''],
                    [name(), '''cranes''', hisher(), '''head back and watches the steady rise and fall of the woman's hand (while trying to ignore the accompanying''',
                    '''flashes of pain in''', hisher(), '''poor bottom). Once''', heshe(), '''has the timing of the slaps down,''', hisher(), '''hand lances back and''',
                    '''catches the woman's wrist.''', name(), '''twists and yanks the woman forward. She lurches against''', names(), '''torso, and two fall to the ground''',
                    '''in a heap. After a few seconds of flailing, the two manage to disentangle themselves, and roll to their feet.'''],
                    [name(), '''gives''', hisher(), '''stinging bottom a quick rub. Though''', heshe(), '''can't see''', hisher(), '''opponent's expression through the''',
                        '''mask,''', heshe(), '''is sure she's smirking.''']])
        elif position == positions.waistBetweenLegs:
            reversalText = universal.format_text([[T, '''starts to backhand''', B + ",", '''but''', B, '''catches''', T + "'s", '''hand, and kicks''', T, '''in the shin. As''', T,
                '''hops in pain,''', B, '''sweeps''', hisher(top), '''feet out from under''', himher(top) + ".", '''As''', T, '''teeters,''', B, '''yanks on''', 
                hisher(top), '''arm, and steps back and to the right.''', T, '''falls forward, landing hard on''', hisher(top), '''hands and knees.''', B, '''swings''', 
                hisher(bottom), '''legs over''', T + "'s", '''waist, and straddles''', himher(T) + ".\n\n"]]) 
            if top.name == 'Necia':
                reversalText += universal.format_text([[name(), '''smiles, leans over, and gives the Vengador's round bottom, currently straining against tight trousers, a''',
                '''mocking rub.'''],
                    ['''The Vengador growls, and squirms in a failed attempt to break free.'''],
                    ['''"Uh-uh. Take your licks like a good girl," says''', name() + ",", '''slapping the woman's vulnerable bottom.'''],
                    ['''The woman pushes upward, trying to throw''', name(), '''off her back.''', name(), '''jerks''', hisher(), '''right leg back, and dislodges''',
                        '''the insurgent's arm. While the Vengador teeters,''', name(), '''reaches back and pushes on the woman's shoulder blades, forcing her face and''',
                        '''upper-body into the ground, and pushing her bottom higher into the air. While continuing to hold the woman down with one hand,''', name(),
                        '''begins spanking the Vengador's bottom.'''],
                    ['''Unfortunately,''', name(), '''isn't able to spank the Vengador for long, before the woman manages to get her hands back underneath herself, and''',
                        '''heave upward, throwing''', name(), '''off.'''],
                    [name(), '''stumbles forward, and spins back around to continue the confrontation.''']])
            else:
                reversalText += universal.format_text([[T, '''freezes. This wasn't what was supposed to-'''],
                    ['''Crack!'''],
                    [name(), '''gasps. Then the woman's hand collides with''', names(), '''bottom a second time. Then a third, a fourth, a fifth...'''],
                    ['''The woman's hands drum against''', names(), '''bottom,''', name(), '''twitching and gasping beneath the bombardment.''', name(), '''reaches back''',
                        '''and grabs the woman's ankles, tightening''', hisher(), '''abs to keep''', himselfherself(), '''from slumping. With a mighty heave,''', heshe(),
                        '''surges upward, and throws the woman off of''', hisher(), '''back.''', HeShe(), '''jumps to''', hisher(), '''feet and spins to face the woman,''',
                        '''who is scrambling back to her own feet.''']])
        elif position == positions.headBetweenLegs:
            reversalText = universal.format_text([[T, '''punches''', B, '''in the gut, grabs''', himher(bottom), '''by the hair, and forces''', himher(bottom), 
            '''to bend over, locking''', hisher(top), '''legs around''', B + "'s", '''neck.''', B, '''grabs the backs of''', T + "'s", '''knees and yanks them forward.''', 
            T, '''buckles, and for a second slumps over''', B + "'s", '''back.''', B, '''straightens, lifting''', T, '''into the air, and dropping''', himher(top), 
            '''flat on''', hisher(top), '''back.'''],
            [B, '''spins around to face''', T + ",", '''as''', T, '''is scrambling to''', hisher(top), '''feet.''', B, '''grabs''', T, '''by the hair, grabs the back of''',
                T + "'s", T.clothing_below_the_waist().name, '''and yanks''', himher(top), '''towards''', himselfherself(bottom) + ".", HeShe(bottom), '''wraps''', 
                hisher(bottom), '''legs around''', T + "'s", '''neck, tightens''', hisher(bottom), '''grip on''',  T + "'s", T.clothing_below_the_waist().name, 
                '''and lifts''', T + "'s", '''bottom up higher into the air.''']])
            if top.name == 'Necia':
                reversalText += universal.format_text([[name(), '''yanks on the Vengador's tight trousers, giving her a small wedgie.''', Hisher(), '''hand snapped across the''',
                '''woman's raised bottom, making it bounce slightly. The woman squirms, and tugs on''', names(), '''legs, but''', name(), '''ignores her, and continues''',
                '''to batter her bottom. The woman kicks her leg a few times, and rocks her hips, but the squirming does little to mitigate the spanking. Then, the woman''',
                '''starts to bounce her hips up and down. The bouncing becomes so bad, that''', names(), '''grip on her trousers slips. As soon as she feels the grip''',
                '''slip, the woman drives forward, ramming her shoulders against''', names(), '''thighs.''', name(), '''sways dangerously for a moment. The woman,''',
                '''sensing victory, snarls and drives forward a second time, knocking''', name(), '''on''', hisher(), '''back.''', name(), '''quickly rolls back to''', 
                hisher(), '''feet.''', HeShe(), '''can't quite deny a little smirk as''', heshe(), '''sees the woman give her bottom a light rub.''']])
            else:
                if wearing_skirt_or_dress():
                    reversalText += universal.format_text([[name(), '''grunts and tries futiely to pry apart the Vengador's thighs. Stupid, cow-thighed-'''],
                        [name(), '''feels''', hisher(), p.PC.clothing_below_the_waist().armorType, '''being lifted up over''', hisher(), '''hips. "Hey, no stop!"'''],
                        ['''The woman laughs mockingly. "Such sexy underwear. I'd mock you for it, but somehow, it really helps with targeting. Kinda like a bulls-eye."'''
                            if not no_underwear() and PC.underwear().baring else universal.format_text([['''"Stop? Why would I stop? You need to learn what happens when you pick''',
                            '''a fight with a REAL Taironan."'''], 
                            ['''"But you started the fight," yelps''', name() + "."]])],
                        ['''There is a sharp crack, and a shock of pain flares in''', names(), '''bottom. There is another crack, and another shock of pain. Soon, the''',
                            '''cracks are coming hard and fast, and a hot pain blooms in''', names(), '''bottom.''', name(), '''struggles, squirms, and dances, but''',
                            '''the wretched Vengador's thighs are like a vice. Desperately,''', name(), '''reaches up around and behind the Vengador's hips, and manages''',
                            '''to snag the tail of the woman's shirt.''', name(), '''gives the shirt a vicious tug, yanking the woman's torso back. The woman's legs''',
                            '''instinctively loosen as she backs up a step to mainain her balance.''', name(), '''quickly yanks''', hisher(), '''head free, and scrambles''',
                            '''backward a few steps, furiously rubbing''', hisher(), '''stinging bottom.''']])
        return reversalText
                

    def reversed_spanking_of(self, person, position):
        return self.spanking_reversal_text(self, person, position)

    def spanked_by(self, person, position):
        #self.spankingPositions = [positions.overOneKnee, positions.waistBetweenLegs, positions.headBetweenLegs]
        top = person
        bottom = self
        T = person.printedName
        Ts = T + "'s"
        B = self.printedName
        Bs = B + "'s"
        if position == positions.overOneKnee:
            spankedText = universal.format_text([[T, '''and''', B, '''sway and shuffle about the room, locked in the other's deadly grip, each trying to get the advantage. Then,''',
                T, '''manages to latch onto the back of''', Bs, '''neck and sweeps''', Bs, '''legs out from underneath''', himher(bottom) + ".", B, '''falls painfully to''',
                hisher(bottom), '''knees.''', T, '''pivots down into a lunge position, and hauls''', B, '''across''', hisher(top), '''knee.'''],
                [B, '''yelps indignantly, and tries to roll off, but''', Ts, '''hand clamps down on the small of''', hisher(bottom), '''back and holds''', himher(bottom),
                    '''fast.'''],
                ['''"Let go of me," snarls''', B, '''squirming uselessly.'''],
                ['''"Now why would I do that?" asks''', T + ".", HeShe(top), '''gives''', Bs, '''bottom a light rub, then followed by a stinging slap to''', Bs, 
                    '''left cheek. The cheek bounces slightly beneath the slap, and''', B, '''grunts savagely.'''],
                [T, '''then leans over''', Bs, '''bottom, and gives''', himher(bottom), '''a fast spanking, the next blow landing before the ripples from the previous''',
                    '''blow finished.''', B, '''begins to squirm more and more frantically, and the occasional yelp slips from''', hisher(bottom), '''lips. Finally,''',
                    B, '''manages to slip free of''', Ts, '''grip and roll off''', hisher(top), '''knee.''', B, '''leaps to''', hisher(bottom), '''feet, and charges''',
                    T, '''with bared teeth.''']])
        elif position == positions.waistBetweenLegs:
            spankedText = universal.format_text([[T, '''pivots, and throws''', B, '''into a nearby chest.''', B, '''crashes into the piece of furniture, and rolls over it and''',
                '''across the ground. As''', heshe(bottom), '''scrambles to''', hisher(bottom), '''feet,''', T, '''dashes up and straddles the other combatant, locking''',
                hisher(top), '''legs around''', Bs, '''waist, with''', T, '''facing''', Bs, '''behind.'''],
                [B, '''groans.''', T, '''smirks.'''],
                ['''With a loud crack,''', T, '''smacks''', Bs, '''bottom. Over and over again,''', Ts, '''hand cracks against''', Bs, '''bottom.''', HeShe(top), 
                    '''alternates between cheeks, quickly building a fire beneath the seat of''', Bs, '''pants.'''],
                ['''For''', hisher(bottom), '''part,''', B, '''takes the first few smacks stoically, but soon begins to yelp, and squirm. At one point,''', hisher(bottom),
                    '''squirming unsteadies''', T, '''giving''', himher(bottom), '''just enough freedom to throw''', T, '''off.'''],
                [T, '''rolls across the ground, and leaps to''', hisher(top), '''feet. "Sorry. Was I being a little rough?"'''],
                [B, '''sneers, and scrambles off of the chest. Then,''', heshe(bottom), '''charges the other Taironan.''']])
        elif position == positions.headBetweenLegs:
            spankedText = universal.format_text([[T, '''knees''', B, '''between the legs.''', B, '''gasps, and hunches, as waves of nauseating pain ripple across''', hisher(bottom),
                '''body.'''],
                [T, '''grabs''', Bs, '''head, and forces''', himher(bottom), '''over. Then,''', heshe(top), '''latches''', hisher(top), '''legs around''', Bs, 
                    '''neck, and grabs the seat of''', Bs, '''trousers.''', T, '''lifts''', Bs, '''bottom slightly, forcing''', himher(bottom), '''into a (mostly)''',
                    '''straight-legged position, and pushing''', Bs, '''bottom up into the air. Without further ado,''', T, '''begins slapping''', Bs, '''tight bottom.'''],
                ['''The muffled crack of hand to clothed flesh echoes throughout the armory.''', Bs, '''bottom jerks slightly beneath each blow, and the trapped Taironan''',
                    '''clutches at the back of''', Ts, '''knees. The''', boygirl(bottom), '''mewls pitifully.''', T, '''hesitates, and tries to crane back to look at''',
                    '''the other Taironan's face. Suddenly,''', B, '''lurches, and flings''', T, '''off of''', himher(bottom) + "."],
                [T, '''hits the ground, and rolls backt to''', hisher(top), '''feet.'''],
                ['''"Moron," says''', B + "."],
                ['''"Says the''', boygirl(bottom), '''with a smarting bottom," says''', T + "."],
                [B, '''sneers, and charges''', T + "."]])
        return spankedText

    def spanks(self, person, position):
        #self.spankingPositions = [positions.overOneKnee, positions.waistBetweenLegs, positions.headBetweenLegs]
        top = self
        bottom = person
        T = self.printedName
        Ts = T + "'s"
        B = person.printedName
        Bs = B + "'s"
        if position == positions.overOneKnee:
            spankedText = universal.format_text([[T, '''wrenches''', himselfherself(top), '''free of''', Bs, '''grip, and backs up a step.''', HeShe(top), '''lowers''', hisher(top), 
            '''shoulder, and barrels shoulder-first into''', B + ".", '''The two stumble backwards, and crash into an empty armor rack.''', T, '''grabs''', B, 
            '''around the waist, and drops down into a lunge, hauling''', B, '''over''', hisher(top), '''knee.'''],
            [B, '''curses, and squirms uselessly in''', Ts, '''grip.'''],
            ['''"Such naughty language," says''', T + ",", '''smacking''', Bs, '''right cheek. "Seems to me somebody desperately needs a spanking."'''],
            ['''"Then let me go, and bend-oww!"''', B, '''yelps as another stinging smack cracks against''', hisher(bottom), '''left cheek.'''],
            ['''"Oh very clever," says''', T + ".", HeShe(top), '''administers three hard smacks to''', Bs, '''right cheek. "Trying to make it sound like I need the''',
                '''spanking. No one's ever done that before."'''],
            ['''"Let go of me," says''', B + ",", '''kicking''', hisher(bottom), '''legs. "If anyone deserves a spanking it's you! You're the one who attacked me."'''],
            ['''"Sorry, little''', boygirl(bottom) + ".", T, '''begins peppering''', Bs, '''bottom, quickly building a stinging burn. "But might makes right around''',
                '''here."'''],
            ['''"What does-oww-that have to with-aggh-anything?" snaps''', B + ",", '''vainly kicking''', hisher(bottom), '''feet.'''],
            [T, '''gives''', Bs, '''bottom a squeeze. "It means I'm tough enough to spank you, so I decide what's a spanking offense."'''],
            [B, '''growls savagely, and throws''', himselfherself(bottom), '''off of''', Ts, '''knee.''', HeShe(bottom), '''rolls across the ground, and springs to''',
                hisher(bottom), '''feet. "I'll show you whose tough enough to spank who!"''']])
        elif position == positions.waistBetweenLegs:
            spankedText = universal.format_text([[T, '''grabs''', Bs, '''hair in a vicious, painful grip.''', B, '''cries out, and reaches back to grap''', Ts, '''hand.''', B,
                '''sweeps''', Bs, '''feet out from underneath''', himher(bottom) + ",", '''forcing''', himher(bottom), '''to''', hisher(bottom), '''knees. Then,''', 
                heshe(top), '''side-stepped, shoved hard on''', Bs, '''head, driving''', hisher(top), '''opponent onto''', hisher(bottom), '''hands and knees.''', 
                HeShe(top), '''straddled''', Bs, '''waist, and locked''', hisher(top), '''legs around the other's waist.'''],
                [T, '''leans over, and begins spanking''', Bs, '''bottom.'''],
                [B, '''squirms, and rocks''', hisher(bottom), '''hips beneath the harsh smacks. Casting about desperately,''', hisher(bottom), '''hands chance upon an''',
                '''empty armor rack that had been tipped over. With grunt,''', heshe(bottom), '''snaps the rack backwards, and cracks''', T, '''on the back of the head.'''],
                [T, '''falls over''', Bs, '''bottom, who shakes''', hisher(bottom), '''opponent off.''', B, '''scramlbes to''', hisher(bottom), '''feet, and spins to''',
                '''face''', T + "."]])
        elif position == positions.headBetweenLegs:
            spankedText = universal.format_text([[T, '''and''', B, '''wrestle back and forth, each fighting for an advantage. Then,''', T, '''pulls''', B, '''into a slight hunch,''',
                '''smashes''', hisher(top), '''fist against the back of''', Bs, '''head.''', B, '''falls down onto''', hisher(bottom), '''hands and knees, and''', T, 
                '''latches''', hisher(top), '''legs around''', Bs, '''neck.''', HeShe(top), '''grabs''', top.clad_bottom(), '''and pulls''', Bs, '''butt up high.'''],
                ['''"Let me go you miserable-oww!"''', B, '''yelps as''', Ts, '''hand cracks against''', hisher(bottom), '''vulnerable bottom. Blow after blow rains down''',
                    '''on''', Bs, '''bottom, while the crack of hand to bottom batters against''', hisher(bottom), '''ears.'''],
                ['''"Anyone ever tell you what a perfect target your bottom makes?" asks''', T + ".", '''"Really, it's like fishing in a barrel."'''],
                ['''"Oh shut up and let me go," says''', B + ",", '''tugging at''', Ts, '''legs.'''],
                ['''"How pathetic."''', T, '''cracks''', hisher(top), '''lands four hard smacks to the middle of''', Bs, '''bottom. "A Taironan would never ask to be''',
                    '''freed."''', HeShe(top), '''administers five hard smacks to''', Bs, '''right cheek.''', '"' + HeShe(bottom), '''would free''', himselfherself(bottom) +
                    '!"'],
                ['''"Fine."''', B, '''snarls, and with a mighty heave, drives forward, slamming''', hisher(bottom), '''shoulders against''', Ts, '''shins. The other''',
                    '''Taironan sways, and with the extra freedom''', B, '''manages to get''', hisher(bottom), '''feet underneath''', himselfherself(bottom) + ".", 
                    B, '''rockets upward, throwing''', T, '''off of''', himher(bottom) + "."],
                [T, '''flies through the air and hits the ground hard.''', HeShe(T), '''rolls across the ground, and jumps to''', hisher(top), '''feet.''', HeShe(top),
                    '''grins. "That's what I'm talking about. Come on, fight me like a true Taironan."''']])
        return spankedText

    def avoided_spanking_by(self, person, position):
        return self.spanking_missed_text(person, self, position)

    def spanking_missed_text(self, top, bottom, position):              
        T = top.printedName
        Ts = T + "'s"
        B = bottom.printedName
        Ts = B + "'s"
        if position == positions.overOneKnee:
            return universal.format_text([[T, '''grabs''', B, '''around the shoulders, and starts to pivot, and haul''', B, '''across''', hisher(top), '''knee. However,''', B, 
                '''smashes the heel of''', hisher(bottom), '''hand into''', Ts, '''cheek, right next to''', hisher(top), '''eye.''', Ts, '''head jerks to the side, and''',
                heshe(top), '''stumbles, all attempts to paddle''', B, '''forgotten.''']])
        elif position == positions.waistBetweenLegs:
            return universal.format_text([[T, '''laces''', hisher(top), '''fingers around''', Bs, '''neck and tries to force''', himher(bottom), '''to bend over.''', B, 
            '''smashes''', hisher(bottom), '''arms against''', Ts, '''elbows, forcing the other Taironan to release''', himher(bottom), '''or risk having''', hisher(top),
            '''arms broken.''']])
        elif position == positions.headBetweenLegs:
            return universal.format_text([[T, '''rams''', hisher(top), '''knee into''', Bs, '''gut, but''', B, '''manages to block''', Ts, '''knee with''', hisher(top), 
            '''own.''']])

    def failed_to_spank(self, person, position):
        return self.spanking_missed_text(self, person, position)

    def set_default_stats(self):
        if universal.DEBUG:
            self.set_all_stats(warfare=4, grapple=4, magic=2, stealth=4, willpower=4, health=2, mana=20)
        else:
            self.set_all_stats(warfare=4, grapple=4, magic=2, stealth=4, willpower=4, health=25, mana=20)

necia = Necia(None, None, description=universal.format_line(['''An athletic, hard-bodied, dagger-wielding woman of average height. There is a tremendous amount of''',
'''tension in her stance.''']), printedName="Warslinger's Companion")
necia.learn_spell(spells_PotionWars.firebolt) 
necia.learn_spell(spells_PotionWars.icebolt) 
necia.learn_spell(spells_PotionWars.weaken) 
necia.learn_spell(spells_PotionWars.distortMagic) 
necia.equip(itemspotionwars.qualityDagger)
necia.equip(itemspotionwars.trousers)
necia.equip(itemspotionwars.leatherCuirass)
necia.equip(itemspotionwars.lacyUnderwear)

#-----------------------------------------------Scenes--------------------------------------------------------------------------------------------------------

def guard_questions_2():
    return '"You are a Taironan, correct?"'

def guard_questions_3(): 
    return '"When was the last time you were in Bonda?"'

def guard_questions_4():
    return '"And you were raised by your parents?"'

def guard_questions_5(): 
    return '"Last question. What\'s your business in Avaricum?"'
def guard_questions_6():
    return '\n\n'.join(['''"Alright. Welcome to Avaricum. If you see anything suspicious, please report it to us immediately. Lives may depend on it."'''])

def guardhouse_1(): 
    return '\n\n'.join([' '.join([p.PC.name, '''is led across the street and into a small stone building sitting just off the road. The inside of the guardhouse is a single large room. There is an uncomfortable looking armless chair in the center, and a small desk and chair pushed against the northeast corner. Sitting at the desk, hunched over some paperwork, is a woman wearing a slender black dress with red trim. Frizzy blond hair sticks out from underneath a black beret. Sewn onto the beret is a patch. The background of the patch is a pair of crossed shepherd's crooks, juxtaposed on top of which is a female string puppet.''',
'''In other words, this woman is a puppeteer who studied at Stasia University, the preeminent University in the known world.\n\n''',
'''The woman looks up impatiently. Her cold blue eyes sweep over both''',  p.PC.name, 
'''and the guard.''', p.PC.name, ('''represses a shiver.''' if p.PC.willpower_check(2) else '''shivers.'''), '''"Another one?"''']),
    '''"Er, yes ma'am," says the guard, nervously fidgeting with his weapon.''',
    ' '.join(['''The woman returns to her paperwork. "So beat''', himher(p.PC), '''until''', heshe(p.PC), '''tells you what you want to know. I've got work to do."''']),
    '''"But the commander's orders," stammers the guard. "He said to-"''',
' '.join(['''"I know what the commander said," snaps the woman. She glares at the man, and he takes a step back. She flicks her quill at''',  p.PC.name + ".", '''"I see''', himher(p.PC) + ".", HeShe(p.PC), '''is definitely a Taironan. Now take''', himher(p.PC), '''behind a woodshed or something, and stop bothering me."''']),
'''"And if he finds out you didn't er, deal with an uncooperative Taironan?" asks the guard.''',
    '''The woman shifts in her seat. She glares at the guard a second time, though this time the guard doesn't back up. "And you'd report me of course."''',
'''"I have a job to do," says the guard. "And so do you."''',
    '''The woman sighs, and rubs her eyes. "Fine, fine, fine. Go on back to your post like a good little soldier. I'll take care of little ''' +  mistermiss(p.PC) + ''' dumbass, here."'''])

def charmed_text(): 
    return universal.format_text(['''The woman stands. She's rather tall, close to six feet. She stands with her back straight and her shoulders back. As she steps around the desk, a pair of (silk!) slippers peek out from underneath her near floor-length dress.''',
    ['''The guard hands the woman''', p.PC.name + "'s", '''dagger, then salutes and leaves.'''],
    ['''The woman puts the dagger on the desk, and approaches''', p.PC.name + ".", '''She grabs''', p.PC.name + "'s", '''chin in an iron grip. "Look deeply into my eyes."''',
    '''Her voice has taken on a soothing, melodic tone. Her pupils fill her eyes. Then they open into a bottomless pit, and''', p.PC.name, '''starts to fall.'''],
    ['''"You and I are the greatest of friends." The voice reverberates throughout the universe. It makes''', p.PC.name + "'s", '''skin tingle, and''', hisher(p.PC), '''hair stand on end. "You trust me with everything."''']])

def guard_greeting_1_1_quip():
    guard_greeting_1_1.quip = universal.format_text([[universal.format_line(['''One of the  guard's''' + universal.format_line([''' eyes ''' + '''flick over''', p.PC.name + ", and he blocks", himher(p.PC), '''with his spear.''']) if p.PC.is_female() else universal.format_line(['''The southern guard blocks''', p.PC.name + "'s", '''path with his spear.''']), '''"I'd like to ask you a few questions."'''])],
    universal.format_line([p.PC.name + ''' hesitates for a moment, then steps onto the side of the road.''', HeShe(p.PC), '''makes sure to keep''', hisher(p.PC), '''distance.''']), 
    ['''The guard is a broad-shouldered, heavily muscled brute of a man. At over six feet tall, he towers over just about everyone else on the road. The large, steel-tipped''',
    '''spear he carries only adds to his intimidating appearance. Perhaps scariest of all is his armor: a thick leather breastplate. A city as prosperous as Avaricum would only''',
    '''outfit a guard in leather if that guard were also a spellslinger.'''],
    '''"What's your name?" asks the guard.'''])
    guard_greeting_1_1.playerComments = ['''"I don't have to answer that."''', '"' + p.PC.name + '"', '"' + p.PC.fakeName + '"']
    music.play_music(GUARDS)

southGuard.litany = too_busy
southGuard.defaultLitany = too_busy

guard_greeting_1_1.quip_function = guard_greeting_1_1_quip
guard_1_1_1 = Node(3)
guard_2_1_1 = Node(4)
guard_3_1_1 = Node(5)

guard_greeting_1_1.children = [guard_1_1_1, guard_2_1_1, guard_3_1_1]

def guard_1_1_1_quip():
    guard_1_1_1.quip = '\n\n'.join(['''"Actually, yes you do," says the guard. "Unless you want to be thrown in the dungeons for a while."''',
    ' '.join([p.PC.name, '''grimaces. Although, there's nothing stopping''', himher(p.PC), '''from giving a fake name...'''])])
    guard_1_1_1.playerComments = ['"' + p.PC.name + '"', '"' + p.PC.fakeName + '"']
guard_1_1_1.quip_function = guard_1_1_1_quip
guard_1_1_1.children = [guard_2_1_1, guard_3_1_1]

guard_4_1_1 = Node(6)
guard_5_1_1 = Node(7)
guard_6_1_1 = Node(8)

def guard_2_1_1_quip():
    guard_2_1_1.quip = '''"Excellent," says the guard. "Sorry for this, ''' +  p.PC.name + ''', but it's strict policy that we question every Taironan that tries to enter the city."\n\n''' + guard_questions_2()
guard_2_1_1.quip_function = guard_2_1_1_quip
guard_2_1_1.playerComments = ['''Sarcasm: "No, I'm the one person in the kingdom with brown skin who doesn't have a drop of Taironan blood in them. Crazy right?"''',
'''"I am."'''] 
guard_2_1_1.children = [guard_4_1_1, guard_5_1_1]

def guard_3_1_1_quip():
    p.PC.add_keyword('lied_about_name')
    guard_3_1_1.quip = ' '.join(['''"Excellent," says the guard. "Sorry for this,''', p.PC.fakeName, '''but it's strict policy that we question every Taironan that tries to enter the city."\n\n''', guard_questions_2()])
guard_3_1_1.quip_function = guard_3_1_1_quip
guard_3_1_1.children = [guard_4_1_1, guard_5_1_1]
guard_3_1_1.playerComments = ['''SARCASM: "No, I'm the one person in the kingdom with brown skin who doesn't have a drop of Taironan blood in them. Crazy right?"''', 
'''"I am."''']

guard_7_1_1 = Node(9)
guard_8_1_1 = Node(10)
guard_9_1_1 = Node(11)

def guard_4_1_1_quip():
    guard_4_1_1.quip = ' '.join(['''The guard grimaces. "Your sarcasm is not appreciated''', mistermiss(p.PC) + '''.''', '''It's just protocol."\n\n''', guard_questions_3()])
guard_4_1_1.quip_function = guard_4_1_1_quip
guard_4_1_1.children = [guard_6_1_1, guard_7_1_1, guard_8_1_1]
guard_4_1_1.playerComments = ['''"None of your business."''', '''"LIE: I've never been to Bonda. I was born and raised in Chengue."''', 
'''"I was born in Bonda, but my family left when I was about three, when the Potion Riots began. I was raised in Chengue."''']

def guard_5_1_1_quip():
    guard_5_1_1.quip = "The guard nods.\n\n" + guard_questions_3()
guard_5_1_1.quip_function = guard_5_1_1_quip
guard_5_1_1.children = [guard_6_1_1, guard_7_1_1, guard_8_1_1]
guard_5_1_1.playerComments = ['''"None of your business."''', '''"LIE: I've never been to Bonda. I was born and raised in Chengue."''', 
'''"I was born in Bonda, but my family left when I was about three, when the Potion Riots began. I was raised in Chengue."''']

def guard_6_1_1_quip():
    guard_6_1_1.quip = '\n\n'.join(['''The guard scowls. "It is my business, because the safety of this city is my business."''',
    ' '.join(['''"What does the last time I was in Bonda have to do with the safety of this city?" asks''', p.PC.name + ''',''', '''crossing''', hisher(p.PC), '''arms over''', hisher(p.PC), '''chest.''']),
    '''"There has been a rash of attacks against this city by a Taironan terrorist group calling themselves the Harapiento Vengadores-"''',
    ' '.join(['''"And because I'm Taironan you naturally assume I'm involved," snaps''', p.PC.name + '''.''']),
    '''"I'm tempted," growls the guard. "These are exclusively Taironan rebels. Focusing on Taironans is a hell of a lot easier than questioning everyone. Now, are you going to answer my questions, or will I have to haul you off to the guardhouse to be questioned there?"'''])
guard_6_1_1.quip_function = guard_6_1_1_quip

guardhouse_1_1_1 = Node(12)
guard_6_1_1.children = [guardhouse_1_1_1, guard_7_1_1, guard_8_1_1]
guard_6_1_1.playerComments = ['''"The Tyrant take you."''', '''"LIE: I've never been to Bonda. I was born and raised in Chengue."''', 
'''"I was born in Bonda, but my family left when I was about three, when the Potion Riots began. I was raised in Chengue."''']

guard_10_1_1 = Node(13)
guard_11_1_1 = Node(14)

guard_7_1_1.children = [guard_10_1_1, guard_11_1_1]
guard_7_1_1.playerComments = ['''"My father died when I was young, and my mother left soon after. I was raised by my Nana, a woman named Reyna."''', '''"LIE: Yes, I was raised by my mother."''']
def guard_7_1_1_quip():
    p.PC.add_keyword('lied_about_Bonda')
    guard_7_1_1.quip = '\n\n'.join(['''"You've never been to Bonda? I find that hard to believe," says the guard.''',
    ' '.join(['''"You do realize the Taironans are an entire civilization with over a dozen major city-states, dozens more smaller towns, and hundreds of villages, right?" says''', p.PC.name + ''', testily.''', '''"I was born and raised in Chengue, an unremarkable city-state of average wealth and minor influence. Even when conditions are good, it takes a week to reach Bonda from there."''']),
    ' '.join(['''The guard studies''', p.PC.name, '''for a minute, obviously trying to decide if''', heshe(p.PC), '''is lying. Then, he shrugs. "Very well."''']), guard_questions_4()])
guard_7_1_1.quip_function = guard_7_1_1_quip

def guard_8_1_1_quip():
    guard_8_1_1.quip = universal.format_text([['''"I see," says the guard. He studies''', p.PC.name, '''for a moment, probably trying to decide if''', heshe(p.PC), '''looks young enough for''', hisher(p.PC), '''story to make sense. He nods, apparently satisfied.'''], guard_questions_4()])

guard_8_1_1.quip_function = guard_8_1_1_quip
guard_8_1_1.children = [guard_10_1_1, guard_11_1_1]
guard_8_1_1.playerComments = ['''"My father died when I was young, and my mother left soon after. I was raised by my Nana, a woman named Reyna."''', 
    '''"LIE: Yes, I was raised by my mother."''']

guard_9p1_1_1 = Node(15)
def guard_9_1_1_quip():
    guard_9_1_1.quip = universal.format_text([['''The guard glares at''', p.PC.name, '''and his hand tightens on the loop of a thick rope that hangs on his belt. "Answer the cursed question."''']])
guard_9_1_1.children = [guardhouse_1_1_1, guard_10_1_1, guard_11_1_1]
guard_9_1_1.playerComments = ['''"No."''', '''"My father died when I was young, and my mother left soon after. I was raised by my Nana, a woman named Reyna."''', 
'''"LIE: Yes, I was raised by my mother."''']

guard_12_1_1 = Node(16)
guard_13_1_1 = Node(17)

def guard_10_1_1_quip():
    guard_10_1_1.quip = '''"Interesting," says the guard.\n\n''' + guard_questions_5()
guard_10_1_1.quip_function = guard_10_1_1_quip
guard_10_1_1.children = [guard_12_1_1, guard_13_1_1]
guard_10_1_1.playerComments = ['''"I'm looking for work. Probably join the Adventurer's Guild."''', '''"I'm just visiting a friend of mine who lives here."''']

def guard_11_1_1_quip():
    guard_11_1_1.quip = '\n\n'.join(['''The guard nods. "And your mother is?"''',
                ' '.join(['''"Reyna of Chengue," says''',  p.PC.name + '''.''']),
                '''"What happened to your father?" asks the guard.''',
                ' '.join(['''"Died of the Wasting Wail," says''', p.PC.name + '.']),
                '''"Sorry to hear that," says the guard.''',
                guard_questions_5()])
guard_11_1_1.quip_function = guard_11_1_1_quip
guard_11_1_1.children = [guard_12_1_1, guard_13_1_1]
guard_11_1_1.playerComments = ['''"I'm looking for work. Probably join the Adventurer's Guild."''', '''"I'm just visiting a friend of mine who lives here."''']

def guard_12_1_1_quip():
    guard_12_1_1.quip = '\n\n'.join(['''The guard nods, as if he expected that answer. "Please try to stay out of trouble. We have enough problems as it is without having to deal with adventurers drunkenly brawling and slinging spells in the streets."''',
    '''"Of course," says ''' + p.PC.name + '''.''', guard_questions_6()])
    p.PC.add_keyword('help_guard')
    p.PC.add_keyword('spoke_to_guard')
    return (universal.acknowledge, [start_Maria_conversation])
guard_12_1_1.quip_function = guard_12_1_1_quip

guard_13p1_1_1 = Node(18)
guard_13p2_1_1 = Node(19)
guard_13p3_1_1 = Node(20)

guard_13_1_1.quip = '''"And who is your friend?" asks the guard.'''
guard_13_1_1.children = [guard_13p1_1_1, guard_13p2_1_1, guard_13p3_1_1]
guard_13_1_1.playerComments = ['''"Maria of Chengue"''', '''Lie: "A woman named Lola"''', '''"I'm not answering that."''']
        

guard_13p1_1_1.quip = '\n\n'.join(['''"We know of her," says the guard.''',
    '''"Really?"''',
    '''"She's had business with us before," says the guard.''',
    "That doesn't sound good.",
    guard_questions_6()])
def guard_13p1_1_1_quip():
    p.PC.add_keyword('claimed_to_be_visiting Maria')
    p.PC.add_keyword('spoke_to_guard')
    return (universal.acknowledge, [start_Maria_conversation])
guard_13p1_1_1.quip_function = guard_13p1_1_1_quip

def guard_13p2_1_1_quip():
    p.PC.add_keyword('lied to_guard_about_friend\'s_name')
    p.PC.add_keyword('spoke_to_guard')
    guard_13p2_1_1.quip = '\n\n'.join(['''"I see," says the guard. "Well, that's the last of my questions."''', guard_questions_6()])
    return (universal.acknowledge, [start_Maria_conversation])

guard_13p2_1_1.quip_function = guard_13p2_1_1_quip

guard_13p3_1_1.quip = '\n\n'.join(['''"Yes, yes you are," says the guard. "You can answer it here, or at the guardhouse, but you're answering the question."'''])
guard_13p3_1_1.children = [guardhouse_1_1_1, guard_13p1_1_1_quip, guard_13p2_1_1]
guard_13p3_1_1.playerComments = ['''"Get buried."''', '''"Maria of Chengue"''', '''Lie: "A woman named Lola."''']

guardhouse_1p1_1_1 = Node(21)
guardhouse_1p2_1_1 = Node(22)
guardhouse_1_1_1.children = [guardhouse_1p1_1_1, guardhouse_1p2_1_1]
guardhouse_1_1_1.playerComments = ['''Resist.''', '''Go quietly.''']
def guardhouse_1_1_1_quip():
    guardhouse_1_1_1.quip = ' '.join(['''"Fine." The guard grabs''', p.PC.name, '''by the scruff of''', hisher(p.PC), '''neck and spins''', himher(p.PC), '''around.''', p.PC.name, '''glances over''', hisher(p.PC), '''shoulder and sees him reach for a thick loop of rope at his belt.'''])
    p.PC.add_keyword('resist_guard')
    p.PC.add_keyword('spoke_to_guard')
guardhouse_1_1_1.quip_function = guardhouse_1_1_1_quip

def guardhouse_1p1_1_1_quip():
    guardhouse_1p1_1_1.quip = '\n\n'.join([' '.join([p.PC.name, '''rams''', hisher(p.PC), '''elbow into the guard's gut, then pushes him to the ground.''', HeShe(p.PC), '''makes a break for the city proper, hoping to lose''', himselfherself(p.PC), '''in the crowds.''']),
            ' '.join(['''However, the other guard has cut''', himher(p.PC), '''off.''', p.PC.name, '''scrambles to change direction, when something hard and heavy slams into''', himher(p.PC), '''from behind, throwing''', himher(p.PC), '''to the ground.''', HeShe(p.PC), '''looks over''', hisher(p.PC), '''shoulder, and sees the first guard straddling''', hisher(p.PC), '''prone form.''']),
        ' '.join(['''The guard grabs''', p.PC.name + "'s", '''wrists, and binds them tightly together behind''', hisher(p.PC), '''back.''',
    '''Next, he gives''', p.PC.name, '''a quick pat down, taking''', hisher(p.PC), '''dagger in the process. Then the guard pulls''', himher(p.PC), '''to''', hisher(p.PC), '''feet.''']), guardhouse_1()]) 
guardhouse_1p1_1_1.quip_function = guardhouse_1p1_1_1_quip

guardhouse_2p1_1_1 = Node(23)
guardhouse_2p2_1_1 = Node(24)
guardhouse_2p3_1_1 = Node(25)

guardhouse_1p1_1_1.children = [guardhouse_2p1_1_1, guardhouse_2p2_1_1, guardhouse_2p3_1_1]
guardhouse_1p1_1_1.playerComments = ['''"Watch who you're insulting you overeducated tramp."''', '''Say nothing.''', '''"That was uncalled for."''']

def guardhouse_1p2_1_1_quip():
    guardhouse_1p2_1_1.quip = '\n\n'.join([' '.join([p.PC.name, '''stands quietly while the guard gives''', himher(p.PC), '''a brief, professional patdown, taking''', hisher(p.PC), '''dagger in the process. Then he ties''', p.PC.name + "'s", '''hands behind''', hisher(p.PC), '''back, and pushes''', himher(p.PC), '''towards the guardhouse.''']),
    '''"Let's go," he says. "Don't want to hold up the line any more than you already have."''', guardhouse_1()])
guardhouse_1p2_1_1.quip_function = guardhouse_1p2_1_1_quip
guardhouse_1p2_1_1.children = [guardhouse_2p1_1_1, guardhouse_2p2_1_1, guardhouse_2p3_1_1]
guardhouse_1p2_1_1.playerComments = ['''"Watch who you're insulting you overeducated tramp."''', '''"SAY NOTHING."''', '''"That was uncalled for."''']

def guardhouse_2p1_1_1_quip_function():
    p.PC.add_keyword('insulted_Deidre')
    p.PC.add_keyword('charmed_by_Deidre')
    p.PC.add_keyword('spoke_to_guard')
    guardhouse_2p1_1_1.quip = '\n\n'.join(['''The woman raises an eyebrow. "We've got a feisty one here."''',
        universal.format_line(['''"You have no idea," growls''', p.PC.name + "."]),
        universal.format_line(['''The woman smirks. "Never have I met so terrifying a''', manwoman(p.PC) + ".", '''Why, if it wasn't for the fact that you're unarmed and have your hands tied behind your back, I don't know what I'd do."''']), charmed_text()])
    return (universal.acknowledge, [start_Maria_conversation])
guardhouse_2p1_1_1.quip_function = guardhouse_2p1_1_1_quip_function

def guardhouse_2p2_1_1_quip_function():
    guardhouse_2p2_1_1.quip = charmed_text()
    p.PC.add_keyword('didn\'t_respond_to_Deidre')
    p.PC.add_keyword('spoke_to_guard')
    p.PC.add_keyword('charmed_by_Deidre')
    return (universal.acknowledge, [start_Maria_conversation])
guardhouse_2p2_1_1.quip_function = guardhouse_2p2_1_1_quip_function

def guardhouse_2p3_1_1_quip_function():
    guardhouse_2p3_1_1.quip = '\n\n'.join([universal.format_line(['''The woman throws''', p.PC.name, '''a surprised glance. "Thought you said''', heshe(p.PC), '''was being uncooperative."''']), 
        universal.format_line(['''"Maybe you've scared''', himher(p.PC) + ',"', '''says the guard with a shrug.''']), charmed_text()])
    p.PC.add_keyword('protested_peacefully_to_Deidre')
    p.PC.add_keyword('spoke_to_guard')
    p.PC.add_keyword('charmed_by_Deidre')
    return (universal.acknowledge, [start_Maria_conversation])

guardhouse_2p3_1_1.quip_function = guardhouse_2p3_1_1_quip_function

def south_guard_scene():
    southGuard.litany = guard_greeting_1_1
    if not 'spoke_to_guard' in p.PC.keywords:
        conversation.converse_with(southGuard, townmode.town_mode)
    else:
        townmode.town_mode()

avaricumSquare.after_arrival = south_guard_scene

#-----------------------------------end South Guard--------------------------------

#-----------------------------------------Maria------------------------------------------------------

def start_Maria_conversation():
    southGuard.litany = too_busy
    townmode.town_mode()
    universal.say('\n\n'.join(['', universal.format_line(["However, people make sure to give", p.PC.name, "a wide berth. Men unconsciously palm the hilt of their daggers. Women pull their children close. Hawkers avoid", himher(p.PC), ". Guards keep a close eye on", himher(p.PC), "."]),
universal.format_line(['''To the northeast, dominating the square, is a massive stone building. Above the large double doors is a single stained glass window. It depicts a featureless woman made of golden light, and a pale-skinned naked woman with her "assets" discreetly obscured by ankle-length brown hair. The woman made of light is resting one of her hands on the bowed head of the brunette.''']),
        universal.format_line(['''"''' + name() + '''!''', '''Hey,''', nickname() + '''!''', '''Over here!"''']), 
        universal.format_line([p.PC.name, '''spins about, searching through the crowd. Nearby guards tense slightly and their hands twitch towards their weapons.''', '''Then''', p.PC.name, '''spies the woman who called her name, and recognizes her immediately. It's Nana's niece, Maria. She is a tall, willowy Taironan in her mid thirties. Her skin is a few shades lighter than''', p.PC.name + "'s", '''own rich caramel. She is wearing a worn leather skirt that extends about halfway down her thighs, and a slightly ragged tunic. A large, wicked looking dagger rests at her hip. People give her a wide berth, just like they do''', p.PC.name + ",", '''but she doesn't seem to be bothered by it.'''])]), justification=0)
    conversation.converse_with(maria, townmode.town_mode)

def maria_greeting_1_1_quip():
    #I really need to figure out a good way of abstracting this.
    maria_greeting_1_1.quip = universal.format_text([[p.PC.name, '''pushes through the crowd,''', hisher(p.PC), '''heart pounding.''', '''Memories flood''', hisher(p.PC), '''mind: Maria winking and slipping a clump of hair into the stove as a prank (and then getting paddled with a heavy bone hairbrush when she was inevitably found out). Maria teaching''', p.PC.name, '''some of the basics of knife-fighting, and sparring with''', names(), '''older sister Catalin. Maria and Catalin standing at the door, their training complete, hugging''', p.PC.name + ",", '''and Nana good-bye before venturing out into the scary world.''',  '''"Maria? Is that really you?"'''],
    ['''As soon as she reaches''', p.PC.name + ",", '''Maria grabs''', himher(p.PC), '''in a rib-crushing hug. "In the flesh! Aunt Reyna's letter was right, you've grown up. I hardly recognized you."'''],
    [p.PC.name, '''hasn't heard Nana referred to as Aunt Reyna in ten years.''', HeShe(p.PC), '''returns the fierce hug.'''],
    ['''"So how is Aunt Reyna doing?" asks Maria. Maria breaks the hug, but keeps a firm grip on''', p.PC.name + "'s", '''shoulders.'''],
    ['''"She's doing alright, all things considered," says''', p.PC.name + ".", '''"Getting kind of old, but still as feisty as ever."'''],
    '''"Has her hand softened with age?" asks Maria, her eyes sparkling.''',
    ['''"I wouldn't know," says''', p.PC.name + ".", '''"I was a very well-behaved student."'''], 
    ['''Maria tries to smooth her smile into a frown (and only partially succeeds). She shakes her finger at''', p.PC.name + ".", '''"Not according to her letter. I'll bet you walked halfway here with a sore bottom."'''],
    ['''"Well, maybe a little," mutters''', p.PC.name + '''.''', '''"But at least I never squealed. Unlike some people I know."'''],
    '''"I never squealed." Maria puts her hand against her chest as if wounded. "I grunted. Loudly. At a high pitch."''',
    ['''"Oh, Maria I've missed you."''', p.PC.name, '''pulls her into another hug.'''],
    '''"I've missed you too," says Maria. "Now come on. There are a couple of guards over there, watching us a bit more carefully than I like-no don't look. Just makes them more suspicious. Come on, I'll lead you someplace private, and we'll enjoy some lunch. It's not much, but it's food."''',
    [p.PC.name, '''follows Maria across the square, fighting the temptation to look around.''', HeShe(p.PC), '''slows slightly when Maria starts to ascend the stairs into the church. Maria opens the door, and turns to usher''', himher(p.PC), '''in.'''],
    [p.PC.name, '''frowns. "Are we really going to eat in there?"'''], 
    ['''Maria smiles. "Relax. The shrine is empty this time of day, and I'm good friends with the Younger Sister currently in charge of cleaning it. So long as we help her clean up after we're done, she doesn't mind." Her eyes flick over the square behind''', p.PC.name + ".", '''"Besides, it's also one of the few places we can go where we don't have to worry about the guards bothering us."'''],
    ['''"Well, alright," says''', p.PC.name + ",", '''entering the Shrine. "But if this is some kind of prank, and you end up getting me spanked by an irate Sister, I will drag you into the middle of the Square and switch you in front of La Madre and everybody."'''],
    '''Maria grins. "First, there's no way a novice like you could possibly drag me anywhere. Second, where you gonna find a switch?"''',
    ['''"Never underestimate a''', manwoman(p.PC), '''with a sore bottom," says''',  p.PC.name, '''grimly.'''], 
    ['''Maria chuckles, and follows''', himher(p.PC), '''in, the door closing behind her. She takes a deep breath. "I love it in here. So peaceful. So soothing."''']]) 
    return (conversation.SPLIT, maria_greeting_1_1_quip2)

def maria_greeting_1_1_quip2():
    maria_greeting_1_1.quip = universal.format_text([
    ['''Despite the size of the church, the Shrine is barely big enough to fit twenty people, and that's only if they don't mind being friendly. In the back of the shrine is a lone figure in a robin egg blue dress. She is hunched over a large altar sitting on a raised dais, apparently cleaning it.'''], ['''"Kind of small, isn't it?" asks''', p.PC.name + "."],
    '''"Most of the building is taken up by the hospital and orphanage." Maria waves towards the young woman at the altar. "Hey Elise!"''',
    ['''The Sister turns around, and returns Maria's wave. She is fairly short, and has the peach-colored skin common to Carnutians, though she is pale even by their standards. Although her dress obscures much of her figure,  she appears to be fairly curvy. Her shoulder-length brown hair has been pulled back into a ponytail to keep it out of her way while cleaning. "Taking advantage of me again, are you?"'''],
    '''"I'll clean up after myself, I promise," says Maria, plopping down into one of the pews.''',
    ['''"What about your new friend?" asks Elise, gesturing towards''', p.PC.name + "."],
    ['''"This is''', p.PC.name + ''',''', nickname(), '''for short.''', HisHer(p.PC), '''Nana is my aunt and combat instructor," says Maria.''', '"' + p.PC.name + ",", '''this is Elise. She's a Sister of the Matirian Church. Got ordained just last month."'''],
    ['''"Pleasure to meet you," says Elise, giving''', p.PC.name, '''a wave. "I guess I can count on Maria to make sure you clean up properly, so I hope you don't mind if I keep cleaning up here. I was less than productive yesterday, so I've fallen a bit behind."'''],
    ['''"Not at all. I think it's best if''', nickname(), '''and I have a mildly private conversation anyway," says Maria. "After all, it's the first time we've seen each other in ten years."'''],
    ['''Maria pulls out some hard looking bread, as''', p.PC.name, '''sits down next to her.'''],
    '''"Hope you don't mind the rather basic fare," says Maria, slipping into the dialect of Taironan spoken in Chengue. "I'm not exactly rich, and food's scarce right now."'''])
    shrine.add_character(p.PC)
    townmode.set_current_room(shrine)
    shrine.add_character(maria)
    avaricumSquare.remove_character(p.PC)
    avaricumSquare.remove_character(maria)
    music.play_music(CHURCH)
    universal.say_title('Shrine')

maria_3_1_1 = Node(27)
maria_4_1_1 = Node(28)
maria_5_1_1 = Node(29)
mariaRootChildren = [maria_3_1_1, maria_4_1_1, maria_5_1_1]
mariaRootPlayerComments = ['''"So, I know the entire reason I came here was to join the Adventurer's Guild and all, but do you really think that's a good idea? I mean, things aren't exactly how I expected them to be."''', '''"Know where I could find a place to live?"''', '''"There's not really anything else I need to know right now. I think I might take a look around."''']

maria_greeting_1_1.quip_function = maria_greeting_1_1_quip
maria_1_1_1 = Node(30)
maria_2_1_1 = Node(31)
maria_greeting_1_1.children = [maria_1_1_1, maria_2_1_1]
maria_greeting_1_1.playerComments = ['''"Are you kidding? After nearly two weeks of travel rations, this stuff looks fit for a king."''', 
'''"Well, I don't want to impose. Especially not if you can't afford much."''']

def maria_1_1_1_quip():
    maria_1_1_1.quip = universal.format_text([['''Maria grins, and hands''', p.PC.name, '''a piece of bread. "That's the spirit. And here I was afraid you'd grown into one of those spoiled ex-rich brats forced into adventuring because their family lost all their money and the only skill they have is a bit of sport fighting they learned growing up."'''],
    ['''"You can thank Nana for that," says''', p.PC.name + ''', tearing into the hard bread. "Though it sounds like you've dealt with such before."'''],
    '''"Indeed," says Maria. Her grin turns into a smirk. "Fortunately, Aunt Reyna's hairbrush has proven most useful in such situations."''',
    ['''"Oh really?"''', p.PC.name, '''laughs. "And how many times did I hear you curse that hairbrush? How many times did you vow to treat your students differently?"'''],
    '''"They weren't my students," says Maria. "They were mentees at best. Besides, they desperately needed to learn that they no longer had anywhere near enough money for the world to care about them."''',
     ['''"Now you sound like that cranky old guard Armando."''', p.PC.name, '''pretends to think, tapping''', hisher(p.PC), '''finger against''', hisher(p.PC), '''cheek. "You know, maybe you should join the city guard. World could always use more Armandos."''', universal.format_line([p.PC.name + "'s", '''smile falters, as''', hisher(p.PC), '''thoughts slip back towards that puppeteer's abyss.''']) if 'charmed_by_Deidre' in p.PC.keywords else ''], 
     '''Maria winces. "You better be cursed careful who you say that to. Most Taironans around here would challenge you to a duel for even implying that they should, were, or might someday be associated with the guard. They search us randomly, they take us in for questioning over the most trivial of reasons, and they mind control anyone who doesn't cooperate fully."'''])
    if 'charmed_by_Deidre' in p.PC.keywords:
        maria_1_1_1.children.append(maria_1p1p1_1_1)
        maria_1_1_1.playerComments.append('''"Yeah, I learned that last one the hard way."''')
    else:
        maria_1_1_1.children.append(maria_1p1p2_1_1)
        maria_1_1_1.playerComments.append('''"That's just fearmongering. I refuse to believe they'd ever do that for any reason other than self-defense, and even then it'd just be a Charm, not a full MC."''')

maria_1p1p1_1_1 = Node(32)
maria_1p1p2_1_1 = Node(33)
maria_1p1p3_1_1 = Node(34)
maria_1_1_1.quip_function = maria_1_1_1_quip
maria_1_1_1.children = [maria_1p1p3_1_1]
maria_1_1_1.playerComments = ['''"Really? I never imagined... but Armando was always such a kind old man, even if he could get a little grumpy. And sure Isaias could be a bit obnoxious, but I can't imagine him ever doing something like that."''']

def maria_1p1p1_1_1_quip():
    maria_1p1p1_1_1.quip = universal.format_text([['''\mMaria risks a quick glance at Elise, who is cleaning underneath the altar, and whistling some merry tune or other. She leans in close to''', p.PC.name, '''and takes''', hisher(p.PC), '''hand. Her voice is barely audible. "Whatever you do, don't tell anyone else. Don't even think about it."''']])
    maria_1p1_1_1.music = [MARIA]

maria_1p1p1_1_1.quip_function = maria_1p1p1_1_1_quip
maria_1p1p1p1_1_1 = Node(35) 
maria_1p1p1p2_1_1 = Node(36) 
maria_1p1p1p3_1_1 = Node(37)
maria_1p1p1_1_1.children = [maria_1p1p1p1_1_1, maria_1p1p1p2_1_1, maria_1p1p1p3_1_1]
maria_1p1p1_1_1.playerComments = ['''"Why not?"''', '''"Are you kidding? What they did to me was apalling! We can't let them get away with it!"''', '''"Alright, if you say so."''']

maria_1p1p1p1_1_1.quip = '''"Because nobody will trust you, or even be willing to spend time with you," says Maria. "Affluent folk with nothing to hide get uncomfortable when reminded of what their precious guards are doing to protect their money. Poor folk with nothing to hide worry that the guards are looking for a reason to arrest them. Folks hiding something start to think you're some kind of spy put there to catch them red-handed. Better to stay quiet about it."'''
maria_1p1p1p1_1_1.children = [maria_1p1p1p2_1_1, maria_1p1p1p3_1_1]
maria_1p1p1p1_1_1.playerComments = ['''"Are you kidding? What they did to me was apalling! We can't let them get away with it!"''', '''"Alright, if you say so."''']

maria_1p1p1p2_1_1.quip = '''Maria laughs bitterly. "And who are you going to tell? Sir Roland? Who do you think hired the puppeteers in the first place?"''' 
maria_1p1p1p2p1_1_1 = Node(38) 
maria_1p1p1p2p2_1_1 = Node(39)
maria_1p1p1p2_1_1.children = [maria_1p1p1p2p1_1_1, maria_1p1p1p2p2_1_1]
maria_1p1p1p2_1_1.playerComments = ['''"So I'll tell everyone. Just get up on a box and shout it to the masses. Make them see what the guards have done to me."''', '''"Ok...but is there really nothing we can do?"''']

def maria_1p1p1p2p1_1_1_quip():
    maria_1p1p1p2p1_1_1.quip = universal.format_text([['''Maria leans in close,''', '''her hand tightening over''', p.PC.name + "'s", '''wrist.''', '''"''' + p.PC.name + ",", '''there's something you need to learn about the masses. Out of a hundred people, sixty of them don't give a cursed about you, and just want you to stop bothering them. Thirty-five think you're probably an addict, and deserved it. Four will actually care enough to be apalled, and one will be apalled enough to do something about it. So, you can get up there on your little box and shout until you're blue in the face, and all you'll do is ostracize yourself. You're better off just burying it and moving on. Long as you don't do anything stupid, the guards'll leave you alone. Mostly."''']])
maria_1p1p1p2p1_1_1.quip_function = maria_1p1p1p2p1_1_1_quip
maria_1p1p1p2p1p1_1_1 = Node(40)  
maria_1p1p1p2p1p2_1_1 = Node(41)
maria_1p1p1p2p1_1_1.children = [maria_1p1p1p2p1p1_1_1,  maria_1p1p1p2p1p2_1_1, 
         maria_1p1p1p2p2_1_1]
maria_1p1p1p2p1_1_1.playerComments = ['''"So? My life is ruined anyway. Might as well get some good out of it."''', 
'''"How do you know? How do you know they won't just bust down my door one day and force me to help them, whether I want them to or not?"''', 
'''"Ok... but is there really nothing we can do?"''']

maria_1p1p1p2p1p1_1_1.quip = '''Maria rolls her eyes. "Mother's mercy. Your life is not ruined by any stretch of the imagination. So long as you steer clear of the guards, you'll be perfectly fine, and can live a long, normal, happy life."'''
maria_1p1p1p2p1p1p1_1_1 = Node(42)
maria_1p1p1p2p1p1_1_1.children = [maria_1p1p1p2p1p1p1_1_1, maria_1p1p1p2p1p2_1_1]
maria_1p1p1p2p1p1_1_1.playerComments = ['''"But that woman crawled inside my head! And she...she...hell, I don't even know what she did! But I'm not going to just sit here and let her get away with it!"''',
'''"How do you know? How do you know they won't just bust down my door one day and force me to help them, whether I want them to or not?"''']

def maria_1p1p1p2p1p1p1_1_1_quip():
    maria_1p1p1p2p1p1p1_1_1.quip = universal.format_text(['''"No that's exactly what you're going to do," says Maria. "It's the only way things'll get better. Trust me on this, please, I've seen it happen. A Taironan whose been MC'd and interrogated by the guards starts protesting it, talking about it, trying to stir up fear and outrage. Carnutians just walk on by, refusing to meet their eyes. Taironans chase them off. Their friends stop talking to them about anything but the weather. Wives and husbands leave them and take the children. Landlords turn them out. They stop getting hired, even during harvest and planting. I won't let that happen to you. Even if I have to turn you over my knee."''',
    ['''"You wouldn't dare. I've done nothing wrong, and you're just trying to intimidate me into keeping my mouth shut!"''', p.PC.name, '''recoils away from Maria, but Maria's iron grip on''', hisher(p.PC), '''wrist holds''', himher(p.PC), '''fast.'''],
    '''"I know that," snaps Maria. She takes a deep breath. "But you're about to throw away your life, and I can't let you do that. So please, don't force me to do something we'll both regret."'''])
maria_1p1p1p2p1p1p1_1_1.quip_function = maria_1p1p1p2p1p1p1_1_1_quip
maria_1p1p1p2p1p1p1p1p1_1_1 = Node(43) 
maria_1p1p1p2p1p1p1p1p3_1_1 = Node(44)
maria_1p1p1p2p1p1p1_1_1.children = [maria_1p1p1p2p1p1p1p1p1_1_1, 
        maria_1p1p1p2p1p1p1p1p3_1_1]
maria_1p1p1p2p1p1p1_1_1.playerComments = ['''"Coward. It's because of people like you that they can keep getting away with this crap."''', 
'''"Fine. I won't say anything."''']

def maria_1p1p1p2p1p1p1p1p1_1_1_quip():
    maria_1p1p1p2p1p1p1p1p1_1_1.quip = universal.format_text([[p.PC.name, '''picks up''', hisher(p.PC), '''pack and starts to stand, but Maria's grip on''', hisher(p.PC), '''wrist tightens to the point of pain.'''], ['''Maria gives''', p.PC.name, '''a warning glare. "I'm giving you one last chance. Don't force my hand."'''],
        [p.PC.name, '''leans in until''', hisher(p.PC), '''face and Maria's are only inches apart. "The only one forcing your hand is you."'''],
        ['''Maria grabs''', p.PC.name + "'s", '''collar, and pivots in her seat, yanking''', p.PC.name, '''across her lap.''', p.PC.name + "'s", 
        '''head just barely misses the edge of the pew.''', HeShe(p.PC), '''pushes against the pew seat and floor and tries to throw''', himselfherself(p.PC), '''off of Maria's lap,''',
        '''but Maria just grabs the hand that's pressed against the pew seat, yanks it out from underneath''', name() + ",", '''and pins it securely against the small of''', names(), '''back.'''],
    ['''Then she begins to spank''', p.PC.name + "."], 
    ['''"Stop this!" cries''', p.PC.name, ' '.join(['''vainly kicking''', hisher(p.PC), '''legs.''']) if p.PC.willpower_check(2) else ' '.join(['''as a sharp sting cuts through''', hisher(p.PC), '''bottom.''']), '''"It isn't right!"'''],
    ['''Maria ignores''', p.PC.name + "'s", '''plea, and slaps''', p.PC.name + "'s", '''bottom hard and fast, the next blow landing almost before the previous had registered. Her hand roams all over''', p.PC.name + "'s", '''bottom, smacking the center of''', hisher(p.PC), '''cheeks, then the top, then the center, then the sit spots, then the sit spots again.''', ' '.join(['''It isn't long before''', p.PC.name, '''is kicking''',
    hisher(p.PC), '''legs, pounding''', hisher(p.PC), '''free fist against the floor, and bucking''', hisher(p.PC), '''hips.''', p.PC.name + "'s", '''yelps of pain turn into a continuous wail, and tears gather at''', hisher(p.PC), '''eyes. After a few stinging smacks to''', hisher(p.PC), '''sensitive thighs,''', hisher(p.PC), '''legs learn on their own to keep the kicking low. At one point,''', p.PC.name + "'s", '''flailing nearly topples''', himher(p.PC), '''off Maria's lap. Maria stops a second to readjust''', p.PC.name + "'s",'''position, before resuming the punishment, though she seems to be going slightly slower.''']) if p.PC.willpower_check(2) else ' '.join([p.PC.name,  '''gnaws on''', hisher(p.PC), '''lower lip,''', hisher(p.PC), '''hips jerking slightly under particularly painful blows.'''])],
    ['''Maria doesn't speak throughout the spanking. She doesn't scold''', p.PC.name + ",", '''or ask''', himher(p.PC), '''any questions like Nana did. She just strikes''', hisher(p.PC), '''burning bottom over and over and over again.'''],
    ['''Eventually, Maria takes a deep breath, and rests her hand lightly on''', p.PC.name + "'s", '''tender bottom. Then, she reaches over''', p.PC.name, '''and starts rooting around in''', p.PC.name + "'s",
'''pack. "Hmm. A spoon eh? Looks like Aunt Reyna went easy on you." She pulls out the wooden spoon given to''', p.PC.name, '''by Nana. "Now, are you going to just let it go and try to live your life, or am I going to have to bare your bottom and use your own spoon on you?"'''],
['''"If Nana found out what you're doing, she'd paddle you until your stupid hairbrush broke," mutters''', p.PC.name + ", blinking away tears."], 
                ['''"I know," says Maria quietly. She gently rubs''', p.PC.name + "'s", '''tender bottom. "And it wouldn't hurt a fraction as much as this does. Now please, stop pushing it."''']])
    p.PC.add_keyword('Maria_spanked_you')
    p.PC.numSpankings += 1
maria_1p1p1p2p1p1p1p1p1_1_1.quip_function = maria_1p1p1p2p1p1p1p1p1_1_1_quip
maria_1p1p1p2p1p1p1p1p1p1_1_1 = Node(45) 
maria_1p1p1p2p1p1p1p1p1p2_1_1 = Node(46)
maria_1p1p1p2p1p1p1p1p1_1_1.children = [maria_1p1p1p2p1p1p1p1p1p1_1_1, 
        maria_1p1p1p2p1p1p1p1p1p2_1_1]
maria_1p1p1p2p1p1p1p1p1_1_1.playerComments = ['''"Go ahead, beat me all you want. I'm not keeping quiet."''', '''"Fine. I'll stay quiet."'''] 

def maria_1p1p1p2p1p1p1p1p1p1_1_1_quip():
    maria_1p1p1p2p1p1p1p1p1p1_1_1.quip = universal.format_text([['''Maria lifts''', p.PC.name + "'s",  '''hips slightly off her lap and unties the string that holds''',  p.PC.name + "'s", '''trousers up. Then she yanks them and''', p.PC.name + "'s", '''underwear down.''', p.PC.name, '''lies still as stone. Maria taps the wooden spoon against''', p.PC.name + "'s", '''bare, tender bottom''', universal.format_line(['''and''', p.PC.name, '''winces despite''', himselfherself(p.PC) + "."]) if p.PC.willpower_check(3) else ''],
    '''"I'm giving you one last chance," says Maria. "Don't make me do this."''',
    ['''"I'm not making you do anything."''', p.PC.name, '''glares over''', hisher(p.PC), '''shoulder at Maria. "Don't you dare pretend that I am."'''],
    ['''"Your choice." The spoon cracks against''', p.PC.name + "'s", '''right cheek. A vicious sting spreads across''', hisher(p.PC), '''bottom, and''', p.PC.name + ''' shrieks''' if p.PC.willpower_check(2) else p.PC.name + ''' hisses''' + "."], 
    [p.PC.name, '''takes a deep breath, then the spoon cracks against''', hisher(p.PC), '''bottom a second time. Then a third, and a fourth.''', 
        universal.format_line(['''At first,''', p.PC.name, '''tries to be still and tough it out. But every blow spreads a horrific sting across''', hisher(p.PC), '''bottom, and Maria spanks''', himher(p.PC), '''hard and fast, without any sign of relenting. Before long,''', p.PC.name + "'s", '''hips start to buck.''', HisHer(p.PC), '''left hand claws futitely at the air, while''', hisher(p.PC), '''right hand pounds the hard wooden floor.''', HisHer(p.PC), '''legs kick frantically, and''', heshe(p.PC), '''bangs''', hisher(p.PC), '''shins against the pews more than once.''', HeShe(p.PC), '''starts to sob, though from pain or despair,''', heshe(p.PC), '''isn't sure.''']) if p.PC.willpower_check(3) else universal.format_line([p.PC.name, '''squeezes''', hisher(p.PC), '''legs together and''', hisher(p.PC), '''eyes shut. A sob builds and dies in the back of''', hisher(p.PC), '''throat. Somehow,''', heshe(p.PC), '''manages to keep still, as Maria paddles''', himher(p.PC), '''relentlessly. But as''', p.PC.name, '''counts the smacks, and then loses count and starts again, and then loses count and starts again,''', heshe(p.PC), '''realizes that Maria isn't going to stop until''', heshe(), '''gives in. And''', heshe(), '''begins to realize that''', heshe(p.PC) + "'s", '''going to give in eventually.'''])],
    ['''Finally, after another minute or so of blistering blows,''', p.PC.name, '''can't take it anymore.'''],
    ['''"Ok, ok!"''', heshe(p.PC), ' ' .join(['''howls through''', hisher(p.PC), '''sobs.''']) if p.PC.willpower_check(3) else '''cries.''', '''"I'll keep quiet, I'll keep quiet."'''],
    ['''Maria stops, and''', p.PC.name, '''lays limply on her lap''', '''sobbing quietly.''' if p.PC.willpower_check(3) else '''fighting back tears.'''], 
    ['''After a moment, Maria tenderly raises''', p.PC.name + "'s", '''underwear and trousers back up over''', hisher(p.PC), '''hips. She lifts''', p.PC.name + "'s", '''hips slightly off her lap, and reties the string holding the trousers up. Then she helps''', p.PC.name, '''clamber off her lap, and sits''', himher(p.PC), '''down on the pew.''',  p.PC.name, '''winces as''', hisher(p.PC), '''burning bottom touches the hard wood.'''],

    ['''Maria gently runs the backs of her fingers up and down''', p.PC.name + "'s", '''cheek, like she used to do after''', p.PC.name, '''had a bad dream. Her touch is more tentative than''', name(), '''remembers. "I'm sorry,''', nickname() + ".", '''But it's for the best, I promise.'"''']])
    p.PC.add_keyword('Maria_intimidated_you')

maria_1p1p1p2p1p1p1p1p1p1_1_1.quip_function = maria_1p1p1p2p1p1p1p1p1p1_1_1_quip
maria_1p1p1p2p1p1p1p1p1p1p1_1_1 = Node(47) 
maria_1p1p1p2p1p1p1p1p1p1p2_1_1 = Node(48) 
maria_1p1p1p2p1p1p1p1p1p1p3_1_1 = Node(49)
maria_1p1p1p2p1p1p1p1p1p1_1_1.children = [maria_1p1p1p2p1p1p1p1p1p1p1_1_1, 
        maria_1p1p1p2p1p1p1p1p1p1p2_1_1, maria_1p1p1p2p1p1p1p1p1p1p3_1_1]
maria_1p1p1p2p1p1p1p1p1p1_1_1.playerComments = ["Slap her.", 
    "Angrily brush her hand away.", "Accept her comfort."]

def maria_1p1p1p2p1p1p1p1p1p1p1_1_1_quip():
    maria_1p1p1p2p1p1p1p1p1p1p1_1_1.quip = universal.format_text([[p.PC.name + "'s", '''palm snaps up and cracks across Maria's cheek. Maria's face snaps to the side, and her body lurches backward, her hands snapping back to catch herself.'''],
        ['''"You beat me," says''', p.PC.name, '''quietly,''', hisher(p.PC), '''voice shaking. "Not because I did something foolish, or selfish or harmful, but because I refused to accept an unwarranted invasion of my deepest mind and soul."'''],
        ['''"Please,''', p.PC.name + '''-"'''],
        ['''"Shut up!" screeches''', p.PC.name + ".", HisHer(p.PC), '''hands open and close into fists, as if to catch something slipping through''', hisher(p.PC), '''fingers. "What you did... I can't even begin to...'''],
        ['''Maria reaches for''', p.PC.name + ",", '''but''', p.PC.name, '''shoves her back against the pew. Maria slams into the hard wood, her head cracking against the wooden back.'''],
        ['''"Don't touch me!"''', p.PC.name + "'s", '''hand flies to the handle of''', hisher(p.PC), '''weapon. "Don't you dare touch me!"'''],
        ['''Maria's face crumples. She nods, and picks up her pack with shaking hands. She stumbles into the aisle on the opposite side of the pew from''', p.PC.name, '''and runs out the door.'''],
        [p.PC.name, '''takes a deep shuddering breath.''', HeShe(p.PC), '''hears the creak of a door opening. One of the doors near the altar opens, and the young Sister slips out. She sees''',  p.PC.name + ",", ''' and gives''', himher(p.PC), '''an awkward smile. Then she resumes her cleaning.''']])
    p.PC.add_keyword('slapped_Maria')
    shrine.remove_character(maria)
    offStage.add_character(maria)

maria_1p1p1p2p1p1p1p1p1p1p1_1_1.quip_function = maria_1p1p1p2p1p1p1p1p1p1p1_1_1_quip

def maria_1p1p1p2p1p1p1p1p1p1p2_1_1_quip():
    maria_1p1p1p2p1p1p1p1p1p1p2_1_1.quip = universal.format_text([[p.PC.name, '''pushes Maria's hand away. "Don't you dare try to comfort me. Not after what you just did."'''],
    '''"What do you think this is, a story?" asks Maria, her voice rising. "You think that if you stand up for what's right, then people will become consumed by righteous rage, drop their mostly pleasant lives, and join you? That together you'll rise up and make your voices heard? Or maybe you think Roland and Amelia are reasonable. Maybe you think that if you make your argument convincing enough, they'll agree and stop using their most powerful tool."''',
    [p.PC.name, '''crosses''', hisher(p.PC), '''arms and looks away. "I don't know. But I know that what just happened wasn't right."'''],
    '''"I know," says Maria, her voice pained. "But I had no choice. Please, it's for your own good. I promise."''',
    [p.PC.name, '''doesn't respond.''', HeShe(p.PC), '''doesn't even look at Maria.'''],
    ['''Maria pulls out a small scrap of parchment. "Here, I wrote this before you arrived. It's my address. You can find me in the slums."'''],
    ['''She tries to push it into''', p.PC.name + "'s", '''hands, but''', p.PC.name, '''continue to ignore her. Finally,''', p.PC.name + "'s", '''temper snaps and''', heshe(p.PC), '''twists around to face Maria.''',
    '''"I have no need to know where you live!"'''],
    ['''Maria stares at''', himher(p.PC), '''with wide eyes. Then, she nods shoves her address back into her pack with shaking hands, and dashes from the shrine.'''], 
    ['''As she leaves,''', p.PC.name, '''notices one of the two doors at the back of the chapel open, and Sister Elise slip in. She notices Maria leave, then glances at''',  p.PC.name + ".", '''Then she returns to her cleaning.''']])
    p.PC.add_keyword('disowned_Maria')
    offStage.add_character(maria)
    shrine.remove_character(maria)

maria_1p1p1p2p1p1p1p1p1p1p2_1_1.quip_function = maria_1p1p1p2p1p1p1p1p1p1p2_1_1_quip

def maria_1p1p1p2p1p1p1p1p1p1p3_1_1_quip():
    maria_1p1p1p2p1p1p1p1p1p1p3_1_1.quip = universal.format_text([[p.PC.name, '''sags against Maria's hand, and allows''', hisher(p.PC), '''tears to flow.''', HeShe(p.PC), '''lets Maria gather''', himher(p.PC), '''into a comforting hug. Maria rocks''', himher(p.PC), '''back and forth, rubbing''', hisher(p.PC), '''back, and whispering comforting nothings. For a time,''', p.PC.name, '''just cries a deep, broken cry.'''],
    ['''"Why are you doing this?" asks''', p.PC.name, '''at last. "Surely someone will listen to me."'''],
    ['''"Yeah, other MC victims," says Maria. "But they aren't exactly powerful." She chuckles bitterly. "Most of them are dirt-poor, potion-addicted, homeless wretches. The rest are just dirt-poor and potion-addicted."'''],
    [p.PC.name, '''doesn't say anything, and the two sit in silence for a few minutes.'''],
    ['''Eventually, Maria reluctantly lets go of''', p.PC.name + ".", '''She roots around in her pack for a moment, and comes up with a scrap of parchment. "This has my address on it, in the slums. If at any time you need anything, come see me. Of course, I can't guarantee that I'll be in. So, if you have any questions about anything, now's the best time to ask. Otherwise, I need to be going."'''],
    '''Now you can find Maria's home in the slums on the far eastern side of the city.'''])
    p.PC.add_keyword('Maria\'s_home')

maria_1p1p1p2p1p1p1p1p1p1p3_1_1.quip_function = maria_1p1p1p2p1p1p1p1p1p1p3_1_1_quip
maria_1p1p1p2p1p1p1p1p1p1p3_1_1.children = mariaRootChildren
maria_1p1p1p2p1p1p1p1p1p1p3_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p1p2p1p1p1p1p1p2_1_1_quip():
    maria_1p1p1p2p1p1p1p1p1p2_1_1.quip = universal.format_text([[p.PC.name, '''slumps against Maria's legs, defeated.''', HeShe(p.PC), '''knows better than to lie to Maria, and''', heshe(p.PC), '''has the terrible feeling that Maria would spank''', himher(p.PC), '''until''', heshe(p.PC), '''finally agreed.'''],
['''Maria tenderly rubs''', p.PC.name + "'s", '''bottom, then helps''', himher(p.PC), '''get off her lap, and sit down next to her.''', p.PC.name, '''winces as''', hisher(p.PC), '''bottom touches the hard wood. Maria runs the backs of her fingers down''', p.PC.name +  "'s", '''cheek, like she used to do after''', p.PC.name, '''had a bad dream. Her touch is more tentative than''', p.PC.name, '''remembers.''']])
    p.PC.add_keyword('Maria_intimidated_you')
maria_1p1p1p2p1p1p1p1p1p2_1_1.quip_function = maria_1p1p1p2p1p1p1p1p1p2_1_1_quip
maria_1p1p1p2p1p1p1p1p1p2_1_1.children = maria_1p1p1p2p1p1p1p1p1p1_1_1.children 
maria_1p1p1p2p1p1p1p1p1p2_1_1.playerComments = maria_1p1p1p2p1p1p1p1p1p1_1_1.playerComments 

def maria_1p1p1p2p1p1p1p1p3_1_1_quip():
    maria_1p1p1p2p1p1p1p1p3_1_1.quip = universal.format_text(['''"I'm sorry that I'm making you do this," says Maria. "Every choice sucks right now, but this is the least sucky one."''',
        ['''"The least dangerous one anyway," says''', p.PC.name + ", refusing to meet Maria's eyes."],
        '''Maria shrugs.''',
        ['''The two sit in silence for a moment. Then, Maria reaches into her pack, removes a small scrap of parchment, and hands it to''', p.PC.name + ".", '''"This is the address of my home, in the slums. If you need anything, anything at all, please come see me. I can't guarantee that I'll always be in, but that's life. If there's anything you need now, please ask."'''],
        '''Now you can find Maria's home in the slums on the far side of the city.'''])
    p.PC.add_keyword('Maria_intimidated_you')
    p.PC.add_keyword('Maria\'s_home')


maria_1p1p1p2p1p1p1p1p3_1_1.quip_function = maria_1p1p1p2p1p1p1p1p3_1_1_quip
maria_1p1p1p2p1p1p1p1p3_1_1.children = mariaRootChildren
maria_1p1p1p2p1p1p1p1p3_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p1p2p1p2_1_1_quip():
    maria_1p1p1p2p1p2_1_1.quip = universal.format_text([['''Maria runs a hand through her hair.''', p.PC.name, '''notices that her hand is shaking slightly. "To tell you the truth? I don't, I really don't. But I've never heard of it happening before. Usually once they're done asking their questions they let you go, and don't bother you again."'''],
    ['''"That's enough to make you want me to drop it?" asks''', p.PC.name, '''incredulously.'''],
    '''Maria shrugs. "Sometimes, that's all you get."'''])
    p.PC.add_keyword('how_do_you_know')
    if 'just_want_to_live' in p.PC.keywords:
        del maria_1p1p1p2p1p2_1_1.playerComments[maria_1p1p1p2p1p2_1_1.children.index(maria_1p1p1p2p1p3_1_1)]
        try:
            maria_1p1p1p2p1p2_1_1.children.remove(maria_1p1p1p2p1p3_1_1)
        except ValueError:
            return
maria_1p1p1p2p1p2_1_1.quip_function = maria_1p1p1p2p1p2_1_1_quip
maria_1p1p1p2p1p3_1_1 = Node(50)
maria_1p1p1p2p1p4_1_1 = Node(51)
maria_1p1p1p2p1p2_1_1.children = [maria_1p1p1p2p1p3_1_1, maria_1p1p1p2p1p4_1_1]
maria_1p1p1p2p1p2_1_1.playerComments = ['''"Dammit, I just want to live my life. I don't want to deal with any of this."''', '''"Fine. If that's the best way to deal with it, that's the best way to deal with it."''']

def maria_1p1p1p2p1p3_1_1_quip():
    maria_1p1p1p2p1p3_1_1.quip = '''"Then it should be a no-brainer," says Maria. "Let it go. I know it rankles, and it's nowhere near just, but what else can you do? You have no money, no friends with money, and therefore no power. All you can do is live, and hope the people who do have power don't screw you over too hard."'''
    p.PC.add_keyword('just_want_to_live')
    if 'how_do_you_know' in p.PC.keywords:
        del maria_1p1p1p2p1p3_1_1.playerComments[maria_1p1p1p2p1p3_1_1.children.index(maria_1p1p1p2p1p2_1_1)]
        try:
            maria_1p1p1p2p1p3_1_1.children.remove(maria_1p1p1p2p1p2_1_1) 
        except ValueError:
            return
maria_1p1p1p2p1p3_1_1.quip_function = maria_1p1p1p2p1p3_1_1_quip
maria_1p1p1p2p1p3_1_1.children = [maria_1p1p1p2p1p2_1_1, maria_1p1p1p2p1p4_1_1, maria_1p1p1p2p1p1p1p1p1_1_1]
maria_1p1p1p2p1p3_1_1.playerComments = ['''"How do you know?"''', '''"Fine. If that's the best way to deal with it, that's the best way to deal with it."''', 
'''"Coward. It's because of people like you that they can keep getting away with this crap."''']

def maria_1p1p1p2p1p4_1_1_quip():
    maria_1p1p1p2p1p4_1_1.quip = universal.format_text([['''Maria squeeezes''', p.PC.name + "'s", '''shoulder. "I know, it sucks. But you're making the right choice. This isn't the end of the world. Hell, it really isn't that big of a deal when you think about it. Just keep your nose out of trouble, and ten years from now it'll be like it never happened."'''],
    [p.PC.name, '''nods, still feeling a bit uncertain. But if there's anyone in this city''', heshe(p.PC), '''can trust, it's Maria.'''],
    '''Maria opens up her pack and roots around in it for a second. "Ah ha! Here it is." Maria pulls out a small scrap of parchment. She holds it out to you. "This is my address, in the slums. Come look for me if you have any questions. I can't guarantee I'll always be in, though. So if you have any questions, now would be a good time to ask them."''',
    '''You can now visit Maria's home in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword('Maria\'s_home')
maria_1p1p1p2p1p4_1_1.quip_function = maria_1p1p1p2p1p4_1_1_quip
maria_1p1p1p2p1p4_1_1.children = mariaRootChildren
maria_1p1p1p2p1p4_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p1p2p2_1_1_quip():  
    maria_1p1p1p2p2_1_1.quip = universal.format_text([['''"'Fraid not kiddo," says Maria, ruffling''', p.PC.name + "'s", '''hair. "But it's not so bad. So long as you avoid drawing the attention of the guards you shouldn't have any problem. Now, things have gotten way too morbid for a first conversation in ten years, so let's change the subject. Before I forget..." Maria pulls a small scrap of parchment out of her pack and hands it to''', p.PC.name + ".", '''"This is my address in the slums. Come see me if you need anything. Now is there anything else you need? I have to be going soon, but I don't want to leave you if you still have questions."'''],
    ['''It's pretty clear that Maria's trying very hard to change the subject.''', p.PC.name, '''decides to let her, for now.'''],
    '''You can now visit Maria's home in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword('Maria\'s_home')

maria_1p1p1p2p2_1_1.quip_function = maria_1p1p1p2p2_1_1_quip
maria_1p1p1p2p2_1_1.children = mariaRootChildren
maria_1p1p1p2p2_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p1p3_1_1_quip():
    maria_1p1p1p3_1_1.quip = universal.format_text([['''Maria smiles sadly. "I do. It sucks horribly, but that's life, and it's something you're probably going to have to get used to. Here, before I forget..." Maria pulls a scrap of parchment out of her pack and hands it to''', p.PC.name + ".", '''"This has my address on it. If you have any questions, come ask me. I'll need to be going soon, unfortunately, so if you need anything now you should probably ask."'''],
    ['''You can now visit Maria's home in the slums, on the far eastern side of the city.''']]) 
    p.PC.add_keyword('Maria\'s_home')

maria_1p1p1p3_1_1.quip_function = maria_1p1p1p3_1_1_quip
maria_1p1p1p3_1_1.children = mariaRootChildren
maria_1p1p1p3_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p2_1_1_quip():
    maria_1p1p2_1_1.quip = universal.format_text([['''\mMaria scowls. "Don't be so naive. The guards are going to do whatever they feel like to 'protect' Carnutians from us. The second you give them anything less than full cooperation, they'll drag you into some dank dungeon, steal your mind, pick it clean, then put it back, and they'll probably leave a few going away presents in there too."'''],
[p.PC.name, '''scowls right back. "And do you have any proof for this supposed brutality?"'''],
'''"Sure," says Maria. "Go take a walk through the slums. Look for the beggars that people take extra pains to avoid. Look for the men and women doing their laundry with their heads down. Quickly, furtively, like they're scared of being caught cleaning their own cursed clothing. Look for the ones who have a bubble of silence that follows them everywhere."'''])
    maria_1p1p2_1_1.music = [MARIA]
maria_1p1p2_1_1.quip_function = maria_1p1p2_1_1_quip
maria_1p1p2p2_1_1 = Node(52)
maria_1p1p2p5_1_1 = Node(53)
maria_1p1p2_1_1.children = [maria_1p1p2p2_1_1, maria_1p1p2p5_1_1]
maria_1p1p2_1_1.playerComments = ['''"You make it sound like half the Taironan population has been mind-controlled."''', '''"Isn't there anyone trying to help them?"''']

def maria_1p1p2p2_1_1_quip():
    maria_1p1p2p2_1_1.quip = '''Maria's scowl darkens. "That is not what I said, and you know it. You'd have to look for a while to find one, but they exist, and their numbers are growing, especially with all the Potion wars breaking out in the slums."'''

maria_1p1p2p2_1_1.quip_function = maria_1p1p2p2_1_1_quip
maria_1p1p2p2p1_1_1 = Node(54) 
maria_1p1p2p2p2_1_1 = Node(55)
maria_1p1p2p2_1_1.children = [maria_1p1p2p2p1_1_1, maria_1p1p2p2p2_1_1]
maria_1p1p2p2_1_1.playerComments = ['''"What do you mean by that? Are you suggesting that the guards are hooking innocent people, to keep tabs on these Potion lords?"''', 
'''"Let me guess. The Potion lords are attacking each other and innocent people who have nothing to do with anything, so the guards feel forced to interrogate innocent people who have nothing to do with anything in an effort to track them down."''']

def maria_1p1p2p2p1_1_1_quip():
    maria_1p1p2p2p1_1_1.quip = universal.format_text(['''Maria grimaces. "Partly, yes. The vast majority of Taironans would never reveal anything willingly to the guards, for fear'''
    ''' of what the Potion lords would do to them. So the only way for the guards to get any information is to force it."''',
    '''"Oh."''',    
    '''"Anyway, maybe we should change the subject," says Maria. "Hate talking politics." She reaches down and roots around in her pack for a minute. She comes up with a slightly crumbled scrap of parchment. "Here. I managed to borrow some parchment from Elise. This has my address on it. I need to be going soon, and I probably won't be back to my place until sundown. So if you need to know anything, now's the time to ask about it."''',
    '''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword("Marias_home")

maria_1p1p2p2p1_1_1.quip_function = maria_1p1p2p2p1_1_1_quip
maria_1p1p2p2p1_1_1.children = mariaRootChildren
maria_1p1p2p2p1_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p2p2p2_1_1_quip():
    maria_1p1p2p2p2_1_1.quip = universal.format_text(['''Maria laughs bitterly. "That about sums it up."''',
    '''"Anyway..." Maria reaches into her pack, and roots around for a minute. She comes up with a small scrap of paper. "Here. It's got my address on it, in the slums. I'm going to need to be going soon, got a job for Adrian. So, if you have any questions, you'd better ask."''',
    '''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword("Marias_home")
    #p.PC.add_keyword("Marias_challenge_about_Elise")

maria_1p1p2p2p2_1_1.quip_function = maria_1p1p2p2p2_1_1_quip
maria_1p1p2p2p2_1_1.children = mariaRootChildren
maria_1p1p2p2p2_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p2p5_1_1_quip():
    maria_1p1p2p5_1_1.quip = universal.format_text(['''Maria shrugs. "Not really. The Matirian Church prefers to think that these people don't actually exist, and most Taironans don't want to touch them with a ten foot pole, for fear of drawing the attention of the guards."''',
    ['''"That's terrible," says''', p.PC.name + ".", '''"Someone should help them."'''],
    '''"Yeah, probably," says Maria. "But you're not exactly much better off yourself. And keep in mind that if any of them were associated with any of the Potion lords, the guards know it. You try to help them, and you run the risk of being arrested for being a sympathizer. Anyway, I need to be going soon. So if you have any questions, now would be a good time to ask them."''',
    ['''"How about your address?" asks''', p.PC.name + "."],
    '''"Of course, almost forgot," says Maria. She opens up her pack and starts rooting around in it. "You did get around to learning your letters, like Aunt Reyna wanted you to, right?"''',
    ['''"Of course," says''', p.PC.name + ".", '''"Nana would never have let me leave if I hadn't."''',],
    '''"She probably never would have let you sit, either," says Maria, grinning. She pulls out a small scrap of paper.''',
    ['''"That's true," admits''', p.PC.name + "."],
    ['''Maria hands the paper to''', p.PC.name + ".", '''"This has my address on it. Come visit me sometime. I won't be there until later tonight, though. Have a job to perform for Adrian. Anyway, if there's anything else you want to know, ask away."'''],
    '''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])

maria_1p1p2p5_1_1.quip_function = maria_1p1p2p5_1_1_quip
maria_1p1p2p5_1_1.children = mariaRootChildren
maria_1p1p2p5_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p3_1_1_quip():
    maria_1p1p3_1_1.quip = universal.format_text([['''\mMaria's face takes on a slightly haunted look. Her voice is soft. "That's because they don't have the same job. Armando and Isaias protect the people of Chengue from bad guys. Avernite guards protect Carnutians from Taironans."''']])
    maria_1p1p3_1_1.music = [MARIA]
maria_1p1p3_1_1.quip_function = maria_1p1p3_1_1_quip
maria_1p1p3p1_1_1 = Node(56) 
maria_1p1p3p2_1_1 = Node(57) 
maria_1p1p3p3_1_1 = Node(58)
maria_1p1p3_1_1.children = [maria_1p1p3p1_1_1, maria_1p1p3p2_1_1, maria_1p1p3p3_1_1]
maria_1p1p3_1_1.playerComments = ['''"Maria, are you alright?"''', 
'''"Surely most guards want to protect us. I mean, maybe there are a few bad apples out there, but they must be in the minority."''', 
'''"Then it sounds they're crappy guard. We should bring in Armando and have him whip them into shape."''']

def maria_1p1p3p1_1_1_quip():
    maria_1p1p3p1_1_1.quip = universal.format_text([['''"It's been a long, long ten years," says Maria. She lifts her head up and gives''', p.PC.name, '''a false smile. "But enough of that. Things really haven't been as bad as I've been carrying on about. Life's
just a bit more complicated than you'd ever imagine, growing up in Chengue. Anyway..." Maria reaches down and pulls out a scrap of parchment. "Here. This is my address in the slums. Come see me sometime. I need to be going soon, so if you have any questions, now's probably the best time to ask them."'''],
    '''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword("Marias_home")

maria_1p1p3p1_1_1.quip_function = maria_1p1p3p1_1_1_quip
maria_1p1p3p1_1_1.children = mariaRootChildren
maria_1p1p3p1_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p3p2_1_1_quip():
    maria_1p1p3p2_1_1.quip = universal.format_text(['''"Oh, most guards want to protect people all right," says Maria. Her lips twist into a bitter smile. "Problem is, it's not us they care about. They only care about the merchant guilds, the nobility, and the clergy. Sometimes they have a little spare time and try to help craftsmen and the like. But us? We are far, far beneath their notice."''',
    [p.PC.name, '''nods, picking at a loose thread in the hem of''', hisher(p.PC), '''tunic.'''],
    '''"Sorry," says Maria. "Don't mean to be so bitter, it just slips out sometimes. Anyway..." Maria opens up her pack and pulls out a scrap of parchment. "Here. This is my address in the slums. Come see me sometime. I need to be going soon, so if you have any questions, now's probably the best time to ask them."''',
                '''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword("Marias_home")

maria_1p1p3p2_1_1.quip_function = maria_1p1p3p2_1_1_quip
maria_1p1p3p2_1_1.children = mariaRootChildren
maria_1p1p3p2_1_1.playerComments = mariaRootPlayerComments

maria_1p1p3p3_1_1.quip = '''Maria chuckles. "There's an image for you. A half-senile old man coming in and teaching all these impertinent young brats the proper way to act as city guards." Maria's smile fades. "If only. You know, after seeing what I've seen these past years, I can't help but wonder. How much of Armando was Armando, and how much was the fact that Chengue is a dinky little town where nothing bad ever happens?"'''
maria_1p1p3p3p1_1_1 = Node(59)
maria_1p1p3p3p2_1_1 = Node(60)
maria_1p1p3p3_1_1.children = [maria_1p1p3p3p1_1_1, maria_1p1p3p3p2_1_1]
maria_1p1p3p3_1_1.playerComments = ['''"Armando of course. Good, honest folk are good, honest folk, regardless of the circumstances."''', 
'''"Probably more the fact that Chengue is a dinky little town where nothing bad ever happens."'''] 

def maria_1p1p3p3p1_1_1_quip():
    maria_1p1p3p3p1_1_1.quip = universal.format_text([['''Maria's smile turns, if anything, even more bitter. She reaches over and pinches''', p.PC.name + "'s", '''cheek. "You're so cute. I'd offer to make a bet about that, but you seem just naive enough to take it."''']])

maria_1p1p3p3p1_1_1.quip_function = maria_1p1p3p3p1_1_1_quip
maria_1p1p3p3p1p1_1_1 = Node(61) 
maria_1p1p3p3p1p2_1_1 = Node(62)
maria_1p1p3p3p1_1_1.children = [maria_1p1p3p3p1p1_1_1, maria_1p1p3p3p1p2_1_1]
maria_1p1p3p3p1_1_1.playerComments = [' '.join(['''"Shut up. Life isn't just a choice between being a naive child and being a bitter old hag."''']), 
'''"Maria, are you sure you're ok? You've changed so much."'''] 

def maria_1p1p3p3p1p1_1_1_quip():
    maria_1p1p3p3p1p1_1_1.quip = universal.format_text([[p.PC.name, '''angrily pushes Maria's hand away from''', hisher(p.PC), '''cheek and glares at her.'''],
'''Maria grimaces. "Sorry. Didn't mean to be so demeaning. It's just, Catalin felt the exact same thing when she first came here, too. And she was proven very very wrong."''', 
['''"Speaking of Catalin, do you know where she is?" asks''', p.PC.name + ".", '''"I'd like to see her."'''],
'''Maria shrugs. "A few years ago she left. Got tired of Avaricum, and decided to seek out greener pastures. I don't know where she is now."''',
'''"Oh."''',
'''"Sorry," says Maria. She opens up her pack and pulls out a scrap of parchment. "Here, before I forget, it's my address in the slums. Come by and visit me sometime. Do you have any questions about anything?"''',
                '''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword("asked_Maria_about_Catalin")

maria_1p1p3p3p1p1_1_1.quip_function = maria_1p1p3p3p1p1_1_1_quip
maria_1p1p3p3p1p1_1_1.children = mariaRootChildren
maria_1p1p3p3p1p1_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p3p3p1p2_1_1_quip():
    maria_1p1p3p3p1p2_1_1.quip = universal.format_text([[p.PC.name, '''reaches up and gently rests''', hisher(p.PC), '''hand on Maria's (''' + HeShe(p.PC), '''also extracts her cheek from Maria's fingers. That pinch hurt!).'''], 
'''Maria runs her other hand through her hair. "I'm fine. It's just, seeing you reminds me of happier, more ignorant times is all. Catalin and I were going to change the world. We were so young. So young, and so stupid."''', 
['''"What happened?" asks''', p.PC.name + "."], 
'''"Ancient history." Maria opens up her pack and removes a scrap of parchment. "Here. My address in the slums. Come see me sometime. I need to be going soon, so if you have any questions, now's the time to ask them."''',   
'''"But-"''',
'''"Please," says Maria, a hint of pleading in her voice. "Maybe someday, we can talk about it. But not now."''',
[p.PC.name, '''considers for a moment, then nods.'''],
'''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword("Marias_home")

maria_1p1p3p3p1p2_1_1.quip_function = maria_1p1p3p3p1p2_1_1_quip
maria_1p1p3p3p1p2_1_1.children = mariaRootChildren
maria_1p1p3p3p1p2_1_1.playerComments = mariaRootPlayerComments

def maria_1p1p3p3p2_1_1_quip():
    maria_1p1p3p3p2_1_1.quip = universal.format_text([['''Maria studies''', p.PC.name, '''for a minute. "I can't decide if the fact that you think that is a good thing, or a bad thing. On the one hand, it'll make growing up the rest of the way that much easier. On the other hand, I don't know. I don't want to say ignorance is a good thing, because it never is. But... I don't know."'''],
'''The two sit in silence for a few minutes.''',
'''"Oh, before I forget," mutters Maria, opening her pack and rooting around in it. She pulls out a crumpled scrap of parchment. "Here. It has my address in the slums on it. If you need anything, come and see me. Hell, come and see me even if you don't need anything, my door's always open. But I need to go soon, so if you have any questions, now would be a good time to ask them."''',
'''Now you can find Maria's house in the slums, on the far eastern side of the city.'''])
    p.PC.add_keyword("Marias_home")

maria_1p1p3p3p2_1_1.quip_function = maria_1p1p3p3p2_1_1_quip
maria_1p1p3p3p2_1_1.children = mariaRootChildren
maria_1p1p3p3p2_1_1.playerComments = mariaRootPlayerComments

def maria_2_1_1_quip():
    maria_2_1_1.quip = universal.format_text([['''"Oh you're not imposing," says Maria, pushing the bread and cheese into''', p.PC.name + "'s", '''hands. "Now eat, before I do what Reyna would do if she heard you'd turned down someone's offer of hospitality."''']])

maria_2_1_1.quip_function = maria_2_1_1_quip
maria_2p1_1_1 = Node(63) 
maria_2p2_1_1 = Node(64)
maria_2_1_1.children = [maria_2p1_1_1, maria_2p2_1_1]
maria_2_1_1.playerComments = ['''"Well, I am hungry."''', '''"You wouldn't really spank me because I refused to eat your food, would you?"''']

def maria_2p1_1_1_quip():
    maria_2p1_1_1.quip = universal.format_text([['''"So what are you waiting for?" asks Maria, she points at the bread in''', p.PC.name + "'s", '''hand. "There sitting in your hand is some delicious, well tasty, maybe more like edible, food. Eat up!"'''],
    [p.PC.name, '''smiles, and start wolfing down the meager fare.''', HeShe(p.PC), '''hadn't quite rationed''', hisher(p.PC), '''food well enough, and''', heshe(p.PC), '''had been forced to go without dinner last night and breakfast this morning. "You're pushier than that guard who questioned me when I entered the city. Bet you'd fit right in with them."''', universal.format_line([p.PC.name +"'s", '''smile falters for a second, as''', hisher(p.PC), '''thoughts flick back to that abyss.''']) if "charmed_by_Deidre" in p.PC.keywords else ''],
    '''Maria raises her eyebrows. "If you were anyone else, you'd be over my knee and howling, right about now."''',
    ['''"It's just a joke," says''', p.PC.name, '''around a mouthful of food.'''],
    '''"I know, but you need to understand that around here, implying that a Taironan is, was, or might someday be associated with the city guard is a good way to end up in a duel. And I don't care what Aunt Reyna said about your potential, you are not ready to fight someone whose been fighting on the streets of the slums since they were old enough to hold a knife."''',
    ['''"Wait, Taironan children fight from the minute they're old enough to hold a knife?" asks''', p.PC.name + "."],
    '''"Some of them," says Maria. "I mean not all of them. Not even most of them. But they're the ones most likely to be offended. Regardless, the point is that saying that a Taironan is involved with the guards is like saying their daughter and sister are the same."''',
    '''"Oh."''',
    '''"Yeah. Oh." Maria takes a bite of her own lunch.''',
    ['''"What have the guards done?" asks''', p.PC.name + ".", universal.format_line([HeShe(p.PC), '''wonders if''', hisher(p.PC), '''trip to the abyss had been a special case, or normal.''']) if "charmed_by_Deidre" in p.PC.keywords else ''],
    '''"Don't even get me started," says Maria curtly. "They badger any Taironan who enters the city. They randomly stop, search, and question Taironans whose only crime was walking down the Mother cursed street. And worst of all they have those wretched puppeteers MC you if you don't cooperate."'''])
    if "charmed_by_Deidre" in p.PC.keywords:
        if not maria_1p1p1_1_1 in maria_2p1_1_1.children: 
            maria_2p1_1_1.children.append(maria_1p1p1_1_1)
            maria_2p1_1_1.playerComments.append('''"Yeah, I learned that last one the hard way."''')
    else:
        if not maria_1p1p2_1_1 in maria_2p1_1_1.children: 
            maria_2p1_1_1.children.append(maria_1p1p2_1_1)
            maria_2p1_1_1.playerComments.append('''"That's just Taironan propaganda. I refuse to believe they'd ever do that for any reason other than self-defense, and even then it'd just be a Charm, not a full MC."''')
    
maria_2p1_1_1.quip_function = maria_2p1_1_1_quip
maria_2p1_1_1.children = [maria_1p1p3_1_1]
maria_2p1_1_1.playerComments = ['''"Really? I never imagined... but Armando was always such a kind old man, even if he could get a little grumpy. And sure Isaias could be a bit obnoxious, but I can't imagine him ever doing something like that."''']


def maria_2p2_1_1_quip():
    maria_2p2_1_1.quip = universal.format_text(['''"No," says Maria. "My hairbrush is worn out enough as it is. Besides, eating in front of someone is so much more fun when they're not eating too. Observe." Maria splits a small loaf of bread, and takes a big bite. "Hmm. So delicious. Man, it's so great having a full stomach. Especially after all that hard walking I didn't have to do."''',
[p.PC.name + "'s", '''stomach rumbles, and Maria grins smugly.'''],
['''"Alright, alright already," says''', p.PC.name + ",", '''petulantly taking a bite of''', hisher(p.PC), '''lunch. "Jerk."'''],
 ['''Maria chuckles. "That's what you get for refusing my hospitality you silly''', boygirl(p.PC) + "."],
[p.PC.name, '''sticks''', hisher(p.PC), '''tongue out at her. "You're an even bigger jerk than that guard who pestered me outside the city."''', (' '.join([p.PC.name, '''snaps''', hisher(p.PC), '''tongue back into''', hisher(p.PC), '''mouth, as''', hisher(p.PC), '''thoughts flick back to the abyss.''']) if "charmed_by_Deidre" in p.PC.keywords else '')], 
'''Maria's expression sobers. "That reminds me. You better be careful about what you say about the guards when talking to other Taironans. Lately, they've been coming down hard on us. Searching random Taironans for the simple crime of walking down the street, taking them in for questioning for the most pathetically thin reasons, and mind controlling anyone who doesn't fully cooperate."'''])
    if "charmed_by_Deidre" in p.PC.keywords:
        maria_2p2_1_1.children.append(maria_1p1p1_1_1)
        maria_2p2_1_1.playerComments.append('''"Yeah, I learned that last one the hard way."''')
    else:
        maria_2p2_1_1.children.append(maria_1p1p2_1_1)
        maria_2p2_1_1.playerComments.append('''"That's just Taironan propaganda. I refuse to believe they'd ever do that for any reason other than self-defense, and even then it'd just be a Charm, not a full MC."''')
    

maria_2p2_1_1.quip_function = maria_2p2_1_1_quip
maria_2p2_1_1.children = [maria_1p1p3_1_1]
maria_2p2_1_1.playerComments = ['''"Really? I never imagined... but Armando was always such a kind old man, even if he could get a little grumpy. And sure Isaias could be a bit obnoxious, but I can't imagine him ever doing something like that."''']

maria_3p1_1_1 = Node(65)
maria_3p2_1_1 = Node(66)
maria_3p3_1_1 = Node(67)
def maria_3_1_1_quip():
    maria_3_1_1.quip = universal.format_text(['''"And you're worried that maybe you need to change plans," says Maria, nodding. "Understandable. However, at this point, the Adventurer's Guild is practically the only place willing to hire Taironans. You can look around a bit if you want, but really the Guild is your only option, unless you want seasonal work on the farms. And that work's not pleasant, when it's there at all.''', '''"Fortunately, Adrian's a good man. He won't send you into anything that's over your head, and he treats his employees very well. In fact, let him know that I sent you, and he's certain to hire you. We've got a long, successful history together."'''])

    if not "Maria_intimidated_you" in p.PC.keywords:
        if maria_3_1_1.children is None:
            maria_3_1_1.children = [maria_3p1_1_1, maria_3p2_1_1, maria_3p3_1_1]
        maria_3_1_1.children.extend([maria_3p1_1_1, maria_3p2_1_1, maria_3p3_1_1]) 
        if maria_3_1_1.playerComments is None:
            maria_3_1_1.playerComments = ['''"A 'history' eh? Didn't know you were that kind of girl."''', '''"Ooh, a 'history'? Got any dirty details to share?"''', 
                    '''"Thanks, I will! Wait, this isn't some sort of prank is it? He doesn't actually like hate you or something does he? I won't get my booty blistered if I mention your name, will I?"''']
        else:
            maria_3_1_1.playerComments.extend(['''"A 'history' eh? Didn't know you were that kind of girl.", "Ooh, a 'history'? Got any dirty details to share?"''', 
                '''"Thanks, I will! Wait, this isn't some sort of prank is it? He doesn't actually like hate you or something does he? I won't get my booty blistered if I mention your name, will I?"'''])
    else:
        maria_3_1_1.children = mariaRootChildren
        maria_3_1_1.playerComments = mariaRootPlayerComments
    commentIndex = mariaRootChildren.index(maria_3_1_1)
    try:
        mariaRootChildren.remove(maria_3_1_1)
    except ValueError:
        return
    del mariaRootPlayerComments[commentIndex]

maria_3_1_1.quip_function = maria_3_1_1_quip

def maria_3p1_1_1_quip():
    maria_3p1_1_1.music = [LIGHT_HEARTED]
    maria_3p1_1_1.quip = universal.format_text([['''\m"Oh stop." Maria smacks''', p.PC.name, '''upside the head, her lips quirking. "That's not what I meant by 'history' and you know it. I'm just one of his more successful adventurers, and he trusts my judgement."'''],
    ['''"Yeah, I'll bet he does," says,''', p.PC.name, '''grinning suggestively.'''],
    ['''"Brat!" cries Maria, her voice filled with laughter. She jerks''', p.PC.name, '''to''', hisher(p.PC), '''feet and lands three smacks to''', hisher(p.PC), '''bottom. They're not particularly hard slaps, and clearly meant more as a joke than any sort of actual punishment.'''],
    ['''That doesn't stop''', p.PC.name, '''from mock-yelping, and pouting. "I'm just teasing you. You're such a big jerk."'''],
    '''Maria rolls her eyes. "Yes, I am a huge jerk. Keep that in mind the next time you try to imply that I sleep with my boss."''',
    [p.PC.name, '''sticks''', hisher(p.PC), '''tongue out at Maria, who sticks out her tongue right back.'''],
    ['''Maria's tongue returns to its proper place.  "So what else do you need, you insufferable young''', manlady(p.PC) + '?"']])

maria_3p1_1_1.quip_function = maria_3p1_1_1_quip
maria_3p1_1_1.children = mariaRootChildren
maria_3p1_1_1.playerComments = mariaRootPlayerComments

def maria_3p2_1_1_quip():
    maria_3p2_1_1.music = [LIGHT_HEARTED]
    maria_3p2_1_1.quip = universal.format_text([['''\mMaria rolls her eyes. "I can assure you, there is nothing dirty about Adrian. The man probably thinks the Mother created dirt precisely to annoy him. Despite that, he'd rather roll around in the mud than sleep with one of his employees. Maybe. It'd be a tough decision either way."'''],
['''"And how you would know this?" asks,''', p.PC.name + "."], 
['''Maria slaps''', p.PC.name, '''upside the head. "Brat. What would Aunt Reyna say if she saw you acting like this?"'''],
['''"She'd scold you for trying to make a move on your employer of course," says''',  p.PC.name + "."],
['''Maria shakes her head, laughing. "I've missed you, you insufferable little''', boygirl(p.PC) + '."']])

maria_3p2_1_1.quip_function = maria_3p2_1_1_quip
maria_3p2_1_1.children = mariaRootChildren
maria_3p2_1_1.playerComments = mariaRootPlayerComments

def maria_3p3_1_1_quip():
    maria_3p3_1_1.music = [LIGHT_HEARTED]
    maria_3p3_1_1.quip = universal.format_text(['''\mMaria gets shifty-eyed. "Of course not. What could ever make you think that?"''',
[p.PC.name, '''puts''', hisher(p.PC), '''hands on''', hisher(p.PC), '''hips and mock scowls. "Maria."'''],
['''"Oh relax," says Maria, lightly touching''', p.PC.name, '''on the arm. "Adrian and I are close friends, I assure you. He might even give you a discount. Maybe. Guy's almost as stingy as he is clean."''']])

maria_3p3_1_1.quip_function = maria_3p3_1_1_quip
maria_3p3_1_1.children = mariaRootChildren
maria_3p3_1_1.playerComments = mariaRootPlayerComments

def maria_4_1_1_quip():
    maria_4_1_1.music = [LIGHT_HEARTED]
    maria_4_1_1.quip = universal.format_text([['''"You can stay with me until Adrian gives you your first real job," says Maria. "Things can be a bit slow at first, and for the first month or so, you'll probably make barely enough to keep yourself fed, let alone afford a place to live. Once you've got a real job or two under your belt, then we can discuss your options. One possibility is that we room together. It'd certainly be cheaper for both of us."''']])
    if 'Maria_intimidated_you' in p.PC.keywords:
        maria_4_1_1.quip += '\n\n' + universal.format_text([[p.PC.name, '''shrugs. "I'll consider it I guess."'''], 
    '''For a second, Maria looks hurt. "Alright. Well, you know where to find me if you need someplace to stay."'''])
    else:
        maria_4_1_1.quip += '\n\n' + universal.format_text([['''Maria gives''', name(), '''a stern look. "But I'm sure you remember just how-"'''],
    ['''"Anal you are about your living space?" asks''', p.PC.name, '''innocently.'''],
    '''"Oh hush," says Maria. "The point is, there are certain rules you'll have to follow."''',
    ['''"Well I maybe I have rules too," says''', p.PC.name + ",", '''drawing''', himselfherself(p.PC), '''up. "And you'll have to follow them."'''],
    '''"Like I said, it's something we can discuss once you have enough money to make the discussion worthwhile," says Maria. "For now, you can stay with me, if you'd like. You can try talking to Adrian, too. He provides some fairly nice rooms to adventurers for a very reasonable price."'''])
    commentIndex = mariaRootChildren.index(maria_4_1_1)
    try:
        mariaRootChildren.remove(maria_4_1_1)
    except ValueError:
        return
    del mariaRootPlayerComments[commentIndex]

maria_4_1_1.quip_function = maria_4_1_1_quip
maria_4_1_1.children = mariaRootChildren 
maria_4_1_1.playerComments = mariaRootPlayerComments 

def maria_5_1_1_quip():
    maria_5_1_1.quip = universal.format_text(['''"Alright," says Maria, standing. "I've a job that Adrian's been badgering me to work on. I'll see you later tonight, maybe."''',
    ['''"Maybe," says''', p.PC.name + "."]]) 
    if "Maria_intimidated_you" in p.PC.keywords:
        maria_5_1_1.quip += '\n\n' + universal.format_text(['''There is a tense, uncomfortable silence.''',
    '''"Alright, well. Bye then," says Maria at last, before turning and leaving.'''])  
    else:
        maria_5_1_1.quip += '\n\n' + universal.format_text(['''"And don't be shy around Elise," says Maria, as she crouches down, pulls out a small rag and dabs it with water from her canteen. She starts to wipe up the crumbs from her lunch. "Sure she acts like she's working hard, but she hates cleaning and loves any excuse to stop and chat. In particular, she loves talking philosophy."''',
            ['''Once she's finished, she stands, gives''', p.PC.name, '''and Elise a jolly wave, and then walks out of the Cathedral.''']])
    shrine.remove_character(maria)
    offStage.add_character(maria)
maria_5_1_1.quip_function = maria_5_1_1_quip


elise_3_1_1 = Node(70)
elise_4_1_1 = Node(71)
def elise_greeting_1_1_quip_function():
    music.play_music(ELISE)
    if "Maria_intimidated_you" in p.PC.keywords:
        elise_greeting_1_1.quip = universal.format_text(['''"Hi. I, umm, couldn't help but overhear some of what happened," says Elise, smiling uneasily. "Sounded like you two had an argument."''',
[p.PC.name, '''shrugs.'''],
'''"Do you want to talk about it?" asks Elise, fidgeting with her cleaning rag.'''])
        if "Maria_spanked_you" in p.PC.keywords:
            elise_1_1_1.comment = '''"Yeah. I got mind raped by the city guard, and Maria beat me into keeping quiet about it. Have any spiritual words of wisdom to impart?"'''
        else:
            elise_1_1_1.comment = '''"Yeah. I got mind raped by the city guard, and Maria threatened to beat me into keeping quiet about it. Have any spiritual words of wisdom to impart?"'''
    else:
        elise_greeting_1_1.quip = universal.format_text([['''Elise flashes''', p.PC.name, '''a bright smile. "It's nice to finally meet you. Maria's been looking forward to your arrival for weeks. Pretty much all she's talked about is your impending arrival."''']])
        elise_greeting_1_1.children = [elise_3_1_1, elise_4_1_1]

elise_show_you_around = Node(72)
elise_cathedral_history = Node(73) 
elise_farewell = Node(74)
eliseRootChildren = [elise_show_you_around, elise_cathedral_history, elise_farewell]

elise_1_1_1 = Node(75)
elise_2_1_1 = Node(76)
elise_greeting_1_1.quip_function = elise_greeting_1_1_quip_function
elise_greeting_1_1.children = [elise_1_1_1, elise_2_1_1]

elise_farewell.comment = '''"Well, I need to get going. See you around."'''
def elise_farewell_quip_function():
    elise_farewell.quip = '''"Alright. Bye," says Elise.'''
    if "Elise_shows_you_around" in p.PC.keywords:
        elise_farewell.quip += ''' "Don't forget, meet me here this evening, at six. Don't be late."'''
    elif "Marias_home" not in p.PC.keywords:
        elise_farewell.quip += universal.format_text([[''' Elise appears to be considering something. Then, she walks over to a cabinet in the back of the shrine. After taking a quick look around, she opens it. Inside is a quill, some ink, and a few sheets of parchment. She tears off a little bit from one of the sheets, and scribbles something on it. Then, she closes and latches the cabinet, and returns to''', p.PC.name + "."],
    ['''"If someone discovers what I just did I won't be able to sit for a month," she mutters. "Maybe I can blame it on mice." Once she reaches''', p.PC.name + ",", 
        '''she holds out the parchment. "Near as I could tell, Maria never gave you her address. Well, here it is."'''],
    [p.PC.name, '''looks down at the scrap of parchment. "And you think I would want that because..."'''],
    '''Elise sighs in exasperation. "Look, you two were close friends for years, right? Are you really going to let one argument ruin that?"''',
    ['''"She spanked me!" cries''', p.PC.name + ".", '''"For absolutely no reason!"'''],
    '''"I don't believe that," says Elise. "Maybe it wasn't a good reason, but she had to have a reason."''',
    ['''"You have no idea what you're talking about," growls''', p.PC.name + "."],
    '''"Please?" says Elise. "You don't have to read it. Use it for kindling if you want, tear it up and drop on the street outside, but at least take it."''',
    ['''"Fine, if you'll stop harassing me about it," mutters''', p.PC.name + ",", '''taking the parchment and shoving it into''', hisher(p.PC), '''pack. "Happy now?"'''],
    '''"I'll take it," says Elise, shrugging. "See you around."'''])
    elise.litany = elise_default

elise_farewell.quip_function = elise_farewell_quip_function

elise_show_you_around.comment = '''"I wouldn't even know what to ask first. It all just seems like a big mess."'''
elise_show_you_around_yes = Node(77) 
elise_show_you_around_no = Node(78) 
elise_show_you_around_weird = Node(79)
elise_show_you_around.children = [elise_show_you_around_yes, elise_show_you_around_no, elise_show_you_around_weird]

def elise_show_you_around_quip_function():
    if "Maria_intimidated_you" in p.PC.keywords:
        elise_show_you_around.quip = '''"It is a bit of a mess, isn't it?" says Elise ruefully. "But there are nice things out there as well. Look, my friend Carrie and I are going out tonight, to celebrate my ordination. How about you join us? You could use some cheering up, I think."'''
    else:
        elise_show_you_around.quip = '''"Well I think I know how to keep you from feeling quite so overwhelmed," says Elise. "My friend Carrie and I are going out tonight to celebrate my ascension to Sisterhood. How about you join us? It'll be fun, I promise, and you look like you could use some fun."'''
    eliseRootChildren.remove(elise_show_you_around)

elise_show_you_around.quip_function = elise_show_you_around_quip_function

elise_show_you_around_yes.comment = '''"Sure, sounds like fun."'''
elise_show_you_around_yes.children = eliseRootChildren
def elise_show_you_around_yes_quip_function():
    elise_show_you_around_yes.quip = '''"Great," says Elise, grinning. "I'm looking forward to it. Is there anything else I can help you with?"'''
    p.PC.add_keyword("Elise_shows_you_around")
elise_show_you_around_yes.quip_function = elise_show_you_around_yes_quip_function

elise_show_you_around_no.comment = '''"I'm sorry, but I'm busy tonight."'''
elise_show_you_around_no.children = eliseRootChildren
def elise_show_you_around_no_quip_function():
    elise_show_you_around_no.quip = universal.format_text([['''"That's too bad," says Elise. "Oh well. Is there anything else I can do for you?"''']])
elise_show_you_around_no.quip_function = elise_show_you_around_no_quip_function

elise_show_you_around_weird.comment = '''"Well, I don't know..."'''
elise_feel_weird = Node(80) 
elise_carrie_question = Node(81) 
elise_show_you_around_weird.children = [elise_feel_weird, elise_carrie_question, 
    elise_show_you_around_yes, elise_show_you_around_no]
def elise_show_you_around_weird_quip_function():
    elise_show_you_around_weird.quip = '''"Why not?" asks Elise. "I'm not scary, I promise, and I won't get you in trouble. Unlike some people I know ..."'''
    elise_show_you_around_yes.comment = '''"Well, alright. You've convinced me."'''
    elise_show_you_around_no.comment = '''"I'd just rather not, alright?"'''
elise_show_you_around_weird.quip_function = elise_show_you_around_weird_quip_function

def elise_feel_weird_quip_function():
    elise_feel_weird.quip = '''"Because we don't know each other? Well, how are you going to get to know someone if you don't hang out with them for a while?" asks Elise.'''
    elise_show_you_around_yes.comment = '''"I...good point, actually. Alright, I'll go."'''
elise_feel_weird.quip_function = elise_feel_weird_quip_function
elise_feel_weird.comment = '''"I don't know, it'd feel weird."'''
elise_feel_weird_shy = Node(144)
elise_feel_weird.children = [elise_show_you_around_yes, elise_feel_weird_shy]

elise_feel_weird_shy.comment = '''"I just need some time by myself, I guess. To get used to the city."'''
elise_feel_weird_shy.quip = '''"That's understandable," says Elise. "Is there anything else I can help you with?"''' 
elise_feel_weird_shy.children = eliseRootChildren

elise_carrie_question.comment = '''"Some people you know?"'''
elise_enjoy_spanking_carrie_protest = Node(82) 
elise_enjoy_spanking_carrie_poetic = Node(83) 
elise_carrie_question.children = [elise_enjoy_spanking_carrie_protest, elise_enjoy_spanking_carrie_poetic]
def elise_carrie_question_quip_function():
    elise_carrie_question.quip = '''Elise smiles, and her eyes sparkle. "My best friend, Carrie. She's still a student, though she's almost finished. That girl could get the Mother Herself in trouble! Not the bad kind of trouble mind you, she's mostly a perfectly intelligent, nice woman. Just, you know, the mischievous kind of trouble." Elise leans in conspiratorially. "Had to spank her the other day for being out past curfew. Considering all the times she got me in trouble for exactly that when we were both students, it made for some nice poetic justice."'''
    p.PC.add_keyword('Elise_told_you_about_Carries_spanking')
elise_carrie_question.quip_function = elise_carrie_question_quip_function


elise_enjoy_spanking_carrie_protest.comment = '''"You know, you're not supposed to enjoy punishing someone."'''
elise_disbelief = Node(145) 
elise_agree = Node(146)
elise_enjoy_spanking_carrie_protest.children = [elise_disbelief, elise_agree]
elise_enjoy_spanking_carrie_protest.quip = '''"Me? Enjoy punishing someone? Never," says Elise. "It was grim satisfaction derived from a punishment well executed, and a lesson well learned."'''

elise_enjoy_spanking_carrie_poetic.comment = '''"Ah, yes, sweet poetic justice, my favorite kind. Though surely you've gotten her in trouble before. So how do you know that poetic justice won't come back and smack you in the butt?"'''
elise_enjoy_spanking_carrie_poetic.children = [elise_show_you_around_yes, elise_show_you_around_no]
def elise_enjoy_spanking_carrie_poetic_quip_function():
    elise_enjoy_spanking_carrie_poetic.quip = universal.format_text(['''"Because I'm the good girl," says Elise, grinning wolfishly. "If I ever got her in trouble, it was for tattling on something she did, not for convincing her to get in trouble with me."''',
        ['''"Ah, I see," says''', p.PC.name + ".", '''"Truly, you have nothing to fear."'''],
        '''"I know, right?" says Elise. "But you haven't answered my question. Are you going to join Carrie and I tonight?"'''])
elise_enjoy_spanking_carrie_poetic.quip_function = elise_enjoy_spanking_carrie_poetic_quip_function


elise_disbelief.comment = '''"Uh-Huh."'''
elise_disbelief.children = [elise_show_you_around_yes, elise_show_you_around_no]
def elise_disbelief_quip_function():
    elise_disbelief.quip = universal.format_text(['''Elise mock pouts. "Your untrusting nature does you no favors."''',
        ['''"That is my burden to bear," says''', p.PC.name,  '''with overexaggerated solemnity.'''],
    '''Elise's pout vanishes into a grin. "May the Mother have mercy upon your soul. Anyway, you never answered my question. You gonna join us tonight?"'''])
elise_disbelief.quip_function = elise_disbelief_quip_function

elise_agree.comment = '''"Makes perfect sense to me."'''
elise_agree.children = [elise_show_you_around_yes, elise_show_you_around_no]
elise_agree.quip = '''Elise grins. "I think you and I will get along just fine. So, you joining us?"'''

elise_1p1_1_1 = Node(84) 
elise_1p2_1_1 = Node(85)
elise_1_1_1.children = [elise_1p1_1_1, elise_1p2_1_1]
def elise_1_1_1_quip_function():
    elise_1_1_1.quip = universal.format_text([[p.PC.name, '''opens''', hisher(p.PC), '''mouth to tell Elise what happened. The words are there, right on the tip of''', hisher(p.PC), '''tongue. It'd be so easy to just say them. So very easy.'''],
    '''And yet...''',
    ['''What was it Nana always said? "People are people are people." No reason to believe Sisters would be any different from anyone else, vows notwithstanding. Perhaps it'd be better to wait. Get to know Elise better. Yes. After all''', p.PC.name, '''could always tell her later.''']])
elise_1_1_1.quip_function = elise_1_1_1_quip_function

elise_1p1_1_1.comment = '''"Maria's just a heavy-handed, domineering, selfish, short-sighted coward, whose more interested in her own comfort than what's right."'''
elise_1p1p1_1_1 = Node(86) 
elise_1p1p2_1_1 = Node(87) 
elise_1p1p3_1_1 = Node(88)
elise_1p1_1_1.children = [elise_1p1p1_1_1, elise_1p1p2_1_1, elise_1p1p3_1_1]
def elise_1p1_1_1_quip_function():
    elise_1p1_1_1.quip = universal.format_text([['''Elise puts her hand on''', p.PC.name + "'s", '''shoulder and gives it a comforting squeeze.  "You sound angry."''']])
elise_1p1_1_1.quip_function = elise_1p1_1_1_quip_function

elise_1p1p1_1_1.comment = '''"Angry? I'm not angry,  I'm Madre-be-cursed furious! She had no right. No right!"''' 
elise_1p1p1p1_1_1 = Node(89) 
elise_1p1p1p2_1_1 = Node(90)
elise_1p1p1p3_1_1 = Node(91)
elise_1p1p1_1_1.children = [elise_1p1p1p1_1_1, elise_1p1p1p2_1_1, elise_1p1p1p3_1_1]
elise_1p1p1_1_1.quip = '''"Perhaps she was scared you'd make some terrible mistake," says Elise.'''

elise_1p1p1p1_1_1.comment = '''"I just want justice, dammit! How could that possibly be a mistake?"'''
def elise_1p1p1p1_1_1_quip_function(): 
    elise_1p1p1p1_1_1.quip = universal.format_text([['''"I guess that depends on what you want to do in life," says Elise, shrugging. "If you just want to live a quiet, comfortable life, which is what Maria wants, then pursuing justice can be a massive mistake. Especially in times like these. If instead you want a life of principle, where you fight for whatever you believe is right, then it's not a mistake." Elise gives''', p.PC.name, '''a warning look. "Be careful, though. Sister Samantha tells me all the time that it's not always clear which is the right principle, let alone how to stand by it. Before you even try to commit to anything, try to get a full understanding of the situation."'''],
        [p.PC.name, '''nods a touch reluctantly. Nana had often told''', himher(p.PC), '''a similar thing. Perhaps it would be best if''', heshe(p.PC), '''took that to heart, for now.'''],
        ['''"You know, if you give me a few details of what happened, I might be able to help you better," says Elise. She takes''', p.PC.name + "'s", '''hand. "Or maybe Sister Samantha can help. She's a wonderful woman, and wants nothing more than for all the Mother's children to live happy, fulfilling lives."'''],
        [p.PC.name, '''shakes''', hisher(p.PC), '''head.'''],
    ['''Elise grimaces. "Well, alright, if that's what you want. I hope I've done something to help you, even a little." Elise gives''', p.PC.name + "'s", '''hand another pat. "Now, is there anything else you need?"''']])
elise_1p1p1p1_1_1.quip_function = elise_1p1p1p1_1_1_quip_function
elise_1p1p1p1_1_1.children = eliseRootChildren

elise_1p1p1p2_1_1.comment = '''"Maybe. I don't know. Mother's love, I don't know anything."'''
def elise_1p1p1p2_1_1_quip_function():
    elise_1p1p1p2_1_1.quip = universal.format_text(['''"Welcome to life," says Elise sardonically. "But just relax, there's no rush on anything. Get used to the city, get your feet under you. Let the stress of arrival fade. Maybe then you'll have a better perspective on Maria's fears, and from there you can decide if you're
going to be angry or not."''',
    [p.PC.name, '''nods. Perhaps Elise is right. At the very least, doing what she 
suggests would be easier. That isn't so bad, is it? At least as a temporary measure?'''],
    '''"Now, is there anything else I can help you with?" asks Elise. "Any questions or anything you want answered? Because I'm here if you need anything.'"'''])
elise_1p1p1p2_1_1.quip_function = elise_1p1p1p2_1_1_quip_function
elise_1p1p1p2_1_1.children = eliseRootChildren

elise_1p1p1p3_1_1.comment = '''"I guess."'''
elise_1p1p1p3_1_1.quip = '''"Well, think about it a while, I guess. Until then, how about we change the subject, maybe talk about something less unpleasant? Maybe it'll make you feel better. For example, is there anything you'd like to know about the city?" asks Elise.'''
elise_1p1p1p3_1_1.children = eliseRootChildren

elise_1p1p2_1_1.comment = '''"I don't know. I'm hurt. She was supposed to be my friend. I'd been looking forward to seeing her for weeks. And from the  minute this wretched city came into view, everything began going wrong."'''
elise_1p1p2p1_1_1 = Node(92) 
elise_1p1p2p2_1_1 = Node(93) 
elise_1p1p2p3_1_1 = Node(94)
elise_1p1p2_1_1.children = [elise_1p1p2p1_1_1, elise_1p1p2p2_1_1, elise_1p1p2p3_1_1]
def elise_1p1p2_1_1_quip_function():
    elise_1p1p2_1_1.quip = universal.format_text([['''Elise pulls''', p.PC.name, '''into a brief hug. "That makes sense. But understand, all she's''', 
'''talked about for the past two weeks is your impending arrival. She's been looking forward to today as much as you have, and she's probably just as hurt that things went so terribly."''']])
    if "Maria_spanked_you" in p.PC.keywords:
        elise_1p1p2p1_1_1.comment = '''"If that were true, she never would have spanked me."'''
    else:
        elise_1p1p2p1_1_1.comment = '''"If that were true, she never would have threatened to spank me."'''
elise_1p1p2_1_1.quip_function = elise_1p1p2_1_1_quip_function

elise_1p1p2p1_1_1.children = eliseRootChildren
def elise_1p1p2p1_1_1_quip_function():
    elise_1p1p2p1_1_1.quip = universal.format_text(['''"I have no answer for that," says Elise reluctantly. "Because I don't know why she spanked you. But she believes she had a good reason, and before you judge her too harshly, perhaps you should try to get a better understanding of what that reason was."''',
    [p.PC.name, '''looks away.'''],
    '''Elise sighs. "Just think about it at least. She cares deeply for you, and is almost certainly in just as much pain as you."''',
    ['''"Find that highly unlikely," grumbles''', p.PC.name + ",", '''rubbing''', hisher(p.PC), '''stinging bottom.'''],
    '''"Well-"''',
    ['''"Can we talk about something else?" asks''', p.PC.name + "."],
    '''"Ok," says Elise. "Anything in particular you'd like to talk about?"'''])
elise_1p1p2p1_1_1.quip_function = elise_1p1p2p1_1_1_quip_function

elise_1p1p2p2_1_1.comment = '''"I just want to go home. At least there, I only got spanked when I did something bad."'''
def elise_1p1p2p2_1_1_quip_function():
    elise_1p1p2p2_1_1.quip = universal.format_text([['''Elise pats''', p.PC.name, '''on the shoulder. "I know. But don't give up on this city just yet. It's got its warts, but it's beautiful too."'''],
    [p.PC.name, '''shrugs.'''],
    '''"Let's talk about something else, then. Maybe try to take your mind off it," says Elise."'''])
elise_1p1p2p2_1_1.quip_function = elise_1p1p2p2_1_1_quip_function
elise_1p1p2p2_1_1.children = eliseRootChildren

elise_1p1p2p3_1_1.comment = '''"I guess."'''
elise_1p1p2p3_1_1.quip = universal.format_text(['''"Give yourself some time. Hopefully once you've calmed down, you'll be better able to think about it. For now, let's try to change the subject, talk about something a little bit more pleasant. Is there anything you'd like to know about Avaricum or the Cathedral or something? Been living here my whole life, so I know quite a bit about it," says Elise."''',
    '''"Cathedral?"''',
    '''Elise smiles. "It's what we call this place. I know, it's not as fancy as some of the overpriced monoliths that have been raised in the Father and Mother's 'honor' in other kingdoms, but at least this Cathedral is dedicated to actually helping people."''',
    '''"I see."''',
    '''"It's lucky for me that it's not like the others," says Elise. She runs her hand lovingly across the top of one of the pews. "Grew up in the orphanage here. My friend Carrie and I both. Probably be dead right now if it wasn't for the Cathedral, and the Brothers and Sisters who work here." She glances up. "But enough about me. Anything you'd like to know about?"'''])
elise_1p1p2p3_1_1.children = eliseRootChildren

elise_1p1p3_1_1.comment = '''"It doesn't matter."'''
elise_1p1p3p1_1_1 = Node(95) 
elise_1p1p3p2_1_1 = Node(96) 
elise_1p1p3p3_1_1 = Node(97)
elise_1p1p3_1_1.children = [elise_1p1p3p1_1_1, elise_1p1p3p2_1_1, elise_1p1p3p3_1_1]
elise_1p1p3_1_1.quip = '''"Are you sure?" asks Elise. "I mean, it certainly looks like it matters."'''

elise_1p1p3p1_1_1.comment = '''"I wouldn't have said it if I wasn't sure! Just back off and leave me  alone."'''
elise_1p1p3p1p1_1_1 = Node(98) 
elise_1p1p3p1p2_1_1 = Node(99)
elise_1p1p3p1_1_1.children = [elise_1p1p3p1p1_1_1, elise_1p1p3p1p2_1_1]
elise_1p1p3p1_1_1.quip = '''"Well, I'm sorry,' says Elise defensively. "I just want to help."'''

elise_1p1p3p1p1_1_1.comment = '''"I'm sorry. I shouldn't have snapped like that. It's been a bad day, is all."'''
elise_1p1p3p1p1_1_1.quip = '''"It's alright,' says Elise. "I understand. If you don't want to talk about it, that's fine. We can just change the subject. Like, is there anything you'd like to know about Avaricum, or the Cathedral?"'''
elise_1p1p3p1p1_1_1.children = eliseRootChildren

elise_1p1p3p1p2_1_1.comment = '''"Well, I don't want your help!"'''
def elise_1p1p3p1p2_1_1_quip_function():
    elise_1p1p3p1p2_1_1.quip = universal.format_text([[p.PC.name, '''grabs''', hisher(p.PC), '''pack.'''],
        ['''"''' + p.PC.name + ",", '''wait," says Elise, starting after''', himher(p.PC) + "."],
        [p.PC.name, '''storms out of the church, and back onto Avaricum Square, quickly leaving the young Sister behind. The Sister doesn't follow.''']])
    p.PC.add_keyword('stormed_from_church')
    return (universal.acknowledge, [go, avaricumSquare])
elise_1p1p3p1p2_1_1.quip_function = elise_1p1p3p1p2_1_1_quip_function

elise_1p1p3p2_1_1.comment = '''"I don't know. Maybe. I just, I'm angry, and I'm hurt and I'm a little bit scared, and today was supposed to be a good day, but it's all been horribly ruined and I just want to go home."'''
def elise_1p1p3p2_1_1_quip_function():
    elise_1p1p3p2_1_1.quip = universal.format_text([['''"I know." Elise wraps her arm around''', p.PC.name + "'s", '''waist, and gives''', himher(p.PC), '''a squeeze. "But try not to give up yet. After all, you've only just arrived. There are so many wondrous things to see, like the
100 Fountain Garden, or the Mid-Summer Festival. Believe me, Avaricum isn't all bad. In fact, I'd say it's mostly good."'''],
        [p.PC.name, '''nods, drawing comfort, almost despite''', himselfherself(p.PC) + ",", '''from Elise's hug and optimism.'''],
        '''"Anything else on your mind?" she asks after a moment of silence.'''])
elise_1p1p3p2_1_1.children = eliseRootChildren
elise_1p1p3p2_1_1.quip_function = elise_1p1p3p2_1_1_quip_function

elise_1p1p3p3_1_1.comment = '''"I just need some time to think about it, is all. I appreciate your concern, but I just don't want to talk about it now."'''
elise_1p1p3p3_1_1.quip = '''"Perfectly understandable," says Elise. "Know that I'm here if ever you need anything. Now, is there anything you else you need?" She grimaces down at her cleaning rag. "Or should I return to my cleaning?"'''
elise_1p1p3p3_1_1.children = eliseRootChildren

elise_1p2_1_1.comment = '''"It doesn't matter."'''
elise_1p2p1_1_1 = Node(100)
elise_1p2p3_1_1 = Node(101)
elise_1p2_1_1.children = [elise_1p2p1_1_1, elise_1p1_1_1, elise_1p2p3_1_1]
def elise_1p2_1_1_quip_function():
    elise_1p2_1_1.quip = universal.format_text([['''"Of course it matters," says Elise, taking''', p.PC.name + "'s", '''hands in hers. "Maria looked like she was about to completely breakdown, and you look pretty bad too. Are you sure you don't want to talk about it?"''']])
    if "Maria_spanked_you" in p.PC.keywords:
        elise_1p2p1_1_1.comment = '''"When I first arrived I was questioned by the city guards. I wasn't very cooperative, so they took me into a small guardroom. There was a woman there. She looked me in the eye, and mind controlled me. The next thing I knew, I was standing in the square, and Maria was calling my name. I told Maria about it, and she insisted I keep quiet. I refused, so she beat me until I agreed."'''
    elif "Maria_intimidated_you" in p.PC.keywords:
        elise_1p2p1_1_1.comment = '''"When I first arrived I was questioned by the city guards. I wasn't very cooperative, so they took me into a small guardroom. There was a woman there. She looked me in the eye, and mind controlled me. The next thing I knew, I was standing in the square, and Maria was calling my name. I told Maria about it, and she insisted I keep quiet. She threatened to beat me, unless I agreed."''' 
    else:
        elise_1p2p1_1_1.comment = '''"When I first arrived I was questioned by the city guards. I wasn't very cooperative, so they took me into a small guardroom. There was a woman there. She looked me in the eye, and mind controlled me. The next thing I knew, I was standing in the square, and Maria was calling my name. I told Maria about it, and she insisted I keep quiet."''' 
elise_1p2_1_1.quip_function = elise_1p2_1_1_quip_function


elise_1p2p1p1_1_1 = Node(102) 
elise_1p2p1p2_1_1 = Node(103)
elise_1p2p1_1_1.children = [elise_1p2p1p1_1_1, elise_1p2p1p2_1_1]
def elise_1p2p1_1_1_quip_function():
    elise_1p2p1_1_1.quip = universal.format_text([[p.PC.name, '''looks at Elise. Everything about her is gentle, from the way she rests her hand on''', p.PC.name + "'s", '''hand, to the way she patiently watches the young Taironan, waiting for a response. Surely''', p.PC.name, '''can trust her. Maria was just overreacting.''', p.PC.name, '''opens''', hisher(p.PC), '''mouth to tell Elise everything that happened, but something stops''', himher(p.PC) + ".", HeShe(p.PC), '''doesn't know if it's fear, or dread, or some stupid hook that puppeteer put in''', himher(p.PC), '''but''', heshe(p.PC), '''just can't bring''', himselfherself(p.PC), '''to say anything.'''],
    ['''Finally,''', p.PC.name, '''looks away and shrugs uncomfortably. "Just, when I first arrived, the guards questioned me a bit more intensely than I would have liked. When I complained about it to Maria, she told me just to keep quiet, because it would bring more trouble down on me. Better to just keep my head down, she said. To just act like it never happened. But, that feels so wrong."'''],
    ['''Elise gives''', p.PC.name + "'s", '''hands another squeeze. "I can understand why that would make you angry. But her fear is justified. Things are very, very tense right now, especially between the guards and Taironans. Roland's trying to keep things under control, trying to keep things from getting too bad, but he's got a lot of forces pulling him in a dozen different directions, and he can only do so much. There's nothing wrong with waiting until things calm down a little."''']])
elise_1p2p1_1_1.quip_function = elise_1p2p1_1_1_quip_function

elise_1p2p1p1_1_1.comment = '''"Figures you'd make excuses for the guards. Guess if I want help, I'll have to look somewhere else."'''
elise_1p2p1p1p1_1_1 = Node(104)
elise_1p2p1p1p2_1_1 = Node(105)
elise_1p2p1p1_1_1.children = [elise_1p2p1p1p1_1_1, elise_1p2p1p1p2_1_1]
def elise_1p2p1p1_1_1_quip_function():
    elise_1p2p1p1_1_1.quip = universal.format_text([[p.PC.name, '''grabs''', hisher(p.PC), '''pack.'''],
['''"''' + p.PC.name, '''wait," says Elise, grabbing''', p.PC.name + "'s", '''arm. "Please, I'm trying to help you as best I can, but I can't do anything but give vague advice if you don't give me details."''']])
elise_1p2p1p1_1_1.quip_function = elise_1p2p1p1_1_1_quip_function

elise_1p2p1p1p1_1_1.comment = '''"If I did, you'd probably just tell me I was asking for it."'''
elise_1p2p1p1p1p1_1_1 = Node(106) 
elise_1p2p1p1p1p2_1_1 = Node(107)
elise_1p2p1p1p1_1_1.children = [elise_1p2p1p1p1p1_1_1, elise_1p2p1p1p1p2_1_1]
def elise_1p2p1p1p1_1_1_quip_function():
    elise_1p2p1p1p1_1_1.quip = universal.format_line(['''"I don't care what they did, or what you did," says Elise. She puts a hand on''', p.PC.name + "'s", 
            '''shoulder. "I would never, ever say that."'''])
elise_1p2p1p1p1_1_1.quip_function = elise_1p2p1p1p1_1_1_quip_function

elise_1p2p1p1p1p1_1_1.comment = '''"Sorry for snapping like that. But we can just drop it? I really don't want to talk about this anymore."'''
elise_1p2p1p1p1p1_1_1.children = eliseRootChildren
def elise_1p2p1p1p1p1_1_1_quip_function():
    elise_1p2p1p1p1p1_1_1.quip = universal.format_text([['''Elise lets go of''', p.PC.name + "'s", '''arm. "I'm sorry too. I never meant to make you think I wasn't sympathetic. I just I'm trying to help as best I can."'''],
    ['''"Can we just change the subject, please?" asks''', p.PC.name, '''putting''', hisher(p.PC), '''pack back on one of the pews.'''],
    '''"Of course," says Elise. She forces a smile. "If there's anything you'd like to know about the Cathedral, or Avaricum, please ask it."'''])
elise_1p2p1p1p1p1_1_1.quip_function = elise_1p2p1p1p1p1_1_1_quip_function

elise_1p2p1p1p1p2_1_1.comment = '''"I'll believe it when I see it."'''
def elise_1p2p1p1p1p2_1_1_quip_function():  
    elise_1p2p1p1p1p2_1_1.quip = universal.format_text([[p.PC.name, '''pulls''', hisher(p.PC), '''arm free, and leaves the Church, taking a deep breath as''', heshe(p.PC), '''emerges into the harsh late-spring sunlight baking Avaricum Square.''']])
    p.PC.add_keyword('stormed_from_church')
    return (universal.acknowledge, [go, avaricumSquare]) 
elise_1p2p1p1p1p2_1_1.quip_function = elise_1p2p1p1p1p2_1_1_quip_function

elise_1p2p1p1p2_1_1.comment = '''"I'm done talking about this."''' 
elise_1p2p1p1p2_1_1.children = eliseRootChildren
def elise_1p2p1p1p2_1_1_quip_function():
    elise_1p2p1p1p2_1_1.quip = universal.format_text([['''"Ok, ok," says Elise, letting go of''', p.PC.name + "'s", '''hand. "Is there anything else you'd like to talk about?"''']])
elise_1p2p1p1p2_1_1.quip_function = elise_1p2p1p1p2_1_1_quip_function

elise_1p2p1p2_1_1.comment = '''"Well, alright, if you think it's best."'''
elise_1p2p1p2_1_1.children = eliseRootChildren
def elise_1p2p1p2_1_1_quip_function():
    elise_1p2p1p2_1_1.quip = universal.format_text([['''"I have no idea if it's best or not," says Elise. "I don't even know if it's good, or bad, or anything. But I think it's safest, for what it's worth."'''],
    [p.PC.name, '''grimaces.'''],
    ['''"Maybe it's best if we changed the subject. Things have gotten really
dour in here. So, anything you'd like to know about Avaricum?" asks Elise.''']])

elise_1p2p3_1_1.comment = '''"Yes, I'm sure."'''
elise_1p2p3_1_1.children = eliseRootChildren
def elise_1p2p3_1_1_quip_function():
    elise_1p2p3_1_1.quip = '''"Well, alright," says Elise. "Just know that I'm here for you, if you need me. Anyway, if you have any questions about the city, or Cathedral, please ask."'''
elise_1p2p3_1_1.quip_function = elise_1p2p3_1_1_quip_function

elise_2_1_1.comment = '''"It's not worth it. Just a disagreement between friends."'''
elise_2p1_1_1 = Node(108) 
elise_2p2_1_1 = Node(109) 
elise_2p3_1_1 = Node(110)
elise_2_1_1.children = [elise_2p1_1_1, elise_2p2_1_1, elise_2p3_1_1]
def elise_2_1_1_quip_function():
    if "slapped_Maria" in p.PC.keywords:
        elise_2_1_1.quip = '''"She spanked you, then you slapped her, then she ran out crying," says Elise, putting her hands on her hips. "That's one heck of a disagreement between friends."'''
    else:
        elise_2_1_1.quip = '''"I don't know, seemed pretty intense to me," says Elise.'''
elise_2_1_1.quip_function = elise_2_1_1_quip_function

elise_2p1_1_1.comment = '''"Look, just mind your own business, alright?"'''
elise_2p1_1_1.children = eliseRootChildren
def elise_2p1_1_1_quip_function():
    elise_2p1_1_1.quip = universal.format_text([['''"Ok," says Elise. "I'm sorry, I didn't mean to pry. Just, if you ever want to talk to someone, know that you can talk to me, ok? I want to help, however I can."'''],
    ['''"Maybe it's better if we just changed the subject," says''', p.PC.name + "."],
    ['''"If you insist," says Elise. "Is there anything you'd like to know about the city? I've lived here all my life."''']])
elise_2p1_1_1.quip_function = elise_2p1_1_1_quip_function

elise_2p2_1_1.comment = '''Sarcasm: "You know, I want to thank you for giving us some privacy. Really, it touches me."'''
elise_2p2p1_1_1 = Node(111) 
elise_2p2p2_1_1 = Node(112)
elise_2p2_1_1.children = [elise_2p2p1_1_1, elise_2p2p2_1_1]
def elise_2p2_1_1_quip_function():
    elise_2p2_1_1.quip = '''Elise winces. "I didn't mean to pry.''' 
    if 'Maria_spanked_you' in p.PC.keywords: 
        elise_2p2_1_1.quip += ''' I left as soon as Maria turned you over her knee, but I could still hear it through the door. When it finally ended I saw Maria dash out with her head down."'''
    else:
        elise_2p2_1_1.quip += ''' I tried to just focus on my cleaning, but it was obvious your argument was getting pretty heated, and Maria looked a little devastated when she finally left."'''
        elise_2p2p1_1_1.comment = '''"Well, then maybe you should have just left us alone for a while."'''
elise_2p2_1_1.quip_function = elise_2p2_1_1_quip_function

elise_2p2p1_1_1.comment = '''"Well, then you shouldn't have stood outside the door."'''
elise_2p2p1_1_1.children = eliseRootChildren
def elise_2p2p1_1_1_quip_function():
    elise_2p2p1_1_1.quip = '''Elise frowns. "The Elder Brothers and Sisters don't like it when someone is left 
unattended in the Shrine, for fear they might try to steal something.''' 
    if 'Maria_spanked_you' in p.PC.keywords:
        elise_2p2p1_1_1.quip += ''' As it was, if I'd been caught just standing outside the door like that, you're not the only one who would have been thoroughly paddled today."'''
    elise_2p2p1_1_1.quip = universal.format_text([elise_2p2p1_1_1.quip, 
        ['''"I see," says''', p.PC.name + "."],
    '''Elise sighs. "I'm sorry. I tried the best I could under the circumstances. Maybe it'd be better if we changed the subject."''',
    [p.PC.name,  '''nods.'''],
    '''"So, anything you'd like to know about the Cathedral or city?" askes Elise."'''])
elise_2p2p1_1_1.quip_function = elise_2p2p1_1_1_quip_function

elise_2p2p2_1_1.comment = '''"I'm sorry. I didn't mean to snap at you like that. It's just... I've been looking forward to today for weeks, and it's all just gone to hell so hard."'''
elise_2p2p2_1_1.children = eliseRootChildren
def elise_2p2p2_1_1_quip_function():
    elise_2p2p2_1_1.quip = universal.format_text([['''Elise gives''', p.PC.name, '''a quick hug. "I can't even begin to imagine. The thought of moving by myself to another city entirely freaks me out enough. Then getting into a major argument''']]) 
    if 'Maria_spanked_you' in p.PC.keywords:
        elise_2p2p2_1_1.quip = universal.format_line([elise_2p2p2_1_1.quip, '''and being spanked for questionable reasons by an old friend would probably just finish me.'''])
    else:
        elise_2p2p2_1_1.quip += ''' with an old friend would probably just finish me.'''
    elise_2p2p2_1_1.quip = universal.format_text([universal.format_line([elise_2p2p2_1_1.quip, '''But come on, the day's still young. Things could still improve."''']),
    [p.PC.name, '''smiles a little, despite''', himselfherself(p.PC) + ".", '''"Lived here a while, I take it?"'''],
    '''"Have I ever!" says Elise, her eyes lighting up. She jerks her thumb towards the northern door. "Grew up in the orphanage with my best friend Carrie. We've been from one end of this city to the other, well, except for the slums. Always stayed away from there. Anyway, I know as much about the city as anyone alive. If you have any questions about anything, I'd be happy to answer them. Might cheer you up too, you know? Remind you that there are all sorts of wonderful things to explore."'''])
elise_2p2p2_1_1.quip_function = elise_2p2p2_1_1_quip_function

elise_2p3_1_1.comment = '''"Yeah, but I don't feel comfortable talking about it. Can we please just let it rest for now?"'''
elise_2p3_1_1.children = eliseRootChildren
def elise_2p3_1_1_quip_function():
    elise_2p3_1_1.quip = universal.format_text([['''"Of course," says Elise quickly, patting''', p.PC.name, '''on the shoulder. "I never meant to pry. Why don't we change the subject huh? I actually grew up in the orphanage attached to this Church. So if you have any questions about anything, especially the Cathedral, I'd be happy to answer them."''']])
elise_2p3_1_1.quip_function = elise_2p3_1_1_quip_function

elise_3_1_1.comment = '''"Really? To be honest, I wasn't even sure she'd remember me, until she found me outside."'''
elise_3p1_1_1 = Node(113) 
elise_3p2_1_1 = Node(114)
elise_3_1_1.children = [elise_3p1_1_1, elise_3p2_1_1]
elise_3_1_1.quip = '''Elise laughs. "To hear Maria talk, she isn't going to forget you if she lives to be a hundred and never sees you again."'''
elise_3p1_1_1.comment = '''"Well, I am pretty remarkable, so I guess that makes sense."'''
elise_3p1_1_1.children = eliseRootChildren
def elise_3p1_1_1_quip_function():
    elise_3p1_1_1.quip = universal.format_text(['''"Yes," says Elise, raising her eyebrows. "And modest too, I see."''',
        ['''"Well, I don't like to brag, but yeah, I am the''', kingqueen(p.PC), '''of modesty," says''', p.PC.name, '''puffing out''', hisher(p.PC), '''chest. "And today is your lucky day. For I have questions that need answering, peasant."'''],
        ['''Elise rolls her eyes. "I'll do my best to answer them my''', lordlady(p.PC) + '''."''']])
elise_3p1_1_1.quip_function = elise_3p1_1_1_quip_function

elise_3p2_1_1.comment = '''"Really?"'''
elise_3p2p1_1_1 = Node(115) 
elise_3p2p2_1_1 = Node(116)
elise_3p2_1_1.children = [elise_3p2p1_1_1, elise_3p2p2_1_1] 
elise_3p2_1_1.quip = '''"Of course," says Elise. "The years she spent with you were some of the best years of her life, and she loves you like a sister. Why would she forget you?"'''

elise_3p2p1_1_1.comment  = '''"Oh, no reason. Just you know, it's been a while is all."'''
elise_3p2p1p1_1_1 = Node(117) 
elise_3p2p1p2_1_1 = Node(118)
elise_3p2p1_1_1.children = [elise_3p2p1p1_1_1, elise_3p2p1p2_1_1]
elise_3p2p1_1_1.quip = '''"Personally, I can't ever imagine forgetting about my best friend Carrie. Though we've never been far from each other, so what do I know? Sister Samantha likes to joke that we have conjoined souls." Elise chuckles. "We got in so much trouble growing up. Still do, come to think of it."'''

elise_3p2p1p1_1_1.comment  = '''"That's how Maria, my sister Catalin, and I were. Maria was almost always coming up with the ideas. Catalin almost always dragged her heels. Me, I waffled between the two depending on how I felt at the time. Nana always complained that we were going to ruin her shoulder."'''
elise_3p2p1p1_1_1.children = eliseRootChildren
def elise_3p2p1p1_1_1_quip_function():
    elise_3p2p1p1_1_1.quip = universal.format_text(['''"Yes," says Elise. "Maria's told me a few of those stories. She was a hellion, though apparently you had your moments too."''',
        [p.PC.name, '''smiles sheepishly. "Catalin and I were much better behaved after Maria left."'''],
        '''"So, what happened to Catalin?" asks Elise. "Maria has no idea."''',
        [p.PC.name, '''shrugs. "Dunno. She came to Avaricum about eight years ago, much like I'm doing now, but I haven't heard anything. I was kind of hoping she'd be with Maria to meet me."'''],
    '''"Well, I'm sure you'll run into her eventually," says Elise.''',
    [p.PC.name, '''nods. "I hope so."'''],
    '''"So, is there anything else you need?" asks Elise. She glances down at her wash rag, her lips twisting. "Because if not, I should probably get back to cleaning. If I slack today like I did yesterday, Sister Samantha will not be pleased."'''])
elise_3p2p1p1_1_1.quip_function = elise_3p2p1p1_1_1_quip_function

elise_3p2p1p2_1_1.comment = '''"Sounds wonderful."'''
elise_3p2p1p2_1_1.children = eliseRootChildren
elise_3p2p1p2_1_1.quip = '''"That it is," says Elise. "I'd do anything for Carrie, and she'd do the same for me. But, that's neither here nor there. If there's anything else you need, you should probably ask now. I still have a lot of cleaning to do." Elise groans. "So much cleaning. I will never understand how a Shrine so small could possibly take so wretched long to clean. Definitely not what I signed up for."'''

elise_3p2p2_1_1.comment = '''"I guess, it's just that all my life people have been leaving. My mother, Maria, my sister. We went from having a full house to just being Nana and me. I know it's silly, but I just couldn't help but wonder if maybe it had something to do with me, you know?"'''
elise_3p2p2_1_1.children = eliseRootChildren
def elise_3p2p2_1_1_quip_function():
    elise_3p2p2_1_1.quip = universal.format_text(['''"That's absolutely ridiculous," says Elise. "Maria talked about you and Catalin all the time. Especially you. She didn't want to leave, but apparently her aunt threatened to paddle her every morning until she got her rear moving out your door and into the world to make a place for herself."''', ['''Elise smiles. "In fact, I still remember the day two weeks ago, when she came running into the Shrine, a crumpled note in her hand.\n''',
    '''"'Elise, elise!' she said,''', "'" + p.PC.name, '''my baby''', brothersister(p.PC), '''is coming to Avaricum!''', HeShe(p.PC), '''is all grown up and ready to be an adventurer. Oh this is so exciting, I've missed''', himher(p.PC), '''so much!''' + "'\n",
    '''"I've known her for a few years, and I don't think I've ever seen her so happy," says Elise. She rolls her eyes. "Also, it was like a week before I learned that you aren't her actual''', brothersister(p.PC), '''just someone she grew up with. Score one for good communication, huh?"'''],
    ['''"She called me her''', brothersister(p.PC) + '?" asks',p.PC.name + "."],
    '''"She did."''',
    [p.PC.name, '''smiles.'''],
    '''"Now is there anything else you need?" Elise looks down at her cleaning rag. "Because if not I
should probably get back to work."''',
    ['''"I don't mean to waste your time," says''', p.PC.name + "."],
    '''"Oh, you're not," says Elise quickly. "In fact, if Sister Samantha, or any other Brother or Sister for that manner, walked in right now, they'd have no problem with us talking. The cleaning is mostly to keep me busy while sitting in the Shrine waiting for people to come asking for help."''',
    ['''"Oh, ok, then," says''', p.PC.name + "."]])
elise_3p2p2_1_1.quip_function = elise_3p2p2_1_1_quip_function

elise_4_1_1.comment = '''"Misericordia de la Madre. What exactly did she tell you?"'''
elise_4p1_1_1 = Node(119) 
elise_4p2_1_1 = Node(120) 
elise_4_1_1.children = [elise_4p1_1_1, elise_4p2_1_1]
def elise_4_1_1_quip_function():
    elise_4_1_1.quip = '''Elise glances around. "Careful, there. Some of our stodgier Brothers and Sisters don't take kindly to people vainly invoking the Mother like that, especially not in the shrine. Just last week, Sister Samantha caught Maria ranting to me about something. Now, when Maria rants she tends to invoke the Mother (among other things) like Armageddon itself has arrived. Sister Samantha didn't take kindly to it, and things got unpleasant. For both of us."'''
elise_4_1_1.quip_function = elise_4_1_1_quip_function
elise_4p1_1_1.comment = '''"Define 'unpleasant.'"'''
elise_4p1p1_1_1 = Node(121) 
elise_4p1p2_1_1 = Node(122)
elise_4p1_1_1.children = [elise_4p1p1_1_1, elise_4p1p2_1_1]
elise_4p1_1_1.quip = '''"A ten minute bare bottom spanking. Three minutes with the hand, and seven with a hairbrush about this thick." Elise holds her fingers up, about an inch apart, maybe a little less.'''

elise_4p1p1_1_1.comment = '''"Ouch. I don't suppose Maria learned her lesson?"'''
elise_4p1p1_1_1.children = eliseRootChildren
def elise_4p1p1_1_1_quip_function():
    elise_4p1p1_1_1.quip = universal.format_text([['''Elise chuckles. "She lived with you for several years. What do you think?"'''], ['''"Not at all," says''', p.PC.name + "."],
        ['''"Not at all," says Elise, nodding. "She just got a bit more careful about periodically checking to make sure Sister Samantha hadn't snuck up on us." Elise's lips crack into a smile. "Just yesterday, she came in about ready to explode over an encounter with a couple of guards. She stalked over to the door, cracked it open, peeked out, and nearly headbutted Sister Samantha. Sister Samantha smiled, waved at her, and asked how her day was going. Maria went beet red, mumbled something vague and quickly backed up. Sister Samantha poked her head in, asked how I was doing, then went back to the orphanage. I'm pretty sure she left so quickly, because she didn't want us to see her laugh."'''],
        ['''"She had a few similar encounters with Nana," says''', p.PC.name + ".", '''"Except Nana never left afterwards. Least not right away."'''],
        ['''Elise's smile widens into a grin. "Guess Maria is Maria is Maria."'''],
        ['''"Guess so," says''', p.PC.name + ", returning the grin."],
        ['''There is a brief lull in the conversation.'''],
        ['''"So," says Elise after a moment. "What's up? Have any burning questions you need answered? Moral dilemmas to be resolved? Need something to do tonight?"''']])
elise_4p1p1_1_1.quip_function = elise_4p1p1_1_1_quip_function

elise_4p1p2_1_1.comment = '''"And Maria just let her? I can count on one hand the number of times she went willingly over Nana's knee."'''
elise_4p1p2p1_1_1 = Node(147)
elise_4p1p2p2_1_1 = Node(150)
def elise_4p1p2_1_1_quip_function():
    elise_4p1p2_1_1.quip = universal.format_text([['''Elise shrugs. "Maria holds the Brothers and Sisters in high regard. Especially the older ones."'''],
        ['''"Really? Why?"'''],
        ['''"Probably because she's a convert," says Elise. "They tend to be the most zealous."''']])
    p.PC.add_keyword("learned_Maria_converted")
    return (universal.acknowledge, [conversation.say_node, elise_4p1p2p1_1_1])
elise_4p1p2_1_1.quip_function = elise_4p1p2_1_1_quip_function
elise_4p1p2_1_1.children = [elise_4p1p2p1_1_1, elise_4p1p2p2_1_1]

elise_4p1p2p1p1_1_1 = Node(123)
elise_4p1p2p1p2_1_1 = Node(124)
elise_4p1p2p1_1_1.children = [elise_4p1p2p1p1_1_1, elise_4p1p2p1p2_1_1]
elise_4p1p2p1_1_1.comment = '''Angrily: "She's a what!"'''
def elise_4p1p2p1_1_1_quip_function():
    elise_4p1p2p1_1_1.quip = universal.format_text([['''\mElise frowns. "Didn't she tell you?"'''],
            ['''"This is the first I've heard of it," says''', p.PC.name, "curtly."],
            ['''Elise's frown deepens. "Huh. Figured it'd be the first thing she told you."'''],
            ['''"Apparently not. Why in La Madre's name did she become a Matirian?"'''],
            ['''Elise glares at''', p.PC.name + ".", '''"What is that supposed to mean?"'''],
            ['''"It means what is Maria doing joining the group that caused the Potion Riots?" cries''', p.PC.name + '''.'''],
            '''"That was an accident!" snaps Elise. "Do you really believe we'd have given you Potions if we'd known how addictive they were?"'''])
elise_4p1p2p1_1_1.quip_function = elise_4p1p2p1_1_1_quip_function

elise_4p1p2p1p1_1_1.comment = '''"Yes."'''
elise_4p1p2p1p1p1_1_1 = Node(125)
elise_4p1p2p1p1p2_1_1 = Node(126)
elise_4p1p2p1p1_1_1.children = [elise_4p1p2p1p1p1_1_1, elise_4p1p2p1p1p2_1_1]
def elise_4p1p2p1p1_1_1_quip_function():
    elise_4p1p2p1p1_1_1.quip = universal.format_text(['''Elise's eyes widen. "Do you really believe that?" Her voice is quiet, barely more than a whisper.''',
        ['''"Yes," says''', p.PC.name + ".", '''"Or are you seriously telling me that your precious Church didn't bother to test those wretched things before using them?"'''],
        '''"Of course we tested them!" says Elise. "It takes three to five Potions to become addicted. Our test subjects only ever used one. Maybe two. Sure, it wasn't the most thorough testing, but... but it's not like it's my fault!"'''])
elise_4p1p2p1p1_1_1.quip_function = elise_4p1p2p1p1_1_1_quip_function
    
elise_4p1p2p1p1p1_1_1.comment = '''"You're right, it's not your fault, I'm sorry. It's just, you can't deny the fact that the Matirian Church is responsible, at least in part, for the Riots."''' 

def elise_4p1p2p1p1p1_1_1_quip_function():
    elise_4p1p2p1p1p1_1_1.quip = universal.format_text([['''"I have never denied that," says Elise. She takes''', p.PC.name + "'s", '''hands in her own. "None of us have. Yes, we made a terrible mistake, but we're doing everything we can to rectify it."'''],
            ['''"How?" asks''', p.PC.name + "."],
            ['''"We've converted over half the hospital to a center dedicated to helping people break their Potion addictions," says''', 
            '''Elise. "We are also working to improve Potions so that this tragedy never happens again. We go into the Slums, and try to help those suffering from addiction, either directly or indirectly. But it's so hard. So many Taironans hate us."'''],
            ['''"I see," says''', p.PC.name + ".", '''"Well, again, I'm sorry."'''],
            '''Elise smiles lightly. "Don't worry about it. It's understandable."''',
            '''The two stand in silence for a minute.''',
            ['''"So," says''', p.PC.name, '''after a moment. "Care to answer a few questions for me?"'''],
            '''"Of course," says Elise. "It's why I'm here."'''])
elise_4p1p2p1p1p1_1_1.quip_function = elise_4p1p2p1p1p1_1_1_quip_function


elise_4p1p2p1p1p2_1_1.comment = universal.format_text([['''"'It wasn't the most thorough of testing?' Are you kidding me? Your precious Church obliterates and abandons an entire cursed city, and the best you can claim is rank incompetence?"''']])
elise_4p1p2p1p1p2p1_1_1 = Node(127)
elise_4p1p2p1p1p2p2_1_1 = Node(128)
#elise_4p1p2p1p1p2_1_1.children = [elise_4p1p2p1p1p2p1_1_1, elise_4p1p2p1p1p2p2_1_1]
def elise_4p1p2p1p1p2_1_1_qf():
    add_keyword('met_Samantha')
    elise_4p1p2p1p1p2_1_1.add_song(OMINOUS)
    elise_4p1p2p1p1p2_1_1.quip = universal.format_text([['''\m"Excuse me?" says an unfamiliar voice from''' , p.PC.name + "'s", '''right.'''],
        [p.PC.name, '''jerks around. Standing in one of the doorways leading out of the shrine is a middle-aged woman in the dark red robes of a Sister of the Spectral Persuasion.'''],
            ['''Her skin is similar in tone to Elise's. She is of average height, but carries herself with a level of''',
            '''confidence and conviction that makes her appear taller. Crows feet spread out from her blue eyes. Her light brown hair is pulled back into a single long braid that extends about halfway down her back.'''],
            '''"Sister Samantha," says Elise, her relief palpable.''',
            ['''"I said," says''', p.PC.name, '''with exaggerated slowness. "That you forced your wretched concoction on an entire city, despite having no clue what the side-effects were. And then, when you saw how badly you FUCKED up, you decided to cut and run, rather than try to clean up the mess that YOU made."'''], 
            ['''"You know nothing about what happened in Bonda," says Sister Samantha, sweeping into the room, and pinning''', p.PC.name, '''with a glare. Her voice is''',
            '''strained, on edge. "You are an ignorant child, suckled on bitter propaganda and second hand tragedy."'''],
            [p.PC.name, '''stands in shocked silence''', hisher(), '''hands spasmadocially clenching and unclenching. Blood pounds in''', hisher(p.PC), '''ears.'''],
            ['''Second hand.'''],
            ['''"You..."''', names(), '''voice is strangled.'''],
            ['''Second hand.'''],
            ['''An old, half-buried memory surges to the surface.''', HeShe(), '''was five.''', HeShe(), '''cowered behind Nana's skirts. There were three men sitting in Nana's living room. Two of them had weapons, the third casually played with a small ball of fire. His eyes locked with''', names() + "."], 
            ['''"Hey little''', boygirl() + ".", '''Like playing with fire?" The man flicked his wrist, and the small ball of flame flew towards''', name() + '''.'''],
            [name(), '''bursts out of the Shrine, and stumbles down the stairs. Passerbys shy away.'''],
            ['"' + name() + ",", '''wait." Elise hurries down the stairs after''', himher() + ".", '''"Sister Samantha didn't mean it. It's just, she was in Bonda, so-"'''],
            ['''"Get the hell away from me," snarls''', name(), '''spinning towards Elise,''', hisher(), '''hand tightening on''', hisher(), '''weapon.'''],
            ['''Elise comes up short, her eyes wide. "Hey now, calm down. Nobody wants to hurt you."'''],
            ['''"Is there a problem here?" A pair of city guards in steel breastplates and carrying heavy steel pikes step into the small circle of space that has formed''',
                '''around Elise and''', name() + "."],
            ['''"No," says Elise. "Nothing's going on. Least, nothing you need to concern yourself with."'''],
            ['''"Are you sure?" asks one of the guards, warily eyeing''', name() + ".", '''"Sir Roland will have our heads if-"'''],
            ['''"I said there's no problem," says Elise curtly. "Return to your normal duties."'''],
            ['''"This is our normal duty," says the first guard, still watching''', name() + "."],
            ['''Elise rolls her eyes. "Then take your duty someplace else. You're not helping anything."'''],
            ['''"Alright," says the second guard reluctantly. "We'll be nearby if you need us."'''],
            ['''"I'm confident that I will not," says Elise. "But thank you."'''],
            ['''The guards give''', name(), '''one more look, then return to their posts.'''],
            ['''"Please," says Elise, reaching out to''', name() + ".", '''"Sister Samantha spoke out of turn. Come back inside."'''],
            ['''"I want nothing to do with any of you," hisses''', name() + "."],
            ['''Elise lowers her hand. "Sorry."'''],
            [name(), '''turns, and loses''', himselfherself(), '''in the square.''']])
    p.PC.add_keyword('second_hand_tragedy')
    return (universal.acknowledge, [townmode.go, avaricumSquare])
elise_4p1p2p1p1p2_1_1.quip_function = elise_4p1p2p1p1p2_1_1_qf

    
elise_4p1p2p1p2_1_1.comment = '''"No, no of course not."'''
elise_4p1p2p1p2_1_1.quip = '''"Then what do you have against Maria joining the Matirian Church?" asks Elise.'''
elise_4p1p2p1p2p1_1_1 = Node(133) 
elise_4p1p2p1p2p2_1_1 = Node(134)
elise_4p1p2p1p2_1_1.children = [elise_4p1p2p1p2p1_1_1, elise_4p1p2p1p2p2_1_1]

elise_4p1p2p1p2p1_1_1.comment = '''"I don't have anything against her converting. I was just surprised, is all."'''
def elise_4p1p2p1p2p1_1_1_quip_function():
    elise_4p1p2p1p2p1_1_1.quip = universal.format_text([['''"Oh," says Elise. "Well, ok."'''],
        ['''"I wonder, why didn't she tell me?" asks''', p.PC.name + ".", '''"I mean, doesn't that seem like something you'd tell an old friend you haven't seen in years?"'''],
        '''Elise shrugs. "Maybe she was worried you'd react negatively. There are a lot of Taironans out there who are very hostile towards Matirians, and she hasn't seen you since you were very young. Who knows what kind of person you'd grown up to be."''',
        ['''"I suppose," mutters''', p.PC.name + ".", '''"I still don't like it, though."'''],
        '''"Well, you'll have to take it up with her," says Elise. "And try to be nice, when you do. Dirt to gold says she's been stressing about this from the moment she got her aunt's letter."''',
        [p.PC.name, '''nods.'''],
        '''"Great," says Elise, smiling brightly. "So, is there anything else you need?"'''])
elise_4p1p2p1p2p1_1_1.quip_function = elise_4p1p2p1p2p1_1_1_quip_function
elise_4p1p2p1p2p1_1_1.children = eliseRootChildren

elise_4p1p2p1p2p2_1_1.comment = '''"I don't know. I just, Abandoning our faith, it's like she's abandoning us."'''
def elise_4p1p2p1p2p2_1_1_quip_function():
    elise_4p1p2p1p2p2_1_1.quip = universal.format_text([['''"That's ridiculous," says Elise. She takes''', p.PC.name + "'s", '''hands in her own. "There's so much more to any''',
        '''group of people than just their faith. There's still your shared experiences, your shared culture-"'''],
        ['''"But our faith is a fundamental part of our culture," says''', p.PC.name + ".", '''"How can you possibly have one without the other?"'''],
        '''"Well, I don't-"''',
        ['''"The Mother is the Earth," says''', p.PC.name + ",", '''stamping''', hisher(p.PC), '''foot.''', '''"Here, underneath us. Around us, inside us. Not some distant,''',
        '''distinct creature like you claim. The Father is the sun above us, bathing us in light and warmth. Every second of every minute of every day, the two work together to give us life. Our celebrations, our rituals, our jokes, our insults, they all revolve around that fundamental belief. To walk away from''',
        '''all of that..."'''],
        ['''"You have to understand," says Elise. "Maria was in a very bad spot. She was alone, and depressed. We gave her comfort, and friendship. We gave her a place''',
        '''to belong. It's not that she wants to leave you. It's just that, she found something with us that she was missing with her own people. Besides, we're all''',
        '''people here. We're all part of one big family, regardless of how we see the Mother and Father."'''],
        ['''"What happened to Maria?" asks''', p.PC.name + ".", '''"You said she was in trouble. What happened?"'''],
        '''Elise shrugs. "I don't know the details. Maria didn't share them with me. You'll have to talk to her."''',
        ['''"I see," says''', p.PC.name + "."],
        '''Elise forces a smile. "Anyway, I'm sure there are plenty of other questions I can help you with. Anything in particular you'd like to know?"'''])
    p.PC.add_keyword('learn_about_Marias_trouble')
elise_4p1p2p1p2p2_1_1.quip_function = elise_4p1p2p1p2p2_1_1_quip_function
elise_4p1p2p1p2p2_1_1.children = eliseRootChildren

elise_4p1p2p2_1_1.comment = '''"Wait, wait slow down. Did you just call her a convert?"'''
elise_4p1p2p2p1_1_1 = Node(148) 
elise_4p1p2p2p3_1_1 = Node(149)
elise_4p1p2p2_1_1.children = [elise_4p1p2p2p1_1_1, elise_4p1p2p1p1p2_1_1, elise_4p1p2p2p3_1_1]
def elise_4p1p2p2_1_1_quip_function():
    elise_4p1p2p2_1_1.quip = universal.format_text([['''"Yeah," says Elise. "She joined the Matirian Church several years ago. Didn't she tell you?"'''],
    [p.PC.name, '''shakes''', hisher(p.PC), '''head. "She didn't say a word."'''],
    '''"Oh." Elise sounds hurt. "Maybe she was worried you wouldn't react well."''',
    [p.PC.name, '''sighs, and rubs''', hisher(p.PC), '''forehead. "She has good reason. Most Taironans wouldn't react well to learning that she'd joined the''',
        '''Matirian Church."'''],
    '''"Because of the Potion Riots?" asks Elise quietly.''',
    [p.PC.name, '''nods. "My Nana was one of them. She always hated and blamed the Matirian Church for their role in what happened. Always said that the Wasting Wail''',
    '''is bad, but at least we know how to mitigate its damage. The Potions completely blindsided us, and made a terrible situation much much worse."'''],
    '''"And what do you think?" asks Elise hesitantly.''',
    [p.PC.name, '''shrugs. "Maria never agreed with Nana. She always said that if everyone thought the same as Nana, then nothing'd ever get better. She claimed''', 
    '''that the Matirian Church had the right idea, even if things backfired."'''],
    '''"Way to dodge the question," says Elise, putting her hands on her hips.'''])
    elise_4p1p2p1p1p2_1_1.comment = universal.format_line(['''"Quite frankly, it's not the fact that you got us addicted to Potions that pisses me off. It's that after you''', 
    '''saw what happened, you abandoned us! Waltzed right in, said 'Oh look, let's help these poor people. Oh dear, look at the mess we made. Welp, I'm sure they''', 
    '''can clean it up, now let's get out of here. After all, who gives a fuck about them? They're just Taironans!'"''']) 
elise_4p1p2p2_1_1.quip_function = elise_4p1p2p2_1_1_quip_function


elise_4p1p2p2p1_1_1.comment = '''"Honestly, I agree with Maria. Your hearts were in the right place. Just, you made a mistake, and it had terrible consequences. Doesn't mean I'm going to convert, though."'''
def elise_4p1p2p2p1_1_1_quip_function():
    elise_4p1p2p2p1_1_1.quip = universal.format_text([['''"I'm glad to hear that," says Elise. She paces over to one of the pews. She gives it an anxious swipe with her cloth, then starts kneading the cleaning rag. "Hatred like that scares me, you know? And it hurts. We're just trying to help people, you know? We had no idea what would happen. Several Brothers and Sisters who are stationed here were in Bonda during the Wail, you know? Most days, they're fine, but sometimes, sometimes you'll catch one of them staring into space, or they'll blow up at a student whose attitude is a bit too cavalier. The whole thing is a mess, but we're trying to help. Most of the hospital is taken up by Taironans who are addicted, and who we're trying to help break the addiction. But it's so hard, and it hurts them so much."'''],
        [p.PC.name, '''walks over to Elise, and gives her a pat on the shoulder. "Well, we'll get through it. Maria always told me, hatred and vengeance never''',
            '''solved anything. At best, they just push the problem onto the next generation. At worst, they generate a whole slew of new problems that have to be dealt with."'''],
        '''"Hard to believe a woman with a temper like Maria's would say something like that," says Elise, smiling. "You'll have to save that little tidbit for the next time she gets mad at you."''',
        ['''"Me?" says''', p.PC.name + ".", '''"What about you?"'''],
        '''"Maria, mad at me?" says Elise in mock horror. "Never. I'm a Sister. She'd never get mad at a Sister."''',
        ['''"Right," says''', p.PC.name, '''skeptically.'''],
        ['''"Oh hush," says Elise, slapping''', p.PC.name + "'s", '''shoulder. "Anyway, you really should talk to Maria about her conversion. I'm sure she's stressing out like crazy at the thought of you finding out and breaking off your friendship. Probably why she didn't mention it. Just, don't tell her I told you, or she'll get mad at me."'''],
        [p.PC.name, '''nods. "Yeah."'''],
        '''"So," says Elise. "Anything you need from me?"'''])
elise_4p1p2p2p1_1_1.quip_function = elise_4p1p2p2p1_1_1_quip_function
elise_4p1p2p2p1_1_1.children = eliseRootChildren

elise_4p1p2p2p3_1_1.comment = '''"The truth is, I don't know. I don't know what to think. Maybe your potions saved lives from the Wail, but how many of them then died of withdrawal? How many of those would have survived the Wail unaided? But at the same time, I find it impossible to believe that you intended anything other than to help us."'''
def elise_4p1p2p2p3_1_1_quip_function():
    elise_4p1p2p2p3_1_1.quip = universal.format_text([['''Elise pats''', p.PC.name, '''on the arm. "You're not the only one who struggles with that. There are plenty of Brothers''',
        '''and Sisters who don't know how to deal with it either. Men and women who went to Bonda believing that they were going to save a city, only to watch it''',
        '''crumble around them."'''],
        ['''"Look, can we just change the subject?" asks''', p.PC.name + ".", '''"I don't want to talk about this."'''],
        ['''"Of course," says Elise. "Though you really should talk to Maria about her conversion. I'm sure she's been stressing out about you finding out from the''',
            '''minute she got her aunt's letter. Better to get that conversation over with, for better or for worse."''']])
elise_4p1p2p2p3_1_1.quip_function = elise_4p1p2p2p3_1_1_quip_function
elise_4p1p2p2p3_1_1.children = eliseRootChildren


elise_4p2_1_1.comment = '''"Both of you? She didn't spank you too, did she?"'''
elise_4p2_1_1.quip = '''Elise grimaces. One of her hands sneaks back and gives her bottom a rub. "She did. After planting Maria in the corner, she hauled me over her lap and gave me the same thing for not doing my 'Sisterly duty of preserving the sanctity of the Mother's name'."'''
elise_4p2p1_1_1 = Node(135) 
elise_4p2p2_1_1 = Node(136)
elise_4p2_1_1.children = [elise_4p2p1_1_1, elise_4p2p2_1_1]

elise_4p2p1_1_1.comment = '''"Nevermind the fact Maria's distress was far more important than the words she used. Sister Samantha sounds like a right old bat."'''
def elise_4p2p1_1_1_quip_function():
    elise_4p2p1_1_1.quip = universal.format_text([['''"Oh, no no no," says Elise quickly. "Sister Samantha is anything but. She just believes that after a certain point,''',
    '''your rage starts to feed off itself, and you end up just getting angrier and angrier and angrier. After she paddled me and Maria, she had Maria tell her what''', 
    '''happened, but in a calm voice and decent language. I have to admit, it had a positive effect. Normally, when Maria rants to me, she doesn't seem to feel''',
    '''much better when she leaves. But Maria looked much more relaxed when she finally left, even if she was walking a bit gingerly."'''],
    ['''"I see," says''', p.PC.name + "."],
    '''"Seriously, Sister Samantha wants nothing more than for us to live successful, happy lives," says Elise. "Even if she has to bust out her paddle to make it happen."''',
    [p.PC.name, '''nods.'''],
    '''"Anyway," says Elise. "Anything else you need?"'''])
elise_4p2p1_1_1.quip_function = elise_4p2p1_1_1_quip_function
elise_4p2p1_1_1.children = eliseRootChildren


elise_4p2p2_1_1.comment = '''"Well, I suppose that is technically a part of your job..."'''
def elise_4p2p2_1_1_quip_function():
    elise_4p2p2_1_1.quip = universal.format_text([['''"That's what Carrie said too," mutters Elise, giving her bottom another rub. "Still seems kind of unfair. I mean, I've only been a Sister''',
'''for a few weeks, and Maria is my senior by like a decade. What am I supposed to do? Say 'Hey Maria, can you like stop swearing quite so much?'"'''],
['''"Um, yes?" says''', p.PC.name + ".", '''"On the bright side, now you'll have a good reason to give her, if you have trouble asserting authority over her. 'Hey, Maria, could you like stop swearing quite so much? I don't want to get paddled again.'"'''],
'''"Carrie said that too," says Elise. She pouts. "Why doesn't anyone take my side?"''',
['''"You're not the one with the paddle," says''', p.PC.name + "."],
'''"Touche," Elise smiles. "Anyway, let's change the subject to something a bit less erm, painful. Anything you want to know about the city?"'''])
elise_4p2p2_1_1.quip_function = elise_4p2p2_1_1_quip_function
elise_4p2p2_1_1.children = eliseRootChildren

elise_cathedral_history.comment = "Why exactly is this shrine so small? The actual building is huge!"
def elise_cathedral_history_quip_function():
    elise_cathedral_history.quip = universal.format_text(['''"That's because it's mostly a hospital and orphanage," says Elise.''',
        [p.PC.name, '''scratches''', hisher(p.PC), '''head. "But, who paid for it?"'''],
        ['''"Well, King Wesleyan III ordered its construction." Elise gestures to a small inscription on the entryway. It reads "In memory and thanks to King''',
        '''Wesleyan III for his unflagging support of the construction of the Mother's Hospital and Orphanage.'''],
        ['''"He really paid for a building this large, and this nice, for an orphanage and hospital?" asks''', p.PC.name + "."],
        ['''"I know, right?" says Elise sardonically. "Mother forbid a King pay for anything that actually, you know, helps people. Well, legend has it that King Wesleyan wanted the entire Cathedral to be a huge worship space.  It was supposed to be big enough to house half the city's population. However, when the Mother heard of this ridiculous ostentation, she came and spanked both him and the Eldest Sister, and insisted that the actual shrine be only as large as the smallest shrine in the City. The rest of the Cathedral should then be converted to a hospital on one side and an orphanage on the other. That way, the Sisters could more easily do the true work of the Church: helping those who need it."'''],
        ['''"But wait a minute. If your Mother is willing to intervene on such a minor thing, why doesn't She intervene over major things, like wars or famine?"''']])
    eliseRootChildren.remove(elise_cathedral_history)
    return (universal.acknowledge, [conversation.say_node, elise_interference_belief])
elise_cathedral_history.quip_function = elise_cathedral_history_quip_function
elise_interference_belief = Node(137)  
elise_eldest_sister_fantasy = Node(138)

elise_interference_belief.comment = '''"But wait a minute. If your Mother is willing to intervene on such a minor thing, why doesn't She intervene over major things, like wars or famine, or to warn us about the Potions?"'''
def elise_interference_belief_quip_function():
    elise_interference_belief.quip = '''"I know, right?" says Elise. "Personally, I figure that's just a tale, maybe spun by a later King who didn't like King Wesleyan. Anyway, I personally think that the reason She doesn't interfere is that She can't. None of the gods can. See, there was this religious scholar from the 5th Century, Sister Beatrice, who argued that what we call magic is actually some sort of shield. It's been woven around the Earth in order to keep the gods out. So, maybe the Mother can provide guidance through dreams and other indirect means, but She can't actually come to earth and paddle a naughty king."'''
    p.PC.add_keyword('elise_interference_beliefs')
elise_interference_belief.quip_function = elise_interference_belief_quip_function
elise_support_question = Node(139)
elise_limitless_gods = Node(140)
elise_limitless_gods_rude = Node(141)
elise_uncomfortable = Node(142)
elise_interference_belief.children = [elise_support_question, elise_uncomfortable]

elise_support_question.comment = '''"Interesting. What does Sister Beatrice use to support this?"'''
elise_support_question.quip = universal.format_text(['''Elise's eyes light up, and her lips break out into a broad smile. "Well, one of her most compelling arguments are the old stories. See, if you go back and look at any of the stories that involve the Mother or any other god interfering directly, they don't make any mention of magic. None whatsoever. Now, historians have been able to find a lower bound on how old these stories are. They think the youngest showed up, at the latest, about two thousand years ago. Meanwhile, the first serious text on magical study that we've found is thought to be about fifteen hundred years old.''',
    '''"Then there's the Pandemonium Cycle. More than a third of our most famous stories about the gods take place during this saga. It details a struggle between the gods for supremacy with humans caught in the middle. But the worst part is there's no ending. No final battle, no horrifying realization by the gods about what they'd done. The stories just stop.''',
    '''"So, Sister Beatrice argues that magic was developed as a shield by the Mother, Father, and other goodly gods, since humanity couldn't develop while caught in the maelstorm of divine conflict. Of course, others argue that magic developed spontaneously as a result of all the miracles being performed, and still others think that magic is in fact the body of the Mother, who sacrificed herself to drive the other gods off the earth. But you get the basic idea."'''])
elise_distant_gods = Node(143) 
elise_Taironan_take = Node(157)
elise_support_question.children = [elise_distant_gods, elise_Taironan_take]

elise_distant_gods.comment = '''"So you believe that the Mother and Father are distant? That's depressing."'''
def elise_distant_gods_quip_function():
    elise_distant_gods.quip = universal.format_text(['''"I suppose," says Elise, shrugging. "But isn't that how life is? No matter how close you may to your parents, there is always some distance between you, and that distance only grows as you get older. Plus once you've grown older, it's not like your parents can do much more than give advice. Well, the Mother and Father understand that pain. Besides, it doesn't mean that they don't love us, or they don't try to help us. It's just, to try to do more than give advice would lead to a second Pandemonium War, the deaths of countless thousands of people, and the end of our civilization."''',
        ['''"I see," says''', p.PC.name + '''. "Still kinda depressing"'''],
        '''"I suppose." Elise shrugs a second time. "Anyway, got any other questions?"'''])
elise_distant_gods.quip_function = elise_distant_gods_quip_function
elise_distant_gods.children = eliseRootChildren

elise_Taironan_take.comment = '''"An interesting idea. We Taironans believe that the Earth itself is the Mother, or Madre, and the Sun the Father, or Padre. Magic is the combined essence of the Mother and Father. To touch magic, to weave it, is to be in direct contact with the Parents, los Padres, Themselves."'''
def elise_Taironan_take_quip_function():
    elise_Taironan_take.quip = universal.format_text([['''"But then, what about evil? What about people who abuse magic?" asks Elise. "Why do the Parents allow that?"'''],
        [p.PC.name, '''shrugs. "The Mother and Father are eternal. What does good and evil mean in the face of eternity? Nothing. Good and evil are for mortals. Besides, just because the Mother and Father created us, doesn't mean that They can control us, anymore than parents can control their children."'''],
        ['''Elise's eyes widen. "You mean, you believe that good and evil are separate from the gods?"'''],
        [p.PC.name, '''nods. "We do. That doesn't mean it doesn't exist, only that it does not spring from the Mother and Father. Just as nature is amoral, so too are the Parents."'''],
        '''"Fascinating," murmurs Elise. "I'd never even considered..." She taps her lip thoughtfully. "I'll have to see if the library has any books about Taironan religions. I think they'd make for some interesting reading. Anyway, anything else you need?"'''])
elise_Taironan_take.quip_function = elise_Taironan_take_quip_function
elise_Taironan_take.children = eliseRootChildren

elise_limitless_gods.comment = '''"But can you put limits on your gods like that? According to Nana, Matirians believe that the gods possess unlimited power."''' 
def elise_limitless_gods_quip_function():
    elise_limitless_gods.quip = universal.format_text([['''Elise shrugs. "Maybe we can't. But what about other gods? I mean, I never said that magic was created by mortals. It could be something developed by the Mother or some group of goodly gods in general, in order to protect us."''',
        '''"Fascinating," says''', p.PC.name + ".", '''"I've never heard of a Matirian putting limits on their gods like that."''',
        '''Elise grimaces. "That's probably because Taironans tend to interact with Matirians who live in the southern regions of Carnute, along the border with the Taironan League. They tend to be rather insistent that the Mother and Father are significantly more powerful than the other gods, and are in complete control of everything. Which basically forces the answer to your question to be some variant of 'It's all part of Their larger plan.' Which is just dumb if you ask me. Short-term sacrifices for long-term gain only make sense when you aren't omnipotent."'''],
        ['''"I see," says''', p.PC.name + "."],
        '''"Anyway," says Elise. "Sorry for that. Didn't mean to drag you into a religious debate about a religion you aren't even a part of. What else is up?"'''])
elise_limitless_gods.children = eliseRootChildren

elise_uncomfortable.comment = '''"I see. Anyway, could we talk about something else? Religious discussions make me uncomfortable."'''
elise_uncomfortable.quip = '''"Oh, I'm sorry," says Elise. "I didn't mean to make you uncomfortable. So how else can I help you?"'''
elise_uncomfortable.children = eliseRootChildren

#-----------------------------------Wesley and Anne's Armor Shop---------------------------------

peter_greeting = Node(158)
def peter_greeting_quip_function():
    if "insulted_Peters_kid" in p.PC.keywords:
        peter_greeting.quip = universal.format_line(['''"I don't recall inviting you back into my''',
                '''shop," says Peter. Realizing that''', heshe(p.PC), '''won't be getting''',
                '''any more service today,''', p.PC.name, '''turns and leaves.'''])
        peter_greeting.children = None
        return (go, [craftmansCorridor])
    elif "visited_blacksmith" not in p.PC.keywords:
        peter_greeting.quip = universal.format_line(['''"Sorry for keeping you waiting. How can I help you today?"'''])
    else:
        peter_greeting.quip = universal.format_line(['''"Ah, good to see you again,' says Peter,''',
            '''smiling. "What can I do for you?'"'''])
        if 'asked_Peter_about_work' in p.PC.keywords:
            peterRootChildren.remove(peter_1_1_1)
        if 'asked_Peter_about_bikini' in p.PC.keywords:
            peterRootChildren.remove(peter_2_1_1)
        peter_greeting.children = peterRootChildren 
peter_greeting.quip_function = peter_greeting_quip_function

peter = p.Person('Peter', p.MALE, peter_greeting, peter_greeting)
peter.inventory = [itemspotionwars.qualityDagger, itemspotionwars.warspear, itemspotionwars.longsword, itemspotionwars.leatherCuirass, itemspotionwars.chainCuirass,
    itemspotionwars.chainmailBikini]
offStage.add_character(peter)
peter_initial_greeting = Node(159)
peter.litany = peter_initial_greeting
peter_1_1_1 = Node(160) 
peter_2_1_1 = Node(161) 
peter_3_1_1 = Node(162) 
peter_4_1_1 = Node(164)
peterRootChildren = [peter_1_1_1, peter_2_1_1, peter_3_1_1, peter_4_1_1]
peter_greeting.children = peterRootChildren

peter_1_1_1.comment = universal.format_line(['''"You wouldn't happen to be taking on apprentices, or''',
'''a shop clerk or something, would you?"'''])
def peter_1_1_1_qf():
    peter_1_1_1.quip = universal.format_line(['''Peter grimaces. "Unfortunately, I have neither enough''',
        '''work nor enough money to take on any kind of help at all. I can provide for my''',
        '''family, but that's about it."'''])
    p.PC.add_keyword('asked_Peter_about_work')
    peterRootChildren.remove(peter_1_1_1)
peter_1_1_1.quip_function = peter_1_1_1_qf
peter_1_1_1.children = peterRootChildren

peter_2_1_1.comment = universal.format_line(['''"What's with that ridiculous piece of armor on the''',
    '''wall? I've seen lingerie that covers more."'''])
def peter_2_1_1qf():
    p.PC.add_keyword('asked_Peter_about_bikini')
    peter_2_1_1.quip = universal.format_text([['''Peter chuckles. "My grandfather had a bit of''',
    '''a gift for spectral magic."''',
    p.PC.name + "'s", '''eyes widen. Spectral magic is powerful, but also exceptionally''',
    '''complex, and sometimes downright odd. A 'gift' for spectral magic is''',
    '''exceptionally rare (it's also a favorite claim of charlatans).''', 
'''"Usually grandpa was perfectly sane, but sometimes he'd be gripped by what he called''',
'''a fever. Then he'd become obsessed with some particular project, and he'd work on''',
'''it to the exclusion of all else. Produced some true masterpieces under the grip of''',
'''that fever. That armor was the last of his fever pieces before he died. It's infused''',
'''with magic, providing protection as strong as good solid plate mail, only without''',
'''the susceptibility to hammers."'''], 
['''"Ok, but why is it so ... baring?" asks''', p.PC.name + "."],
['''Peter rolls his eyes. "Grandpa claimed that the way the spell he used worked,''',
'''the less the armor covers, the better the protection. When I asked him about that''',
'''particular design..." Peter shudders.''',
'''"He said it was based on an outfit grandma liked to wear when they were getting''',
'''intimate.''' if p.PC.is_female() else '''"He said it was based on an outfit he used to wear when he and grandma were getting intimate.''',
'''I stopped asking after''',
'''that." He shudders again.'''], 
['''"What about cold weather''', '''or the male gaze?"''' if p.PC.is_female() else '',  
'''asks''', p.PC.name + ".", '''"Does it protect you against that too?"'''],
['''"Well, I imagine you could wear it under other clothing," says Peter, scratching''',
'''his chin. "You interested in purchasing it? 5000 coins."'''],
'''"Eh, little bit outside my price range."''',
'''"Thought so," says Peter. "Ah well. What else can I do for you?"'''])
    peterRootChildren.remove(peter_2_1_1)
peter_2_1_1.quip_function = peter_2_1_1qf
peter_2_1_1.children = peterRootChildren

peter_3_1_1.comment = '''"Could I see your wares?"'''
def peter_3_1_1_qf():
    if p.PC.is_male() and chainmailBikini in peter.inventory:
        peter.inventory[peter.inventory.index(chainmailBikini)] = chainmailThong
    return(shop_mode, [peter, peter_return_from_shopping])
peter_3_1_1.quip_function = peter_3_1_1_qf
#peter_3_1_1.children = peterRootChildren

peter_return_from_shopping = Node(165)
peter_return_from_shopping.quip = '''"Anything else you need?" asks Peter.'''
def peter_return_from_shopping_qf():
    if 'asked_Peter_about_bikini' in keywords():
        try:
            peterRootChildren.remove(peter_2_1_1)
        except ValueError:
            pass
    if 'asked_Peter_about_work' in keywords():
        try:
            peterRootChildren.remove(peter_1_1_1)
        except ValueError:
            pass
peter_return_from_shopping.quip_function = peter_return_from_shopping_qf
peter_return_from_shopping.children = peterRootChildren

peter_4_1_1.comment = '''"Thank you for your time. I'll see you around."'''
def peter_4_1_1qf():
    if "visited_blacksmith" not in p.PC.keywords:
        p.PC.add_keyword("visited_blacksmith")
        wesleyAndAnnesArmorShop.description = universal.format_text([['''The shop consists of a single small room. A counter runs the length of the far wall. Hanging on the left wall is a small collection of weapons, while on the right side are a few pieces of armor. What really catches''', p.PC.name + "'s", '''attention is a 'suit' of chanmail hanging on the wall above the counter.''', universal.format_line(['''The armor is a two piece affair. The top looks like to be barely big enough to cover (for a sufficiently loose definition of 'cover')''', p.PC.name + "'s", '''breasts, while the bottom is a thong. A thong made out of chainmail.''' if p.PC.is_female() else '''The armor is a single, small thong, which is made out of chainmail.'''])]])
        peter_4_1_1.quip = universal.format_text([['''"Have a nice day," says Peter, giving a''',
            '''cheerful wave.'''],
            ['''Before''', name(), '''can respond, a young girl, no more than''',
            '''five,''', 
            '''enters the shop and skitters past''', p.PC.name + ".", '''She wraps her arms around''', 
            '''Peter's''', '''leg and watches''', p.PC.name, '''warily.''', 
            '''Her skin is a slightly lighter variant of the''',
            '''caramel skin color associated with Taironans.'''],
            ['''"Hey honey," says Peter, crouching down next to her and wrapping one''',
                '''large arm around her small shoulders. "What's up?"'''],
            ['''The girl's face crumples. "Lilly made fun of me''',
            '''again. She put mud on her face and called me names."'''],
            '''"What did she say?" asks Peter gently.''',
            ['''The girl glances at''', p.PC.name, '''then leans in close and whispers''',
            '''something in Peter's ear.'''],
            ['''Peter's previously pleasant disposition darkens. "I've got to have a''',
            '''talk with her parents. A little bit of childish bickering is one thing,''',
            '''but this is too''', '''much."''']])
        peter_4_1_1.children = [peter_5_1_1, peter_6_1_1, peter_7_1_1, peter_8_1_1]
    else:
        peter_4_1_1.quip = '''"Have a nice day", says Peter."'''
        peter_4_1_1.children = None
peter_4_1_1.quip_function = peter_4_1_1qf
peter_5_1_1 = Node(166)
peter_6_1_1 = Node(167)
peter_7_1_1 = Node(168)
peter_8_1_1 = Node(169)
    
peter_5_1_1.comment = '''"You have Taironan children?"'''
peter_5p1_1_1 = Node(170) 
peter_5p2_1_1 = Node(171) 
peter_5p3_1_1 = Node(172)
peter_5_1_1.children = [peter_5p1_1_1, peter_5p2_1_1]#, peter_5p3_1_1]
peter_5_1_1.quip = universal.format_line(['''"My wife was a Taironan," says Peter. He''',
    '''scowls. "Stones to gold says that's the primary reason much of my business''',
    '''has dried up these past few years."'''])

peter_5p1_1_1.comment = '''"What happened to her?"'''
def peter_5p1_1_1qf():
    peter_5p1_1_1.quip = universal.format_text([['''"That's not something I'd like to''', 
        '''discuss," says Peter firmly. "Do we have any more business?"'''],
        [p.PC.name, '''shakes''', hisher(p.PC), '''head.'''],
        ['''Peter smiles. "Then have a nice day. I hope you remember me whenever''', 
            '''you need a weapon or armor replaced or repaired. Now, if you'll''', 
            '''excuse me, I need to see to my daughter."''']])
peter_5p1_1_1.quip_function = peter_5p1_1_1qf

peter_5p2_1_1.comment = universal.format_line(['''"You mean they'd stop coming to your shop''',
    '''just because she was a Taironan? That's ridiculous!"'''])
def peter_5p2_1_1qf():
    peter_5p2_1_1.quip = universal.format_text([['''Peter shrugs uneasily. "Yeah, well that's''',
        '''life. My kids are still fed and housed, and that's all that really''',
        '''matters. Now, is there anything else you need?"'''],
            [p.PC.name, '''shakes''', hisher(p.PC), '''head. "I'll definitely come to''',
            '''you, if I need any arms or armor though."'''],
            ['''"Great to hear it," says Peter. 'Now, if you'll excuse me, I'd like to''',
            '''attend to my daughter."''']])
peter_5p2_1_1.quip_function = peter_5p2_1_1qf

"""
peter_5p3_1_1.comment = '''"Was your wife involved with the Vengadores?"'''
def peter_5p3_1_1qf():
    peter_5p3_1_1.quip = universal.format_text([['''"Of course not!" snaps Peter.''',
    '''His daughter jumps and backs up a step, but he''',
    '''doesn't seem to notice. "Ever so much as think that again, and I'll throw you''',
    '''out of my shop so hard, by the time you land you'll be in Bonda, understand?"'''],
    ['''"Hey, wow calm down," says''', p.PC.name + ",", '''holding up''', hisher(p.PC),
        '''hands. "It was just a question."'''],  
    ['''Peter scowls. "One of the''',
    '''Vengadores used to frequent my shop, before her allegiance became known.''',
    '''Not long after that,''',
    '''my wife disappeared, so naturally I spent a day in the dungeons being questioned''',
    '''up one side and down the other."'''],
        ['''"Rough," says''', p.PC.name + "."],
        ['''"Yeah, well, do you need anything else?" asks Peter.'''],
        ['''"Er, no I don't think so," says''', p.PC.name + "."],
        '''"Mind leaving then?" says Peter. "I've got work to do."'''])
    p.PC.add_keyword('Peter_mentioned_wife')
peter_5p3_1_1.quip_function = peter_5p3_1_1qf
"""

peter_6_1_1.comment = universal.format_line(['''"Seems to me that if their child is acting like''',
    '''that, the parents won't be much better."'''])
def peter_6_1_1qf():
    peter_6_1_1.quip = universal.format_text([['''"Not necessarily," says Peter. "I've known''',
        '''some perfectly nice people whose children were complete terrors." His''',
        '''grimace deepens. "Though in this case you're right. I've spoken to both''',
        '''of them before. The father in particular is convinced Taironans are''',
        '''a bunch of Potion-crazed, violent thugs, secretly plotting to take over''',
        '''Avaricum and turn us all into addicts. Scary part''',
        '''is, he's a member of the city guard."'''],
        ['''"How many share his attitudes?" asks''', p.PC.name, "uneasily."],
        ['''Peter shrugs. "Don't know. Don't interact with the city guard much these''',
            '''days. Used to get pretty steady business from them, but that all dried''',
            '''up when the latest bout of gang wars started." Peter''',
            '''shakes his head. "Anyway, is there anything else you need?"'''],
        [p.PC.name, '''shakes''', hisher(p.PC), '''head.'''],
        ['''"Then I need to see to my daughter." Peter lifts the girl and sits her on''',
        '''his shoulder. He forces a smile. "I'll see you around."''']])
peter_6_1_1.quip_function = peter_6_1_1qf

peter_7_1_1.comment = '''"Personally, I think you should do more than just 'talk.'"'''
def peter_7_1_1qf():
    peter_7_1_1.quip = universal.format_text([['''Peter grunts. "Believe me, there's nothing''',
        '''I'd like to do more. But thrashing a member of the city guard''',
        '''would not end well. Plus, I wouldn't be much of a role model for the''',
        '''munchkin here if I tried to solve all my problems with violence."'''],
    [p.PC.name, '''scowls. "You know that they're just going to ignore you, right?"'''],
    '''Peter nods. "Yeah, but there's not much else I can do."''',
    ['''"The nice''', manlady(p.PC) + "'s", 
    '''right, you should beat 'em up daddy," says''',
    '''the girl, tugging on Peter's shirt.'''],
    ['''"Now honey, that won't do anything but get me thrown in jail," says Peter,''',
    '''tweaking the girl's nose. "Come on, let's go and practice your letters."'''],
    '''The girl groans. "But that's boring."''',
    ['''"I know, but if you want to be a spellslinger someday, you're going to have to''',
    '''learn how to read and write," says Peter, lifting the girl and sitting her on''',
    '''his shoulder. He looks at''', p.PC.name + ".", '''"Need anything else?"'''],
    [p.PC.name, '''shakes''', hisher(p.PC), '''head.'''],
    ['''"Have a nice day then, and I hope you come back if you need armor or weapons''',
    '''repaired or replaced," says Peter, before turning and carrying his daughter''',
    '''into the back of the room.''']])
peter_7_1_1.quip_function = peter_7_1_1qf

peter_8_1_1.comment = universal.format_line(['''"Kid's going to have to just toughen up. Nobody''',
'''respects a thin-skinned wimp."'''])
def peter_8_1_1qf():
    peter_8_1_1.quip = universal.format_text(['''The girl shrinks back against her father.''',
    ['''Peter scowls, and puts a protective arm around her shoulders. "I neither asked''',
        '''for nor need your opinion."'''],
    ['''"I'm just being honest," says''', p.PC.name, ''' defensively.'''],
    ['''"I really don't care,' says Peter, standing and towering over''', p.PC.name + ".",
        '''"Now unless there's something you want to purchase, get out."''']])
peter_8_1_1.quip_function = peter_8_1_1qf
peter_8p1_1_1 = Node(173) 
peter_8p2_1_1 = Node(174) 
peter_8p3_1_1 = Node(176)
peter_8_1_1.children = [peter_8p1_1_1, peter_8p2_1_1, peter_8p3_1_1]

peter_8p1_1_1.comment = '''"I'm sorry. I just wanted to help."'''
def peter_8p1_1_1qf():
    peter_8p1_1_1.quip = universal.format_text([['''Peter runs a hand through his hair. "Don't''',
    '''worry about it. I'm just a little defensive about my children."'''],
    ['''"That's understandable," says''', p.PC.name + ".", '''"I probably should have''',
    '''given a bit more thought to what I was going to say before I said it."'''],
    ['''"Is there anything else you need?" asks Peter. "Because I really do need to''',
    '''attend to my daughter."'''],
    [p.PC.name, '''shakes''', hisher(p.PC), '''head.'''],
    ['''"Fine then, if you could go about your business, I'd appreciate it," says''',
    '''Peter.'''],
    [p.PC.name, 'leaves.']])
    return(universal.acknowledge, [townmode.go, craftmansCorridor])
peter_8p1_1_1.quip_function = peter_8p1_1_1qf

peter_8p2_1_1.comment = '''"Alright, fine."'''
def peter_8p2_1_1qf():
    peter_8p2_1_1.quip = universal.format_text([[p.PC.name, '''turns on''', hisher(p.PC), '''heel''',
        '''and leaves.''']])
    p.PC.add_keyword('insulted_Peters_kid')
    return(universal.acknowledge, [townmode.go, craftmansCorridor])
peter_8p2_1_1.quip_function = peter_8p2_1_1qf

peter_8p3_1_1.comment = universal.format_line(['''Cross your arms''',
'''defiantly. "You know, if you want to stay in business, you should treat your''',
'''customers with a little bit more respect."'''])
def peter_8p3_1_1qf():
    peter_8p3_1_1.quip = universal.format_text([['''Peter grabs''', p.PC.name, 
        '''by the arm and drags''', himher(p.PC),
        '''out of the shop. He flings''', himher(p.PC), '''a few steps away. "When I''',
        '''tell you to get out of my shop, you get out."'''], 
        ['''"Fine. I didn't want any of your crap anyway," says''', p.PC.name + "."], 
        ['''Peter turns and goes back into his shop, slamming the door behind''',
        '''him.''']])
    p.PC.add_keyword('refused_to_leave_Peters_shop')
    return (universal.acknowledge, [townmode.go, craftmansCorridor])
peter_8p3_1_1.quip_function = peter_8p3_1_1qf   

#----------------------------------Adventurer's Guild----------------------------------
def join_guild():
    return universal.format_text([['''"There are five things you should know: One, the structure''',
        '''of your missions. Two, your payment. Three, emerits. Four, demerits. Five, responsibilities to other members of the Guild.'''],
        ['''"First, the structure of the missions. Typically, a client will come''',
        '''in and request a service. I sit down with them and figure out what they''',
        '''need done, as well as any secondary''',
        '''tasks they'd like accomplished. Then, I select one or more adventurers who''',
        '''I think would be best suited for the mission. Then, I sit you down and''',
        '''explain the location of the mission, the primary''', 
        '''objective, any secondary objectives, and some of the expected dangers.''',
        '''You'll usually have to explore some dark, smelly place filled with''',
        '''baddies. Objectives usually consist of finding a particular item,''',
        '''defeating a particular enemy, or even just reconaissance.'''],
        ['''"Second, your payment. There's a base fee that you get paid regardless of''',
        '''whether you succeed or not. I emphasize with my clients''', 
        '''that I do not guarantee results. I personally would rather see you live''',
        '''another day, even if both of us become a little poorer as a result.''',
        '''Therefore, I encourage my people to return and report failure if things''', 
        '''become too dangerous. In such a case, I usually get back to the client,''',
        '''explain the situation, and then the client can choose either to hire''',
        '''additional adventurers, or just give up the cause as lost. If you complete''',
        '''the primary objective, you receive additional coin beyond the base fee,''',
        '''usually an extra 50%."'''],
        ['''"You also receive bonuses for completing any secondary objectives. These''',
        '''tasks are usually very similar to the primary objective, but aren't as''',
        '''important. The primary objective is what drove the''',
        '''client to come to me, secondary objectives are just things that would be''',
        '''kind of nice to see accomplished. You will be paid the bonus for''',
        '''completing the secondary objectives even if you fail''',
        '''to complete the primary."'''], 
        ['''"Third, emerits. I already mentioned that the more objectives you complete,'''
        '''the better you are paid. In addition, in order to track your success''',
        '''record, I have an internal system of emerits and''', 
        '''demerits. You receive emerits for completing objectives, the more important''',
        '''and the more difficult, the more emerits. Every 20 emerits, you receive a''',
        '''bonus, perhaps some extra coin, a piece of equipment, that type of thing.'''],
        ['''"Fourth, demerits. You receive demerits if you fail to complete a''',
        '''primary objective. You do not receive demerits for failing to complete a''',
        '''secondary objective. You receive as many demerits for failing a primary''',
        '''objective as you would earn emerits for completing it. Note that''',
        '''typically you would receive more emerits for completing a primary objective''',
        '''than all the secondary objectives combined. So if you fail to complete the''',
        '''primary objective, you're going to have a net loss. For every 20 demerits''',
        '''you receive, we have a little talk about your performance. And I mean''',
        '''actual talking. I want to figure out what the problem is, and then get it fixed''',
        '''before it gets you killed. After that chat, you get to spend some time''',
        '''training with one of  my trainers. The point of the training is help you''',
        '''shore up any weaknesses''',
        '''you might have. The training is probably going to be rather intense and''',
        '''more than a little unpleasant. All of my trainers are big fans of corporal''',
        '''punishment and have very high standards. After the training, up to 20''',
        '''demerits are removed from your record, allowing you to restart with''',
        '''more or less a clean slate.'''],
        ['''Finally, your responsibilities to other Guild members. You are expected to help and support your fellow members, and they are expected to help you, so long''',
                '''as it is not illegal, overly dangerous, or involves direct aid in your missions. For example, you can obtain healing from our healer Paloma, and you''',
                '''can ask for''','''advice, but other members can't join you in fulfilling your missions unless I explicitly assign them. If you fail to uphold''',
                '''this responsibility, the wronged Guild member is within their rights to punish you. Any questions?'"''']])
adventurersGuild.add_character(adrian)
adrian_1_initial_greeting = Node(177)
adrian_greeting_1_1 = Node(191)
adrian.litany = adrian_1_initial_greeting
adrian.defaultLitany = adrian_greeting_1_1
adrian_1_1_1 = Node(178) 
adrian_2_1_1 = Node(179)
adrian_1_initial_greeting.children = [adrian_1_1_1, adrian_2_1_1]
adrian_6_1_1 = Node(188) 
adrian_7_1_1 = Node(189) 
adrian_8_1_1 = Node(190)
adrianRootChildren = [adrian_6_1_1, adrian_7_1_1, adrian_8_1_1]
def adrian_1_initial_greeting_qf():
    adrian_1_initial_greeting.quip = universal.format_line(['''"Hello, and welcome''',
    '''to Adrian's Adventurer's Guild," says the man. He gives''', p.PC.name, 
    '''a quick, professional look-over. "My name is Adrian, and I take''',
    '''it you're looking for employment."'''])
adrian_1_initial_greeting.quip_function = adrian_1_initial_greeting_qf

adrian_1_1_1.comment = '''"Erm, yes. Are there any open spots?"'''
adrian_1p1_1_1 = Node(180)
adrian_1p2_1_1 = Node(181)
adrian_1p3_1_1 = Node(182)
adrian_1p4_1_1 = Node(183) 
adrian_1p5_1_1 = Node(184)
adrian_1_1_1.children = [adrian_1p1_1_1, adrian_1p2_1_1, adrian_1p3_1_1, 
        adrian_1p4_1_1, adrian_1p5_1_1]
def adrian_1_1_1_qf():
    adrian_1_1_1.quip = universal.format_line(['''"You're in luck," says Adrian.''',
    '''"We could''', '''definitely use more adventurers. The sign up fee is''',
    str(adrian.myPrice), '''coins."'''])
    if 'Maria_intimidated_you' in p.PC.keywords:
        adrian_1p2_1_1.comment = universal.format_line(['''"Great. Maria treats me''',
            '''like dirt, and now I have to pay some cursed sign up fee.''',
            '''Could this day get any worse?"'''])
    else:
        adrian_1p2_1_1.comment = universal.format_line(['''"Wait, I know Maria. She''',
            '''said to tell you she sent me. Could I get a discount or''',
            '''something?"'''])
adrian_1_1_1.quip_function = adrian_1_1_1_qf

adrian_1p1_1_1.comment = '"Sign up fee? No one told me about a sign-up fee!"'
adrian_1p1_1_1.children = [adrian_1p2_1_1, adrian_1p3_1_1]
def adrian_1p1_1_1_qf():
    adrian_1p1_1_1.quip = universal.format_line(['''"Yes, isn't it unfortunate that''',
        '''we don't''',
    '''all have our own personal narrator telling us everything we'll''',
    '''ever need to know?" says Adrian.''', '"' + str(adrian.myPrice), 
    '''coins, please."'''])
    p.PC.add_keyword('full_conversation')
    p.PC.add_keyword('learned_about_signup_fee')
adrian_1p1_1_1.quip_function = adrian_1p1_1_1_qf

adrian_3_1_1 = Node(185)
adrian_1p2_1_1.children = [adrian_1p5_1_1, adrian_3_1_1]    
def adrian_1p2_1_1_qf():
    if 'Maria_intimidated_you' in p.PC.keywords:
        adrian_1p2_1_1.quip = universal.format_text([['''"Maria of Chengue?" asks''',
            '''Adrian quickly. "Do you know her? Have you seen her recently? She hasn't been in for''',
            '''almost two weeks now, and I've got a job sitting in the''',
            '''queue that's just perfect for her."'''],
            ['''"Yes," says''', p.PC.name, '''in a clipped tone.'''],
            ['''Adrian clearly notices''', p.PC.name + "'s", '''angry tone.''',
                '''"Yes, well, if you see her again, please let her know''',
                '''that I'm looking for her. My client is getting''',
                '''impatient, but he's not willing to spend enough to''',
                '''hire more than one adventurer, and I really don't have''',
                '''anyone else that can handle this solo."'''],
            ['''"Fine."'''],
            ['''"Anyway," says Adrian. "Are you interested in joining?''',
                str(adrian.myPrice), '''coins, remember."''']])
    else:
        adrian_1p2_1_1.quip = universal.format_text([['''Adrian's face lights up.''',
        '''"Oh, Maria! Have you seen her recently? She hasn't been in for''',
        '''almost two weeks now, and I've got a job sitting in the queue''',
        '''that's just perfect for her."'''],
        ['''"Yeah, she met me when I arrived," says''', p.PC.name + ".", 
            '''"But don't worry. She's working your job right now."'''],
        ['''"But I haven't given her the job yet," says Adrian, frowning.'''],
        [p.PC.name, '''cocks''', hisher(), '''head to the side, and''', hisher(), '''forehead wrinkles. "Are you sure?"'''],
        ['''Adrian crouches behind the counter. There is a rough shuffling''',
            '''of parchment, then he emerges with a sheet, which he consults for a moment.''',
        '''He nods.''',
        '''"Yup, I'm sure. It says here that she successfully completed her''',
        '''last job three weeks ago, and hasn't yet received another one."'''],
        ['''"Why would she lie to me?" mutters''', p.PC.name + "."],
        ['''"I don't know." Adrian shrugs. "But since you know her, and she recommends you,''',
            '''I'll happily give you a discount. Woman's real good at''',
            '''finding new talent. So how about''', str(adrian.myPrice - 10), 
            '''coins instead?"''']])
    p.PC.add_keyword('Maria_lied_about_job')
    if 'Maria_intimidated_you' not in p.PC.keywords:
        adrian.myPrice -= 10
adrian_1p2_1_1.quip_function = adrian_1p2_1_1_qf

adrian_1p3_1_1.comment = '''"How about I give you 5 coins instead?"'''  
adrian_1p3_1_1.children = [adrian_1p2_1_1, adrian_1p5_1_1, adrian_3_1_1]
def adrian_1p3_1_1_qf():
    if 'snarked_at_Adrian' in p.PC.keywords:
        adrian_1p3_1_1.quip = universal.format_line(['''"First you waste my time''',
            '''with sarcasm, now you try to haggle on something''',
            '''non-negotiable. The sign up fee is now 25 coins," says''',
            '''Adrian.'''])
    else:
        adrian_1p3_1_1.quip = universal.format_line(['''"How about 20 gold instead?"''',
        '''asks Adrian sharply.'''])
    adrian_1p3_1_1.quip = universal.format_text([adrian_1p3_1_1.quip,  
        ['''"Hey what?" cries''', p.PC.name + ".", '''"You can't just increase''',
        '''the fee like that."'''],
        ['''"Of course I can," says Adrian, looking''', p.PC.name, '''dead in the eye.''',
        '''"It's my business, and to be''',
        '''frank, you need me more than I need you."'''],
        ['''"This is highway robbery," mutters''', p.PC.name + "."],
        ['''"Storefront robbery, actually," says Adrian. "Now, are you''',
        '''going to pay?"''']])
    adrian_1p5_1_1.comment = universal.format_line(['''"Alright, alright. I guess''',
    '''I'm interested, as long as you don't raise your stupid''',
    '''fee anymore."'''])
    p.PC.add_keyword('tried_to_haggle_with_Adrian')
    adrian.myPrice += 5
    if 'snarked_at_Adrian' in p.PC.keywords:
        adrian.myPrice += 5
adrian_1p3_1_1.quip_function = adrian_1p3_1_1_qf

adrian_1p4_1_1.comment = '''"I don't have enough money."'''
adrian_1p4p1_1_1 = Node(186) 
adrian_1p4p2_1_1 = Node(187)
adrian_1p4_1_1.children = [adrian_1p4p1_1_1, adrian_1p4p2_1_1]
def adrian_1p4_1_1_qf():
    adrian_1p4_1_1.quip = universal.format_text([['''"That's not a problem," says''',
        '''Adrian. "We'll just give you''', str(adrian.myPrice), '''coins''',
        '''worth of credit. The price will come out of the''',
        '''payment for your first real mission."'''],
        ['''"You're not going to charge like 500% interest or something''',
        '''are you?" asks''', p.PC.name, '''warily.'''],
        ['''Adrian shakes his head. "I'm not interested in taking''',
            '''advantage of you. I was an adventurer too once, and I know''',
            '''how hard it is to scrape up enough money for your next''',
            '''meal, let alone for some fee. I'll take''', 
            '''The fees you guys get paid are high enough that it won't''',
            '''hurt much."'''],
    ['''Still,''', p.PC.name, '''hesitates.'''], 
    ['''"Relax kid,' says one of the other adventurers, a man who looks''',
            '''to be in his late thirties. "Adrian's true to his word. I''', 
        '''was in the exact same situation you are, he gave me a 15 coin''',
        '''credit, and 15 coins is all he took."''']]); 
adrian_1p4_1_1.quip_function = adrian_1p4_1_1_qf

adrian_1p4p1_1_1.comment = universal.format_line(['''"Well, alright. I mean, it's''',
    '''not like I have much else of a choice."'''])
adrian_1p4p1_1_1.children = [adrian_6_1_1, adrian_7_1_1, adrian_8_1_1]
def adrian_1p4p1_1_1_qf():
    p.PC.add_keyword('joined_the_guild')
    p.PC.add_keyword('owe_Adrian_signup_fee')
    adrian_1p4p1_1_1.quip = universal.format_text([['''"Excellent," says Adrian. "I''',
        '''look forward to working with you." He pulls out a few sheets''',
        '''of parchment. "Can you read and write?"'''],
    [p.PC.name, '''nods.'''],
    ['''"Excellent," says Adrian. He passes the forms across to you.''',
    '''"First, we have an IOU. Just a slip of paper that you and I each''',
    '''get a copy that says you owe me''', str(adrian.myPrice), '''coins,''',
    '''and that the debt will''',
    '''be paid out of the fee of your first mission.'''],
    ['''"Then we have the real forms. I highly recommend that you read''',
    '''them,''',
    '''but first I'll give you a brief overview of what they''',
    '''say.'''], join_guild()])
adrian_1p4p1_1_1.quip_function = adrian_1p4p1_1_1_qf

adrian_1p4p2_1_1.comment = '''"You know, I think I'll look for something else."'''
def adrian_1p4p2_1_1_qf():
    adrian_1p4p2_1_1.quip = universal.format_line(['''Adrian nods. "Understandable.''',
    '''If you change your mind, we'll be here."'''])
    p.PC.add_keyword('searching_for_a_non_adventuring_job')
    adrian.litany = adrian_greeting_1_1
adrian_1p4p2_1_1.quip_function = adrian_1p4p2_1_1_qf

adrian_1p5_1_1.comment = '''"Alright, I guess I'm interested."'''
adrian_1p5_1_1.children = adrianRootChildren
def adrian_1p5_1_1_qf():
    adrian_1p5_1_1.quip = ""
    p.PC.add_keyword('joined_the_guild')
    if p.PC.coins < adrian.myPrice:
        p.PC.add_keyword('owe_Adrian_signup_fee')
        adrian_1p5_1_1.quip = universal.format_text([[p.PC.name, '''pulls out''', 
            hisher(p.PC), '''purse, then notices that''', heshe(p.PC), 
            '''doesn't have enough.''', HeShe(p.PC), '''grins sheepishly up''',
            '''at Adrian.'''],
            ['''"Not enough?" asks Adrian. "Not a problem. I'll just take''',
            '''the sign up fee out of your first job."'''],
            [p.PC.name + "'s", '''hackles rise. "Plus 500% interest I''',
                '''suppose? Sorry, I'm not interested in turning into a''',
                '''debt slave."'''],
            ['''Adrian grimaces. "I'm not interested in taking advantage''',
                '''of you. I was an adventurer once too, and I remember''',
                '''well how hard it can be to find enough money for food,''',
                '''let alone some silly sign up fee. You will owe''',
                '''me''', str(adrian.myPrice), '''coins and only''',
                str(adrian.myPrice), '''coins."'''],
            ['''"He's on the level miss," says an adventurer behind''', 
                p.PC.name + ",", '''a woman a few years older than''', 
                himher(p.PC) + ".", '''"Most of us didn't have the sign up''',
                '''fee either, and he only took the 15 coins he needed''',
                '''from us."'''],
            ['''"Besides," says another, chuckling. "Adrian makes most''',
            '''of his money by skinning his customers. He doesn't need''',
            '''to skin us too."'''],
            ['''"Well, alright then," says''', p.PC.name + ",", '''though''',
            heshe(p.PC), '''still wonders if perhaps''', heshe(p.PC), '''is''',
            '''about to make a mistake.''']])
    else:
        p.PC.coins -= adrian.myPrice
    if adrian_1p5_1_1 != '':
        adrian_1p5_1_1.quip = universal.format_text([adrian_1p5_1_1.quip, 
            ['''Adrian pulls out a few sheets of parchment. "The following''',
            '''are some forms that you'll need to sign. They detail''',
            '''the rules,  and compensation, for working''',
            '''for me. Can you read and write?"'''],
            [p.PC.name, '''nods, staring at the sheets of parchment. The''',
                '''money he spends on parchment alone would probably be''',
                '''enough to live comfortably on.'''],
            ['''"Excellent," says Adrian. "So you should probably read''',
                '''these. Still, I can give you the general gist."'''],
                join_guild()]);
    else:
        adrian_1p5_1_1.quip = universal.format_text([
            ['''Adrian pulls out a few sheets of parchment. "The following''',
            '''are some forms that you'll need to sign. They detail''',
            '''the rules,  and compensation, for working''',
            '''for me. Can you read and write?"'''],
            [p.PC.name, '''nods, staring at the sheets of parchment. The''',
                '''money he spends on parchment alone would probably be''',
                '''enough to live comfortably on.'''],
            ['''"Excellent," says Adrian. "So you should probably read''',
                '''these. Still, I can give you the general gist."'''],
                join_guild()]);
adrian_1p5_1_1.quip_function = adrian_1p5_1_1_qf

adrian_2_1_1.comment = universal.format_line(['''"No, I'm rich enough to hire''',
    '''adventurers despite having faded, threadbare clothing, blistered''', 
    '''feet, and aching shoulders."'''])
adrian_2_1_1.children = [adrian_1p1_1_1, adrian_1p2_1_1, adrian_1p3_1_1, 
        adrian_1p5_1_1]
def adrian_2_1_1_qf():
    adrian_2_1_1.quip = universal.format_text([['''"Watch your tongue," says Adrian''',
    '''sharply. "Two of those things I could hardly be expected to know''',
    '''just by looking at you. And I would not call your clothing''',
    '''threadbare by any stretch of the''',
    '''imagination, unless you actually are rich enough to hire''',
    '''adventurers. Now I'm going to take your lip as''',
    '''a yes, you are looking for employment. The sign-up fee is''',
    str(adrian.myPrice), '''coins."''']])
    p.PC.add_keyword('snarked_at_Adrian')
    if 'Maria_intimidated_you' in p.PC.keywords:
        adrian_1p2_1_1.comment = universal.format_line(['''"Great. Maria treats me''',
            '''like dirt, and now I have to pay some cursed sign up fee.''',
            '''Could this day get any worse?"'''])
    else:
        adrian_1p2_1_1.comment = universal.format_line(['''"Wait, I know Maria. She''',
            '''said to tell you she sent me. Could I get a discount or''',
            '''something?"'''])
adrian_2_1_1.quip_function = adrian_2_1_1_qf

adrian_3_1_1.comment = '''"Actually, nevermind."'''
def adrian_3_1_1_qf():
    adrian_3_1_1.quip = universal.format_line(['''"Hope I'm not scaring you," says''',
        '''Adrian wryly. "Anyway, if you change your mind, come on back.''',
        '''I could always use more adventurers."'''])
    p.PC.add_keyword('searching_for_a_non_adventuring_job')
    return(conversation.set_litany, (adrian_greeting_1_1,))
adrian_3_1_1.quip_function = adrian_3_1_1_qf            

adrian_4_1_1 = Node(192) 
adrian_5_1_1 = Node(194)
adrian_greeting_1_1.children = [adrian_4_1_1, adrian_5_1_1]
def adrian_greeting_1_1_qf():
    adrian_greeting_1_1.quip = universal.format_text([['''"Didn't have much luck, I''',
    '''take it?" asks Adrian, setting his quill down.'''],
    [p.PC.name, '''shakes''', hisher(p.PC), '''head.'''],
    ['''"Sorry to hear that. So, you interested in joining?"''']])
adrian_greeting_1_1.quip_function = adrian_greeting_1_1_qf

adrian_4_1_1.comment = '''"Actually, I'd like to keep looking."'''
adrian_4_1_1.quip = '''Adrian shrugs. "Enjoy yourself."'''

adrian_5_1_1.comment = '''"Guess I don't have much choice."'''
adrian_5_1_1.children = adrianRootChildren
def adrian_5_1_1_qf():
    adrian_5_1_1.quip = universal.format_text([['''"Oh don't worry about it," says Adrian,''',
        '''pulling several documents out from underneath the counter. "It's a''',
        '''pretty good life, all in all. Gets kind of rough sometimes, but you meet''',
        '''some great people, and get some great stories to tell.''', 
        '''You also have horrific nightmares, but hey that's life."'''],
    ['''"Encouraging."''',
        p.PC.name, 
        '''opens''', hisher(), '''purse. "How much was it again?"'''],
        ['"' + str(adrian.myPrice) + '"','''says Adrian.''']])
    if p.PC.coins < adrian.myPrice:
            universal.format_text([adrian_5_1_1.quip, '''"Oh."''',
            ['''"Not enough?" asks Adrian. "Don't worry about it. I'll just take the fee out of''',
            '''your first real job."'''],
            [p.PC.name + "'s", '''hackles rise. "Plus 500% interest, I suppose?"'''],
            ['''"No, actually," says Adrian. "See, I was an adventurer at one time, too. I know how''',
            '''hard it is to scrape up enough money for food, let alone a sign up fee. It'll be''',
            str(adrian.myPrice), '''coins, and only''', str(adrian.myPrice), '''coins."'''],
            ['''"He's on the level, kid," says one of the adventurers at the table. "Most of us''',
            '''were in a similar situation. He took the sign up fee, and not a coin more."'''],
            '''The other adventurers all nod.''',
            ['''"Well, alright," says''', p.PC.name + ",", '''though''', heshe(p.PC), 
            '''can't help but''',
            '''wonder if''', heshe(p.PC), '''might be making a mistake.''']])
    adrian_5_1_1.quip= universal.format_text([adrian_5_1_1.quip, join_guild()])
    if p.PC.coins < adrian.myPrice:
        p.PC.add_keyword('owe_Adrian_sign_up_fee');
    else:
        p.PC.coins -= adrian.myPrice;
    return(universal.acknowledge, townmode.town_mode)
adrian_5_1_1.quip_function = adrian_5_1_1_qf

adrian_6_1_1.comment = universal.format_line(['''"Can you give me any guarantees about how many''',
    '''jobs per month I'll get?"'''])
def adrian_6_1_1_qf():
    adrian_6_1_1.quip = universal.format_text([['''"No more than you can guarantee how many''',
    '''clients I'll have''',
    '''every month," says Adrian, chuckling. "These days though, things are pretty busy,'''
    '''and I don't have that many adventurers. So you'll probably get''', 
    '''about one major job a month. There may also be a few minor things scattered''',
    '''throughout, like saving cats from trees, but those don't usually pay much more''',
    '''than pocket change."'''],
    ['''"Why the shortage of adventurers?" asks''', p.PC.name + "."],
    ['''"The discovery of the Dale Ruins to the far north," says Adrian. "A lot of''',
    '''adventurers have been going north to explore those."''']])
    adrianRootChildren.remove(adrian_6_1_1)
adrian_6_1_1.children = adrianRootChildren
adrian_6_1_1.quip_function = adrian_6_1_1_qf

adrian_7_1_1.comment = '''"How much will I get paid per mission?"'''
def adrian_7_1_1_qf():
    adrian_7_1_1.quip = universal.format_text([['''"The standard base fee is 100 coins,' says''',
    '''Adrian. "You get paid that whether you succeed or not. Living expenses in''',
    '''Avaricum are about 90 to 200 coins per month, depending on where you live. We do have rooms here, however. Rent for them is 90 coins a month, but you also have''',
    '''to help with various chores, and we have several rules you would need to follow. So,''',
    '''you should be able to live on''', 
    '''your fees, so long as you're careful. Anyway, secondary objectives usually net you an additional 20 coins each. Don't''',
    '''get your hopes up, though, there aren't usually that many. One or two, when''',
    '''there are any at all. Completing the primary objective gets you an extra 50''',
    '''coins."''']])
    adrianRootChildren.remove(adrian_7_1_1) 
adrian_7_1_1.children = adrianRootChildren
adrian_7_1_1.quip_function = adrian_7_1_1_qf

adrian_8_1_1.comment = '''"I think that's all my questions. What's my first mission?"'''
def adrian_8_1_1_qf():
    adrian_8_1_1.quip = universal.format_text([['''"Patience," says Adrian. "You need to read''',
        '''and sign the forms''']]) 
    if 'owe_Adrian_sign_up_fee' in p.PC.keywords: 
        adrian_8_1_1.quip = universal.format_line([adrian_8_1_1.quip + ",", 
            '''including the IOU,'''])
    adrian_8_1_1.quip = universal.format_line([adrian_8_1_1.quip, '''and then'''])
    return (display_text_start_next_scene, [250], True)
adrian_8_1_1.quip_function = adrian_8_1_1_qf


def display_text_start_next_scene(delayTime):
    flush_text()
    #pygame.time.delay(delayTime)
    episode1.next_scene()

def start_scene_1_episode_1(loading=False):
    print('starting_scene_1')
    if not loading:
        townmode.go(edgeOfAvaricum)
        print('going to edge of avaricum')
        p.PC.equip(itemspotionwars.familyDagger)
        p.PC.equip(itemspotionwars.tunic)
        p.PC.equip(itemspotionwars.trousers)
        p.PC.equip(itemspotionwars.modestUnderwear)
        p.PC.take_item(itemspotionwars.woodenSpoon)

    enterLeft(carol, theresesTailors)
    carol.litany = carol_first_greeting

    enterLeft(peter, wesleyAndAnnesArmorShop)
    peter.litany = peter_greeting

    enterLeft(maria, avaricumSquare)
    maria.litany = maria_greeting_1_1
    
    enterLeft(southGuard, edgeOfAvaricum)

    enterLeft(elise, shrine)
    elise.litany = elise_greeting_1_1

    enterLeft(adrian, adventurersGuild)
    adrian.litany = adrian_1_initial_greeting


#---------------------------------------Scene 2 Conversation Nodes-------------------------------------------

spankCarlitaStern = Node(196) 
spankCarlitaNice = Node(197) 
spankCarlitaCruel = Node(198)
spankCarlita.children = [spankCarlitaStern, spankCarlitaNice, spankCarlitaCruel]
def spankCarlita_qf():
    music.play_music(CARLITA)
    universal.say_title(carlita.printedName)
    spankCarlita.quip = universal.format_text([[p.PC.name + "'s", '''eyes widen as the young rebel collapses, her health clearly drained. It is blatantly obvious the young''',
        '''woman has had little to no combat training.'''],
    [p.PC.name, '''cleans and puts away''', hisher(p.PC), '''weapon, then bends down over the Vengador, and yanks off the girl's mask. The girl yelps, and tries to grab it,''',
        '''but her attempt is slow and clumsy, and''', p.PC.name, '''easily keeps it out of reach. The girl looks to be about eighteen. Her cheeks are hollow, hinting''',
        '''at limited food of poor quality. She has a purple birthmark that arcs from just above her right eye, down across her cheek to her jawline.''', name(), 
        '''snatches up the young woman's dagger and studies it more closely. The weapon is rusty, heavily nicked, and so dull as to be borderline unusuable.'''],
    ['''"Give that back," says the young woman in a weak voice. She grabs''', p.PC.name + "'s", '''legs, and tries to pull herself up.''',
    p.PC.name, '''sets the dagger down on the nearby counter, then looks down at the woefully underprepared girl.''']])
    increment_spankings_given()
spankCarlita.quip_function = spankCarlita_qf

spankCarlitaStern.comment = universal.format_line(['''"You don't have any combat training to speak of, do you? What do you think you're doing attacking a guild full''',
    '''of professional warriors? You could have been hurt, or even killed."'''])
sternOTK = Node(199)
sternBentOver = Node(200)
spankCarlitaStern.children = [sternOTK, sternBentOver]
def spankCarlitaStern_qf():
    spankCarlitaStern.quip = universal.format_text([['''The girls frowns. "What?"'''],
        [name(), '''picks the younger woman up by the arm and forces her to look at the chaos ripping its way through the room.''',
    '''Adventurers and Vengadors are unleashing spells, slamming each other through tables, and hacking at limbs, heads, and torsos. "What do you think would''',
    '''have happened if you'd gotten involved in one of those fights? Well?"'''],
    ['''"I dunno," mutters the girl petulantly. She tries to pull free, but like anyone whose health has been drained, she's weak as a kitten.'''],
    [name() + "'s", '''free hand snaps down and cracks hard against the girl's bottom. The younger Taironan yelps and pushes her hips forward, away from the''',
        '''older Taironan's hand.''', '''"Let's try that again. What do you think would have happened?"'''],
    ['''The woman just pouts, so''', p.PC.name, '''lands two more sharp smacks to her bottom.'''],
    ['''"Fine, fine," yelps the girl, her hands flying down to shield her bottom. "I'd have been defeated, just like against you."'''],
    ['''"No, not just like against me," snaps''', p.PC.name + ".", '''"I'm nowhere near as strong as the other adventurers here. If they weren't careful,''',
    '''they could've hurt you so badly that your health wouldn't be able to handle it. You could've found yourself lying on the ground,''',
    '''covered in burns, or-"'''],
    ['''"Oh shut up and leave me alone, you stupid''', p.pigcow() + '!"', '''snaps the girl, yanking at her arm.'''],
    [p.PC.name + "'s", '''eyes narrow, and the Vengador starts to look nervous.''']])
    p.PC.add_keyword('stern_to_Carlita')
spankCarlitaStern.quip_function = spankCarlitaStern_qf

sternOTK.comment = "Turn her over your knee."
sternOverTrousers = Node(201)
sternLowerTrousers = Node(202)
sternOTK.children = [sternOverTrousers, sternLowerTrousers]
def sternOTK_qf():
    sternOTK.quip = universal.format_text([[p.PC.name, '''glances around, and notices a sturdy, wooden chair that has miraculously survived the battle so far.''', HeShe(), 
    '''drags the girl towards the chair.'''], 
    ['''"Hey, now what're you doing?" says the girl, ineffectually dragging her heels.'''],
    ['''"What do you think I'm doing?" says''', p.PC.name + ".", '''"You attack me for absolutely no reason. You've put''',
    '''yourself in serious danger, and when I try to point this out to you, you call me a''', p.pigcow(p.PC) + '."']])
     
    if 'spanked_young_insurgent' in p.PC.keywords:
        sternOTK.quip = universal.format_text([sternOTK.quip, ['''"But you've already spanked me!' wails the young woman, as she struggles to break free.'''],
        ['''"Clearly, I didn't spank you hard enough," says''', p.PC.name + "."]])
    sternOTK.quip = universal.format_text([sternOTK.quip, [p.PC.name, '''sits down and yanks the younger woman across''', hisher(), '''lap. The girl falls across''', 
    name() + "'s", '''lap with a yelp and wiggles around in a desperate attempt to roll off.''', p.PC.name + "'s", '''left hand clamps down on the Taironan's lower''',
    '''back.'''],
    ['''"Stop squirming, before you get on my nerves," says''', p.PC.name + ".", ''''''],
    ['''"Go suck off El Padre!" The young woman twists and tries to smack''', p.PC.name, '''in the face.''']])
sternOTK.quip_function = sternOTK_qf

sternOverTrousers.comment = "Spank her over her trousers."
def sternOverTrousers_qf():
    sternOverTrousers.quip = universal.format_text([['''"You really need to work on your mouth," says''', p.PC.name + ",", '''smacking the young woman's right bum cheek.'''],
    ['''"This cannot be happening," moans the Vengador, squirming in''', p.PC.name + "'s", '''grip.'''], 
    ['''"Oh, yes it can," says''', p.PC.name + ".", HisHer(p.PC), '''hand starts to rise and fall, slapping first one cheek, and then the other. Before long, the''',
        '''girl is wailing and bucking, her legs kicking frantically while''', p.PC.name + "'s", '''thoroughly spanks her bouncing bottom.'''], 
    ['''"Stop kicking," says''', p.PC.name, '''curtly, slapping the young woman's thighs a few times.'''],
    ['''The young Vengador squeals, and her legs stop kicking. "I'm sorry, I'm sorry I'm sorry! I won't fight for the Vengadores anymore I promise! Please stop!"'''],
    ['''In response,''', p.PC.name, '''shifts her slightly farther forward on''', hisher(p.PC), '''lap, and administers another half-dozen quick, sharp slaps to her''',
        '''sit spots.'''],
    ['''The girl howls, and her legs start kicking again. "Pleeeease!"'''],
    ['''"The question is, should I believe you, or are you just trying to get out of your spanking?" asks''', p.PC.name + "."],
    ['''Before the girl can respond, Adrian half rolls, half staggers into the room, barely dodging a gout of flame. When he sees''', p.PC.name, '''sitting in the''',
        '''chair, with''', hisher(p.PC), '''opponent turned over''', hisher(p.PC), '''knee, his eyes nearly bug out of his head.''',
        '''"What the hell are you doing?" he roars, nearly causing''', p.PC.name, '''to jump out of''', hisher(p.PC), '''chair. "My guild is under attack, my armory''',
        '''probably being raided, and you're spanking your opponent?" He points to the door to the north. "Get your ass down into the armory, and stop these sons''',
        '''of bitches before I thrash you from now to new years!"'''],
    ['''Then, his opponent bursts through the wall and swings her sword at his head. Adrian ducks the swing and lunges up with his own weapon, forcing the woman''',
        '''backwards a few steps.'''],
    [p.PC.name, '''pushes the young girl off''', hisher(p.PC), '''lap, and jumps to''', hisher(p.PC), '''feet.''', HeShe(p.PC), '''pulls the girl into a corner, away from''',
        '''the fighting.''', HeShe(p.PC), '''points a finger at her. "Stay here. You move, and so help me the spanking I'll give you will make the''',
        '''last one feel like a lover's rub."'''],
    ['''"Yes''', p.sirmaam(p.PC) + ',"', '''mutters the girl, gingerly rubbing her smarting bottom.''', p.PC.name, '''thinks''', heshe(p.PC), '''can detect a hint of''',
    '''a smirk, but''', heshe(p.PC), '''doesn't have time to deal with it. Instead,''', heshe(p.PC), '''takes one last look at the battle, then charge into the back of''',
    '''the guild.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
sternOverTrousers.quip_function = sternOverTrousers_qf

sternLowerTrousers.comment = "Lower her trousers."
def sternLowerTrousers_qf():
    sternLowerTrousers.quip = universal.format_text([[p.PC.name, '''grabs the back of the young woman's trousers.'''],
        ['''"What are you-oh no no no please no," wails the girl, her legs flailing frantically.'''],
        ['''"You just told me to engage in oral sex with a god," says''', p.PC.name + ".", '''"You better believe these trousers are coming down."'''],
        ['''"Nooo, wait I'm sorry!" cries the rebel as''', p.PC.name, '''pulls her trousers down to her knees, revealing a small, heart-shaped bottom.'''],
        ['''Smack! Smack! Smack! Smack!'''],
        ['''The girl squeals and kicks her legs, while''', p.PC.name, '''punishes her rapidly reddening bottom. Her bottom bucks and heaves about on''', p.PC.name + "'s",
            '''lap.''', '''As a result,''', p.PC.name, '''accidentally smacks the side of the girl's hip a few times, and''',
            '''smacks''', hisher(), '''own knee a few times as well.'''],
        ['''"Stay still," snaps''', p.PC.name + ".", HeShe(p.PC), '''lands half a dozen particularly hard, particularly fast slaps to the girl's dancing bottom.''',
            '''"Or I'll pull out my wooden spoon."'''],
        ['''Before the girl has a chance to respond, Adrian comes flying through the air and rolls across the counter, coming to rest next to the two Taironans. He looks''',
        '''at''', name() + ",", '''and at''',
            hisher(), '''opponent, draped across''', hisher(), '''lap. His eyes bug out of his head.  "What in the Mother's name are you doing?" His roar makes''',
            p.PC.name, '''jump, nearly knocking the girl off''', hisher(p.PC), '''lap. "My guild is under attack, Vengadores are probably raiding my armory and''',
            '''you're spanking a defeated opponent?" He points to a door on the north side of the building. "Get your ass up and defend my guild, or I'll put you''',
            '''over my knee, and won't let you up until new year's!"'''],
        ['''"Yes-"'''],
        ['''Adrian's enemy flies out of the hole in the wall and slams into him. The two roll across the room, punching and hacking.'''],
        [p.PC.name, '''pulls the young rebel off''', hisher(p.PC), '''knee, and guides her over to a small corner of the room, near the door into the back of the guild.''',
        p.PC.name, '''sit her down on the floor, hard enough to make her yelp.'''],
        ['''"Stay here," says''', p.PC.name + ".", '''"Understand?"'''],
        ['''The girl nods, rubbing her bottom and wincing.'''],
        ['''"Good."''', p.PC.name, '''throws open the door, and charges into the back of the guild.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
sternLowerTrousers.quip_function = sternLowerTrousers_qf

sternBentOver.comment = "Bend her over."
sternHand = Node(203)
sternSpoon = Node(204)
sternBentOver.children = [sternHand, sternSpoon]
def sternBentOver_qf():
    sternBentOver.quip = universal.format_text([['"' + p.PigCow(p.PC), '''huh?"''', p.PC.name, '''(none too gently) bends the girl over and wraps''', hisher(p.PC), '''arm around her''',
        '''lower back, holding her tight against''', hisher(p.PC), '''hip. The girl tries to struggle, but she can barely stand, let alone fight off''', name() + "."],
    ['''"Let go of me!" she wails, her cry almost lost in the din of battle. "Or so help me I'll gut you!"''']])
sternBentOver.quip_function = sternBentOver_qf

sternHand.comment = "Give her a hand spanking."
def sternHand_qf():
    sternHand.quip = universal.format_text([['''"Nice bluff, but I call."''', p.PC.name, '''starts smacking the young woman's small bottom,''', hisher(p.PC), 
        '''hand alternating''','''rapidly between cheeks.'''],
        ['''The girl yelps and twists, her hips rocking back and forth. She pounds her fist weakly against the older Taironan's thigh with one hand, while trying''',
            '''to break''', p.PC.name + "'s", '''grip with the other.'''],
        ['''"The more you squirm, the harder I'll going to spank you," says''', p.PC.name + ",", '''giving her a particularly hard slap to her right sitspot.'''],
        ['''"Let go of meee!" wails the girl, stomping the ground with both feet. "I better not catch you walking alone in the-oww!"'''],
        [p.PC.name, '''increases the force and tempo of the spanking, and the girl's threats quickly degenerate into wails of rage (and pain. Mostly pain).'''],
        [p.PC.name, '''takes a breath, and tries to decide whether the girl's had enough, or if''', heshe(p.PC), '''should yank the girl's pants down or bust out the''',
            '''spoon. Before''', name(), '''can come to a decision, Adrian's opponent sails by, her flailing legs nearly cracking''', p.PC.name, '''in the skull. The''',
            '''woman hits the ground and rolls, springing to her feet. Adrian bursts in, and notices''', p.PC.name, '''standing in the middle of the room with''', 
            hisher(p.PC), '''opponent under''', hisher(p.PC), '''arm.'''],
        ['''"What are you doing?" he roars. He points towards the door in the northeast corner of the room. "Get your ass down there and stop them from raiding-"''',
        '''His opponent holds up a hand, and unleashes a torrent of flame. Adrian blocks the blast with his forearm, the vicious burns healing as quickly as they''',
             '''form. His opponent dashes towards him, her blade weaving a mesmerizing dance. Adrian kicks the woman in the shin, and gives''', p.PC.name, '''one''',
             '''last glare. "The armory! Get moving!"'''],
        [p.PC.name, '''nods quickly, and drags''', hisher(p.PC), '''opponent into the corner, sitting her down hard enough to make her yelp. "You stay right here. If I''',
            '''come back and find out you tried to get involved in the fighting again, I will pull your pants down and paddle your bare bottom right here in front of''',
            '''the gods and everybody. Are we clear?"'''],
         ['''The girl nods morosely, rubbing her tender bottom.'''],
         ['''"Good."''', p.PC.name, '''takes a deep breath, and dashes into the back of the guild."''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
sternHand.quip_function = sternHand_qf

sternSpoon.comment = "Spank her with the wooden spoon."
def sternSpoon_qf():
    sternSpoon.quip = universal.format_text([['''"Oh dear are you ever going to regret saying that," says''', p.PC.name + ".", p.PC.name, '''reaches back and, with an''',
        '''impressive''',
        '''show of flexibility, pulls''', hisher(p.PC), '''wooden spoon out of a side pocket of''', hisher(p.PC), '''pack.''', HeShe(p.PC), '''adjusts''', hisher(p.PC), 
        '''grip, and taps the round head of the spoon against the girl's bottom.'''],
        ['''"What's that?" askss the girl nervously.'''],
        ['''"A wooden spoon my nana used to use on me," says''', p.PC.name + ".", '''"She gave it to me as a gift when I left home. You should be proud. Yours is only''',
        '''the second bottom to feel its sting."'''],
        ['''"No wait-oww!" The girl bounces in''', p.PC.name + "'s", '''grip as the older Taironan cracks the flat of the spoon against the girl's left cheek. "You''',
            '''wouldn't be so tough if I-"'''],
        ['''"Were tougher?"''', p.PC.name, '''cracks the spoon against the young woman's right cheek, drawing a squeal. "That is usually how toughness works."'''],
        [p.PC.name, '''briskly paddles the girl's bouncing bottom. The girl kicks and squirms. She alternates between inefectually pounding''',
            names(), '''calf, and trying (equally inefectually) to trip''', p.PC.name + "."],
        ['''"Have we learned our lesson yet?" asks''', p.PC.name + "."],
        ['''"Suck off the Father!' howls the girl through her tears.'''],
        ['''"Apparently not," says''', p.PC.name + ".", '''Before''', heshe(p.PC), '''can do anything about it, Adrian dashes into the main room. He spins back to face''',
            '''the hole in the wall, then ducks a thrown butcher knife. He flings a column of fire into the hole, and is rewarded with a scream of pain. He glances''',
            '''over his shoulder at''', p.PC.name + "."],
        ['''"What are you doing?" he roars. "My guild is being attacked, my armory likely being raided, and you're spanking your opponent?" He points to the''',
            '''northeast. "Get your ass down there and stop them from stealing all our weapons, or I'll thrash you so hard just the thought of sitting will make''',
            '''you burst into tears!"'''],
        ['''Then, his opponent (her clothing more than a little charred) sprints into the room and swings her blade at his head.'''],
        ['''Adrian ducks the swing, and his attention is once more consumed by his opponent.'''],
        [name(), '''quickly pulls the girl into the northeast corner of the room, and plops her down next to the door. The girl winces as her sore bottom smacks into''',
            '''the wooden floor.'''],
        ['''"You stay right here," says''', p.PC.name + ",", '''pointing a finger at her. "Or I will pull those trousers down and paddle your bottom until either my''',
        '''spoon breaks, or your bottom falls off, which ever comes first. Get it?"'''],
        '''"Fine," mutters the girl, crossing her arms and looking away.''',
        [p.PC.name, '''grimaces, but after a quick glance over''', hisher(p.PC), '''shoulder at Adrian (focusing in particular on the speed and precision with which''',
        '''he swings his blade), decides not to push it. Instead,''', heshe(), '''yanks open the door, and enters the back of the guild.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
sternSpoon.quip_function = sternSpoon_qf

spankCarlitaCruel.comment = '''"Well, that was pathetic. The Vengadores must be pretty desperate if they recruited you for slinger fodder."'''
def spankCarlitaCruel_qf():
    spankCarlitaCruel.quip = universal.format_text([['''The young woman shrinks away from''', name() + ",", '''her face crumpling. "You don't know what you're talking about.''',
        '''I'm going to be a powerful warrior, and save our people from the Matirians and their Potions. Ana told me so."'''],
    ['''"And you believed her?"''', name(), '''laughs mockingly. "Girl, this Ana was clearly just looking for expendable bodies to throw at us. If she really''',
    '''cared, she'd have given you something approximating training before throwing you into a full-fledged battle."'''],
    '''"Leave me alone," mutters the young woman, starting to drag herself away.''',
    ['''"Oh I don't think so," says''', name() + ",", '''grabbing the girl's hips. "Not until I've spanked the stupid out of you."''']])
spankCarlitaCruel.quip_function = spankCarlitaCruel_qf
cruelOTK = Node(205)
cruelSit = Node(206)
spankCarlitaCruel.children = [cruelOTK, cruelSit]

cruelOTK.comment = "Turn her over the knee."
def cruelOTK_qf():
    add_keyword('cruel_to_Carlita')
    cruelOTK.quip = universal.format_text([[name(), '''looks around, and spies a heavy wooden chair. Grinning sadistically,''', heshe(), '''drags the young woman towards the''',
        '''chair.'''],
    ['''"No, let go of me!" screeches the woman, clawing at the wooden floor. "No, stop stop! Please!''' + 
        (universal.format_text([[''' You've already spanked me once! Isn't that enough?"'''], ['''"Nope."''']]) if 'spanked_young_insurgent' in keywords() else '"')],
    ['''Once''', name(), '''reaches the chair,''', heshe(), '''grabs the girl's arms, yanks the girl around, plops downs in the chair, and tugs the''',
        '''girl over''', hisher(), '''lap.'''],
    ['''"No, no no! Let go, let go!" The girl flails desperately as she goes over, at one point smacking''', name(), '''in the face.''']])
cruelOTK.quip_function = cruelOTK_qf
cruelBare = Node(207)
cruelSpoon = Node(208)
cruelOTK.children = [cruelBare, cruelSpoon]

cruelBare.comment = "Pull down her trousers"
def cruelBare_qf():
    cruelBare.quip = universal.format_text([[name(), '''rubs''', hisher(), '''cheek and scowls down at the girl.''', HeShe(), '''grabs the back of the girl's trousers, and yanks them''',
        '''down to her knees, drawing a wail from the girl. "You are so going to regret not going quietly over my knee."'''],
        [name(), '''raises''', hisher(), '''hand, and starts giving the naughty young woman a good, hard spanking. The young woman wiggles around on''', names(), '''lap and wails''',
        '''at the top of her lungs, but the older Taironan's hand doesn't slow. Before long, the Vengador's bottom has darkened nicely, and''', name(), '''can also''',
        '''make out hints of red beneath the young woman's brown skin.'''],
        ['''"Please stop," says the girl, her voice full of tears. "Please-oww!"'''],
        ['''"Now why would I do that?" asks''', name(), '''landing a sharp slap to the middle of the girl's left bum cheek. "You attacked me for absolutely no''',
            '''reason. Here I was, just minding my own business, trying to make a living. And. You. Attack. Me!"''', name(), '''punctuates the last four words with''',
            '''four hard slaps to the girl's sit spots.'''],
        ['''"I just want to help my people," wails the girl.'''],
        ['''"Well you're doing a terrible job of it," says''', name() + ".", HeShe(), '''unleashes a flurry of hard and fast slaps. At first the girl bucks and''',
        '''flails, but by the end, she's lying limply on''', name() + "'s", '''lap, sobbing quietly.'''],
        ['''"Now, have we learned our lesson?" asks''', name() + ",", '''absently rubbing''', hisher(), '''throbbing hand.'''],
        ['''The girl nods.'''],
        '''"Good-"''',
        ['''Adrian bursts into the room, wrestling with his opponent. He pivots, and flings the woman over his shoulder, grinning in satisfaction when she slams''',
        '''headfirst into another one of the Vengadores. He glances over at''', name() + ",", '''and his satisfied smile vanishes. "What are you doing?" he roars.''',
        '''He points to the northeastern door. "Stop wasting your time spanking a beaten opponent, get downstairs and protect my armory!"'''],
        [name(), '''jumps to''', hisher(), '''feet, knocking the girl onto the ground in the process.''', name(), '''quickly steps over her, and dashes for the''',
            '''northeastern door.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
cruelBare.quip_function = cruelBare_qf

cruelSpoon.comment = "Use the spoon"
def cruelSpoon_qf():
    cruelSpoon.quip = universal.format_text([['''"Right then," says''', name() + ",", '''rubbing''', hisher(), '''stinging cheek.''', HeShe(), '''grabs''', hisher(), '''pack,''',
        '''and pulls out the wooden spoon that Nana used to use on''', himher() + ".", '''"I was going to use my hand, but since you insist on fighting me..."''', 
        name(), '''gives the girl two''','''quick slaps with the wooden spoon, one on top of the other.'''],
        ['''The girl yelps, and tries to shield her bottom with her hands.''', name(), '''pins her hands to her lower back, and gives her another four sharp smacks.''',
        '''"That was for trying to shield your bottom."'''],
        ['''"Stop this!" cries the girl, starting to sob. "You have no right!"'''],
        ['''"Sorry brat, but you deserve every smack."''', name(), '''peppers the girl's backside, the spoon roaming from the top of her cheeks to the crease where''',
            '''bottom meets thigh, and back up again.'''],
        ['''Throughout it all, the girl bucks and shrieks, her legs kicking frantically.'''],
        [name(), '''pauses for a moment, and rubs''', hisher(), '''slightly aching shoulder. Then''', heshe(), '''reaches down, and hook the back of the girl's trousers''',
            '''with''', hisher(), '''fingers. The young Taironan starts to wail again, but before''', name(), '''can yank the trousers down, Adrian crashes into''',
            '''the room. He skids across the counter, and lands in a heap at''', names(), '''feet.'''],
        ['''Almost as soon as he lands, he's back on his feet, and throwing a flurry of small red sparks back the way he came.  There is a series of crackles, and''',
        '''a cry of pain. He glances down at''', name() + ",", '''and his eyes bug out of his head. "What are you doing?" he roars, the force of his voice nearly''',
        '''knocking the novice adventurer over. He points to a door in the northeast. "My guild is being raided, and you're sitting here spanking an already defeated''',
        '''opponent? Get your ass downstairs and defend my armory, or I'll use that spoon on you!"'''],
        ['''"Yes sir," says''', name(), '''quickly, rolling the girl off''', hisher(), '''lap, slinging''', hisher(), '''pack back over''', hisher(), '''shoulder, and''',
            '''dashing towards the northeastern door.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
cruelSpoon.quip_function = cruelSpoon_qf

cruelSit.comment = "Sit on her."
def cruelSit_qf():
    cruelSit.quip = universal.format_text([[name(), '''pivots around the Vengador's hips, so that''', heshe(), '''is straddling the young woman, facing towards her bottom.''',
        '''Then,''', name(), '''pushs the Vengador's legs out from under her, and plops down on her back, flattening the girl against the ground.'''],
        ['''The young woman gasps. "Hey, hey get off!"'''],
        ['''"I don't think so," says''', name() + ",", '''patting the girl's bottom. "Not until you've been thoroughly chastised for being an idiot."'''],
        ['''"You asshole!" screeches the young woman, squirming uselessly. "Get off!"''']])
cruelSit.quip_function = cruelSit_qf
cruelSitBare = Node(209)
cruelSitSpoon = Node(210)
cruelSit.children = [cruelSitBare, cruelSitSpoon]

cruelSitBare.comment = "Push down her trousers."
def cruelSitBare_qf():
    cruelSitBare.quip = universal.format_text([[name(), '''removes the bit of rope holding up the young woman's trousers, and slides them down about halfway down her thighs,''',
        '''revealing a small, caramel colored bottom.'''],
        ['''"Hey, what in the Mother's name are you doing?" cries the young woman, wiggling vainly beneath''', name() + "."],
        ['''"Everyone knows that spankings are most effective when administered on the bare," says''', name() + ",", '''patting the girl's right cheek. "And to be''',
        '''frank, you need a serious spanking."'''],
        ['''"Who are you to decide that?" says the young woman. She braces her knees against the ground, and tries to lift herself up.'''],
        ['''"Simple," says''', name() + ",", '''giving the girl's right cheek a sharp slap. "The fact that you're here, convinced that you could actually stand a''',
            '''chance against a seasoned adventurer, let alone a rank novice like me, indicates that someone has been seriously remiss in your education. And I, being''',
            '''the selfless person that I am, just cannot stand by and let this failure continue any longer."'''],
        ['''"In other words, you're a self-important busybody who can't mind''', hisher(), '''own business," mutters the young woman.'''],
        [name(), '''land three sharp slaps to the girl's bottom, two to her left cheek and one to her right.  "Don't you know it's never wise to insult someone whose''',
            '''about to tan your backside?"'''],
        '''"Bite me," snaps the girl.''',
        ['''"Think I'd rather spank you," says''', name() + ".", '''Bracing''', himselfherself(), '''with''', hisher(), '''left hand against the woman's hip,''', name(),
        '''raises''', hisher(), '''hand, and begins swiftly spanking the Vengador's bare bottom.'''],
        ['''The young woman squeals and pounds her legs against the ground. She squirms frantically, desperately trying to escape''', names(), '''punishing hand. But''',
        '''she is still tremendously weak from the battle, and''', name(), '''barely even registers her struggles.'''],
        [name(), '''pauses. "Looks like we have a squealer."'''],
        '''"Shut up," mutters the young woman.''',
        ['''"Ok."''', name(), '''resumes the spanking, sending the girl into another fit of kicking and squealing.''', name(), '''can't quite deny a sadistic smirk as''',
        heshe(), '''watches the young woman's jiggling bottom first darken, and then start to show a few hints of red.'''],
        ['''"Get off of me you fat-assed-" The insult ends in a particularly high-pitched screech as''', name(), '''leans over and land a series of particularly hard''',
            '''and fast slaps to the girl's sit-spots.'''],
        ['''Then, another fragment of the back wall shatters, and Adrian comes flying into the room. He half slides, half rolls across the ground and comes to rest''',
            '''next to''', name() + ".", name(), '''glances up at the two gaping holes in the wall, seeing a glimpse of what appears to be a kitchen.''', 
            '''Hopefully, that wall isn't required for structural soundness.'''],
        ['''"What are you doing?" roars Adrian, nearly causing''', name(), '''to jump off of the young woman. "My guild is being raided, and you're taking time to''',
        '''spank your opponent?" He points to the northeast. "Get your ass down to the second floor, and stop them from stealing our weapons!"'''],
        ['''"Yes sir," yelps''', name() + ",", '''jumping to''', hisher(), '''feet. As''', heshe(), '''runs for the door, Adrian's opponent bursts into the room, and''',
        '''fling a pair of knives at Adrian. Adrian flattens himself against the young Vengador, protecting her from any stray knives. Then he jumps to his feet,''',
        '''and charges his opponent, gouts of flame erupting from his fingertips. Then''', name(), '''is through the door and into a long hallway at the back of the''',
        '''guild.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
cruelSitBare.quip_function = cruelSitBare_qf

cruelSitSpoon.comment = "Use the spoon."
def cruelSitSpoon_qf():
    cruelSitSpoon.quip = universal.format_text([[name(), '''pulls off''', hisher(), '''pack, and rest it on top of the young woman's lower back.'''],
    '''"What are you doing?" asks the girl nervously.''',
    ['''"I'm going to spank you with a wooden spoon my nana gave me," says''', name() + ".", HeShe(), '''flips open a side pocket, and removes the worn wooden''',
        '''spoon. A slight shudder runs down''', hisher(), '''spine as''', heshe(), '''considers all the times''', heshe() + "'s", '''felt the sting of this''',
        '''particular implement. "Feel free to cry. It helps, trust me."'''],
    ['''"No, get off of me!" cries the young woman, flailing about underneath''', name() + ".", '''"Get off, get off!"'''],
    ['''"Nah," says''', name() + ".", HeShe(), '''taps the spoon lightly against the girl's right cheek. The young woman freezes, and her bottom clenches.'''],
        ['''"Come on now. Every novice knows that clenching your bottom only makes it worse. Wait, you're not from Concha are you? I hear they don't believe in''',
        '''spanking," says''', name() + "."],
    '''"Of course not," snaps the young woman. "What do you take me for?"''',
    ['''"A naughty girl who doesn't know how to get spanked properly."''', name(), '''snaps the wooden spoon against the girl's right cheek. The girl shrieks, her thin''',
    '''trousers clearly not protecting much more than her modesty.''', name(), '''lands six hard smacks to the girl's right cheek, focusing in particular on the''',
    '''middle of her bottom. The young woman wails her way through every smack, vainly trying to reach back to shield her bottom. Alas, her arms aren't long enough to reach''',
    '''around''', name() + "'s", '''thighs.'''],
    '''"Stop smacking me there!" cries the girl after the sixth smack.''', 
    ['''"What's that? You'd rather I spank your left cheek instead?" says''',  name() + ".", '''"Well, since you asked so nicely."'''],
    ['''"No, no-oww!" The girl bucks her hips desperately as''', name(), '''lays into her left cheek. Her legs scramble vainly at the ground, and she starts to''',
    '''sob.'''],
    [name(), '''starts alternating between cheeks, spreading a nice even sting across the girl's entire bottom.''', name(), '''even land a few sharp smacks to''',
        '''her thighs.'''],
    ['''"You sadistic-" The girl howls as''', name(), '''interrupts her insult with a particular hard smack to her lower cheek. However, before''', name(), 
        '''can properly address her attitude, Adrian sprints back into the main room, ducking and dodging thrown kitchen knives.'''],
    ['''He sees''', name() + ",", '''sitting on top of''', hisher(), '''opponent, a wooden spoon poised above the girl's bottom, and his face contorts with''',
        '''rage. "What are you doing?" he roars. "We're being raided, my armory is probably being robbed, and you're sitting here spanking your opponent? Get''',
        '''your ass up, and get yourself downstairs to protect the armory!" He points to the northeast. "Before I thrash you with that spoon!"'''],
    [name(), '''nods, and jumps to''', hisher(), '''feet, dashing for the northeastern door.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
cruelSitSpoon.quip_function = cruelSitSpoon_qf

spankCarlitaNice.comment = '''"Are you alright? I didn't permanently hurt you, did I?"'''   
def spankCarlitaNice_qf():
    add_keyword('nice_to_Carlita')
    spankCarlitaNice.quip = universal.format_text([[name(), '''tries to gently touch the girl's face, but the girl shrinks away.'''],
['''"What are you doing?" says the young woman. "One minute you're trying to gut me, the next you're worried about me?"'''],
[name(), '''raises''', hisher(), '''eyebrows. "To be fair, you attacked me, and I was just defending myself. If I'd realized how little training you've had, I'd have''',
    '''held back a little."'''],
['''The young pulls herself to her feet, her legs and arms shaking, and starts to limp towards the counter.'''],
['''"What are you doing?" asks''', name() + ",", '''putting''', hisher(), '''hands on''', hisher(), '''hips.'''], 
['''The girl reaches for her dagger.''', names(), '''hand snaps out and catches her wrist. She tugs vainly against the older''', manwoman() + "'s", '''grip. "Let go''',
'''of me."'''],
['''"What are you doing?" asks''', name(), '''again, much more sternly.'''],
['''"What does it look like?" says the young woman curtly. "I'm fighting for my people."'''],
['''"In the condition you're in? I think not," says''', name() + ".", '''"You'll just get yourself killed."'''],
['''"No, I'm fine, let go of me!" cries the young rebel, tugging more insistently on her trapped wrist. "I've gone easy on you because you're a Taironan, but I''',
    '''swear I'll gut you if you don't leave me alone."''']])
spankCarlitaNice.quip_function = spankCarlitaNice_qf
niceBentOverCounter = Node(211) 
niceStraight = Node(212)
spankCarlitaNice.children = [niceBentOverCounter, niceStraight]

niceBentOverCounter.comment = "Bend her over the counter."
def niceBentOverCounter_qf():
    niceBentOverCounter.quip = universal.format_text([[name(), '''shoves the wretched old dagger over the far side of the counter.'''],
    ['''The girl yelps and reaches for it, bending over the counter.''', names(), '''left hand snaps down, and pins her against the counter top.'''],
    ['''"Hey, let me up!" cries the girl, squirming fiercely. ''' +  ('''"Come on, you've already spanked me."''' if 'spanked_young_insurgent' in keywords() else '')],
    ['''"I am not going to let you get yourself killed," says''', name() + ".", '''"Even if I have to paddle your bottom to do it."'''],
    '''"Like it's any of your business anyway," mutters the girl.'''])
niceBentOverCounter.quip_function = niceBentOverCounter_qf
niceHand = Node(213) 
niceSpoon = Node(214)
niceBentOverCounter.children = [niceHand, niceSpoon]

niceHand.comment = "Administer a hand spanking."
def niceHand_qf():
    niceHand.quip = universal.format_text([[name(), '''lands four quick, sharp smacks to the seat of the young woman's trousers. "What were you thinking? You clearly have''',
        '''absolutely no combat experience, and less training. You could have been seriously hurt, or killed."'''],
        ['''"You're just jealous, because I'm not afraid of standing up for us," says the girl, glaring over her shoulder at''', name() + "."],
        ['''"Foolishness and courage are not the same thing."''', name(), '''administers half a dozen slaps to the girl's bottom, three to each cheek. The girl yelps''',
        '''and bounces against the counter. "Besides, how exactly would getting yourself killed help anyone? It certainly wouldn't help your mother."'''],
        '''"Ignorant moron," mutters the girl. "My mom's been dead for years."''',
        [name(), '''hesitates,''', hisher(), '''hand flexing uneasily.''', '''Then,''', heshe(), '''gives the girl's bottom a soothing rub. "You know? For all I''',
        '''know, my mother could be dead, too. She left when I was very young. Almost too young''',
            '''to remember."'''],
        '''For a moment, the girl doesn't respond. Then, she looks over her shoulder at''', name() + ".", '''"Was she an addict too?"''',
        ['''"Of course not!" snaps''', name() + ".", '''The girl tenses.''', '''"Actually, I don't know. Maybe. I mean, I didn't know what''',
            '''Potions were when she left. How would I have known if she were addicted? Maybe she was hiding it. Maybe that's why she left."'''],
        ['''Adrian stumbles into the room. His shirt is in tatters, and smears of blood criss-cross his chest. His own blade is practially coated in the stuff. He''',
            '''looks at''', name() + ",", '''taking in''', hisher(), '''opponent's position over the counter. "What are you doing?" he roars. "Stop spanking our''',
            '''enemies, and start stopping them from raiding our armory!"'''],
        ['''"But-"'''],
        ['''He points towards the northeastern door. "Get through there, get down to the armory, and stop them. Or you'll be the one bent over the counter."'''],
        ['''"Yes sir," says''', name(), '''quickly.''', HeShe(), '''pulls the young woman off the counter and quickly but firmly guide to the northeastern corner.''',
            '''"Stay here."'''],
        ['''"Why?" mutters the girl, crossing her arms over her chest and pouting.'''],
        ['''"Because I don't want you to get killed," says''', name() + "."],
        ['''The girl stares at''', name() + ",", '''apparently not quite sure how to handle''', names(), '''unexpected concern.'''],
        ['''"Please?" says''', name() + "."],
        ['''"Fine," mutters the girl. "I'll stay here."'''],
        ['''"Good," says''', name() + ".", HeShe(), '''opens the door to the northeast, and step into the back of the guild.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
niceHand.quip_function = niceHand_qf

niceSpoon.comment = "Use the spoon."
def niceSpoon_qf():
    niceSpoon.quip = universal.format_text([[name(), '''reaches back, and manages to inch the wooden spoon out of the side pocket of''', hisher(), '''pack.''', HeShe(), 
        '''taps it lightly against the girl's bottom, causing her to tense. "Now look, you don't want to tense up like that, it will only make it hurt worse."'''],
        ['''The young woman tries (in vain) to break free. "Let go of me. Who died and gave you the right to spank me?"'''],
        [name(), '''sighs. "Do you know what the hardest spanking I ever got from my Nana was for?"'''],
        ['''"Of course I know," says the girl sarcastically. "I know everything there is to know about random''', menwomen(), '''I didn't even know existed until''',
            '''today."'''],
        [name(), '''gives the girl's left cheek a stinging smack with the spoon. "I was climbing a very difficult cliff, well above my skill. Several times''',
        '''I slipped and fell, breaking an arm at one point, spraining my ankle at another. Even broke my back."''', name(), '''smacks the girl's bottom four times.'''],
        ['''The girl hops up and down, and cries out, her hips rocking back and forth.'''],
        ['''"So naturally, my health was being severely drained," says''', name() + ".", '''"Now, I'd been trained to recognize when my health is running low. There''',
            '''are warning signs, but I was determined to scale that cursed cliff, so I ignored them."'''],
        [name(), '''administers six hard smacks to the girl's sit spots, making her squeal and buck against the counter. "Finally, I slipped the last time and broke''',
        '''both my ankles. Badly. One of them healed, but it healed crooked. The other didn't heal at all. And it hurt."'''],
        [name(), '''lands three rapid smacks to the girl's left cheek, then three to her right. "I bound my ankle, and dragged myself back to town. I ran into my''',
            '''Nana right in the town square. She'd been looking all over for me, and was just getting ready to head out into the mountains to look there.''',
            '''Fortunately, Nana is quite skilled at healing. She managed to spark my health, and reset my crooked ankle. Then, she upended me over her knee, bared''',
            '''my bottom, whipped out this very spoon and paddled me right there in the middle of the town square. And what a paddling. Never been spanked that hard''',
            '''before or since."'''],
        [name(), '''administers four good hard smacks to the girl's bottom. The girl howls and flails about on the counter, her body twisting sinuously. "And she''',
            '''told me that stupid is bad enough."''', name(), '''lands a particularly hard smack to the girl's right cheek. "Dangerous is bad enough."''', name(),
            '''cracks her hard on the left cheek. "But you went so far beyond both there isn't a word to describe it."''', name(), '''gives the girl four hard and''',
            '''fast slaps, two to each cheek.'''],
        ['''The girl bounces against the counter, her hips pressing desperately against it. She howls, and tears flow freely down her face. "Please, I'm sorry,''',
            '''I'm sorry. Stop, stop!"'''],
        [name(), '''puts away the spoon, and gives the girl's bottom a gentle rub. "I just don't want to see any pointless death, alright?"'''],
        ['''Adrian stumbles into the room, slapping out a fire that is eating at his shirt sleeve. He glances over at''', name() + ",", '''and his eyes widen.''',
            '''"What are you doing?" he roars.''',  name(), '''jumps. "We're being raided, and you're standing there spanking your opponent? Get your ass through''',
            '''that door," he points at the northeastern door. "And stop them from raiding my armory, or so help me I will thrash you from now until the day after''',
            '''eternity!"'''],
        [name(), '''nods quickly.''', HeShe(), '''takes the girl, and drags her towards the northeastern corner.''', name(), '''sets her down in the''',
            '''corner next to the door. The girl hisses as her tender bottom touches the floor. "Stay here, and try to stay out of trouble."'''],
        ['''The girl rubs her bottom, and nods. "Yes''', sirmaam() + '."'],
        ['''"Good."''', name(), '''turns and fling open the door, striding into the back of the guild.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
niceSpoon.quip_function = niceSpoon_qf  

niceStraight.comment = "Spank her standing."
def niceStraight_qf():
    niceStraight.quip = universal.format_text([[name(), '''steps behind the younger Taironan, and wraps''', hisher(), '''left arm around the girl's shoulders, pulling her away''',
        '''from the counter.'''], 
    ['''"Let go of me!" howls the girl, kicking and twisting in''', name() + "'s", '''grip. She grabs''', names(), '''forearm, and tries to pull it off, to no avail.''',
    '''"I'll kill you, you hear me? Traitorous shit!"''']])
niceStraight.quip_function = niceStraight_qf
niceStraightTrousers = Node(215) 
niceStraightBare = Node(217)
niceStraight.children = [niceStraightTrousers, niceStraightBare]

niceStraightTrousers.comment = "Spank her over her trousers."
def niceStraight_qf():
    niceStraightTrousers.quip = universal.format_text([['''"Watch your language," says''', name() + ",", '''landing three hard smacks to the girl's bottom. The girl's hips buck''',
    '''forward beneath the smacks, and she cries out. "I don't care what the Vengadores told you. Things are not as simple as 'us vs. them'."'''],
    ['''"Just what I'd expect a traitor to-oww!" The girl howls as''', name(), '''lands six hard and fast slaps to her bottom.'''],
    ['''"Look, I've never done anything that could be considered remotely harmful to other Taironans," says''', name() + ".", HeShe(), '''lands two particularly''',
        '''hard smacks to the girl's bottom. "And I will not stand here and listen to you suggest otherwise. Are we clear?"'''], 
    '''"This seems pretty harmful!" whines the girl.''',
    [name(), '''land another string of smacks to the young woman's bottom. The girl bounces up and down on the balls of her feet, yelping and squirming. "Paddling a''',
    '''naughty girl for spending far too much time daydreaming about being a hero, and far too little thinking through the consequences of her actions is not''',
    '''harmful."'''],
    ['''"I don't want to be a hero," says the girl. Her body sags in''', names(), '''grip, and her shoulders start to shake. "I just, nobody else is helping us.''',
        '''Nobody cares about us. We're just''',
    '''thugs and addicts stinking up their precious city."'''],
    [name(), '''sighs.''', HeShe(), '''gently turns the girl around, and looks her in the eye. "So you're going to prove them wrong by proving them right?"'''],
    '''"I just don't know what to do," says the girl quietly.''',
    ['''"Hush", says''', name(), '''pulling the girl into a hug. "We'll-"'''],
    ['''Adrian's opponent sprints into the room, Adrian hot on her heels.  She spins around, just in time for Adrian to kick her''',
        '''in the face. While the woman reels, Adrian, who has somehow managed to lose his sword, grabs her, pivots, and slams her through the counter. He glances''',
        '''over his shoulder, and notices''', name(), '''holding the young woman. His face contorts with rage. "What the hell are you doing?" he roars. "These''',
        '''people are raiding my guild, and you're hugging one of them? Get your ass downstairs, and stop them from stealing all of our weapons, or I'll paddle''',
        '''you every day for a month!"'''],
    [name(), '''jumps, and nods quickly. "Yes sir!"'''],
    [name(), '''leads the young woman to the northeast corner. "Look, stay here, and try to stay out of trouble. I don't want you killed."'''],
    ['''The young woman nods, wiping at her tears. "Still think you should be helping us."'''],
    ['''"Well, now's not the time for making those kinds of decisions," says''', name() + ".", name(), '''throws open the door into the back of the guild, and after''',
        '''taking a deep breath, charges through it.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
niceStraightTrousers.quip_function = niceStraight_qf

niceStraightBare.comment = "Spank her bare."
def niceStraightBare_qf():
    niceStraightBare.quip = universal.format_text([[name(), '''reachs around the young woman's hip and removes the frayed rope she uses as a belt.'''],
    ['''"Oh no," says the young woman, bucking and twisting weakly in''', names(), '''grasp. "I know what you're doing. Stop, stop stop."'''],
    ['''"I hate to do this," says''', name() + ".", '''"But spankings are best administered on the bare."'''],
    ['''"Who died and gave you the right to spank me?" cries the young woman. She awkwardly kicks her leg back, likely trying to catch''', names(), '''shin. However,''',
    name(), '''easily dodges those kicks that come close enough to require dodging.'''],
    ['''"You're just making it worse for yourself, you know," says''', name() + ".", name(), '''grabs the young woman's trousers, and pushes them down past her hips,''',
    '''where they slide the rest of the way to her ankles, revealing a small, heart-shaped bottom.''', name(), '''starts to land quick, stinging slaps to''',
    '''the bare cheeks.'''],
    ['''The girl yelps and weaves her hips in a desperate attempt to avoid''', names(), '''iron-hard hand hand.'''],
    ['''"Hold still," snaps''', name() + ",", '''after missing for the third or fourth time. "Or I'll pull out my spoon."'''],
    ['''The girl's bobbing slows, and''', name(), '''really lays into it. The girl wails, and pushes her bottom forward beneath the smacks. "Why are you doing''',
        '''this?"'''],
    ['''"Because you shouldn't be here, fighting some stupid guerilla war against Avaricum," says''', name() + ",", '''landing a series of hard smacks to her lower''',
        '''right cheek. "You should be, I don't know, flirting, and working and living."'''],
    ['''"You don't know anything," sobs the girl.'''],
    ['''Then, Adrian bursts into the room, twisting and unleashing a trio of small glowing spheres back towards the large hole in the wall. The three spheres''',
    '''collide with his opponent, just as she enters the room. She shrieks in pain, and collapses, her body smoking.'''],
    ['''Adrian takes a quick glance around the room, and notices''', name(), '''and''', hisher(), '''opponent. "What are you doing?" he roars. "My guild is being''',
        '''raided, and you're spanking your opponent?" He points to the northeast. "Get your ass downstairs and stop them, before I paddle you from now until a day''',
        '''after eternity!"'''],
    ['''"Yes sir!" yelps''', name() + ".", name(), '''quickly drags''', hisher(), '''opponent into the northeastern corner of the room, and forces her to sit. She''',
        '''winces slightly when her tender bottom touches the wood, and quickly yanks her pants up. "Stay here. I don't want you getting killed."'''],
    ['''The young woman crosses her arms and looks away.'''],
    ['''"I mean it," says''', name() + "."],
    ['''The girl eyes''', name(), '''carefully. "Fine. Not like I can do much to help anyway." She winces again, and shifts her weight. "You made that abundantly''',
        '''clear."'''],
    ['''"Good."''', name(), '''turns, throws open the door, and enters the back of the guild.''']])
    return (universal.acknowledge, (dungeonmode.dungeon_mode,))
niceStraightBare.quip_function = niceStraightBare_qf    

def start_scene_2_episode_1(loading=False):
    carlita.litany = spankCarlita
    if not loading:
        music.play_music(INTENSE, 500)
    if not loading:
        universal.say(universal.format_text([['''The door bursts open and over a dozen heavily armed, masked warriors''',
        '''in ragged clothing charge into the guild. Only their dark eyes, and a bit of brown skin''',
        '''are exposed.''', 
        '''Adrian has a sword in his hand before the door finishes slamming open. Cries of''',
        '''surprise fill the room, followed by the''',
            '''clatter of drawn weapons, knocked over tables, and flung chairs.'''],
        ['''For a moment, there is tense silence. Then, one of the masked warriors, a man, steps forward. "We are the Vengadores. We fight''',
        '''to free Taironans from the scourge of the Avaricumites and their Potions."'''],
        '''"I'm sure your mother's very proud," says Adrian in a tight voice. "Now get out of my guild."''',
        '''The Vengador points at Adrian. Sparks dance across his fingertips. "We are here for your arms and armor. Surrender them peacefully, and no one will be hurt."''',
        '''"No," says Adrian.''',
        '''A bolt of fire erupts from his fingertip and arcs towards Adrian, who throws his own hand up. Just before the firebolt strikes, his hand flares with blue light. When the light fades, the firebolt is gone.''',
        ['''\mThe Vengadores scatter through the room, engaging the heavily outnumbered''',
        '''adventurers.''',
            '''The only swordswoman in the group locks eyes with''', p.PC.name + ".", '''She twists around a charging adventurer,''',
            '''and sprints towards''', himher(p.PC) + ".", '''The young Taironan starts to scramble''',
            '''backwards, only to bump into the counter.''', HeShe(p.PC), '''fumbles for''', 
            hisher(p.PC), '''weapon. As soon as the Vengador gets in range,''', name(), '''lunges forward with a desperate thrust. The woman smoothly sidesteps''',
            '''the thrust, hooks''', names(), '''arm under her own, pivots the younger Taironan around, bends''', himher(), '''over the counter, and lands two sharp''',
            '''slaps to''', p.PC.clad_bottom() + " with the flat of her blade."],
                [name(), '''yelps, and twists around to glare at the masked Taironan. The Taironan shakes her finger at''', name() + ".", '''Though''', name(), '''can't be sure, it seems like the woman is smirking.'''],
            ['''Then, a bright golden cord wraps''',
                '''itself around the swordswoman's waist. Adrian stands on top of the counter, the magic''',
                '''cord gripped in both hands.''',
            '''"Leave the new''',  boygirl(), '''alone."''','''He snaps the cord back, and the woman flies towards him.''',
            '''Adrian ducks her out-thrust sword, grabs her by the wrists, pivots, and flings''',
            '''her through the wall. He raises his sword, jumps off the counter, and charges''',
            '''after her, screaming a battle cry.'''],
            ['''A short, painfully thin, masked woman runs towards''', p.PC.name + ".", 
                '''She is wearing a battered leather breastplate''',
                '''that is two sizes too big for her, and a pair of trousers with a massive''',
                '''hole in the left knee, and half the right pant leg missing completely.''',
                '''She clutches an old, heavily nicked dagger. Her hand is shaking, but her eyes are filled with grim''',
            '''determination.''', p.PC.name, '''readies''', hisher(p.PC), '''weapon.''']]), justification=0, music=[CATALIN])
    adventurersGuild.add_character(carlita)
    def after_fighting_carlita(allies, enemies, won):
        carlita.restores()
        music.play_music(CARLITA)
        conversation.converse_with(carlita, townmode.town_mode)
    if not loading:
        universal.acknowledge(combat.fight, carlita, after_fighting_carlita, townmode.town_mode, False)

#----------------------------------------Episode 1 Dungeon-------------------------------------------------------
def e1_0_4():   
    if 'visited_back_of_guild' not in keywords():
        add_keyword('visited_back_of_guild')
        universal.say_title('Back of Guild')
        music.play_music(INTENSE)
        universal.say(universal.format_text([[name(), '''enters a long, dim corridor with wooden walls, and a wooden floor. There are four doors, two on each side, regularly spaced''',
        '''down the''',
        '''hallway. All of the doors are ajar, and three of them are hanging from one hing. The deafening sounds of battle echo throughout the building. Despite the''',
        '''chaos,''', name(), '''can't help but take a minute and be amazed at just how filthy rich Adrian must be to afford such a large building. He must be''',
        '''charging exhorbitant prices to keep''',
        '''this''',
        '''thing viable.'''], 
        [names(), '''musings are interrupted by a piercing scream to''', hisher(), '''right, and by yelps of pain to''', hisher(), '''left.''']]))
        universal.acknowledge(backOfGuild.display, ())
    else:
        backOfGuild.display()
def e1_2_3():
    universal.say_title('Guild Kitchen')
    cookText = universal.format_text([[name(), '''enters a large kitchen.  There are two long, waist-high stone counters in the middle of the room. The''',
        '''counters are''',
        '''covered in blood, heavily singed, missing bits of stone, and are even coated in ice in some places. Pots, pans, and various cooking utensils are''',
        '''scattered about the floor. There are two gaping holes''',
        '''in the southern wall, through which''', name(), '''can see the raging melee. Two massive ovens line the far wall.  Directly to the west, between''', name(),
        '''and the ovens, is a tall, muscular, golden-haired, fair-skinned woman, likely about the age of Adrian. She is wearing an apron, a short-sleeve tunic,''',
        '''trousers, and a heavy pair of boots.'''],
        ['''Bent over the counter, her skirt around her ankles, and her round, protruding bottom exposed to the air, is a Taironan woman about''', names(), '''age.''']])
    if not 'Ildri_event' in keywords():
        cookText = universal.format_text([cookText, ['''The cook is vigorously paddling the young woman's bottom with a wooden spatula. The woman is kicking, flailing, and''',
            '''howling at the top of her lungs.'''],
        ['''"How dare you attack my kitchen like this. You want to harass Adrian, fine. But you leave. My. Kitchen. Alone." The cook punctuates the last few words''',
        '''with several particularly hard smacks to the woman's sitspots. The Taironan pounds her toes against the counter and wails.''']])
    universal.say(cookText)
    universal.acknowledge(backOfGuild.display, ())
def e1_2_1():
    universal.say_title('The Cook')
    if 'Ildri_event' in keywords():
        cookText = universal.format_text([['''The raider is still bent over the counter, and her bottom is still bare. However, the cook has stopped spanking her,''',
        '''and is now having a quiet conversation with the girl. Considering how hard the cook spanks,''', name(), '''decides to leave them be.''']])
    else:
        add_keyword('Ildri_event')
        lc = p.PC.lower_clothing() 
        underwear = p.PC.underwear()
        if lc == emptyLowerArmor:
            lc = p.PC.underwear()
        cookText = universal.format_text([['''As soon as''', name(), '''get within arm's reach, the cook spins and grabs''', himher(), '''around the elbow. "One of this brat's''',
        '''buddies I take it?"'''],
        ['''The next thing''', name(), '''knows,''', hisher(), '''pack is on the floor,''', heshe() + "'s", '''bent over the counter next to the raider''']])
        if lc.armorType == items.Skirt.armorType or lc.armorType == items.Dress.armorType:
            cookText += universal.format_text([[''', and''', hisher(), lc.name, '''is hiked up around''', hisher(), '''waist, exposing''', hisher(), underwear.name + "."]])
        elif lc.armorType == items.Pants.armorType:
            cookText += universal.format_text([[''', and''', hisher(), lc.name, '''is pooled around''', hisher(), '''ankles, exposing''', hisher(), underwear.name + "."]])
        else:
            cookText += universal.format_text([[ ''', and''', hisher(), lc.name, '''is pooled around''', hisher(), '''ankles, exposing''', hisher(), '''bare bottom.''']])
        cookText = universal.format_text([cookText, ['''"Wait, wait I'm not a raider," yelps''', name() + ".", '''"I'm a member of the guild. I joined literally just before''',
        '''the attack!"'''],
        '''"A likely story," says the woman. "Do you have any proof?"'''])
        if itemspotionwars.whiteRibbon in inventory():
            cookText = universal.format_text([cookText, ['''"In my pack, there's a white ribbon. Healer Paloma gave it to me for helping her," says''', name() + "."],
            [name(), '''feels''', hisher(), '''pack get set on''', hisher(), '''back, and then feels it shift around while the cook roots through it.'''],
            [name(), '''notices some movement out of the corner of''', hisher(), '''eye. The other girl is trying to slip away. The sharp crack of hand to flesh''',
                '''echoes through the kitchen, and the girl is back fully bent over the counter.'''],
            ['''"Uh-huh," says the cook. "Your spanking isn't over yet young lady. Ah! Here it is. Well, it definitely has Paloma's print on it. Feels''',
                '''legitimate. No hidden markers indicating duress. Alright, I guess I'll believe you."'''],
            ['''"Thank you," says''', name(), ''', starting to slide off the counter.''']])
            if lc.armorType == items.Underwear.armorType:
                cookText = universal.format_text([cookText, ['''But then the woman's heavy hand comes down on''', names(), '''lower back, pinning''', himher(), '''firmly to''',
                '''the counter. "Hang on there, young''', manlady() + ".", '''Just because you're not a raider, doesn't mean you don't need a proper spanking."'''],
                ['''"What do you mean?"''', names(), '''voice squeaks, to''', hisher(), '''abject humiliation. "I haven't done anything."'''],
                ['''"It's less what you've done, and more what you're not wearing," says the cook. Her heavy boots tug gently on the''', underwear, '''currently''',
                    '''clumped around''', names(), '''ankles. "I can't help but notice that you're running around in nothing but your underwear. Care to explain why''',
                    '''you didn't bother putting on some pants this morning?"'''],
                [name(), '''laughs uneasily. "Oh that, well, I uhh, it's kind of funny-"'''],
                ['''A hard, callused hand collides with''', names(), '''right cheek. The hand starts low and snaps up across''', hisher(), '''cheek, lifting''', 
                    hisher(), '''hips slightly off the counter. A horrific sting flashes across''', hisher(), '''bottom.''', name(), '''squeals, grabs the far edge''',
                    '''of the counter, and paws at the ground with''', hisher(), '''feet. Madre's mercy, what is this woman made of? Iron?'''],
                '''"Stop hedging and answer the question,' says the cook sternly.''',
                ['''"I hate sewing," admits''', name() + ".", '''"And you know, fighting has a tendency to damage one's clothing. So..."'''],
                ['''"In other words, having less work to do is more important to you than your decency," says the cook. The woman's hand cracks against''', names(),
                    '''left cheek.''', name(), '''squeals and bucks''', hisher(), '''hips against the counter.''', HeShe(), '''clutches the far edge of the counter''',
                    '''hard enoguh to make''', hisher(), '''fingers cramp.'''],
                ['''Over and over again, the cook's hard, large, callused palm strikes''', names(), '''bottom. Before long,''', hisher(), '''entire bottom is''',
                    '''throbbing, and''', name(), '''is not entirely certain it isn't literally on fire.''', name(), '''bucks.''', HisHer(), '''legs pound against''',
                    '''the counter, and''', hisher(), '''hips bounce up and down. Tears begin to slip down''', hisher(), '''face.'''],
                ['''The woman spanks''', name(), '''with a consistent rhythm. She never varies the frequency or strength of her slaps, regardless of how much''',
                    name(), '''struggles or howls. Eventually,''', name(), '''breaks down completely, sobbing while she pounds your bottom.''', name(), 
                    '''stops struggling, and slump against the counter. As if on cue, the barrage stops.'''],
                ['''"Do you have any idea how indecent this is?" asks the cook. She punctuates the question with a hard blow to''', names(), '''left sitspot.''',
                    '''"Or how silly it makes you look? Nobody is going to take you seriously if you can't even be bothered to cover yourself properly. And can''',
                    '''you imagine what would happen if people knew you were a member of our guild? Can you begin to comprehend how embarassing it would be for a''',
                    '''representative of our guild to be running around in''', hisher(), '''skivvies? What would our clients think?"'''],
                ['''"I'm sorry," says''', name(), '''through''', hisher(), '''tears. "I didn't think of that."'''],
                ['''Nothing happens for a moment. Then, the cook's large, callused, but suddenly gentle hand begins to rub small circles on''', names(), '''back. "So''',
                    '''are you going to go get yourself some proper clothing after this whole raid thing is over?"'''], 
                ['''"Yes ma'am."'''],
                ['''"I'll give you a full day's grace period," says the cook. "If after that I catch you running around in your''', p.underwearpanties(), '''like this''',
                '''again, I will throw you over my shoulder, carry you to Terry's Tailors and buy you some trousers myself. And I'll be spanking you the whole time.''',
                '''Clear?"'''],
                [name(), '''nods quickly.'''],
                '''"Alright," says the cook. "Now stand up, and get back to driving off this raid."''',
                [name(), '''slides off the counter, and (very gingerly) rubs''', hisher(), '''angry red bottom for a moment, before (very gingerly) pulling up''',
                    hisher(), p.underwearpanties() + ".", '''"Did you have to spank me now?"'''],
                ['''"Discipline should never be delayed," says the cook. She picks up her spatula and makes a shooing motion with it. "Now go."''']])
                increment_spankings_taken() 
                add_keyword('Ildri_no_pants')
            else:
                cookText = universal.format_text([cookText, ['''"Sorry for almost thrashing you like that," says the cook, shrugging. "Get a little overeager sometimes."'''],
                [name(), '''smiles (though the smile is a bit sickly), and can't help but glance at the thick, exceptionally painful looking spatula gripped in the''',
                '''cook's large fist, at her broad shoulders, and at her well-defined musculature.'''],
                ['''The cook returns her attention to the raider. She rubs her spatula against the girl's tender bottom. "Now where we? Oh yes, I was teaching you''',
                '''the importance of not raiding my kitchen."'''],
                ['''The sharp slap of wood on flesh, and the girl's accompanying howls follow''', name(), '''as''', heshe(), '''turns''', hisher(), '''attention back''',
                '''to business.''']])
        else:
            add_keyword('Ildri_spanked_you_unjustly')
            increment_spankings_taken()
            cookText = universal.format_text([cookText, ['''"Erm, well, no, not exactly," says''', name() + " uneasily."],
                '''Crack!''',
            [name(), '''shrieks as the heavy wooden spatula cracks against''', hisher(), '''left cheek.'''],
            ['''"Just as I thought," says the cook smugly. "Well, you won't be getting any of your silly little lies past me." She grabs''', name(), '''around''',
                '''the waist and pushes''', himher(), '''up against the raider, so that their bare hips and thighs are touching. Then, the cook''',
                '''leans over''', name(), '''and presses her long, thick arm across both their backs.'''],
            '''Crack!''',
            ['''The girl howls, and''', name(), '''can feel the counter shake as the girl kicks it. In fact,''', name(), '''is pretty sure''', heshe(), '''could''',
                '''feel the other Taironan's bottom ripple against''', hishers() + "."],
            ['''"Since you two are partners in crime, you should be partners in punishment."'''],
            ['''Crack!'''],
            ['''This time, it's''', name(), '''who shrieks. "No, wait, stop this isn't fair!"'''],
            ['''Unfortunately,''', names(), '''outburst gets''', himher(), '''nothing but a second, harder smack.'''],
            ['''The cook quickly settles into a rhythm, alternating between''', name(), '''and the Vengador.'''],
            ['''It isn't long before''', name(), '''begins to thrash and squirm on the counter, the cold stone quickly becoming damp with sweat and tears. However,''',
                '''despite''', names(), '''frantic thrashing, neither the cook's rhythm nor severity waver. Nor does she say anything. She just lets''', name(), 
                '''buck and kick beneath that horrible spatula.''', 
                 '''Several times''', names(), '''hand cracks against the girl's face, and several times the girl's hand smacks against''', names() + ".", 
                 '''However, both''',
                 '''Taironans are too caught up in the horrible burns in their bottoms to care. At some point, they begin to clutch each other, seeking comfort,''',
                 '''any comfort at all, beneath the cook's vigorous paddling.''', names(), '''universe narrows to two points: the horrific and ever-building burn''',
                 '''in''', hisher(), '''bottom, and the warmth of the girl's hands in''', hisher(), '''own.'''],
            ['''Dimly,''', name(), '''hears a crash, and something heavy lands on the counter next to''', himher() + ".", name(), '''glances over, and finds Adrian''',
                '''looking''', himher(), '''in the eye.'''],
            ['''"Why do you keep bursting into my kitchen?" roars the cook, waving her spatula in the air. "Haven't you and your playmate done enough damage''',
                '''already?"'''],
            ['''Adrian rockets to his feet. "Ildri what are you doing?"'''],
            ['''Ildri frowns. "I'm spanking a few raiders who attacked me-"'''],
            ['''Adrian jumps off the counter, and cracks the flat of his blade against Ildri's large bottom. Ildri yelps.''',
                '''"You idiot!" He points at''', name() + ".", '"' +  HeShe(), '''isn't a raider.''', HeShe() + "'s", '''one of us!"'''],
            ['''"Oh," says Ildri sheepishly, rubbing her bottom.'''],
            ['''Before Adrian can respond, his opponent sweeps into the room, and once again locks him in mortal combat.'''],
            ['''Ildri helps''', name(), '''get off the counter, and gives the young Taironan's bottom an apologetic rub. She also helps''', himher(), '''fix''', 
                hisher(),'''clothing. "Sorry. Guess I got overeager."'''],
            [name(), '''scowls at the cook as''', heshe(), '''rubs''', hisher(), '''scalding bottom. "Whatever, I need to go."'''],
            ['''"Err, yes, you do that," says Ildri.'''],
            ['''"Wait, don't leave me!" cries the raider, reaching out to''', name() + "."],
            ['''"Relax," says Ildri. She gives the girl's bruised bottom a gentle rub. "I'm done spanking you. Now, you and I are just going to have a little talk''',
                '''about what you're doing attacking a group that's done you no wrong."''']])
    universal.say(cookText, justification=0)
    universal.acknowledge(backOfGuild.display, ())
def e1_2_5():
    universal.say_title('Infirmary')
    healerText = universal.format_text([['''The infirmary is a large open space with about half a dozen cots scattered about it. Many of them have been upturned, and a few have''',
    '''holes in them. There are several Taironans slumped against one wall. A few have leaned their heads back against the wall, with their eyes closed. Others have''',
    '''curled into the fetal position, and still others sit with their heads hanging between their knees. All of them look on the verge of passing out (those who''',
    '''haven't already).''']]) 
    if not itemspotionwars.whiteRibbon in inventory() and not 'failed_to_help_Paloma' in keywords():
        healerText = universal.format_text([healerText, ['''Tied up on the opposite side of the room are people of a variety of descent, likely adventurers, who are also''',
        '''suffering from health fatigue.'''],
            ['''In the center of the room are three Taironan women, only two of whom are wearing masks. The unmasked one is bent over the edge of a cot, while the''',
            '''two masked ones are on''',
            '''opposite sides of her. The woman on the left, a rather short, voluptuous woman, is holding the bent over woman down against the cot.''',
                '''The other, a tall, broad-shouldered amazon, is standing over the other two with a worn leather belt held''',
                '''loosely in one hand. The woman in the middle looks to be between''', names(), '''age and Maria's. She has black, short-cut hair, and is wearing the standard white dress with''',
                '''red trim''',
                '''of a female member of the White Roses, a neutral order of healers. Her dress is hiked up over her waist, and her panties have been pulled down to her knees, revealing a round, jiggly bottom.''',
                '''Her bottom is streaked with several ugly welts, likely from the amazon's belt.'''],
    ['''The amazon raises her belt, and straps the healer with it, setting the other woman's cheeks bouncing. The healer howls and rocks her hips.'''],
    ['''"Don't like it? If you agree to help us we'll stop," says the amazon.'''],
    ['''The healer glares over her shoulder. There is a steely glint in her eyes, despite the tears. "Get buried."'''],
    ['''"Shame," says the amazon, snapping the belt down a second time.''']])
    else:
        healerText = universal.format_text([healerText, ['''Paloma moves about the injured adventurers, untying them and helping them to the various cots, and tending to any''',
        '''injuries that the adventurers' last dregs of health couldn't handle.''']])
    universal.say(healerText)
    universal.acknowledge(backOfGuild.display, ())

def e1_2_7():
    if itemspotionwars.whiteRibbon in inventory():
        universal.say_title('Paloma')
        universal.say(universal.format_text([['''Paloma smiles when''', name(), '''approaches. "Need a bit of healing? Guess I can spare a bit of energy for you." Paloma touches''',
            names(), '''forehead, and''', heshe(), '''feels an invigorating burst of power flow through''', himher() + "."],
        [names(), '''health and mana have been fully restored.''']]))
        p.PC.restores()
        universal.acknowledge(dungeonmode.dungeon_mode, ())
    elif 'failed_to_help_Paloma' in keywords():
        universal.say_title('Paloma')
        if 'get_ribbon' in keywords() and not itemspotionwars.whiteRibbon in inventory():
            universal.say(universal.format_text([['''"Well, I was sent to get a white ribbon-"'''],
                ['''"To mark you as one of our guild members?" says Paloma curtly. She sighs. "Well, I suppose you didn't act like a Vengador when''',
                    '''those two left. Alright, give me a minute."'''],
                ['''The healer goes to the back of the room, and pulls out a long white ribbon. She concentrates on it for a moment, then brings it''',
                    '''back to''', name() + ".", '''"Here you go. Also, might as well heal you while you're here."''']]), justification=0)
            p.PC.get_item(itemspotionwars.whiteRibbon)
        else:
            universal.say(universal.format_text([['''"What do you want?" snaps Paloma. She moves gingerly amongst the wounded, binding an arm here, checking a dagger wound there.'''],
                ['''"Well, you're a healer-" begins''', name() + "."],
                ['''"And you want me to heal you?" snaps Paloma. "Fine. Come here."'''],
                [name(), '''approachs, and the healer touches''', names(), '''forehead. A burst of strength flows through''', himher() + "."],
                ['''"Now get out of here," says the healer.'''],
                [names(), '''health and mana have been fully restored.''']]))
        p.PC.restores()
        universal.acknowledge(dungeonmode.dungeon_mode, ())
    else:
        paloma.litany = helpPaloma
        conversation.converse_with(paloma, dungeonmode.dungeon_mode)
helpPaloma = Node(219)
def helpPaloma_qf():
    add_keyword('met_Paloma')
    helpPaloma.quip = universal.format_text([['''Upon reaching the three woman, the amazon turns to''', name() + ",", '''and grins. "Ah, a fellow Vengador."'''],
    ['''"Are you sure''', heshe() + "'s", '''one of us?" asks the other.''', '"' + HeShe(), '''isn't wearing a mask."'''],
    ['''"''' + HeShe(), '''probably just lost it during the fighting," says the amazon.''', '"' +  HeShe(), '''doesn't look like any of the Taironans in the Guild."''',
    '''The amazon turns her attention back to''', name() + ".", 
    '''"Anyway, we found this sniveling traitor cowering in here, and tried to convince''',
    '''her to join us. You know, fight the good fight against the soulless bastards that run this city. And she refused! Can you believe it? We're''',
        '''being crushed under Avaricum's bootheel, and she just wants us to lie there and take it!"'''],
    ['''"I have no interest in helping a bunch of lawless butchers," says the healer, glaring up at the amazon.'''],
    ['''"See what we have to deal with?" asks the amazon, clearly exasperated. "Ah well, at the least we can give her a proper belting before we get out of''',
    '''here."'''],
    ['''"Please!" says Paloma twisting to look at''', name() + ".", '''Her face is flushed, and streaked with tears. "Help me! I haven't done anything to anyone.''',
    '''These two are just sadistic lunatics."'''],
    ['''The amazon growls, turns to face Paloma, and raises her belt.''']])
helpPaloma.quip_function = helpPaloma_qf
savePaloma = Node(220) 
hesitateToHelpPaloma = Node(221) 
failedToHelpPaloma = Node(222)
helpPalomaClever = Node(223)
helpPaloma.children = [savePaloma, hesitateToHelpPaloma, failedToHelpPaloma, helpPalomaClever]

savePaloma.comment = "Grab the amazon's wrist." 
spellSlinger = pwenemies.VengadorSpellslinger(p.FEMALE)
warrior = pwenemies.VengadorWarrior(p.FEMALE)
def savePaloma_qf():
    savePaloma.quip = universal.format_text([['''The amazon looks back at''', name() + ",", '''clearly surprised and annoyed. "What are you doing? This 'Taironan' deserves''',
        '''to have her cowardly bottom soundly thrashed, and you know it!"'''],
    ['''"Coward?" says''', name(), '''in a quiet, dangerous voice. "The only cowards I see here are a couple of naughty little girls who think they have the right''',
        '''to beat an innocent healer."'''],
    ['''The amazon sneers, and shoves''', name(), '''back a few steps. "Should have known you were a traitor too. Madre's love, this place is infested with''',
    '''them." The amazon snaps up her spear. "Come on. Let's show this''', bastardbitch(), '''what happens to traitors."''']])
    return (combat.fight, ([spellSlinger, warrior], save_the_healer, dungeonmode.dungeon_mode, False,False, True))
savePaloma.quip_function = savePaloma_qf

def save_the_healer(allies, enemies, won):
    if not won and not spellSlinger in enemies and not warrior in enemies:
        paloma.litany = palLost
        conversation.converse_with(paloma, dungeonmode.dungeon_mode)
        add_keyword('defeated_by_Palomas_Attackers')
    elif not won and spellSlinger in enemies:
        paloma.litany = palLostSlingerDown
        conversation.converse_with(paloma, dungeonmode.dungeon_mode)
    elif not won and warrior in enemies:
        paloma.litany = palLostWarriorDown
        conversation.converse_with(paloma, dungeonmode.dungeon_mode)
    else:
        victoryText = universal.format_text([['''The amazon leans on her spear for a moment, then slowly slumps onto one of the cots. Her friend, the spellslinger, is on her''',
            '''hands and knees, taking deep, gasping breaths.'''],
            ['''"I told you we should have left the healer alone," gasps the spellslinger. "I told you!"'''],
            ['''"Oh shut up," mutters the amazon. "This''', bastardbitch(), '''just got lucky, is all. Nine times out of ten, we'd have beaten''', himher() + "."],
            [name(), '''rolls''', hisher(), '''eyes.'''],
            ['''Over the course of the battle, Paloma managed to get away from the cot, pull up her panties and readjust her dress. She is holding the amazon's''',
                '''discarded belt.'''],
            ['''"Thank you for helping me," says Paloma, putting a hand on''', names(), '''shoulder. "What's your name?"'''],
            ['"' + name() + '," says', name() + ".", '''"I joined the guild just before our fellow Taironans here decided to wreck the place."'''],
            ['''"Well, it's lucky for my bottom that you showed up when you did," says Paloma. She glares down at the two, and slaps the belt against the palm of''',
                '''her hand. "You know, White Roses are recognized by every nation as neutral non-combatants. It is generally considered good form to  leave us alone''',
                '''during battle."'''],
            ['''"Yes, my Nana told me that," says''', name() + "."],
            ['''"Was your Nana strict?" asks Paloma, continuing to slap the belt against her palm. With each slap, the two Vengadores wince. Neither is strong enough''',
                '''to do much more than watch.'''],
            ['''"Fair, I think would be more accurate," says''', name() + ".", '''"I mean, she never made a threat she wasn't willing to carry out, and if I broke''',
                '''a rule, she didn't hesitate to punish me. Typically with extra letters, or being forced to stand in the corner when I was young. A wooden spoon''',
                '''to my backside when I got old enough to take a spanking. But her punishments were never particularly extreme."'''],
            ['''"What do you think she'd say if she heard about these two?" asks Paloma.'''],
            ['''"She'd say that both should have their bare bottoms beaten with their own belt," says''', name() + ".", '''The two Vengadores groan.'''],
            ['''"My thoughts exactly. Position them for me, would you?" asks Paloma.'''],
            ['''"Of course."''', name(), '''grabs the amazon by the hair and drags her over the cot, roughly bending her over its edge.''', HeShe(), '''reaches down,''',
                '''and yanks the woman's trousers down to her ankles, revealing a large, heavily muscled bottom.'''],
            ['''Then''', name(), '''walks over and grabs the other insurgent.'''],
            ['''"Wait, stop please," says the spellslinger. "It was her idea, honest. She'd have spanked me if I didn't go along with it and-"'''],
            ['''The amazon's eyes widen. "I would not have-"'''],
            ['''"You made one measly protest," snaps Paloma, glaring at the spellslinger. "And I don't recall her ever so much as hinting that you'd be spanked as''',
                '''well. Besides, I don't care. You both attacked a member of the White Roses, and you both will be thoroughly''', '''strapped for it."'''],
                
            [name(), '''throws the spellslinger over the cot next to her friend, and pulls up her dress. Her bottom is as large as her friend's, but significantly''',
                '''flabbier.''', name(), '''kneels on the cot between them, and places one hand between each of their shoulder blades, pressing their faces into''',
                '''the cot.'''],
            ['''"Now then," says Paloma, looping the belt and then snapping the two halves together. Both girls wince, and the spellslinger whimpers.'''],
            ['''"Oh stop carrying on," mutters the amazon. "It won't be the first time we've been strapped."'''],
            ['''"No, but it still hurts!" wails the other girl.'''],
            ['''Paloma raises the belt and proceeded to lay a good dozen hard smacks to the amazon's bottom. At first, the woman takes the blows stoically. But about''',
                '''halfway through, she begins to jerk and grunt. Then she starts to yelp. By the last one, she lets out a howl, and her right leg kicks, nearly''',
                '''clipping Paloma's wrist.'''],
            ['''Next, Paloma turns her attention to the spellslinger, who had started to cry about two-thirds through the amazon's belting. Unlike the amazon,''',
                '''she doesn't try to be stoic. She starts shrieking and thrashing the instant the belt first licks her big, wobbling bottom. Her shrieking gets''',
                '''louder and her writhing more frantic with every blow, until by the end''', name(), '''starts to fear for the integrity of both''', hisher(), 
                '''ears and the cot.'''],
            ['''"What is wrong with you two?" says Paloma once she's finished giving the spellslinger her first dozen. She snaps the belt once across the warrior's,''',
            '''then the spellslinger's bottom, making both howl. "I understand how awful things are for you girls. I can understand your desire to find some way of''',
            '''fighting back." She gives the warrior two hard lashes that makes her squeal and buck, then two lashes for the spellslinger, with similar results.''',
            '''"But the adventurer's guild has done nothing to hurt either of you. And neither have I."'''],
            ['''She leans over, puts her free hand on the warrior's lower back for support and administers three hard blows to the girl's heavily welted bottom. The warrior throws her head back''',
                '''and howls. Then she leans over the spellslinger and does the same thing. The spellslinger, to''', names(), '''surprise, doesn't howl. Instead,''',
                '''she sags completely into the cot and sobs brokenly.'''],
                ['''"And even if this raid were somehow justified, you do not attack a member of the White Roses.''',
                '''Ever!" Seeing the spellslinger sobbing, she focuses her attention on the warrior, belting her until she too finally stops thrashing, and just sags''',
                '''into the cot. "Do I make myself clear?"'''],
            ['''The two girls nod, both crying too hard to speak. The cold, angry expression on Paloma's face breaks into one of concern. She gently shoos''', name(), 
                    '''off the cot, and''',
                '''sits down next to the two girls. She gathers the two of them into a hug, and holds them tight, rocking and comforting them. The two girls cling''',
                '''to her, their previous bravado completely broken.'''],
            ['''As''', name(), '''watches them,''', heshe(), '''realizes just how young they are. They look to be about the same age as the first insurgent''', name(),
                    '''fought.'''],
            ['''"It's ok," says Paloma gently. "It's all over. You're forgiven now. And once you've recovered some, you're going to tell me what those wretched''',
                    '''Vengador recruiters told you, so I can tell you all the ways in which they lied, fudged the truth, and just generally misled you. Ok?"'''],
            ['''The two girls nod.'''],
            ['''"Alright," says the healer. She looks up at''', name(), ''', and gestures for''', himher(), '''to lean over the healer. She reaches up and touches''',
                    names(), '''forehead. An invigorating burst of energy flows through''', name() + ".", '''"Here, I'm no good in a fight, but I can heal with''', 
                    '''the best of them. Also, if you could walk over to that cabinet over there, you'll find a couple of white ribbons. Bring one to me, and I'll''',
                    '''mark it. It'll mark you as one of us, which might be useful considering your resemblence of our attackers, and the fact that''',
                    '''no one in the guild knows you yet."'''],
            [name(), '''does as she requests, and a few minutes later''', name(), '''tucks the enchanted white ribbon into''', hisher(), '''pack.'''],
            ['''As''', name(), '''prepares to leave''', heshe(), '''spies the discarded leather belt. Deciding that A)''', heshe(), '''could use a better belt than''',
                    '''a piece of string, and B) to the victor go the spoils,''', heshe(), '''snatches up the belt, and''', 
                    universal.format_line(['''loops it through''', hisher(), '''belt loops.''']) if lower_clothing().armorType == items.Pants.armorType else 
                    universal.format_line(['''slips it into''', hisher(), '''pack.''']), '''Paloma raises an eyebrow, but doesn't say anything.'''],
            [name(), '''has received a white ribbon. It will make''', hisher(), '''encounters with various members of the guild run a bit more smoothly.''', name(), 
            '''has also been fully healed. Finally,''', name(), '''has received an old leather belt. This may come in handy in the future.''']])
        add_keyword('defeated_Palomas_attackers')
        universal.say(victoryText, justification=0)
        universal.acknowledge(dungeonmode.dungeon_mode, ())
        p.PC.take_item(itemspotionwars.whiteRibbon)
        p.PC.take_item(itemspotionwars.leatherBelt)
        p.PC.restores()

hesitateToHelpPaloma.comment = "Hesitate."
def hesitateToHelpPaloma_qf():
    hesitateToHelpPaloma.quip = universal.format_text([['''The amazon's belt snaps across Paloma's fleshy, quivering bottom, leaving an ugly red diagonal mark across both''',
            '''cheeks.'''],
    ['''Paloma howls and bucks against the cot, but the other woman holds her firm.'''],
    [name(), '''winces. On the one hand,laying hands on a White Rose during''',
    '''battle is a blatant violation of the laws of war. On the other,''', name(), '''White Roses aren't typically trained in the discipline needed''',
    '''for casting magic. If''', name(), '''decided to challenge the two Vengadores,''', heshe() + "'d", '''be on''', hisher(), '''own.'''],
    ['''The amazon's belt cuts into Paloma's bottom twice more, the second one snapping across the crease where Paloma's bottom meets her thighs. Paloma shrieks''',
        '''and flails violently, nearly throwing the smaller insurgent off.'''],
    ['''"I can't hold her much longer," says the other woman. "If we want to keep punishing her, our friend over here is going to need to help."'''],
    ['''The amazon looks over at you. "Well? What are you waiting for?"'''],
    ['''Although the amazon seems oblivious to''', names(), '''doubt, Paloma clearly notices it. "Please, this isn't right and you know it. Help me."'''],
    [name(), '''looks the amazon in the eye, and realizes that''', heshe(), '''will have to make a decision: Find a way to help Paloma, or go along with the''',
    '''two Vengadores.''']])
hesitateToHelpPaloma.quip_function = hesitateToHelpPaloma_qf
palomaBravado = Node(224)
hesitateToHelpPaloma.children = [palomaBravado, failedToHelpPaloma, helpPalomaClever]

palomaBravado.comment = '''"Sorry. I'm just trying to decide which one of you bullies I should spank first."'''
def palomaBravado_qf():
    palomaBravado.quip = universal.format_text([['''The amazon scowls and snatches up her spear. "Should have known you were a traitor."'''],
    ['''"Told you," says the other woman, jumping to her feet.'''],
    ['''"Shut up and take her," snaps the amazon.''']])
    return (combat.fight, ([spellSlinger, warrior], save_the_healer, dungeonmode.dungeon_mode, False, None, True))
palomaBravado.quip_function = palomaBravado_qf

failedToHelpPaloma.comment = "Go along with the Vengadores."
def failedToHelpPaloma_qf():
    add_keyword('failed_to_help_Paloma')
    failedToHelpPaloma.quip = universal.format_text([[name(), '''takes half a step back,''', hisher(), '''guts churning.''', HeShe(), '''seriously doubts''', heshe(), '''can''',
        '''handle two raiders at once.''', HeShe(), '''winces with each blow of the amazon's belt. The healer's howls and sobs grate at''', names(), '''ears. Slowly''',
        heshe(), '''starts to ease backward, hoping to slip away before the two raiders notice.'''],
    ['''But then the amazon's belt lands a particularly vicious lick across the crease where Paloma's bottom meets her thighs, and the healer jerks so hard that''',
        '''she nearly throws off the raider holding her down.'''],
    ['''"Look, her flailing is getting worse," says the raider. "I can't hold her down any longer without help."'''],
    ['''The amazon looks over her shoulder at you. "Hey, come over here and sit on this fat-assed cow. I'm not done beating her yet."'''],
    ['''"Is this really necessary?" asks''', name() + ".", '''"She's a healer of the White Rose."'''],
    ['''The amazon throws her belt over her shoulder, and storms up to''', name() + ".", '''She grabs''', names(), '''arm, spins''', himher(), '''around, and lands''',
        '''three hard and fast slaps to''', p.PC.clad_bottom() + ".", name(), '''yelps and dances in the amazon's grip, pushing''', hisher(), '''hips forward in an''',
        '''effort to escape her blows.'''],
    ['''"Now get over here and help us, or I'll turn you over the cot and strap you instead," says the amazon.'''],
    [name(), '''hurries over and sits down on Paloma's back.'''],
    ['''"Good, good," says the amazon. Paloma's body starts to shake, and''', name(), '''realizes that she has completely broken down, her body shaking with sobs of''',
        '''despair.'''],
    ['''The amazon ignores her sobs, and resumes her belting. Now that she has two people holding the healer down, she is free to increase the speed and strength of''',
    '''the''',
        '''strapping. At first, the hard, merciless blows generate a spate of kicking, screaming, and bucking from the captive healer. Before long, however, she''',
        '''collapses completely and just sobs brokenly as the amazon mercilessly beats her.'''],
    ['''"Alright," says the amazon at last, relooping her belt. "Let's go. Ana'll thrash us for a month straight if we don't go and help empty the''',
        '''armory."'''],
    ['''The other insurgent nods and quickly stands.''', name(), '''slowly gets off of the healer.'''],
    ['''"You coming?" asks the amazon.'''],
    ['''"I'll be along," says''', name() + ",", '''glancing down at Paloma.'''],
    ['''"Well don't be long," says the amazon. "Who knows when the guards will show, and we need to be out of here by then."'''],
    [name(), '''sit down next to the healer, and watches as the two insurgents run off.''', HeShe(), '''reaches over and gently rub Paloma's brutalized bottom.'''],
    ['''"What are you doing?" snaps Paloma, scooting away from''', name() + ".", '''"Not done beating me yet? Well, you can beat me from now until Judgement Day, I'll''',
        '''never help you lunatics."'''],
    ['''"Shh," says''', name() + ".", '''"I'm not like them. I just, two-on-one are not good odds, and that big woman looked more than a little scary. I didn't know what''',
    '''to do."'''],
    ['''In response, Paloma rolls away from''', name() + ",", '''tugging her dress back down over her welted bottom. She doesn't bother trying to pull up her panties.'''],
    ['''"Please," says''', name() + ",", '''reaching out to her. "I'm sorry. I just-"'''],
    ['''"Go suck off the Father," says the healer.''']])

failedToHelpPaloma.quip_function = failedToHelpPaloma_qf        
helpPalomaClever.comment = '''"You know, we're getting spanked over at the entrance. We need all the help we could get out there."'''           
def helpPalomaClever_qf():
    if p.PC.willpower() > 2:
        helpPalomaClever.quip = universal.format_text([['''The amazon frowns, and looks over her shoulder at''', name() + ".", '''"I find that hard to believe. Our express''',
        '''orders were to raid the armory-"'''],
        [name(), '''gives the amazon's heavily muscled bottom a hard slap.'''],
        ['''The amazon squeaks, and dances forward a few steps, clutching at her bottom.''', name(), '''follows after her, smacking her botom. "Are you stupid? Or''',
            '''just dumb? What do you think will happen if Adrian's adventurers take control of the entrance?"''', name(), '''grabs her wrists, forces them away from''',
            '''her bottom, and lands a few more stinging slaps to her bottom. "Well?"'''],
        ['''"We'd be trapped?" chirps up the other insurgent.'''],
        ['''"Exactly!" says''', name() + ".", '''"Good to know one of you has something approximating a brain. And what do you think will happen if we get''',
            '''trapped?"'''],
        ['''"We'll get arrested and thrown in the dungeons to rot," mutters the amazon, rubbing her stinging bottom.'''],
        ['''"Clearly," says''', name() + ".", name(), '''points back towards the door. "So get your asses back to the entrance and shore up our people before I take''',
        '''that belt, bare your bottoms and thrash you both so hard just the thought of sitting makes you burst into tears!"'''],
        ['''"Yes ma'am," says the two raiders in sync. The two dash for the exit, though the amazon makes sure to snatch up her spear before leaving.'''],
        ['''As soon as the two leave,''', name(), '''sits down on the bed next to Paloma, who is watching''', himher(), '''warily. "Ok, that was scary."'''],
        ['''"I take it you lied to them?" says Paloma.'''],
        ['''"Hmm?" says''', name() + ".", '''"Oh, actually I have no idea. Last I saw, the battle was pretty evenly matched, though I think the raiders were winning.''',
        '''But those two looked fairly inexerpienced compared to most of the adventurers in the main room, so I figured they could handle those two better than''',
        '''either of us."'''],
        ['''"I see," says Paloma. "And who are you?"'''],
        ['''"Right, sorry," says''', name() + ".", '''"My name's''', name() + ".", '''I'm new here. Had the misfortune of signing up just as our fellow Taironans''',
        '''decide to wreck the place."'''],
        ['''"Well, one peron's bad luck is another's good," says Paloma. She rolls onto her back, and pulls her panties back up, hissing as the fabric rubs against''',
        '''her welts. Then, she pulls her dress back over her bottom. "I'm Paloma. Resident healer. Thanks a lot for helping me."'''],
        ['''"I try," says''', name() + ",", '''shrugging.'''],
        ['''Paloma puts her fingertips on''', names(), '''forehead, and a warmth spreads throughout''', hisher(), '''body. "I'm pretty useless in battle, but I'm''',
            '''a very good healer outside of battle, if I do say so myself. So if ever you need healing, come to me and I'll fix you up right quick."'''],
        [name(), '''is fully healed!'''],
        ['''"Also," says the healer, drawing her fingertips away from''', name() + ".", '''She stands up and hurries towards a cabinet in the back of the room.''',
        '''Opening it reveals a small number of bright white ribbons. She takes one, and holds it for a second. To''', names(), '''magical senses, the white ribbon''',
        '''starts to give off a warm, soothing glow very reminiscient of the woman herself. She walks back over to''', name(), '''and offers it to''', himher() + ".",
        '''"Here. This will let the others know that you're on our side. Might be useful considering your resemblance of our attackers."'''],
        ['''"Thank you," says''', name() + ",", '''taking the ribbon, and slipping it into''', hisher(), '''pack.'''],
        ['''"Now go get out of here and help take back our guild," says Paloma. She pulls''', name(), '''to''', hisher(), '''feet and sends''', himher(), '''on''', 
            hisher(), '''way with a light slap to the bottom.'''],
        [name(), '''flashes a grin over''', hisher(), '''shoulder before turning''', hisher(), '''attention to plotting''', hisher(), '''next move.'''],
        [names(), '''quick thinking and powerful personality has allowed''', himher(), '''to save Paloma without resorting to violence.''', name(), '''has earned''',
            '''25 experience.''']])
        p.PC.get_item(whiteRibbon)
        p.PC.add_experience(25)
        p.PC.restores()
    else:
        helpPalomaClever.quip = universal.format_text([['''The amazon frowns, and looks over her shoulder at''', name() + ".", '''"I find that hard to believe."'''],
        ['''"Well, it's true," says''', name() + ".", '''"See our leader is in dire straights and..."'''],
        ['''The amazon slowly turns and picks up her spear. "The Leader gave us explicit orders to rob the armory, regardless of what's happening in the entrance.''',
            '''She said our more experienced fighters will hold the path open long enough for us to do so, and maybe make a few unpleasant impressions on any''',
            '''Taironans who won't join us."'''],
        ['''"Well...,"''', names(), '''voice trails off as''', heshe(), '''looks at the woman's spear.''', name(), '''warily backs up a step, reaching for''', hisher(),
            '''weapon.'''],
        ['''"I'm thinking you're one of those Taironans who won't join us," says the amazon.'''],
        ['''"Told you," mutters the other woman, standing and facing''', name() + "."],
        ['''The amazon smirks. "What do you say we bend this naughty little''', boygirl(p.PC), '''over and thrash''', himher(), ''''till''', heshe(), '''can't think''',
        '''straight?"''']])
    return (combat.fight, ([spellSlinger, warrior], save_the_healer, dungeonmode.dungeon_mode, False, None, True))
helpPalomaClever.quip_function = helpPalomaClever_qf

palLost = Node(225)
def palLost_qf():
    palLost.quip = universal.format_text([[name(), '''staggers. The room spins, and''', hisher(), '''weapon begins to lower.'''],         
        ['''The amazon smirks, and begins to lower her spear.'''],
        ['''The spellslinger lances forward, and her dagger flashes.'''], 
        ['''"Wait, stop!" cries the amazon, jerking forward to grab the spellslinger.'''],
        ['''The spellslinger's dagger rams into''', names(), '''chest, puncturing a lung. She pulls her dagger free, and backs up, grinning in satisfaction.'''],
        [name(), '''clutches at the hole in''', hisher(), '''chest, a hole that refuses to close.''', HeShe(), '''takes quick, deep, agonizing breaths, that aren't''',
        '''enough.''', name(), '''falls to''', hisher(), '''knees, as the room begins to spin.'''],
        ['''The satisfaction fades from the spellslinger's face, replaced by confusion, then horror.'''],
        ['''"You idiot," snaps the amazon, grabbing her friend's arm. "Don't you know health fatigue when you see it? Where's that cursed healer!"'''],
        ['''Paloma rushes past the two Vengadores, and crouches next to''', name() + ".", '''Her fingers fly across the stab wound, then touch''', names(), '''forehead.'''],
        ['''"I...I..." mutters the spellslinger. She threads her thumb through the wrappings of her mask, and begins gnawing furiously on her thumbnail. "I didn't-"'''],
        ['''The amazon lands a sharp slap to her friend's round derrier. "How many times did Ana tell you to pay attention when you're fighting? You never know when''',
            '''your enemy-!"'''],
        ['''"You," snaps Paloma, turning and pointing a finger at the amazon. "Shut up, and get to that cabinet over there. Inside you'll find several vials. Bring''',
            '''one to me. Now!"'''],
        ['''The amazon's eyes narrow. "I'm not bringing you a Potion."'''],
        ['''"Then''', heshe(), '''will die," says Paloma.'''],
        ['''"Better dead than addicted," says the amazon, crossing her arms and glaring at Paloma.'''],
        [names(), '''vision reduces to a single point. The voices seem to be coming from the far end of a long tunnel.'''],
        '''"That's not your decision to make," says Paloma.''',
        '''"I'll get it."''',
        '''"I don't-"''',
        '''"I won't be a killer! Not for some stupid ideology, not for anything!"''',   
        ['''A few seconds later, something cool presses against''', names(), '''lips.'''],
        ['''"Drink."'''],
        [names(), '''mouth opens. Something slurdgy slides across''', hisher(), '''tongue, and sloughs down''', hisher(), '''throat.''', name(), 
        '''begins to gag.'''],
        ['''"Come on, swallow."'''],
        [name(), '''does just that.''', HisHer(), '''eyes fly open, and''', heshe(), '''arches''', hisher(), '''back. A kaleidescope of every pleasure imaginable,''',
            '''from the physical to the emotional and back again, rips through''', names(), '''heart and soul. For an instant and an eternity,''', name(), '''swims''',
            '''in an ocean of ecstasy.'''], 
        ['''Slowly, the concerned face of Paloma comes into focus. Somehow,''', name(), '''is on''', hisher(), ''' back.''', HeShe(), '''groans, and rolls onto''', hisher(), '''side.'''],
        ['''The loud crack of hand to bare flesh snaps against''', names(), '''ears, followed by a wail of pain.''', '''The amazon has tucked her friend underneath''',
        '''her arm, and raised her dress, revealing a round, wobbly bottom. She''', '''is administering hard, sharp slaps to the exposed derrier.'''],
        ['''"Thank the Madre," says Paloma. She presses soft hands against''', names(), '''shoulders and gently but firmly pushes''', himher(), '''onto''', hisher(),
            '''back. "Stay still. I need to make sure you aren't seriously injured."'''],
        ['''"I'm sorry, I'm sorry," cries the spellslinger, her hips rocking and her legs kicking beneath the amazon's hard slaps.'''],
        ['''"Just wait until we get back," says the amazon. "There, I'm going to take my belt to you, and I'm not going to stop until you're so sore, you won't''',
        '''be able to sit 'till the first snowfall!"'''],
        ['''Paloma gives''', name(), '''a thorough inspection. She starts with the now-healed dagger wound, then studies''', names(), '''gaze, tests''', hisher(), 
        '''reflexes, asks a few short, easy questions, and ends by putting her hand on''', names(), '''forehead.'''], 
        ['''Meanwhile, the sharp slaps of the spanking continue to press on''', names(), '''ears, along with the ever-louder wails of the young spellslinger.'''],
        ['''Paloma grunts in surprise. "You took that much better than I expected, all things considered."'''],
        [name(), '''shrugs. "I've been trained in combat almost since I was old enough to hold a dagger. So, you know, I'm in pretty good shape."'''],
        ['''Paloma grimaces. "I see. Well, let's get you fully healed, at least." Paloma touches''', names(), '''forehead, and a rush of energy flows through''',
            names(), '''body. Then, Paloma offers her hand, which''', name(), '''takes. As''', name(), '''stands,''', heshe(), '''realizes with a start that the''',
            '''spanking has stopped.'''],
        ['''Something flickers at the corner of''', hisher(), '''eye, and''', heshe(), '''spins just in time to see the two Vengadores disappear through the door.'''],
        ['''"Guess they didn't want to stick around for round two," says Paloma, crossing her arms.'''],
        ['''"Guess not," says''', name() + ".", HeShe(), '''massages''', hisher(), '''forehead. "What happened, exactly?"'''],
        ['''"Well, the last of your health drained, and that dagger-wielding young woman stabbed you in the chest. Punctured a lung at least, might have done''',
        '''additional damage. Of course, since you didn't have any more health, you couldn't heal yourself. So I used a Potion," says Paloma, smiling hesitantly.'''],
        ['''"What!"'''],
        ['''"Oh no, you are not going to be angry about this," says Paloma, shaking her finger at''', name() + ".", '''"You were dying and unconscious. The only way''',
                '''I could save your life was to give you a Potion. One is not going to make you addicted, and even if that were somehow enough to''',
                '''carry you over the edge, and I'm pretty sure that's not how addiction works, the addiction would probably be so light that we could just lock''',
                '''you in a room somewhere, let you go through a few days of nausea and headaches, and then you'd be fine."'''],
        ['''"Ok, Ok," says''', name(), '''holding up''', hisher(), '''hands in a conciliatory gesture. "I just, it's been a bad day."'''],
        ['''"Indeed," says Paloma, rubbing her bottom. "What's your name again?"'''],
        ['"' + name() + '."'],
        ['''"Well, it's a pleasure to meet you''', name() + ',"', '''says Paloma. "If you'll give me a second, I think I have something you might find useful."''',
        '''Paloma walks to a large cabinet at the back of the room. She removes a small white ribbon. She focuses on it for a moment, and the ribbon begins to give''',
        '''off a warm, golden glow. She returns, and hands the ribbon to''', name() + ".", '''"Here. This will probably come in handy, in case you run into any''',
        '''other guild members. This way, they'll know you're one of us."'''],
        ['''"Thank you," says''', name() + ',', '''taking the ribbon.'''],
        ['''"No, thank you for helping me. Now get out there and help retake our guild. I'll be here if you need me."'''],
        [name(), '''nods, slips the ribbon into''', hisher(), '''pack.'''],
        [name(), '''has been healed by Paloma, and has received a white ribbon as a reward for helping her. Hopefully this should make other encounters run a bit''',
            '''more smoothly.''']])
    p.PC.take_item(itemspotionwars.whiteRibbon)
    p.PC.restores()
palLost.quip_function = palLost_qf


palLostSlingerDown = Node(232)
def palLostSlingerDown_qf():
    palLostSlingerDown.quip = universal.format_text([[name() + "'s", '''weapon slips from numb fingers, and''', heshe(), '''falls to''', hisher(), '''knees. For a moment the''',
        '''room spins, and''', heshe(), '''nearly blacks out. The spinning eventually fades, but''', hisher(), '''limbs feel like lead.'''],
        '''"Hah!" says the amazon. "Pathetic."''',
        ['''"I dunno," says the other Vengador. Her voice is strained, woozy. The young woman is on her knees, and has wrapped her hands around her gut.''', '''"''' + 
        '''Don't feel good."'''],
        '''"Oh suck it up," says the amazon. "You'll be perfectly fine in a few hours."''',
        '''In response, the other insurgent pulls her hands away. They're covered in blood. "My belly..." The Vengador collapses.''',
        ['''"Belita!" The amazon rushes to her friend's side. Gently, the amazon turns the insurgent onto her back, and tears away some of her dress. "Oh Madre,''',
        '''oh Madre, Madre."'''],
        ['''The amazon looks around, her eyes wild.''', name(), '''follows her gaze, and notices that during the fight, Paloma had slipped off, and is currently''',
        '''untying one of the injured adventurers, checking him for serious injuries.'''],
        ['''"Paloma!" screams the amazon. The amazon dashes over to''', name() + "," '''and grabs''', names(), '''hair in her fist. She pulls out a dagger, and holds''',
        '''it to''', names(), '''throat. "My friend is dying! Get over here and help her, or I'll slit''', hisher(), 
        '''throat!"'''],
        '''Paloma hurries towards the injured woman. "Put that away. You don't need to threaten anyone to get my help."''',
        '''The amazon sneers. "Bull. You'd probably let her bleed her life out, if I let you."''',
        ['''"I am a healer of the White Rose," says Paloma, kneeling down next to Belita. "I help anyone who needs it. Regardless''',
        '''of what they've done to me."'''],
        ['''Paloma studies the wound for a moment longer, then touches Belita's forehead. A worried frown creases her face. She looks up at the warrior. "Her wound''',
        '''is''',
        '''very serious. I'm going to need to get some materials from a cabinet back there." The healer gestures towards a cabinet at the far end of the room. "Is''',
        '''that alright?"'''],
        ['''"No tricks," says the amazon. She presses the dagger against''', names(), '''neck hard enough to draw blood.''', name(), '''swallows and''',
        '''tries''',
        '''not to panic. Barely in Avaricum a single day, and now''', heshe(), '''is going to die.''', name(), '''starts to whimper. The amazon gives''', hisher(),
        '''head a shake. "Shut up!" Then she turns her attention back to Paloma. "You do anything funny, and I open''', hisher(), '''throat. Understand?"'''],
        ['''"Nothing funny," says Paloma. She stands, and hurries back to the cabinet. She pulls open a small drawer in the back, and pulls something out. When she''',
        '''turns around,''', name(), '''sees a small vial clutched in her hand. She starts to approach Belita'''],
        ['''"What the fuck is that?" The amazon's voice is in full-fledged panic, the dagger digs into''', names(), '''neck. "Stop right now! Stay away from her!"'''],
        '''Paloma stops.''',
        ['''"You take one more step, and I'm killing''', himher() + ',"', '''says the warrior. She is shaking, the dagger grinding against the widening laceration on''',
        names(), '''throat. "I swear I will!"'''],
        ['''"Your friend doesn't have any health left," says Paloma calmly, gently, but firmly. "I haven't mastered the art of resparking it yet, and her wound''',
            '''is very, very serious." She holds up the vial. "A Potion is her only chance."'''],
        ['''"You're lying," says the amazon. The amazon jerks''', names(), '''head back hard enough to rip a few hairs from''', hisher(), '''head. "You're fucking''',
            '''lying!"'''],
        ['''Fueled by panic,''', name(), '''grabs the dagger blade, and yanks it away from''', hisher(), '''throat, cutting''', hisher(), '''fingers to the bone.''',
            HeShe(), '''twists out of the amazon's grip, and start to scramble away.'''],
        ['''The amazon screams, and kicks''', name(), '''in the thigh, hard enough to trigger a blinding cramp.''', name(), '''cries out, and curls into a ball,''',
            '''clutching at''', hisher(), '''leg. The amazon kicks''', himher() + "again,", '''then rolls''', himher(), '''onto''', hisher(), '''back, and drives her knees''',
            '''into''', hisher(), '''gut.'''],
        '''"Stop this!" cries Paloma, taking half a step forward.''',
        ['''The amazon grabs''', names(), '''hair and smashes''', hisher(), '''head against the floor. The room spins sickeningly, as a shock of pain rips through''',
            names(), '''head.'''],
        ['''"I'll kill you!" screams the amazon, raising the dagger.'''],
        '''Paloma is beside the two Taironans. She grabs the amazon's arm. "I said stop!"''',
        ['''The amazon throws Paloma to the ground. "You want me to stop? Then heal her without that ... that poison!"'''],
        ['''"Listen," says Paloma, pulling herself to her feet. "I can't. It's outside of my abilities. She won't be addicted from a single Potion, I promise.''',
            '''In fact, the state she's in now, she probably won't even remember it. And it doesn't matter anyway, because it's the Potion, or death."'''],
        '''"Better death than addiction," mutters the amazon.''',
        '''Belita cries out in pain.''',
        ['''The amazon is beside her friend in an instant, cradling her with surprising gentleness.''',
        '''She starts to cry. "Madre help me, what do I do?"'''],
        ['''"Let me help her," says Paloma quietly. "She won't be addicted, I promise. In fact, she'll be perfectly fine. Just as good as if it never happened.'''],
        ['''"Well, then use it!" screams the amazon. "What are you waiting for? Get over here!"'''],
        ['''Paloma rushes over to the young woman, and crouches down next to her. All''', name(), '''can see is Paloma's hunched back, and beside her the panting,''',
            '''crying Taironan.'''],
        ['''A faint cough breaks the silence.'''],
        ['''"Belita!" The amazon lifts her friend into a deep embrace, and the two hold each other fiercely, like shipwrecked women clinging to scraps of wood.'''],
        ['''"Your friend is going to be fine," says Paloma.'''],
        [name(), '''turns onto''', hisher(), '''side, and throws up.'''],
        ['''Paloma is beside''', name() + " in an instant.", '''Gentle fingers touch the back of''', hisher(), '''head, and run across''', hisher(), 
                '''bloody fingers.''', name(),
        '''groans,''', hisher(), '''stomach roiling.''', HeShe(), '''throws up a second time.'''],
        ['''"You stupid brute! You nearly cut off''', hisher(), '''fingers! Not to mention giving''', himher(), '''a serious concussion. And without any health..."'''],
        ['''The amazon, still too caught up in holding her friend, doesn't seem to hear Paloma. Paloma curses, and leaves''', names(), '''side.  She returns a''',
            '''few seconds later with another small vial. "Here, drink this."'''],
        ['''Paloma starts to pour the Potion into''', names(), '''mouth.''', name(), '''gags as the slurdgy, sticky mess touches''', hisher(), '''tongue.'''],
        ['''"Uh-uh," says Paloma firmly. "Drink it. Unless you want to have limited motion in your fingers at best, lose them completely at worst."'''],
        ['''Truth be told,''', name(), '''doesn't have the strength to resist anyway, so''', heshe(), '''swallows the sludge.'''],
        ['''And enters heaven.'''],
        [name(), '''arches''', hisher(), '''back and gasps. Euphoria beyond''', hisher(), '''wildest imaginings consumes''', himher() + ".", '''It's the raw,''',
            '''orgasmic pleasure of sex. The comforting safety of a mother's arms. The joy of a good joke told by good friends. The satisfaction of a difficult''',
            '''task done well. Every source of pleasure''', name(), '''can imagine, and countless sources''', heshe(), '''can't. All rolled into one and dumped in''',
            '''its purest form into''', hisher(), '''heart and soul.'''],
        ['''Then, the euphoria fades, and it leaves behind a horrific emptiness. For a time, an eternity or a moment,''', name(), '''stares blankly up at the''',
        '''ceiling,''', hisher(), '''mind skittering between ecstasy and depression, determination and despair, peace and rage.'''], 
        ['''With painful slowness,''', name(), '''realizes that''', heshe(), '''is staring up at Palma's concerned face.''', HeShe(), 
                '''sits up. "What in the Madre's''', '''name was that?'''],
        ['''"That was a Potion," says Paloma sadly. "Now you know how they could bring such ruin to one of the wealthiest cities in the known world."'''],
        ['''"I want another one, no no I don't want anymore, I never want to see one of those things again!"''', name(), '''scrambles to''', hisher(), '''feet.''', 
                names(), '''entire body is shaking. "How could you-"'''],
        ['''"It was that or lose almost total use of your fingers," says Paloma calmly. "And who knows what kind of havoc that concussion would have wreaked."'''],
        [name(), '''grimaces, and is about to retort, when a flicker of motion out of the corner of''', hisher(), '''eye catches''', hisher(), '''full attention.'''],
        ['''The amazon is slowly helping her friend stand. "She had to use a Potion on you. Don't worry, we'll keep you well away from them for a few days, so''',
            '''you're not tempted to use another one. Careful, careful. Lean on me."'''],
        ['''"Oh no," says Paloma, turning and approaching the two. "Your friend there had a very close brush with death, and is in''',
                '''no condition to go anywhere."'''],
        ['''The amazon laughs. "What, and wait here until the guards show up? I think not." The amazon carefully leads her friend towards the door.'''],
        ['''"I said stop!" says Paloma, zipping past the two and poisitioning herself between the two and the door.'''],
        ['''"Thank you for saving my friend's life," says the amazon, tightening her grip on the shorter woman. "I mean it. And I'm sorry, for hurting you like we''',
            '''did. But we cannot stay here. Now get out of our way, or I will make you move."'''],
        ['''The two glare at each for a moment. Then, reluctantly, Paloma steps to the side. "Fine. But she needs to spend at least two days in bed. Then you need''',
                '''to gradually, and I mean gradually, get her back into exercising. She shouldn't cast any spells for two weeks at least. And if you have a''',
                '''healer, make sure they check her at least once a day for the next few weeks, to make sure that all the damage was healed properly."'''],
        ['''"Yes ma'am," says the amazon, helping her friend out the door.'''],
        ['''Paloma takes a deep breath, then turns back and approaches you. "And as for you, let me see you. Sit down."'''],
        [name(), '''sits down on one of the cots, still too woozy to protest. Paloma studies''', himher(), '''for a few minutes. She runs her fingers across''', names(),
                '''blood-matted hair, studies''', hisher(), '''hands, makes''', name(), '''follow a fingertip with''', hisher(), '''eye, and makes''', name(), 
            '''walk a few laps around the edge of the room. While''', name(), '''is walking, Paloma tends to some of the others, though from what''', name(), 
            '''can see, most of them healed fully with their final burst of health. Only a few have lingering injuries, and most of those injuries are fairly''',
            '''minor.'''],
        ['''After''', name(), '''finishes walking, Paloma asks''', himher(), '''a barrage of questions, then checks''', himher(), '''a second time, both physically''',
                '''and magically.'''],
        ['''"Alright," she says at last. "Looks like you're ok. Only one thing left to do." She touches''', names(), '''forehead, and''', name(), '''feels a burst''',
                '''of energy flow through''', himher() + "."],
        ['''Paloma has fully restored''', names(), '''health and mana.'''],
        '''"By the way, what's your name?" asks Paloma. "I'm Paloma. Don't think we've been fully introduced."''',
        ['"' + name() + ',"', '''says''', name() + ".", '''"Sorry I couldn't do more to help you."'''],
        ['''"Oh you tried, and I appreciate it," says Paloma. She puts a hand on''', names(), '''shoulder, and gives''', himher(), '''a worried look. "Besides,''', 
                '''you just went through a lot worse than me. A belting isn't that big a deal, no matter how undeserved."'''],
        [name(), '''shrugs. "Not a big deal." Still, despite''', hisher(), '''bravado,''', name(), '''has a feeling that dagger will be haunting''', hisher(), 
                '''nightmares for the next few weeks.''', name(), '''absently reaches up and rubs''', hisher(), '''throat.'''],
        ['''"Yes, well, there is one thing I can give you," says Paloma. She returns to the back cabinet, and removes a small white ribbon. With''', names(), 
                '''magical senses,''', heshe(), '''can see her imbue it with a touch of magic. The ribbon begins to glow (to magical senses) with a warm golden''',
                '''hue. She returns and gives it to''', name() + ".", '''"Here. Show this to any other guild member you meet, and they'll know you're on our side."'''],
        ['''"Thank you," says''', name() + ",", '''taking the ribbon. "Guess, I should probably get back into the fight."'''],
        ['''"Be careful,' says Paloma. "And if you need healing, come back to me."''']])
    p.PC.get_item(itemspotionwars.whiteRibbon)
palLostSlingerDown.quip_function = palLostSlingerDown_qf

palLostWarriorDown = Node(234)
def palLostWarriorDown_qf():
    music.play_music(INTENSE)
    palLostWarriorDown.quip = universal.format_text([[name(), '''stumbles, suddenly feeling very woozy.''', HisHer(), '''knees buckle, and''', hisher(), '''weapon begins to''',
        '''lower.'''],
        ['''The spellslinger raises her arms back over her head, and then snaps forward, her hands pushing out in front of her.'''],
        '''"Wait, stop!" cries Paloma.''',
        ['''A bolt of raw magic erupts from the Vengador's hands and slams into''', name() + "."],
        [name(), '''collapses,''', hisher(), '''entire body seizing as the magic rips through''', hisher(), '''body.''', HisHer(), '''head slams against the''',
        '''ground with a sickening thud, and one leg cracks against a cot, bringing it crashing down on top of''', hisher(), '''shin, cracking the bone.'''], 
        '''"Idiot!"''',
        ['''The ceiling begins to spin sickeningly.'''],
        '''"Amor de la Madre, I didn't notice-"''',
        '''"What kind of fighter can't recognize health fatigue?"''',
        [names(), '''stomach roils, and''', hisher(), '''vision narrows to a single point. The voices fade into faint murmurs.'''],
        [names(), '''leg wrenches.''', HeShe(), '''unleashes a high-pitched, glass-shattering shriek.'''],
        ['''Everything goes dark.\p''']])
    #music.play_music(INTENSE)  
    palLostWarriorDown.quip = universal.format_text([palLostWarriorDown.quip, [name(), '''jerks awake, coughing and sputtering. A lingering taste of something... sweet(?)''',
        '''sits on''', hisher(), '''tongue. There is a strange, lingering''',
            '''sense of satisfaction, as if waking up from a particularly restful night. The pain in''', hisher(), '''head and leg is gone. A quick glance down''',
            '''reveals a blood-smeared,''', ''' torn trouser leg, but''' if p.PC.lower_clothing().armorType == items.Pants.armorType else 'but otherwise', 
            '''undamaged limb.'''],
        ['''Paloma sighs. She touches''', names(), '''forehead.  "Thank Los Padres."'''],
        [name(), '''groans, and puts''', hisher(), '''head in''', hisher(), '''hands.'''],
        ['''Paloma guides''', himher(), '''onto a nearby (undamaged) cot. "Just rest here."'''],
        ['''"Is... is''', heshe(), '''going to be ok?" asks the spellslinger. She's threaded her thumb through the cloth of her mask, and is nervously gnawing on''', 
            '''her thumbnail.'''],
        '''Paloma gives the girl an icy glare. "Yes, no thanks to you."''',
        '''"B-but..." The girl trails off as Paloma stands up. The healer seems to grow ten feet, and tower over the shrinking Taironan.''',
        '''Paloma takes the girl's ear in a twisting pinch, and drags her to the cabinet.''',
        ['''"Oww! Wait, I'm sorry, I'm sorry, please-" The spellslinger's eyes widen in horror as Paloma opens a lower drawer, and pulls out''',
        '''an old, leather-soled slipper. "Wait, wait stop I'm sorry, I'm sorry please don't..."'''],
        ['''Paloma twists the girl around and slaps the younger woman's derrier with the slipper.'''],
        ['''"Oww! Erizelda, help!" cries the woman, reaching towards the amazon.'''],
        ['''"Hmph," says the amazon. At some point during the chaos, she had managed to get herself up onto one of the cots. "If I still had the energy, you'd be''',
        '''over my knee, instead of hers. Amor de la Madre, you could have killed''', himher() + '''!"'''],
        ['''Paloma starts to drag the spellslinger towards the nearest cot, but the Vengador drags her feet, and claws at Paloma's arm.'''],
        ['''"Oh, Padres grant me patience," snaps Paloma. She roughly jerks the Vengador around and lands another smack to the girl's bottom. The girl yelps, and''',
        '''her hand snaps back to cover her bottom.''',
            '''"Young lady, you are going to stop fighting, and take what you've got coming to you. Understand?"'''],
        ['''"But it'll hurt," whines the girl, clutching at her bottom.'''],
        ['''"Of course it'll hurt," says Paloma. She points the slipper at''', name() + ".", '''"You almost killed''', himher() + '''."'''],
        '''"Didn't mean to," mutters the girl, scuffing her foot against the ground.''',
        ['''"That wouldn't have made''', himher(), '''any less dead," says Paloma. "Gods above, below and all around us. First, you attack a White Rose, then you''',
            '''attack a helpless combatant. Do you people give any regards at all to the rules of war?"'''], 
        '''"Of course we do," snaps the amazon (weakly). "We're not thugs."''',
        '''"Well you could have fooled me," says Paloma, throwing the amazon a glare.''',
        '''Erizelda sighs in exasperation. "Belita, just take the cursed slippering."''',
        ['''The spellslinger starts to protest, but then she glances at''', name() + ".", '''She nods, and lowers her head.'''],
        '''Paloma sits down on the cot, and pats her lap. Belita folds herself over the healer's lap, gnawing furiously on her thumbnail.''',
        ['''"Ready?" asks Paloma, lifting the young woman's skirt, and unveiling a large, round bottom.'''],
        '''"No," whimpers Belita.''',
        ['''Paloma presses her left hand against the small of Belita's back, and raises the slipper. Belita squeezes her eyes shut, and takes a deep breath. The''',
            '''slipper arcs through the air and cracks against the young Vengador's bottom. Belita yelps, as her fleshy bottom flattens beneath the slipper, then''', 
            '''bounces back into position. Paloma proceeds to slipper the young woman with precise, methodical blows. The slipper moves''',
            '''from the top of Belita's bottom to the sitspots, and back again, alternating between cheeks with each blow.'''],
            '''Barely three smacks in, Belita is crying.''',
        ['''After a few minutes of intense (and painful, if Belita's shrieks are to believed) slippering, Paloma rests the implement lightly on the girl's burning bottom. "Young lady, do you have any idea how''',
        '''terrible a mistake you almost made?"'''],
        '''"I, I guess," mutters the girl through her tears.''',
        ['''"You guess?" Paloma raises the slipper and cracks it hard against Belita's right sitspot. Belita yelps, and her legs kick frantically. "Death is''',
        '''irreversible. Irreversible. Not only would''', hisher(), '''life had permanently ended, but you would have had to live with''',
        '''what you did for the rest of yours." Paloma lands three hard blows. "Have you even reached your second decade?"'''],
        ['''"Almost," says the Vengador, sniffing.'''],
        ['''"Almost." Paloma cracks the slipper against the girl's left sitspot. "Almost two decades. Barely a quarter of your way through life, and you almost did''',
            '''something you'd regret for the rest of it. Sixty years of the deepest shame you could possibly imagine. You'd dream about it.''',
            '''You'd be cleaning, watching your children, practicing your magic, anything, and you'd stop. You'd flash back to today, to''', hisher(), 
            '''lifeless body. And you'd replay the events over and over again. Wondering what you could have done differently, wondering how you could have been so''',
            '''stupid."'''],
        ['''Belita begins to cry harder. She slumps across Paloma's lap, and sobs. "I'm sorry, I'm sorry. I just, I just, it's all so hard."'''],
        '''"I know," says Paloma. She sets the slipper down on the cot, and gently rubs the young woman's bottom. "Come on, get up."''',
        ['''Belita clambers off of Paloma's lap, and the older Taironan draws the younger girl into a hug. Belita buries her face in Paloma's shoulder and cries, while''',
        '''Paloma rocks her gently and makes soothing noises. After a few minutes, the sobs begin to fade, and Paloma pulls the young woman back. She points to the''',
        '''southeastern corner. "Now, I want you to go stand in that corner, with your dress up. Then you're going to help me tend to the injured. Understand?"'''],
        '''Belita nods, and waddles painfully into the corner. There, she lifts her dress above her marked bottom, and stares miserably at her feet.''',
        ['''Paloma nods in satisfaction, grabs her slipper, stands, and approaches''', name() + ".", '''"How you feeling?"'''],
        [name(), '''shrugs. "Much better. What happened, exactly?"'''],
        ['''Paloma gives the young''', manwoman(), '''a thorough inspection. She grunts in surprise. "You look and feel fine, too. I'm surprised."'''],
        [name(), '''shrugs a second time. "My nana taught me how to fight almost from the minute I was old enough to hold a knife. What happened, exactly?"'''],
        ['''Paloma's lips twist into a grimace. "I see. Well, questionable as I may find such a practice, it looks like it's paid off for you today." Paloma touches''',
            names(), '''forehead, and a surge of energy flows through''', himher() + ". She holds up a white ribbon.", '''"Here, I grabbed this when I was picking''',
            '''up my slipper. This will tell others that you helped me. Now get out there, and help take back our guild."'''],
        [name(), '''glares at Paloma. "Not until you tell me what the hell happened? I've been resparked before, and I can assure you, it doesn't leave feelings of''',
                '''satisfaction. It usually leaves you feeling ill."'''],
        ['''Paloma grimaces. "Well, see, I don't know how to respark."'''],
        '''"What."''',
        ['''Paloma smiles hesitantly. "And you were a pretty bad way, so I used one of my emergency Potions. That lingering satisfaction was''',
                '''the remnant of the supreme and rather addictive Potion-bliss."'''],
        ['''"What!"''', name(), '''jumps to her feet,''', hisher(), '''hands closing into fists.'''],
        ['''"Oh no, you are not going to be angry about this," says Paloma, shaking her finger at''', name() + ".", '''"You were dying and unconscious. The only way''',
                '''I could save your life was to give you a Potion. One Potion is not going to make you addicted, and even if that one Potion were somehow enough to''',
                '''carry you over the edge, and I'm pretty sure that's not how addiction works, you'd probably be so lightly addicted that we could just lock you in''',
                '''a room somewhere, let you go through a few days of nausea and headaches, and then you'd be fine."'''],
        [name(), '''scowls at Paloma, but Paloma meets''', hisher(), '''gaze with a gaze of iron. Eventually,''', name(), '''sighs. "Alright, fine. I suppose it was''',
        '''better than the alternative."'''],
        ['''"Indeed," says Paloma, rubbing her bottom. "What's your name again?"'''],
        ['"' + name() + '."'],
        ['''"Well, it's a pleasure to meet you''', name() + ',"', '''says Paloma "Now how about you get out of here, and help retake the guild?"'''],
        [name(), '''nods.'''],
        [name(), '''has been healed by Paloma, and has received a white ribbon as a reward for helping her. Hopefully this should make other encounters run a''',
        '''bit more smoothly.''']])
                
    p.PC.take_item(itemspotionwars.whiteRibbon)
    p.PC.restores()
palLostWarriorDown.quip_function = palLostWarriorDown_qf


def e1_7_1():
    if "helped_Morey" in keywords() or 'met_Airell' in keywords():
        universal.say(universal.format_text([['''There's nothing here, except a pile of dazed Taironans.''', name(), '''can't help but notice that, despite the clear gap between Morey's''',
        '''power, and that of his attackers, none of the attackers are injured; Morey managed to inflict just enough damage to drain their health, and no more.''',
        '''An impressive (and rather scary) testament of skill.''']]))  
        universal.acknowledge(backOfGuild.display, ())
    else:
        universal.say_title('Morey')
        universal.say(universal.format_text([[name(), '''approaches the melee,''', weapon().name, '''at the ready. One of the insurgents on the far side notices''', himher() + ",", 
        '''and lets out a warning cry. Two of the insurgents closest to''', name(), '''disengage from the fight and move to intercept''', himher() + "."],
        ['''"Good, we could use some reinforcements," says one of the insurgents, lowering her dagger. "This guy refuses to go down."'''],
        ['''"Wait, look.''', HeShe(), '''isn't wearing a mask," says the other, keeping his spear raised. "I don't think''', heshe() + "'s", '''one of us.'''],
        ['''One of the still fighting insurgents lets out a cry, and collapses, clutching at his barely healed stomach.'''],
        ['''The first insurgent curses. "We don't have time to figure this out. Help the others. I'll take''', himher() + '''!"''']]), justification=0)
        gender = random.randint(0, 1)
        insurgentScout = pwenemies.VengadorScout(gender)
        universal.acknowledge(combat.fight, [insurgentScout], help_Morey, dungeonmode.dungeon_mode, False, None, False)

def help_Morey(allies, enemies, won):
    moreyText = universal.format_text([['''"Whew," says someone nearby.''', name(), '''spins, and raises''', hisher(), '''weapon, only to realize with a start that the''',
    '''raven-haired swordsman has defeated all of his opponents as well. He grins at''', name(), '''and offers his hand. "Thanks for the help. I take it from your''',
    '''lack of a mask, and the fact that you helped me, that you're a new member of the guild, and not one of our attackers?"'''],
    [name(), '''nods''', hisher(), '''head.'''],
    ['''"Yes you're a new recruit, or yes you're an attacker?" asks the man dangerously, fingering his blade.''']])
    if itemspotionwars.whiteRibbon in inventory():
        moreyText = universal.format_text([moreyText, ['''"New recruit," says''', name(), '''quickly.''', HeShe(), '''pulls out Paloma's white ribbon. "See? Paloma gave this''',
        '''to me."'''],
        ['''"For helping her I take it?" The man reaches out and touches it. "Excellent. Good to know you're pulling your weight already. My name's Morey." He holds''',
        '''out his hand.''']])
    elif "Ildri_event" in keywords() and "Ildri_spanked_you_unjustly" in keywords():
        moreyText = universal.format_text([moreyText, ['''"No I'm not an attacker," says''', name(), '''quickly,''', hisher(), '''hands flying back to''', hisher(), 
        '''still tender bottom. "I promise, I promise, please don't spank me."'''],
        ['''The man stares at''', name(), '''in confusion for a moment. Then he throws his head back and laughs. Despite his small frame, he has a loud,''',
        '''booming laugh.'''],
        ['''Just when''', name(), '''starts to consider punching him, his laughter dies down.'''], 
        ['''"I take it you had a pleasant conversation with our dearest Ildri?" asks the man, wiping tears from his eyes.'''],
        ['''"That's one way of describing it I suppose," mutters''', name() + "."],
        ['''"Well don't worry, I'm not quite so quick to violence as our wonderful cook. Can't say the same about some of the other instructors, though. If you want''',
        '''to avoid that, I'd suggest going to the infirmary, back at the start of the hallway. She can give you a little ribbon that marks you as a member of the''',
        '''Guild. Might come in handy, all things considered," says the man. He holds out his hand. "Anyway, my name's Morey."''']])
        add_keyword('get_ribbon')
    else:
        moreyText = universal.format_text([moreyText, ['''"New recruit," says''', name(), '''quickly. "I promise."'''],
            ['''"Had you worried for a second there didn't I?" says the man, grinning.'''],
            [name(), '''scowls at him. "That's not funny. Especially considering this."''', name(), '''sweeps''', hisher(), '''arm out to indicate the pile of''',
                '''defeated enemies.'''],
            ['''"Really? I think it's hilarious. Still, I recommend you go see Paloma, our healer in the first room on the right after you enter the guild. If you''',
            '''can convince her that you're one of us, she can give you a little ribbon that verifies it. It'll be quite useful for you considering your resemblence''',
            '''to our attackers. Anyway, I'm Morey." He holds out his hand.''']])
        add_keyword('get_ribbon')
    moreyText = universal.format_text([moreyText, ['''"''' + name() + ''',"''', '''says''', name() + ",", '''taking his hand.'''],
        (['''Rather than shaking''', names(), '''hand, Morey sweeps into a bow, and kisses the back of''', hisher(), '''hand. He flashes''', himher(), 
            '''a bright grin. "Pleasure to meet you miss''', name() + '."'] if p.PC.is_female() else ['''Morey gives''', name(), '''a quick, firm handshake.''']),
        '''"Um..."''',
        ['''"Right, so how are things in the rest of the guild?" asks Morey, reclaiming his hand, and clapping. "Most of the attackers back here are woefully''',
        '''inexperienced. Barely more than rabble, really."'''],
        ['''"I think all their experienced fighters are in the main room," says''', name() + ",", '''pointing back towards the door. "Last I saw, the fighting there''',
        '''was pretty fierce."'''],
        ['''The man curses. "That's where I'm heading then. Did Adrian give you any orders?"'''],
        ['''"He told me to get down to the armory, and see if I can keep them from stealing any of our equipment," says''', name() + "."],
        ['''"Any more of our equipment would be more accurate," says Moray. "Well, get to it, time's a wasting. Now, if you'll excuse me."'''],
        ['''"Wait," says''', name(), '''quickly. "Can you give me any pointers?"'''],
        ['''Morey narrows one eye. "Well, your enemy's choice of weapon can give you a clue of their skills. If your opponent is wielding a spear, they're probably''',
            '''not very good at grappling, and prefer to keep their distance. Successfully grappling them can be a good way of shutting them down. By the same token''',
            '''if your enemy's using a dagger of some kind, they're keen on getting close to you. Keeping your distance can be invaluable when dealing with such''',
            '''enemies."'''],
        [name(), '''rolls''', hisher(), '''eyes. "Yes, yes, I already knew that. Anything useful?"'''],
        ['''"Well, I don't know what you know and don't know," says Morey testily. "I guess, one other thing is that your natural magic responds to threats in kind.''',
            '''You fight an opponent who is exceptionally strong, and you'll grow stronger. Fight an opponent who is very agile, and dextrous, and you'll grow''',
            '''more-"'''],
        ['''"Nevermind," says''', name(), '''waving''', hisher(), '''hand. "Get on out to the main room. I'll get down to the armory."'''],
        ['''"Right, then." The warrior nods, and runs out the door, weapons at the ready.''']])
    universal.say(moreyText, justification=0)
    add_keyword('helped_Morey')
    universal.acknowledge(dungeonmode.dungeon_mode, ())

def e1_7_3():
    if 'helped_Morey' in keywords() or 'met_Airell' in keywords():
        universal.say(universal.format_text([[name(), '''enters a large, open space. Blunted weapons of all shapes and sizes line the south wall. To''', names(), '''astonishment, there''',
        '''is a full length mirror hanging on the northern wall.''', name(), '''has never seen such a massive, expensive luxury.''']]))
    else: 
        universal.say_title('Combat Room')
        universal.say(universal.format_text([['''Directly to the west, in the center of the large room is a brutal melee. Six insurgents surround a whirling, slender''',
        '''pale-skinned man with jet black hair. He is holding a rapier in one hand, and a dueling dagger in the other. He runs one insurgent through, blocks another's attack''',
        '''with his dagger, and ducks under a third's spear thrust. A fourth, however, manages to club the warrior across the face with the the butt of his spear.''']]))
    universal.acknowledge(backOfGuild.display, ())
def e1_7_5():
    universal.say_title('Dining Room')
    if not 'first_time_in_dining_room' in keywords():
        add_keyword('first_time_in_dining_room')
        universal.say(universal.format_text([[name(), '''enters the dining room, and finds a battle nearly as pitched as the one in the main entrance. The massive dining table has been''',
        '''upended, and is covered in pockmarks, burns, and coats of ice. The deafening ring of steel on steel, howls of rage, and screams of pain batter against''', 
        names(), '''ears. An adventurer gets thrown into the wall next to''', name(), '''and he crumples. His attacker notices''', name() + ",", '''and the two''',
        '''watch each other warily for a moment. Then,''', name(), '''goes for''', hisher(), '''weapon, and battle is joined.''']]))
        insurgentScout = pwenemies.VengadorScout(random.randint(0, 1))
        universal.acknowledge(combat.fight, [insurgentScout], None, dungeonmode.dungeon_mode, False, None, False)
    else:
        universal.say(universal.format_text([[name(), '''enters the dining room, and finds a battle nearly as pitched as the one in the main entrance. The massive dining table has been''',
        '''upended, and is covered in pockmarks, burns, and coats of ice. The deafening ring of steel on steel, howls of rage, and screams of pain batter against''', 
        names(), '''ears.''']]))
        universal.acknowledge(dungeonmode.dungeon_mode, ())
floor1 = (
               #0    1     2     3      4     5    6     7     8     9   
            ( '__','___','___','___', '__', '__','___','___','___','___', '_'), 
            ('|  ','   ','   ','   ','|d ','|  ',' ! ','   ','   ','   ','|'),  #9
            ('|  ','   ','   ','   ','|  ','|  ','   ','   ',' ! ','   ','|'),  #8
            ('|  ',' * ','   ',' * ',';  ',';* ','   ','   ','   ',' ! ','|'),  #7 
            ('|  ','   ','   ','   ','|  ','|  ',' ! ',' ! ','   ','   ','|'),  #6
            ('|__','___','___','___','|  ','|__','___','___','___','_!_','|'),  #5
            ('|  ','   ','   ','   ','|  ','|  ','   ','   ','   ','   ','|'),  #4
            ('|  ','   ','   ','   ','|  ','|  ','   ','   ','   ','   ','|'),  #3
            ('|  ',' * ','   ',' * ',';  ',';* ','   ',' * ','   ','   ','|'),  #2 
            ('|  ','   ','   ','   ','|  ','|  ','   ','   ','   ','   ','|'),  #1
            ('|__','-%-','___','-%-','|_s','|__','___','___','___','___','|')   #0 
         )
floor1Events = (
              #0     1     2     3      4     5    6     7     8     9   
            (None, None, None, None, None, None, None, None, None, None),  #9
            (None, None, None, None, None, None, None, None, None, None),  #8
            (None,e1_7_1,None,e1_7_3,None,e1_7_5,None, None, None, None),  #7 
            (None, None, None, None, None, None, None, None, None, None),  #6
            (None, None, None, None, None, None, None, None, None, None),  #5
            (None, None, None, None, None, None, None, None, None, None),  #4
            (None, None, None, None, None, None, None, None, None, None),  #3
            (None,e1_2_1,None,e1_2_3,None,e1_2_5,None,e1_2_7,None, None),  #2 
            (None, None, None, None, None, None, None, None, None, None),  #1
            (None, None, None, None,e1_0_4,None, None, None, None, None)   #0
        )

def e0_8_4():
    if not 'first_time_on_bottom_floor' in keywords():
        add_keyword('first_time_on_bottom_floor')
        universal.say_title('Armory Floor')
        universal.say(universal.format_text([[name(), '''finds''', himselfherself(), '''in another dark corridor, though this one is made of stone, rather than wood. Just like above, the''',
        '''air is filled with the chaotic sounds of battle. However, the sounds aren't quite as overwhelming; likely the most intense fighting is still occuring''',
        '''upstairs.''','''Somewhere down here is the armory, and the end of''', names(), '''first "mission" with the Adventurer's Guild.''']]))
        universal.acknowledge(dungeonmode.dungeon_mode, ())
        
def e0_6_3():
    if 'met_Airell' in keywords():
        universal.say_title('Magic Training Room')
        universal.say(universal.format_line(['''In the center of the room are over half a dozen sniffling Taironans. Their pants (resp. skirts) are around their ankles (resp. waist),''',
        '''and their''', '''bottoms are an angry red. Airell has left, but his spell holding the Taironans aloft remains, forcing them to endure a unique''',
        '''(though ostentatious) version of "corner time."''']))
    else:
        universal.say_title('Magic Training Room')
        universal.say(universal.format_text([['''The next room is a large, open, bare space. The walls are covered in old scorch marks and water damage. Large chunks are missing from''',
        '''the walls.''',
                '''In the middle of the room, stands a slouching,''',
                '''exceptionally pale, man with out of control red hair and a big bushy red beard that extends all the way down to his chest. Hovering in the air''',
                '''above him are over half a dozen Taironan men and women, their bare''',
                '''bottoms''','''dark red. As''', name(), '''enters, the redheaded man snaps his wand through the air. In tandem, over half a dozen translucent,''',
                '''spectral hands''','''arc through the air and smack against over a dozen wobbling bottoms, and over a dozen cries of pain echo throughout''',
                '''the room.''']]))
    universal.acknowledge(dungeonmode.dungeon_mode, ())
def e0_6_1():
    if 'met_Airell' in keywords():
        universal.say_title('Punished Taironans')
        if 'spectral_caned' in keywords():
            universal.say([name(), '''glares up at the Taironans, who studiously ignore''', himher() + ".", HisHer(), 
                '''bottom still burns like the Dickens from that wretched caning. Wonder if Adrian would let''',himher(), 
                '''cane the lot of them when this was done?'''], justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        else:
            universal.say(universal.format_text([['''\n\nOne of the Taironans looks down at you. "Hey, think you could help us down? If we're here when the guards show up..." The Taironan''',
                '''shudders.'''],
                ['''"Even if I wanted to," says''', name(), '''looking up at the disembodied hands floating in the air. "How exactly would I do that?"'''],
                ['''"Do you know Distort Magic?" asks another Taironan through her tears. "If you do, that might be enough to break the hands."\n\n''']]), 
                    justification=0)
            if p.PC.knows_spell(spells_PotionWars.DistortMagic):
                universal.say(universal.format_text([['''It turns out that''', name(), '''does indeed know Distort Magic. Would''', heshe(), '''like to cast it on the spectral hands?''']]),
                        justification=0)
                universal.set_commands(['(Y)es', '(N)o'])
                universal.set_command_interpreter(e0_6_1_interpreter)
            else:
                universal.say(universal.format_text([['''"Sorry," says''', name(), '''shrugging. "But I don't know that spell."'''],
                    '''The other Taironans all groan.''',
                    '''"Well, if you happen to learn it before the guards show up, think you could let us down?" pleads the first Taironan. "Please?"''',
                    ['''"I'll think about it," says''', name() + "."]]), justification=0)
                universal.acknowledge(dungeonmode.dungeon_mode, ())
    else:
        add_keyword('met_Airell')
        universal.say_title('Airell')
        universal.say(universal.format_text([['''Drawing closer,''', name(), '''realizes that the spellslinger isn't holding a wand, but rather a switch. How comforting.'''],
            ['''As soon as''', name(), '''reaches the slinger, he spins, points at''', himher(), '''and snaps his fingers.''',
            '''A pair of translucent hands appear above the slinger.''',
            '''"I'll teach you to raid my guild!"''', '''The pair of hands snap towards''', name() + "."],
            ['''"Waagh!"''', name(), ''' hits the ground, and the two hands arc past''', himher() + ".", HeShe(), '''rolls to''', hisher(), '''feet and bolts for''',
                '''the far side of the room. "Wait, I'm a member of the Guild!"'''],
            ['''"Then why haven't I seen you before?" The two spectral hands fly towards''', name(), '''one high, one low.'''],
            [name(), '''feints left. The two hands fly left, and''', heshe(), '''pivots and scrambles to the right. "I just joined!"'''],
            ['''"A likely story," says the spellslinger. "However, I am aware of false flag operations."\n\n''']]))
        if itemspotionwars.whiteRibbon in inventory():
            universal.say(universal.format_text([[name(), '''curses, and whips off''', hisher(), '''pack.''', HeShe(), '''spins and throws the pack at the two hands. "Inside is a Ribbon''',
                '''from-yeep!" Though one of the hands slowed enough to catch the pack, the other rocketed for''', names(), '''torso.''', name(), '''falls backward''',
                '''watching as the hand zooms by inches from''', hisher(), '''nose. "From Paloma! Look, look!"'''],
                ['''"Hmmm." The slinger gestures, and the first hand carries the pack to the spellslinger's side.'''],
                [name(), '''sighs in relief, and starts to climb to''', hisher(), '''feet. But then the second hand grabs''', himher(), '''by nape of''', hisher(),
                    '''neck, and carries''', himher(), '''towards the slinger.'''],
                ['''"Hey!" cries''', name() + ".", '''"What's the big deal?"'''],
                ['''"I don't want to have to chase you around the room a second time if I decide you are lying," says the slinger as he roots through''', names(), 
                    '''pack.'''],
                ['''"Haven't you ever heard of privacy?" asks''', name() + " petulantly.", '''"Or how about trust?"'''],
                ['''"Privacy is for those with the power to enforce it," says the slinger. He pulls out the white ribbon. "And trust for those who have earned it."'''],
                ['''The slinger frowns as he studies the ribbon, and''', name(), '''holds''', hisher(), '''breath.'''],
                ['''"And it would seem that you have indeed earned it," declares the slinger. He gestures, and the two hands disappear, dropping''', name(), 
                    '''to the ground. "I apologize for that. When in battle, better to cast first, and ask questions later. What can I do for you?"'''],
                ['''"Well, I'm looking for the armory-"'''],
                ['''"Down the hall and to your right," says the slinger. He replaces the ribbon in''', names(), '''pack and hands it back to''', himher() + ".", 
                '''"Anything else?"'''],
                ['''"You a trai-"'''],
                ['''"I am," says the slinger. He draws himself up. "Names Airell, spectralslinger extraordinaire. Of course, I'm also quite good at the other schools."'''],
                ['''"Do you have any-"'''],
                ['''"I do," says the slinger. He holds one finger up. "Your magic is a beautiful, adaptive beast. It will develop itself in a way that reflects your''',
                    '''disposition. You want to learn spells of a particular type? Cast a lot of spells of that type. For example, if you want to unleash destructive''',
                    '''hell upon your enemies, sling a lot of Firebolts. If on the other hand you'd like to become the greatest Healer since...whoever the greatest''',
                    '''Healer is, sling Heal a lot."'''],
                ['''"I already-"'''],
                ['''Suddenly, the door bursts open, and''', '''Morey''' if 'helped_Morey' in keywords() else '''a lanky, raven-haired man''', 
                    '''burst into the room.'''],
                ['''"Morey!" roars Airell, shaking his fist. "You know you are not welcome in this hallowed room!"'''],
                ['''"Yeah, whatever," says Morey. "Look, Adrian wants you upstairs. Things are pretty ugly in the entranceway, and we need all the firepower we can''',
                    '''get if we want to keep these bastards locked in here until the guards arrive."'''],
                ['''"Very well," says Airell. He turns to''', name() + ".", '''"Fare well, young warrior. Always remember, magic is awesome. Also, don't mess with''',
                    '''these guys. Just leave them there."'''],
                ['''With that, Airell turns and runs out of the door with Morey.''']]), justification=0)
            universal.acknowledge(e0_6_1, ())
        else:
            universal.say(universal.format_text(['\p', ['''1. "Why won't anyone''' if 'Ildri_spanked_you_unjustly' in keywords() or 'met_Mai' in keywords() else
                '''you''', '''believe me?"'''], ['''2. "No no no I don't want to be spanked!"''']]), justification=0)
            if 'Ildri_spanked_you_unjustly' in keywords():
                universal.say(universal.format_line(['''\n\n3. "Arrgh! Stupid no good wretched dicks. It's bad enough I got beaten by that stupid cook, I'm not getting spanked by''',
                '''you too!"''']), justification=0)
            elif 'met_Mai' in keywords():
                universal.say(universal.format_line(['''\n\n3. "Arrgh! Stupid no good wretched dicks. It's bad enough I got beaten by that creepy-ass shadow chick, I'm not getting spanked''',
                '''by you too!"''']), justification=0)
            universal.set_commands(['(#) Select a number.'])
            universal.set_command_interpreter(e0_6_1_no_ribbon_interpreter)
        add_keyword('met_Airell')

def e0_6_1_no_ribbon_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1 or num == 2:
            if num == 1:
                universal.say(universal.format_text([['''"Because you have no proof," says Airell. He pulls out a white ribbon. "Every member of the Guild receives one of these from our''',
                    '''Healer Paloma. If you don't have one, then I have no choice but to assume that you are an enemy."'''],
                    ['''"Adrian never told me that," wails''', name() + ",", '''as''', heshe(), '''dodges a particularly fast attack by one of the hands.'''],
                    ['''"Indeed, mighty suspicious says I." Airell snaps his fingers. A translucent strap forms above his head. "Young''', manlady(), '''you have until''',
                    '''the count of three to stop and submit to your spanking, or you will get the strap."''']]), justification=0)
            if num == 2:
                universal.say(universal.format_text([['''"If you didn't want a spanking, then you shouldn't be attacking the guild," says Airell. "I have no sympathy for you."'''],
                    ['''"But I'm not attacking the guild. I'm a member, I swear," says''', name() + ".", '''A hand flies down from the roof.''', name(), '''rolls to''',
                        '''the left, then front flips away from a slanting assault by the second hand.'''],
                    ['''"If that were true, then you'd have proof." Airell pulls out a faintly glowing white ribbon. "This is given to every member of the guild by''',
                        '''our healer Paloma. If you don't have one, then I must assume you are an enemy."'''],
                    ['''"Adrian never told me that," cries''', name() + ".", '''The two hands fly towards''', himher(), '''from opposite sides.''', name(), 
                        '''backflips, and slams into the wall. The two hands collide with a resounding clap.'''],
                    ['''"Mighty suspicious says I." Airell snaps his fingers, and a translucent strap appears above his head. "Now, young''', manlady(), 
                        '''you have until the count of three to submit to your spanking, or you get the strap."'''],
                    ['''"But-"'''],
                    ['''"Enough of your whining," says Airell. "You are in desperate need of a right good paddling, and I intend to give it to you."''']]), justification=0)
            universal.say(universal.format_text(['\p', ['''1. Submit to the spanking.'''], ['''2. Keep dodging.''']]), justification=0)
            universal.set_commands(['(#) Select a number.'])
            universal.set_command_interpreter(e0_6_1_dodge_or_submit_interpeter)
        elif num == 3: 
            p.PC.receives_damage(1)
            increment_spankings_taken()
            add_keyword('spanked_by_Airell')
            universal.say(universal.format_text([[name(), '''lunges at the slinger,''', p.PC.weapon().name, '''leading. The slinger throws up his hand.''', name(), '''slams headfirst''',
                '''into something very hard, and very invisible.''', HeShe(), '''staggers, clutching at''', hisher(), '''head.'''],
                ['''The slinger grabs''', name(), '''by the arm. In one smooth, practiced motion, the slinger goes down on one knee, and hauls''', name(), '''across''',
                    '''his proferred thigh. He strikes''', names(), '''vulnerable''', p.PC.clothing_below_the_waist().name + "-clad bottom", '''sharply with the switch.'''],
                [name(), '''yelps as a line of fire lances across''', hisher(), '''bum.'''],
                ['''"Attack me will you," thunders the spellslinger. He grabs the''', items.waistbandhem(p.PC.clothing_below_the_waist()), '''of''', names(),
                    p.PC.clothing_below_the_waist().name,'''and''', 
                    items.lowerlift(p.PC.clothing_below_the_waist()) + "s", items.itthem(p.PC.clothing_below_the_waist()), 
                    universal.format_line(['''over''', names(), '''bottom and drapes it across''', hisher(), '''back''']) if 
                    p.PC.clothing_below_the_waist().armorType == items.Dress.armorType else universal.format_line(['''down to''', hisher(), '''knees.'''])],
                ['''He lays six stinging stripes across''', names(), universal.format_line(['''exposed bum cheeks.''', name(), '''wails and bucks through every''',
                '''blow. After the sixth stripe,''', name(), '''slumps across the slinger's thigh, and silently curses the uselessness''',
                    '''of''', hisher(), '''tiny''', p.PC.underwear().name + "."]) if (p.PC.lower_clothing().name != items.emptyLowerArmor.name and 
                    p.PC.underwear().name != items.emptyUnderwear.name and p.PC.underwear().baring) else
                    (universal.format_line(['''bare bum cheeks.''', name(), '''wails and kicks through every blow, not thinking how much''', heshe(), 
                        '''exposes to the slinger's''','''gaze. After the sixth stripe lands, the slinger pauses.''', name(), '''slumps across his thigh. After a''',
                        '''moment,''', name(), '''realizes just how much''', heshe(), '''must have exposed to the stranger.''', HeShe(), '''can't help but blush, and''',
                        '''curse''', hisher(), '''decision not to wear ''' + ('''underwear.''' if p.PC.lower_clothing().name != items.emptyLowerArmor.name else 
                        '''trousers or something.''')]) if (p.PC.underwear().name == items.emptyUnderwear.name or 
                        p.PC.lower_clothing().name == items.emptyLowerArmor.name) else
                        universal.format_line([p.PC.underwear().name + "-clad", '''bum cheeks.''', name(), '''squirms and yelps''', hisher(), '''way through every stripe.''',
                            '''Though''', hisher(), '''thin''', p.underwearpanties(), '''is''' if p.PC.is_male() else '''are''', '''clearly doing little to ease the sting,''', heshe(), 
                            '''is grateful for what little protection (and modesty) they provide.''']))],
                        [universal.format_line(['''Then, the slinger hooks his fingers in the waistband of''', names(), p.underwearpanties(), 
                            '''and pulls them halfway down''', hisher(),
                            '''thighs.''', universal.format_line([name(), '''grimaces. Looks like the skimpiness of''', hisher(), p.underwearpanties(), '''isn't going to matter''',
                                '''after all.''']) if p.PC.underwear().name != items.emptyUnderwear.name and p.PC.underwear().baring else universal.format_line([name(), '''groans, and buries''', hisher(), '''face in''', hisher(), 
                                    '''hands. So much for modesty.'''])]) if p.PC.underwear().name != items.emptyUnderwear.name and 
                                p.PC.lower_clothing().name != items.emptyLowerArmor.name else
                                universal.format_line(['''The slinger rubs the switch''','''against''', names(), '''hot, vulnerable bottom, preparing to give''', himher(), 
                                    '''another set of stripes.'''])],
                        ['''Before he can continue the switching, however,''', '''Morey''' if 'helped_Morey' in keywords() else '''a raven-haired, thin, white-skinned man''',
                            '''bursts into the room.''', '''"Airell!"'''],
                        ['''"Morey!" roares Airell, shaking his fist, and nearly knocking''', name(), '''off his knee. "How dare you barge in uninterrupted like''',
                            '''this!"'''],
                        ['''"Pretty sure you mean unannounced," says Morey, smirking.'''],
                        ['''"Whatever," roares Airell. "What do you want?"'''],
                        ['''Morey glances at''', name() + ".", '''Morey frowns, and gestures at''', names(), '''half-dressed state, and precarious position.''', 
                            '''"Erm, Airell, you do know''', heshe(), '''is a member of the Guild, right?"'''],
                        ['''"What are you talking about?" snaps Airell.''', '"' + HeShe(), '''doesn't have a ribbon."'''],
                        ['''"Is that so? How odd." Morey's eyes narrow, and he gives''', name(), '''a stern glare.''', name(), '''returns the glare with''',
                            '''a sheepish smile. "I distinctly remember telling''', himher(), '''to go see Paloma before''', heshe(), '''did anything else."'''],
                        ['''"Heh heh, oops? Oww," says''', name() + ",", '''reaching back to touch the hot stripes spaced evenly up and down''', hisher(), '''bottom.'''],
                        ['''"We'll discuss this more later," says Morey, snapping his attention back to Airell. "For now, Airell, let''', himher(), '''up, and let's''',
                        '''go. Adrian needs us upstairs, and he needs us ten minutes ago.'''],
                        ['''Airell helps''', name(), '''clamber off his thigh. "Terribly sorry''', p.ladlass() + ".", '''We all make mistakes sometimes."''']]),
                        justification=0)
            if 'helped_Morey' in keywords():
                add_keyword('talk_with_Morey')
            universal.say('\p', justification=0)
            universal.say(universal.format_text([['''1. Sock him in the face.'''], '''2. Glower at him.''', 
                ['''3. "Indeed. Why, just the other day I kicked a puppy because I thought''',
                '''it was a vicious attack dog."'''], '''4. "Don't worry about it. It's understandable."''']), justification=0)
            universal.set_command_interpreter(e0_6_1_attack_mage_interpreter)
def e0_6_1_dodge_or_submit_interpeter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 2:
            universal.say(universal.format_text([['''"1."'''],[name(), '''dashes for the door, only for one of the hands to snap down in front of it.''', HeShe(), '''falls into a roll''',
                '''slamming into the door directly below the hand.'''],
                ['''"2."'''],
                [name(), '''throws''', himselfherself(), '''to the left, missing the first hand's thumb by a hair, as it slams into the ground where''', 
                    heshe(), '''was previously lying.'''],
                ['''"3."'''],
                ['''The other hand floats down right in front of''', names(), '''face, as if taunting''', himher() + ".", HeShe(), '''scrambles to''', 
                    hisher(), '''feet, but  the hand latches onto''', 
                    hisher(), '''wrists.'''],
                ['''"No, no no!" cries''', name(), '''digging''', hisher(), '''heels in.''', '''The hand starts to drag''', himher(), '''forward, and''', name(), 
                    '''is forced to bend over, and walk forward a few steps to maintain''', hisher(), '''balance.'''],
                ['''Out of the corner of''', names(), '''eye,''', heshe(), '''sees the magical strap start to float towards''', himher() + ".", '''"No no no!"'''],
                ['''Then the door flies open, and slams into''', names(), '''behind.''', name(), '''goes sprawling forward, yelping in pain and surprise.'''],
                ['''"Airell!" snaps''', '''Morey.''' if 'helped_Morey' in keywords() else 'a thin, raven-haired man.'],
                ['''"Morey!" roars Airell, shaking his fist. "How dare you and your crass method of combat stain this hollowed room."'''],
                ['''Morey narrows one eye. "I think you meant hallowed."'''],
                ['''"Whatever!" roars Airell, his voice boaming throughout the room.''', name(), '''thinks''', heshe(), '''can even hear a bit of thunder. "What do''',
                    '''you want?"'''],
                ['''"We're getting hurt pretty badly upstairs," says Morey. "We need you upstairs, and we need you now."'''],
                ['''"But what about''', himher() + '?"', '''asks Aidell, pointing his switch at''', name()],
                ['''Morey glances at''', name() + ".", universal.format_text([['''He breaks into a smile. "Oh,''', himher() + "?", HeShe() + "'s", 
                    '''cool. Helped me upstairs."'''],
                ['''"So''', heshe(), '''is a member of the guild?" says Airell.'''],
                ['''"Yup," says Morey, smirking.'''],
                ['''For a moment, Airell deflates. But then he puffs out his chest, and starts flailing his arms through the air. "Then why doesn't''', heshe(), 
                '''have a White Ribbon?"'''],
                ['''Morey's eyes narrow. He turns and looks at''', name() + ",", '''who grins sheepishly. "Indeed. I thought I told you to go see Paloma."'''],
                ['''"I might have forgotten?" says''', name() + ",", '''hesitantly.'''],
                ['''"Get up and see her now," says Morey in a stern voice. "Then get your ass to the armory. We'll discuss this more later. Airell, come on we need''',
                '''to go."'''],
                ['''The two trainers run out the door, leaving''', name(), '''to regain''', hisher(), '''feet, and wonder a touch anxiously about what Morey meant by''',
                    ''''dicussing this more'.''']]) if 'helped_Morey' in keywords() else universal.format_text([['''Morey glances at''', name() + ".", '''"Hey, I think Adrian''',
                        '''gave me''', hisher(), '''description.''', HeShe(), '''is a new member of the guild, who may not have had a chance to see Paloma for a''',
                        '''white ribbon yet."'''],
                        ['''"I see," says Airell, deflating slightly. "Well, I apologize young''', mistermiss() + ".", '''I hope you understand, it is difficult to''',
                            '''tell friend from foe in combat, and a mistake can be deadly."'''],
                        [name(), '''smiles sickly. "Yeah, sure, understandable."'''],
                        ['''"You should get upstairs and see Paloma as soon as possible if you plan on trying to help out anywhere else," says Morey. "Things are''',
                            '''rough enough without us fighting each other. As for you Airell, we need to go. Now."'''],
                        ['''"Very well." Airell runs out the door with Morey, leaving''', name(), '''to pick''', himselfherself(), '''back up.''']])]]), 
                    justification=0)
            if 'helped_Morey' in keywords():
                add_keyword('talk_with_Morey')
            else:
                add_keyword('get_ribbon')
        elif num == 1:
            increment_spankings_taken()
            add_keyword('spanked_by_Airell')
            universal.say(universal.format_text([[name(), '''stops, and sighs.''', HeShe(), '''morosely turns''', hisher(), '''bottom towards the spellslinger, bends over, and grasps''', 
                hisher(),'''knees.'''],
                ['''"Excellent," says the slinger, clapping his hands together. "Because of your cooperation, you will receive your spanking over your''', 
                    p.PC.clothing_below_the_waist().armorType, '''rather than on the bare."'''],
                ['''One of the hands lightly grasps''', names(), '''torso, holding''', himher(), '''in position. The other takes up position behind''', name() + ".",
                    name(), '''screws''', hisher(), '''eyes shut, and takes slow, deep breaths.'''],
                ['''With a loud clap, the hand smacks''', p.PC.clad_bottom() + ".", name(), '''gasps, as a shock of pain''',
                    '''spreads across''', hisher(), '''bottom.'''],
                ['''"Attack our guild will you?" The hand strikes''', names(), '''bottom a second time.''', name(), '''hisses, and bobs''', hisher(), '''bottom.''',
                    '''The spectral hand is more than large enough to cover''', hisher(), '''entire bottom, and each blow has the sting of a''', 
                    '''million''' if p.PC.lower_clothing().name == items.emptyLowerArmor.name and p.PC.underwear().baring else ('''thousand''' 
                        if p.PC.lower_clothing().name == items.emptyLowerArmor.name else '''hundred'''), '''hornets.'''],
                ['''"We have done nothing to hurt any of you," says the slinger. "Why, we even hire Taironans. Who else does that, aside from the lord when he's''',
                '''desperate for every pair of hands he can get into the fields?"'''],
                ['''The hand cracks against''', names(), p.PC.clothing_below_the_waist().name + "-clad bottom", '''a third time.''', name(), '''moans, and tightly squeezes''', hisher(), '''knees.''', 
                universal.format_line(['''Even with the protection of''', hisher(), p.PC.clothing_below_the_waist().name, '''each blow hurts like hell.''', HeShe(), 
                    '''couldn't even begin to imagine how much it must hurt on the bare.''']) if p.PC.lower_clothing().name != items.emptyLowerArmor.name or 
                    not p.PC.underwear().baring else universal.format_line(['''A few tears trace their way down''', names(), '''cheeks.''', HeShe(), '''takes a deep, shuddering''',
                        '''breath, and silently curses''', hisher(), '''decision to wear so little clothing. Even a pair of''', p.underwearpanties(), '''that actually''',
                        '''covered''', hisher(), '''bottom, let alone thick trousers or a multi-layered dress, would be precious.'''])],
                ['''Before a fourth blow could land, the door flies open and''', '''Morey''' if 'helped_Morey''' in keywords() else '''a thin, pale, raven-haired man''',
                    '''bursts into the room.'''],
                ['''"Morey!" roars Airell, shaking his fist. "How dare you and your crass method of combat stain this hollowed room!"'''],
                ['''Morey narrows one eye. "I think you meant hallowed."'''],
                ['''"Whatever!" roars Airell, his voice boaming throughout the room.''', name(), '''thinks''', heshe(), '''can even hear a bit of thunder. "What do''',
                    '''you want?"'''],
                ['''"We're getting hurt pretty badly upstairs," says Morey. "We need you upstairs, and we need you now."'''],
                ['''"But what about''', himher() + '?"', '''asks Aidell, pointing his switch at the bent over form of''', name()],
                ['''Morey glances at''', name() + ".", universal.format_text([['''He frowns. "Oh,''', himher() + "?", HeShe() + "'s", 
                    '''cool. Helped me upstairs. Also, why are you spanking''', himher() + "?"],
                ['''"So''', heshe(), '''is a member of the guild?" says Airell.'''],
                ['''"Yup," says Morey, smirking.'''],
                ['''For a moment, Airell deflates. But then he puffs out his chest, and starts flailing his arms through the air. "Then why doesn't''', heshe(), 
                '''have a White Ribbon?"'''],
                ['''Morey's eyes narrow. He turns and looks at''', name() + ",", '''who grins sheepishly. "Indeed. I thought I told you to go see Paloma."'''],
                ['''"I might have forgotten?" says''', name() + ",", '''hesitantly. The hand holding''', himher(), '''down dissipates, and''', heshe(), 
                    '''stands, rubbing''', hisher(), '''stinging bottom.'''],
                ['''"I see. Well, get up there and see her now," says Morey in a stern voice. "Then get your ass to the armory. We'll discuss this more later. Airell,''',
                '''come on we need''','''to go."'''],
                ['''The two trainers run out the door.''', name(), '''rubs''', hisher(), '''face with one hand, and rubs''', hisher(), '''bottom with the other.''', 
                HeShe(), '''wonders with a touch of anxiety what Morey meant by''',
                    ''''dicussing this more'.''']]) if 'helped_Morey' in keywords() else universal.format_text([['''Morey glances at''', name() + ".", '''"Hey, I think Adrian''',
                        '''gave me''', hisher(), '''description.''', HeShe(), '''is a new member of the guild, who may not have had a chance to see Paloma for a''',
                        '''white ribbon yet. So, you should probably stop spanking''', himher() + "."],
                        ['''"I see," says Airell, deflating slightly. "Well, I apologize young''', mistermiss() + ".", '''I hope you understand, it is difficult to''',
                            '''tell friend from foe in combat, and a mistake can be deadly."'''],
                        [name(), '''smiles sickly. The hand holding''', himher(), '''down dissipates, and''', heshe(), '''straightens.''', HeShe(), '''gives''', 
                            hisher(), '''bottom a vigorous rub. "Yeah, sure, understandable."'''],
                        ['''"You should get upstairs and see Paloma as soon as possible if you plan on trying to help out anywhere else," says Morey. "Things are''',
                            '''rough enough without us fighting each other. As for you Airell, we need to go. Now."'''],
                        ['''"Very well." Airell runs out the door with Morey, leaving''', name(), '''to pick''', himselfherself(), '''back up.''']])]]), 
                    justification=0)
            if 'helped_Morey' in keywords():
                add_keyword('talk_with_Morey')
            else:
                add_keyword('get_ribbon')
        e0_6_1()
def e0_6_1_attack_mage_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''Airell's nose crunches most satisfactorily against''', names(), '''fist. The slinger falls flat on his back, while his nose realigns''',
                '''itself.''', name(), '''has only an instant to savor it, however, before''', heshe(), '''finds''', himselfherself(), 
                '''bent underneath Morey's arm,''',
                '''with''', hisher(), universal.format_line(['''trousers around''', hisher(), '''ankles''']) if p.PC.clothing_below_the_waist().armorType == items.Pants.armorType
                    else (universal.format_line([p.PC.clothing_below_the_waist().armorType, '''scrunched up around''', hisher(), '''waist''']) if 
                    p.PC.clothing_below_the_waist().armorType == items.Skirt.armorType or p.PC.clothing_below_the_waist().armorType == items.Dress.armorType else 
                    universal.format_line([p.underwearpanties(), '''around''', hisher(), '''thighs'''])) + (universal.format_line([''' and''', hisher(), p.underwearpanties(), 
                        '''around''', 
                        hisher(), '''thighs.''']) if p.PC.clothing_below_the_waist().armorType != items.Underwear.armorType and 
                        p.PC.underwear().name != items.emptyUnderwear.name else '''.''')],
                        ['''Morey's hand beats a rapid-fire tattoo against''', names(), '''already heavily welted bottom. "You only strike an instructor like that if''',
                            '''they threaten your safety, and only then. Do I make myself clear?"'''],
                        [name(), '''squeals and kicks beneath Morey's hard, calloused hand. The man might have been a stick, but weak he wasn't.'''],
                        ['''"Do I make myself clear?" snaps Morey.'''],
                        ['''"Yes!" cries''', name() + ".", '''Between Airell's stripes, and Morey's bruising hand, any feelings of rebellion that''', name(), 
                            '''may have felt were thoroughly quashed.'''],
                        ['''"Good." Morey pulls''', name(), '''erect, spins''', himher(), '''around, and lands two more sharp blows to''', names(), '''bottom.''',
                            '''"Now apologize to Airell, and we can get on with repulsing this cursed attack."'''],
                        ['''"I'm sorry," says''', name(), '''hanging''', hisher(), '''head.'''],
                        ['''"If you think you're going to get off with just a hand spanking from Morey for this, you've got a surprise coming," says Airell in a''',
                        '''low, dangerous voice. "However, we don't have time to deal with this now. Get on with whatever you're here to do, and let Morey and I''',
                        '''get upstairs."'''],
                        [name(), '''nods and quickly covers''', himselfherself(), '''again.''', HeShe(), '''doesn't know if''', heshe(), '''should feel relief, or''',
                        '''worry.''', '''On the one hand, any minute not spent feeling that awful switch was a moment to be cherished. On the other hand,''', heshe(),
                        '''would have to deal with it later, and that didn't sound fun.''']]))
            add_keyword('punched_Airell')
            e0_6_1()
        elif num == 2:
            add_keyword('future_fight_with_Airell')
            universal.say(universal.format_text([['''"Well, I suppose that's the best I could hope for in the circumstances," says Airell, smiling awkwardly. "Morey, let's go."'''],
                ['''Morey nods, and the two leave to aid their companions upstairs. Meanwhile''', name(), '''covers up''', hisher(), '''stinging bottom, and''',
                '''wonders absently if''', heshe(), '''will ever be strong enough to punch Airell in the face without fear of repercussion.''']]))
            e0_6_1()
        elif num == 3:
            universal.say(universal.format_text(['''"Are you mocking me?" asks Airell, his eyes narrowing.''']))
            universal.say('\p')
            universal.say(universal.format_text(['''1. Smile innocently.''', ['''"2. No, no no. Of course I'm not mocking you. Why would I mock such a tremendously powerful mage, who''',
                '''couldn't be bothered to take thirty seconds to figure out friend from foe."'''], '''3. "Yes."''']), justification=0)
            universal.set_commands('(#) Select a number.')
            universal.set_command_interpreter(e0_6_1_mocking_interpreter)
        elif num == 4:
            universal.say(universal.format_text([['''Airell looks at''', name(), '''in surprise. "Just like that? Boy, you're a nicer person than I am."'''],
                ['''"I'd just rather not get spanked any more," admits''', name() + ",", '''rubbing''', hisher(), '''stinging bottom.'''],
                ['''Airell chuckles. "Point taken. Alright, Morey, let's go."'''],
                ['''The two instructors hasten out of the room, leaving''', name(), '''to''', hisher(), '''own devices.''']]))
            e0_6_1()

def e0_6_1_mocking_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''Airell eyes''', name(), '''suspiciously. "I'd recommend watching your tongue, young''', manlady(), '''if you enjoy sitting."'''],
                ['''"Come on Airell, we don't have time for this," says Morey. "Besides,''', heshe(), '''makes a good point."'''],
                ['''"I don't like being mocked," says Airell, continuing to glower at''', name(), '''.'''],
                ['''"Then why do you make it so easy?" asks Morey.'''],
                ['''Airell turns his glower on Morey. He tugs on his beard. "I suppose you have a point. Let's go." He turns one last glare on''', name() + ".", 
                    '''"And you,''', mistermiss(), '''consider yourself warned."'''],
                ['''The two instructors run out the door, while''', name(), '''sticks''', hisher(), '''tongue out after them, and readjusts''', hisher(), 
                    '''clothing.''']]))
        elif num == 2:
            universal.say(universal.format_text([['''Morey groans.'''], 
                ['''"I will not stand here and be mocked!" roars Airell, driving his switch up above his head. He points his other finger at''', name() + ",", 
                    '''who takes a step back, despite''', himselfherself() + ".", '''"When we are done driving these foul thugs from our home, you and I will sit''',
                    '''down and have a long talk. And by sit down I mean you draped over my lap, and by talk I mean a thorough paddling that will have you crying''',
                    '''and begging me to stop afore we are even half done!"'''],
                ['''"And by long?" asks''', name() + "."],
                ['''"Exactly that," says Airell, glaring at''', name() + ".", '''There is a great crack of thunder.'''],
                ['''"Yes, yes, yes, and there will be wailing and gnashing of teeth," says Morey, rolling his eyes. "Let's go, Airell."'''],
                ['''"Very well," says Airell, giving''', name(), '''one last glare.'''],
                ['''The two instructors leave, leaving''', name(), '''to readjust''', hisher(), '''clothing, and reflect on the wisdom of mocking an experienced''',
                    '''spellslinger, no matter how deserving he may be.''']]))
            add_keyword('talk_with_Airell')
        elif num == 3:
            universal.say(universal.format_text([['''Airell and''', name(), '''glare at each other. Then, Airell throws his head back and laughs a great booming laugh that makes''',
                name(), '''jump.'''],
                ['''"Aye, aye I suppose it was a stupid question," says Airell. "And I suppose it was well-deserved. And I appreciate your honesty, boldness''', 
                '''and wisdom in backing down. I like you, you are a worthy addition to this Guild!'''],
                ['''"Yes, yes, yes," says Morey impatiently. "Let's go before you try to adopt''', himher(), '''or something."'''],
                ['''"Aye, I suppose we should go," says Airell. He salutes''', name() + ".", '''"Farewell young one. Always remember, magic beats steel any day."'''],
                ['''Morey rolls his eyes again, and the two leave, leaving''', name(), '''alone to fix''', hisher(), '''clothing.''']]))
        e0_6_1()


def e0_6_1_interpreter(keyEvent):
    if keyEvent.key == K_y:
        if p.PC.mana() >= spells_PotionWars.DistortMagic.cost:
            increment_spankings_taken()
            add_keyword('spectral_caned')
            p.PC.uses_mana(spells_PotionWars.DistortMagic.cost)
            universal.say(universal.format_text([[name(), '''holds up''', hisher(), '''hands, and focuses. A blanket of chaotic, seizure-inducing colors erupt from''', hisher(), 
            '''outstretched hands, and blanket the spectral constructs. For a moment, the hands wobble, and everyone lets out a cheer. Then, the chaotic colors fly away''',
            '''from the hands, and condense into a large sphere. The sphere begins spinning, ever faster and faster. Then the sphere explodes, and the colors fly''',
            '''throughout the room, disappearing as soon as they touch a wall, or a person. In the place of the sphere is another spectral hand, and a long,''',
            '''thick spectral cane.'''],
            ['''"Oh dear," says''', name(), '''backing up a step.'''],
            ['''The hand flies towards''', name() + "."],
            [name(), '''ducks the hand, its fingers missing''', himher(), '''by inches.''', HeShe(), '''bolts for the door. The cane shoots through the air and snaps''',
                '''down horizontally in front of the door.''', name(), '''skids in a desperate attempt to stop, and falls flat on''', hisher(), '''butt.''', 
                HeShe(), '''rolls onto''', hisher(), '''hands and knees, and then begins to scramble to''', hisher(), '''feet. The cane swishes through the air, and''',
                '''cracks against''', hisher(), '''upthrust bottom.'''],
            [name(), '''yelps, and falls back onto''', hisher(), '''hands and knees.''', HeShe(), '''flattens, and rolls, the cane swishing inches above''', hisher(),
                '''head.''', HeShe(), '''gets back to''', hisher(), '''feet, and then bends over to dodge another attack from the hand. The cane whishes back''',
                '''around and cracks against''', hisher(), '''bottom a second time.'''],
            [name(), '''cries out, and half hops, half runs forward.'''],
            ['''The hand flies towards''', himher(), '''a third time. As''', heshe(), '''twists around the outstretched fingers, the cane cracks against''', hisher(),
                '''bottom a third time, pushing''', himher(), '''right into the hand's mystic grip.'''],
            ['''As soon as''', heshe(), '''touches the translucent palm, the hand's fingers snap closed around''', himher() + ".", name(), '''squirms desperately,''',
                '''but the hand has the strength of ten giants. The hand bends''', name(), '''over into the proper caning position.'''],
            ['''Another, smaller hand materializes, and grabs''', names(), p.PC.clothing_below_the_waist().name, '''and''', universal.format_line(['''drapes it across''', 
                names(), '''back,''']) if p.PC.clothing_below_the_waist().armorType == items.Dress.armorType else 
                universal.format_line(['''pushes it up over''', names(), '''round, quivering bottom,''']) if p.PC.clothing_below_the_waist().armorType == items.Skirt.armorType
                    else universal.format_line(['''pulls''', items.itthem(p.PC.clothing_below_the_waist()), '''down to''', names(), '''ankles,''']), 
                    universal.format_line(['''exposing''', hisher(), p.PC.underwear().name + "."]) if p.PC.clothing_below_the_waist().armorType != items.Underwear.armorType else 
                    universal.format_line(['''completely baring''', hisher(), '''bottom.'''])],
            [universal.format_line(['''The hand doesn't stop there however, and with a quick tug, yanks''', names(), p.underwearpanties(), '''down to''', hisher(), '''knees,''',
                '''completely baring''', hisher(), '''bottom to the menacing cane.''']) if p.PC.clothing_below_the_waist().armorType != items.Underwear.armorType else
                universal.format_line([name(), '''gnaws nervously on''', hisher(), '''lower lip lands two sharp slaps to''', hisher(), 
                    '''exposed derrier before vanishing.'''])]]), justification=0)
            universal.say('\p')
            universal.say(universal.format_text([['''1. "Wait, wait I'm sorry, I'm sorry, I won't do it again, please don't cane me!"'''], 
                ['''2. "Stupid slinger could have warned me.'''],
                ['''3. "Yeah, come on what are you waiting for! Go ahead and''',
                    '''cane me you mindless magical construct! Come on, I dare ya!"''']]), justification=0)
            universal.set_command_interpreter(e0_6_1_caning_interpreter)
            universal.set_commands('(#) Select a number.')
        else:
            universal.say([['''Oops. Looks like''', name(), '''doesn't have enough mana to cast Distort Magic.''']], justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
    elif keyEvent.key == K_n:
        universal.say(universal.format_text([[name(), '''eyes the large disembodied hands warily. "Sorry guys, but if there's one thing Nana taught me, it was not to mess with a''',
            '''slinger's''','''enchantments."'''],
            ['''"Aw, come on," says a Taironan. "Can't you risk yourself a little bit for your fellow Taironans?"'''],
            ['''"Well, considering you'd probably be trying to gut me right now if you weren't hanging there with your pants around your ankles, I think not," says''',
                name() + "."],
            ['''The Taironans all groan, and resign themselves to their rather embarassing fate.''']]), justification=0)
        universal.acknowledge(dungeonmode.dungeon_mode, ())
def e0_6_1_caning_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if 1 <= num and num <= 3:
            universal.say(universal.format_text([['''As''', name(), '''is about to discover, it doesn't matter what you say to mindless magical constructs. They'll still cane the''',
            '''bejeezus out of you.'''],
            ['''Vip!'''],
            [name(), '''shrieks as a sharp line of pain flares across the center of''', hisher(), '''bottom.''', HeShe(), '''twists and flails frantically in the''',
                '''iron grip of the spectral hand. Then the cane strikes again, this time cutting across the fleshy lower part of''', names(), '''bottom.''', name(),
                '''howls again. The howls only begin to fade, when the cane strikes a third time, this time slicing across the middle-upper part of''', names(), 
                '''cheeks.''', HisHer(), '''howl rises again to a fever pitch, and''', heshe(), '''begins to blubber like a naughty slinger apprentice.'''],
            ['''All in all, the spectral cane gives''', name(), '''six horrible, burning stripes before fading. As soon as the spectral hand fades,''', name(), 
                '''falls to''', hisher(), '''hands and knees and clutches at''', hisher(), '''fiery bottom.'''],
            ['''"Sorry," says the second Taironan sheepishly. "Didn't realize there was a trap on the enchantment."'''],
            [name(), '''scowls up at the Taironan. "You're so lucky you're out of reach right now."'''],
            ['''The Taironan smiles uneasily. "So, uh you going to leave and do whatever you're here to do?"'''],
            [name(), '''grumbles something less than pleasant as''', heshe(), '''regains''', hisher(), '''feet.''', HeShe(), '''winces, and gingerly rubs''', hisher(),
                '''bottom while considering''', hisher(), '''next move.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
    
            
def e0_8_5():
    universal.say_title('Grappling Room')
    if not 'met_Cosima' in keywords():
        universal.say(universal.format_line(['''Another large, open room. However, unlike the others, in this one there is a large, hay-filled sack covering most of the floor like some''',
            '''sort of carpet for lovers of all thing stables. Scattered about the room are several Vengadores, all lying on the ground, clutching at their bare''',
            '''bottoms. In the center of the room is a tall, lanky, middle-aged woman with olive-skin, dark hair and matching eyes. She has managed to wrestle''',
            '''a Taironan''','''into the diaper position, and is vigorously spanking the other woman's exposed ass with a small paddle.''']))
    else:
        universal.say(universal.format_line(['''Other than the chastised Vengadores scattered about, the room is empty; Cosima has left to aid in repulsing the attackers.''']), 
                justification=0)
    universal.acknowledge(dungeonmode.dungeon_mode, ())
def e0_8_7():
    universal.say_title('Cosima')
    if not 'met_Cosima' in keywords():
        add_keyword('met_Cosima')
        universal.say(universal.format_text([['''As''', name(), '''warily approaches the woman, she looks up from her latest victim. Her eyes narrow.'''],
            [name(), '''stops,''', hisher(), '''heart pounding.''',
            universal.format_line([HeShe(), '''has a terrible feeling''', heshe(), '''is going to wind up getting spanked again.''']) 
            if 'Ildri_spanked_you_unjustly' in keywords() or 
                'spanked_by_Airell' in keywords() or 'Ildri_no_pants' in keywords() else universal.format_line([HeShe(), '''desperately hopes this woman gives''', himher(), 
                '''a chance to explain.'''])],
            ['''The woman's eyes flick over''', name() + ".", '''She drops the Taironan's legs, and stands. She gives the paddled Taironan a gentle nudge, and the''',
            '''chastised woman rolls away, whimpering and clutching at her bottom. "Another attacker? You're not wearing a mask. Who are you? Quickly now."''']]),
            justification=0)
        universal.say('\p')
        if itemspotionwars.whiteRibbon in inventory():
            universal.say(universal.format_text([['''"I'm a member of the Guild. I joined just before the attack."''', name(), '''quickly pulls out the white ribbon given to''', himher(),
                '''by Paloma. "Here, Paloma gave me this."'''],
                ['''The woman takes the ribbon and studies it for a moment. Then she smiles and hands it back. "Welcome to the Guild. My name is Cosima, I'm the''',
                    '''grappling instructor. Seems you picked an interesting time to join."'''],
                [name(), '''nods a bit weakly. "Could say that again."'''],
                ['''"Speaking of interesting," says Cosima. "Do you have any idea what's going on? One minute I was in here stretching, the next a group of''',
                    '''thugs burst in and attacked me."'''],
                ['\p'],
                ['''1. "A Taironan gang with delusions of grandeur is attacking. They seem to think they're fighting to liberate us all from our Carnutian''',
                    '''opressors. Honestly, I doubt they'll be a big deal to a group as experienced as all of you."'''],
                ['''2. "A group of Taironans who've finally gotten sick and tired of being ground into the dirt are fighting back."'''],
                ['''3. LIE: "I don't know, actually. I was in the middle of signing up, when a bunch of masked people burst in and attacked."'''],
                ['''4. "I'd rather not say."''']]), justification=0)
            universal.set_commands('(#) Select a number.')
            universal.set_command_interpreter(cosima_whiteRibbon_interpreter)
        else:
            universal.say(universal.format_text([['''"I'm a member of the Guild. I joined just before the attack," says''', name() + "."],
                ['''"Oh?" says the woman. "That would explain why I don't recognize you. Do you have a ribbon?"''']]), justification=0)
            if 'get_ribbon' in keywords():
                universal.say(universal.format_text([['''\n\n"Oh, right, Morey told me about that," says''', name() + ".", '''"He said I should talk to Paloma."'''],
                    ['''"And have you?" presses the woman.''']]))
                universal.say('\p')
                universal.say(universal.format_text([['''1. ''' + ('''LIE: ''' if 'failed_to_help_Paloma' in keywords() else '') + '''"Well, no. Not exactly."'''], 
                                 ['''2. "Of course not! We're being attacked by a gang of thugs. We don't have time for silly things like ribbons!"''']]),
                                 justification=0)
                if 'failed_to_help_Paloma' in keywords():
                    universal.say(universal.format_text([['''\n\n3. "Well, erm, yes, yes I did, but she didn't give me a ribbon."\n\n''']]), justification=0)
                universal.set_commands('(#) Select a number.')
                universal.set_command_interpreter(cosima_failedPaloma_interpreter)
            else:
                universal.say(universal.format_text([['''\n\n"Ribbon?" asks''', name() + ".", '''"What do you mean ribbon?"'''],
                    ['''Cosima's frown deepens. Her hand tightens on her paddle, and she takes a half-step towards''', name() + ".", '''She is almost, but not quite,''',
                        '''subtle enough for''', name(), '''not to notice. "I find that very, very suspicious. The ribbons are one of the first things Adrian''',
                        '''discusses."'''],
                    ['''"Well, like I said, I signed up, then the Guild was attacked," says''', name() + ".", HisHer(), '''eyes flick about the room, lingering''', 
                        '''on the well-spanked men and women scattered about the room.''', HeShe(), '''backs up a step, and Cosima follows. "Really."'''],
                    ['''"How very convenient," says Cosima.''']]), justification=0)
                universal.say('\p')
                universal.say(universal.format_text(['''1. Make a run for it.''', 
                                ['''2. Turn around and bend over.'''], 
                                ['''3. "Globos de la Madre, this is so stupid! Your precious Guild is being''',
                    '''attacked by La Madre only knows who, they're making off with hundreds if not thousands of coins worth of equipment, at least one person''',
                    '''is probably seriously hurt, and the damage everyone is doing to this place will take months if not years to repair, and you're standing here''',
                    '''getting ready to spank me? In case you haven't noticed, the Vengadores have this obnoxious habit of attacking anyone who isn't them.''',
                    '''See me, standing here not attacking you? Can't that be enough to convince you I'm not your enemy?''']]), justification=0)
                universal.set_commands('(#) Select a number.')
                universal.set_command_interpreter(cosima_noRibbon_interpreter)

def cosima_failedPaloma_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 3 and 'failed_to_help_Paloma' in keywords():
            universal.say(universal.format_text([['''The instructor frowns. "Why not?"'''],
                ['''\p'''],
                ['''1. LIE: "Because she's a jerk, who refused to help me."'''],
                ['''2. "Well, see, she was kind of getting strapped by a couple of Vengadores, and I kind of didn't help her."'''],
                ['''3. "Oh, you know. She probably forgot what with all the craziness of the attack, and all."''']]), justification=0)
            universal.set_command_interpreter(cosima_failedPaloma_why_interpreter)
            universal.set_commands('(#) Select a number.')
        elif num == 1:
            universal.say(universal.format_text([['''The woman rolls her eyes. "And why, exactly, haven't you gone to see her yet?"'''],
                ['''"In case you haven't noticed, things are kind of crazy-"'''],
                ['''"Yes, and the last thing we need is to waste time fighting each other, because we can't tell friend from foe!" snaps the instructor.''',
                    '''She points towards the door. "As soon as we're done here, you're going to get your butt upstairs, and talk to her, or I will''',
                    '''paddle you silly when this is all over. Clear?"'''],
                ['\p'],
                ['''1. "Yes ma'am."'''],
                ['''2. "Look Lady, you're not the boss of me. The only person I'll take orders from is Adrian, and he said nothing about getting some stupid''',
                '''ribbon."''']]), justification=0)
            universal.set_command_interpreter(cosima_failedPaloma_see_Paloma_interpreter)
        elif num == 2:
            universal.say(universal.format_text([['''The woman gives''', name(), '''a skeptical look. "Uh huh. And which do you think would take more time:''',
            '''visiting Paloma, or fighting with other members of the Guild, because they have no way of knowing that you're a member?"'''],
            ['\p'],
            ['''1. "Visiting Paloma, obviously. None of you can hold a candle to me."'''],
            ['''2. "...Fighting with other members, I guess."''']]), justification=0)
            universal.set_command_interpreter(cosima_failedPaloma_time_interpreter)

def cosima_failedPaloma_why_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            add_keyword('get_ribbon')
            add_keyword('lied_to_Cosima_about_Paloma')
            add_keyword('Cosimas_task')
            universal.say(universal.format_text([['''The instructor crosses her arms over her chest, and gives''', name(), '''a skeptical look.'''],
                ['''"It's true," says''', name() + ",", hisher(), '''voice dangerously close to a whine.'''],
                ['''"She is a healer of the White Rose. Why in hell would she refuse to help you?" asks the instructor, beginning to lightly tap her paddle against''',
                    '''her shoulder.'''],
                ['''"I don't know, why don't you ask her?" asks''', name() + "."],
                ['''The instructor sighs in exasperation. "I don't have time for this. Just get back up there, and talk to her. If she continues to refuse, then''',
                    '''tell her she'll have to answer to Adrian."'''],
                ['''"Not like it will matter anyway," mutters''', name() + "."],
                ['''The instructor's eyes narrow, and her nostrils flare. "If you don't, you'll have to answer to me, and I promise, you will not like the''',
                '''questions."'''],
                [name(), '''eyes the woman's paddle''', hisher(), '''hands slipping back to cup''', hisher(), '''aching bottom.''' 
                    if one_in_keywords(['Ildri_spanked_you_unjustly', 'Maria_spanked_you', 'spectral_caned', 'spanked_by_Airell', 'Ildri_no_pants']) else
                        '''bottom.'''],
                ['''"Exactly," says the instructor.'''],
                [names(), '''hands snap fly guiltily away from''', hisher(), '''bottom.'''],
                ['''The woman unfolds her arms, and she considers the Taironans scattered about the room. "By the way, what's going on?"'''],
                ['''"We're being attacked by a gang of Taironans calling themselves the Vengadores," says''', name() + "."],
                ['''"Why?" asks the instructor, frowning. She begins lightly slapping her paddle against her thigh.'''],
                [name(), '''warily watches the paddle for a moment. "Erm, they seem to be after our equipment."'''],
                ['''"Figured as much," says the instructor sardonically. She gives''', name(), '''a sharp look. "What's your name?"'''],
                ['"' + name() + ',"', '''says''', name() + "."],
                ['''"Well,''', name() + ",", '''I'm Cosima, and I want you to get a Ribbon from Paloma, then seek out the other instructors," says Cosima. "Get them''',
                '''to either get upstairs and hold the entranceway, or into the armory. I'm going to take a look around, get a feel for the situation, then''',
                '''head down to the armory, most likely."'''],
                ['''With that, Cosima slips her paddle into a holster(?) in her belt, draws her dagger, and runs out the door.'''],
                ['''"Madre's mercy", mutters''', name() + ".", '''"These people make Nana look downright lenient."''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''The instructor's eyes widen, then narrow dangerously. "Come again?"'''],
                [name(), '''smiles nervously. "See, there were two of them, and I didn't think I could fight them, so-"'''],
                ['''"So you just stood there and let them beat her?" asks the instructor tightly.'''],
                ['''"Well, they also kind of strong-armed me into helping hold her-"'''],
                ['''"You helped them beat her?" cries the instructor. She shakes the paddle at''', name() + ".", '''"Give me one good reason why I shouldn't bend''',
                    '''you over and paddle you raw!"'''],
                ['\p'],
                ['''1. "I was scared, alright! There were two of them, one was a big amazon of a woman, and the other was barely armed, which screamed spellslinger.''',
                    '''I didn't think I could fight them, and I didn't know what they'd to do to me if I lost, and..."'''],
                ['''2. "Oh shut up, you stupid bitch. You don't know anything about what happened."'''],
                ['''3. "I'm sorry."''']]), justification=0)
            universal.set_command_interpreter(cosima_failedPaloma_response_interpreter)
            universal.set_commands(['(#) Select a number.'])
        elif num == 3:
            universal.say(universal.format_text([['''The instructor nods. "Understandable. Well, when we're done here, get up there and get a Ribbon. We need you fighting our''',
                '''attackers, not our members. My name's Cosima, by the way."'''],
                ['"' + name() + ',"', '''says''', name() + "."],
                ['''"Pleasure." Cosima slips her paddle into a holster(?) hanging on her belt. "Any idea why these people are attacking us, or who they are?"'''],
                [name(), '''shrugs. "They call themselves the Vengadores. Apparently, they're a gang of Taironans who've decided to violently challenge the Powers''',
                    '''That Be."'''],
                ['''Cosima frowns. "So why the hell are they attacking us? We're a band of mercenaries that are only barely tolerated by the government."'''],
                ['''"Apparently, they want your spears," says''', name() + "."],
                ['''Cosima curses. "Alright, I'm going to try to defend the armory. I want you to get a ribbon from Paloma, then try to find the other instructors.''',
                '''Make sure they either get get''',
                '''upstairs and hold the entranceway, or into the armory. I'm going to take a look around, get a feel for the situation, then''',
                '''head down to the armory, most likely. I want you to join me in the armory once you've seen the other instructors."'''],
                [name(), '''nods.'''],
                ['''"Good." Cosima draws her dagger, and runs out the door.''']]), justification=0)
            add_keyword('Cosimas_task')
            add_keyword('get_ribbon')
            universal.acknowledge(dungeonmode.dungeon_mode, ())

def cosima_failedPaloma_response_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''The woman sighs, and rubs her eyes. "I suppose that's understandable. Mother knows, we don't condone suicide. Look, you really should''',
                '''try to help your fellow members whenever possible, if only for the sake of sitting. But that's between you and Paloma. Regardless, we have''',
                '''more pressing matters to take care of. First, I suppose you should know my name. I'm Cosima. And you?"'''],
                ['"' + name() + '."'],
                ['''Cosima nods. "Alright, I need you to go back upstairs and see Paloma, try to get a Ribbon from her."'''],
                ['''"But-"'''],
                ['''"No buts," says Cosima sternly, holding up one hand in a stopping gesture. "We have enough to deal with right now without friendly fire''',
                '''incidents, and I need you to get the other instructors either upstairs to the entranceway, or to the armory to defend our equipment.''',
                '''I'm going to get a feel for situation, then head down to the armory myself. Understand?"'''],
                [name(), '''nods.'''],
                ['''"Good." Cosima slips her paddle into a holster(?), draws her dagger, and runs out the door.''']]), justification=0)
            add_keyword('Cosimas_task')
            add_keyword('get_ribbon')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            increment_spankings_taken()
            add_keyword('spanked_by_Cosima')
            add_keyword('Cosimas_task')
            add_keyword('get_ribbon')
            universal.say(universal.format_text([['''The instructor nods. "Ok."'''],
                ['''The instructor steps forward, grabs''', names(), '''arm, and yanks''', himher(), '''towards her. As''', name(), '''stumbles, she wraps her left''',
                    '''arm around''', names(), '''torso, and pivots into a lunge position, hauling''', name(), '''across her knee at the same time.'''],
                ['''"Hey!" cries''', name() + ",", hisher(), '''hands snapping down to catch''', himselfherself() + ".", '''"Let go of me!"'''],
                ['''Cosima''', universal.format_line(['''lifts''', names(), p.PC.lower_clothing().name, '''and bunches it up around''', hisher(), '''waist.''']) 
                    if p.PC.lower_clothing().armorType == items.Dress.armorType or p.PC.lower_clothing().armorType == items.Skirt.armorType else 
                    universal.format_line(['''pulls''', names(), p.PC.clothing_below_the_waist().name, '''about halfway down''', hisher(), '''thighs.''']),
                name(), '''squeals indignantly, and reaches back to shield''', hisher(), '''bare''' if p.PC.lower_clothing().name == items.emptyLowerArmor.name or 
                    p.PC.underwear().name == items.emptyUnderwear.name else universal.format_line([p.PC.underwear().name + "-clad"]), '''bottom, but the instructor''',
                    '''catches''', hisher(), '''wrist and pins it against''', hisher(), '''back.''',
                '''Then, the instructor rubs her hard wooden paddle against the''', (universal.format_line(['''sensitive skin of''', names(), '''exposed bum''']) if no_pants() or 
                    p.PC.underwear().baring else universal.format_line(['''thin cloth of''', names(), p.PC.underwear().name])) + ", causing the young", manwoman(), 
                    '''to tense.'''],
                ['''Thwack!'''],
                [name(), '''squeals and kicks''', hisher(), '''legs, as the small but surprisingly heavy paddle crashes into''', hisher(), '''bottom.'''],
                ['''Over and over again, the paddle rains heavy, bum-flattening blows to''', names(), '''already sore cheeks.''' if 
                    one_in_keywords(['Ildri_no_pants', 'Ildri_spanked_you_unjustly', 'spectral_caned', 'spanked_by_Airell', 'Maria_spanked_you']) else 
                    '''painfully vulnerable cheeks.'''],
                [name(), '''flails frantically, but the instructor holds''', himher(), '''firm, despite the precariousness of the position.'''],
                ['''After a dozen hard, fast slaps, the instructor rolls''', name(), '''onto the mat. She straightens, leans down over''', name(), '''and shakes''',
                    '''her paddle under the chastised Taironan's nose. "You will treat me with respect rookie. And when all this is over, you will go to Paloma,''',
                    '''you will apologize to her, and you ask her to punish you for not helping her."'''],
                ['''"But-"'''],
                ['''"Ah! No buts," says the instructor. "You will apologize, or I will paddle you, drag you to her by your ear, and make you apologize. And then''',
                    '''she'll give you a spanking of her own, to make sure you're really sorry. Get it?"'''],
                [name(), '''nods.'''],
                ['''The instructor straightens. "Good. Now until then, I want you to go upstairs and get a ribbon from Paloma. Then you'll visit the other instructors''',
                    '''and get them to either go upstairs to hold the entranceway, or come to the armory to help me defend it. They give you any trouble, and you tell''',
                    '''them Cosima sent you. Then you'll come and help me defend the armory. Meanwhile, I'm going to take a look around, get a feel for the''',
                    '''situation. Understand?"'''],
                [name(), '''nods a second time.''', HeShe(), '''reaches back and gingerly rubs''', hisher(), '''stinging bottom.'''],
                ['''"Good." Cosima straightens, and slips her paddle into a holster(?) at her belt. Then she draws her dagger, and runs out the door.'''],
                [name(), '''sticks''', hisher(), '''tongue out after the departing warrior, and clambers to''', hisher(), '''feet.''', HeShe(), 
                    items.lowerlift(p.PC.clothing_below_the_waist()) + "s", hisher(), p.PC.clothing_below_the_waist().name, '''back over''', hisher(), 
                    '''smarting bottom.''']]), justification=0)
                
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 3:
            universal.say(universal.format_text([['''"It's not me you should be apologizing to," says the instructor, putting her hands on her hips and giving''', name(), 
            '''a stern glare. "Is it?"'''],
            [name(), '''shakes''', hisher(), '''head, and scuffs''', hisher(), '''foot against the ground.'''],
            ['''"But we can worry about that later," says the instructor. "First, my name's Cosima."'''],
            ['"' + name() + ',"', '''mumbles''', name() + ",", '''still looking at''', hisher(), '''boots.'''],
            ['''"Well,''', name(), '''I'm going to need you to do something for me, ok?" asks Cosima. She puts her fingers underneath''', names(), 
            '''chin, and gently forces''', himher(), '''to look up at him. "I'm going to need you to go to Paloma and get a Ribbon from her."'''],
            ['''"But-"'''],
            ['''"Ah. I know it'll be awkward, but this is important, and you'll need to get deal with it anyway, if you want to be successful here," says Cosima.''',
                '''"Once you've gotten a Ribbon, I need you to go talk to the other instructors, and get them to either come down to the armory, or help Adrian at''',
                '''the entranceway. Meanwhile, I'm going to take a look around, get a feel for the situation before heading to the armory. Ok?"'''],
            [name(), '''nods.'''],
            ['''Cosima smiles. "Great. Do this, and it'll go a long way to make up for failing to help Paloma."'''],
            ['''Cosima spins''', name(), '''around and gives''', himher(), '''a light slap on the bum to speed''', himher(), '''on''', hisher(), '''way. "Now, get''',
                '''going. We've got thugs to punish."''']]), justification=0)
            add_keyword('Cosimas_task')
            add_keyword('get_ribbon')
            universal.acknowledge(dungeonmode.dungeon_mode, ())

def cosima_failedPaloma_see_Paloma_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''"Good," says the instructor. "I'm Cosima, by the way. And you are?"'''],
                ['"' + name() + '."'],
                ['''"Well''', name() + ",", '''once you've gotten a ribbon from Paloma, I want you to visit the other instructors. Get them either to the entranceway''',
                    '''to help Adrian, or down here to the armory to help me. Then I want you to join me in holding the armory. Understand?"'''],
                [name(), '''nods.'''],
                ['''"Good." Cosima slips her paddle into a holster(?) on her belt, draws her dagger, and runs out the door.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''The instructor's expression goes stormy. "Excuse me?" Her voice is quiet, but dangerous.'''],
                [name(), '''tosses''', hisher(), '''head defiantly, and crosses''', hisher(), '''arms over''', hisher(), '''chest. "I said you're not my boss-"'''],
                ['''The instructor grabs''', names(), '''arm and jerks''', himher(), '''forward.''', name() + ",", '''caught off-guard by the woman's strength''',
                    '''stumbles forward. As''', heshe(), '''stumbles forward, the instructor snakes her arm around''', names(), '''waist, and bends''', himher(),
                    '''over her hip, holding the young Taironan securely in the underarm position.'''],
                [name(), '''yelps indignantly and pounds''', hisher(), '''fist uselessly against the woman's calf.'''],
                ['''With a sharp crack, the instructor slaps''', universal.format_line([names(), '''exposed bottom''']) if no_pants() and 
                    p.PC.underwear().is_baring() else universal.format_line(['''the seat of''', names(), p.PC.clothing_below_the_waist().name]), '''with her paddle.'''],
                [name(), '''yelps as a flash of hot pain spreads across''', hisher(), '''bottom.'''],
                ['''The paddle cracks against''', names(), '''vulnerable bottom three more times, drawing additional yelps, and more than a little squirming from''',
                '''the young Taironan.'''],
                ['''"Alright, you little brat," says the instructor. "Are you going to listen to me now? Or do I need to''', 
                    items.liftlower(p.PC.clothing_below_the_waist()),'''your''', p.PC.clothing_below_the_waist().armorType + "?"],
                ['''"Ok, ok. I'll go get this stupid ribbon," says''', name() + ",", '''tugging uselessly on the instructor's iron-hard arm. "Just let go of me."'''],
                ['''"Good." The instructor pushes''', name(), '''out from beneath her arm. As''', name(), '''straightens, the instructor grabs''', hisher(), '''arm.'''],
                ['''"Hey!" cries''', name() + "."],
                ['''The instructor shakes her paddle under''', names(), '''nose. "I want you to know that the only reason you're not kicking and squealing right now''',
                    '''is because I don't have time to deal with you properly. However, when this is all over, we will have a long, frank discussion about your''',
                    '''insubordination. Understand?"'''],
                ['''"Yeah, fine, whatever," mutters''', name(), '''petulantly.'''],
                ['''"Good." The instructor lets go of''', names(), '''arm, and slips her paddle into a holster(?) at her belt. She draws her dagger. "After you've''',
                    '''gotten a ribbon, I want you to find the other instructors. Get them to the entranceway, or down to the armory, then I want you to join me in''',
                    '''holding the armory. Understand?"'''],
                [name(), '''nods, as''', heshe(), '''rubs''', hisher(), '''stinging bottom.'''],
                ['''"Good. Any of them give you trouble, tell them Cosima sent you." With that, Cosima runs out the door.'''],
                ['''"Thank La Madre, she's gone," says one of the defeated Taironans. She drags herself to her feet, lifting her trousers back up over her scorched''',
                    '''bottom. "Let's get out of here, before she returns."'''],
                ['''Slowly, the defeated Taironans drag themselves to their feet, and begin stumbling towards the door.''']]), justification=0)
            add_keyword('Cosimas_task')
            add_keyword('get_ribbon')
            add_keyword('talk_with_Cosima')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
def cosima_failedPaloma_time_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1 :
            universal.say(universal.format_text([['''The instructor laughs. "Oh really? Care to back up that boast? How about a sparring match when this is all over?"'''],
                ['''"What are the stakes?" asks''', name() + "."],
                ['''"Simple, really," says the instructor, smirking. "Loser gets a bare-bottom spanking from the winner, in front of the audience, and has to''',
                    '''apologize. If I lose, I apologize for underestimating you, if you lose you apologize for being a cheeky, boastful brat."'''],
                ['\p'],
                ['''1. "Eh, I don't think so."'''],
                ['''2. "You're on!"''']]), justification=0)
            universal.set_command_interpreter(cosima_sparring_acceptance)
            universal.set_commands(['(#) Select a number.'])
        elif num == 2:
            universal.say(universal.format_text([['''"Indeed," says the instructor. She slips her paddle back into a holster(?) at her waist, and draws her dagger. "After you get a''',
                '''ribbon from Paloma, visit the other instructors. Get them to either join Adrian at the entranceway, or help me defend the armory. If any of them''',
                '''give you trouble, tell them Cosima sent you. Me, I'm going to take a look around before heading into the armory."'''],
                ['''With that, Cosima runs out the door, leaving''', name(), '''alone to plan''', hisher(), '''next move.''']]), justification=0) 
            add_keyword('Cosimas_task')
            add_keyword('get_ribbon')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
def cosima_sparring_acceptance(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''"Hmm. Thought so," says the instructor smugly. "Anyway, get your bum upstairs and get a ribbon from Paloma, then see the other''',
                '''instructors. Try to get them to either head to the entrance-way and help Adrian, or come down to the armory and help me. Any of them give you''',
                '''trouble, tell them Cosima sent you. Me, I'm going to take a look around before heading to the armory."'''],
                [name(), '''nods, deciding not to press the issue any longer.'''],
                ['''Cosima returns the nod, then runs out the door.''']]), justification=0)
            add_keyword('Cosimas_task')
            add_keyword('get_ribbon')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''"Alright then," says the instructor. She grins wolfishly. "I'm looking forward to it. But for now, visit the other instructors, and''',
                '''get them to either go upstairs and help Adrian, or come down to the armory and help me. Any of them give you trouble, tell them Cosima sent you.''',
                '''Meanwhile, I'm going to take a look around and get a feel for the situation before I head into the armory."'''],
                [name(), '''nods. Cosima returns the nod, then runs out the door, dagger at the ready.''']]), justification=0)
            add_keyword('Cosimas_task')
            add_keyword('spar_with_Cosima')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
def cosima_noRibbon_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([[name(), '''pivots and bolts for the door.'''],
                ['''"Hey!" cries the woman. "Come back here."'''],
                [name(), '''glances over''', hisher(), '''shoulder, and squeaks. The woman is only a half-step behind''', himher(), '''and is already reaching out''',
                    '''to grab''', himher() + "."],
                [name(), '''swerves right, pivots, and tries to sweep the instructor's legs out from under her. The instructor crouches and catches''', names(), 
                '''leg. Then, she steps forward, and yanks''', name(), '''towards her.''', name(), '''hops forward several steps, bringing''', himher(), 
                '''in full arms reach of the instructor. The instructor wastes no time in grabbing''', name() + ",", ''' and pressing''', himher(), 
                '''face-first against the wall.'''],
                ['''"No no no no no no no," whines''', name() + "."],
                ['''Three times, the paddle cracks against''', universal.format_line(['''the back of''', names(), p.PC.clothing_below_the_waist().name + '.']) if not (no_pants() 
                    and 
                    p.PC.underwear().is_baring) else universal.format_line([names(), '''exposed butt.''']) , name(), '''yelps and rocks''', hisher(), 
                '''stinging bottom.'''],
                ['''"I'm a member of the Guild, I swear, I swear," cries''', name() + ".", '''"Please, with the attack and all I didn't have time to get a Ribbon''',
                    '''and-"'''],
                ['''"Then why did you run away from me?" asks the instructor.'''],
                ['''"Because that paddle looks painful," says''', name() + "."],
                ['''The woman shakes her head and chuckles. "This may be hard to believe, but I'm not as spank-happy as Ildri."'''],
                ['''"Then why are you paddling me?" mutters''', name() + "."],
                ['''"Three swats is not a paddling." The woman rubs the paddle against''', names(), '''bottom. "They weren't even particularly hard swats. Though if''',
                    '''you want a proper-"'''],
                ['''"No no no no no," says''', name(), '''quickly,''', hisher(), '''hands flying back to shield''', hisher(), '''bottom.'''],
                ['''The woman chuckles, and lets go of''', name() + ".", '''"Look, I swatted you because running away like that is not a good idea. It just makes''',
                    '''you look all the more suspicious. My name is Cosima, by the way."'''],
                [name(), '''turns and gingerly takes the woman's proffered hand. "''' + name() + '."'],
                ['''"Well,''', name(), '''care to tell me what's going on?" Though Cosima's smile is friendly''', name(), '''can't help but notice that she is still''',
                    '''keeping a firm grip on her paddle.'''],
                ['''"Some Taironan gang is attacking," says''', name() + ".", '''"Say they're after our equipment."'''],
                ['''Cosima curses. "Of course they are. Always figured Adrian's cache made too tempting a target. I'm going to and try to defend it. You  visit the''',
                    '''other instructors, especially Paloma upstairs, then get down to the armory and help me. The armory's just down this hallway, on the left."'''],
                ['''"Why don't I go with you now?" asks''', name() + "."],
                ['''"Because we've never trained together," says Cosima. "I have no idea how you move, or what your fighting style is, and you have no idea what''',
                    '''mine is. Trying to fight together would be a disaster. Better for you to find the other instructors and get a few of them down to the armory. Then, if I'm defeated you can''',
                    '''serve as backup."''']]), justification=0)
            universal.say('\p', justification=0)
            universal.say(universal.format_text([['''1. "I guess that makes sense."'''], 
                             ['''2. "No way. I've been learning how to fight since I was three. Well, five. Or seven.''',
                    '''Whatever. The point is, I'm not some untrained kid with delusions of grandeur. I'm a member of this Guild, and I can help you."''']]), 
                    justification=0)
            universal.set_command_interpreter(cosima_noRibbon_run)
        elif num == 2:
            universal.say(universal.format_text([['''"Um, what are you doing?" asks the woman.'''],
                [name(), '''sighs.''', 
                    universal.format_line(['''"I've been through this before. No matter what I say, or do, you're going to insist I'm an enemy, then you're going to spank''',
                    '''me, and there's nothing I can do about it. So let's just get it over with."''']) if 'Ildri_spanked_you_unjustly' in keywords() or 
                    'spanked_by_Airell' in keywords() else universal.format_line(['''"I have no proof that I'm a member of the guild, and I'm a Taironan. Considering what''',
                        '''you're doing''','''to these poor souls, I figure I'm going to get paddled no matter what I do, and I'd just like to get it over''',
                        '''with."'''])],
                ['''"You know, we're not all as crazy as Ildri or Airell," says the woman, her voice thick with exasperation. "Stand up, I'm not going to paddle''',
                '''you. Not unless you do something to earn it, like attack me or something."'''],
                [name(), '''quickly stands, and spins back around to face the woman. "Thank La Madre. Getting spanked when you've done something wrong is''',
                    '''bad enough."'''],
                ['''Cosima nods. "Indeed. Look, I would highly recommend you go upstairs and talk to Paloma. She can give you one of those ribbons, it'll make''',
                    '''your experiences with the other instructors go much more smoothly. But before that, name's Cosima. Now, what in the Mother's''',
                    '''name is going on?"'''],
                ['''"A Taironan gang is attacking," says''', name() + ".", '''"Apparently, they want our equipment."'''],
                ['''Cosima shakes her head. "It was inevitable I suppose; Adrian's cache is far too tempting a target, especially with the refugees and their''',
                '''wretched Potion Wars. But that's neither here nor there. I'm going to try to defend the armory. You try to speak with the other''',
                '''instructors, starting with Paloma. Try to get them either upstairs to hold the entrance or into the Armory to help me. Then, come and''',
                '''help me."'''],
                ['''"Wait, why don't I just go with you now?" asks''', name() + "."],
            ['''"Because we've never trained together," says Cosima. "I have no idea how you move, or what your fighting style is, and you have no idea what''',
                '''mine is. Trying to fight together would be a disaster. Better for you to find the other instructors, people I have trained with, then to try''',
                '''to join me directly."''']]), justification=0)
            universal.say('\p', justification=0)
            universal.say(universal.format_text([['''1. "I guess that makes sense."'''], 
                             ['''2. "No way. I've been learning how to fight since I was three. Well, five. Or seven.''',
                '''Whatever. The point is, I'm not some untrained kid with delusions of grandeur. I'm a member of this Guild, and I can help you."''']]), 
                justification=0)
            universal.set_command_interpreter(cosima_noRibbon_run)
        elif num == 3:
            universal.say(universal.format_text([['''The woman's eyes widen, and she holds up her hands in a concilitary gesture. "Hey now, calm down, calm down. I think a''',
                '''little bit of suspicion is justified, considering I just finished fighting off half a dozen fighting mad Taironans. But I'm''',
                '''sorry. I'm probably being a bit unfair, so let's just focus on protecting our Guild. First, my name is Cosima. Second, do you have any idea''',
                '''what these people are after?"'''],
                ['''"The equipment in the armory," says''', name() + "."],
                ['''Cosima grimaces. "Dammit, I told Adrian someone was going to attack us for that crap eventually. Look, I need you to get your ass up to''',
                    '''Paloma and convince her to give you a ribbon. Then, I need you to go see the other instructors. Get them to either join the fight''',
                    '''at the entranceway or help me down in the armory. Then, you should join me as well. Meanwhile, I'm going to take a quick look around before''',
                    '''heading to the armory as well."'''],
                ['''"Why don't I go with you now?" asks''', name(), '''with a touch of suspicion.'''],
                ['''"Because we've never trained together," says Cosima. "I have no idea how you move, or what your fighting style is, and you have no idea''',
                '''what mine is. Trying to fight together would be a disaster. Better for you to find the other instructors, people I have trained with,''',
                '''then to try to join me directly."''']]), justification=0)
            universal.say('\p', justification=0)
            universal.say(universal.format_text([['''1. "I guess that makes sense."'''], 
                         ['''2. "No way. I've been learning how to fight since I was three. Well, five. Or seven.''',
                '''Whatever. The point is, I'm not some untrained kid with delusions of grandeur. I'm a member of this Guild, and I can help you."''']]), 
            justification=0)
            universal.set_command_interpreter(cosima_noRibbon_run)

def cosima_noRibbon_run(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''"Don't worry. You'll get plenty of action before everything's over I'm sure," says Cosima, winking. She turns''', name(), '''towards''',
                '''the door and gives''', himher(), '''a light slap on the bum. "Now get going. We've got work to do."''']]))
            add_keyword('Cosimas_task')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''Cosima's eyes narrow, and her mouth twists down into a frown. "In this guild, I am your superior, and rule number one of combat''',
                '''situations: you do whatever your superior tells you without question. You can debate the wisdom of my decision until you're blue in the face''',
                '''after the dust has settled, but not during a crisis. Do I make myself clear?"''']]), justification=0)
            universal.say('\p')
            universal.say(universal.format_text([['''1. "Yes ma'am."'''], ['''2. "I'm going with you and that's final."''']]), justification=0)
            universal.set_command_interpreter(cosima_noRibbon_join)

def cosima_noRibbon_join(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_line(['''Cosima nods. "Good." She turns''', name(), '''towards the door, and gives''', himher(), '''a light swat to speed''', himher(), 
                '''towards the door. "Now get going. We've got work to do."''']), justification=0)
            add_keyword('Cosimas_task')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''The words are barely out of''', names(), '''mouth before''', hisher(), '''face is pressed against the wall again, and Cosima's''',
                '''paddle is lighting''', hisher(), '''ass on fire.'''],
                ['''"I do not have time for your pointless recalcitrance," says Cosima over''', names(), '''yelps of pain, and the heavy thwack of paddle to bottom.''',
                    '''"You will do as you're told, understand?"'''],
                ['''"Oww, oww, yes, I understand," cries''', name() + ", alternating between hopping up and down, and bucking her hips against the wall."],
                ['''"Good, then get to it." Cosima releases her hold on''', name() + ".", '''"I don't have time to deal with you properly right now, but I can assure''',
                    '''you, when this is done, you, me, your ass, and my paddle are going to be spending some quality time together."'''],
                [name(), '''nods, as Cosima runs out the door. Stupid smug bitch. You'd think she was some great general, and not a dirt-poor, inconsequential''',
                '''adventurer.''']]), justification=0)
            add_keyword('Cosimas_task')
            add_keyword('talk_with_Cosima')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
                    
                

def cosima_whiteRibbon_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''Cosima frowns. "But why attack us?"'''],
                ['''"They're interested in stealing our equipment," says''', name() + "."],
                ['''Cosima nods thoughtfully. "That makes sense. From what I've seen, the group isn't particularly well equipped. Explains all the poor fighters too.''',
                    '''They know they're going to suffer heavy casualties, and that they probably don't have enough highly skilled fighters to take us all on, so''',
                    '''instead they try to bury us in numbers. If even a third of them escape with a third of our equipment, they'll be in pretty good shape.''',
                    '''And finding new recruits would be easy for a group like that."'''],
                ['''Cosima gives''', name(), '''a sharp look. "I'm heading to protect the armory. I suggest you see if you can get any of the other instructors to''',
                '''either head upstairs to help hold the entrance, or head to the armory to help me. Once that's done, I want you in the armory, helping me hold''',
                '''it. Meanwhile, I'm going to take a quick look around before heading to the armory."'''],
                [name(), '''nods.'''],
                ['''Cosima returns the nod, and runs out the door.''']]), justification=0)
            add_keyword('Cosimas_task')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''Cosima cocks her head to the side, and gives''', name(), '''a baffled look. "How is attacking us helping them 'fight back?'"'''],
                ['''"They need equipment," says''', name() + ".", '''"Kind of hard to fight when all you've got are battered daggers, and a few wooden spears."'''],
                ['''Cosima shakes her head. "I suppose that we're the least suicidal group to attack, all things considered. Still, it strikes me as a desperate''',
                    '''gamble that is sure to attract the attention of the guards." She gives''', name(), '''a sharp look. "I'm heading to the armory to try and''',
                    '''stop them. I suggest you try to find the other instructors, and see if they can either head upstairs to help hold the entrance, or come to''',
                    '''help guard the armory. I'm going to take a look around as well, try to get a feel for the situation before I hunker down in the armory."'''],
                [name(), '''nods.'''],
                ['''Cosima starts to go, but then she stops and turns around. "Oh, and I couldn't help but a note a bit of admiration in your voice. Be careful about''',
                    '''that. Revolutionaries rarely lead happy lives. Or particularly long ones."'''],
                ['''With that last warning, Cosima turns and leaves.''']]), justification=0)
            add_keyword('Cosimas_task')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 3:
            universal.say(universal.format_text([['''"And they didn't say anything about who they were or why they attacked?" asks Cosima sharply.'''],
                [name(), '''shakes''', hisher(), '''head.'''],
                ['''"You're sure?" asks Cosima.'''],
                [name(), '''rolls''', hisher(), '''eyes. "No, I fell asleep in the middle of the attack. Of course I'm sure!"'''],
                ['''"Ok, ok," says Cosima, holding up her hands. "Sorry." She frowns thoughtfully. "I'm going to head upstairs then, see if Adrian has any idea of''',
                    '''what's going on, or where I should go. You track down some of the other instructors, and get them moving to the entrance as well. We need to''',
                    '''seal them in here, and hold them long enough for the guards to arrive."'''],
                ['''With that, Cosima leaves.''']]), justification=0)
            add_keyword('lied_to_Cosima')
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 4 and not 'info_demanded' in keywords():
            add_keyword('info_demanded')
            universal.say(universal.format_text([['''Cosima frowns. "You do realize we're obligated to help each other, right? That includes providing intel''',
                '''about our enemies. Now answer the cursed question."''']]), justification=0)
            universal.say('\p')
            universal.say(universal.format_text([['''1. "A Taironan gang with delusions of grandeur is attacking. They seem to think they're fighting to liberate us all from''',
                '''our Carnutian opressors. Honestly, I doubt they'll be a big deal to a group as experienced as all of you."'''],
                ['''2. "A group of Taironans who've finally gotten sick and tired of being ground into the dirt are fighting back."'''],
                ['''3. LIE: "I don't know, actually. I was in the middle of signing up, when a bunch of masked people burst in and attacked."'''], 
                ['''4. "Look, you seem to have everything well in hand. I need to go. Bye."''']]), justification=0)
        elif num == 4 and 'info_demanded' in keywords():
            remove_keyword('info_demanded')
            universal.say(universal.format_text([['''Cosima growls. "I don't have time to deal with this crap. Rest assured, you and I are going to have a talk when all''',
                '''of this is over."'''],
                ['''With that, Cosima runs out the door, likely seeking someone a bit more helpful.''']]), justification=0)
            add_keyword('talk_with_Cosima')
            universal.acknowledge(dungeonmode.dungeon_mode, ())

def e0_3_5():
    if not 'met_Mai' in keywords():
        universal.say_title('Stealth Maze')
        universal.say(universal.format_text([[name(), '''tenses as''', heshe(), '''enters the room. Unlike the others, this is not a large, wide open space. Rather, it is a dark,''',
            '''claustrophobic maze. The whole maze has the feeling of a forest where the birds have suddenly gone quiet.'''],
            [name(), '''glances over''', hisher(), '''shoulder at the door, and considers the wisdom of continuing into these dark corridors.\n\n''']]))
        universal.acknowledge(dungeonmode.dungeon_mode, ())
    else:
        backOfGuild.display()
    if not 'Cosimas_task' in keywords():
        universal.say(universal.format_text([['''Eventually,''', heshe(), '''backs away, deciding not to enter the scary looking maze. Perhaps''', heshe(), 
            '''would be better off checking out a different place for now. Like the training room to the north.''']]))
        backOfGuild.coordinates = (backOfGuild.coordinates[0], backOfGuild.coordinates[1], backOfGuild.coordinates[2] - 1)
        universal.acknowledge(dungeonmode.dungeon_mode, ())
def e0_5_5():
    if not 'met_Mai' in keywords():
        universal.say(universal.format_text([[name(), '''freezes. For a second there,''', heshe(), '''thought''', heshe(), '''heard a faint scrabbling.''']]))
        universal.acknowledge(dungeonmode.dungeon_mode, ())
    else:
        backOfGuild.display()
def e0_1_6():
    if not 'met_Mai' in keywords():
        universal.say(universal.format_text([['''A dead end. As''', name(), '''turns,''', heshe(), '''catches a glimpse of something moving through the shadows.''', HeShe(), 
            '''freezes, and waits for the movement to occur again. After several minutes,''', heshe(), '''takes a deep breath and continues moving.''']]))
        universal.acknowledge(dungeonmode.dungeon_mode, ())
    else:
        backOfGuild.display()
    
def e0_2_9():
    if not 'met_Mai' in keywords():
        universal.say(universal.format_text([['''A faint, haunting giggle wafts through the air.''']]))
        universal.acknowledge(dungeonmode.dungeon_mode, ())
    else:
        backOfGuild.display()
def e0_5_9():
    if not 'met_Mai' in keywords():
        universal.say(universal.format_text([['''As''', name(), '''draws abreast of another shadowy alcove,''', heshe(), '''glances to''', hisher(), '''left. And freezes. In the alcove to''',
            hisher(), '''left is a dim figure. The figure is standing so perfectly still, that''', name(), '''almost didn't see it. Almost.''']]))
        universal.acknowledge(dungeonmode.dungeon_mode, ())
    else:
        backOfGuild.display()
def e0_5_8():
    if 'met_Mai' in keywords():
        backOfGuild.display()
        return
    increment_spankings_taken()
    add_keyword('met_Mai')
    universal.say_title('Mai')
    universal.say(universal.format_text([[name(), '''dashes forward and grabs the figure. The figure flops lifelessly in''', names(), '''grip, and''', 
    name(), '''throws it to the ground with a curse. Just a stupid mannequin. Odd place for a mannequin...'''],
        [name(), '''pivots and starts to dash from the alcove.'''],
        ['''Someone drops down on''', himher(), '''from above, dragging''', himher(), '''to the ground.'''],
        ['''"Naughty, naughty," hisses a female voice in''', names(), '''ear. The woman has a strange, exotic accent that''', name(), '''has never heard before.''',
            '''Not that''', heshe(), '''has heard all that many Carnutian accents.'''],
        ['''"Let go-mpph!" Hands of steel shove something into''', names(), '''mouth and deftly tie a cord around''', hisher(), '''head, holding the gag in place.'''],
        ['''"Uh-huh," whispers the woman. "No noise. Silence. Total silence."'''],
        [name(), '''reaches up and grabs the gag.'''],
        ['''"Naughtier and naughtier," hisses the woman. Her hands grab''', names(), '''and force them away from the gag. She binds''', names(), '''arms tight''',
        '''against''', hisher(), '''sides.''', name(), '''squirms uselessly, and screams (equally uselessly) against the gag. The weight on''', hisher(), 
        '''back shifts, and then firm hands grab''', names(), '''ankles.'''],
        ['''Panicking,''', name(), '''begins frantically kicking. The weight shifts some more, and suddenly both of''', hisher(), '''ankles are caught in iron-hard''',
            '''hands.'''],
        ['''"So very naughty," hisses the woman. "Attack guild, intrude my home, now resist punishment. I think switch is best."'''],
        [name(), '''squeaks through the gag.'''],
        ['''The weight shifts off of''', names(), '''back. Strong hands grab''', hisher(), '''hips and lift them high into the air.''', name(), '''struggles, but all''',
            heshe(), '''manages to do is jerk''', hisher(), '''hips back and forth.'''],
        [universal.format_line(['''"Oh-ho. Such delightfully bare bottom," hisses the woman.''', '''"You wear your stripes for all to see with elven pride. Perhaps switch is too much. Perhaps hand is enough."''' 
            if one_in_keywords(['Ildri_spanked_you_unjustly', 'spanked_by_Airell', 'spanked_by_Cosima', 'Maria_spanked_you', 'spectral_caned']) and no_pants() and 
            p.PC.underwear().baring
            else 
                '''"So smooth and unmarked. Switch change that, I think."''']) if no_pants() and p.PC.underwear().baring 
                else universal.format_line([names(), p.PC.clothing_below_the_waist().name, 
                items.isare(p.PC.clothing_below_the_waist()), items.liftlower(p.PC.clothing_below_the_waist()) + "ed", universal.format_line(['''up over''', hisher(), '''hips.'''])
                if skirt_or_dress() 
                    else universal.format_line(['''down to''', hisher(), '''knees.\n\n'''])]), universal.format_line(['''"Tsk tsk," says the voice as''', names(), 
                    p.underwearpanties(), '''are lowered down just past''', names(), '''bottom. "Two layers covered bottom. And hiding such stripes! Shameful. Humans''',
                '''so cowardly. Should bear stripes with pride, for all to see. Extra strokes needed, I think."''']) if not p.PC.underwear().baring and 
                    one_in_keywords(['Ildri_spanked_you_unjustly', 'spanked_by_Airell', 'spanked_by_Cosima', 'Maria_spanked_you']) 
                        else universal.format_line(['''"Tsk, tsk", hisses the voice. "Two layers covered bottom. So cowardly. Hope be punished over both, perhaps? No,''',
                            '''switching on bare." Fingers sneak into the waistband of''', names(), p.underwearpanties(), '''and slip them down to just below''', 
                            hisher(),'''bottom.''']) if not p.PC.underwear().baring and not no_pants()
                            else universal.format_line(['''"Hmm. Nice, leaves bottom exposed, and such impressive stripes. But why hide them beneath''', 
                                p.PC.clothing_below_the_waist.armorType + "?", '''Stripes should be worn proudly. Not shamefully hidden. But one layer of hiding''',
                                '''better than two.''']) if p.PC.underwear().baring and 
                                one_in_keywords(['Ildri_spanked_you_unjustly', 'spanked_by_Airell', 'spanked_by_Cosima', 'Maria_spanked_you'])
                                else universal.format_line(['''"Hmm. Hiding behind one layer of cloth, not two. Better than many humans. Perhaps because you have no stripes''',
                                    '''to show? I will give you some stripes to be proud of."''']) if not p.PC.underwear().baring
                                    else universal.format_line(['\n\n' + name(), '''tenses, and squeezes''', hisher(), '''eyes shut.'''])]]), justification=0)
    if no_pants() and p.PC.underwear().baring and one_in_keywords(['Ildri_spanked_you_unjustly', 'spanked_by_Airell', 'spanked_by_Cosima', 'Maria_spanked_you', 
        'spectral_caned']):
        add_keyword('spanked_by_Mai')
        universal.say(universal.format_text([['''\n\nSoft fingers trace a few of the welts on''', names(), '''bottom. Then, there is a sharp crack, and the woman's iron-hard palm slams into''',
            hisher(), '''tender bottom.''', name(), '''yelps against the gag, and jerks''', hisher(), '''bottom desperately back and forth. An arm snakes its way''',
            '''around''', hisher(), '''waist and holds''', himher(), '''still. Then, the hand cracks against''', hisher(), '''bottom again. And again, and again''',
            '''and again.''', name(), '''cries, the welts from''', hisher(), '''previous''', '''spankings''' 
            if many_in_keywords(['Ildri_spanked_you_unjustly', 'spanked_by_Airell', 'spanked_by_Cosima', 'Maria_spanked_you']) else '''spanking''', '''making each''',
            '''slap sting exponentially more than it had any right to.'''], ['''For several minutes, heavy hand smacks''', names(), '''upthrust bum.''',
                '''The woman focuses almost exclusively on''', names(), '''lower buttocks, particularly the sitspots, with a few smacks to the middle, fleshiest''',
                '''part of the bottom.'''],
            ['''"Hmm. So impressive." Light hands rub''', names(), '''burning bottom. "You took it well, all things considered. Now, any goodies your pack?"''']]),
            justification=0)
    else:
        add_keyword('switched_by_Mai')
        universal.say(universal.format_text([['''\n\nSomething thin and just long enough to touch both cheeks taps against''', names(), '''bare bum. There is a swish, and a long line of''',
        '''fire cuts across''', names(),
            '''bum.''', HeShe(), '''screams against the gag, and jerks''', hisher(), '''bottom in a desperate but futile attempt to escape the switch.'''],
            ['''Over and over again, the switch swishes through the air and cuts against''', names(), '''bottom.''', HisHer(), '''squirming becomes so bad, that''',
                '''the woman has to wrap her arm around''', names(), '''waist and hold''', himher(), '''still while administering the switch.'''],
            ['''Eventually, after La Madre only knows how long (could have been a few seconds, a few minutes, or a few hours, for all''', name(), '''knew), a ''',
                '''gentle hand rubs''', hisher(), '''fresh welts.'''],
            ['''"There," says the voice. "New stripes. Very nice. Let's see what's in your pack, yes? Maybe fancy new dagger, or sexy outfit!"''']]))
    if itemspotionwars.whiteRibbon in inventory():
        universal.say(universal.format_text([['''\n\n"Oh dear." The hissing menace of the woman's voice has vanished, replaced with a chagrined, childish tone. "Heh, heh heh. You're new Guild''',
            '''member?"'''],
            [name(), '''grunts savagely through the gag.'''],
            ['''"Sorry, sorry. Thought you were enemy," says the woman.'''],
            [name(), '''growls.'''],
            ['''The woman deftly unties''', name(), '''and removes the gag.'''],
            ['''As soon as''', heshe(), '''is free,''', name(), '''adjusts''', hisher(), '''clothing,''',  universal.format_line(['''silently thanking Los Padres''', heshe(), 
                '''decided to wear such a flimsy outfit.''']) if no_pants() and baring_underwear() else
                universal.format_line(['''hissing as the cloth scrapes against''', hisher(), '''fresh welts.''']), '''Then,''', heshe(), '''spins to confront the woman who''',
                '''ambushed''', himher() + "."],
            [HisHer(), '''attacker is a tall, curvy woman with pale skin.''',
                '''Long, pointed ears poke out from beneath a rich mane of bark-brown hair. She has wide, dark blue eyes. She is wearing nothing but a loincloth''',
                '''that (mostly) covers her bottom, and an equally skimpy scrap of clothing across her chest. An elf. Interesting.''',
            '''The elf bows. "My name is Mai. Great apologies. Did not know you were Guild member. Perhaps I should have checked before punishing you." She laughs''',
            '''uneasily.'''],
            [name(), '''says nothing.'''],
            ['''The elf clears her throat. "Anyway, two ways of apologizing. One, I give you switch, and bend over. Two, I have magic clothing. You call it''',
            '''loin cloth. I give it to good students. It makes you extra stealthy, easier to sneak up on''',
            '''and ambush enemies. Which do you prefer?"'''],
            ['\p'],
            ['''1. "Gimme that switch, and bend over. By the time I'm done with you, you'll wish you'd never met me!"'''],
            ['''2. "I'll take the stealthy loincloth. As cathartic as switching you may be, I think the magic clothing would be a bit more useful."''']]),
            justification=0)
        universal.set_commands(['(#) Select a number.'])
        universal.set_command_interpreter(mai_apologizes_intepreter)
    else:
        add_keyword('mai_and_you_chastised')
        add_keyword('Mai_defends_armory')
        increment_spankings_taken()
        universal.say(universal.format_text([['''The woman groans. "Nothing good. Except fancy dagger, but my dagger is better. Ah well." The woman lifts''', name(), '''and throws''',
            himher(), '''over''', hisher(), '''shoulder. "I'll dump you with others until thing is done."'''],
            ['''Despite carrying''', name(), '''the woman easily clambers up one of the walls, and paces along the lip at the top, hunching to keep from scraping''',
                '''both her head and''', name(), '''against the ceiling. Soon, she reaches a small alcove closed on all sides, and only accessible from the ceiling.''',
                '''She drops down into the alcove, and gently lays''', name(), '''down next to several other equally bound Taironans. Then, she vanishes into''',
                '''the shadows.'''],
            [name(), '''lies in that alcove for an indeterminate amount of time. Then,''', heshe(), '''hears a pair of female voices. They rise and fall, apparently''',
                '''having an argument. Then there is a yelp of surprise, followed by the sharp crack of wood on bare flesh, followed by a wail of pain. The paddling''',
                '''continues for several minutes, the shrieks of pain growing more and more shrill with every blow.'''],
            ['''A few minutes after the paddling stops, someone lifts''', name(), '''and carries''', himher(), '''back to the alcove where''', heshe(), '''was first''',
                '''ambushed. Standing in the alcove with her hands on her hips and a dark scowl on her face is Cosima.''', name(), '''feels the bottom drop out of''',
                hisher(), '''stomach. This is not going to end well.'''],
            ['''The person carrying''', name(), '''gently sets''', himher(), '''down and unties''', himher() + ".", '''"Sorry. I Didn't you were member."'''],
            [name(), '''sits for a minute, rubbing feeling back into''', hisher(), '''newly freed hands and feet, before pulling''', himselfherself(), '''to''',
                hisher(), '''feet.''', HeShe(), '''finally gets a good look at''', hisher(), '''attacker.'''], 
            [HisHer(), '''attacker is a tall, curvy woman with pale skin.'''
                '''Long, pointed ears poke out from beneath a rich mane of bark-brown hair. She has wide, dark blue (at this point rather bloodshot) eyes. Tearlines mar''',
                '''her smooth face. She is standing rather gingerly, and is rubbing her bottom. She is wearing nothing but a brown loincloth that (mostly) covers her''',
                '''bottom, and a scrap of cloth across her chest. An elf. Interesting.'''],
            [names(), '''observations are interrupted when Cosima grabs''', hisher(), '''arm, and hauls''', himher(), '''over her knee.'''],
            ['''"Hey-oww!" cries''', name(), '''as Cosima's paddle cracks against''', hisher(), '''bottom.'''],
            '''"What did I tell you?" says Cosima. She rains four hard blows on''', universal.format_line(['''the seat of''', names(), 
                p.PC.clothing_below_the_waist().name + ","]) if not no_pants() or not baring_underwear() else universal.format_line([names(), '''exposed, vulnerable bottom,'''
                    '''two blows to each cheek.''']),
            [name(), '''wails and kicks''', hisher(), '''legs.'''],
            ['''"I said, what did I tell you?" says Cosima. She gives''', name(), '''another three hard licks, this time focusing on the middle of''', names(), 
                '''right cheek.'''],
            ['''"To go see Paloma before anyone else," cries''', name() + "."],
            ['''"And you didn't, did you?"'''],
            ['''"I-"'''],
            ['''"And don't you dare even consider lying to me," says Cosima, cracking the paddle hard against''', names(), '''left cheek. "I already talked to''',
            '''Paloma."'''],
            ['''"No," says''', name(), '''miserably, hanging''', hisher(), '''head.'''],
            ['''"And why not?" asks Cosima.'''],
            ['''"I dunno," mutters''', name() + "."],
            ['''Cosima paddles''', name(), '''four more times, drawing a long, loud wail from''', names(), '''throat. Then, she rolls the chastised Taironan off her''',
                '''knee. "I don't have time to paddle you properly, so that will have to do for now. You will get your naughty ass upstairs, and you will see Paloma''',
                '''and you will get a ribbon from Paloma now, or so help me, by the time I'm done with you, the slightest summer breeze will feel like an hour-long''',
                '''caning. Are we clear?"'''],
            [name(), '''nods, sniffing miserably.'''],
            ['''"Good." Cosima stands, and gives Mai a glare. "And you. Come on. We've got an armory to defend."'''],
            ['''"Yes ma'am," mutters the elf, meekly following Cosima into the maze.''']]), justification=0)
        universal.set_command_interpreter(mai_apologizes_intepreter)
        universal.set_commands(['(#) Select a number'])

def mai_apologizes_intepreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''The elf chews on her lip for a moment, apparently regretting her offer. She holds out the thin switch. The switch is just long enough''',
                                '''to crease both cheeks of an average-sized bottom.'''],
                ['''"I'm sure you will give me stripes to be proud of." The elf turns around, bends over, and grasps her ankles.''', name(), '''flips the elf's loincloth up onto the small of her''',
                                        '''back, leaving her wide, round, firm globes completely exposed.'''],
                [name(), '''taps the switch lightly against Mai's bottom, in the exact same manner that Mai had done to''', himher() + ".", '''Mai's bottom''',
                    '''reflexively clenches, but quickly relaxes.''', name(), '''places''', hisher(), '''free hand on the small of Mai's back, and draws''', hisher(),
                    '''arm back.''', HeShe(), '''holds the pose for a moment''', hisher(), '''thoughts zeroing in on the lingering sting in''', hisher(), 
                    '''own bottom.''', '''Then,''', heshe(), '''snaps''', hisher(), '''arm forward, and flicks''', hisher(), '''wrist just before contact.''',
                    '''The switch snaps across Mai's proffered bottom. Mai yelps, and bobs her hips.'''],
                ['''"That stings!" cries the elf.'''],
                ['''"Good."''', name(), '''lays on half a dozen fast, stinging blows to the elf's naughty bottom.'''],
                ['''"Oww, oww, oww," moans the elf. As the blows land, she alternates between gripping her ankles with a white-knuckled grip, and slapping the ground with''',
                '''one hand.'''],
                ['''On the sixth blow, there is a loud cracking sound, and the switch snaps.'''],
                ['''The elf looks over her shoulder at''', name() + ".", '''"You broke my switch!"'''],
                ['''"You broke my bottom," retorts''', name() + "."],
                ['\p'],
                ['''1. Stop spanking her.'''],
                ['''2. Give her a hand spanking.'''],
                ['''3. Spank her with the spoon.''' if itemspotionwars.woodenSpoon in inventory() else ''],
                ['''4. Spank her with the belt.''' if itemspotionwars.leatherBelt in inventory() else '']]), justification=0)
            universal.set_command_interpreter(mai_spanking_interpreter)
            universal.set_commands(['(#) Select a number.'])
        elif num == 2:
            p.PC.take_item(itemspotionwars.stealthThong)
            universal.say(universal.format_text([['''Mai claps her hands gleefully. "I'll be right back." The elf vanishes into the shadows.'''],
                [name(), '''taps''', hisher(), '''foot impatiently. Just when''', heshe(), '''is fairly certain the elf is renegging on the deal, the elf slips out''',
                    '''of the shadows right next to''', himher(), '''(scaring the ever-loving crap out of''', himher(), '''in the process).'''],
                ['''"Here," says Mai. She holds out a (very!) small strip of brown cloth.'''],
                ['\p'],
                ['''1. "Sexy!"'''],
                ['''2. "Doesn't this seem a little small to you?"'''],
                ['''3. Spank Mai anyway.''']]), justification=0)
            universal.set_command_interpreter(mai_stealth_thong_interpreter)
            universal.set_commands(['(#) Select a number.'])
def mai_spanking_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([[name(), '''glances down at the broken switch, then at the rows of narrow welts on Mai's bottom. "Well, I think that'll be enough. I''',
                '''believe my bottom has been properly avenged."'''],
                ['''Mai straightens, and curves around to look at her bottom. She rubs her finger along one of her welts, wincing slightly. "Stings. Not most''',
                    '''intense switching I received, but respectable."\n\n''']]), justification=0)
            if 'Cosimas_task' in keywords():
                universal.say(universal.format_text([['''"That's great", says''', name() + ".", '''"Because Cosima wants you to either go upstairs and help hold the entranceway, or''',
                    '''head to the armory and help her there."'''],
                    ['''Mai's eyes widen. "Oh no no. Not a fighter. Better at hiding, better at hiding."'''],
                    ['\p'],
                    ['''1. "Look you miserable brat, I didn't come into this creepy-ass maze, get pounced on, bound and''', '''switched''' if not (no_pants() and 
                        baring_underwear()) else '''spanked''', '''only for you to refuse to help us. So get your rear moving, or Cosima and I will both go to town''',
                        '''on your ass!"'''],
                    ['''2. "But, we need your help."'''],
                    ['''3. "Oh... Well, ok."'''],
                    ['''4. "Coward."''']]), justification=0)
                universal.set_command_interpreter(mai_convince_to_help_interpreter)
                universal.set_commands('(#) Select a number.')
            else:
                universal.say(universal.format_text([[name(), '''nods and the two stare at each other for a few minutes.'''],
                    ['''"So," says''', name(), '''at last. "Aren't you going to ask me what's going on, or how you can help or..."'''],
                    ['''"I don't care," says Mai. "Better to hide anyway. Rather not fight."'''],
                    ['''"But-"'''],
                    ['''Mai vanishes into the shadows.'''],
                    [name(), '''grimaces. "Ok. Whatever."''']]), justification=0)
                universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
                        universal.say(universal.format_text([[name(), '''tosses the switch away, and wraps''', hisher(), '''arm around Mai's waist.''', HisHer(), '''flat, hard hand arcs through the''',
                                '''air and slams into Mai's right cheek with a resounding crack, sending a powerful ripple through the elf's exposed flesh.'''],
                                ['''Mai yelps in surprise and pain, and squirms in''', names(), '''grip. "Hey, hey what are you doing?"'''],
                                ['''"If you think I'm going to let you off so easily, you have another thing coming," says''', name(), '''grimly.''', HisHer(), '''palm beats a hard,''',
                                        '''rapid pattern on Mai's large, jiggling bottom. Mai squeals, kicks, and wiggles in''', names(), '''grip, but doesn't try to break it (which''',
                                        name(), '''is reasonably certain she could do).'''],
                                [name(), '''pauses, and rubs''', hisher(), '''palm against''', hisher(), '''leg in an attempt to ease the sting. "Madre, you have a hard bottom."''']]), justification=0)
                        if p.PC.is_female():
                            universal.say(universal.format_text([['''"100 squat thrusts everyday," says Mai smugly.''', '''"You should join me. I noticed more than a little jiggle to your''',
                            '''wiggle when I was spanking you earlier."'''],
                                ['''"Oooh, I'll show you jiggle!"''', name(), '''begins swatting Mai as hard and fast as she can, laying on about fifty smacks in about''',
                                '''twenty seconds to the cheeky elf's rippling bottom.'''],
                                ['''"Oww, oww, oww, oww!" cries the elf. "I'm not insulting-oww! Just-oww!" The elf kicks, and bucks and flails beneath''', names(), 
                                        '''punishing hand.''', name(), '''ignores the elf's cries, and lays on at least another hundred blows, half of them landing on the sitspots.'''],
                                ['''Mai sags in''', names(), '''grip sniffing, and moaning in pain. Her bottom is a blazing, angry red.'''],
                                ['''"Alright, I think that's enough," says''', name() + ".", '''She releases her hold on the elf, who jumps up and begins dancing in place, her''',
                                        '''hands immediately flying back to her burning bottom.'''],
                                ['''"Oww, oww, oww, you have such hard hand," moans the elf, furiously rubbing her bare cheeks.'''],
                                ['''While the elf is carrying on,''', name(), '''can't help but reach back and give her own bottom a light slap. She frowns. Her bottom does feel''',
                                        '''a lot softer than the elf's, and it does seem to jiggle a bit more than it should. "About those squat thrusts..."'''],
                                ['''The elf flashes''', name(), '''a self-satisfied grin through her tears. "Told you. I do them beginning and end every training''',
                                        '''session. You want join me?"'''],
                                ['\p'],
                                ['''1. "Yes. If I'm going to be getting spanked a lot (and I have a terrible feeling I will be), I'd rather not be rippling like a lake in a''',
                                        '''rainstorm."'''],
                                ['''2. "You know, I think my butt is fine just the way it is. A little jiggle never killed anyone."''']]), justification=0)
                            universal.set_command_interpreter(mai_squat_thrusts_interpreter)
                            universal.set_commands(['(#) Select a number.'])
                        else:
                            universal.say(universal.format_text([['''"Sure doesn't feel that way," mutters Mai.'''],
                                ['''"Trust me, it is."'''],
                                [name(), '''lays on another good fifty smacks or so, the elf's plump bottom bouncing and rocking beneath the hard blows. "Alright, I''',
                                    '''think that's enough."'''],
                                ['''Mai straightens, and rubs her bottom gingerly. "These are some nice stripes. I'll wear them with pride."''']]), justification=0)
                            convince_mai()    
        elif num == 3 and itemspotionwars.woodenSpoon in inventory():
            universal.say(universal.format_text([[name(), '''removes the wooden spoon from''', hisher(), '''pack, and slaps it against''', hisher(), '''palm. "Get back over!"'''],
            ['''Mai, who has begun to rise, glances over her shoulder at''', name() + ".", '''"But, the switch-"'''],
            ['''"Broke, yes," says''', name() + ".", '''"Most unfortunate. However, that certainly does not mean I'm done with you. Now get back over!"'''],
            ['''Mai groans, but obediently bends back over and grasps her ankles.'''],
            ['''"Very good," says''', name() + ",", '''continuing to slap the spoon against''', hisher(), '''palm.\n\n''']]))
            spank_mai_with_spoon()
        elif num == 4 and itemspotionwars.leatherBelt in inventory():
            universal.say(universal.format_text([[name(), '''pulls''', hisher(), '''belt free, the leather almost hissing as it slides free of the loops on''', hisher(), 
                p.PC.lower_clothing().name] if wearing_pants() else [name(), '''removes''', hisher(), '''belt from''', hisher(), '''pack and doubles it.'''],
                '''Mai watches with wide eyes.''',
                ['''"There is no way you're getting off easy, just because your switch broke," says''', name(), '''grimly.''', HeShe(), 
                '''raises''', hisher(), '''belt. "Not after what you did to me."\n\n''']]), justification=0)
            spank_mai_with_belt()
    def mai_flirt_interpreter(keyEvent):
        add_keyword('flirted_with_Mai')
        try:
            num = pygame.key.name(keyEvent.key)
        except ValueError:
            return
        if num == 1:
            universal.say(universal.format_text([[name(), '''peppers the elf's bottom, making sure to put his whole arm into it. He watches with great appreciation as the woman's bottom jiggles and ripples beneath his efforts, despite''',
                '''how heavily toned it is. The elf for her part is moaning and eagerly pushing her bottom up to meet his hand. She has also begun to run her hand up and down his calf, and has pressed one of her''',
                '''legs against his own.'''],
                [name(), '''gives the elf's bottom a light rub. Th elf's moaning intensifies, and she grinds the side of her hip against his. Then, he pulls away. "Alright, stand up."'''],
                ['''The elf stands. She glances over her shoulder, and gives him a cute pout. Then, she leans forward, pushes her hips back, and gives her bottom a long, slow rub.'''],
                [name(), '''takes a deep breath. Things to do. Things to do. Better not get distracted.'''],
                ['''"Such nice stripes," says the elf in a low, throaty voice. "I'll wear them with pride."''']]), justification=0)
        elif num == 2:
            universal.say(universal.format_text([['''"What do you mean, maybe?" asks the elf. She grinds her hip harder against''', names() + ".", '''"Either you like it, or you don't."'''],
                ['''"Well, yeah, but we just met," says''', name() + "."],
                ['''The elf rolls her eyes. "Not asking if you want marry me. Foolish man."'''],
                ['''"Foolish? I'll show you foolish."''', name(), '''resumes the hard spanking. The elf squeaks, and her bum begins bobbing up and down, and swaying side to side beneath the onslaught. She''',
                    '''rapidly bends and straightens her legs, making her bottom tilt left and right. Between her squirming, and''', names(), '''hard slaps, her generous cheeks jiggle and bounce magnificently,''',
                    '''despite how toned they are.'''],
                ['''Throughout the spanking, the elf's squeaks turn to moans. She grinds one of her legs against''', names(), '''and she presses her hip against''', names(), '''with such force that he nearly topples''',
                    '''over. She gets a few extra to her sitspots for that.''']
                ['''Finally,''', name(), '''steps back, and lets her up. "And let that be a lesson to you. Don't ambush and spank people without first finding out who they are."'''],
                ['''The elf stands in a single smooth sweep. Her shoulder-length hair flies back and smacks against her back (it also nearly smacks''', name(), '''in the face). Her loincloth settles back in place,''',
                '''hiding all but the outer edges of her bottom. She glances coyly over her shoulder,''',
                   '''and tries to pout, but it's hindered by a smile that tugs at her lips. She reaches back, and gives her bottom a few slow rubs, shifting the loincloth ever so slightly in the process, and giving''',
                   name(), '''glimpses of the rest of her bottom (which admittedly, he'd literally just seen, but whatever). "Nice stripes." She says in a breathy voice. "I'll wear them with pride."''']]), 
                justification=0)
        elif num == 3:
            universal.say(universal.format_text([[name(), '''rotates down onto one knee, hauling the elf over the other at the same time.'''],
                ['''"Hey!" cries the elf, her hands snapping out to catch herself.'''],
                [names(), '''heavy hand smashes into the elf's round, firm, warm right cheek. The cheek ripples like a lake in a rainstorm, and a sweet squeak slips from the elf's lips.''', name(), 
                    '''begins spanking her even harder than before, making her bottom bounce and jiggle. The elf begins to moan, and rubs her hips against''', names(), '''leg. She squeezes her thighs together, and''',
                    '''pushes her shins in opposite directions, her feet tense. She lowers herself down onto her elbows, accenuating the upward thrust of her round, bare bottom.'''],
                ['''Eventually, once the elf's bottom has turned a truly delightful shade of red,''', name(), '''stops. He lifts her off his knee, and sets her back on her feet. He shakes a finger at her. "And don't''',
                    '''let me catch you ambushing and spanking any other innocents, or I'll give you a spanking that makes the last one look like a love tap."'''],
                ['''"You mean it wasn't?" asks the elf in a low, breathy voice, her eyes sparkling, and her hands rubbing slow, smooth circles across her burning cheeks. "Ohh, I'll wear these stripes with pride."''']]),
                justification=0)
        else:
            return
        if 'Cosimas_task' in keywords():
            convince_mai()
        else:
            universal.say(universal.format_text([['''"Good," says''', name(), '''gruffly. "Now I need your help taking back the armory."'''],
                ['''Mai's eyes widen, and she shakes her head, backing up. "Oh, no no no. I'm not fighter. I hide."'''],
                ['''"Now wait just a minute."''', name(), '''reaches for Mai, but she's already vanished into the shadows. "Mai, come back here, or I swear the next time I see you, I will thrash you senseless!"'''],
                ['''No answer.'''],
                ['''"Stupid elf," mutters''', name() + "."]]), justification=0)

def spank_mai_with_spoon():
    universal.say(universal.format_text([['''The wooden spoon cracks sharply against Mia's right cheek. The elf yelps, and bends her knees, sending her bottom into a bobbing fit. "Owww!''',
        '''Wait, stop, that hurts!"'''],
        ['''"Stop? Is that what you said? Oh hey, how about that. I said stop too," says''', name() + ".", HeShe(), '''lands six hard smacks, three to each cheek,''',
            '''focusing on the regions already welted by the switch. "Not that you would know, since you gagged me!"'''],
        ['''Mai shrieks, and bobs her bottom.''', name(), '''wraps''', hisher(), '''arms around her waist, and forces her to keep her bottom raised.'''],
        ['''"I'm sorry, I'm sorry," says Mai. "It won't happen again, I promise."'''],
        ['''"That doesn't help me any, now does it?" asks''', name() + ".", HeShe(), '''batters Mai's bottom with the spoon. The elf dances and kicks, her ass''',
            '''bucking and bouncing.'''],
        ['''Soon, the elf is crying, her sobs punctuated by soft yelps everytime the spoon cracks against her bottom.'''],
        [name(), '''takes a deep breath, and rolls''', hisher(), '''aching shoulder. "Ok. I think you've learned your lesson."'''],
        ['''Mai straightens, her hands going back to clutch at her sore bottom. She glances over her shoulder at the darker streaks and hints of red that bear witness''',
            '''to her punishment. While one hand gingerly massages her thrashed cheeks, the other wipes tears from her face. "Oh. Good stripes. I'll wear''',
            '''them pride."\n\n''']]), justification=0)

    if 'Cosimas_task' in keywords():
        convince_mai()
    else:
        universal.say(universal.format_text([['''"Good for you," says''', name() + "."],
            ['''Mai flashes''', himher(), '''a smile. "You should wear yours with pride as well. A thrashing well-endured should not be hidden."'''],
            universal.format_text([['''"I am aren't I?" says''', name() + ",", '''twisting around to reveal''', hisher(), '''exposed, well-spanked bottom. "I just wish I''',
                '''didn't have to."'''], ['''"Don't we all?" says Mai sardonically, giving her bottom another careful rub.''']]) if no_pants() and baring_underwear()
            else universal.format_text([['''"Eh, I'd really rather not," says''', name(), '''giving''', hisher(), '''still stinging bottom a rub.'''],
                ['''Mai shrugs. "Too bad. Your stripes are impressive."'''], ['''"Not for humans. For us, they're rather embarassing," says''', name() + "."],
                ['''"I've noticed. It is pity," says Mai.''']]),
            ['''"Anyway," says Mai. "I think I'll go now. Need to hide, wait out the chaos."'''],
            ['''Before''', name(), '''can say anything else, the elf bleeds into the shadows, and disappears.''']]), justification=0)
        universal.acknowledge(dungeonmode.dungeon_mode, ())

def spank_mai_with_belt():
    universal.say(universal.format_text([['''The belt snaps across Mai's all but bare bottom. Her cheeks jiggle beneath the hard slap, and she squeals. Her hips rock desperately back and forth''',
        '''and she shakes her head.''', name(), '''puts''', hisher(), '''free hand on the small of Mai's back to keep her bent over, and lays on lick after lick.'''],
        ['''Mai's bottom bobs beneath the belting. She breaks into tears three blows in.'''],
        [name(), '''pauses, caught off-guard by how quickly the elf broke down.'''],
        ['''"I'm sorry, I'm sorry," says the elf. "I never meant to hurt guild member, I thought you were invader and-"'''],
        ['''"Well, I'm not," says''', name(), '''angrily.'''],
        ['''"I know, I know," says the elf tearfully.'''],
        ['''The belt begins descending once again, and the small maze echoes with the crack of leather to bare flesh, and Mai's accompanying howls.'''],
        ['''After a few more minutes,''', name(), '''stops once again.'''],
        ['''"Sorry," whispers the elf. "Sorry, sorry, sorry."'''],
        ['\p'],
        ['''1. GENTLY: "It's ok. It's over now. You're forgiven."'''],
        ['''2. CURTLY: "Well you should be. Now stand up. I don't have any more time to waste on your naughty bottom."''']]), justification=0)
    universal.set_command_interpreter(spank_mai_with_belt_comfort_interpreter)
    universal.set_commands(['(#) Select a number.'])

def spank_mai_with_belt_comfort_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''Slowly, Mai stands, her hands reaching to clutch her well-belted bottom. She turns to face''', name(), '''and hangs her head.''',
            '''"I'm sorry."'''],
            [name(), '''pulls the elf into a hug. "Hey, the spanking's done. Now it's as if it never happened."''', names(), '''bottom twinges, and''', hisher(), 
                '''lips twist. "Well, in a matter of speaking anyway."'''],
            ['''Mai laughs, and then pulls away. She smiles at''', name(), '''through her tears. "Thank you." She glances back at her bottom. "These are good stripes.''',
                '''I shall wear them pride."''']]))
        elif num == 2:
            universal.say(universal.format_text([['''"Yes''', sirmaam()  + ",", '''says Mai, straightening, and rubbing her bottom. She refuses to meet''', names(), '''eye. "Thank you.''',
                '''You have spanked me well, I will wear stripes with pride."\n\n''']]), justification=0)
        if 'Cosimas_task' in keywords():
            convince_mai()
        else:
            universal.say(format_Text([['''"I'm going hide now," says Mai. "Wait out the combat."'''],
                ['''"You're not going to help?" asks''', name(), '''in surprise.'''],
                ['''Mai shakes her head. "I'm not good combat. Better hiding."'''],
                ['''Before''', name(), '''could respond, Mai slips into the shadows, and vanishes.''']]))
            universal.acknowledge(dungeonmode.dungeon_mode)

def convince_mai(): 
    universal.say(universal.format_text([['''"That's great", says''', name() + ".", '''"But Cosima wants you to either go upstairs and help hold the entranceway, or''',
        '''head to the armory and help her there."'''],
        ['''Mai's eyes widen. "Oh no no. I'm not fighter. I'm better hiding, much better hiding."'''],
        ['\p'],
        ['''1. "Look you miserable brat, I didn't come into this creepy-ass maze, get pounced on, bound and''', '''switched''' if not (no_pants() and 
            baring_underwear()) else '''spanked''', '''only for you to refuse to help us. So get your rear moving, or Cosima and I will both go to town''',
            '''on your ass!"'''],
        ['''2. "But, we need your help."'''],
        ['''3. "Oh... Well, ok."'''],
        ['''4. "Coward."''']]), justification=0)
    universal.set_command_interpreter(mai_convince_to_help_interpreter)
    universal.set_commands('(#) Select a number.')

def mai_hand_spanking_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1 and not 'asked_mai_about_hand' in keywords():
            add_keyword('asked_mai_about_hand')
            universal.say(universal.format_text([['''"Because, private corporal punishment within tribe is with hand," says Mai. "Implements are only allowed with''',
                '''approval clan majority, or when punishing outsiders. Private punishments only occur between people who know each other. So,''',
                '''man giving woman public hand spanking, or vice versa, is saying he wants know her well enough punish her in private, or vice versa."'''],
                ['''"I see," says''', name() + "."],
                ['\p'],
                ['''1. Continue the hand spanking.'''],
                ['''2. Pull out the wooden spoon.'''],
                ['''3. Pull out the leather belt.''' if itemspotionwars.leatherBelt in inventory() else '']]), justification=0)
        elif num == 2 or num == 1:
            add_keyword('flirting_with_Mai')
            universal.say(universal.format_text([[names(), '''hand crashes into Mai's upthrust buttocks, his large, heavy hand making her bare, warm, vulnerable cheeks bounce.'''],
                ['''Mai squeals prettily, and squirms mightily, though most of her squirming seems to consist of rubbing the side of her hip against''', names() + "."],
                ['''After several minutes of smacking,''', name(), '''stops. Mai hangs limply in his grip, breathing heavily.'''],
                ['''"Now then, next time you'll make sure a stranger is a member of the guild before thrashing them, yes?" asks''', name() + "."],
                ['''Mai nods. "Yes sir."'''],
                ['''"Good."''', name(), '''releases his hold on the elf, and allows her to stand. She immediately snaps up, and starts dancing in place, furiously''',
                    '''rubbing her bottom.'''],
                ['''"Your hand is so hard," she whines. There is also a hint of satisfaction in her voice.\n\n''']]), justification=0)
            if 'Cosimas_task' in keywords():
                convince_mai()
            else:
                universal.say(universal.format_text([['''After about a minute or so of dancing and rubbing her bottom, the young woman calms down. She flashes''', name(), 
                    '''a smile. "I'll see you later, after the fight."'''],
                    ['''The elf bleeds into the shadows, and disappears.''']]), justification=0)
                universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 3 or num == 2:
            universal.say(universal.format_text([['''"Well I don't want to give you the wrong idea," says''', name() + ".", '''"Especially since I just met you."'''],
                ['''He pulls out his wooden spoon. "So I think I'll use my spoon instead."'''],
                ['''Mai squeaks.''']]), justification=0)
            spank_mai_with_spoon()
        elif (num == 4 or num == 3) and itemspotionwars.leatherBelt in inventory():
            universal.say(universal.format_text([['''"Well I don't want to give you the wrong idea," says''', name() + ".", '''"Especially since I just met you."'''],
                ['''He takes his leather belt, and doubles it over. "So I think I'll use my belt instead."'''],
                ['''"Wha?" says Mai in a small voice.\n\n''']]), justification=0)
            spank_mai_with_belt()


def mai_squat_thrusts_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            add_keyword('mai_squat_thrusts')
            universal.say(universal.format_text([['''"Great," says Mai, grinning. But then she shakes her finger at''', name() + ".", '''"However, if you want my exercises''',
                '''have any affect, you have come everyday. Sporadic attendance waste both our times. So I'm going turn you over my knee and spank you everytime you''',
                '''don't show up. Clear?"'''],
                [name(), '''nods.\n\n''']]), justification=0)
            if 'Cosimas_task' in keywords():
                convince_mai()
            else:
                universal.say(universal.format_text([['\n\nMai slips away into the shadows, leaving''', name(), '''standing alone.''']]), justification=0)
                universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''"Ok," says Mai, shrugging. Bye. I shall wear your stripes pridefully."\n\n''']]), justification=0)
            if 'Cosimas_task' in keywords():
                convince_mai()
            else:
                universal.say(universal.format_text([['\n\nMai slips away into the shadows, leaving''', name(), '''standing alone.''']]), justification=0)
                universal.acknowledge(dungeonmode.dungeon_mode, ())

def mai_convince_to_help_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1 and p.PC.willpower() > 2:
            add_keyword('Mai_defends_armory')
            universal.say(universal.format_text([['''Mai's eyes widen further, and she leans away from''', name() + ".", '''She nods. "Yes''', sirmaam() + '."', '''She runs past''', name(),
                '''and vanishes into the shadows.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 1:
            add_keyword('Mai_refused_to_defend_armory')
            universal.say(universal.format_text([['''Mai shakes her head. "Better sore bottom than open throat."'''],
                [name(), '''growls, and reaches out to grab the elf. Mai ducks the grab, dances past the Taironan, and runs into the maze.''', name(), 
                    '''curses savagely. No way''', heshe(), '''was going to be able to find the wretched elf in this shadowy maze. Hopefully Cosima doesn't''',
                    '''blame''', himher(), '''for this.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            add_keyword('Mai_defends_armory')
            universal.say(universal.format_text([['''Mai gnaws uneasily on a strand of hair. "Are you sure?"'''],
                [name(), '''nods. "Most of our enemies aren't particularly skilled, but they heavily outnumber us. We need every swordarm that we can get."'''],
                ['''Mai studies''', name(), '''carefully, as if looking for a sign of deceit, or exaggeration. Finally, she sighs. "Oh, alright. I'll head to the''',
                    '''armory now. Don't know how useful I'll be, though."'''],
                [name(), '''shrugs. "Hey, this is the first time I've fought outside of sparring matches with my Nana. Don't know how useful I'll be, either."'''],
                ['''Mai gives''', name(), '''a smile, and vanishes into the shadows.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 3:
            add_keyword('Mai_refused_to_defend_armory')
            universal.say(universal.format_text([['''"Thank you," says Mai. "Good luck." The elf vanishes into the shadows.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 4:
            add_keyword('Mai_refused_to_defend_armory')
            universal.say(universal.format_text([['''An expression of sadness flicks across Mai's face. "I've grown used label."'''],
                ['''The elf vanishes into the shadows before''', name(), '''can respond.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())

def mai_stealth_thong_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''"Isn't it?" says Mai, grinning. "And it does excellent job showing off your stripes."'''],
                ['''"That's not exactly something to be proud of," says''', name() + ".", '''"I was thinking more of how I'd look when my bottom isn't all black and''',
                    '''blue."'''],
                ['''Mai flicks her wrist dismissively. "Bah. Good spanking well taken is sign strength. Strength is attractive."'''],
                ['\p'],
                ['''1. "You are a very weird person."'''],
                ['''2. "Ehhh, gonna have to disagree with you on that. About the spanking part anyway."'''],
                ['''3. "I never thought of it like that. Brilliant! Look out world,''', name(), '''and''', hisher(), '''thoroughly paddled bottom is coming at you''',
                    '''whether you're ready or not!"''']]), justification=0)
            universal.set_command_interpreter(mai_spanking_strength_interpreter)
            universal.set_commands(['(#) Select a number.'])
        elif num == 2:
            universal.say(universal.format_text([['''Mai rolls her eyes. "Always you complain about how small it is. Cloth is expensive. So is magic. Also, elves show stripes with''',
                '''pride. Why not humans?"'''],
                ['''"Because we don't like the whole world to know we've been spanked?" says''', name() + ".", '''"It's kind of embarassing."'''],
                ['''"Yes, yes shows you broke rules, did something foolish, whatever," says Mai. She flicks her wrist dismissively. "If rule truly matters, you''',
                    '''get banished not-" Mai stops, and a flash of pain crosses her face. "Nevermind. Though small, outfit is very useful."\n\n''']]), justification=0)
            if 'Cosimas_task' in keywords():
                convince_mai()
            else:
                universal.say(universal.format_text([['''Mai fades into the shadows, leaving''', name(), '''alone with''', hisher(), '''new underwear.''']]))
                universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 3:
            add_keyword('talk_with_Mai')
            universal.say(universal.format_text([['''"This will be useful, I'm sure," says''', name() + ".", '''"However, I've decided that it's not enough."'''],
                ['''"What?" says Mai in a flat voice.'''],
                ['''"I think you still need to be spanked," says''', name() + ".", '''The Taironan lunges for the elf. The elf ducks''', names(), '''lung, and trips''',
                    '''the young Taironan.''', name(), '''falls hard on''', hisher(), '''hands and knees.'''],
                ['''The elf stripes''', name(), '''three times with her switch.''', name(), '''crawls frantically away, yelping in pain, and nearly falling several''',
                    '''times.'''],
                ['''"Terrible, naughty''', boygirl() + ',"', '''thunders the elf. "I offer apology, and make it up you, and you demand more! Terrible, terrible. I will''',
                    '''talk Adrian about this."'''],
                [name(), '''scrambles to''', hisher(), '''feet, only to discover that the elf has vanished.''', name(), '''curses and rubs''', hisher(), '''bottom.''',
                    '''Stupid elf.''']]), justification=0)
            universal.acknowledge(dungeonmode.dungeon_mode, ())
                

def mai_spanking_strength_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            universal.say(universal.format_text([['''Mai shrugs. "Different culture. I'm going hide now. Bye."\n\n''']]), justification=0)
            if 'Cosimas_task' in keywords():
                convince_mai()
            else:
                universal.say(universal.format_text([['''Mai fades into the shadows, leaving''', name(), '''alone with''', hisher(), '''new underwear.''']]))
                universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif num == 2:
            universal.say(universal.format_text([['''"You are free do so," says Mai. "Your culture values strength differently is all. I'm going to hide now, good luck."\n\n''']]))
            if 'Cosimas_task' in keywords():
                convince_mai()
            else:
                universal.say(universal.format_text([['''Mai fades into the shadows, leaving''', name(), '''alone with''', hisher(), '''new underwear.''']]))
                universal.acknowledge(dungeonmode.dungeon_mode, ())
        elif  num == 3:
            universal.say(universal.format_text([['''Mai laughs. "Careful. I'm not sure world is ready."'''],
                [name(), '''chuckles as well.'''],
                ['''"I'm going hide now," says Mai. "See you. Good luck with attackers."\n\n''']]), justification=0)
            if 'Cosimas_task' in keywords():
                convince_mai()
            else:
                universal.say(universal.format_text([['''Mai fades into the shadows, leaving''', name(), '''alone with''', hisher(), '''new underwear.''']]))
                universal.acknowledge(dungeonmode.dungeon_mode, ())
def e0_1_3():
    universal.say_title('Warslinger')
    music.play_music(VENGADOR)
    universal.say(universal.format_text([['\m' + name(), '''enters the armory. The room is depressingly bare. Mostly empty racks line the right and left walls. Scattered about the room are''',
    '''toppled armor stands and empty chests.\n\n''']]), justification=0, music=[VENGADOR])
    if 'met_Cosima' in keywords():
        universal.say(universal.format_text([['''In the center of the room, Cosima wrestles with a masked Taironan man. There is a deep, nearly inaudible thud, and Cosima flies through''',
            '''the air and slams into the wall next to''', name() + ".", '''The woman rolls to her feet, but then the man throws his hands forward.''',
            '''Half a dozen rippling, ocean-blue, razor-sharp spikes fly through the air and drive themselves into Cosima's body. The woman slams into''',
            '''the wall, and hangs pinned. The spikes pulse three times, and each time, Cosima screams.'''],
            ['''"Cosima!"''', name(), '''dashes forward, and reaches for one of the spikes, but a shock of energy drives''', himher(), '''back.'''],
            ['''Then the spikes fade, and Cosima collapses. Her wounds heal, but her entire body is shaking.'''],
            ['''"Are you alright?" asks''', name(), '''crouching next to Cosima.'''],
            ['''Cosima looks up at''', name() + ",", '''before her eyes roll back, and she passes out.''', name(), '''presses''', hisher(), '''fingertips against''',
                '''the instructor's neck. The pulse is faint, but steady, as is Cosima's breathing. A severe case of combat fatigue, but nothing more.'''],
            ['''The Taironan warslinger who took down Cosima strides forward. Behind and to his right is a Taironan woman, clutching a finely made steel dagger in''',
                '''one hand, and wearing a finely-made leather cuirass. Both were almost certainly pilfered from the armory.\n\n''']]), justification=0)
        if 'Mai_defends_armory' in keywords():
            universal.say(universal.format_text([['''Mai, curse the woman, is nowhere to be seen.\n\n''']]), justification=0)
    else:
        universal.say(universal.format_text([['''In the center of the room stands a tall, masked Taironan man, along with an equally masked Taironan woman, though the woman only''',
            '''comes up to the man's shoulder. As soon as''', name(), '''enters, the two turn towards''', himher() + ".", '''The three combatants watch each other''',
            '''for a moment. Then, the two Vengadores approach.''']]), justification=0)
    universal.say(universal.format_text([['''The warslinger, clearly the man who spoke when the Vengadores first attacked, studies''', name() + ".", 
                '''"I've had reports of you. You're the Taironan who recently joined the Guild. I''',
        '''hear you've taken down quite a few of our people. Impressive."'''],
        ['\p'],
        ['''1. "Impressive my ass. 'Your people' could be taken down by a stiff breeze."'''],
                    ['''2. "Look, I'm clearly outmatched here, and stopping you isn't really all that's important to me. So, let's try to end this peacefully, ok?"'''],
        ['''3. "You think so? You hiring?"''']]), justification=0)
    universal.set_command_interpreter(warslinger_interpreter)
    universal.set_commands(['(#) Select a number.'])


def warslinger_interpreter(keyEvent):
    if keyEvent.key in NUMBER_KEYS:
        num = int(pygame.key.name(keyEvent.key))
        if num == 1:
            add_keyword('chastised_warslinger')
            universal.say(universal.format_text([['''The warslinger laughs bitterly. "I suppose that's true. A pity isn't it?"'''],
                ['''An image of the girl''', name(), '''fought in the entranceway flashes through''', hisher(), '''mind.''', HisHer(), '''grip on''', hisher(),
                    weapon().weaponType, "tightens.", '''"How much time did you spend training them? A week? A day?"'''],
                ['''"As much time as we could afford," says the warslinger. All traces of his previous humor (such as it was) have vanished.  "We're on a tight schedule."'''],
                ['''"A pity? That's all you have to say? How much did you teach them?" asks''', name() + ".", '''"Did you teach them how to recognize when their health is nearly''',
                    '''drained? Did you teach them how to fight spellslingers, grapplers, or''',
                    '''spearmen? Or did you just throw them blindly into the Guild as slinger''',
                    '''fodder, while you help yourself to the guild's equipment?"'''],
                ['''"This is war," says the warslinger, a hint of annoyance in his voice. "Sometimes, you have to make less than ideal choices."'''],
                ['''"Oh? And if one of them gets killed? Oh well, it's war right? If one of them kills a guild member? Oh well, it's war, right?''',
                    '''I mean, the Carnutians treat us like shit, so that totally justifies us treating us like shit too!"'''],
                ['''"You know nothing little''',  boygirl() + ',"', '''says the warslinger in a low, dangerous voice. "I think it's time someone taught you some manners."'''],
                ['''The door bursts open, and another masked Vengador rushes in.'''],
                [name(), '''dances to the side, trying to keep all three Vengadores in view. This is just getting better, and better.'''],
                ['''The Vengador spares''', name(), '''a quick glance, before turning to the warslinger. His eyes are wide, and his voice desperate. "We've got a problem."'''],
                ['''The warslinger growls, but his eyes never leave''', name() + ".", '''"Not now."'''],
                ['''"But Airell has joined the fight upstairs. We're losing badly, and need your help," says the Vengador frantically. "If we lose the-"'''],
                ['''The warslinger growls again. "Fine." He jerks his head at his female companion. "Take care of''', himher(), '''would you?"'''],
                ['''The woman nods, and raises her dagger. She grins at''', name() + ".", '''"I've heard of you. Let's see-oww!"'''],
                ['''The woman jerks forward, her free hand lancing back to her rear, as the warslinger gives it a hard slap.'''],
                ['''"Stop taunting''', himher(), '''and just take''', himher(), '''down," snaps the man. He gives the woman a final glare, then starts to leave.'''],
                ['''"Oh no," says''', name() + ", beginning to intercept the warslinger.", '''"You're not-"'''],
                ['''But then the woman attacks, and''', name(), '''suddenly finds''', himselfherself(), '''a little busy.''']]), justification=0)
            universal.acknowledge(combat.fight, necia, spank_necia, townmode.town_mode, False, True, True)
        elif num == 2:
            add_keyword('wimpy')
            universal.say(universal.format_text([['''The woman snorts. "This is''', name() + '?', '''And here-oww!"'''],
                ['''The warslinger's hand snaps down and cracks sharply against the woman's bottom. She hops forward, her hands flying back to shield it.'''],
                ['''The warslinger studies''', name(), '''with narrowed eyes. "I find that hard to believe."'''],
                [name(), '''shrugs. "I don't like fighting when I'm outmatched?"'''],
                ['''The woman laughs scornfully. "You wouldn't last five minutes on the streets of Bonda." She glances at the warslinger. "Can I spank''', himher(), 
                    '''and put''', himher(), '''to bed? Please?"'''],
                ['''The warslinger shakes his head. "This obsession with dominating everyone you meet is not healthy. If''', heshe(), '''doesn't want to fight, then I''',
                '''see-"'''],
                ['''The door bursts open, and another Vengador runs in.'''],
                ['''"We've got a problem," says the newest arrival breathlessly. "Airell's joined the battle in the entranceway. We need you upstairs, and we need you''',
                    '''now."'''],
                ['''"Agh. To be expected I suppose. Alright, let's go." He glances at his female companion. "And as for you, if I return and find out you attacked''',
                    '''this''', manwoman(), '''without provocation, I will take you over my knee, and I won't let you up until you've grown a beard."'''],
                ['''The warslinger and the messenger leave,''', name(), '''quickly side-stepping out of their way.'''],
                ['''As soon as the two leave, the female Vengador turns towards''', name(), '''and raises her dagger.'''],
                [name(), '''takes a wary step backward. "Let me guess, you're a very hairy woman."'''],
                ['''The woman charges.''']]), justification=0)
            universal.acknowledge(combat.fight, necia, spank_necia, townmode.town_mode, False, True, True)
        elif num == 3:
            add_keyword('mercenary')
            universal.say(universal.format_text([['''The warslinger rubs his chin thoughtfully. "Well, 'hiring' is a bit of a strong word. Ragtag bands of poverty stricken freedom''',
                '''fighters don't exactly have a lot of money. But I'm not about to-"'''],  
                ['''Suddenly, the door flies open, and another Vengador runs in. "We've got a problem! Airell's joined the fight upstairs, and we're getting beaten''',
                    '''badly."'''],
                ['''The warslinger curses. "Alright, alright I'm coming." He glances at his female companion. "Be nice to our new friend."'''],
                ['''The woman nods.'''],
                ['''"I mean it," says the warslinger, shaking his finger at the woman.'''],
                ['''"Come on," says the other Vengador impatiently. "If we lose the-"'''],
                ['''"I know, I know," snaps the warslinger, leaving the room with the messenger.'''],
                ['''As soon as the warslinger leaves, the woman turns towards''', name(), '''and raises her knife.'''],
                ['''"Erm, what are you doing?" asks''', name() + ", backing up a step and going for", hisher(), '''own weapon.'''],
                ['''"I wanna see if you're any good," says the woman.'''],
                ['''"I don't-"'''],
                ['''The woman charges.''']]), justification=0)
            universal.acknowledge(combat.fight, necia, spank_necia, townmode.town_mode, False, True, True)

def against_vengadores():
    return universal.format_text([['''The woman falls to her knees, breathing heavily. Her dagger slips from numb fingers with a clatter, and she sways dangerously.'''],
                            [name(), '''is bent over with''', hisher(), '''hands on''', hisher(), '''knees, panting.''', HeShe(), '''glances towards the door, and''',
                                    '''considers chasing after the warslinger and his buddy. But then''', hisher(), '''head starts to throb. So instead,''', heshe(), '''approaches''', hisher(), 
                                    '''beaten opponent, and yanks off the woman's mask.'''],
                            ['''"Hey!" cries the beaten Taironan. She reaches for the mask, but a firm hand on the shoulder keeps her down. The woman has rich dark skin, even''',
                                    '''darker than''', names() + ".", '''Her black hair is cut boy-short. Like the girl upstairs, her cheeks have a hint of gauntness about them.''',
                                    '''Indeed, on closer inspection her body is painfully thin. Her dark eyes are slightly too big for her face.''',
                                    name(), '''judges her to be mid to late twenties, close to''', hisher(), '''own age, maybe a few years older. A thick scar''',
                                    '''runs from just underneath the woman's ear, arcs across her cheek, follows her jawline, and terminates at her chin.'''],
                            [name(), '''can't help but stare at the scar. Scars only form when an injury has to heal without the aid of magic. Most such scars are minor cuts that''',
                            '''aren't traumatic enough to trigger a person's health, and the scars fade after a few months anyway. There are only two cases in which''',
                                    '''someone can go long enough without magic to force a serious injury to heal without it:'''],
                            ['''1. They were seriously ill.'''],
                            ['''2. They were a child.''']])

def neutral_vengadores():
    return universal.format_text([['''The woman stumbles, and falls onto her hands and knees, taking slow, deep breaths. "Ok...maybe I was wrong. You might be a''',
                            '''cursed coward, but at least you're a skilled coward."'''],
                            ['''The ragged scarf she was using as an imprompteu mask was damaged in the battle, and as she slumps, it comes unwound and falls to her feet, revealing rich dark skin, even''',
                                    '''darker than''', names() + ".", '''Her dark hair is cut boy-short. Like the girl upstairs, her cheeks have a hint of gauntness about them.''',
                                    '''Indeed, on closer inspection her body is painfully thin. Her dark eyes are slightly too big for her face.''',
                                    name(), '''judges her to be mid to late twenties, close to''', hisher(), '''own age, maybe a few years older. A thick scar''',
                                    '''runs from just underneath the woman's ear, arcs across her cheek, follows her jawline, and terminates at her chin.'''],
                            [name(), '''can't help but stare at the scar. Scars only form when an injury has to heal without the aid of magic. Most such scars are minor cuts that''',
                            '''aren't traumatic enough to trigger a person's health. Such scars are small, faint, and usually fade away after a few months. There are only two''',
                            '''cases in which someone can go long enough without magic to force a serious injury to heal without it:'''],
                            ['''1. They were seriously ill.'''],
                            ['''2. They were a young child.''']])

def support_vengadores():
    return universal.format_text([['''The woman backs up a step, and clutches at an armor rack. With a shaking hand, she slips her dagger back into its sheath.''',
                    '''"Not...not bad."'''],
    [name(), '''scowls.''', HeShe(), '''marches over to the woman, and yanks her mask off.'''],
                            ['''The woman has rich dark skin, even''',
                                    '''darker than''', names() + ".", '''Her dark hair is cut boy-short, and her dark eyes are slightly too big for her face. Like the girl upstairs, her cheeks have a hint of''',
                                    '''gauntness about them.''',
                                    '''Indeed, on closer inspection her body is painfully thin.''',
                                    name(), '''judges her to be mid to late twenties, close to''', hisher(), '''own age, maybe a few years older. A thick scar''',
                                    '''runs from just underneath the woman's ear, arcs across her cheek, follows her jawline, and terminates at her chin.'''],
                            [name(), '''can't help but stare at the scar. Scars only form when an injury has to heal without the aid of magic. Most such scars are minor cuts that''',
                            '''aren't traumatic enough to trigger a person's health. Such scars are small, faint, and usually fade away after a few months. There are only two''',
                            '''cases in which someone can go long enough without magic to force a serious injury to heal without it:'''],
                            ['''1. They were seriously ill.'''],
                            ['''2. They were a young child.'''],
                            [name(), '''gives herself a little shake, and grabs the woman by the ear. "Give me one reason why I shouldn't yank those trousers down, and paddle your bare bottom from now until new years."'''],
                            ['''The Vengador gives''', name(), '''a cheeky smile. "Stop being such a pussy. I wasn't going to hurt you."'''],
                            ['''"Oh really? I don't know where you're from, but around here getting stabbed hurts, health or no health," says''', name() + "."],
                            ['''"Like I said, stop being a pussy," says the Vengador, smirking.''']])

def spank_necia(allies, enemies, won):
        music.play_music(VENGADOR)
        universal.say_title("Warslinger's Companion")
        if won:
            if 'chastised_warslinger' in keywords():
                universal.say(universal.format_text([against_vengadores(), 
                    ['\p'],
                    ['''1. "Right, anyway. Time you learned what happens to violent little brats that attack innocent guilds."'''],
                    ['''2. Gesture vaguely at the Vengador's scar. "What happened?"''']]), justification=0)
                universal.set_commands(['(#) Select a number.'])
                universal.set_command_interpreter(necia_chastised_warslinger_interpreter)
            elif 'wimpy' in keywords():
                universal.say(universal.format_text([neutral_vengadores(),
                    ['\p'],
                    ['''1. "What did you just call me?"'''],
                    ['''2. "I know, right? It's almost like you can be good at fighting, while avoiding it whenever possible. Who'd have thought."''']]), justification=0)
                universal.set_commands(['(#) Select a number.'])
                universal.set_command_interpreter(necia_wimpy_interpreter)
            elif 'mercenary' in keywords():
                universal.say(universal.format_text([support_vengadores(), 
                    ['\p'],
                    ['''1. "That's it, it's paddling time."'''],
                    ['''2. "Yeah, fine, whatever. Just warn me next time, alright?"''']]), justification=0)
                universal.set_commands(['(#) Select a number.'])
                universal.set_command_interpreter(necia_mercenary_interpreter)
        else:
            universal.say_title("Warslinger's Companion")
            add_keyword('beaten_by_Necia')
            universal.say(universal.format_line([name(), '''stumbles, and clutches at''', hisher(), '''head. The room starts to spin sickeningly.''', HeShe(), '''sways, and then falls forward onto''', hisher(), '''hands and knees.''', HeShe(),
                        '''takes slow, deep breaths, and tries not to throw up.''']), justification=0)
            if 'Mai_defends_armory' in keywords():
                necia_ambush()
                p.PC.currentEpisode.next_scene()
                return
            else:
                if 'chastised_warslinger' in keywords():
                    universal.say(universal.format_text([
                        [''' The Vengador laughs, and walks up to''', name() + ".", '''The scarf she'd been using as a makeshift mask slipped off at some point during the battle,''',
                        '''revealing rich dark skin, even''',
                            '''darker than''', names() + ".", '''Her dark hair is cut boy-short, and her dark eyes are slightly too big for her face. Like the girl upstairs, her cheeks have a hint of''',
                            '''gauntness about them.''',
                            '''Her body is painfully thin,''',
                            '''and looks to be in her mid to late twenties, close to''', hisher(), '''own age, maybe a few years older. A thick scar''',
                            '''runs from just underneath the woman's ear, arcs across her cheek, follows her jawline, and terminates at her chin.'''],
                        [name(), '''stares at the woman, uneasily, focusing in particular on her scar. Scars only form when an injury has to heal without the aid of magic. Most such scars are minor''',
                            '''cuts that aren't traumatic enough to trigger a person's health. Such scars are small, faint, and usually fade away after a few months. There are only two''',
                                    '''cases in which someone can go long enough without magic to force a serious injury to heal without it:'''],
                        ['''1. They were seriously ill.'''],
                        ['''2. They were a young child.'''],
                        ['''"What's wrong?" asks the Vengador, giving''', names(), '''bottom a sharp slap. "Afraid of the big scary rebel lady?"'''],
                        ['\p'],
                        ['''1. Spit on her.'''],
                        ['''2. "Nah. You're just ugly."'''],
                        ['''3. "Please don't hurt me."''']]), justification=0)
                    universal.set_command_interpreter(necia_chastised_lost_interpreter)
                    universal.set_commands(['(#) Select a number.'])
                elif 'wimpy' in keywords():
                    universal.say(universal.format_text([['''\n\n"Feh. No wonder you didn't want to fight us." The Vengador slaps''', name(), '''on the bottom.''', names(), '''arms give out, and''', heshe(), '''slumps forward,''', hisher(), 
                        '''chest pressing against the ground.'''],
                        ['''"Well, isn't that convenient," says the Vengador. She crouches next to''', name(), '''and presses her left hand against the side of''', names(), '''face, holding''', himher(), 
                        '''against the ground. She rubs''', names(), '''upthrust,''', p.PC.clothing_below_the_waist().name + "-clad", '''bottom with her right hand. "Time for a naughty''', boygirl(), '''to get''',
                        hisher(), '''much deserved spanking."'''],
                        ['\p'],
                        ['''1. "How in La Madre's name is getting attacked naughty?"'''],
                        ['''2. "Aww, come on you don't really want to spank me do you? What have I ever done to you?"'''],
                        ['''3. Say nothing.''']]), justification=0)
                    universal.set_command_interpreter(necia_wimpy_lost_interpreter)
                    universal.set_commands(['(#) Select a number.'])
                elif 'mercenary' in keywords():
                    universal.say(universal.format_text([['''\n\n"Well, that was fun," says the Vengador cheerfully. She walks over, and gives''', names(), 
                    '''bottom a smack. "Now, it's time for the loser to be duly chastised."'''],
                    ['''"Say what?" says''', name() + ".", HeShe(), '''starts to crawl away from the crazy Vengador. "Why?"'''],
                    ['''"Because, your fighting style clearly needs some works," says the Vengador, grabbing''', names(), '''hips and dragging''',
                        himher(), '''backwards, towards a particularly flat-topped chest. "It's sloppy, erratic, and has half a dozen or more''',
                        '''openings."'''],
                    ['''"Hey, I put up a pretty good fight," says''', name(), '''indignantly.'''],
                    ['''"Indeed you did," says the Vengador. "If you learn how to fight properly, I wouldn't be fit to clean your boots."'''],
                    ['''The Vengador lifts''', name(), '''and drapes''', himher(), '''across the top of the chest, with''', hisher(), '''bottom''',
                        '''positioned right in the center of the chest. She gives''', names(), '''bum an experimental pat. "The Vengadors could use''',
                        '''a fighter with your potential, and I'm going to help you achieve it."'''],
                    ['''"How is spanking me helping me achieve anything?" cries''', name() + "."],
                    ['''"It'll give you incentive to train, and beat me the next time we spar," says the Vengador. She lands a sharp slap to''',
                        p.PC.clad_bottom() + ".", '''"Don't worry. This time it'll only be a mild spanking over your''', 
                        p.PC.clothing_below_the_waist().name + ".", '''Next time, though, it'll be a sandal on the bare."'''],
                    ['''\p'''],
                    ['''1. Resignation.'''],
                    ['''2. "You stupid tramp, let me go."''']]), justification=0) 
                    universal.set_command_interpreter(necia_mercenary_lost_interpreter)
                    universal.set_commands(['(#) Select a number.'])

def necia_mercenary_lost_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([[name(), '''sighs, and grabs onto the base of the chest.'''],
            ['''"Stick your butt up a little," says the Vengador. "I need a good target."'''],
            [name(), '''grimaces, but does as requested,''', hisher(), '''round bottom rounding even more as''', heshe(), '''elevates it.''', 
                HisHer(), '''face reddens. Getting spanked by this woman was humiliating enough, but being forced to "provide a better target?"'''],
                ['''"Good''', boygirl(), ",", '''says the Vengador. She cracks the flat of her hand against''', names(), '''right cheek.''',
                    '''"There's hope for you yet."'''],
                ['''The Vengador proceeds to give''', name(), '''a short, but sharp spanking. The woman's hand is callused, and her arms''',
                    '''well-muscled, allowing her to land hard, rough slaps.''', universal.format_line([names(), p.PC.lower_clothing().name, '''provides some''',
                        '''protection, but''', hisher(), '''bum is still buzzing angrily by the time the Venador finishes.''']) 
                    if wearing_pants() or wearing_skirt_or_dress() else (universal.format_line([names(), '''thin''', p.PC.underwear().name, 
                    '''provide minimal protection, and''', hisher(), '''bum is stinging fiercely by the end of the spanking. Perhaps''', heshe(),
                    '''should invest in some pants.''']) if not p.PC.underwear().baring else universal.format_line([names(), '''miniscule''', 
                        p.PC.underwear().name, '''provides absolutely no protection, and''', heshe(), '''begins to squirm and yelp lightly''',
                        '''as the woman's heavy hand pounds''', names(), '''poor, exposed bottom. Perhaps running around with''', hisher(), 
                        '''ass hanging out wasn't the greatest idea ever.'''])), universal.format_line([HisHer(), '''lingering welts aren't exactly''',
                            '''helping either.''']) if spanked_episode_1() else universal.format_line(['''At least''', hisher(), '''bottom was still''',
                                '''unblemished. Thank Los Padres for small mercies.'''])],
                            ['''"Alright, I think that's enough," says the Vengador. "Consider that a warning, if you don't get better before''',
                                '''next we meet, it'll be a sandal on the bare."'''],
                            ['''"What do you mean? Wouldn't I go with you guys now?" asks''', name() + ",", '''rubbing''', hisher(), 
                            '''aching bum.'''],
                            ['''The Vengador shrugs. "Maybe. Depends on-"'''],
                            ['''The door bangs open, and the warslinger charges in. His eyes sweep over''', name(), '''and the Vengador. He''',
                                '''sighs in resignation, and looks at the Vengador. "Let me guess, you attacked''', himher(), '''despite''', 
                                hisher(), '''desire to join us, and my express orders not to."'''],
                            ['''The Vengador smiles innocently.'''],
                            ['''"We'll discuss this later," says the warslinger, drumming his fingers against his belt. The Vengador winces.''',
                                '''"For now, we need to get out of here."'''],
                            ['''"What about me?" asks''', name() + ",", '''half-rolling, half-falling off the chest.'''],
                            ['''"We'll send a contact to speak with you later," says the warslinger. "For now, act like you tried to stop us, but''',
                                '''we defeated you." The warslinger gives the Vengador a flat look. "Which shouldn't be too hard. Now let's go."'''],
                            ['''The two Vengadores run out the door, leaving''', name(), '''alone''' + ''', except for Cosima's unconscious''',
                                '''form.''' if 'met_Cosima' in keywords() else '''.''']]), justification=0)
        add_keyword('spanked_by_Necia')
    elif num == 2:
        add_keyword('spanked_by_Necia')
        add_keyword('spanked_by_Necia_with_sandal')
        universal.say(universal.format_text([['''"Right," says the woman. "Sandal on the bare it is, then."'''],
            ['''"Hey, wait, no!" cries''', name() + ",", '''as the Vengador grabs''', universal.format_line(['''the hem of''', names(), '''dress, and''',
                '''drapes it over''', names(), '''back,''']) if
                wearing_dress() else universal.format_line(['''the waistband of''', names(), p.PC.clothing_below_the_waist().name, '''and yanks''', 
                items.itthem(p.PC.clothing_below_the_waist()), '''down to''',
                    names(), '''knees,''']), universal.format_line(['''exposing''', names(), '''quivering bare bottom''']) if not wearing_underwear() or 
                        (not wearing_pants() and not wearing_skirt_or_dress()) else (universal.format_line(['''exposing''', names(), '''skimpy little''', 
                            p.PC.underwear().name, '''and round, not so little bum cheeks.''']) if p.PC.underwear().baring else 
                            universal.format_line(['''exposing''', names(), '''modest''', p.PC.underwear().name, '''(though they suddenly feel a lot thinner than they did''',
                                '''when''', name(), '''put them on).''']))]]), justification=0)
        if wearing_skirt_or_dress_or_pants() and p.PC.underwear().baring:
            universal.say(universal.format_text([['''\n\n"Madre's love," says the Vengador mirthfully. She gathers some of the (rare and valuable) material making up''', names(),
                p.PC.underwear().name, '''in her fist. "Look at how small''', p.thisthese(), p.underwearpanties(), p.isare() + "!", '''Clearly,''',
                p.itthey(),
                '''won't give you any protection to speak of. The only question is: Do I keep''', p.itthem(), '''up, or pull''', p.itthem(), '''up?''',
                '''Up? Down? Up? Down?"'''],
                ['''Each time the bratty Vengador says 'Up,' she pulls''', names(), p.underwearpanties(), '''up. Each time she says 'Down,' she yanks''',
                    p.itthem(), '''down. She does this at least half a dozen times.'''],
                ['''"Oh, for the love-I don't care," snaps''', names(), '''squirming weakly on the chest. "Just make your decision and get it over''',
                    '''with!"'''],
                ['''"Right, down it is," says the Vengador, yanking''', names(), p.underwearpanties(), '''about halfway down''', hisher(), '''thigh.'''],
                ['''"Hey, wait-oww!" cries''', name()  + "."]]), justification=0)
        elif wearing_skirt_or_dress_or_pants() and not p.PC.underwear().baring:
            universal.say(universal.format_text([[''' Next, the woman grabs''', names(), p.underwearpanties(), '''and yanks''', p.itthem(), '''about halfway down''', names(),
                '''thighs.'''],
                [name(), '''groans, and buries''', hisher(), '''head in''', hisher(), '''arms.'''],
                ['''"Sorry, little''', manlady() + ',"', '''says the Vengador. "But I said bare, and I meant bare."''']]), justification=0)
        universal.say(universal.format_text([['''A hard leather sole cracks against''', names(), '''completely exposed, vulnerable bottom, leaving a sandal-shaped''',
        '''burn across''', names(), '''sensitive right cheek.''', name(), '''barely has time to take a breath, before the sandal slaps against''',
        hisher(), '''left cheek.'''],
        ['''The sandal cracks mercilessly against''', names(), '''exposed,''', '''welted''' if spanked_episode_1() else '''smooth''', '''bottom,''',
            '''each blow setting a hundred fires dancing across''', names(), '''cheeks.''', name(), '''starts off gasping, and twitching, but it''',
            '''isn't long before''', heshe(), '''is bucking and yelping beneath that horrible sandal.'''],
        ['''Just when''', name(), '''is convinced''', heshe(), '''can't take anymore, the door bursts open, and the warslinger leading the Vengadores''',
            '''charges in. He spots the Vengador hunched over''', names(), '''bare bottom, with sandal in mid-swing.'''],
        ['''"What are you doing?" roars the warslinger, striding over and grabbing the Vengador's wrist.'''],
        ['''"Um, paddling''', himher() + '?"', '''says the Vengador hesitantly, pointing at''', names(), '''bare, angry red bottom.'''],
        ['''"Didn't I explicitly tell you not to attack''', himher() + '?"', '''says the warslinger, giving the Vengador a light shake. "Well?"'''],
        ['''"Er, maybe," says the Vengador, beginning to gnaw on a fingernail.'''],
        ['''The warslinger growls. "We'll discuss this in much greater length later. For now, we need to get out of here." He glances over at''',
            name() + ".", '''"Terribly sorry about that. I can assure you, she will be paddled far longer and harder than you were. We'll''',
            '''send an agent to meet with you later. Just sit tight and act loyal to the guards."'''],
        ['''The warslinger and his companion run out the armory door.''']]), justification=0)
        p.PC.currentEpisode.next_scene()


def necia_wimpy_lost_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    picked = False
    if num == 1:
        add_keyword('defiant')
        picked = True
    elif num == 2:
        add_keyword('pleading')
        picked = True
    elif num == 3:
        add_keyword('stoic')
        picked = True
    if picked:
        universal.say(necia_wimpy_spanked(), justification=0)
        add_keyword('spanked_by_Necia')

def necia_wimpy_spanked():
    spankText = ''
    if 'defiant' in keywords():
        spankText = universal.format_text([spankText, ['''"You're not naughty because I attacked you," says the Vengador. She lands a hard slap on''', p.PC.clad_bottom() + ".", '''"You're naughty because you got me mad."'''],
            ['''"How could I have possibly gotten you mad?" snaps''', name() + ".", '''"We don't even know each other."'''],
            ['''The Vengador lands a pair of sharp smacks to''', names(), '''uplifted bottom. "Because you're fighting against us, when you should be fighting with us."'''],
            [name(), '''groans. "Not this claptrap again. Can't you people give it a rest? There is no grand Taironan-Carnutian war sweeping the land. Just a bunch of Bondan refugees-oww!"'''],
            ['''"We are not just a bunch of Bondan refugees," cries the Vengador, landing four hard slaps to''', p.PC.clad_bottom() + ".", '''"We're people, living on the edge of starvation, in rotten little''',
                '''hovels, harassed by the guards on one side and the Potion lords on the other, and we're sick of it!"''']])
    elif 'pleading' in keywords():
        spankText = universal.format_text([spankText, ['''"For one thing you have a very annoying pleading voice," says the Vengador, slapping''', name(), 
            '''sharply on the bottom. "For another, how about the fact that you've been helping them, instead of us!"'''],
            ['''"Oh, come on what do you expect me to do?" says''', name() + ".", '''"I've been here for half a day. I don't know who you are,''',
                '''or why you're fighting. I just want a job, and someplace to live."'''],
            ['''"Spoiled brat," mutters the Vengador, sharply slapping the other Taironan's bottom. "'Oh look at me, all I want's a job.' So great''',
                '''to know you have that option. Not all of us are so lucky."''']])
    elif 'stoic' in keywords():
        spankText = universal.format_text([spankText, ['''"I get it," says the Vengador, smacking''', names(), '''bottom. "You're just going to ignore''',
            '''us. Maybe if you ignore us long enough, we'll go away. Well, let's see you ignore this!"''']])
    spankText = universal.format_text([spankText, ['''The Vengador unleashes a flurry of hard blows to''', names(), '''bottom.''', name(), '''squirms and yelps,''', hisher(), p.PC.clothing_below_the_waist().name, 
        universal.format_line(['''doing distressingly little to shield''', hisher(), '''bottom.''']) if wearing_pants() or wearing_skirt_or_dress() or not p.PC.underwear().baring else universal.format_line(['''tiny panties doing''',
        '''absolutely nothing to protect''', hisher(), '''bottom. Seriously,''', heshe(), '''should really start wearing pants.'''])], 
        ['''"Oww!" cries''', name(), '''after a particularly hard blow. "Madre's curse, just leave me alone! I've done nothing to you."'''],
        ['''"Exactly," says the Vengador. She grabs''', names(), p.PC.clothing_below_the_waist().name, universal.format_line(['''and yanks''', items.itthem(p.PC.clothing_below_the_waist()), '''down to''', hisher(), '''knees.''']) if
            wearing_skirt_or_pants() else universal.format_line(['''lifts it up over''', names(), '''bottom and drapes it across''', hisher(), '''back.''']), name(), '''squeals indignantly as''', hisher(),
                universal.format_line([p.PC.underwear().name, '''is exposed.''']) if (wearing_skirt_or_dress() or wearing_pants()) and wearing_underwear() else '''bare bottom is exposed. "You've done absolutely nothing.''',
                '''"Our people are being crushed, and all you care about are a couple handfuls of coins!"'''],
        ['''"This is ridiculous," wails''', name(), '''pounding''', hisher(), '''feet against the ground as the Vengador's heavy hand crashes into''', hisher(), '''bare''' if p.PC.underwear().baring or
            (not wearing_skirt_or_dress() and not wearing_pants) else p.PC.underwear().name + "-clad", '''bottom over and over again.''', '''"I've only been here a day."'''],
        ['''Before the Vengador can respond, the door bangs open, and the warslinger bursts in.'''],
        ['''"We've got to-" He stops, his eyes quickly taking in the situation.'''],
        [names(), '''opponent smiles sheepishly, her hand raised in mid-spank. "Hi."'''],
        ['''The warslinger sighs, and begins massaging his forehead. "You attacked''', himher(), '''didn't you?"'''],
        ['"' + HeShe(), '''attacked-"'''],
        ['''"No I didn't," snaps''', name() + ".", '''"I was just standing there minding my own business when you-"'''],
        ['''"Enough," roars the warslinger. He points a threatening finger at his companion. "You were supposed to be gathering what remaining scraps of equipment you could, not beating someone who didn't want''',
            '''to fight!"'''],
        ['''"But you never-"'''],
        ['''"I never said it, because it should have been obvious!"'''],
        ['''The Vengador hangs her head.'''],
        ['''"We don't have time for this." A golden cord flies from the warslinger's hand and wraps itself around the Vengador's waist. He gives it a tug, and yanks the woman to him, grabbing her and throwing''',
        '''her over his shoulder. He gives her bottom a heavy slap. "When we get back you are getting switched so hard, your wails are going to keep everyone else up, and then they'll spank you too!"'''],
        ['''"No, not the switch," cries the Vengador, struggling. "Anything but the switch."'''],
        ['''"The cane?" suggests the warslinger as he strides to the door.'''],
        ['''"That's even worse!" wails the Vengador as the two disappear into the hallway.''']])
    return spankText



def necia_ambush():
    add_keyword('necia_ambush')
    universal.say(universal.format_text([[''' The Vengador chuckles, and gives''', names(), '''vulnerable bum a sharp slap. "Now-hey!"'''],
        ['''There is a pitter-patter of bare feet on stone, and the rough, grating sound of sandals scraping against stone.''', name(), '''glances over''', hisher(), '''shoulder. Mai has appeared out of''',
            '''nowhere, and grabbed the Vengador from behind. One hand holds the Vengador's hair in a deathgrip, while the other is wrapped around the woman's chest, holding the invader tight against her. The Vengador''',
            '''has reached back to grab the hand holding her hair with one hand, and is struggling to pull Mai's arm free with the other. The two women sway.''', 
            universal.format_line(['''\n\nThe bottom drops out from''', names(), '''stomach. That wretched elf must have surely heard''', hisher(), '''declaration of support for the Vengadores. If she tells the guards...'''])
            if 'mercenary' in keywords() else ''],
        ['''"Naughty girl," hisses Mai into the Vengador's ear. "Attacking and spanking my friends. Very, very naughty."'''],
        ['''The Vengador rams her elbow into Mai's gut once, twice, three times, but Mai only tightens her hold.'''],
        ['''"Every heard of badger?" asks Mai, tugging on the Vengador's hair. "Elves are like badgers."'''],
        ['''Mai sweeps the Taironan's legs out from under her, and throws her to the ground. She puts a foot on the middle of the Taironan's back, and holds her pinned against the ground. She holds out both''',
            '''hands, and glowing golden cords fly from her palms and wrap themselves around the Taironan's arms and legs, tying the woman's arms together, and her legs together. Then Mai sits down on the''',
            '''woman, facing her bottom. She grins, and removes one of the Vengador's sandals. "Badgers who punish naughty invaders."'''],
        ['''"No, let go of me," cries the Vengador, squirming desperately. Mai ignores the woman's pleas, and tugs her trousers down just past her bottom, exposing the other woman's small, dark, round bottom.'''],
        ['''"No resisting, naughty girl," says the elf. She cracks the sole of the sandal against the woman's right cheek. The cheek bounces, and the woman yelps. "Take your punishment like good girl."'''],
        ['''The elf batters the woman's bottom with the sandal, alternating between cheeks, and straying all over her tush.  The woman squirms and bucks against the ground, crying out in pain with every blow.'''],
        ['''Soon, the hard sole of the sandal has reduced the woman to tears, and left deep red marks on her bottom. Still, the elf paddles the Vengador, never slowing, no matter how much the Taironan carries''',
            '''on. Finally, the Vengador sags, all her energy spent. She sobs into the floor, as the sandle continues to rise and fall.'''],
        ['''Then, the door bursts open, and the warslinger charges in. Mai leaps to her feet, and spins to face the warslinger, even as he raises his hand and unleashes four pulsing blue spikes. The spikes''',
            '''slam into the elf, and drive to the ground. They pulse three times, each time eliciting a scream of pain from the elf. After the third pulse, the elf sags, clearly suffering from combat''',
            '''fatigue.'''],
        ['''The warslinger dashes into the room, grabs his sobbing friend, and throws her over his shoulder.'''],
        ['''"Wait," says the Vengador. "First pull-"'''],
        ['''"No time, let's go." The warslinger dashes out of the armory, helping the woman pull her trousers back up even as he runs.''']]), justification=0)
        
def necia_chastised_lost_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        add_keyword('spit')
        universal.say(universal.format_text([['''The woman's head jerks backwards.''', name(), '''smiles in satisfaction as''', heshe(), '''watches the spit trace a rather nasty line down the woman's cheek. The Vengador reaches up''',
            '''and wipes her cheek, and flashes''', name(), '''a rather dangerous looking grin. "Defiant to the end eh? I like that. Not exactly a good survival strategy, least not in Bonda, but I like it. Now,''',
            '''let's see how defiant you are after I'm done paddling you raw!"''']]), justification=0)
    elif num == 2:
        add_keyword('cheeky')
        universal.say(universal.format_text([['''"Well, aren't we a cheeky brat," says the Vengador, giving''', names(), '''bottom a second slap. "You know what happens to cheeky brats?"'''],
            ['''"They're declared Worthy Opponents, and left to recover in peace?" says''', name(), '''hopefully.'''],
            ['''The Vengador gives''', name(), '''a predatory smile. "Not exactly."''']]), justification=0)
    elif num == 3:
        add_keyword('submissive')
        universal.say(universal.format_text([['''"Classic survival trait. You're beaten, so you act as pitiful, and submissive as possible. 'I'm not a threat to you, I've learned my lesson.' Saved my ass''',
            '''more times than I care to count. Well, maybe not my ass, exactly, but the rest of me, certainly."''',
            '''The Vengador takes''', names(), '''chin in a firm grip. "Don't worry, I won't hurt you. You'll just get spanked for opposing us, and I'll get on with my job."''']]), justification=0)
    universal.say(necia_chastised_lost_spank(), justification=0)
    necia_spanking_you_over()

def necia_chastised_lost_spank():
    spankText = universal.format_text([])
    if 'spit' in keywords():
        spankText = universal.format_text([spankText, [''' The Vengador grabs''', name(), '''around the arm, and hauls''', himher(), '''to''', hisher(), 
            '''feet.'''], [name(), '''struggles gamely, but''', hisher(), '''limbs feel like lead, and''', heshe(), 
                '''can't do much more than push weakly against the other Taironan.'''],
            ['''"Stop squirming," says the Vengador, reaching around and slapping''', names(), '''bottom.''', universal.format_line([name(), '''yelps, at the sudden sharp pain spreading across''', hisher(),
                '''tender bottom.''', HisHer(), '''hand snaps back to shield it, but''', heshe(), '''accidentally smacks the woman in the side, instead.''']) if spanked_episode_1() else 
                universal.format_line([name(), '''clenches''', hisher(), '''teeth together, and responds by elbowing the woman in the gut.'''])],
            ['''"Stupid brat," mutters the Vengador. She spins''', name(), '''around and lands six hard smacks to''', p.PC.clad_bottom() + ".", universal.format_line([name(), '''squeals, and dances in place, as the''',
                '''Vengador's hard, callused hand further inflames''', hisher(), '''welts.''']) if spanked_episode_1() else universal.format_line([name() + "'s", '''jaw clenches hard enough to make it ache, and''', heshe(),
                '''takes the blows stoically.'''])],
                ['''Then, the Vengador spins''', himher(), '''back around to face her. She goes down into a lunge position, and with a sharp tug, hauls''', name(),
                    '''across her proffered thigh.''', name(), '''sprawls forward, grunting as''', hisher(), '''gut slams into the woman's leg.''']])
    elif 'cheeky' in keywords():
        spankText = universal.format_text([spankText, [''' The Vengador grabs''', name(), '''around the arm, and hauls''', himher(), '''to''', hisher(), 
            '''feet.'''], ['''"Aww, come on. You don't really want to spank me, do you?" asks''', name() + ".", '''"Don't you have big important rebel things to do?"'''],
            ['''"Aren't you suffering from combat fatigue?" mutters the woman. "Shouldn't you be spending more time panting, and less time talking?"'''],
            ['''"Yeah, Nana always complained about that too," says''', name() + ".", '''"Apparently, I'm a bit of a talker. Don't see how that's a big deal, though-oww!"'''],
            ['''The Vengador reaches around and cracks her hand against''', names(), p.PC.clothing_below_the_waist().name + "-clad", '''bottom. "Seriously, shut up."'''],
            ['''"Now, why would I do what you want me to do?" asks''', name() + ".", '''"After all-"'''],
            ['''The Vengador falls into a lunge position, hauls''', name(), '''across her thigh, and lands two sharp smacks to''', names(), '''bottom.'''],
            ['''"Good answer," says''', name() + "."]])
    elif 'submissive' in keywords():
        spankText = universal.format_text([spankText, ['''"Stand up," says the Vengador.'''],
            ['''Slowly,''', name(), '''pushes''', himselfherself(), '''to''', hisher(), '''feet.''', HeShe(), '''wobbles for a moment,''', hisher(), '''legs threatening to fold, but the Vengador steadies''',
                himher() + ".", '''Once''', name(), '''is stable, the Vengador goes down into a lunge position, and pats''', hisher(), '''thigh.'''],
            [name(), '''grimaces.'''],
            ['''"Come on," says the Vengador, patting her thigh a second time. "It'll be worse if I have to do it."'''],
            [name(), '''sighs. It's not like''', heshe(), '''really has much of a choice, not while''', heshe() + "'s", '''weak as a kitten. So,''', name(), '''bends over, and carefully places''', himselfherself(),
                '''over the Vengador's knee.''']])
    spankText = universal.format_text([spankText, ['''The Vengador lightly taps''', names(), '''bottom. Then there is a loud 'splat' and a wave of pain washes across''', names(), '''bottom.''']])
    if wearing_pants() or wearing_skirt_or_dress():
        spankText = universal.format_text([spankText, universal.format_text([ 
            ['''The Vengador beats''', names(), '''ass with hard, fast blows. Between the woman's stinging slaps and the angry buzzing of''', names(), '''old welts, it isn't long before''', name(), 
                '''is bucking wildly and howling at the top of''', hisher(), '''lungs.''']]) if spanked_episode_1() else 
            universal.format_text([['''The Vengador beats''', names(), '''ass with hard, fast blows. The sting in''', names(), '''bottom builds from a single hornet, to two, to a nest, to three nests, to a thousand''',
                '''nests of angry hornets all driving their stingers into''', names(), '''poor, vulnerable bottom.'''],
                [name(), '''begins to squirm, and hiss. Then, pound the ground, then''', hisher(), '''feet start to kick.''']]),
            ['''Unfortunately, the more''', name(), '''carries on, the harder the Vengador spanks''', himher() + ",", '''which makes''', name(), '''flail more, which makes the Vengador spank harder, in a''',
                '''vicious, painful cycle.'''],
            ['''"Madre's love, you're pathetic," says the Vengador. "You take a hand spanking like a spoiled brat whose never been spanked a day in''', hisher(), '''life."'''],
            ['''"Shut up," mutters''', name(), '''through''', hisher(), '''tears. "It hurts."''']])
        spankText = universal.format_text([spankText, ['''"OK. We'll just move on to the main event."''']]) 
        if wearing_skirt_or_dress():
            spankText = universal.format_text([spankText, ['''The Vengador grabs the hem of''', names(), p.PC.lower_clothing().name, '''and pushes it up over''', names(), '''bottom.''']])
        elif wearing_pants():
            spankText = universal.format_text([spankText, ['''The Vengador''', universal.format_line(['''removes''', names(), '''belt''']) if itemspotionwars.leatherBelt in inventory() else universal.format_line(['''unties the string''',
                '''holding''', names(), '''trousers up''']), '''and pulls''', names(), '''trousers down to''', hisher(), '''ankles.''']])
    if spanked_episode_1():
        spankText = universal.format_text([spankText, universal.format_line(['''She whistles, and one of her fingers lightly traces one of''', names(), 
            '''visible welts. "No wonder you were carrying on like a three year old."''']) if p.PC.underwear().baring else universal.format_line(['''The Vengador then hooks her fingers in the''',
            '''waistband of''', names(), p.underwearpanties(), '''and pulls them down to''', names(), '''ankles. She whistles. "No wonder you were carrying on like a three year old."''']),
        [universal.format_text([['''"So, does that mean you'll go easy on me?" asks''', name() + "."],
            ['''"No."''']]) if 'submissive' in keywords() else (universal.format_text([['''"I know right? And I thought Nana was quick-oww!"'''],
            ['''The Vengador spanks''', names(), '''tender right cheek. "Please shut up."''']]) if 'cheeky' in keywords() else universal.format_text([['''"Not a big deal," says''', name(), '''through''', hisher(),
                '''tears.'''],
                ['''"That so?" says the Vengador. She lands a particularly hard blow to''', names(), '''left sitspot.''', name(), '''kicks, and cries out in pain. "Guess you won't mind if I don't''',
                    '''go easy on you?"'''],
                [name(), '''grimaces. Stupid bravado.''']]))]])
    else:
        spankText = universal.format_text([spankText, ['''"Hmm. Your bottom is darkening nicely." The Vengador gives''', names(), '''right cheek a sharp slap. "There's even some red peeking through."'''],
            [universal.format_line(['''"Please stop," says''', name(), '''quietly. "Please, I've add enough."''']) if 'submissive' in keywords() else (universal.format_text([['''"So, that sounds to me like a good reason to stop,''',
                '''right? Nana always told me that unless someone did something really bad you should always stop when red starts to peek through, and-oww!"'''],
                ['''"I'm not going to stop until you shut up," says the Vengador, striking''', names(), '''left cheek. "Madre's love!"''']]) if 'cheeky' in keywords() else universal.format_text([['''"Oh the horror," says''',
                    name(), '''in a bored voice. "How ever will I survive?"'''],
                    ['''The Vengador lands another stinging slap to''', names(), '''sitspot. "I dunno. Let's find out."''']]))]])
    if wearing_pants() and itemspotionwars.leatherBelt in inventory() and (('cheeky' in keywords() and not spanked_episode_1()) or ('spit' in keywords())):
        spankText = universal.format_text([spankText, ['''The Vengador rests''', names(), '''leather belt across''', hisher(), '''back, and holds it with the same hand with which she's holding down''', 
            name() + ".", '''Then, she doubles the belt over.'''],
        ['''"What are you doing?" asks''', name() + "."],
        ['''"Well, I noticed you have this wonderful belt," says the Vengador. "And it just seems like such a waste not to use it."'''],
        [universal.format_line(['''"No, no no. Please don't use that you really don't want to-owwwww!"''']) if 'cheeky' in keywords() else universal.format_text([['''"What's wrong, my butt too hard for your hand?" asks''', 
            name() + "."],
            [''' The Vengador laughs, and gives''', names(), '''bum a squeeze. "Are you kidding? This flabby thing? No, I just think your past misbehavior has earned you a taste of your own''',
            '''leather."''']])]])
        spankText = universal.format_text([spankText, ['''The hard, cracked leather snaps across''', names(), '''bottom.''', name(), '''shrieks, and begins to buck and flail.''', '''The Vengador tightens her grip, and begins vigorously lashing''', names(), '''blazing bottom.''', names(), '''flailing becomes so''',
            '''bad, that the Vengador loses her grip, and''', name(), 
            '''rolls off of her thigh.''', HeShe(), '''starts to crawl away, but the Vengador grabs''', hisher(), '''ankle and drags''', himher(), '''back.'''],
            ['''"Naughty''', boygirl() + ',"', '''says the Vengador, giving''', names(), '''left cheek a sharp slap. She sits down on her ankles, and hauls''', name(), '''back across her knee, but''',
            '''this time in a much more secure manner. "You're getting extra for that."'''],
            ['''"No, stop please," cries''', name() + ".", '''"Madre, it hurts so much."'''],
            [universal.format_line(['''"Hah!" cries the Vengador. She snaps the belt across''', names(), '''blazing bottom, eliciting a high-pitched howl. "Bravado sure does vanish quickly when you're getting''',
                '''your naked ass tanned with your own belt, doesn't it?"''']) if 'spit' in keywords() else 
                universal.format_line(['''"What that's it? Aren't you going to keep talking?" The Vengador snaps the belt across''', names(),
                '''bottom a second, eliciting an ear-splitting shriek. "Finally learned the value of silence?"'''])],
            ['''All in all, the Vengador straps''', name(), '''a dozen times with the belt, fully half of them across''', names(), '''sitspots. She even lands a few just below that, across the crease''',
                '''where bum meet thigh. The rest are applied with great gusto to the middle of''', names(), '''cheeks.''', name(), '''bucks, flails, and shrieks''', hisher(), '''way through every''',
                '''blow.'''],
    ['''Finally, the Vengador stops, and''', name(), '''fully slumps across the woman's lap.''', HisHer(), '''entire body shakes with the force of''', hisher(), '''sobs.''']])
    else:
        spankText = universal.format_text([spankText, ['''And with that, the Vengador begins sharply spanking''', names(), ''' bare bottom.'''], 
            [name(), '''cries and kicks frantically with each blow. The sharp crack of hand to bare flesh rams against''', hisher(), '''ears, in perfect tandem with the hot flashes of pain erupting across''',
                hisher(), '''bottom. Just as before, the more''', heshe(), '''flails, the harder the Vengador spanks, until the crack and heat meld together into a single multi-sensory sensation of pain.'''],
            ['''Then, the sensation fades.''', name(), '''takes a few slow, deep breaths,''', hisher(), '''bottom clenching and unclenching in preparation for the next slap.''']])
    spankText = universal.format_text([spankText, ['''Then, to''', hisher(), '''immense surprise the Vengador begins to very gently stroke''', names(), '''welts. "Hush. It's all over now. Are you going to challenge''',
    '''us again?"'''],
    [name(), '''shakes''', hisher(), '''head fervently, sending tears flying from''', hisher(), '''face.'''],
    ['''"Good, good. Because I'll make this feel like a gentle love tap if you do."'''],
    ['''Then, the door bursts open, and the warslinger from before runs in. His eyes quickly take in the scene. "I see you've brought our''',
        '''self-righteous friend here down a peg or two."'''],
    ['''The Vengador shrugs, and flashes the warslinger a grin. "All in a day's work."'''],
    ['''"And you also lost your mask," says the warslinger sternly, putting his hands on his hips.'''],
    ['''The Vengador shrugs uneasily, as she pushes''', name(), '''off her lap. "It got damaged in the battle."'''],
    ['''"Can't be helped I suppose," says the warslinger. "Though I'd feel more comfortable about it if you weren't so distinctive. Anyway, we''',
        '''need to get out of here, now. We're holding the entranceway, but the guards are on their way, and they're on their way fast."'''],
    ['''The Vengador nods, and leaps to her feet. "Then let's get out of here."'''],
    ['''The two Vengadores rush out, leaving''', name(), '''lying on the floor, clutching at''', hisher(), '''ravaged bottom.''']])
    remove_keyword('spit')
    remove_keyword('cheeky')
    remove_keyword('submissive')
    return spankText


def necia_spanking_you_over():
    add_keyword('spanked_by_Necia')
    p.PC.currentEpisode.next_scene()



def necia_mercenary_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        add_keyword('wants_to_spank_rich_brats')
        universal.say(universal.format_text([['''"Hey no, stop," says the woman, as''', name(), '''bends the Taironan over''', hisher(), '''hip, and locks''', hisher(), '''arm around the woman's waist. "Come on, it was just a bit of''',
            '''fun."'''],
            ['''"No, it wasn't."''', name(), '''smacks the woman's (unwillingly) proffered bottom. "Fun, would be you saying 'Hey, let's spar a little. Here are some rules we can follow, give a warning if things''',
                '''get too intense.' Then, I can say 'Aren't you supposed to be stealing equipment for the Vengadores? Won't your bosses be a little miffed if they catch us sparring?' And then you can say''',
                ''''Oh, I suppose you're right. Darn.' That's fun. Fun is not randomly attacking me."'''],
            ['''Throughout this entire rant,''', name(), '''peppers the woman's bottom. The Vengador squirms, her hips rocking back and forth.'''],
            ['''"Seriously, stop squirming," says''', name(), '''as''', heshe(), '''tightens''', hisher(), '''grip. "This is like the fourth time I've had to adjust my grip."'''],
            ['''"So sorry to be inconveniencing you," says the Vengador sarcastically.'''],
            ['''"Fine."''', name(), '''unties the string holding up the woman's trousers.'''],
            ['''"Hey, come on," cries the Vengador, reaching back to grab her trousers. "Aren't you going a little far?"'''],
            [name(), '''gives the woman's hand a hard slap. The Vengador yelps, and snaps her hand away.''', name(), '''quickly grabs the woman's trousers, and yanks them down, letting them pool around the woman's''',
                '''ankles, exposing a round, brown bottom.''', name(), '''begins slapping the woman's cheeks, watching (with more than a little satisfaction) as they bounce a little beneath the''',
                '''blows. For her part, the Vengador starts to yelp, and her squirming intensifies.'''],
            ['''"I told you to stop squirming, or I'll spank you harder," says''', name() + ",", '''landing a particularly sharp slap to the woman's left sitspot.'''],
            ['''"But that'll just make me squirm more," whines the Vengador.'''],
            ['''"Indeed. Better get yourself under control now."''', names(), '''cupped hand alternates between each cheek,''', hisher(), '''wrist snapping just before each impact, so that each blow''',
                '''skips across the woman's cheeks.'''],
            ['''"Sadistic, boring, stiff-necked ass," cries the Vengador after a particularly hard blow to her right cheek.'''],
            [name(), '''stops, and rubs''', hisher(), '''aching hand against''', hisher(), '''thigh. Stupid muscle butt. Why couldn't''', heshe(), '''be spanking some rich brat whose never worked a day in her''',
            '''lives? Bet a girl like that would have a soft, fleshy bottom.'''],
            ['\p'],
            ['''1. Stop the spanking.'''],
            ['''2. The spoon reigns supreme.'''],
            ['''3. But not as supreme as the belt.''' if itemspotionwars.leatherBelt in inventory() else '']]), justification=0)
        universal.set_command_interpreter(necia_spar_interpreter)
        universal.set_commands(['(#) Select a number.'])
    elif num == 2:
        universal.say(universal.format_text([['''The woman smiles gratefully, clearly glad she won't get spanked (or at least, that the spanking's going to be delayed until the warslinger finds out).''']]), justification=0)
        necia_spanking_over()

def necia_spar_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([['''"I think that's enough," says''', name() + ",", '''freeing the woman from''', hisher(), '''grasp. "Next time you want to spar, we set up rules, first."'''],
            ['''The woman sags onto her knees, and hikes her trousers back up, wincing a little as the rough wool scrapes against her tender bottom.''']]), justification=0)
        necia_spanking_over()
    elif num == 2:
        universal.say(universal.format_text([[name(), '''pulls''', hisher(), '''wooden spoon from''', hisher(), '''pack.'''],
            ['''"What are you doing?" asks the Vengador nervously, as''', name(), '''lightly taps the spoon against the woman's very vulnerable bottom.'''],
            ['''"Your ass is way too hard," says''', name() + ".", '''"Spanking you with my hand hurts too much."'''],
            ['''"Oh, it hurts your hand-aagh!" cries the Vengador, as the spoon slaps against her right cheek.'''],
            ['''"Indeed. Fortunately, I've found a solution."''', name(), '''rains half a dozen sharp blows to the woman's bottom, three to each cheek.'''],
            ['''The Vengador yelps and kicks. She bounces her bottom up and down in''', names(), '''grip. "Well aren't you clever!"'''],
            ['''"I know right?" says''', name() + ",", '''landing three quick blows to the woman's right sitspot.'''],
            ['''The Vengador howls, her hands snapping back to shield her very sensitive sitspots. A few light smacks with the spoon against her knuckles solves that problem.'''],
            [name(), '''peppers the woman's bare, bouncing bum with the wooden spoon. The Vengador bucks and kicks desperately. She pounds her fist uselessly against''', names(), '''calf, while the other tugs''',
                '''vainly on the arm wrapped around her waist. Her yelps come more and more frequently, until she's yelping after every blow.'''],
            ['''Finally,''', name(), '''stops. "Have you learned your lesson?"'''],
            ['''The Vengador nods quickly. "Sparring needs rules."'''],
            ['''"Good."''', name(), '''lets the woman go. The Vengador slumps to her knees, and tugs her rough woolen trousers back up over her bruised, aching bottom.''']]), justification=0)
        necia_spanking_over()
    elif num == 3 and itemspotionwars.leatherBelt in inventory():
        universal.say(universal.format_text([[name(), '''lets go of the woman, and lets her slump down onto her knees, clutching at her sore bottom and moaning. But then,''', name(), 
            '''grabs the scruff of her neck, and pushes her gently''',
            '''but firmly forward. The Vengador, caught off-guard, yelps, and her hands snap out to catch herself. Unfortunately, her arms are still terribly weak from the combat fatigue, and she ends up slumping forward,''',
            '''her chest and face pressed against the ground, and her bottom high up in the air. She tries to struggle back up, but''', names(), '''hand keeps her firmly in place.'''],
            ['''"Hey, what are you doing?" asks the Vengador, squirming in''', names(), '''grip.'''],
            [name(), universal.format_line(['''removes''', hisher(), '''belt from''', hisher(), '''trousers''']) if wearing_pants() else universal.format_line(['''removes''', hisher(), '''belt from''', hisher(), '''pack.''']), 
                '''"Kind of hard to use the belt while I've got you tucked under my arm."'''],
            ['''The Vengador's eyes widen. She tries to crawl away, but''', names(), '''hold is firm. "Wait, come on you don't really-oww!"'''],
            ['''The cracked leather licks across the woman's bottom, her cheeks bobbing beneath the hard blow. The harsh snap of leather to bare flesh echoes throughout the room, intermingled with her cry of''',
                '''pain.'''],
            ['''The sharp bang of leather to flesh echoes throughout the room a second time, and a third time, and a fourth. Soon, the armory is filled to bursting with the cacophony of leather to bare cheeks,''',
                '''intermingled with pained cries. The Vengador pounds her feet against the ground, and her hips sway frantically through the air.'''],
            ['''The bobbing makes it very difficult for''', name(), '''to aim. At one point,''', heshe(), '''accidentally strike the woman's lower back. Later,''', heshe(), '''strikes the woman's''',
                '''thigh.''', name(), '''grimaces, and lowers the belt. The woman's just squirming too much to make using the belt safe.''', name(), '''studies the many welts that criss-cross the woman's bottom.''',
                '''Though it looks like the woman's been been thoroughly chastised. Perhaps too thoroughly, if truth be told.'''],
            ['''"Alright, that's enough," says''', name() + ",", '''standing and replacing''', hisher(), '''belt. "Have we learned our lesson?"'''],
            ['''The Vengador curls into the fetal position, and reaches back to hold her bottom, nodding wordlessly through her tears.'''],
            ['''"Good."''']]), justification=0)
        necia_spanking_over()

def necia_wimpy_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([['''The woman raises her head, and glares at''', name() + ".", '''"I called you a coward."'''],
            [name(), '''marches up to the woman, and leans down,''', hisher(), '''face inches away from the Vengador's. "Care to tell me what's cowardly about kicking your little ass?"'''],
            ['''"Defending yourself isn't courage.''',
                '''Picking a cause, and fighting for it, no matter the odds. Making your voice heard. Standing up and saying 'I won't let you crush me.' That's courage. You? You're just a cowardly little''',
                '''mercenary."''',
                '''The Vengador spits on''', name() + ",", '''who lurches backward,''', hisher(), '''hand snapping up to wipe away the spittle that had slammed into''', hisher(), '''eye.'''], 
            ['\p'],
            ['''1. "I did not just get lectured on morality by a violent little thief."'''],
            ['''2. "Right. Someone's earned herself a hell of a spanking."''']]), justification=0)
        universal.set_command_interpreter(necia_lecture_interpreter)
        universal.set_commands(['(#) Select a number.'])
    elif num == 2:
        universal.say(universal.format_text([['''The Vengador scowls, clearly not appreciating the sarcasm. "Get buried."'''],
            ['''"Sorry, brat, but you're not getting off that easily."''', name(), '''puts''', hisher(), '''hands on''', hisher(), '''hips. "Now, I believe you said something about someone being''',
                '''spanked and put to bed. So let's get on with it, shall we?"\n\n''']]), justification=0)
        necia_wimpy_spanking()


def necia_wimpy_spanking():
    add_keyword('spanked_necia')
    universal.say(universal.format_text([[name(), '''grabs the Vengador's arm and hauls her to her feet. The Vengador struggles, but she's still weak as a kitten, so''', name(), '''easily spins her around, and pushes her over''',
        '''a nearby chest. The Taironan grunts as she falls across the chest, and tries to roll off.''', name(), '''grabs her around the hips, and half-carries, half-pushes her further forward on the chest, until''',
        '''her bottom is positioned right on top. The woman tries to push herself up with her arms, but they're still too weak to hold even her upper body up, and she slumps down, her chest pressed against the''',
        '''ground.'''],
        [name(), '''crouches next to the woman, and hooks''', hisher(), '''arm around the small of the woman's back.''', HisHer(), 
            '''hand begins to rise and fall, cracking sharply against the Vengador's upraised bottom.'''],
        ['''"Seriously, what in La Madre's name were you doing?" asks''', name(), '''as''', hisher(), '''hand smacks against the woman's trouser-clad bottom. "I'd expect some spoiled rich kid knight-wannabe to push a''',
            '''fight, but you? Unless I'm completely off base, you grew up on the streets of the slums, fighting and running almost from the day you were born."'''],
        ['''"Bonda, actually," says the woman, squirming after a particularly sharp slap to her right sitspot.'''],
        ['''"Even worse," cries''', name() + ".", HeShe(), '''lands four hard slaps to the girl's left sitspot. "You grew up in Bonda. Bonda. A ruined wretch of a city''',
            '''whose ruins are being squabbled over by petty warlords. Whose surrounding lands are rife with roving bands of thugs. A place of endless war, and carnage, and at the first opportunity, you go running''',
            '''into-Oh. I guess running into battle makes sense, if everyone else is doing it too. Hit your enemy before he can hit you, yeah? I suppose that's how you got your scar, huh?"'''],
        ['''The woman glances over her shoulder at''', name() + ",", '''and then twists back around to stare at the floor. "Spank me or don't, but stop looking at me like that."'''],
        ['\p'],
        ['''1. "Like what? With understanding?"'''],
        ['''2. "Ok. Spank it is, then."''']]), justification=0)
    universal.set_command_interpreter(necia_understanding_interpreter)
    universal.set_commands(['(#) Select a number.'])

def necia_understanding_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([['''The woman barks a short, harsh, mocking laugh. "Just shut up, and spank me, or leave me be."'''],
            ['''1. Spank her. Hard.'''],
            ['''2. Leave her be.''']]), justification=0)
        universal.set_command_interpreter(necia_leave_be_interpreter)
        universal.set_commands(['(#) Select a number.'])
    elif num == 2:
        necia_wimpy_continue_spanking()

def necia_leave_be_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([['''"Ok, spanking it is." ''']]), justification=0)
        necia_wimpy_continue_spanking()
    elif num == 2:
        universal.say(universal.format_text([[name(), '''removes''', hisher(), '''arm, and stands.''', HeShe(), '''wipes''', hisher(), '''hands. "Whatever. I'm done here."''']]), justification=0)
        necia_spanking_over()

def necia_wimpy_continue_spanking():
    universal.say(universal.format_text([[name(), '''unties the string holding the woman's trousers up.''', HeShe(), '''hooks''', hisher(), '''fingers in the waistband of her trousers, and yanks them down to her ankles, exposing a''',
    '''round, muscular bottom, already lightly marked by''', names(), '''hand. The Vengador groans, and unsuccessfully tries to squirm out of''', names(), '''grip.'''],
    ['''"Oh, stop squirming," says''', name() + ".", HisHer(), '''hand smacks sharply against the woman's exposed bottom. "Madre's love,''',
        '''you take your spankings like the youngest daughter of the eldest son of the largest noble family in Avaricum."'''],
    ['''The Vengador slumps against the chest, her small burst of energy quickly spent.'''],
    ['''The sharp crack of bare hand to bare flesh echoes throughout the armory, interlaced with the occasional moan of pain, and the harsh scraping of the chest against the floor, as the Vengador drives against''',
        '''the ground with her feet, and pushes against the chest with her bare hips.'''],
    ['''"You naughty girl," says''', name() + ",", hisher(), '''voice as sharp as''', hisher(), '''slaps. "You fight only when it's strictly necessary. Only when it's strictly necessary! Getting into random fights''',
        '''because you want to 'spank someone and put them to bed' is a good way to get yourself hurt or killed. And what about the General's Gift, huh? You want your body to break down before you're even into''',
        '''your fifth decade?"'''],
    ['''"Please," says the woman through gritted teeth. "You really think I'm going to live to my fifth decade? I'll be impressed if I make it to forty."'''],
    ['''"Of course you won't, if you keep getting into fights like this," cries''', name() + ",", '''landing a series of particularly hard slaps to the girl's firm globes.'''],
    ['''"What do you care, anyway?" muttered the woman. "We're enemies, remember?"'''],
    ['''"Padre de la Madre," says''', name(), '''in exasperation.''', HeShe(), '''smacks the girl's left sitspot, eliciting a yelp and squirm. "We're not enemies. Maybe you've got a grudge against Avaricum.''',
        '''Fine, whatever. But I'm not an Avaricumite, Madre, I'm not even Carnutian. I just want to be left alone to live my life. You respect that, and we won't get into situations like this. Understand?"'''],
    ['''"Either you're with us, or you're supporting our enemies," says the woman grimly.'''],
    ['\p'],
    ['''1. "Perhaps..."'''],
    ['''2. Give up on her.'''],
    ['''3. Bust out the spoon.'''],
    ['''4. Maybe the belt will do the trick.''' if itemspotionwars.leatherBelt in inventory() else '']]), justification=0)
    universal.set_command_interpreter(necia_wimpy_escalate_interpreter)
    universal.set_commands(['(#) Select a number.'])

def necia_wimpy_escalate_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([[name(), '''grimaces, and runs a hand through''', hisher(), '''hair.''', HeShe(), '''stands, and walks a few steps away. "How, exactly, am I supporting them?"'''],
            ['''"By supporting the current system," says the woman. "By letting them grind us down."'''],
            [name(), '''shakes''', hisher(), '''head, but doesn't say anything.''']]), justification=0)
        necia_spanking_over()
    elif num == 2:
        universal.say(universal.format_text([['''"You know, what fine. I'm done."''', name(), '''pushes the woman off the chest, and stands. "Hate me all you want, I really don't care anymore."''']]), justification=0)
        necia_spanking_over()
    elif num == 3:
        universal.say(universal.format_text([['''"Stupid, pointless, black and white viewpoint," mutters''', name() + ".", HeShe(), '''pulls''', hisher(), '''wooden spoon out of''', hisher(), '''pack. "Maybe my spoon'll open your''',
            '''eyes."'''],
            ['''The woman's bottom clenches nervously, and she sucks in a deep breath.''', name(), '''begins to smack the woman's bottom with the spoon, focusing on the girl's sitspots. The Vengador kicks''',
                '''and twists in''', names(), '''grasp, the chest shifting around on the floor as she grinds against it. With each blow, the woman's squirming increases in intensity. Soon, she is thrashing''',
                '''and yelping as the spoon cracks against her bottom, and''', name(), '''can't help but  feel a bit of sympathy for her; after all''', heshe(), '''has felt the spoon's sting countless times''',
                himselfherself() + '''.'''],
            ['''Finally,''', name(), '''lands one last sharp smack, and lets go of the woman. The Vengador rolls off the chest, clutching at her bruised, stinging bottom and hissing in pain.'''],
            ['''"Right, hopefully that'll teach you to be a bit more careful who you call an enemy," says''', name() + ",", '''slipping''', hisher(), '''spoon back into''', hisher(), '''pack.''']]), 
            justification= 0)
        necia_spanking_over()
    elif num == 4 and itemspotionwars.leatherBelt in inventory():
        universal.say(universal.format_text([[name(), universal.format_line(['''pulls''', hisher(), '''belt free.''']) if wearing_pants() else universal.format_line(['''pulls''', hisher(), '''belt from''', hisher(), '''pack.'''])],
            [HeShe(), '''doubles it over, watching as the Vengador's bottom clenches and unclenches, the only sign of the woman's nerves. "Alright, brat. You've attacked this guild for no good reason,''',
                '''you've attacked me for no good reason, and to top it off you've tried to wrap it up in some freedom fighting bull. Well, honey, it's time you learned the error of your ways."'''],
            [name(), '''snaps the belt across the woman's bare bottom. The Vengador howls, and she bucks against the chest, her hips slamming into the chest. Her feet scramble against the ground, and''',
                '''she claws the stone with her nails.''', name(), '''straps the other Taironan repeatedly. The woman's bottom bounces beneath the rough leather, and it isn't long before she starts to sob.'''],
            ['''After about ten blows,''', name(), '''puts''', hisher(), '''belt away. "Alright, we're done."'''],
            ['''The woman half rolls, half falls off the chest, grasping her thighs, because her bum is too tender to touch. She takes long, slow breaths, struggling to keep her tears under control.'''],
            [name(), '''watches the woman roll around and cry, wondering if perhaps''', heshe(), '''should comfort the woman. Before too long, however the woman stops rolling, and manages to bring herself''',
                '''back under control.''']]), justification=0)
        necia_spanking_over()


def necia_lecture_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([['''"I'm not a thief. I'm a defender of the Bondan people," says the Vengador, forcing herself to sit up straight.'''],
            ['''"How very noble," says''', name() + ".", HeShe(), '''grabs the woman's arm, and yanks her to her feet. "I'm going to martyr your bottom now. Brace yourself."\n\n''']]), justification=0)
        necia_wimpy_spanking()
    elif num == 2:
        necia_wimpy_spanking()


def necia_chastised_warslinger_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        add_keyword('spanked_necia')
        universal.say(universal.format_text([[name(), '''snatches up the woman's fallen dagger, and slips it into a side pocket of''', hisher(), '''pack. Then,''', heshe(), '''removes the woman's breastplate''',
            '''revealing a ratty, heavily patched shirt. The woman doesn't bother to resist (not that she has the strength to, anyway). She just watches''', name(), '''with a smoldering, hate-filled glare.'''],
            ['''"Oh yes, I'm so sorry," says''', name(), '''sarcastically, as''', heshe(), ''' tosses the leather breastplate to the side. "So terribly sorry that I didn't just stand around with my thumb up my''',
            '''ass while you and your''',
                '''buddies attacked innocent people and took their stuff."'''],
            ['''The woman just continues to glare.'''],
            [name(), '''presses''', hisher(), '''lips together.''', HeShe(), '''grabs the woman by the arm and yanks her to her feet. "Let's see how stoic you are after I've tanned your ass."\n\n''']]),
            justification=0)
        p.PC.take_item(itemspotionwars.qualityDagger)
        p.PC.take_item(itemspotionwars.leatherCuirass)
        necia_chastised_spank_interpreter()
    elif num == 2:
        universal.say(universal.format_text([['''The woman gives''', name(), '''a mystified look, and''', name(), '''explicitly points at the woman's face.'''],
            ['''The Vengador scowls. "None of your cursed business."'''],
            ['''"Sorry," says''', name(), '''with a touch of indignation. "It's just, scars aren't exactly common-"'''],
            ['''The woman laughs harshly. "Maybe not where you're from, you ignorant''', pigcow() + ",", '''but if scars were currency, Bonda'd be the richest city in the world."'''],
            [name(), '''lips tighten. "I was just trying to show concern. No need to insult me."'''],
            ['''"Concern?" says the woman scornfully. "Globos de la Madre, but you are dumb." She gestures towards the wall. "Why don't you go show concern for that wall over there, and leave me alone?"'''],
            [name(), '''grits''', hisher(), '''teeth together.'''],
            ['''1. Spank the brat.'''],
            ['''2. "I'm sorry. I didn't mean to pry."''']]), justification=0)
        universal.set_command_interpreter(necia_concern_interpreter)
        universal.set_commands(['(#) Select a number'])

def necia_concern_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        add_keyword('spanked_necia')
        universal.say(universal.format_text([['''"You know, I've had a really bad day," says''', name() + ", grabbing the Vengador and hauling her to her feet.", '''"I ran out of food last night, so I had to walk the entire morning''',
        '''on an empty stomach.''', 
            '''A friend of mine paddles me for no good reason,''' if 'Maria_spanked_you' in keywords() else ('''I get judged by some obnoxious old bat,''' if 'second_hand_tragedy' in keywords() else 
                '''I...ok that part wasn't so bad actually. Anyway,'''), '''I had to pay some stupid fee to join this stupid guild, and then you losers burst in and attack us. Then I have to run around fighting you people,''',
            '''getting spanked like it's my birthday,''' if spanked_episode_1() else '''desperately hoping a bunch of really scary adventurers aren't about to start spanking me like it's my birthday''', 
            '''and finally I had to fight you, little miss Axe-Crazy. So, I'm very annoyed, very tired, kinda sore, and you my dear, are going to get thoroughly paddled for helping to make my day so miserable. Oh, and''',
            '''for attacking a guild full of innocent people and trying to take their stuff."''']]), justification=0)
        necia_chastised_spank_interpreter()
    elif num == 2:
        universal.say(universal.format_text([['''The woman gives''', name(), '''a look of utter disbelief, as if not quite comprehending what''', name(), '''had just said. "You are a very weird person."'''],
            ['''"Excuse me?" says''', name() + ",", '''bristling slightly.'''],
            ['''The woman shakes her head. "Just, the winners of a fight don't usually apologize to the losers."'''],
            [name(), '''grimaces. "Look, I'm just trying to defend my livelihood here. I don't want to hurt anyone unless I have to."'''],
            ['''The woman throws''', name(), '''a sharp glance. "Me too."'''],
            ['''"Tell me about the Vengadores," says''', name(), universal.format_line(['''as''', heshe(), '''goes to check on Cosima.''']) if 'met_Cosima' in keywords() else universal.format_line(['''as''', heshe(), '''sits down''',
                '''next to the defeated woman.''', universal.format_line([HeShe(), '''can't help but wince, as''', hisher(), '''tender bum touches the packed ground. Stupid health. Heal a gaping sword wound in an''',
                    '''instant, but can't seem to handle a few bruises.''']) if spanked_episode_1() else universal.format_line([HeShe(), '''smiled encouragingly.'''])])],
            ['''"Why?" asks the woman uneasily, weakly shifting away from''', name() + "."],
            ['''"Because I want to understand," says''', name() + ".", '''"Nana used to tell me: 'Anytime someone's driven to violence, find out why. For one, they might have a point. For two, you'll''',
                '''know what to expect next time.'"'''],
            ['''The woman's lips twitch. "I see." The woman shrugs uneasily. "We're just a bunch of dirt poor folk who're tired of being abused."'''],
            [name(), '''waits for the Vengador to elaborate, but she doesn't say anything more. "Aren't you worried this'll make the guards crack down harder?"'''],
            ['''The woman shrugs. "They're gonna do it anyway. The most we'll do is make them do it faster. Least this way it'll be more obvious, get more people angry."'''],
            [name(), '''shakes''', hisher(), '''head. "Things aren't really that bad, are they?"'''],
            ['''The woman gives''', name(), '''a level look. "Yes."'''],
            [name(), '''grimaces.''', universal.format_line([HeShe(), '''turns''', hisher(), '''attention more fully to Cosima, and checks her carefully. Her pulse is stronger. She'll probably be waking soon.''']) if
                'met_Cosima' in keywords() else universal.format_line([HeShe(),'''stands  and walks a few steps away.'''])]]), justification=0) 
        necia_spanking_over()

def necia_chastised_spank_interpreter():
    universal.say(universal.format_text([[universal.format_text([[name(), '''sits down on a nearby chest.''',
    '''Unfortunately,''', heshe(), '''sits down a little bit too hard.''',
    '''As soon as''', hisher(), '''very tender bottom touches the hard metal,''',
        heshe() + "'s", '''back on''', hisher(), '''feet, dancing in place and desperately trying to rub away the burn. "Oww, oww oww oww."'''],
        ['''The defeated Taironan smirks.'''],
        [name(), '''scowls, and sits down much more gently. "Smirk while you can brat. You'll have the same problem in a minute."''']]) if one_in_keywords(['Ildri_spanked_you_unjustly', 'spanked_by_Airell', 
            'spanked_by_Cosima', 'Maria_spanked_you', 'spectral_caned', 'met_Mai']) else 
        universal.format_text([[name(), '''sits down on a nearby chest (and nearly slides off of it). A smirk touches the defeated woman's''',
            '''face.'''],
        ['''"Won't be smirking for long," mutters''', name(), '''shifting''', hisher(), '''position.''']])],
        ['''With a sharp tug,''', heshe(), '''yanks the woman across''', hisher(), '''lap.''', HeShe(), 
        '''shifts the helpless woman's position a few inches, fully centering the woman's bottom over''', hisher(), '''right thigh.''', HeShe(), '''lands three sharp slaps to the woman's clothed bottom.'''],
        ['''"You know, this whole thing is really pissing me off," says''', name() + ".", HeShe(), '''spanks the woman's round bottom with slow, but hard smacks that make even this woman's''',
            '''muscled bottom bounce. "What gives you the right to attack us? What gives you the right to take our equipment? Seriously, what do you think'd happen if the guild had to close because of your''',
            '''naked banditry? My livelihood depends on this place!"'''],
        [name(), '''lands another three hard blows, each to the same spot on the woman's right cheek. She squirms slightly, but other than that doesn't react.'''],
        ['''"Well?" says''', name() + ",", '''landing a hard smack to the woman's left cheek. "Sure, your life probably sucks. I get that. But explain to me how your sucky life gives you the right to ruin mine.''',
            '''Not to mention all the men and women, barely more than boys and girls, that you've hoodwinked into being slinger fodder!"'''],
        ['''The woman says nothing, and''', names(), '''lips thin further. Clearly, things are going to need to be taken up a notch.''']]), justification=0)
    necia_chastised_next_step_interpreter()

def necia_chastised_next_step_interpreter():
    """
    Originally, I was going to allow the player to choose whether to bare the bottom first, or use the implements first, but seeing as how the two would lead to the same thing, it feels repetitive. Plus,
    I still have plenty of other things to write for this encounter.
    """
    universal.say(universal.format_text([['''\n\n''' + name(), '''removes the thin, frayed rope the woman uses to hold her trousers up, and pulls the ragged trousers down to her knees, revealing a round, muscled bottom.''', name(), 
        '''can see slightly darker skin on the woman's bottom with hints of''', names(), '''handprints. The Vengador's bottom briefly clenches, but other than that there is no reaction.'''],
        [name(), '''cracks''', hisher(), '''cupped hand across the woman's right cheek, starting at the bottom and pushing up over the woman's warm, rounded flesh.'''],
        ['''"Explain it to me."''', names(), '''hand cracks across the woman's left cheek. Then right, then left. Then three more to the left. Right, left, right, followed by four more to the right.''',
            '''"Explain it."'''], 
        ['''With each blow, the pace increases.''', '''However, while the pace increases steadily,''', name(), '''varies the strength of''', hisher(), '''blows. Some are light, others hard. One or two are''',
        '''actually hard enough to draw a grunt of pain from the woman.''',
        '''The Vengador's bottom bounces and rolls beneath''', names(), '''barrage, the Vengador starts to squirm around on''', names(), '''lap, and her breathing becomes strained, but still she says nothing.'''],
        [name(), '''stops for a moment, and massages''', hisher(), '''aching palm, then''', hisher(), '''wrist, then''', hisher(), '''shoulder. Madre's love, this woman's bottom is hard,''',
            '''and despite the redness peeking through her skin, she shows no sign of breaking.'''],
        ['\p'],
        ['''1. Stop.'''],
        ['''2. Use the wooden spoon.''']]), justification=0)
    if itemspotionwars.leatherBelt in inventory():
        universal.say('''\n\n3. Use the belt.''', justification=0)
    universal.set_command_interpreter(necia_chastised_bare_implement_interpreter)
    universal.set_commands(['(#) Select a number.'])


def necia_chastised_bare_implement_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([['''"Alright, get up," says''', name(), '''with a sigh.''', HeShe(), '''was probably being too soft, but''', heshe(), '''just couldn't bring''', himselfherself(), '''to be any more severe.''',
            HeShe(), '''had been on the wrong end of a callused palm far too many times for that.''']]), justification=0)
        necia_spanking_over()
    elif num == 2:
        universal.say(universal.format_text([['''"Stupid, stubborn woman."''', name(), '''grabs''', hisher(), '''pack and pulls out''', hisher(), '''large wooden spoon.''', '''"You are going to answer me. Even if I have to spank you''',
        '''from now 'til New Years."'''],
        ['''The Vengador takes a deep breath, but says nothing.'''],
        [name(), '''snaps the spoon against the woman's bare right cheek. The woman gasps. Emboldened,''', name(), '''smacks the most fleshy part of the''',
        '''woman's left cheek. Then''', heshe(), '''lands a series of sharp blows to both of the woman's sitspots. This time, a strangled cry rises and dies in the woman's throat, and her legs twitch.'''],
        ['''"Well?" asks''', name() + ",", '''tapping the spoon lightly against the Vengador's very tender bottom. "Ready to explain it to me?"'''],
        ['''Nothing.'''],
      ['''"Fine."''', name(), '''begins a particularly vigorous spate of smacks. The woman shakes her head, and pounds her fists against the ground. The occasional cry slips past her lips. Her legs twist, and her''',
            '''hips rock a little.'''],
    ['''"Madre's love," cries the woman after a particularly hard slap. She twists around and glares at''', name() + ".", '''"You want me to explain it? Fine. I don't care about you. I don't care about your stupid''',
       '''guild, or your stupid livelihood or anything else. I care about me. I care about my friends. I care about people who get dragged off the streets, and have their minds picked apart by puppeteers. I care''',
           '''about Taironans arrested without question because a Carnutian accuses them of something. I care about people who work sixteen hour days at harvest for the barest pittance of food, who have to choose''',
            '''between feeding their children and feeding their parents through the winter. The rest of you can go get buried!"'''],
        [name(), '''shoves the woman off of''', hisher(), '''lap, a bit more harshly than was perhaps necessary. The woman pulls her trousers back up, hissing in pain, though her hot glare never leaves''', name() + 
        "."],
        [name(), '''stands''', '''(and gives''', hisher(), '''tender bottom a quick rub to ease the lingering sting of sitting).''' if spanked_episode_1() else '.']]), justification=0)
        necia_spanking_over()
    elif num == 3 and itemspotionwars.leatherBelt in inventory():
        add_keyword('strapped_Necia')
        universal.say(universal.format_text([[universal.format_line([name(), '''pulls''', hisher(), '''new belt free of''', hisher(), '''trousers, the cracked leather making a deadly hiss as it slithers free.''']) if 
            lower_clothing().armorType == items.Pants.armorType else universal.format_line([name(), '''pulls the leather belt out of''', hisher(), '''pack.''']), name(), '''doubles the belt over, and snaps the leather''',
            '''together. The sharp snap of leather against leather echoes throughout the large chamber.'''],
            ['''The woman looks over her shoulder, and eyes the leather.'''],
            ['''"Worried?" asks''', name(), '''with just a hint of mockery.'''],
            ['''The Vengador's head snaps back around, and she stares resolutely at the floor.'''],
            ['''"Good."''', name(), '''shifts the Vengador further to the left, and loops''', hisher(), '''right leg over the woman's thighs''', universal.format_line(['''(which was a bit more difficult than it should''',
            '''have been, because of''', hisher(), '''stupid''', lower_clothing().armorType + ")."]) if wearing_skirt_or_dress() else '''.'''],
            [name(), '''snaps the belt across the woman's bottom. The woman's entire body jerks, and a small "eep" slips from her lips. The two sway precariously on the trunk for a moment, ''' +
               (universal.format_line([names(), '''welted bottom flaring as''', hisher(), '''weight shifts.''']) if spanked_episode_1() else '''.'''), '''Perhaps sitting on the chest wasn't such a wise decision after all.'''],
            ['''Regardless,''', name(), '''continues gamely on, giving the other Taironan a good, solid strapping.  The Vengador takes the first few smacks stoically, but then a particularly sharp blow across her''',
                '''sitspots makes her howl, and suddenly she begins bucking, flailing, kicking, and yowling.'''],
            ['''In fact, as the spanking continues, her flailing becomes so bad, that''', name(), '''loses''', hisher(), '''balance, and the two slides down the front of the chest, and slam into the ground.''']]), justification=0)
        if spanked_episode_1():
            universal.say(universal.format_text([[''' In other words,''', names(), '''very tender bottom slides across hard wood and metal, and then crashes into the hard stone floor.''', HeShe(), '''yelps, and twists off of''', hisher(),
                '''derrier, throwing the Vengador off''', hisher(), '''lap in the process.''', HeShe(), '''rubs frantically at''', hisher(), '''bottom, hissing and moaning.''']]), justification=0)
        universal.say(universal.format_text([['''The woman starts to smirk, but the smile quickly vanishes as she tugs her trousers back up over her welted bottom.'''],
            ['''"Yeah, I told you you wouldn't be smirking long," mutters''', name() + ",", '''clambering back to''', hisher(), '''feet.''']]), justification=0)
        necia_spanking_over()
                
def necia_spanking_over():
    universal.say('''\n\n"So what happens now?" asks the Vengador.''', justification=0)
    if 'chastised_warslinger' in keywords():
        universal.say('''"You going to turn me over the guards? Let them dig into my heart, mind, and soul?"''', justification=0)
        if 'charmed_by_Deidre' in keywords():
            universal.say(universal.format_text([['''\n\n"Of course not," snaps''', name() + ".", HeShe(), '''begins to pace anxiously back and forth, mentally tumbling through that...woman's empty abyss.'''],
            ['''"Oh really?" says the Vengador. "And how are you going to stop them?"'''],
            [name(), '''glances at the Vengador, then looks away without saying anything.''']]), justification=0) 
        else:
            universal.say(universal.format_text([['''\n\n"Can you give me a reason not to?" asks''', name() + "."],
                ['''"You mean besides how screwed up it is that they can poke around in our souls at will?" asks the Vengador.'''],
                ['''"You'd do the same thing in an instant, if you could," says''', name() + "."],
                ['''"Of course not," cries the woman angrily. "Look, stealing from your guild isn't exactly ideal, but at least we're not poking around in your deepest, most secret thoughts, hopes and fears.''',
                    '''We'd never, ever do such a disgusting thing."'''],
                [name(), '''only shakes''', hisher(), '''head. "And here I thought I was naive."''']]), justification=0)
    elif 'wimpy' in keywords():
        universal.say(universal.format_text([['\n\n'+ name(), '''shrugs. "I don't know. Guess we wait for someone to show up, either your people, or the guards."'''],
            ['''The Vengador shifts, and begins fiddling with her fingernails, clearly worried that it would be the guards.'''],
            [name(), '''ignores her. Or at least tries to.''']]), justification=0)
    elif 'mercenary' in keywords():
        universal.say(universal.format_text([['\n\n' + '''"Now, I try to figure out how to keep you from being taken by the guards," says''', name() + "."],
            ['''The Vengador frowns. "You're not going to just let the guards have me?"'''],
            ['''"Of course not," says''', name() + ".", '''"Didn't I say I wanted to join you? Can't very well just let you be captured."'''],
            ['''"It'd be a lot less risk to you," says the Vengador.'''],
            ['''"Yeah, well if I didn't want risk, I wouldn't be an adventurer," says''', name() + "."],
            ['''The Vengador smiles. "I'm Necia."'''],
            ['''"Good to know," says''', name() + ".", '''"I'm''', name() + '."', name(), '''grabs a nearby chest, and opens it. "Now crawl in, quickly."''']]), justification=0)
    universal.say(universal.format_text([['''\n\nSuddenly, the door bursts open, and the Taironan warslinger charges into the room.'''],
        ['''"Oh thank La Madre, Adan!" cries the Vengador woman.\n\n''']]), justification=0)
    if 'chastised_warslinger' in keywords():
        add_keyword('gone_dark')
        universal.say(universal.format_text([[name(), '''spins to confront the warslinger, but three rippling blue spears fly from the spellslinger's hands, and slam into''', names(), '''body,''', '''the force of the blow''',
            '''throwing''', himher(), '''to the ground. The spears pulse, and white-hot agony slams into''', hisher(), '''body.''', HeShe(), '''screams, before another wave of agony slams into''', himher() + ",", 
            '''and everything goes dark.''']]), justification=0)
    elif 'wimpy' in keywords():
        universal.say(universal.format_text([['''The warslinger glances at the Vengador woman, who is clearly suffering from combat fatigue. He sighs, and massages his forehead. "Let me guess, you ignored my warning, and attacked''',
            '''this''', manwoman(), '''as soon as I left."'''],
            ['''The Vengador smiles innocently.'''],
            ['''"When we get back, you are getting spanked so hard," says the warslinger. He strides over to the woman, picks her up and throws her over his shoulder, ignoring her protests. "But for now, we've''',
                '''got to get out of here." He glances at''', name() + ".", '''"Sorry about the brat here." He slaps the girl's rump, eliciting a yelp. "Have fun being questioned by the''',
                '''guards."'''],
            ['''With that, the warslinger runs out.''']]), justification=0)
    elif 'mercenary' in keywords():
        universal.say(universal.format_text([['''"Don't use my name," says the Warslinger curtly. He strides over to the woman, yanks her to her feet, and lands a sharp slap to her bottom. "And are you suffering from combat''',
        '''fatigue?"'''],
        ['''"Maybe," mutters the Vengador petulantly.'''],
        ['''The warslinger lands two more sharp slaps to the girl's bottom. "And didn't I tell you to be nice to''', himher(), '?"'],
        '''"Maybe," mutters the Vengador again.''',
        ['''The warslinger sighs in disgust. He lifts the woman up and throws her over his shoulder. "We'll discuss this at much greater length later. For now, we've got to get out of here." He glances at''', 
            name() + ".", '''"Have a nice day."'''],
        ['''"Hey wait a minute-" begins''', name() + "."],
        ['''But the warslinger is already gone.''']]), justification=0)
    p.PC.currentEpisode.next_scene()
        
floor0 = (
           #0    1     2     3      4     5    6     7     8     9   
        ( '__','___','___','___', '__', '__','___','___','___','___', '_'), 
        ('|  ','   ','   ','   ','|u ','|  ','   ','   ','   ','   ','|'),  #9
        ('|  ',' * ','   ',' * ',';* ','|  ','   ','   ','   ','   ','|'),  #8
        ('|  ','   ','   ','   ','|  ',';*_','___','*__','___','___','|'),  #7 
        ('|  ','   ','   ','   ','|  ','|__','|  ','___','|__','|  ','|'),  #6
        ('|  ','   ','   ','   ','|  ','|* ','   ','|__','|*_',' * ','|'),  #5
        ('|__','___','___','___','|  ','|  ','___','   ','|  ','|  ','|'),  #4
        ('|  ','   ','   ','   ','|  ',';* ','|  ','|  ','|  ','|  ','|'),  #3
        ('|  ','   ','   ','   ','|  ','|__','|__','|  ','|__','|* ','|'),  #2 
        ('|  ','   ','   ',' * ',';  ','|  ','|*_','___','   ','___','|'),  #1
        ('|__','-%-','___','-%-','|__','|__','___','___','|__','|_|','|')   #0 
    )
floor0Events = (
          #0     1     2     3      4     5    6     7     8     9   
        (None, None, None, None, None, None, None, None, None, None),  #9
        (None,e0_6_1,None,e0_6_3,e0_8_4,None,None, None, None, None),  #8
        (None, None, None, None, None,e0_8_5,None,e0_8_7,None, None),  #7 
        (None, None, None, None, None, None, None, None, None, None),  #6
        (None, None, None, None, None,e0_5_5,None, None,e0_5_8,e0_5_9),  #5
        (None, None, None, None, None, None, None, None, None, None),  #4
        (None, None, None, None, None,e0_3_5,None, None, None, None),  #3
        (None, None, None, None, None, None, None, None, None,e0_2_9),  #2 
        (None, None, None,e0_1_3,None, None,e0_1_6,None, None, None),  #1
        (None, None, None, None, None, None, None, None, None, None)   #0
    )

floorEvents = [floor0Events, floor1Events]
backOfGuild = dungeonmode.Dungeon('Guild', [floor0, floor1], floorEvents, bgMusic= INTENSE, 
        enemies=[pwenemies.VengadorScout, pwenemies.VengadorWarrior, pwenemies.VengadorSpellslinger]) 

dungeonmode.set_dungeon(backOfGuild)
episode1Scene1 = episode.Scene('Episode 1 Scene 1', start_scene_1_episode_1, None)
episode1Scene2 = episode.Scene('Episode 1 Scene 2', start_scene_2_episode_1, None)

def end_scene_2_episode_1():
    add_keyword('first_dungeon_done')
    backOfGuild.remove_character(p.PC)


def start_scene_3_episode_1(loading=False):
    global elise, adrian, maria, peter
    enterLeft(paloma, infirmary)
    adrian.litany = adrian_end_episode_1
    adrian.defaultLitany = adrian_end_episode_1
    adrian.litany = adrian_end_episode_1
    elise.defaultLitany = elise_end_episode_1
    elise.litany = elise_end_episode_1
    #maria.defaultLitany = maria_end_episode_1
    #maria.litany = maria_end_episode_1
    maria.defaultLitany = ep1_maria_home
    maria.litany = ep1_maria_home
    peter.defaultLitany = peter_end_episode_1
    peter.litany = peter_end_episode_1
    exitLeft(carlita, adventurersGuild)
    if not 'Elise_shows_you_around' in keywords():
        exitLeft(elise, shrine)
        enterLeft(maria, mariasHome)
    if not loading:
        scene_3_guild()

def scene_3_guild():
    if 'gone_dark' in keywords():
        remove_keyword('gone_dark')
        universal.say_title('Adventurers Guild')
        universal.say(universal.format_text([['\m ' + names(), '''eyes flutter open.''', HeShe(), '''is lying on a small cot in the infirmary, staring up at the bare wooden''',
        '''ceiling.'''], 
        ['''"Oh, you're awake," says''', '''a nearby Taironan woman in the white and red robe of a White Rose. "My name's Paloma, the resident healer. How you feeling?"'''
            if not 'met_Paloma' in keywords() else universal.format_line(['''Paloma, stepping up next to''', names(), '''cot. "How you feeling?"'''])],
        ['''"Like I just got run over by a herd of wild horses," says''', name() + ".", HeShe(), '''groans, and rubs''', hisher(), '''aching head.'''],
        ['''"That's because that idiot slung Pain Spikes at you," says Paloma angrily. She lightly touches''', names(), '''face, wrists, and neck.''',
        '''"Pain spikes slung at a''', boygirl(), '''of your power! He could have killed you. Wretched, reckless, selfish bastard son of a goat."'''],
        universal.format_text([[name(), '''flushes guiltily, touched by Paloma's concern. "Look, about what happened-"'''],
            ['''"Don't worry about it," says Paloma, waving her hand dismissively. "I wasn't in any serious danger, and you were outnumbered two to''',
            '''one."'''],
            [name(), '''nods. "Thanks. Still feel bad about it."'''],
            ['''"Well, it's past," says Paloma. "And we have plenty of other things to worry about."''']]) if 'failed_to_help_Paloma' in keywords() else
            universal.format_text([[name(), '''nods gingerly. "Can say  that again."''']]),
            [name(), '''slowly sits up, and glances about the infirmary.'''],
            ['''The cots are filled with men and women, mostly Taironans in ragged clothing.''',
                '''There are quite a few adventurers as well. Moving about the cots are grim-faced men and women. Some of them wear leather''',
                '''breastplates, while others are clad in chain shirts. Some carry spears, and others rest their hands lightly on large war daggers''',
                '''at their hips. All of them have a badge in the shape of a stylized blue hawk with wings uplifted on their left shoulders. The city''',
                '''guard.'''],
            [name(), '''hears a cry coming from outside. It sounds familiar.''', name(), '''swings''', hisher(), '''feet around, and stands up.'''],
            ['''"You shouldn't really be-"'''],
            ['''The room spins dizzily for a moment, but a hand to the bed braces''', himher(), '''until the dizziness passes.\n\n "I'm fine."''', name(),
                '''absently waves Paloma away, as''', heshe(), '''exits the infirmary, and enters the main room.''']]), justification=0, music=[LIGHT_HEARTED])
    else:           
        universal.say_title("Adventurer's Guild")
        universal.say(universal.format_text([['''\n\nAfter taking a few minutes to try to recover,''', name(), '''sighs, and shakes''', hisher(), '''head. Least it's over, finally.''', HeShe(), '''rolls''', hisher(), 
            '''shoulder and grimaces. Gods,''', heshe(), '''is sore all over.''', universal.format_line([HeShe(), '''reaches back and gives''', hisher(),
                '''poor, aching bum a rub. Especially''', hisher(), '''bottom.\n\n''']) if spanked_episode_1() or 'spanked_by_Necia' in keywords() else
            '\n\n']]), justification=0)
        if 'met_Cosima' in keywords():
            universal.say(universal.format_text([[name(), '''approaches Cosima, and touches her lightly on the face. The older woman stirs, and her eyes flutter open.''',
                '''She gasps, and jerks up straight, her eyes flicking about the armory.'''],
                ['''"Hey, calm down," says''', name() + ".", '''"They're gone."'''],
                ['''"Did we stop them?" asks Cosima, looking up at''', name() + "."],
                [name(), '''glances about the bare armory. "Define 'stopped.'"'''],
                ['''Cosima grimaces. "Adrian's going to cane the skin off our butts."'''],
                [names(), '''heart misses a beat, and panic surges through''', himher() + ".", '''"Cane? Really? He's really gonna cane us?"'''],
                ['''Cosima smiles weakly. "No, he's not actually going to cane us. Ever been caned before?"'''],
                [name(), '''shakes''', hisher(), '''head. "Nana didn't like the cane. Said it was too impersonal."'''],
                ['''"Lucky," says Cosima. "It stings like the dickens."'''],
                ['''"And he really won't cane us?" asks''', name() + "."],
                ['''Cosima laughs. "No, he won't cane us. He only canes you when you've really screwed up."\n\n''']]), justification=0)
            if 'Mai_defends_armory' in keywords():
                universal.say(universal.format_text([['''As if summoned, Mai, the elven stealth master, slips up and joins the other two. She smiles sheepishly at Cosima. "Hi."'''],
                    ['''"Speaking of really screwing up," says Cosima sharply. "Where the hell were you?"'''],
                    ['''"Hiding," mutters Mai, scuffing her foot against the stone.'''],
                    ['''"You know hiding's only half of what you were supposed to do, right?" says Cosima. "You were also supposed to ambush the''',
                        '''cursed slinger."'''],
                    ['''"I'm sorry, but he was rather scary," says Mai pitifully. "I mean, he was making you look like an amateur."'''],
                    ['''"Which is why we were supposed to fight him together," snaps Cosima. She winces and clutches at her head. "You wretched,''',
                        '''cowardly, underclad tart. We're going upstairs now. As soon as we do, you will tell Adrian that you hid, and didn't lift a finger to help me. Understand?"\n\n''']]), justification=0)
                if 'necia_ambush' in keywords():
                    universal.say(universal.format_text([['''"But, but I helped''', name() + ',"', '''says the elf, a touch frantically.'''],
                        ['''"Only after that Vengador kicked my ass," says''', name(), '''angrily.'''],
                        ['''"I still helped you," says Mai. "If it weren't for me, your bum would be on fire, right now."'''],
                        ['''"My bum is on fire!" cries''', name() + ",", '''throwing''', hisher(), '''hands in the air. "Because of you!"'''],
                        ['''"Enough," says Cosima sharply. "Perhaps Adrian will moderate your''',
                            '''punishment, but you still have to tell him what happened. You better believe I will, and you know how he feels about lies of omission."\n\n''']]), justification=0)
                universal.say(universal.format_text([['''"Yes ma'am," says Mai quietly, picking at her fingernails.'''],
                    ['''"Good." ''']]),justification=0)
            universal.say(universal.format_text([['''Cosima pulls herself to her feet. She sways for a moment, and steadies herself with a hand against the wall.''', 
            '''"Let's go."\n\n''']]), justification=0)
        if 'mercenary' in keywords():
            add_keyword('owe_Mai_favor')
            universal.say(universal.format_text([['''As Cosima leaves the armory, Mai leans in close to''', names(), '''ear. "I heard the little chat you had with''',
                '''that warslinger."'''],
                [names(), '''heart skips a beat, and''', heshe(), '''glances over at Mai with wide eyes.'''],
                ['''"Relax," says Mai. "I don't care about human politics. But you owe me a favor."\n\n''']]), justification=0)
        universal.say(universal.format_text([['\m' + name(), '''returns to the first floor of the Guild, and finds the place to be in chaos. The floor, walls, and ceiling are''',
            '''charred, frozen, and marked by various other signs of magic. Men and women in finely made armor rush about, some gathering''',
            '''samples of the magic damage, others interrogating adventurers and Vengadores. Some wear''',
            '''leather breastplates, while others chain shirts. Some carry spears, and others lightly rest palms on the hilts of long war daggers.''',
            '''All of them wear a patch on their upper-left shoulder in the shape of a stylized blue hawk with wings lifted towards the sky. City''',
            '''guards.'''],
            ['''Two of the guards spot''', name() + ".", '''They let out cries of warning and lower their spears.'''],
            ['''"Don't move," barks one of the guards, while half a dozen others rush up. "You're under arrest."'''],
            [name(), '''tenses, though''', heshe(), '''can't even begin to imagine what-'''],
            ['''"Hey, what's going on?" snaps Adrian, pushing through the guards. He glares at the guards.''', '"Relax.''', HeShe() + "'s", '''one''',
                '''of us."'''],
            ['''"Are you sure?" asks one of the guards, still warily watching the Taironan.'''],
            ['''Adrian rolls his eyes. "No, sometimes my evil double fires adventurers when I'm not looking. Of course I'm sure! Now, leave''',
            himher(), '''alone."'''],
            ['''"We'll still have to question''', himher() + ',"', '''says the guard.'''],
            ['''"Of course, but you will question''', himher(), '''as an adventurer, not as a Taironan, understand?" says Adrian, a dangerous glint''',
                '''in his eyes.'''],
            ['''The guard scowls. "Of course. What do you take me for?"'''],
            ['''"Indeed," says Adrian. He throws''', name(), '''a reassuring smile, before turning and disappearing back into the milieu.'''],
            ['''A sharp cry comes from the main entranceway. It sounds familiar.''', name(), '''starts to push past the guards, and enters the main''',
                '''room.\n\n''']]), justification=0, music=[GUARDS])
    universal.say(universal.format_text([['''\mThe main room is a complete mess. There is not a single table, chair, or die that hasn't been shattered. The counter has''',
        '''been cut in half, and the two gaping holes in the wall between the kitchen and the main entranceway have merged into one giant hole. The''',
        '''dirt floor is littered with holes, bloodstains, and shattered weapons. The front door has been blown completely off. The room is crawling''',
        '''with city guards.'''], 
        ['''A bearded man stands in the center of the room. He is of average height, and build. He has short-cut brown hair and a''',
        '''thick brown beard. He stands straight and tall, one hand resting on the pommel of his sword (the cross-guard of which is reminiscent of a''',
        '''soaring eagle), and the other behind his back. He is wearing an elaborate set of plate armor. On the chest of his armor is a''',
        '''large, stylized blue hawk with wings outstretched towards the sky. He also wears a full blue cape. His brown eyes sweep over the room, taking''',
        '''in everything. They briefly meet''', names(), '''before sweeping past''', himher(), '''and focusing on the hole in the wall.''',
         '''A tall, blond''',
        '''woman in a slender black''',
        '''dress and black beret approaches and begins speaking with him.\n\n''']]), justification=0, music=[ROLAND])
    if 'charmed_by_Deidre' in keywords():
        universal.say(universal.format_line([name(), '''grows cold. That's the woman from the guardhouse.\n\n''']), justification=0)
    universal.say(universal.format_text([['''\mThen, there is another cry coming from the far end of the room. Two guards are dragging the first Vengador''', name(), '''fought towards the door. She is bucking and crying.'''],
        ['''"No, please I told you everything," cries the young woman. "Please you have to believe me, don't take me there, don't let them in my head.''',
            '''Please!"'''],
        ['''One of the guards growls impatiently and smacks the girl across the face. "Shut up, and quit struggling!"'''],
        ['''The woman cries out. Her eyes meet''', names() + ".", '''"Help me, please!"'''],
        ['\p'],
        ['''1. Help her.'''],
        ['''2. Ignore her.''']]), justification=0, music=[CARLITA])
    universal.set_command_interpreter(help_Carlita_interpreter)
    universal.set_commands(['(#) Select a number.'])

def end_scene_3_episode_1():
    """
    Here is where we have the conversation with Catalin.
    """

episode1Scene3 = episode.Scene('Episode 1 Scene 3', start_scene_3_episode_1, end_scene_3_episode_1)

def help_Carlita_interpreter(keyEvent):
    music.play_music(CARLITA)
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        add_keyword('tried_to_help_Carlita')
        universal.say(universal.format_text([[name(), '''weaves''', hisher(), '''way towards the guards and their captive. "Hey, what are you doing? Leave her alone!''',
            '''Can't you see she's barely more than a child?"'''],
            ['''One of the guards, a woman, scowls at''', name() + ".", '''"Back off, before we take you in as a Vengador sympathizer."'''],
            ['''"This has nothing to do with the Vengadores," says''', name() + ",", '''angrily.''', HeShe(), 
                '''points at the Taironan. "Look at her will you?''',
                '''She's just a frightened, half-starved girl, who-"'''],
            ['''"Oh for the Mother's love, shut up you muddy''', bastardbitch() + ',"', '''snarls the guard, giving the Vengador another tug. "We're going to take her wherever we want, ''',
            '''do to her whatever we want, and there's nothing you can do about it. Now, you can shut up and back off, or you can join her. Your''',
            '''choice."'''],
            ['''"What did you call me?" says''', name(), '''in dangerous voice.''', HisHer(), '''hand tightens around''', hisher(), '''weapon.'''],
            ['''"Charlie, we've got trouble!" calls the guard.'''],
            ['''Three more guards rush up, and grab''', name(), '''before''', heshe(), '''can make a move. Meanwhile, the original two guards resume''',
                '''dragging the young Taironan towards the door, who has begun struggling and wailing again.'''],
            ['\p'],
            ['''1. Struggle.'''],
            ['''2. Give up.''']]), justification=0)
        universal.set_command_interpreter(help_Carlita_interpreter_continued)
        universal.set_commands(['(#) Select a number.'])
    elif num == 2:
        add_keyword('failed_to_help_Carlita')
        universal.say(universal.format_text([[name(), '''turns away from the struggling Taironan. When the Taironan sees''', name(), '''turn away,''',
            '''something inside her breaks. She sags in the grips of the guards, and lets them carry her out, while she cries quietly.''']]), 
            justification=0)
        questioning()

def help_Carlita_interpreter_continued(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([['''"No, let go of me," cries''', name(), '''struggling viciously against the iron grips of the three guards. "You can't take''',
            '''her, she's just as much a victim as the Guild. Let her go, curse you!"'''],
            [name(), '''manages to kick one of the guards in the shin, but a second guard retaliates with a vicious punch to the gut.'''],
            ['''"What is going on here?" roars a voice from behind''', name() + ".", '''"Deidre get that''', manwoman(), '''settled down."'''],
            ['''A tall, blond woman in a slim black dress and wearing a black beret steps in front of''', name() + "."]]), justification=0)
        if 'charmed_by_Deidre' in keywords():
            universal.say(universal.format_text([[' ' + names(), '''blood runs cold.'''],
                ['''"Hello again. This'll be easy." The puppeteer smirks. She opens her mouth, and begins to''',
                '''speak.''']]), justification=0)
            episode_1_guild_end()
        else:
            universal.say(universal.format_text([[''' The blond woman grabs''', names(), '''chin in her hand. Her eyes flash. "Calm down."'''],
                ['''An overwhelming feeling of calm spreads through''', names(), '''heart and soul.''', HeShe(), '''stops struggling. The blond woman,''',
                    '''Deidre apparently, then grabs the other Taironan's chin in her hand. The other Taironan lets out a long, low wail, and''',
                    '''closes her eyes. It doesn't matter. Deidre still tells her to calm down, and the girl still''',
                    '''stops struggling. The two guards nod in (uneasy) thanks, and carry the woman's limp form out of the guild.'''],
                [name(), '''watches impassively, a small voice screaming that this isn't right, but the rest of''', himher(), '''feeling nothing but a deep serenity. As the cries fade away,''', name(),
                    '''shakes''', hisher(), '''head.''']]), justification=0)
            questioning()
    elif num == 2:
        universal.say(universal.format_text([[name(), '''sags helplessly in the grip of the guards.''', HisHer(), '''eyes meet those of the other Taironan's. Then,''', heshe(), '''looks away.'''],
            ['''The girl, seeing no more help coming, sags as well, and lets the guards drag her out.'''],
            ['''The guards release''', name() + ".", HeShe(), '''stares out the door,''', universal.format_line([hisher(), '''mind flicking to the abyss''',
                '''that awaits the young girl.''']) if 'charmed_by_Deidre' in keywords() else universal.format_line([hisher(), '''thoughts wandering through the dark cells, heartless guards, and invasive magics''',
                    '''that await the girl.'''])]]), justification=0)
        questioning()
        
def questioning():
    universal.say(universal.format_text([['\m ' + HeShe(), '''walks over to a remnant of the counter, and leans on it.'''],
        ['''After a few minutes, the tall blonde woman approaches. "Hello, my name is Deidre."\n\n''']]), justification=0, music=[GUARDS])
    if 'charmed_by_Deidre' in keywords():
        universal.say(universal.format_text([['''"Yes, we've met," says''', name(), '''flatly.'''],
            ['''"Indeed, which is why Sir Roland sent me to talk to you," says Deidre, gesturing towards the man with the blue bird emblazoned on his''',
                '''chest. "So, let's get started."'''],
            ['''The puppeteer's eyes seem to flash.'''],
            ['''"No, wait-"''']]), justification=0)
    else:
        universal.say(universal.format_text([['''"Hi," says''', name() + "."],
            ['''"I'm going to be asking you some questions,''', MisterMiss(), '''...''', name() + ',"', '''says the woman, glancing at a piece of''',
                '''parchment in her hand.''', universal.format_line(['''She gives''', name(), '''a tight smile. "Please try not to lie this time."''']) 
                    if 'lied_about_name' in keywords() or 'lied_about_Bonda' in keywords() else '''"Please answer with total honesty."'''],
            ['''What follows is an eternity of intense questioning. The woman pries into every little detail of every little comment made''',
                '''by''', name() + ".", '''She asks each question a dozen different ways. She tears apart''', names(), '''story and pieces it back''',
                '''together, one probing question at a time.'''],
            ['''Eventually, Deidre sighs and massages her forehead. "OK, I think we're done here. Have a nice day."'''],
            ['''She stands, and walks off to speak with the caped man. The two speak for several minutes, and then the caped man turns to address the room.'''],
            ['''"Alright, I think we've learned all we can, here," says the man. "Let's get back to the guardhouse, and see what we have."'''],
            ['''With calm, quick efficiency, the guards gather up their work, and file out of the Guild.''']]), justification=0)
    episode_1_guild_end()
                
def episode_1_guild_end():
    universal.say(universal.format_text([['\m ' + name(), '''is leaning against the counter, looking blankly at the ruined, empty entranceway.''', HisHer(), '''stomach rumbles, and''', heshe(), '''decides to make''', hisher(),
        '''way into the kitchen, to see if''', heshe(), '''can find something to eat.'''],
        ['''With a little bit of help from Ildri, the cook,''', name(), '''manages to scrounge up some bread, a small dried apple from the winter stores''',
            '''and even a bit of jerky.''', HeShe(), '''begins eating voraciously, though''', heshe(), '''does slow down after a few tuts from Ildri.'''],
        ['''After a few minutes, Ildri leaves the kitchen. She returns a few minutes later, and walks over to the large cabinet she'd spent most of''',
            '''her time leaning against. She opens it. "Alright, Alondra, they're gone."'''],
        [names(), '''eyes widen as''', heshe(), '''watches''', universal.format_line(['''the girl, whom Ildri had been paddling when''', name(), '''had first visited the''',
            '''kitchen,''']) if 'Ildri_event' in keywords() else universal.format_line(['''a Taironan woman about''', hisher(), '''age''']), '''clamber out of''',
            '''the cabinet.'''],
        ['''The Taironan woman, Alondra, looks around hesitantly. "Are, are they finally gone?"'''],
        ['''"Yes." Ildri gives the girl's shoulder a comforting pat. "They're gone. You're safe."'''],
        ['''Alondra sags with relief, leans against the counter, and runs a shaking hand through her tangled hair.'''],
        ['''Ildri leans against the counter next to her, and gives her a comforting hug. "Now, why don't you go sit down, and I'll get something to''',
        '''eat."'''],
        ['''Alondra looks around the ruined kitchen. "Where?"'''],
        ['''Ildri chuckles. "Alright, maybe you won't sit, but just wait for me to get you something to eat."'''],
        ['''Alondra smiles, and glances about agian. She notices''', name(), '''and approaches''', himher() + ".", '''She flashes''', name(), '''a hesitant smile.\n\n''']]), justification=0, music=[LIGHT_HEARTED])
    if 'Ildri_spanked_you_unjustly' in keywords() or 'Ildri_no_pants' in keywords():
        universal.say(universal.format_text([[name(), '''returns the smile warmly. Nothing like getting spanked with someone for instant bond building. "Hey. Alondra, right? I'm''',
            name() + ".", '''Nice to see you weren't dragged off by the guards."'''],
            ['''"Yeah. Got real lucky, with Ildri." She gives her bottom a rueful rub. "Though I don't think I realized it at first."'''],
            [name(), '''nods, and the two stand in silence for a moment.\n\n''']]), justification=0)
    else:
        universal.say(universal.format_text([[name(), '''returns the smile, but it's a touch wary. "You're one of the Vengadores who attacked us, right?"'''],
            ['''The woman winces, and her smile fades. "Erm, yeah, but I didn't join because I wanted to hurt anyone."\n\n''']]), justification=0)
    universal.say(universal.format_text([['''"So, why did you join the Vengadores?" asks''', name() + "."],
        ['''Alondra shrugs. "They promised food for my younger siblings. You know how hard it is to feed four kids when their dad's a drunkard, and''',
            '''their mother's dead?"'''],
        ['''"Oh. Uh, no, not really," says''', name(), '''uneasily.'''],
        ['''"Well, it's hard," says Alondra, picking at the stone counter. "And nobody's making it any easier. Thought maybe the Vengadores would be''',
            '''different, but apparently not. I mean, maybe they are, but I don't know, it sure doesn't seem like it."'''],
        ['''Ildri arrives and sets some food in front of Alondra. Alondra smiles gratefully, and begins to dig in. Ildri returns the smile, and then''',
            '''walks off to begin cleaning up, and finding food for any other adventurers that need some.'''],
        ['''"When I told Ildri about my situation, she offered me a job helping in the kitchen," says Alondra. She shuffles her feet, and winces slightly. "I have''',
            '''a feeling sitting is going to become a luxury, but being a well-spanked kitchen girl beats being a Potion mule, beggar, thief, or''',
            '''prostitute any day of the week. Plus, she'll try to convince Adrian to let me bring the munchkins to live here."'''],
        ['''"In the Guild?" says''', name(), '''incredulously.'''],
        ['''Alondra shrugs. "It'll probably be a cursed sight safer than the slums."'''],
        ['''"Hey, you two," says Ildri sharply, shaking her spatula at the two Taironans. "Stop yapping and help us clean, before I tan both your''',
        '''bottoms."'''],
        ['''Both young people jump guiltily and rush to join the cook.''', name(), '''has only taken a few steps, however, before a heavy hand comes''',
            '''down on''', hisher(), '''shoulder.'''],
        ['''"Hang on, Ildri," says Adrian. "I want to have a little talk with''', name() + ",", '''about''', hisher(), '''conduct during the fight."'''],
        ['''Ildri nods. "Then send''', himher(), '''back here. I need all the hands I can get."'''],
        ['''"Of course," says Adrian, steering''', name(), '''through the hole in the wall, and back out into the main room.'''],
        ['''"And stop using that hole like it's a cursed door," snaps Ildri at their backs.'''],
        ['''Adrian leads''', himher(), '''towards the shattered counter. He scrounges up a bit of parchment that wasn't too badly ruined, and searches''',
            '''in vain for a quill, before finally just setting the parchment on the counter, untouched. "So, this was your first 'job' so to speak. I''',
            '''make a habit of talking to my new recruits after their first job. Helps make sure we're all on the same page. So, tell me how it went."'''],
        ['\p'],
        ['''1. Be honest, but leave out the less flattering parts.'''],
        ['''2. Be honest.''']]), justification=0)
    universal.set_command_interpreter(adrian_recap_interpreter)
    universal.set_commands(['(#) Select a number.'])

def adrian_recap_interpreter(keyEvent):
    def num_omissions():
        return len([x for x in keywords() if x in ['failed_to_help_Paloma', 'talk_with_Airell', 'talk_with_Morey', 'talk_with_Cosima', 'talk_with_Mai']])
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        majorOmission = False
        universal.say(universal.format_text([[name(), '''proceeds to tell Adrian an edited version of what happened, glossing over or downright ignoring any events that''',
            '''didn't work out quite so well.'''],
            ['''Adrian nods thoughtfully throughout''', names(), '''story. "Not half-bad for your first time. However,''']]), 
            justification=0)
        summaryOfFailure = []
        if 'failed_to_help_Paloma' in keywords():
            majorOmission = True
            summaryOfFailure.append('your refusal to aid Paloma')
        if 'talk_with_Mai' in keywords():
            summaryOfFailure.append('''your dishonest attempt to both spank Mai and take her peace offering''')
            majorOmission = True
        if 'talk_with_Cosima' in keywords():
            majorOmission = True
            summaryOfFailure.append('''your refusal to do what Cosima told you to do''')
        if 'talk_with_Morey' in keywords():
            majorOmission = True
            summaryOfFailure.append('''your refusal to do what Morey told you to do''')
        if 'talk_with_Airell' in keywords():
            majorOmission = True
            summaryOfFailure.append('''the fact that you punched Airell in the nose''')
        if len(summaryOfFailure) > 1:
            summaryOfFailure[-1] = 'and ' + summaryOfFailure[-1]
        universal.say(' you failed to mention ' + ', '.join(summaryOfFailure) + '.', justification=0)
        if 'failed_to_help_Paloma' in keywords() and 'talk_with_Mai' in keywords() and 'talk_with_Cosima' in keywords() and 'talk_with_Morey' in keywords() and 'talk_with_Airell' in keywords():
            universal.say(universal.format_text([[''' Mother's love, it's almost like you want your bottom lashed to ribbons. It'll take a month to work through the backlog''',
                '''of punishments you've earned yourself."'''],
                ['''"A month?" says''', name(), '''with a small squeak. "Really?"'''],
                ['''"Well, I need to give you time to heal between sessions," says Adrian curtly. "For now, we can get your caning out of the way."'''],
                ['''"My what?" says''', name(), '''in a very small voice.''']]), justification=0)
        else:
            universal.say(universal.format_line(['''"\n\n"Heh, heh," says''', name(), '''weakly. "Didn't know you knew about that."''']), justification=0)
        if majorOmission:
            universal.say(universal.format_text([['''\n\n"Your conduct is unbecoming a guild member." Adrian crouches behind the counter, and comes up with a long''',
                '''thin cane. He flexes it experimentally. Naturally, the cane is the only cursed thing in the entire Guild that wasn't damaged in the''',
                '''fight. "You will visit each wronged instructor at some point over the next month, and submit to their punishment. Today, we'll start''',
                '''with me."'''],
                ['''"But, what did I do to you?" asks''', name() + ",", hisher(), '''eyes never leaving the flexing cane.'''],
                ['''"You lied to me," says Adrian, his voice intense. "I don't mind if things go wrong on a job. They will go wrong, that's how life''',
                    '''works, but you have to tell me everything. Otherwise, I can't gauge the danger of the job, and I can't gauge your skill. You''',
                    '''lie to make yourself look good, and I'll send you into jobs that you can't handle, and you'll end up getting seriously hurt''',
                    '''or killed. And I will not have that!"'''],
                [name(), '''shrinks away as Adrian's sharp voice cracks against''', hisher(), '''ears like a whip.'''],
                ['''"Now, I want you to bare your bottom, and bend over the counter." Adrian's lips twist wryly. "Well, what's left of it, anyway."'''],
                ['''"Completely bare, sir?" says''', name() + ",", '''hesitantly.'''],
                ['''"Completely," says Adrian in a firm voice.'''],
                [name(), '''chews uneasily on''', hisher(), '''lips as''', heshe(), '''eyes the cane.'''],
                ['''"Young''', manlady() + ",", '''you will get extra if I have to do it for you." Adrian snaps the cane against the counter, making''',
                    name(), '''jump.'''],
                [name(), '''hastily''', items.lowerlift(p.PC.clothing_below_the_waist()) + "s", hisher(), p.PC.clothing_below_the_waist().name + ",", 
                universal.format_line(['''and''' if wearing_skirt_or_pants() else universal.format_line(['''and lowers''', hisher()]), p.PC.underwear().name, '''to''', hisher(), '''knees. Then,''', heshe(), 
                '''bends over the counter and grips the far side.\n\n''']) if wearing_skirt_or_dress_or_pants() and  wearing_underwear() else 
                universal.format_line(['''Then,''', heshe(), '''bends over the counter, and grips the far side.\n\n'''])]]), justification=0)
            if p.PC.numSpankings > 2:
                universal.say(universal.format_text([['''\n\n"My goodness," says Adrian, as he studies''', names(), '''bruised, welted, and angry red bottom. "You've had a''',
                    '''terrible day, haven't you?"'''],
                    [name(), '''nods, trying to fight back tears of despair.'''],
                    ['''"Stand up and cover yourself," says Adrian. He steps around''', name(), '''and returns the cane to its original place beneath''',
                        '''the counter. "I'll punish you after you've had some time to heal."'''],
                    [name(), '''jumps to''', hisher(), '''feet and quickly returns''', hisher(), '''clothing to its proper place. "Thank you, sir."'''],
                    ['''Adrian grunts. "I don't want to hurt you. Just put a sting in your bum, to drive the lesson home. Now, go help Ildri."''']]),
                    justification=0)
            else:
                add_keyword('caned_by_Adrian')
                universal.say(universal.format_text([['''"Right, you'll get one stroke for each omission," says Adrian. He taps the cane lightly against''', names(), 
                '''bum.''', name(), '''hisses, and reflexively clenches.'''],
                ['''Adrian sighs, and lowers the cane. "Now, don't do that, you'll just make it worse."'''],
                [name(), '''nods, and takes a slow, deep breath. As''', heshe(), '''releases,''', heshe(), '''relaxes''', hisher(), '''exposed bottom.'''],
                ['''Then, there is a snap, and a deep stinging line of fire lances across the middle of''', names(), '''bottom.''', name(), 
                '''shrieks, and thrashes''', hisher(), '''bottom back and forth.''', HeShe(), '''pounds''', hisher(), '''feet against the ground, and''',
                '''digs''', hisher(), '''fingernails into the countertop.'''],
                ['''"That was one," says Adrian.'''],
                ['''One? Only one? Padres' mercy, how could''', heshe(), '''ever take more?''']]), justification=0)
                if num_omissions() == 1:
                    universal.say(universal.format_text([['''\n\n"And that's it," says Adrian.'''],
                    ['''Oh. Right.'''],
                    ['''Adrian steps around''', name(), '''and places the cane back in its place beneath''',
                        '''the counter. "Not so bad, right?"'''],
                        [name(), '''grunts, and straightens.''', HeShe(), '''returns''', hisher(), '''clothing to the proper place, while silently''',
                            '''vowing never to give Adrian reason to give''', himher(), '''more strokes with that horrible thing.'''],
                        ['''"Why don't you go help Ildri, now," says Adrian.''']]), justification=0)
                else:
                    universal.say(universal.format_text([[''' Then, the cane whips against''', hisher(), '''bottom a second time, and''', hisher(), '''attention is on nothing but the hellish sting in''', hisher(), '''bottom.''',
                    '''In total,''', name(), '''endures''', str(num_omissions()), '''strokes. Each stroke stings worse''',
                        '''than the last, and by the end''', name(), '''is a sobbing wreck.'''],
                        ['''"There," says Adrian. "All done. You going to be honest with me in the future?"'''],
                        [name(), '''nods, as''', heshe(), '''straightens and fixes''', hisher(), '''clothing, sniffing miserably and wiping the tears from''', hisher(), '''face.'''],
                        ['''"Good. Now, why don't you go and help Ildri," says Adrian. "I've taken up enough of your time already."''']]), 
                        justification=0)
        else:
            universal.say(universal.format_text([['''Adrian nods. "Alright. Sounds like you did pretty well, and your story lines up with what the instructors told me. So''',
                '''why don't you go help Ildri, before she starts waving that spatula of hers around."''']]), justification=0)
        ep_1_leave_guild()
    elif num == 2:
        universal.say(universal.format_text([[name(), '''tells Adrian about''', hisher(), '''escapades during the attack, leaving nothing out'''  +
        (universal.format_line([''' except for''', hisher(), '''attempts to join the Vengadores. No telling what Adrian would do if he found out about that.''']) 
        if 'mercenary' in keywords() else '''.''')],
        ['''Adrian listens very closely, occasionally asking questions about a particular detail, or exploring the wisdom of some of''', names(),
            '''decisions.'''],
        ['''After''', name(), '''finishes, Adrian leans back and considers''', himher(), '''for a moment.''', universal.format_line(['''"Well, some of your''',
            '''actions were questionable at best, unbecoming a guild member at worst," says Adrian. "However, I appreciate your honesty in telling me''',
            '''about them, and I'll let the instructors deal with you as they see fit. You seem talented, though, and I look forward to working with''',
            '''you."''']) if num_omissions() > 0 else universal.format_line(['''Then, he grins. "Sounds like you had quite the adventure. You did good, too, I'm''',
                '''very impressed."'''])],
            ['''"Thank you, sir," says''', name() + "."],
            ['''"Just being honest. Now, why don't you go and help Ildri, before she charges in here with murder in her eyes," says Adrian, smiling.''']]),
        justification=0)
        ep_1_leave_guild()

def ep_1_leave_guild():
    if 'caned_by_Adrian' in keywords():
        universal.say(universal.format_text([[name(), '''walks gingerly into the kitchen, rubbing''', hisher(), '''stinging bottom.'''],
            ['''"Heard the caning." Ildri approaches''', name(), '''and gives''', himher(), '''a soothing kiss on the forehead. "Don't worry too much about it. Adrian just doesn't want you hurt.'''],
            [name(), '''grimaces, and gives''', hisher(), '''bottom another rub.'''],
            ['''Ildri laughs. "Look, he didn't want to cane you, but he's found that being strict from the beginning is better for everyone, especially his adventurers. Now, come on let's get to''',
                '''cleaning. We've got a lot of work to do."''']]), justification=0)
    universal.say(universal.format_text([['\n\n' + name(), '''doesn't leave the guild until the sun is hanging low over the horizon, its red-golden rays filtering between the city buildings.''', HeShe(), 
        '''steps outside into the cool evening air, and tries to figure what''', heshe(), '''should do now.''']]), justification=0)         
    universal.acknowledge(townmode.go, craftmansCorridor)

adrian_end_episode_1 = Node(235)
def adrian_end_episode_1_qf():
    if 'boarding_with_Adrian' in keywords():
        adrian_end_episode_1.quip = universal.format_text([['''Adrian smiles at''', name() + ".", '''"Sorry, but I can't talk now. Got a lot to do before I go to bed."''']])
        adrian_end_episode_1.children = None
    else:
        adrian_end_episode_1.quip = universal.format_text([['''Adrian smiles as''', name(), '''returns. "Hey, what's up?"''']])
adrian_end_episode_1.quip_function = adrian_end_episode_1_qf
adrian_request_bed = Node(236)
adrian_nevermind = Node(237)
adrian_end_episode_1.children = [adrian_request_bed, adrian_nevermind]


adrian_request_bed.comment = '''"You wouldn't happen to have a spare bed, would you?"'''
def adrian_request_bed_qf():
    adrian_request_bed.quip = universal.format_text([['''"We do," says Adrian. "And we'd happy to give it to you. However, there are a few rules. First, cleanliness is very important to Ildri and I. Therefore, at''',
        '''sundown of Chiday each week, Ildri will do a quick inspection of your space, to make sure it is sufficiently clean. The first time it is not, you will receive a warning, and we will help''',
        '''you clean it properly. The second time''',
        '''you will receive a fifty swat hand spanking over your clothing, administered by''', '''Ildri.''' if p.PC.is_female() else '''myself.''', '''After that, all transgressions will be punished with''',
        '''a one hundred swat spanking: fifty with the hand over your clothing, twenty-five with the paddle over your''', p.underwearpanties() + ",", '''and twenty-five with the paddle on the bare. If you''',
        '''are not''',
        '''wearing''', p.underwearpanties(), '''the first twenty-five will be on the bare. If you are gone for six or more days''',
        '''of the week because of a job, you will not be held accountable for that week. You may at any time before sundown on Chiday ask us if your space is sufficiently clean. If we have time, we will''',
        '''inspect it, and inform you without penalty. Note that if we are unable to fulfill your request for an early inspection, we will not be held responsible for your failure to maintain''',
        '''cleanliness. Furthermore, if sometime between the early inspection, and the end-of-week inspection your room falls below acceptable standards of cleanliness, you will be held accountable.'''],
        ['''"You may leave and return at any time, however if you are noisy enough to wake either''',
        '''Ildri or myself between sundown''',
            '''and sunup, or noisy enough for the other residents to complain, you will receive penalties similar to those for keeping your space clean. Furthermore, you will be assigned tasks each week,''',
            '''typically geared towards maintaining the Guild. Failure to complete these tasks will earn you similar penalties as with cleanliness, except your second violation will get you twenty-six''',
            '''strokes of''',
            '''the tawse, and move up to twenty-six strokes of the tawse, and ten with the cane for subsequent violations. Finally, I will take a cut out of each of your payments to finish paying for your''',
            '''lodging, up to ninety coins a month. If you don't work enough to make ninety coins in a month, we will find extra work around the Guild for you to do to make up the difference. Understand?"'''],
        [name(), '''nods, feeling slightly overwhelmed.'''],
        ['''"Don't worry, there's a posting in the room hallway with all of the rules laid out in detail," says Adrian. "Also, we try to be merciful to newcomers, which is why the first violation is''',
            '''a warning, and the second violation is relatively mild. You still interested?"''']])

adrian_nevermind.comment = '''"Nevermind."'''
def adrian_nevermind_qf():
    adrian_nevermind.quip = universal.format_text(['''"Alright, then," says Adrian. "See you around."'''])
    adrian.defaultLitany = adrian_end_episode_1
adrian_nevermind.quip_function = adrian_nevermind_qf

adrian_request_bed.quip_function = adrian_request_bed_qf
adrian_request_bed_yes = Node(238)
adrian_request_bed_no = Node(239)
adrian_request_bed.children = [adrian_request_bed_yes, adrian_request_bed_no]

adrian_request_bed_yes.comment = '''"Yes."'''
def adrian_request_bed_yes_qf():
    add_keyword('boarding_with_Adrian')
    guildBedroom.boarding = True
    remove_keyword('boarding_with_Maria')
    mariasHome.boarding = False
    adrian_request_bed_yes.quip = universal.format_text([['''"Excellent," says Adrian. "Go straight back to the end of the hallway, and then right, into the dining room. On the far end of the dining room is a''',
        '''door. Through that door is a hallway lined with doors. You'll be in the third room on the right. Lucky for you, it's currently empty."'''],
        [name(), '''could almost feel the tension oozing out of''', himher() + ".", '''Few things are more wonderful than knowing you have a place to sleep. If''', heshe(), '''wants to,''', heshe(), 
            '''can go to''', hisher(), '''room, go to sleep, and finally put an end to this endless day. Or,''', heshe(), '''could go explore the town a bit more.''']])
adrian_request_bed_yes.quip_function = adrian_request_bed_yes_qf

adrian_request_bed_no.comment = '''"No, thanks."'''
def adrian_request_bed_no_qf():
    adrian_request_bed_no.quip = universal.format_text([['''"Not a problem," says Adrian. "We'll still be here if you change your mind." The building groans ominously.''',
        '''"Hopefully."''']])
adrian_request_bed_no.quip_function = adrian_request_bed_no_qf


peter_end_episode_1 = Node(240)            

ep1EndPeterRootChildren = [peter_3_1_1, peter_4_1_1]
def peter_end_episode_1_qf():
    peter.defaultLitany = peter_greeting
    if 'insulted_Peters_kid' in keywords():
        peter_end_episode_1.quip = universal.format_text([['''Peter gives''', name(), '''a wary look. "Can I help you? And try to keep it down. My daughter is''',
        '''asleep."''']])
        peter_end_episode_1.children = [ep1_peter_apologize, peter_3_1_1, peter_4_1_1]
        if p.PC.is_female():
            peter_end_episode_1.children.insert(1, ep1_peter_apologize_flirt)
            peter_end_episode_1.children.insert(2, ep1_peter_apologize_flirt_lesbian)
            ep1EndPeterRootChildren.insert(0, ep1_peter_flirt)
    else:
        if 'visited_blacksmith' in keywords():
            peter_end_episode_1.quip = universal.format_text([['''Peter flashes''', name(), '''a relieved smile. "I saw some gang or other attack the Guild. Glad''',
                '''to see you're alright. Oh, and try to be quiet, alright? I just put the munchkin to bed."''']])
            peter_end_episode_1.children = [ep1_peter_nonchalance, ep1_peter_child_alright, peter_3_1_1, peter_4_1_1]
            if p.PC.is_female():
                ep1EndPeterRootChildren.insert(0, ep1_peter_flirt, ep1_peter_flirt_lesbian)
        else:
            peter_greeting.quip_function()
            peter_end_episode_1.children = peter_greeting.children

peter_end_episode_1.quip_function = peter_end_episode_1_qf

ep1_peter_apologize = Node(241)
ep1_peter_apologize.comment = '''"About what I said earlier, I'm sorry."'''
def ep1_peter_apologize_qf():
    add_keyword('teaching_Anne')
    ep1_peter_apologize.quip = universal.format_text([['''Peter leans forward, and puts his elbows on the counter. "You hurt my baby girl badly. It's bad enough''',
        '''she has to endure abuse from Carnutians, the last thing she needs is abuse from Taironans too."'''],
    ['''"Yeah, I know," says''', name(), '''in a small voice, nervously wiping''', hisher(), '''hands on''', hisher(), 
        p.PC.clothing_below_the_waist().armorType + "."],
    ['''Peter watches''', name(), '''fidget for a moment. He laces his fingers together. "So, here is what's going to happen. Tomorrow, you're going to''',
        '''apologize to little Anne, and then you're going to start teaching how to fight and use magic."'''],
    [name(), '''gives Peter a bewildered look.'''],
    ['''"I know," says Peter. He runs a hand through his hair. "A father, asking someone to teach his baby girl how to fight? Look, things are tense''',
        '''right now, and the battle lines are being drawn almost exclusively along the lines of race. Once things explode, Anne's going to be caught''',
        '''in the middle, distrusted by both because of her mixed heritage. Besides, I was a camp follower in the last war." His eyes take on a distant,''',
        '''haunted look. "I've seen what happens to defenseless women on the losing side."'''],
    ['''"That seems like an awful lot for an apology," says''', name() + ".", '''"Think I could get paid?"'''],
    ['''Peter nods. "Yeah, you should be, sorry for not offering it right away. I can't pay much. Does twenty coins a month work?"'''],
    ['''"Fifty."'''],
    ['''"Thirty. Can't go above that."'''],
    ['''"Forty."'''],
    ['''"What part of 'can't go above' don't you understand?"'''],
    ['''"The part where you want your daughter to be safe."'''],
    ['''"Fine. Thirty-five."'''],
    [name(), '''nods. "I can work with that."'''],
    ['''"Great," says Peter. "We'll discuss rules and expectations later, but one thing I want to get out of the way right now: no''',
    '''spankings.''',
    '''She's too young. You lay a hand on her, and I'll give you ten times what you give her, only with my belt."'''],
    [name(), '''scowls. "How old is your kid? Five, six? You really think I'm going to hit a six year old? What kind of person do''',
    '''you take me for?"'''],
    ['''"Sorry, sorry," says Peter, holding up his hands in a conciliatory gesture. "I just wanted to make sure we were on the same page. Besides, I'm a little protective of my daughter."'''],
    ['''"I noticed," says''', name() + ".", '''"But don't worry. If she gives me trouble, I'll come to you."'''],
    ['''Peter nods. "Great. Can you start tomorrow?"'''],
    ['''"I'm not sure," says''', name(), '''with a shrug. "Depends on if Adrian is willing to give up a pair of hands for a few hours."'''],
    ['''"Right, the attack on the Guild," says Peter. "I shuttered the shop, and threw Anne in the backroom as soon as those thugs showed up. Glad to see''',
    '''you're not hurt."''']])
ep1_peter_apologize.quip_function = ep1_peter_apologize_qf
ep1_peter_nonchalance = Node(242)
ep1_peter_child_alright = Node(243)
ep1_peter_apologize.children = [ep1_peter_nonchalance, ep1_peter_child_alright, peter_3_1_1, peter_4_1_1]

ep1_peter_apologize_flirt = Node(244)
ep1_peter_apologize_flirt.comment = universal.format_line(['''Attracted to Peter: "So, I was thinking about what I said earlier, and I feel really bad about it, and I'm sorry, and''',
'''I was wondering if maybe you could, I don't know, I guess maybe spank me?"'''])
def ep1_peter_apologize_flirt_qf():
    add_keyword('teaching_Anne')
    ep1_peter_apologize_flirt.quip = universal.format_text([['''"You hurt her, you know," says Peter, his eyes latching onto hers. "She just spent her entire''',
    '''day being harassed and bullied by the other kids, and rather than giving her any sympathy at all, you tell her just to grow a pair."'''],
        [name(), '''shrinks away from Peter's calm, but biting tone, and begins gnawing nervously on''', hisher(), '''thumbnail. "Yeah."'''],
        ['''"And you think something as easy as a spanking will make up for that?" asks Peter sharply.'''],
        ['''"Easy?" says''', name(), '''indignantly. "How is getting spanked easy?"'''],
        ['''"Because it's short," says Peter. "A few minutes of my hand smacking your bare bum, and then it's all over."'''],
        ['''"Um," says''', name() + ",", '''a bit distracted by thoughts of Peter's large hand on''', hisher(), '''bottom, nothing in between, warm''',
            '''flesh against warm flesh.'''],
        ['''"So, instead, tomorrow, you're going to apologize to her, and then you're going to teach her how to fight, and how to use magic," says''',
        '''Peter.'''],
        [name(), '''blinks at Peter.'''],
        ['''Peter sighs, and strokes his beard. "I know, it's an odd request. The thing is, I've been living in this city my whole life. I was a camp''',
            '''follower in a war, would have been forced to fight if I weren't a blacksmith. I've seen every possible mood this city can be in, from''',
            '''happy and uncaring, to brooding and tense, to angry to the point of violence. The city's angry right now, and I worry what'll happen to''',
            '''Anne when things explode. I've seen... Well, point is, I just want her safe."'''],
        ['''"That's an awful lot for an apology," says''', name() + " hesitantly.", '''"I, I really should get paid."'''],
        ['''Peter nods. "Yeah, you should be, sorry for not offering it right away. I can't pay much. Does twenty coins a month work?"'''],
        ['''"Fifty."'''],
        ['''"Thirty. Can't go above that."'''],
        ['''"Forty."'''],
        ['''"What part of 'can't go above' don't you understand?"'''],
        ['''"The part where you want your daughter to be safe."'''],
        ['''"Fine. Thirty-five."''']])
ep1_peter_apologize_flirt.quip_function = ep1_peter_apologize_flirt_qf

ep1_peter_apologize_flirt_lesbian = Node(245)
ep1_peter_apologize_flirt_lesbian.comment = universal.format_line(['''Lesbian in denial: "So, I was thinking about what I said earlier, and I feel really bad about it, and''',
'''I'm sorry, and I was wondering if maybe you could, I don't know, I guess maybe spank me?"'''])

def ep1_peter_apologize_flirt_lesbian_qf():
    add_keyword('lesbian_in_denial')
    ep1_peter_apologize_flirt_lesbian.quip = universal.format_text([[names(), '''thoughts stray back to stories told by Nana, about princes and princesses and love''',
        '''at first kiss, sight, or spank. She'd never felt any interest in men at sight, and what few kisses she'd had were always so forced. But''',
        '''Peter seems like a good, honest man, and surely attractive. Maybe a spanking could be what she needs to finally awaken her interest.'''],
        ['''"You hurt her, you know," says Peter, his eyes latching onto hers. "She just spent her entire''',
    '''day being harassed and bullied by the other kids, and rather than giving her any sympathy at all, you tell her just to grow a pair."'''],
        [name(), '''shrinks away from Peter's calm, but biting tone, and begins gnawing nervously on''', hisher(), '''thumbnail. "Yeah."'''],
        ['''"And you think something as easy as a spanking will make up for that?" asks Peter sharply.'''],
        ['''"Easy?" says''', name(), '''indignantly. "How is getting spanked easy?"'''],
        ['''"Because it's short," says Peter. "A few minutes of my hand smacking your bare bum, and then it's all over."'''],
        [name(), '''frowns, and tries to focus on that thought. Surely it should excite her. His hard, bare hand on her bare, vulnerable flesh.'''],
        ['''"So, instead, tomorrow, you're going to apologize to her, and then you're going to teach her how to fight, and how to use magic," says''',
        '''Peter.'''],
        [name(), '''blinks at Peter.'''],
        ['''Peter sighs, and strokes his beard. "I know, it's an odd request. The thing is, I've been living in this city my whole life. I was a camp''',
            '''follower in a war, would have been forced to fight if I weren't a blacksmith. I've seen every possible mood this city can be in, from''',
            '''happy and uncaring, to brooding and tense, to angry to the point of violence. The city's angry right now, and I worry what'll happen to''',
            '''Anne when things explode. I've seen... Well, point is, I just want her safe."'''],
        ['''"That's an awful lot for an apology," says''', name() + " hesitantly.", '''"I, I really should get paid."'''],
        ['''Peter nods. "Yeah, you should be, sorry for not offering it right away. I can't pay much. Does twenty coins a month work?"'''],
        ['''"Fifty."'''],
        ['''"Thirty. Can't go above that."'''],
        ['''"Forty."'''],
        ['''"What part of 'can't go above' don't you understand?"'''],
        ['''"The part where you want your daughter to be safe."'''],
        ['''"Fine. Thirty-five."''']])
ep1_peter_apologize_flirt_lesbian.quip_function = ep1_peter_apologize_flirt_lesbian_qf

ep1_peter_apologize_flirt_accept = Node(246)
ep1_peter_apologize_flirt_spank_lesbian = Node(254)
ep1_peter_apologize_flirt_lesbian.children = [ep1_peter_apologize_flirt_accept, ep1_peter_apologize_flirt_spank_lesbian]

ep1_peter_apologize_flirt_spank_lesbian.comment = '''"OK, but I still feel kind of bad. Are you sure you won't spank me? It'd make me feel better."'''
def ep1_peter_apologize_flirt_spank_lesbian_qf():
    increment_spankings_taken()
    ep1EndPeterRootChildren.remove(ep1_peter_flirt)
    ep1EndPeterRootChildren.insert(0, ep1_peter_flirt_lesbian)
    ep1_peter_apologize_flirt_spank_lesbian.quip = universal.format_text([['''Peter raises an eyebrow. "You want to be spanked."'''],
        ['''"Well, I wouldn't go that far," says''', name() + ".", '''"Just, whenever I did something inconsiderate, I always felt better after Nana''',
            '''spanked me, like the air had been cleared, or something."'''],
        ['''"Alright, fine," says Peter. He slips into the backroom, and returns a moment later with a soft strip of cloth in one hand, and an armless''',
        '''chair in the other. "Put this in your mouth. I don't want your cries waking up Anne."'''],
        [name(), '''nods and takes the strip of cloth, a part of''', himher(), '''wondering what''', heshe() + "'d", '''gotten''', himselfherself(),
            '''into.''']])
    if wearing_skirt_or_dress_or_pants():
        ep1_peter_apologize_flirt_spank.quip = universal.format_text([ep1_peter_apologize_flirt_spank.quip, ['''"Now, do you want to be spanked over your''',
        p.PC.clothing_below_the_waist().armorType, '''or your panties?" asks Peter, as he gently closes the door into the back of the shop.'''],
        [universal.format_text([[name(), '''flushes. "Um, I'm not wearing any panties."'''],
            ['''"Of course not," says Peter, rolling his eyes. "So do you want to be spanked over your''', p.PC.clothing_below_the_waist().armorType, '''or on the''',
                '''bare?"''']]) if not wearing_underwear() else universal.format_text([['''"You're giving me a choice?" asks''', name() + ",", '''anxiously''',
                '''rubbing''', hisher(), '''hands on the front of''', hisher(), p.PC.clothing_below_the_waist().name + "."], 
                ['''"Of course," says Peter. "After all, you're literally asking for it."''']])]])
        if not wearing_underwear():
            ep1_peter_spanking_panties_lesbian.comment = '''"Bare, sir."'''
        else:
            ep1_peter_spanking_panties_lesbian.comment = '"' + p.UnderwearPanties() + ''', sir."'''
        ep1_peter_spanking_trousers_lesbian.comment =  '"' + p.PC.clothing_below_the_waist().armorType.title() + ', sir."'''
    else:
        ep1_peter_apologize_flirt_spank.quip = universal.format_text([ep1_peter_apologize_flirt_spank.quip, ['''Peter eyes''', names(), '''pantsless state as''',
            '''he gently closes the door into the back of the shop. "Do you want to get spanked over your''', p.underwearpanties() + ",",  
            ('''such as they are, or on the bare?"''' if p.PC.underwear().baring else '''or on the bare?"''')]])
        ep1_peter_spanking_trousers_lesbian.comment = '''"Bare, sir."'''
        ep1_peter_spanking_panties_lesbian.comment = '"' + p.UnderwearPanties() + ', sir."'
ep1_peter_apologize_flirt_spank_lesbian.quip_function = ep1_peter_apologize_flirt_spank_lesbian_qf
ep1_peter_spanking_trousers_lesbian = Node(251)
ep1_peter_spanking_panties_lesbian = Node(252)
ep1_peter_apologize_flirt_spank_lesbian.children = [ep1_peter_spanking_trousers_lesbian, ep1_peter_spanking_panties_lesbian]

def ep1_peter_spanking_trousers_lesbian_qf():
    if wearing_skirt_or_dress_or_pants():
        ep1_peter_spanking_trousers_lesbian.quip = universal.format_text([['''"Alright then," says Peter. He sets the chair down in the middle of the room, and sits down,''',
            '''while''', name(), '''puts the strip of cloth in''', hisher(), '''mouth. Peter pats his lap. "Over you go."'''],
            [name(), '''hesitates for a moment, then steps forward, and drapes''', himselfherself(), '''across Peter's lap. The''',
            '''blacksmith firmly grips''', hisher(), '''waist, lifts the Taironan an inch or so above his lap, and shifts the''',
            '''young''', manwoman(), '''a few inches to the left, centering''', names(), '''bottom on Peter's right thigh. His left hand clamps down''',
            '''on the small of''', names(), '''back, and his right lightly pats''', names(), '''clothed bottom.'''],
            [name(), '''squirms with a bit of anxiety,''', hisher(), '''hips rubbing against Peter's thigh. Nothing. Come on, start spanking''',
            '''already!'''],
            ['''"Ready?" asks Peter kindly.'''],
            [name(), '''nods.'''],
            ['''Smack!'''],
            [names(), '''eyes widen, and a strangled squeak pushes against the cloth in her mouth. Even with''', hisher(), p.PC.lower_clothing().name,
                '''between the hand, and''', hisher(), '''bottom, that hurt!'''],
            ['''Peter's heavy hand smacks repeatedly against''', names(), '''bottom. His hand follows a simple pattern: one to the left cheek, one to''',
            '''the right, and one across the middle.'''],
            ['''Each blow leaves behind stinging pain, and nothing more.'''],
            ['''Then, the blows stop.''', name(), '''lies still for a moment.'''],
            ['''"Alright, get up," says Peter, helping''', name(), '''stand. "Feel better now?"'''],
            ['''"I guess," says''', name() + ",", '''rubbing''', hisher(), '''aching bottom, and fighting a mass of disappointment that has settled in''',
            '''the pit of''', hisher(), '''stomach like a hunk of iron.'''],
            ['''"Good. Anything else you need?" asks Peter with a smile.''']])
    else:
        ep1_peter_spanking_trousers_lesbian.quip = ep1_peter_bare_spanking_lesbian()
    increment_spankings_taken()
ep1_peter_spanking_trousers_lesbian.quip_function = ep1_peter_spanking_trousers_lesbian_qf
ep1_peter_spanking_trousers_lesbian.children = ep1EndPeterRootChildren

def ep1_peter_spanking_panties_lesbian_qf():
    if wearing_underwear():
        if wearing_skirt_or_dress_or_pants():
            ep1_peter_spanking_panties_lesbian.quip = universal.format_text([['''"Alright then," says Peter, setting the chair in the middle of the room, and sitting''',
                '''down.''', '''"Drop your trousers and bend over my knee."''' if wearing_pants() else universal.format_line(['''"Lift your''', 
                    p.PC.lower_clothing().armorType, '''and bend over my knee."'''])]])
            if wearing_pants():
                ep1_peter_spanking_panties_lesbian.quip = universal.format_text([ep1_peter_spanking_panties_lesbian.quip, [name(),
                '''slips the strip of cloth into''', hisher(), '''mouth.''', name(), 
                universal.format_line(['''undoes and removes''', hisher(), '''belt''']) if itemspotionwars.leatherBelt in 
                    inventory() else universal.format_line(['''undoes the string holding up''', hisher(), '''trousers''']), '''and pushes''', hisher(), 
                    '''pants down to''', hisher(), '''ankles. Then,''', heshe(), '''shuffles over and bends over Peter's lap.''', HisHer(), 
                    '''bottom, clad in nothing but''', '''a''' if p.PC.underwear().armorType == items.Thong.armorType else '''a pair of''', 
                    p.PC.underwear().name + ",", '''rounds across Peter's lap.''']])
            elif wearing_skirt_or_dress():
                ep1_peter_spanking_panties_lesbian.quip = universal.format_text([ep1_peter_spanking_panties_lesbian.quip, [name(), '''hikes''', 
                    hisher(), p.PC.lower_clothing().armorType, '''up over''', hisher(), '''hips. Then,''',
                    heshe(), '''walks over and bend over Peter's lap,''', hisher(), 
                    '''bottom, clad in nothing but''', '''a''' if p.PC.underwear().armorType == items.Thong.armorType else '''a pair of''', 
                    p.PC.underwear().name + ",", '''rounding across Peter's lap.''']])
        else:
            ep1_peter_spanking_panties_lesbian.quip = format_txt([['''"Alright, then," says Peter, setting the chair in the middle of the room, and sitting down. He pats his thigh. "Over my knee."'''],
                [name(), '''approaches Peter.''', HeShe(), '''slips the gag into''', hisher(), '''mouth, then slides across Peter's lap, the rough''',
                    '''wool of the smith's trousers scraping harshly against''', hisher(), p.underwearpanties() + "."]])
        if p.PC.numSpankings > 0:
            ep1_peter_spanking_panties_lesbian.quip = universal.format_text([ep1_peter_spanking_panties_lesbian.quip, 
                ['''"Well," says Peter, his callused hand lightly running over''', names(), '''bruises.''',
                '''"Looks like you've already been thoroughly spanked today."'''],
                [name(), '''nods. His fingers leave a line of small, scalding, fires across''', names(), 
                '''aching bottom.'''],
                ['''"Get up," says Peter.'''],
                ['''"What?" says''', name() + ", removing the gag."],
                ['''"I said get up," says Peter. "Look, you've been spanked enough for one day, I'm not going to add to that. Especially since it''',
                    '''really wasn't that big of a deal."'''],
                ['''"But-"'''],
                ['''"Now."'''],
                [name(), '''grimaces, and clambers off Peter's lap.''', HeShe(), universal.format_line(['''pulls''', hisher(), '''trousers back up,'''])
                    if wearing_pants() else (universal.format_line(['''tugs''', hisher(), p.PC.lower_clothing().armorType, '''back down over''', hisher(),
                        '''aching bottom,'''])), '''fighting the disappointment that has settled in the pit of''', hisher(), '''stomach like a hunk of iron.'''],
                    ['''"Look at you," says Peter, laughing. "You've got to be the first person I've ever met whose disappointed that they're not''',
                    '''getting spanked."'''],
                    ['''"I just feel bad," says''', name() + ".", '''"A spanking can be a release, you know? Like a clean slate, or something."'''],
                    ['''"Well, look if it's that important to you, I'll spank you in a few days, after you've healed." Peter stands, and carries the chair around to the back of the counter. "I just''',
                        '''don't want to hurt you. Now, is there anything else you need?"''']])
        else:
            increment_spankings_taken()
            ep1_peter_spanking_panties_lesbian.quip = universal.format_text([ep1_peter_spanking_panties_lesbian.quip, ['''With a great clap, Peter's hard, callused hand strikes''',
                names(), '''left cheek.''', name(), '''squeaks against the gag,''', universal.format_line([hisher(), '''thin''', underwearpanties(), 
                    '''doing little to nothing to shield''', hisher(), '''bottom from the blow.''']) if not p.PC.underwear().baring else 
                universal.format_line(['''as a flash of hot pain spreads across''', hisher(), '''exposed flesh.''']),
                '''Next, Peter's hand claps against''', names(), '''right cheek, with similar effect.'''],
                ['''Peter proceeds to give''', names(), '''bottom a short but thorough hiding, his hand burning into the younger''', manwoman() + "'s",
                    '''bottom with swift, sure strokes.''', name(), '''bucks against Peter's lap.'''], 
                ['''After a few minutes, Peter stops. He rubs''', names(), '''tenderized bottom. "Alright, I think that's enough."'''],
                [name(), '''clambers off of Peter's lap, a ball of disappointment forming in the pit of''', hisher(), '''stomach.'''],
                ['''"Now, is there anything else you'd like?" Peter picks up the chair and carries it around behind the counter, as''', name(), '''fixes''', hisher(), '''clothing.''']])
    else:
        ep1_peter_spanking_panties_lesbian.quip = ep1_peter_bare_spanking_lesbian()
ep1_peter_spanking_panties_lesbian.quip_function = ep1_peter_spanking_panties_lesbian_qf
ep1_peter_spanking_panties_lesbian.children = ep1EndPeterRootChildren

def ep1_peter_bare_spanking_lesbian():
    quip = universal.format_text([['''Peter raises the other eyebrow. He sets the chair in the middle of the room, and sits down. "Are you sure?"'''],
        ['''"Yes," says''', name() + "."],
        ['''"Well, alright. Strip, and get over my knee," says Peter, patting his lap.''']])
    if wearing_skirt_or_dress_or_pants():
        quip = universal.format_text([quip, [name(), universal.format_line(['''pushes''', hisher(), '''trousers down to''', hisher(), 
            '''ankles, making sure''',
            '''to bend all the way over, and giving Peter a flash of the top of''', hisher(), '''breasts. Then,''', heshe(), '''quickly straightens, kicks away''',
            '''the trousers, approaches, and bends across Peter's lap.''']) if wearing_pants() else universal.format_line(['''tugs''', hisher(), 
                p.PC.lower_clothing().name, '''up over''', hisher(), '''hips, making sure to wiggle''', hisher(), '''hips in the process. Then,''', 
                heshe(), '''approaches Peter, and bends down across Peter's lap.'''])]])
    else:
        quip = universal.format_text([quip, [name(), '''takes the thin material of''', hisher(), p.underwearpanties(), '''and in a slow, smooth, sensuous, motion''',
            '''pushes the''', p.PC.underwear().name, '''down to''', hisher(), '''ankles.''', HeShe(), '''raises each foot in turn, and pulls the bit''',
            '''of fabric off''', hisher(), '''feet. Then,''', heshe(), '''approaches Peter, and bends over his lap.''']])
    if p.PC.numSpankings > 0:
        quip = universal.format_text([quip, ['''"Well," says Peter, his callused hand running gingerly over''', names(), '''bruises.''',
            '''"Looks like you've already been thoroughly spanked today."'''],
            [name(), '''nods, then winces. His fingers leave a line of small, scalding fires across''', names(), 
            '''aching bottom.'''],
            ['''"Get up," says Peter.'''],
            ['''"What?" says''', name() + "."],
            ['''"I said get up," says Peter. "Look, you've been spanked enough for one day, I'm not going to add to that. Especially since it''',
                '''really wasn't that big of a deal."'''],
            ['''"But-"'''],
            ['''"Now."'''],
            [name(), '''grimaces, and clambers off Peter's lap.''', HeShe(), universal.format_line(['''pulls''', hisher(), p.PC.clothing_below_the_waist().armorType,
            '''back up,'''])
                if wearing_pants() or not wearing_skirt_or_dress_or_pants() else 
                (universal.format_line(['''tugs''', hisher(), p.PC.lower_clothing().armorType, '''back down over''', hisher(),
                    '''aching bottom,'''])), '''fighting the disappointment that has settled in''', hisher(), '''bottom like a hunk of iron.'''],
                ['''"Look at you," says Peter, laughing. "You've got to be the first person I've ever met whose disappointed that they're not''',
                '''getting spanked."'''],
                ['''"I just feel bad," says''', name() + ".", '''"A spanking can be a release, you know? Like a clean slate, or something."'''],
                ['''"Well, look if it's that important to you, I'll spank you in a few days, after you've healed," says Peter, standing. "I just''',
                    '''don't want to hurt you. Now, is there anything else you need?"''']])
    else:
        increment_spankings_taken()
        quip = universal.format_text([quip, ['''There is a loud smack, and suddenly Peter's palm is ramming into''', names(), '''right cheek, pushing''',
            hisher(), '''hips against the blacksmith's thigh. An explosion of pain cascades across''', names(), 
            '''bottom.''', names(), '''yelps against the gag. Then there is another smack, and another, and another, and soon''', names(), 
            '''cheeks are burning pafinully.'''], 
            ['''Then, the blows stop. "Alright, that's enough."'''],
            [name(), '''quickly clambers off the smith's lap,''', hisher(), '''hands shooting back to''', hisher(), '''stinging bottom. What in La''',
                '''Madre's name could have possessed''', himher(), '''to ask for a spanking?'''],
            ['''There is a moment of awkward silence, as''', name(), '''covers''', himselfherself(), '''and fights the ugly ball of disappointment''',
            '''that has formed in the pit of''', hisher(), '''stomach.'''],
            ['''"So," says Peter at last. He stands, and puts the chair behind the counter. "Anything else I can do for you?"''']])
    return quip


ep1_peter_apologize_flirt_spank = Node(245)
ep1_peter_apologize_flirt.children = [ep1_peter_apologize_flirt_accept, ep1_peter_apologize_flirt_spank]

ep1_peter_apologize_flirt_accept.comment = '''"Alright, I guess I can do that."''' 
def ep1_peter_apologize_flirt_accept_qf():
    ep1_peter_apologize_flirt_accept.quip = universal.format_text([
        ['''"Great," says Peter. "Can you start tomorrow?"'''],
        [name(), '''shrugs. "I'm not sure. The Guild's a mess right now, and I'm not sure if Adrian will be willing to give up a pair of hands for a''',
        '''while."'''],
        ['''"Yeah, I heard the attack," says Peter. "Threw Anne in the backroom the minute those thugs showed up, locked the door, grabbed the biggest''',
            '''spear I had, and really hoped no one busted in. But you were in the thick of it, weren't you? Glad to see you're alright."''']])
ep1_peter_apologize_flirt_accept.quip_function = ep1_peter_apologize_flirt_accept_qf
ep1_peter_apologize_flirt_accept.children = ep1_peter_apologize.children

ep1_peter_apologize_flirt_spank.comment = '''"OK, but I still feel kind of bad. Are you sure you won't spank me? It'd make me feel better."'''
def ep1_peter_apologize_flirt_spank_qf():
    increment_spankings_taken()
    add_keyword('flirting_spank_by_Peter')
    add_keyword('flirting_with_Peter')
    ep1_peter_apologize_flirt_spank.quip = universal.format_text([['''Peter raises an eyebrow. "You want to be spanked."'''],
        ['''"Well, I wouldn't go that far," says''', name() + ".", '''"Just, whenever I did something inconsiderate, I always felt better after Nana''',
            '''spanked me, like the air had been cleared, or something."'''],
        ['''"Alright, fine," says Peter. He slips into the backroom, and returns a moment later with a soft strip of cloth in one hand, and an armless''',
        '''chair in the other. "Put this in your mouth. I don't want your cries waking up Anne."'''],
        [name(), '''nods and takes the strip of cloth, a part of''', himher(), '''wondering what''', heshe() + "'d", '''had gotten''', himselfherself(),
            '''into, and another part still thinking about his hand on''', hisher(),'''bare, vulnerable bottom.''']])
    if wearing_skirt_or_dress_or_pants():
        ep1_peter_apologize_flirt_spank.quip = universal.format_text([ep1_peter_apologize_flirt_spank.quip, ['''"Now, do you want to be spanked over your''',
        p.PC.clothing_below_the_waist().armorType, '''or your panties?" asks Peter, as he gently closes the door into the back of the shop.'''],
        [universal.format_text([[name(), '''flushes. "Um, I'm not wearing any panties."'''],
            ['''"Of course not," says Peter, rolling his eyes. "So do you want to be spanked over your''', p.PC.clothing_below_the_waist().armorType, '''or on the''',
                '''bare?"''']]) if not wearing_underwear() else universal.format_text([['''"You're giving me a choice?" asks''', name() + ",", '''anxiously''',
                '''rubbing''', hisher(), '''hands on the front of''', hisher(), p.PC.clothing_below_the_waist().name, '''as''', heshe(), '''eyes Peter's''',
                '''large, heavy, callused hands.'''], 
                ['''"Of course," says Peter. "After all, you're literally asking for it."''']])]])
        if not wearing_underwear():
            ep1_peter_spanking_panties.comment = '''"Bare, sir."'''
        else:
            ep1_peter_spanking_panties.comment = '"' + p.UnderwearPanties() + ''', sir."'''
        ep1_peter_spanking_trousers.comment =  '"' + p.PC.clothing_below_the_waist().armorType.title() + ', sir."'''
    else:
        ep1_peter_apologize_flirt_spank.quip = universal.format_text([ep1_peter_apologize_flirt_spank.quip, ['''Peter eyes''', names(), '''pantsless state as''',
            '''he gently closes the door into the back of the shop. "Do you want to get spanked over your''', p.underwearpanties() + ",",  
            ('''such as they are, or on the bare?"''' if p.PC.underwear().baring else '''or on the bare?"''')]])
        ep1_peter_spanking_trousers.comment = '''"Bare, sir."'''
        ep1_peter_spanking_panties.comment = '"' + p.UnderwearPanties() + ', sir."'
ep1_peter_apologize_flirt_spank.quip_function = ep1_peter_apologize_flirt_spank_qf

ep1_peter_spanking_trousers = Node(246)
ep1_peter_spanking_panties = Node(247)
ep1_peter_apologize_flirt_spank.children = [ep1_peter_spanking_trousers, ep1_peter_spanking_panties]

def ep1_peter_spanking_trousers_qf():
    if wearing_skirt_or_dress_or_pants():
        ep1_peter_spanking_trousers.quip = universal.format_text([['''"Alright then," says Peter. He sets the chair down in the middle of the room, and sits down,''',
            '''while''', name(), '''puts the strip of cloth in''', hisher(), '''mouth. Peter pats his lap. "Over you go."'''],
            [name(), '''hesitates for a moment, then steps forward, and drapes''', himselfherself(), '''across Peter's large, muscled thighs. The''',
            '''blacksmith firmly grips''', hisher(), '''waist, lifts the Taironan an inch or so above his lap, and shifts the''',
            '''young''', manwoman(), '''a few inches to the left, centering''', names(), '''bottom on Peter's right thigh. His left hand clamps down''',
            '''on the small of''', names(), '''back, and his right lightly pats''', names(), '''clothed bottom.'''],
            [name(), '''squirms with a bit of anxiety,''', hisher(), '''hips rubbing against Peter's stolid thigh. Madre's love, this man is big.'''],
            ['''"Ready?" asks Peter kindly.'''],
            [name(), '''gnaws on the gag, not sure if''', heshe(), '''is excited, or nervous. Then,''', heshe(), '''nods.'''],
            ['''Smack!'''],
            [names(), '''eyes widen, and a strangled squeak pushes against the cloth in her mouth. Even with''', hisher(), p.PC.lower_clothing().name,
                '''between the blacksmith's large, hard hand, and''', names(), '''round, soft bottom, that hurt!'''],
            ['''Peter's heavy hand smacks repeatedly against''', names(), '''sore, sensitive''' if p.PC.numSpankings > 0 else '''sensitive''', 
                '''bottom. His hand follows a simple pattern: one to the left cheek, one to the right, and one across the middle.'''],
            ['''Each blow leaves behind a mixture of stinging pain, and hot, desperate tingles.''', name(), '''can't help but squirm beneath''',
                '''the heavy strokes,''', hisher(), '''hips grinding with short, quick motions against Peter's leg.''', HeShe(), '''moans and pants against the gag.''', HeShe(), '''squeezes''', hisher(), 
                '''legs together, and''', heshe(), '''grips Peter's muscled calf in a deathgrip.'''],
            ['''Then, the blows stop.''', name(), '''lies still for a moment, both trying to recover from, and basking in the warmth in''', hisher(),
                '''bum and groin.'''],
            ['''"Alright, get up," says Peter, helping''', name(), '''stand. "Feel better now?"'''],
            [name(), '''nods, rubbing''', hisher(), '''aching, tingling bottom.'''],
            ['''"Good. Anything else you need?" asks Peter with a smile.''']])
    else:
        ep1_peter_spanking_trousers.quip = ep1_peter_bare_spanking()
    increment_spankings_taken()
ep1_peter_spanking_trousers.quip_function = ep1_peter_spanking_trousers_qf
ep1_peter_spanking_trousers.children = ep1EndPeterRootChildren


def ep1_peter_spanking_panties_qf():
    if wearing_underwear():
        if wearing_skirt_or_dress_or_pants():
            ep1_peter_spanking_panties.quip = universal.format_text([['''"Alright then," says Peter, setting the chair in the middle of the room, and sitting''',
                '''down.''', '''"Drop your trousers and bend over my knee."''' if wearing_pants() else universal.format_line(['''"Lift your''', 
                    p.PC.lower_clothing().armorType, '''and bend over my knee."'''])]])
            if wearing_pants():
                ep1_peter_spanking_panties.quip = universal.format_text([ep1_peter_spanking_panties.quip, [name(), '''wets''', hisher(), '''lips.''', HeShe(),
                '''slips the strip of cloth into''', hisher(), '''mouth. With slightly''',
                    '''shaking hands,''', name(), universal.format_line(['''undoes and removes''', hisher(), '''belt''']) if itemspotionwars.leatherBelt in 
                    inventory() else universal.format_line(['''undoes the string holding up''', hisher(), '''trousers''']), '''and pushes''', hisher(), 
                    '''pants down to''', hisher(), '''ankles. Then,''', heshe(), '''shuffles over and bends over Peter's lap.''', HisHer(), 
                    '''bottom, clad in nothing but''', '''a''' if p.PC.underwear().armorType == items.Thong.armorType else '''a pair of''', 
                    p.PC.underwear().name + ",", '''rounds across Peter's lap.''']])
            elif wearing_skirt_or_dress():
                ep1_peter_spanking_panties.quip = universal.format_text([ep1_peter_spanking_panties.quip, [name(), '''wets''', hisher(), '''lips. With slightly''',
                    '''shaking hands,''', name(), '''hikes''', hisher(), p.PC.lower_clothing().armorType, '''up over''', hisher(), '''hips. Then,''',
                    heshe(), '''walks over and bend over Peter's lap,''', hisher(), 
                    '''bottom, clad in nothing but''', '''a''' if p.PC.underwear().armorType == items.Thong.armorType else '''a pair of''', 
                    p.PC.underwear().name + ",", '''rounding across Peter's lap.''']])
        else:
            ep1_peter_spanking_panties.quip = format_txt([['''"Alright, then," says Peter, setting the chair in the middle of the room, and sitting down. He pats his thigh. "Over my knee."'''],
                [name(), '''approaches Peter''', hisher(), '''legs suddenly feeling very weak.''', HeShe(), '''slips the gag into''', hisher(), '''mouth, then slides across Peter's lap, the rough''',
                    '''wool his trousers rubbing against the thin fabric of''', hisher(), p.underwearpanties() + "."]])
        if p.PC.numSpankings > 0:
            ep1_peter_spanking_panties.quip = universal.format_text([ep1_peter_spanking_panties.quip, 
                ['''"Well," says Peter, his callused hand lightly running over''', names(), '''bruises.''',
                '''"Looks like you've already been thoroughly spanked today."'''],
                [name(), '''nods, rocking''', hisher(), '''hips beneath Peter's touch. His fingers leave a line of small fires across''', names(), 
                '''aching bottom, not all of them painful.'''],
                ['''"Get up," says Peter.'''],
                ['''"What?" says''', name() + ", removing the gag."],
                ['''"I said get up," says Peter. "Look, you've been spanked enough for one day, I'm not going to add to that. Especially since it''',
                    '''really wasn't that big of a deal."'''],
                ['''"But-"'''],
                ['''"Now."'''],
                [name(), '''grimaces, and clambers off Peter's lap.''', HeShe(), universal.format_line(['''pulls''', hisher(), '''trousers back up,'''])
                    if wearing_pants() else (universal.format_line(['''tugs''', hisher(), p.PC.lower_clothing().armorType, '''back down over''', hisher(),
                        '''aching bottom,'''])), '''fighting the disappointment that has settled in the pit of''', hisher(), '''stomach like a hunk of iron.'''],
                    ['''"Look at you," says Peter, laughing. "You've got to be the first person I've ever met whose disappointed that they're not''',
                    '''getting spanked."'''],
                    ['''"I just feel bad," says''', name() + ".", '''"A spanking can be a release, you know? Like a clean slate, or something."'''],
                    ['''"Well, look if it's that important to you, I'll spank you in a few days, after you've healed." Peter stands, and carries the chair around to the back of the counter. "I just''',
                        '''don't want to hurt you. Now, is there anything else you need?"''']])
        else:
            increment_spankings_taken()
            ep1_peter_spanking_panties.quip = universal.format_text([ep1_peter_spanking_panties.quip, ['''With a great clap, Peter's hard, callused hand strikes''',
                names(), '''left cheek.''', name(), '''squeaks against the gag,''', universal.format_line([hisher(), '''thin''', underwearpanties(), 
                    '''doing little to nothing to shield''', hisher(), '''bottom from the blow.''']) if not p.PC.underwear().baring else 
                universal.format_line(['''as a flash of hot pain (and another, far more tingly sensation) spreads across''', hisher(), '''exposed flesh.''',
                    HisHer(),
                    '''hips push upward of their own volition, and''', hisher(), '''hips sway, rubbing''', hisher(), '''cheek against Peter's hand.''']),
                '''Next, Peter's hand claps against''', names(), '''right cheek, with similar effect.'''],
                ['''Peter proceeds to give''', names(), '''bottom a short but thorough hiding, his hand burning into the younger''', manwoman() + "'s",
                    '''bottom with swift, sure strokes.''', name(), '''bucks and grinds (not entirely from pain) against Peter's hips.''', HeShe(),
                    '''can distinctly feel Peter's rough trousers, and beneath that his strong, sturdy leg through the thin fabric of''', hisher(),
                    p.PC.underwear().name + ".", names(), '''breath comes in short, quick gasps, and''', hisher(), '''torso begins to writhe''',
                    '''sinuously, rubbing against Peter's left leg. If Peter notices''', names(), '''mix of pleasure and pain, he doesn't react to it,''',
                    '''just continues to batter''', hisher(), '''bouncing bottom.'''],
                ['''After a few minutes, Peter stops. He rubs''', names(), '''nicely tenderized bottom. "Alright, I think that's enough. Though to be''',
                    '''honest, I'm not sure that you've learned anything from this."'''],
                ['''"Oh, I've learned quite a bit," says''', name(), '''in a breathless voice.''', HisHer(), '''hips press against Peter's thigh. "Yes.''',
                    '''Quite a bit."'''],
                ['''"Come on, stand up," says Peter. "Before I give you a proper paddling."'''],
                [name(), '''pouts, but clambers off of Peter's lap. As enjoyable as that was, it was also just painful enough to dissuade''', name(), 
                '''from truly raising the very large, very strong blacksmith's ire.'''],
                ['''"Now, is there anything else you'd like?" Peter picks up the chair and carries it around behind the counter, as''', name(), '''fixes''', hisher(), '''clothing.''']])
    else:
        ep1_peter_spanking_panties.quip = ep1_peter_bare_spanking()
ep1_peter_spanking_panties.quip_function = ep1_peter_spanking_panties_qf
ep1_peter_spanking_panties.children = ep1EndPeterRootChildren

def ep1_peter_bare_spanking():
    quip = universal.format_text([['''Peter raises the other eyebrow. He sets the chair in the middle of the room, and sits down. "Are you sure?"'''],
        ['''"Yes," says''', name() + ",", '''an image of Peter's big, warm hand running over''', hisher(), '''completely bare, completely exposed''',
            '''bottom filling''', hisher(), '''thoughts.'''],
        ['''"Well, alright. Strip, and get over my knee," says Peter, patting his lap.''']])
    if wearing_skirt_or_dress_or_pants():
        quip = universal.format_text([quip, ['''With shaking hands,''', name(), universal.format_line(['''pushes''', hisher(), '''trousers down to''', hisher(), 
            '''ankles, making sure''',
            '''to bend all the way over, and giving Peter a flash of the top of''', hisher(), '''breasts. Then,''', heshe(), '''quickly straightens, kicks away''',
            '''the trousers, approaches, and bends across Peter's lap.''']) if wearing_pants() else universal.format_line(['''tugs''', hisher(), 
                p.PC.lower_clothing().name, '''up over''', hisher(), '''hips, making sure to wiggle''', hisher(), '''hips in the process. Then,''', 
                heshe(), '''approaches Peter, and bends down across Peter's lap.''']), HeShe(), '''flushes and squirms as''', hisher(), 
                '''bare hips and nether regions press up against the rough wool of Peter's trousers.''']])
    else:
        quip = universal.format_text([quip, [name(), '''takes the thin material of''', hisher(), p.underwearpanties(), '''and in a slow, smooth, sensuous, motion''',
            '''pushes the''', p.PC.underwear().name, '''down to''', hisher(), '''ankles.''', HeShe(), '''raises each foot in turn, and pulls the bit''',
            '''of fabric off''', hisher(), '''feet. Then,''', heshe(), '''approaches Peter, and bends over his lap,''', hisher(),'''naked hips and''',
            '''nether regions slowly rubbing against the rough fabric of Peter's woolen trousers.''']])
    if p.PC.numSpankings > 0:
        quip = universal.format_text([quip, ['''"Well," says Peter, his callused hand running gingerly over''', names(), '''bruises.''',
            '''"Looks like you've already been thoroughly spanked today."'''],
            [name(), '''nods, rocking''', hisher(), '''hips beneath Peter's touch. His fingers leave a line of small fires across''', names(), 
            '''aching bottom, not all of them painful.'''],
            ['''"Get up," says Peter.'''],
            ['''"What?" says''', name() + "."],
            ['''"I said get up," says Peter. "Look, you've been spanked enough for one day, I'm not going to add to that. Especially since it''',
                '''really wasn't that big of a deal."'''],
            ['''"But-"'''],
            ['''"Now."'''],
            [name(), '''grimaces, and clambers off Peter's lap.''', HeShe(), universal.format_line(['''pulls''', hisher(), p.PC.clothing_below_the_waist().armorType,
            '''back up,'''])
                if wearing_pants() or not wearing_skirt_or_dress_or_pants() else 
                (universal.format_line(['''tugs''', hisher(), p.PC.lower_clothing().armorType, '''back down over''', hisher(),
                    '''aching bottom,'''])), '''fighting the disappointment that has settled in''', hisher(), '''bottom like a hunk of iron.'''],
                ['''"Look at you," says Peter, laughing. "You've got to be the first person I've ever met whose disappointed that they're not''',
                '''getting spanked."'''],
                ['''"I just feel bad," says''', name() + ".", '''"A spanking can be a release, you know? Like a clean slate, or something."'''],
                ['''"Well, look if it's that important to you, I'll spank you in a few days, after you've healed," says Peter, standing. "I just''',
                    '''don't want to hurt you. Now, is there anything else you need?"''']])
    else:
        increment_spankings_taken()
        quip = universal.format_text([quip, ['''There is a loud smack, and suddenly Peter's hot, heavy palm is ramming into''', names(), '''right cheek, pushing''',
            hisher(), '''hips against the blacksmith's thigh. An explosion of heat, both painful and not, cascades across''', names(), 
            '''round, rippling, naked bottom.''', '''A faint moan slips out from around''', names(), '''gag, and''', hisher(), '''hips pump against''',
            '''Peter's leg. Then there is another smack, and another, and another, and soon''', names(), '''cheeks are awash with sensation, both''',
            '''positive and negative, pain and pleasure.''', HisHer(), '''hips grind furiously against Peter's lap, as the smith's callused, scalding''',
            '''hot hand thwacks mercilessly against''', hisher(), '''exposed, helpless cheeks.''', HeShe(), '''flushes, as a third of''', hisher(),
            '''blood rushes to''', hisher(), '''head, a third rushes to''', hisher(), '''bottom, and a third to''', hisher(), '''nether regions.''',
            HeShe(), '''wiggles and thrashes about on Peter's lap, each blow driving''', himher(), '''to more and more desperate motions.'''],
            ['''Then, the blows stop. "Alright, that's enough."'''],
            ['''"But-"'''],
            ['''"I try not to sexually stimulate women after only our second conversation," says Peter wryly. "Please get up."'''],
            [names(), '''face flushes with humiliation, and''', heshe(), '''pulls''', himselfherself(), '''off of Peter's lap.''', HisHer(), 
                '''flush deepens when''', heshe(), '''notices a small damp spot on Peter's leg, about where''', hisher(), '''groin had been. The''',
                '''only thing keeping''', himher(), '''from running out the door in complete humiliation was the memory of a certain cylindrical object''',
                heshe(), '''that had poked against''', hisher(), '''hip while''', heshe(), '''was writhing on the smith's lap.'''],
            ['''There is a moment of awkward silence, as''', name(), '''covers''', himselfherself(), '''and tries not to fantasize about Peter's hand,''',
                '''suddenly soft as velvet, rubbing the sting away.'''],
            ['''"So," says Peter at last. He stands, and puts the chair behind the counter. "Anything else I can do for you?"'''],
            ['''Oh Madre's mercy, yes.''', name(), '''swallows, only barely keeping the words from bursting from''', hisher(), '''lips.''', HisHer(),
                '''libido has made things awkward enough, thank you very much.''']])
    return quip

ep1_peter_flirt = Node(248)
ep1_peter_flirt_lesbian = Node(249)
ep1_peter_flirt_lesbian.comment = '''Lesbian in denial: Flirt with Peter.'''
def ep1_peter_flirt_lesbian_qf():
    add_keyword('lesbian_in_denial')
    add_keyword('flirting_with_Peter')
    ep1_peter_flirt_lesbian.quip = ep1_peter_flirt_quip()
    return (universal.acknowledge, [townmode.go, craftmansCorridor])
ep1_peter_flirt_lesbian.quip_function = ep1_peter_flirt_lesbian_qf

ep1_peter_flirt.comment = '''Flirt with Peter.'''
def ep1_peter_flirt_quip():
    return universal.format_text([
        ['''"How about a little conversation?" asks''', name() + ",", '''flashing the smith a smile. "I don't really know anyone yet, and could''',
        '''use a friend or two."'''],
        ['''"You know, I do have stuff to do," says Peter. Rather than doing that stuff, however, he comes around to the same side of the counter as''',
        name(), '''and leans against it,''',
    '''only inches away from where''', name(), '''is standing. "And I'd kind of like to get it done before it gets too dark."'''],
        ['''"Oh, come on," says''', name() + ",", '''taking a half-step towards Peter. "It's not like your stuff is important, or anything."'''],
        ['''"Oh really?" says Peter, leaning forward with silly menace. "So, you're saying my smithy's pointless?"'''],
        [name(), '''grins cheekily, and pats him on the cheek. "Don't take it too hard. Not everyone can be an adventurer."'''],
        ['''"Brat," cries Peter, a humorous gleam in his eye. His hand snaps around''', names(), '''hip and claps against''', hisher(), '''bottom.''',
            universal.format_line([name(), '''jumps''' + (universal.format_line([''', Peter's callused hand leaving a stinging tingle on''', hisher(), '''bare cheeks.''' if 
            not wearing_skirt_or_dress_or_pants() and p.PC.underwear().baring else '''bum.''']) if not 'lesbian_in_denial' in keywords() else '.')])], 
        [HeShe(), 
                '''pouts at Peter, and makes a big show of rubbing''', hisher(), '''bottom. "I was only kidding, you big jerk."'''],
        ['''"Nobody kids about Wesley and Anne's Armor Shop," says Peter with hyperbolic intensity. "Not unless''', heshe(), '''wants''', hisher(), '''bottom smacked."'''],
        [name(), '''sticks''', hisher(), '''tongue out at Peter. "Well, maybe nobody smacks my bottom, unless he wants his bottom smacked. What do''',
            '''you say to that you overgrown brute?"'''],
        ['''Before Peter can respond, the door creaks open, and Anne steps in, dressed in a simple nightshift, a ragged doll clutched in one hand, the''',
        '''thumb of the other jammed in her mouth. She mumbles something around her thumb.'''],
        ['''"Oh, did Bonnie have a bad dream again?" asks Peter, slipping around the counter, and kneeling down next to the girl. "Don't worry, you tell''',
        '''her it's just a dream. It''',
            '''can't hurt her."'''],
        ['''The girl mumbles something else, and hugs the doll tighter.'''],
        ['''"I know, I know, it's still scary," says Peter. He wraps his big arms around the little figure, and lifts her up. She snuggles against''',
            '''his chest, holding her doll tight against her own. "Well, I'll come in and lie down with her. No bad dreams will dare''',
            '''challenge me."'''],
        ['''"Sorry, didn't mean to wake her," says''', name() + "."],
        ['''Peter shakes his head dismissively. "You probably didn't. This happens about once a week or so."'''],
        ['''"Whose Bonnie?" asks''', name() + "."],
        ['''Peter grins, and kisses his daughter on the forehead. "Anne's doll. Quite prone to nightmares if I'm not there to protect her. Right,''',
        '''Anne?"'''],
        ['''The girl nods, and snuggles more tightly against her father's broad chest.'''],
        ['''"I'll see you around," says Peter. "Close the door on your way out, please."'''],
        [name(), '''nods, and slips out, as Peter goes into the backroom.''']])

def ep1_peter_flirt_qf():
    add_keyword('flirting_with_Peter')
    ep1_peter_flirt.quip = ep1_peter_flirt_quip()
    return (universal.acknowledge, [townmode.go, craftmansCorridor])
ep1_peter_flirt.quip_function = ep1_peter_flirt_qf


ep1_peter_nonchalance.comment = '''"Oh, it wasn't that big of a deal. Most of the Vengadores were untrained, and didn't pose a serious threat."'''
def ep1_peter_nonchalance_qf():
    ep1_peter_nonchalance.quip = universal.format_text([['''"I see," says Peter dryly. "So the reason the attack lasted over an hour was because you guys were taking''',
        '''your own sweet time defeating them."'''],
        ['''"Was it really over an hour?" asks''', name() + "."],
        ['''"Thereabouts," says Peter.'''],
        [name(), '''throws''', hisher(), '''hands up in the air. "What took the guards so cursed long, then? How does it take you over an hour to''',
        '''respond to a massive attack on a building in the center of the cursed city?"'''],
        ['''"Watch the language, and keep your voice down," says Peter, glancing at the door in the back of the room. "Little ears are nearby."'''],
        ['''"Sorry," says''', name(), '''moderating''', hisher(), '''tone. "But seriously, what took them so long?"'''],
        ['''"I was chatting with one the guards, while they were cleaning up," says Peter, pulling out a rag, and beginning to clean the countertop.''',
        '''"Apparently, just before the attack, a fight broke out between a bunch of Bondan and Avaricumite gangs, and the fight spilled over into''',
        '''the residential district down at the south end of the city. The guards were too busy keeping that contained to respond to the attack on''',
        '''the Guild."'''],
        ['''"Well, that's convenient," says''', name() + ",", '''crossing''', hisher(), '''hands over''', hisher(), '''chest.'''],
        ['''Peter nods. "Makes you kind of scared doesn't it? If these Vengadores managed to orchestrate a gang fight large enough to distract the''',
            '''guards, you gotta wonder how much influence they have in the slums."'''],
        [name(), '''doesn't respond immediately.''', HeShe(), '''watches Peter clean, as if considering something. "What do you think of the Vengadores? They claim they're trying to make Taironan lives better."'''],
        ['''Peter grimaces down at the countertop. "I don't know. I've seen up close and personal how hard life is for Taironans in this city,''',
            '''especially Bondans. So, maybe I can understand it. But violence? Really? What does that solve? If anything, it'll make things''',
            '''worse."'''],
        ['''"Maybe they just feel desperate," says''', name() + "."],
        ['''"Doesn't make them any less stupid," says Peter. He tosses the rag underneath the countertop.'''],
        ['''"I suppose," says''', name()  + "."]])
    if not 'teaching_Anne' in keywords():
        ep1_peter_nonchalance.quip = universal.format_text([ep1_peter_nonchalance.quip, ['''"Anyway, this attack has gotten me thinking. Things have been getting kind of ugly lately, and I'm worried about Anne. I've been a camp follower, I know the hell that is''',
            '''war, and I want her to be able to defend herself. So I was wondering-"'''],
        ['''"If I'd teach her how to fight," says''', name(), '''with a nod. "Sure. Though, I can't do it for free.''', BoyGirl(), '''needs to eat, you understand."'''],
        ['''"Of course," says Peter. "Though I can't afford much. Twenty a month?"'''],
        ['''"Fifty."'''],
        ['''"Thirty. Can't go above that."'''],
        ['''"Forty."'''],
        ['''"What part of 'can't go above' don't you understand?"'''],
        ['''"The part where you want your daughter to be safe."'''],
        ['''"Fine. Thirty-five."''']])
    else:
        ep1_peter_nonchalance.quip = universal.format_text([ep1_peter_nonchalance.quip, ['''"Anyway, is there anything else you need?" asks Peter.''']])
        ep1_peter_nonchalance.children = ep1EndPeterRootChildren
    
ep1_peter_nonchalance.quip_function = ep1_peter_nonchalance_qf
ep1_peter_teach_anne_yes = Node(249)
ep1_peter_teach_anne_no = Node(255)
ep1_peter_nonchalance.children = [ep1_peter_teach_anne_yes, ep1_peter_teach_anne_no]
       
ep1_peter_child_alright.comment = '''"Speaking of your daughter, is she alright? None of the Vengadores hurt her, did they?"'''
def ep1_peter_child_alright_qf():
    ep1_peter_child_alright.quip = universal.format_text([['''"Oh, no no no," says Peter. "They didn't seem all that interested in us, but the minute I''',
        '''heard them come down the Corridor, I grabbed Anne, grabbed the biggest spear we have, and pulled her into the backroom. Then I barred both''',
        '''doors, and didn't unbar them until the thugs were long gone."'''],
        ['''"That's good," says''', name() + ".", '''"I'd hate it if she got hurt." An image of the first girl''', name(), '''fought flashes through''',
            hisher(), '''mind. "Enough young people were hurt as it is."'''],
        ['''Peter raises an eyebrow. "You're pretty young yourself, you know."'''],
        ['''"Younger people then," says''', name() + ".", '''"Besides, I may have included myself in that group."'''],
        ['''Peter suddenly looks concerned. "Were you hurt?"'''],
        [universal.format_line(['''"Aside from a spanking or''', num_to_word(p.PC.numSpankings), '''not really.''']) if p.PC.numSpankings > 1 else 
            '''"Not really.''', '''They weren't really interested in hurting anyone, I think. They just wanted our stuff."'''],
        ['''"That's good," says Peter. "It'd be unfortunate if something really bad happened to you on your first day."'''],
        ['''"Yeah, terrible," says''', name() + universal.format_line([",", hisher(), '''thoughts flitting back to the abyss.''']) if 'charmed_by_Deidre' else "."]])
    if 'teaching_Anne' not in keywords():
        ep1_peter_child_alright.quip = universal.format_text([ep1_peter_child_alright.quip, ['''"Anyway, this attack has gotten me thinking," says Peter. "Things have been getting kind of ugly lately, and''',
        '''I'm worried about Anne. I've been a camp follower, I know the hell that is''',
            '''war, and I want her to be able to defend herself. So I was wondering-"'''],
        ['''"If I'd teach her how to fight," says''', name(), '''with a nod. "Sure. Though, I can't do it for free.''', BoyGirl(), '''needs to eat, you understand."'''],
        ['''"Of course," says Peter. "Though I can't afford much. Twenty a month?"'''],
        ['''"Fifty."'''],
        ['''"Thirty. Can't go above that."'''],
        ['''"Forty."'''],
        ['''"What part of 'can't go above' don't you understand?"'''],
        ['''"The part where you want your daughter to be safe."'''],
        ['''"Fine. Thirty-five."''']])
    else:
        ep1_peter_child_alright.quip = universal.format_text([ep1_peter_child_alright.quip, ['''"Anyway, is there anything else you need?" asks Peter.''']])
        ep1_peter_child_alright.children = ep1EndPeterRootChildren
ep1_peter_child_alright.quip_function = ep1_peter_child_alright_qf
ep1_peter_child_alright.children = [ep1_peter_teach_anne_yes, ep1_peter_teach_anne_no]

ep1_peter_teach_anne_yes.comment = '''"Alright, I can do that."'''
def ep1_peter_teach_anne_yes_qf():
    add_keyword('teaching_Anne')
    ep1_peter_teach_anne_yes.quip = universal.format_text([['''"Great," says Peter. "We'll discuss rules and expectations later, but one thing I want to get out of the way right now: no''',
    '''spankings.''',
    '''She's too young. You lay a hand on her, and I'll give you ten times what you give her, only with my belt."'''],
    [name(), '''scowls. "How old is your kid? Five, six? You really think I'm going to hit a six year old? What kind of person do''',
    '''you take me for?"'''],
    ['''"Sorry, sorry," says Peter, holding up his hands in a conciliatory gesture. "I just wanted to make sure we were on the same page. Besides, I'm a little protective of my daughter."'''],
    ['''"I noticed," says''', name() + ".", '''"But don't worry. If she gives me trouble, I'll come to you."'''],
    ['''Peter nods. "Great. Can you start tomorrow?"'''],
    ['''"I'm not sure," says''', name(), '''with a shrug. "Depends on if Adrian is willing to give up a pair of hands for a few hours."'''],
    ['''"Well, let me know. Now, is there anything you need?" asks Peter. "Because if not, I'd like to get the shop closed down for the night."''']])
ep1_peter_teach_anne_yes.quip_function = ep1_peter_teach_anne_yes_qf         
ep1_peter_teach_anne_yes.children = ep1EndPeterRootChildren

ep1_peter_teach_anne_no.comment = '''"Sorry, but I don't think so. That's too little for teaching."'''
def ep1_peter_teach_anne_no_qf():
    ep1_peter_teach_anne_no.quip = universal.format_text([['''Peter grimaces, but nods. "Sorry to hear that, but I understand. I'm offering a pittance, I know, but it's all I could afford, and I hoped...but it doesn't''',
        '''matter."'''],
        ['''"You won't hold it against me?" asks''', name() + "."],
        ['''"Of course not," says Peter, smiling. "It'd be a dick move if I did, and I try not to be a dick. Now, is there anything else you need? Because if not, I'd like to start closing up for the''',
        '''night."''']])
ep1_peter_teach_anne_no.quip_function = ep1_peter_teach_anne_no_qf
ep1_peter_teach_anne_no.children = ep1EndPeterRootChildren
            
def num_to_word(num):
    """
    A quick and dirty program that returns the first ten numbers as words.
    """
    return {0 : "zero", 1 : "one", 2 : "two", 3 : "three", 4 : "four", 5 : "five", 6 : "six", 7 : "seven", 8 : "eight", 9 : "nine", 10 : "ten"}[num]

elise_end_episode_1 = Node(256)
def elise_end_episode_1_qf():
    add_keyword('finished_night_on_town')
    if 'second_hand_tragedy' in keywords():
        elise_end_episode_1.quip = universal.format_text([['''\m"Oh, thank the Mother, you're back," says Elise, rushing over. Gone is the bulky blue''',
        '''Sister's dress. In its place is a high-cut, rather tight kelly-green dress that extends about halfway down her shins. It's cut to maximize her small bust,''',
        '''and draw attention to her wide hips and''',
        '''round bottom. She is wearing a pair of matching green silk slippers. Her brown hair is pulled back into a bohemian bun, with a hint of''',
        '''messiness. "Look, I'm really sorry about Sister''',
            '''Samantha. She was in Bonda, you know? Makes her a little sensitive about the whole thing. Also, I heard about the attack on the''',
            '''Adventurer's Guild. Are you alright? Those thugs didn't hurt you, did they?"''']])
        elise_end_episode_1.children = [ep1_elise_dont_worry, ep1_elise_talk_with_Sister_Samantha]
        elise_end_episode_1.music = [ELISE, CARRIE]
        return
    elise_end_episode_1.quip = universal.format_text([['''\m"Hey," says Elise, smiling broadly as she approaches''', name() + ".", '''Gone is the bulky blue''',
        '''Sister's dress. In its place is a high-cut, rather tight kelly-green dress that extends about halfway down her shins. It's cut to maximize her small bust,''',
        '''and draw attention to her wide hips and''',
        '''round bottom. She is wearing a pair of matching green silk slippers. Her brown hair is pulled back into a bohemian bun, with a hint of''',
        '''messiness. "Ready to have some fun?"'''],
        ['''"Madre's love, yes," says''', name() + ".", '''"You won't believe the day I've had."'''],
        ['''Elise nods. "Yeah, I heard about the attack. Roland said no one was seriously hurt though, thank the Mother."'''],
        [name(), '''shrugs. "Yeah. Except the Guild itself. It'll probably take years to rebuild the whole cursed thing."'''],
        ['''"That's rough. No use thinking about it now, though. We're just waiting on Carrie, then we can you cleaned up, and then start the fun," says Elise, forcing a smile.'''],
        [name(), '''nods, and the two stand in silence for a moment.''']])
    if 'Maria_intimidated_you' in keywords() and not 'talked_with_Maria' in keywords():
        elise_end_episode_1.quip = universal.format_text([elise_end_episode_1.quip, ['''"Have you talked to Maria, yet?" asks Elise hesitantly.'''],
            [name(), '''grimaces and shakes''', hisher(), '''head.'''],
            ['''"You really should-"'''],
            ['''"Not talking about this now."'''],
            ['''Elise sighs. "Fine."''']])
    #import universal
    #print('playedMusic:')
    #print(universal.playedMusic.queue)
    #print('setting elises end episode 1 music.')
    #print(CARRIE)
    elise_end_episode_1.quip = universal.format_text([elise_end_episode_1.quip, carrie_arrival()])
    elise_end_episode_1.music = [ELISE, CARRIE]
    if p.PC.is_female():
        elise_end_episode_1.children = [ep1_elise_prank, ep1_elise_no_prank]
    elif p.PC.is_male():
        elise_end_episode_1.children = [ep1_elise_kiss_hand, ep1_elise_shake]
elise_end_episode_1.quip_function = elise_end_episode_1_qf

ep1_elise_dont_worry = Node(260)
ep1_elise_dont_worry.comment = universal.format_line(['''"Don't worry about it, the riots were a bad time for everyone. I just wanted to apologize for''',
''''running out like that."'''])
def ep1_elise_dont_worry_qf():
    ep1_elise_dont_worry.quip = universal.format_text([['''"Oh, you have nothing to apologize for," says Elise, waving her hand. "And I am sorry."'''],
        ['''"Well, don't worry about it, like I said," says''', name() + ".", '''"I should probably be going now. It's been a long day."'''],
        ['''"Wait," says Elise. "My friend and I are going to be going out soon, to celebrate my ascension to Sisterhood. Would you like to join''',
            '''us? It might help you unwind a little."''']])

elise_dont_worry_yes = Node(261)
elise_dont_worry_no = Node(262)
ep1_elise_dont_worry.children = [elise_dont_worry_yes, elise_dont_worry_no]
elise_dont_worry_yes.comment = '''"Sure. Sounds like fun."'''
def elise_dont_worry_yes_qf():
    add_keyword('Elise_shows_you_around')
    elise_dont_worry_yes.quip = universal.format_text([['''Elise claps her hands together, and grins. "Wonderful. Now, we're just waiting on Carrie."'''],
        carrie_arrival()])
    elise_dont_worry_yes.music = [CARRIE]
    if p.PC.is_female():
        elise_dont_worry_yes.children = [ep1_elise_prank, ep1_elise_no_prank]
    elif p.PC.is_male():
        elise_dont_worry_yes.children = [ep1_elise_shake, ep1_elise_kiss_hand]

elise_dont_worry_no.comment = '''"Sorry, but I think I'd rather not. Too tired."'''
def elise_dont_worry_no_qf():
    elise_dont_worry_no.quip = universal.format_text([['''"Well, alright," says Elise, smiling. "Have a nice day, and I'll see you around."'''],
        ['''"See you."''']])

ep1_elise_talk_with_Sister_Samantha = Node(269)
ep1_elise_talk_with_Sister_Samantha.comment = '''"I'd like to talk to Sister Samantha."'''
def ep1_elise_talk_with_Sister_Samantha_qf():
    ep1_elise_talk_with_Sister_Samantha.music = [CHURCH]
    ep1_elise_talk_with_Sister_Samantha.quip = universal.format_text([['''"Alright," says Elise. "Follow me."'''],
        ['''The two go through a door in the back of the shrine, and wind their way through long, twisting corridors, and into a large mess hall.''',
            '''Sisters and Brothers are sitting at the tables, resting after a long day of looking after the orphaned children that lived in the church.''',
            '''Elise smiles and waves at a few of them.''', name(), '''ignores the wary looks that many of them give''', hisher(), 
            '''ragged, bloodstained clothing.'''],
        ['''Elise stops at a door at the back of the hall, and knocks. "Sister Samantha?"'''],
        ['''"Come in," says a voice.'''],
        ['''Elise pushes the door open, and gestures for''', name(), '''to enter. Once''', name(), '''enters, she follows the Taironan in and closes''',
            '''the door behind her.'''],
        ['''\mThe room is dominated by a large mahogany desk with a padded edge. A small bookshelf filled to bursting with books, manuscripts and notes sits against''',
            '''the back wall. Two large, armless wooden chairs sit in front of the desk. Hanging on the right wall is a paddle, a slipper, and a tawse. On the left wall is a switch, and a cane.'''],
        ['''Sister Samantha is sitting in a padded armchair behind the desk, studying some parchment, a small globe of light floating above her head.''',
        '''She looks up, and smiles. "Hey, Elise. Shouldn't you be-" Then she sees''', name() + ".", '''A pained expression crosses her''',
            '''face. "Oh. Hello. Please, sit down."'''],
        ['''Elise and''', name(), '''sit down''' + (universal.format_line([''', though''', name(), '''can't quite contain a wince as''', hisher(), 
        '''sore bottom comes in contact with the unforgiving wood.''']) if p.PC.numSpankings > 0 else '''.''')],
        ['''"This is about that patently stupid and inconsiderate thing I said this morning, isn't it?" says Sister Samantha, setting down the quill,''',
            '''and giving''', name(), '''an apologetic look.'''],
        ['''"Yes," says''', name() + ".", '''"Something about second hand tragedy."'''],
        ['''Like playing with fire?'''],
        ['''Sister Samantha sets down her quill, and leans forward, wincing a little as she does so. "I'm terribly sorry.''',
            '''I have no absolutely no idea how the plague and potion riots affected you, and suggesting otherwise was completely out of line."'''],
        ['''"No, no you don't," says''', name(), '''in a small voice.'''],
        ['''"Again, I'm sorry," says Sister Samantha. "I was too caught up in my own...experiences to give the sympathy I should have."''']])
ep1_elise_talk_with_Sister_Samantha.quip_function = ep1_elise_talk_with_Sister_Samantha_qf
ep1_elise_samantha_angry = Node(263)
ep1_elise_samantha_question = Node(264)
ep1_elise_talk_with_Sister_Samantha.children = [ep1_elise_samantha_angry, ep1_elise_samantha_question]

ep1_elise_samantha_angry.comment = universal.format_line(['''"Sympathy? That's all you can give me? You neanderthals shattered my family,''',
    '''and you're sorry you didn't give me the 'sympathy' you should have?"'''])

def ep1_elise_samantha_angry_qf():
    ep1_elise_samantha_angry.quip = universal.format_text([['"' + name() + '-"'],
    ['''"No, shut up Elise!" cries''', name() + ".", HeShe(), '''is on''', hisher(), '''feet, the room blurred with almost-shed tears. "You're a nice''',
        '''girl and all, but before the plague, my family was a powerful noble family, two loving parents, two children. We had freedom. Now, my dad''',
        '''is dead, the fortune gone, my sister's La Madre only knows where, and my mother's probably nothing more than a Madre-cursed whore!"''', 
        HeShe(), '''points an accusatory finger at Sister Samantha. "And it's all your fucking Church's fault!"'''],
    ['''"Child-" says Sister Samantha gently, standing and coming around the desk.'''],
    ['''"Don't touch me!" snarls''', name(), '''backing up a step, and inadvertently knocking over the chair. "I don't want your sympathy, or your''',
        '''understanding, I want the life you stole from me!"'''],
    ['''"I didn't steal your life," says Sister Samantha calmly. She reaches for''', name() + "."],
    ['''"Don't lie to me!" cries''', name() + ".", HeShe(), '''backs up a step,''', hisher(), '''weapon clenched in''', hisher(), '''fist. "I've heard''',
        '''all about it. All the skirmishes between Bonda and Avaricum, the constant bickering over territory, the shifting alliances to try''',
        '''to bring each other down. Your final, wretched plot to break our city."'''],
    ['"' + name(), '''put that down," cries Elise, jumping to her feet and putting the chair between herself and the Taironan.'''],
    ['''Sister Samantha flicks her wrist. A golden cord lashes out of her palm, wraps itself around the dagger and yanks it out of''', names(), 
        '''hand, flinging it against the wall.'''],
    [name(), '''clenches''', hisher(), '''fist, and it bursts into flame.'''],
    ['''Sister Samantha waves her hand again, and the room seems to ripple.''', name(), '''shakes''', hisher(), '''head, feeling a strange''',
        '''interference between''', himher(), '''and''', hisher(), '''magic. The flame vanishes. Samantha flicks her wrist a''',
        '''third time, and''', name(), '''is overcome by a debilitating weakness. The young''', manwoman(), '''stumbles, clutching at''', hisher(), 
        '''head.'''],
    ['''Sister Samantha steps forward, grabs''', names(), '''wrist in a firm grip.'''],
    ['''"Let go!" cries''', name() + ",", '''struggling against Sister Samantha's grip. "I don't want your comfort, I don't want your sympathy, I want''',
        '''my life!"'''],
    ['''Sister Samantha yanks the young''', manwoman(), '''into a tight embrace.'''],
    [name() + "'s", '''struggling intensifies. "Didn't you hear me? Let go!"'''],
    ['''Sister Samantha doesn't say anything, just tightens her hold, and begins to rock. She starts to hum. The tune is reminiscent of a lullaby''',
        names(), '''mother used to sing, though not exactly the same. Still, it's enough to make''', himher(), '''feel like a young child freshly''',
        '''woken from a nightmare, the warm, safe arms of''', hisher(), '''mother wrapped around''', himher() + ",", '''promising a warm, safe world''',
        '''free from pain or fear.'''],
    [name(), '''stops struggling. Slowly, hesitantly,''', hisher(), '''hands slip around Sister Samantha's waist.''', HeShe(), '''buries''', hisher(),
        '''face in the older woman's shoulder.'''],
    [name(), '''isn't sure how long the Elder Sister holds''', himher() + ",", '''but the woman never complains, or slows her rocking, or stops her''',
        '''light humming. Eventually,''', name(), '''pulls away on''', hisher(), '''own.'''],
    ['''Sister Samantha brushes a bit of hair from''', names(), '''face. "I want you to understand, child, we had no idea how addictive the Potions''',
        '''were. What we did was a terrible mistake, and if we had known what would happen, we never would have done it. But we can't undo it. All''',
        '''we can do is try to make things better. Try to help the people whose lives we inadvertently broke."'''],
    [name(), '''glances at Elise, who is giving''', himher(), '''a sympathetic look.''']]) 

ep1_elise_samantha_angry.quip_function = ep1_elise_samantha_angry_qf
ep1_elise_samantha_unsure = Node(265)
ep1_elise_samantha_moving_on = Node(266)
ep1_elise_samantha_angry.children = [ep1_elise_samantha_unsure, ep1_elise_samantha_moving_on]

ep1_elise_samantha_unsure.comment = '''"I guess so, I don't know."'''

def ep1_elise_samantha_unsure_qf():
    ep1_elise_samantha_unsure.quip = universal.format_text([['''Sister Samantha pats''', name(), '''on the shoulder. "Why don't you go home, and get some''',
        '''sleep? You'll feel better when you've gotten some rest."'''],
        ['''"Or, you could come out with Carrie and I," says Elise, grinning. "You look like you could use a bit of fun."'''],
        ['''"Yes," says Sister Samantha flatly, eyeing Elise's outfit. "Don't you think your dress is a little tight, young lady? Especially for someone''',
        '''getting married in a few months?"'''],
        ['''"Well, Roland had this made for me," says Elise, her eyes flicking to the paddle. "So I'm sure he won't mind."'''],
        ['''Sister Samantha rolls her eyes. "That man is spoiling you rotten. The soles of those slippers are hard-soled at least, yes?"'''],
        ['''"Yes," says Elise warily.'''],
        ['''"Good, because remember, you're a Sister now. Conduct unbecoming a Sister is a slippering offense," says Sister Samantha, giving Elise a''',
            '''stern look. "That includes singing a certain song about ladies and hay."'''],
        ['''Elise smiles innocently.'''],
        ['''"Why is it every time you smile like that, my hand starts to ache?" asks Sister Samantha.'''],
        ['''"Coincidence," says Elise. She grabs''', names(), '''arm and starts pulling''', himher(), '''out of the office. "Come on,''', name() + ".",
            '''Night won't stay young forever."'''],
        ['''Once the two are out of Sister Samantha's office, Elise sighs in relief. "I love that woman to pieces, but Mother's love, she can be''',
            '''scary."'''],
        ['''"How is it no one seemed to notice all the ruckus?" asks''', name() + ",", '''glancing at the various Brothers and Sisters still lounging''',
            '''about the orphanage mess hall.'''],
        ['''"A charm on Sister Samantha's office that soundproofs it," says Elise. "She believes that punishments should be kept''',
            '''private, except in particularly egregious circumstances. Anyway, do you want to join Carrie and I?"'''],
        [name(), '''considers, as the two reenter the Shrine.''']])
ep1_elise_samantha_unsure.quip_function = ep1_elise_samantha_unsure_qf
ep1_elise_samantha_unsure.children = [elise_dont_worry_yes, elise_dont_worry_no]

ep1_elise_samantha_moving_on.children = [elise_dont_worry_yes, elise_dont_worry_no]

ep1_elise_samantha_moving_on.comment = '''"Yeah. The whole thing was a mess wasn't it? Sorry for going a little crazy. I guess I'll go now."'''
def ep1_elise_samantha_moving_on_qf():
    ep1_elise_samantha_moving_on.quip = universal.format_text([['''"Do you want to talk about what happened?" asks Sister Samantha.'''],
        [name(), '''shakes''', hisher(), '''head.'''],
        ['''"Alright." Sister Samantha kisses''', name(), '''on the forehead. "If you ever want to talk about anything, please come see me."'''],
        [names(), '''eyes flick towards the implements on the wall.'''],
        ['''"Oh don't worry about those, they're only for naughty students," says Sister Samantha. Her eyes flick to Elise, and take in the other''',
            '''woman's tight dress. Her voice takes on a very dry tone. "And Younger Sisters. That dress is looking a little tight, Miss Elise. Especially''',
            '''for a woman whose getting married in a few months."'''],
        ['''"Oh come on Sister," says Elise, laughing uneasily. Her eyes flick between Sister Samantha and the paddle. "Roland got me this."'''],
        ['''Sister Samantha rolls her eyes. "That boy is spoiling you rotten."'''],
        ['''Elise just grins."'''],
        ['''Sister Samantha's eyes flick down to Elise's slippers. "Hard-soled slippers?"'''],
        ['''"Yes," says Elise, looking confused.'''],
        ['''Sister Samantha grunts. "Perhaps he's not spoiling you too badly."'''],
        ['''Elise blinks in confusion. Then comprehension dawns, and she blushes. She starts nervously fiddling with her bun. "I'm sure that won't''',
            '''be necessary."'''],
        ['''"Hopefully not," says Sister Samantha. "Just remember, you're a Sister now, and conduct unbecoming a Sister is a slippering offense. That''',
        '''includes singing songs like 'Lady in the Hay.'"'''],
        ['''"Thanks for the warning, come on''', name() + ",", '''we've got to go now, bye!" Elise grabs''', names(), '''arm and all but drags''',
            himher(), '''out of the office.'''],
        ['''Elise doesn't slow down until they are halfway back to the Shrine. Then, she takes a deep breath. "Oh boy. Don't get me wrong, that woman''',
        '''is the closest thing I have to a mother, so I love her to death, and I don't know where I'd be without her. Mother's love, it's thanks to her that I was able''',
        '''to become a Sister in the first place. Thing is, mothers are scary. Even surrogate mothers. Especially surrogate mothers."'''],
        ['''"Tell me about it," says''', name() + ",", '''memories of some of''', hisher(), '''more terrifying encounters with Nana coming to mind.'''],
        ['''"Anyway," says Elise as the two return to the Shrine. "Are you going to join me and Carrie?"''']])
ep1_elise_samantha_moving_on.quip_function = ep1_elise_samantha_moving_on_qf
ep1_elise_samantha_moving_on.children = [elise_dont_worry_yes, elise_dont_worry_no]
            

ep1_elise_samantha_question.comment = '''"I just want to know, did you know how addictive the Potions were before you used them? What happens to''',
'''addicts who try to stop?"'''

def ep1_elise_samantha_question_qf():
    ep1_elise_samantha_question.quip = universal.format_text([['''Sister Samantha looks''', name(), '''in the eye. "If you ever believe anything a Matirian''',
        '''Brother or Sister tells you, please believe this: we had no idea. We never even considered the possibility that the Potions would be''',
        '''addictive, let alone this addictive. I can't begin to tell you wracked with guilt we've all been, or how hard we've been working to both''',
        '''make things better, and make Potions save to use." Sister Samantha kisses''', name(), '''on the forehead. "We just want to help people.''',
        '''That's all. Let the kings, queens and nobles have their petty politics. We just want to help people."'''],
        [name(), '''nods. "That's good to know."'''],
        ['''"Great, so if all the drama's over, what do you say you join me and Carrie for a night on the town?" says Elise gleefully.'''],
        ['''"I figured you were planning on going out," says Sister Samantha, her eyes flicking over Elise's dress. "Though isn't your dress a little''',
            '''tight young lady? Aren't you getting married in a few months?"'''],
        ['''"Don't worry," says Elise laughing nervously, her eyes flicking to the paddle on the wall. "Roland ordered this for me himself."'''],
        ['''"I see." Sister Samantha's eyes flick down to Elise's slippers. "Hard-soled slippers?"'''],
        ['''"Umm, yes?" says Elise, tapping her fingertips together nervously.'''],
        ['''Sister Samantha smiles slightly. "Perhaps he's a good boy after all. Remember young lady, you're a Sister now, and conduct unbecoming''',
            '''a Sister is a slippering offense."'''],
        ['''Elise's nervous smile turns sickly.'''],
        ['''"That includes singing 'Lady in the Hay.'"'''],
        ['''"Oh,well it's a good thing I'm not planning on singing that, come on''', name(), '''we don't want to waste any time, I'm sure Carrie's''',
            '''waiting for us, have a nice night Sister, bye!" Elise grabs''', names(), '''arm and drags''', himher(), '''out of Sister Samantha's''',
            '''room. She scurries down the corridor, and doesn't slow down until they're halfway back to the Shrine.'''],
        ['''"I take it you've had close encounters with Sister Samantha's implements before," says''', name(), '''wryly.'''],
        ['''"Well, yeah, a few," says Elise. "Mostly the paddle. Tawse once. Maybe twice. Well, three times, but that last one doesn't really count. Never got''',
            '''the cane, but saw Carrie get the switch. So, you going to join us? It'll be fun. And since you're not a Sister or a student, you''',
            '''don't have to worry about Sister Samantha paddling you."''']])

ep1_elise_samantha_question.quip_function = ep1_elise_samantha_question_qf
ep1_elise_samantha_question.children = [elise_dont_worry_yes, elise_dont_worry_no]

def carrie_arrival():
    quip = universal.format_text([['''\m"Brace yourselves boys and girls, Carrie has arrived!" declares a singsong voice from the left end of''',
        '''the Shrine.''', name(), '''turns to look at the new arrival.'''],
        ['''Standing with one hand on her right-cocked hip, her back straight and her chest pushed out is a blonde woman about''',
        '''Elise's age. She twirls in place, her brown eyes flashing as she smiles. "What do you think, Elise?"'''],
        ['''She is a little bit taller and slimmer than Elise, and her breasts are ''',
        '''larger. Her hips are not quite as rounded as Elise's (though they're close). Her bum is also only a little bit smaller than Elise's, but''',
        '''manages to achieve the same sexy balance between being firm and wobbly. She is''',
        '''wearing a ''',
        '''low-cut, tight, rich purple dress that extends to about halfway down her thighs. The dress shows off her medium-sized breasts, draws attention to her''',
        '''long legs, and hugs the curves of her hips. Her legs are sheathed in a pair of black wool tights. She is wearing her shoulder-length blonde''',
        '''hair down, with the tips curled. On her feet are a pair''',
        '''of black wool slippers.'''],
        ['''"Lovely as always," says Elise, smiling. "Though if some of the more conservative Sisters caught you wearing that, your evening would take''',
            '''a sharp turn for the unpleasant."'''],
        ['''Carrie's grin turns mischievous. "And they haven't even seen what I'm wearing under this, yet." Then, she turns her attention to''', name() + 
            "."]])
    if p.PC.is_male():
        quip = universal.format_text([quip, ['''The woman's smile widens. She approaches''', name(), 
            '''and offers her hand to be shaken. "Hi. Elise mentioned you. I'm Carrie."''']])
    elif p.PC.is_female():
        quip = universal.format_text([quip, ['''"Elise mentioned you. I'm Carrie, pleasure to meet you," says Carrie. She approaches the Taironan, and holds out a hand.'''],
            ['"' + name() + ',"', '''says''', name() + ",", '''taking the hand and giving it a firm shake.'''],
            ['''"I'd give you a hug," says Carrie, eyeing''', names(), '''bloodstained, battle-damaged clothing. "But not until we get you out of that ratty''',
                '''clothing. Seriously, I'm half-tempted to spank you for even thinking of going out like that."'''],
            [name(), '''huffs indignantly. "My clothing is not ratty."'''],
            ['''"Fine," says Carrie. "Ripped to shreds. Looks like you fought a cursed army''' + 
                (''', and that's before we even get start asking what happened to your pants."''' if not wearing_skirt_or_dress_or_pants() else '''."''')],
            ['''"To be fair, I kind of did," says''', name() + ".", HeShe(), '''glances down at''', hisher(), '''bloody, battle damaged clothing.'''],
            ['''"Don't worry," says Carrie, taking''', names(), '''arm and leading''', himher(), '''into the back of the building. "Elise and I will get''',
                '''you fixed up right quick. Right, Elise?"'''],
            ['''Elise nods, and takes''', names(), '''other arm. "Yup. We'll have you cleaned up and ready to hit the dancing scene in no time."'''],
            ['''The two half pull, half drag''', name(), '''into a large, steamy room containing several baths. Each is sunk into the ground so that the''',
            '''lip''',
                '''of the tub is level with the floor.''', names(), '''eyes nearly bug out of''',
                hisher(), '''head. Back in Chengue, everyone bathed in the public baths. Private baths were never even-'''],
            ['''With a flurry of activity, Carrie starts pulling off''', names(), '''clothing.'''],
            ['''"Hey-"'''],
            ['''"Oh hush, I want to go before it gets too late," says Carrie.'''],
            ['''"Carrie-" begins Elise.'''],
            ['''"Oh, you hush too," says Carrie.'''],
            ['''"Carrie," says Elise more sternly, but at this point, Carrie has finished stripping''', name() + "."],
            ['''"Just don't throw anything out," says''', name(), '''with a touch of desperation. "I can't afford more."'''],
            ['''Carrie tosses the clothing into the corner, then sticks her hand into the tub.''', name(), '''notices''',
                '''a brief flare in the water, and watches as steam begins to rise.'''],
            ['''"Carrie, don't you ignore me," says Elise, her hands on her hips.'''],
            ['''Carrie shoves''', name(), '''into the warmed tub.'''],
            [name(), '''yelps, and comes up sputtering. "Hey!"'''],
            ['''"Oh hush, you're enjoying the bath and you know it," says Carrie. She grabs Elise and starts to drag her out. "Come on, Elise let's find us''',
                '''something for her to wear. She's about my size and body type, so we'll raid my wardrobe."'''],
            ['''"Carrie!" says Elise sharply.'''], 
            ['''But then the two are gone.'''],
            [name(), '''bobs in the water, the room suddenly silent save the faint slap of water lapping against the edge of the tub.''', HeShe(),
                '''leans back in the water, and closes''', hisher(), '''eyes. It does feel nice, but''', heshe(), '''is kind of miffed at being''',
                '''stripped and tossed in the tub without so much as an 'if I may.' A wicked grin suddenly spreads across''', names(), '''face.''',
                '''Some kind of payback may be in order.''']])
    return quip

ep1_elise_kiss_hand = Node(257)
ep1_elise_kiss_hand.comment = '''Kiss Carrie's hand.'''
def ep1_elise_kiss_hand_qf():
    ep1_elise_kiss_hand.quip = universal.format_text([['''"A pleasure to meet you," says''', name() + ",", '''taking Carrie's hand, going into a sweeping bow,''',
        '''and kissing it.'''],
        ['''Carrie blushes. "Ooh. Quite the gentlemen. I like. ''' + (universal.format_text([['''Though the effect is kind of ruined by your lack of pants."'''],
            ['''"Erm, yes, well," says''', name(), '''glancing down at his less than dressed state. "I suppose pants may be useful, wouldn't they?"\n\n "Maybe a little," says Carrie, smiling. ''']]) 
        if not wearing_pants() else universal.format_text([['''Though the effect is ruined by your tattered, bloodstained clothing."'''],
        ['''"Bah. The blood and rags just make me all the more manly," says''', name() + ",", '''puffing out his chest.'''],
        ['''"Yeah, if by manly you mean dirty and kind of disgusting," says Carrie dryly. ''']])) + 
        '''"Fortunately, we have baths for you to bathe in, and I'm sure we can borrow some clothing from one of the Brothers. Like Brother Dan."'''],
        ep1_elise_carrie_banter(ep1_elise_kiss_hand)])
    ep1_elise_kiss_hand.children = [ep1_elise_carrie_come_in, ep1_elise_carrie_thanks]
ep1_elise_kiss_hand.quip_function = ep1_elise_kiss_hand_qf

ep1_elise_shake = Node(258)
ep1_elise_shake.comment = '''Shake Carrie's hand.'''
def ep1_elise_shake_qf():
    ep1_elise_shake.quip = universal.format_text([[name(), '''takes Carrie's hand and gives it a firm shake.'''],
        ['''Carrie pouts prettily. "Oh come on, you're supposed to go into a deep, sweeping bow and kiss my hand. What kind of gentleman are you?"'''],
        ['''"Who said anything about me being a gentleman?" asks''', name() + ",", '''grinning. "Have you seen the blood splatter? I'm a barbarian''',
            '''through and through."'''],
        ['''"Well, fortunately there are plenty of Brothers around. I'm sure we could borrow an outfit for you from one of them," says Carrie, tapping''',
            '''her lip thoughtfully. "Like Brother Dan."''']])
    ep1_elise_shake.quip = universal.format_text([ep1_elise_shake.quip, ep1_elise_carrie_banter(ep1_elise_shake)])
    ep1_elise_shake.children = [ep1_elise_carrie_come_in, ep1_elise_carrie_thanks]
ep1_elise_shake.quip_function = ep1_elise_shake_qf

def ep1_elise_carrie_banter(node):
    node.music = [CARLITA, CARRIE]
    return universal.format_text([
        ['''Elise narrows her eyes. "Carrie, Dan's out of town right now."'''],
        ['''"Exactly," says Carrie, her mischievous grin lighting up her face.'''],
        ['''Elise smacks Carrie's bum. "You are not stealing one of Dan's outfits."'''],
        ['''Carrie jumps, and her hands snap back to cover her bottom. "Oh, come on. He'll never notice."'''],
        ['''"Why is it that every time you say that, my bottom starts to ache?" asks Elise, putting her hands on her hips.'''],
        ['''"Because you're a pessimist," grumbles Carrie, rubbing the sting from her tush.'''],
        ['''"Actually, it's called pattern recognition. Now, here's what's going to happen. We are going to lead''', name(), 
            '''to the bathes, and then find a Brother who is roughly the right size, and ask if we can borrow an outfit."'''],
        ['''"I know, how about you go find an outfit, while I lead''', name(), '''to the bathing house?" says Carrie.'''],
        ['''"No," says Elise. "I don't trust you alone with him."'''],
        ['''"You know, I really-" begins''', name() + "."],
        ['''"Hush you," says Elise. She gives Carrie a wary look. Carrie, meanwhile, has crossed her arms and started sulking.'''],
        ['''"This is ridiculous," says Carrie. "You think that just because I don't spend four years building an 'emotionally fulfilling''',
        '''relationship' before I start the festival, I jump on every breathing male I meet."'''],
        ['''"Oh please." Elise rolls her eyes. "You've got the exact same look on your face you had two summers ago, remember?"'''],
        ['''"Oh come on, are you still going on about that?" says Carrie. "I was drunk, you can't hold me accountable for that."'''],
        ['''"Look I just don't want Sister Samantha to publicly strap you again," says Elise. "Especially since she'd probably strap me now too, for''',
            '''not 'asserting my authority' or some garbage."'''],
        ['''"See, I still don't believe you," says Carrie, putting her hands on her hips. "I'm pretty sure I'd remember getting strapped in public, no matter how drunk I was."'''],
        ['''Elise growls, and her hands turn claw-like. "Stop whining, and let's show''', name(), '''to the baths, before I spank you from now 'til Triday."'''],
        ['''"Yes Sister," says Carrie, sticking her tongue out at Elise, and walking towards the back of the Shrine, her hips swaying.'''],
        ['''Elise shakes her head. "Love that girl to death. Gonna spank her skin off one of these days. Come on."'''],
        ['''The two lead''', name(), '''into the back of the building. They wander through a few corridors, and stop at a door. "The other side has a few tubs for the Brothers. Do you know how to magically heat water?"'''],
        [name(), '''nods.'''],
        ['''"Well, feel free to do so," says Elise, pushing the door open.'''],
        ['''"Hmm, a bath," says''', name() + ",", '''slipping in.'''],
        ['''Thirty seconds and a bit of magic later, he's naked and soaking in the water, enjoying the warm, soothing, luxurious pressure of''',
            '''water against skin. His ragged clothing is soaking in one of the other tubs, and he tried desperately not to think of all the patching''',
            '''he's going to have to do. Someone really needs to invent magical self-mending clothing.'''],
        ['''\m"No, please I told you everything. Please you have to believe me, don't take me there, don't let them in my head. Please!"'''],
        [name(), '''jerks up in the tub, his reverie broken. Images of the first girl he fought flash through his mind. What is that girl going''',
        '''through right now? Probably sitting in chains in some dark,''',
            '''dirty, cold, cell, clad in nothing but rags (if she's lucky), waiting for a puppeteer to-'''],
        [universal.format_line([name(), '''is floating in an empty abyss. "You and I are the greatest of friends-"''']) if 'charmed_by_Deidre' in keywords() else
            universal.format_line([name(), '''shakes his head. He half-wades, half-swims over to the edge of the tub, and grabs a nearby bar of soap. No. Don't''',
                '''think about it. He can't think about it. He begins cleaning himself with the soap. There's nothing he can do about it, and thinking about it would just ruin his evening. He throws the soap across the room and curses violently. Yeah, Madre forbid his wonderful''',
                '''evening dancing, drinking and flirting is ruined because that girl is being tortured!'''])],
        ['''\mThen, he is distracted by the sound of voices wafting in from the bathhouse door.'''],
        ['''"Aww, come on. How am I supposed to give him his outfit if I don't open the door?"'''],
        ['''"How would you feel if a guy you'd only just met stuck his head in the bathing room while you were naked?"'''],
        ['''"...Fine. You win this round Sister Prude."'''],
        ['''There is a knock at the door. "Hey,''', name(), '''I've got an outfit for you. Mind if I crack the door open and slip it in?"''']])

ep1_elise_carrie_come_in = Node(259)
ep1_elise_carrie_come_in.comment = '''"You know, you can just come in. I've been bathing in public baths since I was a year old."'''
def ep1_elise_carrie_come_in_qf():
    ep1_elise_carrie_come_in.quip = universal.format_text([['''"See? I told you he wouldn't care."'''],
        ['''There's a frustrated growl. "Just open the door a crack, and slip the clothing in."'''],
        ['''"Fine. Jerk."'''],
        ['''The sharp slap of hand to bottom rings through the air.'''],
        ['''"Oww! Hey!"'''],
        ['''"Show Sisters some respect."'''],
        ['''"You became a Sister two weeks ago!"'''],
        ['''There's another smack.'''],
        ['''"Gah, fine, fine."'''],
        ['''The door opens a crack, and a black shirt and black trousers made of fine wool are pushed into the room, before the door closes''',
            '''again.'''], ep1_night_on_the_town(ep1_elise_carrie_come_in)])
ep1_elise_carrie_come_in.quip_function = ep1_elise_carrie_come_in_qf
    
ep1_elise_carrie_thanks = Node(267)
ep1_elise_carrie_thanks.comment = '''"Thanks a lot. I'll be out in a few minutes."'''
def ep1_elise_carrie_thanks_qf():
    ep1_elise_carrie_thanks.quip = universal.format_text([['''"See? I told you."'''],
        ['''"Oh shut up."'''],
        ['''The sharp slap of hand to bottom rings through the air.'''],
        ['''"Oww! Hey!"'''],
        ['''"Show Sisters some respect."'''],
        ['''"You became a Sister two weeks ago!"'''],
        ['''There's another smack.'''],
        ['''"Gah, fine, fine."'''],
        ['''The door opens a crack, and a black shirt and black trousers made of fine wool are pushed into the room, along with a pair of black boots,''',
        '''before the door to closes again.'''], ep1_night_on_the_town(ep1_elise_carrie_thanks)])
ep1_elise_carrie_thanks.quip_function = ep1_elise_carrie_thanks_qf

def ep1_night_on_the_town(node):
    node.children = [ep1_elise_little_tight, ep1_elise_fits_perfect]
    return universal.format_text([[name(), '''gets out of the tub, and dries off using one of the nearby towels. Then,''', heshe(), '''slips into the trousers''',
        '''and shirt. The outfit's a bit snug, especially around the posterior region, for totally innocent reasons''', name(), '''is sure.'''],
        ['''"Can we come in yet?" asks Carrie through the door. "I want to see the results of my amazingness!"'''],
        ['''"Your amazingness? Don't you mean our amazingness?"'''],
        ['''"Oh come on. You just stood there tut-tutting and whining about how this was clearly too tight, and that was obviously too small,''',
            '''and I should stop trying to dress him like a street-walker, even though no one's ever heard of a male street-walker-"'''],
        ['''"Oh bull. Male walkers exist."'''],
        ['''"And how would you know that?"'''],
        ['''There's a sharp smack of hand to bottom.'''],
        ['''"Oww! What was that for?"'''],
        ['''"For suggesting that a Sister of the Matirian Church visits prostitutes."'''],
        ['''"I suggested no such thing! It was an innocent question."'''],
        ['''"Not according to your voice tone."'''],
        [name(), '''pulls open the door. "Hey ladies."'''],
        ['''Carrie's eyes light up, and she claps her hands together gleefully. "Oh, it's gorgeous! Mother's mercy, I am a dress-up genius."'''],
        ['''Elise's lips draw together into a thin line. She focuses her attention on''', name() + ".", '''"So, what do you think?"''']])

ep1_elise_little_tight = Node(278)
ep1_elise_little_tight.comment = '''"Well, it is a little bit tight. Feels like my pants'll split if I make any sudden movements."'''
def ep1_elise_little_tight_qf():
    ep1_elise_little_tight.quip = universal.format_text([['''"I see," says Carrie grimly, tapping her finger against her lower lip. "Well, there's only one way''',
        '''to be certain. Turn around and bend over."'''],
        ['''Elise smacks Carrie's bum.'''],
        ['''Carrie yelps, and hops, her hand flying back to her bum. She glares at Elise. "Would you stop that?"'''],
        ['''"Then stop harassing the poor boy," says Elise, putting her hands on her hips.'''],
        ['''"Oh, it's all in good fun," says Carrie. She flashes''', name(), '''a bright smile. "You don't mind, do you?"''']])
ep1_elise_little_tight.quip_function = ep1_elise_little_tight_qf

ep1_elise_bothered = Node(280)
ep1_elise_not_bothered = Node(281)
ep1_elise_little_tight.children = [ep1_elise_bothered, ep1_elise_not_bothered]
ep1_elise_bothered.comment = '''"Actually, it is making me a little uncomfortable."'''
def ep1_elise_bothered_qf():
    add_keyword('bothered_by_Carries_flirting')
    ep1_elise_bothered.quip = universal.format_text([['''"Oh," says Carrie, her smile vanishing. "I'm sorry. I didn't mean to... I mean, I know''',
        '''what's it like for someone's advances to make you uncomfortable, and I would have stopped sooner if I'd known."'''],
        ['''"It was really only that last comment that made me uncomfortable," says''', name() + ".", '''"I don't mind a little flirting, just don't''',
            '''take it too far, alright?"'''],
        ['''"OK," says Carrie, her smile returning to its full brilliance. Then she gives him a sultry wink. "Maybe later you could-"'''],
        ['''Elise smacks Carrie's bottom.'''],
        ['''"Oh for the love of all this holy!" cries Carrie, hopping up and down, clutching at her bottom. "Would you please stop doing that! You didn't''',
            '''even let me finish."'''],
        ['''"That's because I knew what you were going to say," says Elise. "If you don't want me smacking your bum, stop saying inappropriate things."'''],
        ['''Carrie rubs her bottom and scowls at Elise.'''],
        ['''"And don't give me that look, or I'll really give you something to scowl about," says Elise, matching the stare glare for glare.'''],
        ['''"Ladies, perhaps we should just get going?" says''', name() + ".", '''"I'm sure none of us want to start the evening with a fight over what''',
            '''is and isn't appropriate."'''],
        ['''"Fine," says Carrie. "Let's go."'''],
        ep1_tavern_scene(ep1_elise_bothered)])
ep1_elise_bothered.quip_function = ep1_elise_bothered_qf

ep1_elise_not_bothered.comment = universal.format_line(['''"Not at all. In fact, I'm touched by how concerned you are for my pride. And I was thinking, your''',
    '''dress is looking kind of tight as well. So, after you're done checking my clothing's integrity, I'm thinking I should check yours."'''])
def ep1_elise_not_bothered_qf():
    ep1_elise_not_bothered.quip = universal.format_text([['''Elise throws her arms in the air, and unleashes a howl of frustration. Then, she snaps both hands down, and''',
        '''gives both''', name(), '''and Carrie a sharp, simultaneous spank. "I swear in the Mother's name I will spank you both!"'''],
        ['''"Oh, don't mind Elise. She's just jealous, because she's engaged," says Carrie.'''],
        ['''Elise rolls her eyes. "Let's go have some fun, alright?"'''],
        ['''"What you mean the fun hasn't already started?" says Carrie, throwing''', name(), '''another sultry smile.'''],
        ['''Elise smacks her again. "No. The fun hasn't started. Now, let's go."'''],
        ['''Carrie's smile morphs into a sultry pout. "See how mean Elise is to me? I'm thinking I should get better friends."'''],
        ['''"Clearly," says''', name() + "."],
        ['''Elise gives them both another smack.'''],
        ['''"Anyway," says''', name() + ",", '''his bottom starting to sting. "Let's get going, yes? Before Elise gets any more spank-happy."'''],
        ['''"I agree," says Carrie, giving her bottom a sultry rub. "Let's go."'''],
        ['''With that, the three companions leave the Church.'''],
        ep1_tavern_scene(ep1_elise_not_bothered)])
ep1_elise_not_bothered.quip_function = ep1_elise_not_bothered_qf


ep1_elise_fits_perfect = Node(279)
ep1_elise_fits_perfect.comment = '''"I think it looks great. Let's get out there and have some fun."'''
def ep1_elise_fits_perfect_qf():
    ep1_elise_fits_perfect.quip = universal.format_text([['''Carrie smirks at Elise. "See? I told you he'd like it. Not everyone is as boring as you."'''],
        ['''Elise rolls her eyes. "Fine, fine you win. Now, let's go and have some fun."'''],
        ep1_tavern_scene(ep1_elise_fits_perfect)])
ep1_elise_fits_perfect.quip_function = ep1_elise_fits_perfect_qf

ep1_elise_prank = Node(268)
ep1_elise_prank.comment = '''Trip Carrie into the tub.'''
def ep1_elise_prank_qf():
    ep1_elise_prank.quip = universal.format_text([['''Well, if Carrie tossed her in without any warning, it's only fair that she gets a taste of her own''',
    '''medicine.''', name(), '''grins evilly, slips out of the tub, slinks over to stand next to the door, and waits.'''],
    ['''And waits.'''],
    ['''And waits.'''],
    ['''And keeps waiting.'''],
    [name(), '''shivers and wraps her arms around herself. Madre's love, how long does it take to pick out an outfit?'''],
    ['''Then,''', name(), '''glances at the luxurious mini-bathhouse, considers the finely made dresses the two are wearing, and considers how much''',
        '''Carrie appears to enjoy going out.'''],
    ['''Right. Stupid question.'''],
    ['''Finally, the door opens, and Carrie and Elise enter. Carrie appears to be walking a bit funny.'''],
    ['''"Sorry we took-" Carrie stops. "Where's-"'''],
    ['''"Hah!"''', name(), '''jumps out from behind the door, and pushes Carrie into the tub.'''],
    ['''Carrie yelps, and tumbles head first into the water, the dress she's carrying tumbling in with her.'''],
    ['''"How do you like it?" asks''', name() + "."],
    ['''Elise stares at''', name(), '''with wide eyes, then looks at Carrie, only just now surfacing. "Oh no..."'''],
    ['''"You stupid bitch!" cries Carrie, wading towards the edge of the tub. "What the hell is wrong with you? Now, my dress is completely ruined! Give me one reason why I shouldn't drag you over here''',
        '''and blister your wet ass!"''']])
ep1_elise_prank.quip_function = ep1_elise_prank_qf

ep1_elise_prank_sorry = Node(270)
ep1_elise_prank_sorry.comment = universal.format_line(['''"Hey, wow, look I'm sorry. I was just annoyed at you throwing me in the tub like that, and I wanted''',
    '''to get some payback."'''])
def ep1_elise_prank_sorry_qf():
    ep1_elise_prank_sorry.quip = universal.format_text([['''"Well, you could have taken off my dress first!" says Carrie. "Do you have any idea how long it took''',
        '''me to make this thing? I don't have a rich boyfriend, like Elise. If I want a new dress, I have to buy the fabric, and make it myself! It''',
        '''takes me years to make even one dress!"'''],
        ['''"But you love making dresses-" says Elise.'''],
        ['''"Doesn't mean I want them damaged," snaps Carrie.'''],
        ['''"Oh come on, the water hardly damages-" begins Elise.'''],
        ['''"Are you kidding? This is wool!" cries Carrie, throwing her arms in the air, and splashing water all over the place. "I'll be lucky if it''',
        '''only shrinks three sizes! This dress took me two years to make, and now she's ruined it in less than a second! This was my first time''',
        '''wearing it too, and now all that work is wasted, and I really wanted to celebrate your ascension, and I've been making this dress for''',
        '''exactly that, and-"'''],
        ['''"Carrie, calm down. I'm sure''', name(), '''didn't intend-"'''],
        ['''"No." Carrie points her finger at''', name() + ".", '''"If you are really sorry, you're going to get your ass over here, bend over the''',
            '''edge of the tub, and take a good hard spanking!"'''],
        ['''"Carrie-" says Elise.'''],
        ['''"No! No!" snaps Carrie. "You spanked me for tossing her in the tub, and I didn't ruin years of hard work doing it. She's getting a spanking''',
            '''whether she likes it or not."''']])
ep1_elise_prank_sorry.quip_function = ep1_elise_prank_sorry_qf
ep1_elise_prank_sorry_spank = Node(272)
ep1_elise_prank_sorry_no_spank = Node(273)
ep1_elise_prank_sorry.children = [ep1_elise_prank_sorry_spank, ep1_elise_prank_sorry_no_spank]

ep1_elise_prank_sorry_spank.comment = '''Bend over the edge of the tub.'''
def ep1_elise_prank_sorry_spank_qf():
    add_keyword('Samantha_saw_Carries_dress')
    ep1_elise_prank_sorry_spank.quip = universal.format_text([[name(), '''hangs her head, and approaches the tub. She awkwardly clambers into the water, then''',
        '''turns and hoists herself up onto the lip of the tub. She bends over the lip, her bare breasts and flat stomach pressing against the cold''',
        '''stone floor, the warm water swishing against her thighs. She can hear Carrie approaching. Suddenly, a few handfuls''',
        '''of water cascade across her naked bottom.'''],
       ['''"Hey, what are you doing?" yelps''', name() + ",", '''looking over her shoulder at Carrie, and squirming uncomfortably.'''],
       ['''"Your bum was looking a little dry," says Carrie grimly. She loops her left arm around''', names(), '''lower back. "And I really want these''',
           '''to sting."'''],
       ['''"But-oww!"''', name(), '''cries out, as Carrie's damp hand cracks against''', hisher(), '''wet bottom, the water almost tripling the sting.'''],
       ['''"Mother's mercy, you've got a hard bottom," says Carrie, as she begins beating out a rapid tattoo on''', names(), '''bouncing bum cheeks.''',
           '''"Wonder if Sister Samantha would let me use her paddle."'''],
       ['''"No, no paddle please," cries''', name() + ",", '''rocking her hips beneath Carrie's stinging slaps. "Your hand hurts enough!"'''],
       ['''"Good." Carrie lands a particularly sharp blow to the crease where bum meets thigh, just above the water line.''', name(), '''shrieks.''',
           '''"Maybe you'll learn a lesson, then."'''],
       ['''Carrie smacks''', names(), '''bottom for the next five minutes. The bathhouse is filled with the sharp smack of hand to wet, naked flesh,''',
           '''the splashing of water as''',  name(), '''kicks''', hisher(), '''legs, and''', names(), '''pained cries.''', '''Elise watches,''',
           '''nervously gnawing on her lower lip, her fists twisted in her dress.'''],
       ['''"Aw come on-aggh!-Don't you think I've-oww!-had enough?" whines''', name() + ",", '''miserably rocking her hips in a vain effort to shake''',
           '''away the sting of Carrie's last smack.'''],
       ['''"Hah!" says Carrie, landing three quick, sharp slaps to''', names(), '''right sitspot. "Better get comfortable girl. You're not going''',
       '''anywhere anytime soon."'''],
       [name(), '''groans and buries her face in her arm, only for her head to shoot up again with a squeal escaping her lips, as Carrie gives her''',
           '''six hard, fast slaps, three to each cheek.'''],
       ['''Before Carrie can continue however, the door opens, and in steps''', '''Sister Samantha''' if 'met_Samantha' in keywords() else 
           universal.format_line(['''a middle-aged woman in the dark red robes of a Sister of the Spectral Persuasion.''',
            '''Her skin is similar in tone to Elise's. She is of average height, but carries herself with a level of''',
            '''confidence and conviction that makes her appear taller. Crows feet spread out from her blue eyes. Her light brown hair is pulled back into a single long braid that extends about halfway down her back.'''])],
        ['''"Sister Samantha," squeaks Carrie. "Hi."'''],
        ['''"I could hear this ruckus from all the way in my office," says Sister Samantha, her stern gaze washing over the three young women. "Care to''',
            '''tell me what's going on?"'''],
        ['''Carrie gives''', names(), '''bottom a sharp slap. "This jerk didn't take kindly to being bathed, so she shoved me in the tub. While I was''',
            '''wearing a wool dress that took me years to make!"'''],
        ['''"Bull! I shoved you in the tub, because you stripped and tossed me in with neither warning nor permission," snaps''', name() + "."],
        ['''"Well, what did you think was going to happen when we led you into a bathing room?" says Carrie.'''],
        ['''"Enough." Sister Samantha's voice cuts through the squabbling like a hot knife. She turns her gaze on Elise, who''',
            '''visibly shrinks. "And you lost complete control of the situation, as usual."'''],
        ['''Elise anxiously twists her dress. "Yes'm."'''],
        ['''Sister Samantha sighs. "I swear, you two will be the death of me. Carrie, get out, so I can dry off your dress before it gets damaged."'''],
        ['''Carrie's eyes widen. "But the last time I used that spell-"'''],
        ['''"I've been doing this longer than you've been alive," says Sister Samantha. "I can handle drying off a dress without ripping it to shreds.''',
            '''Now, do you want to salvage the dress or not?"'''],
        ['''Carrie nods. She grabs the outfit that had fallen in the tub with her, and clambers out , while''', name(), '''slides off the lip, and sinks deeper into the warm water.'''],
        ['''Sister Samantha holds up her hand, and gently sweeps it down. A thin field of spectral magic flows from her fingertips and cascades across''',
            '''Carrie's body. The young woman shivers, but stands still, as the magical sieve draws out the water in Carrie's hair, dress, tights and''',
            '''slippers. The sieve then floats to the air above the tub, and releases the water, causing''', name(), '''to sputter, as the sudden''',
            '''deluge slaps against her face.'''],
        ['''Carrie looks down at her dress, now bone dry, and smiles in relief. "Oh, thank you Sister."'''],
        ['''"Yes, and I don't suppose it's already shrunk, has it," says Sister Samantha, approaching the student, and tugging at the hem of Carrie's''',
        '''dress.'''],
        ['''"No ma'am," says Carrie in a small voice.'''],
        ['''"Right. March back to your room, and change into something appropriate," says Sister Samantha, pointing towards the door. "Now."'''],
        ['''"But Sister, it took me years to make this," cries Carrie, wrapping her arms around her body.'''],
        ['''"Child, why did you spend years making something you knew I wouldn't let you wear?" asks Sister Samantha, putting her hands on her''',
            '''hips.'''],
        ['''"Because, this was all the fabric I could afford," says Carrie.'''],
        ['''"Then why did you purchase it?"'''],
        ['''"Because it was such a lovely shade of purple, that''',
            '''would go great with these tights I have, and I wanted something really nice to celebrate our ascensions, but even buying this much''',
            '''put me in debt that I only just now paid off, and I've been working really hard on it for years, and looking forward to tonight so''',
            '''much. Please, let me wear it at least once," says Carrie, folding her fingers together in a prayer posture.'''],
        ['''"If you couldn't afford enough for a proper dress, then why didn't you come to me?" asks Sister Samantha. "I would have happily given you''',
            '''enough to purchase more fabric as a very early ascension gift."'''],
        ['''Carrie hangs her head. "I dunno. I was afraid you wouldn't approve."'''],
        ['''"You silly girl," says Sister Samantha, stepping forward, and lightly swatting Carrie's bum. "I love the dresses you make, I know''',
            '''how important they are to you, and that is a lovely shade on you. Why would I ever disapprove?"'''],
        ['''"I dunno," mutters Carrie, staring down at her shoes.'''],
        ['''Sister Samantha sighs. "If the other Sisters find out about this, I won't sit for a week."'''],
        ['''Carrie looks up at Sister Samantha hopefully.'''],
        ['''"You may wear that dress in public twice, and only twice," says Sister Samantha, holding up two fingers. "Once, tonight, when celebrating''',
            '''Elise's ascension, and once to celebrate you own."'''],
        ['''"Oh, thank you Sister," says Carrie gleefully, wrapping Sister Samantha in a hug.'''],
        ['''"Don't hug me until you've heard me out," says Sister Samantha sternly. "I will let you wear that, but first you are going to take a dozen''',
            '''strokes with the hairbrush for not coming to me in the first place, and instead being foolish enough to make a dress that you and I both''',
            '''know I should never allow."'''],
        ['''"Yes ma'am," says Carrie, her smile deflating a little.'''],
        ['''"Good, now how much time did you spend spanking your friend before I walked in?" asks Sister Samantha, gesturing towards''', name() + ",", 
        '''who is still hiding in the water.'''],
        ['''"I dunno. A few minutes," says Carrie.'''],
        ['''"It was quite the solid spanking," pipes up Elise.''', '"' + name(), '''was really squirming and squealing."'''],
        [name(), '''shoots Elise a dirty look.'''],
        ['''"Well, I suppose that's sufficient for her rather foolish decision to shove you in the tub," says Sister Samantha, giving''', name(), 
                '''a stern glare. "Or should I spank you too?"'''],
        [name(), '''hastily shakes her head. "No ma'am."'''],
        ['''"Good. Now, Carrie come with me. We will continue this discussion in my office." Sister Samantha spins on her heel, and strides from the''',
                '''baththouse, Carrie scurrying up behind her, one hand anxiously clutching her soon-to-be-stinging bottom, and the other slipping''',
                '''a strand of hair in her mouth.'''],
        ['''As soon as Samantha is gone, Elise relaxes. She approaches the crumbled dress she and Carrie had picked out for''', name(), '''and holds it''',
                '''up. "You done bathing? Let's get you dressed."'''],
        ['''By the time Carrie returns, her eyes bright from unshed tears, and her walk a bit tender,''', name(), 
                '''has put on the black dress. It's a simple, low-cut black tube (though with straps thankfully)''',
        '''that snugly hugs''', names(), '''hips, and extends about halfway down''', hisher(), '''thigh. She is also wearing a pair of black slippers''',
        '''that came with the dress, and a black thong.'''],
        ['''Carrie claps her hands together. "Oh, you look lovely! Doesn't seem to fit quite right, but close enough, and it's a huge''',
        '''improvement over your other clothing."''']])

ep1_elise_prank_sorry_spank.quip_function = ep1_elise_prank_sorry_spank_qf
ep1_elise_dress_small = Node(274)
ep1_elise_dress_wonderful = Node(275)
ep1_elise_prank_sorry_spank.children = [ep1_elise_dress_small, ep1_elise_dress_wonderful]
                
                
ep1_elise_prank_sorry_no_spank.comment = '''"I am not getting spanked because of your vanity!"'''

def ep1_elise_prank_sorry_no_spank_qf():
    ep1_elise_prank_sorry_no_spank.quip = ep1_elise_prank_sorry_catfight()
ep1_elise_prank_sorry_no_spank.quip_function = ep1_elise_prank_sorry_no_spank_qf
ep1_elise_samantha_refuse = Node(276)
ep1_elise_samantha_accept = Node(277)
ep1_elise_prank_sorry_no_spank.children = [ep1_elise_samantha_refuse, ep1_elise_samantha_accept]
def ep1_elise_prank_sorry_catfight():
    increment_spankings_given()
    return universal.format_text([
        ['"' + name() + '-"', '''says Elise, stepping towards''', name() + "."],
        ['''"Oh, you better believe you are. You can come here and take your spanking, or I can drag you over here and make you take''',
            '''your spanking," says Carrie, her expression darkening even further.'''],
        ['''"Carrie-" says Elise.'''],
        ['''"Yeah? You and what army? I've been-eek!"''', name(), '''yelps as a spectral cord whips itself around her waist, and yanks her forward,''',
            '''into the pool.'''],
        ['''"Wait, stop-" says Elise, stepping towards the edge of the pool.'''],
        ['''"Bend over," snarls Carrie, grabbing''', name(), '''and unleashing a shock of power that pushes''', name(), '''against the lip of the''',
        '''tub. She grabs the Taironan's shoulder, and starts to spin her around.'''],
        ['''Carrie is clearly no grappler however; her grip is clumsy, and she is leaving herself wide open.''', name(), '''easily twists around the''',
            '''grip, grabs Carrie around the waist, and shoves her chest-first against the lip.'''],
        ['''"Hey-"'''],
        ['''"Both of you stop-"'''],
        [name(), '''grabs Carrie around the waist, and half lifts, have shoves her up onto the lip, forcing her to bend over.'''],
        ['''"Let go of me!" cries Carrie, kicking her legs. A pulse of power bursts from her body, and runs up''', names(), '''arms like an electric''',
            '''shock.''', name(), '''is no stranger to Spectral Pushes however, and Carrie's, while powerful, is not particularly well directed.''',
            name(), '''easily maintains her grip.'''],
        [name(), '''grabs the edge of Carrie's tiny dress, and pushes it up over the woman's round hips, exposing a matching purple string-thong, and''',
            '''a pair of round, quivering, bright-red bum cheeks. Mixed amongst the general redness are more than a few handprints.'''],
        ['''"Heh heh heh. Side-effects of your spanking from Elise?" says''', name() + ",", '''tracing one of the handprints with a fingernail.'''],
        ['''"Let go of me you mud-skinned-oww!" howls Carrie, as a full-armed smack cracks against her bottom, right on top of one of Elise's''',
            '''handprints.'''],
        ['''"Wow, was that ever the wrong thing to say," says''', name(), '''in a tight, angry voice.'''],
        ['''Water starts flying everwhere, as''', name(), '''administers hard, full-armed spanks to Carrie's wet, wobbling butt cheeks. Carrie''',
        '''starts kicking and flailing send water flying everwhere. The sharp slap of hand to wet flesh rings through the air.'''],
        ['''Elise stands at the edge of the tub, her fists tangled anxiously in her dress.''', '"' + name() + ',', '''stop it, please!"'''],
        [name(), '''ignores her. Carrie, meanwhile, is cursing and howling, shocks of magic rushing up''', names(), '''left arm as the woman casts''',
            '''Spectral Push again and again. The woman is clearly unpracticed at it however, especially in a stressful situation. Each Push is''',
            '''weaker than the last, and after only two or three, she slumps, clearly too tired to continue.'''],
        ['''Then, the door bangs open, and''', '''Sister Samantha steps in.''' if 'met_Samantha' in keywords() else 
            universal.format_line(['''a middle-aged woman in the dark red robes of a Sister of the Spectral Persuasion steps in.''',
            '''Her skin is similar in tone to Elise's. She is of average height, but carries herself with a level of''',
            '''confidence and conviction that makes her appear taller. Crows feet spread out from her blue eyes. Her light brown hair is pulled back into a single long braid that extends about halfway down her back.'''])],
        ['''"Sister Samantha!" cries Elise in a mixture of relief and fear.'''],
        ['''The Sister points her left hand at''', name() + ".", '''a small silver battering ram flings itself from her palm and collides with''', names(),
            '''chest, firmly shoving her away from Carrie. Carrie scrambles out of the pool, clutching at her bright red bottom, and trying to''',
            '''tug her soaking wet dress back over her bottom.'''],
        ['''"What is going on here?" thunders Sister Samantha.'''],
        ['''"That bitch shoved me in the tub-"'''],
        ['''"Because you stripped and-"'''],
        ['''"And started spanking me-"'''],
        ['''"Because you wanted to spank me-"'''],
        ['''"I tried to stop them Sister, but-"'''],
        ['''Sister Samantha cracks a tawse (that''', name(), '''only just now notices is in her right hand) against the doorframe. The harsh snap of''',
        '''leather on wood silences all three young women.'''],
        ['''Sister Samantha points towards the door. "All three of you, in my office. Now."'''],
        ['''"But I don't have anything-"'''],
        ['''"And I'm soaking wet-"'''],
        ['''Sister Samantha grabs a towel off a nearby bench and throws it at the edge of the tub near''', name() + ".", '''She points her hand towards Carrie.''',
            '''A flat field of magic extends from her fingertips, and sweeps across the younger woman's body, the magical sieve pulling the water from''',
            '''her hair and clothing, and dumping it back in the pool. Carrie bows her head, and starts heading out the door with Elise.'''],
        ['''"Come along, you," says Sister Samantha, giving''', name(), '''a cutting glare. "Stop dawdling and let's go."''']])

ep1_elise_samantha_refuse.comment = '''"Bite me."'''
def ep1_elise_samantha_refuse_qf():
    increment_spankings_taken()
    ep1_elise_samantha_refuse.quip = universal.format_text([['''Thirty seconds later, Sister Samantha is striding purposefully down the hallway,''', names(),
        '''naked body draped over her shoulder, and her heavy hand battering the Taironan's bottom.''', names(), 
        '''face heats as they stride through the orphanage mess hall, and past a group of Brothers and Sisters resting from their labors with the''',
        '''children. Their eyes follow Sister Samantha as she carries the squirming, naked Taironan through the mess hall, her hand smacking the''',
        '''Taironan's brown bottom the whole way.'''],
        ['''They (finally) reach Sister Samantha's office, and find Elise and Carrie waiting. Elise's fists are hopelessly twisted in''',
            '''her dress, while Carrie is chomping on a strand of hair.'''],
        ['''"Elise, I've told you time and again," says Sister Samantha, as she drapes''', name(), '''facedown over the padded lip of the desk.''',
            '''"You are going to wrinkle your dress if you keep doing that."'''],
        ['''The Sister then proceeds to give''', name(), '''half a dozen hard belts with the two-pronged tawse.''', name(), '''howls and bucks her''',
            '''way through every blow, her hips grinding frantically against the padding. Elise and Carrie both watch silently, well aware that it's''',
            '''only a matter of time before they too are bent over the desk, their exposed bottoms bouncing beneath one of the older Sister's''',
            '''implements.'''],
        ['''"The next time I tell you to come to my office, what will you do?" asks Sister Samantha of the chastised Taironan.'''],
        ['''"Come to your office," mumbles the girl through her tears.'''],
        ['''"What was that?" says Sister Samantha, cracking her tawse against''', names(), '''bottom.'''],
        [name(), '''howls and bounces her hips. "I'll come to your office!"'''],
        ['''"Good. Now," says the Sister over''', names(), '''sniveling. "Elise, you will explain to me what happened, and just the facts. I want no''',
            '''speculation about why either one of these two brats did what they did. Quickly girl, I've got a lot''',
        '''to do yet tonight. And for the Mother's sake, stop twisting your dress!"'''],
        ep1_trouble_with_samantha()])
ep1_elise_samantha_refuse.quip_function = ep1_elise_samantha_refuse_qf
ep1_elise_samantha_refuse.children = [ep1_elise_dress_small, ep1_elise_dress_wonderful]
ep1_elise_samantha_accept.comment = '''"Yes'm."'''
def ep1_elise_samantha_accept_qf():
    ep1_elise_samantha_accept.quip = universal.format_text([[name(), '''morosely pulls herself out of the tub, her bottom anxiously clenching and unclenching''',
        '''as she considers the irate Sister's tawse. She picks up the towel and wraps the towel around herself. Then, she follows after Sister Samantha's angry strides. The woman leads her through several twisty''',
            '''corridors and a large mess hall. The mess hall is scattered with various Brothers and Sisters, all slumped at the tables and''',
            '''enjoying a small bit of calm, now that the majority of the rambunctious orphans living here have been put to bed.''', name(), 
            '''blushes as the men and women turn to watch her scurry after the Sister like a naughty child. The fact that she's wearing just a''',
            '''towel doesn't help any.'''],
        ['''At the back of the mess hall is a large, thick oaken door. Sister Samantha pushes it open, and strides in with''', name(), '''hot on her heels.''',
            '''Elise and Carrie are standing next to each other. Elise is clenching the front of her dress in a white-knuckled grip, while Carrie''',
            '''is gnawing on a strand of hair.'''],
        ['''Now," says the Sister, closing the door firmly behind her. "Elise, you will explain to me what happened, and just the facts. I want no''',
            '''speculation about why either one of these two brats did what they did. Quickly girl, I've got a lot''',
        '''to do yet tonight. And for the Mother's sake, stop twisting your dress!"'''],
        ep1_trouble_with_samantha()])

ep1_elise_samantha_accept.quip_function =ep1_elise_samantha_accept_qf
ep1_elise_samantha_accept.children = [ep1_elise_dress_small, ep1_elise_dress_wonderful]

def ep1_trouble_with_samantha():
    increment_spankings_taken()
    add_keyword('Samantha_saw_Carries_dress')
    quip = universal.format_text([['''Elise's hands fly from her dress as if they had been burned. She begins to speak in a quiet, hesitant voice, while at the''',
        '''same time smoothing her twisted dress. She explains everything, from the decision to get''', name(), '''ready, to Carrie just stripping''',
        '''and tossing''', name(), '''into the bath, to Carrie's spanking at Elise's hand over the whole thing, to the shove in the tub, to Carrie's''',
        '''and''', names(), '''fight.'''],
        ['''"I see," says Sister Samantha, once Elise is finished. She turns to''', name(), '''and taps her on the small of her back. "You, what is your''',
            '''name?"'''],
        ['"' + name() + ",", '''ma'am," says''', name() + ".", '''For the briefest of moments, she considers saying something sarcastic, but her''',
            '''tawse-inflamed bottom flares up at the mere thought.'''],
        ['"' + name() + ",", '''why did you shove Carrie into the tub?" asks Sister Samantha.'''],
        ['''"I didn't like how she just ripped off my clothes and tossed me in the tub," says''', name() + ".", '''"I found it exceptionally rude, and''',
            '''more than a little inconsiderate."'''],
        ['''"I was just-"'''],
        ['''"You will have your turn to speak," snaps Sister Samantha, turning her glare on Carrie, who shrinks back, chomping even more frantically''',
            '''on her hair. "And why did you decide to start spanking her?"'''],
        ['''"Because she was trying to spank me," says''', name() + ".", '''"I was just defending myself."'''],
        ['''"And why, Carrie were you trying to spank''', name() + "?"''' asks Sister Samantha.'''],
        ['''"Because she almost ruined my dress," says Carrie, a hint of her earlier anger returning to her voice. "I spent years working on this. Years''',
        '''of work almost ruined in a minute!"'''],
        ['''"I see," says Sister Samantha. "So in other words, you, Carrie, got ahead of yourself like you always do, and did something inconsiderate''', 
            '''and acutely uncomfortable for''', name() + ",", '''and then, when she got even with you, you engaged in very un-Sisterly conduct.''', 
            '''You,''', name() + ",", '''rather than simply talking to Carrie about your discomfort,''',
            '''pulled a stupid, mean prank, and then proceeded to paddle one of my students, because she wanted you rightly punished''',
            '''for your actions. And you Elise lost complete control of the situation, and didn't even try to regain it."'''],
        ['''Elise and Carrie wilt beneath Sister Samantha's biting tone.'''],
        ['''"Right, I want your dresses raised, and I want you two bent over the desk next to''', name() + ".", '''Now."'''],
        ['''Carrie hikes up her dress, lowers her tights, and obediently bends over the padded edge of the desk, her bottom rounding into a full moon next to''', 
            names() + "."],
        ['''Elise, however, stomps her foot. "That's not fair!"'''],
        ['''"Young lady-"'''],
        ['''"No, you listen to me, Sister," says Elise angrily. "I only became a Sister two weeks ago, and Carrie will becoming one a month from now.''',
            '''Not only that, but we've been best friends since we were five. We've spanked each other, been spanked together, and each watched the''',
            '''other howl her way through a paddling like a virgin-bummed student feeling the tawse for the first time. You can't seriously expect me''',
            '''to have any sort of authority over her."'''],
        ['''There is a moment of tense silence, and Elise's hands begin to dig into her dress.'''],
        ['''"You're right," says Sister Samantha, at last. "It is unfair of me to expect you and Carrie to be in a proper Sister-student relationship.''',
            '''And I'm not helping the situation any, both by allowing you to go out with her tonight, and by spanking you two together. So, you will not be spanked."'''],
        ['''"Hey, what?" cries Carrie. "Elise did not just talk her way out of a spanking!"'''],
        ['''"Indeed she did not," says Sister Samantha. She returns the tawse to its place on the wall, and pulls down the long, wooden paddle. "She''',
            '''gave a very compelling, and correct argument for why it would be unjust to punish her. Now, the standard punishment for un-Sisterly''',
            '''conduct by a student is twenty-five smacks with the hand, and ten with the paddle. You two will receive the same punishment''' + 
            (universal.format_text([[''', except we will skip the hand spanking for you, miss''', name() + ",", '''considering what a mess your bottom already is."'''],
                ['''"Aww, how come she's getting out of the hand?" whines Carrie.'''],
                ['''"Because as I said, her bottom is already a mess of welts, bruises, and even a blister or two. If you'd like, I can bring your''',
                    '''bum to the same condition."'''],
                ['''"No, ma'am."'''],
                ['''"Then hush and take your punishment."''']]) if
            p.PC.numSpankings > 3 else '.')],
        ['''Sister Samantha considers the two pairs of bare, quivering cheeks presented for punishment. "Carrie, what kind of panties are you wearing?"'''],
        ['''"The sexy kind?" says Carrie nervously.'''],
        ['''"Indeed." The sharp rapport of hand to bare flesh cuts through the office. Carrie jerks, her hip smacking against''', names() + ",", 
        '''while she yelps. "We will discuss your wardrobe in a moment.''']])
    if p.PC.numSpankings <= 3:
        quip = universal.format_text([quip,  ['''With that, Sister Samantha begins spanking the two very round bottoms of the two very naughty girls. She''',
            '''alternates between each girl, three rapid smacks here, three rapid smacks there. Her hand roams all over their bouncing bums,''',
            '''sometimes striking the fleshy middle, sometimes the sensitive sitspots, sometimes the very top, and oftentimes in between. The smacks''',
            '''rain down in a steady, predictable place, but''', name(), '''gives up trying to predict where exactly the next smack will fall. It isn't''',
            '''long before the two girls are squirming, and yelping beneath the hard blows, their hips rubbing against each other, and their fingers''',
            '''interlacing.'''],
            ['''Then, the blows stop.''', name(), '''swallows, her aching bottom clenching nervously.''']])
    else:
        quip = universal.format_text([quip, ['''Then the rapport of repeated blows of hand to bare flesh reverberates throughout the small office. Carrie yelps''',
            '''and starts bobbing and rocking, her hips occasionally bumping up against''', names() + "."],
            ['''"Stay still girl," says Sister Samantha sharply. "This is hardly your first spanking."'''],
            ['''"But it still hurts," whines Carrie in a high-pitched voice.'''],
            ['''"Of course it hurts," says Sister Samantha, her hand never slowing. "How else will you learn? Not that you learn anyway. Perhaps''',
                '''I should just use the cane from now on?"'''],
            ['''"No, no, Mother's mercy please no!" cries Carrie, bucking against the padded lip, and pounding her hand against the desktop.'''],
            ['''"Then learn something from these, I'm not just smacking you for my health."'''],
            ['''Carrie groans, and buries her face in her arm, while Sister Samantha continues to spank away.''']])
    quip = universal.format_text([quip, ['''"Right then," says Sister Samantha. There is a scrape of wood on wood, as Sister Samantha picks up the paddle.''',
        '''"Time for the paddle."'''],
        ['''Both girls groan.'''],
        ['''"Yes, yes, I know, it's all so terrible," says Sister Samantha. She taps the paddle lightly against first one bum, and then the other.''',
            '''"The big mean Sister Samantha, holding us accountable for our actions. However will we survive?"'''],
        ['''The paddle cracks against Carrie's bottom. The young woman shrieks, and wiggles her ass frantically, occasionally bumping her hip against''',
            names() + ".", '''Then, there is an explosion of pain across the middle of both cheeks of''', names(), 
            '''naked bottom, and a deafening thwack hammers against her ears, as the paddle collides''',
            '''with her tender cheeks.''', name(), '''howls, and bobs her bottom, kicking the front of the desk.'''],
        ['''"Please try not to kick the desk," says Sister Samantha sardonically. "I don't need it damaged, and quite frankly, it hasn't done anything''',
            '''to you."'''],
        ['''Then, the paddling begins in earnest. Sister Samantha alternates between the two girls, one blow to Carries bottom, then while she is''',
        '''bucking and yowling, a blow to''', names(), '''bottom. Then, another blow to Carrie's bum while''', name(), '''is dancing.''',
        '''As the hard paddling continues, the two girls can't help but cling to each other, the hot pain in their bottoms, and their need for comfort''',
        '''burning away all previous animosity.'''],
        ['''Sister Samantha administers the promised ten blows to the bums of both girls in this manner, the heavy paddle reducing both of them to sniveling''',
            '''wrecks. "Alright, we're done here. You can get up when you're ready."'''],
        ['''The two remain bent over the desk a moment more, rubbing their blistered bums, and trying to work up the courage to move. Eventually, the''',
            '''two straighten, hissing and gingerly rubbing their bottoms.'''],
        ['''"Elise, get''', name(), '''covered, and take her back to the bathing room. You can help her get ready for your night out, while I talk''',
            '''to Carrie about her chosen wardrobe."'''],
        ['''Elise throws Carrie a sympathetic look, before wrapping a towel around''', names(), '''shivering body, and leading her back to the warm,''',
            '''steamy bathing room.'''],
        ['''By the time Carrie returns (very gingerly) to the bathhouse, Elise has helped''', name(), '''put on the little black dress, black slippers,''',
            '''and black thong. Getting the dress over''', names(), '''swollen bottom was a particularly fun adventure;''',
            '''the dress was rather tight to begin with, and the material was a bit coarse.'''],
        ['''Still, Carrie's eyes light up when she sees''', name() + ".", '''"Oh you look much better than when you first came in, doesn't she,''',
        '''Elise?"'''],
        ['''"Indeed," says Elise, grinning. "Speaking of looking good, I see you haven't changed."'''],
        ['''"That's because Sister Samantha is letting me wear this tonight, and for my ascension," says Carrie, grinning. "Had to change my underwear''',
            '''though, and she gave me a dozen with the hairbrush for not asking for help purchasing more fabric."'''],
        ['''"Great! Well, except for the hairbrushing on top of the paddling. But really, what more could you expect?" says Elise. She turns to''', name() + ".", '''"So,''', name() + ",", '''what do you think about your outfit?"''']])
    return quip

ep1_elise_dress_small.comment = universal.format_line(['''"I don't know. Doesn't it seem a little small to you? And the underwear! Madre de la Madre, if I'm going''',
'''to wear these, I might as well just go without. Leaves just as little to the imagination, and doesn't ride up quite so badly."'''])
def ep1_elise_dress_small_qf():
    if not wearing_skirt_or_dress_or_pants:
        ep1_elise_dress_small.quip = universal.format_text([universal.format_line(['''"This from the girl who runs around in nothing but a thong," says Carrie, rolling her eyes.''',
            '''"If you can fight a bunch of crazy people with your ass hanging out, you can go to a tavern in a tight minidress."''']) if 
            p.PC.underwear().baring else universal.format_line(['''"This from a girl who normally runs around without pants. If you can venture forth into the''',
            '''world in nothing but a pair of panties, you can go to a tavern in a black minidress and thong."''']),
            ['''"But that was different," says''', name() + ".", '''"I was allowed to stab people then."'''],
            ['''"And now you're looking to get stabbed," says Carrie, coming up next to''', name(), '''and lightly slapping''', names(), '''bum.'''],
            [universal.format_line(['''"Oww! Tender, tender!" cries''', name() + ",", '''her hands flying back to her stinging bottom.''']) if p.PC.numSpankings > 0
                else universal.format_line([name(), '''jerks, caught off-guard by the slap.'''])],
            ['''"Carrie!" cries Elise, smacking Carrie's bottom.'''],
            ['''"Oww! Tender, tender!" yelps Carrie, her hands flying back to rub her bottom.''' if 'Samantha_saw_Carries_dress' in keywords() else 
                '''Carrie hops a little, and throws Elise a scowl.'''],
            ['''"You will watch what you say," says Elise, a hand on her hips, and a finger pointed at Carrie.'''],
    ['''"Aww, come on. What's the big deal? If the Mother didn't want us to enjoy it, she wouldn't have made it so much fun! Now come on you two. The''',
        '''night may still be young, but it's aging even as we speak." With that, Carrie grabs Elise and''', name(), '''by the arms and drags them out''',
        '''of the bathing room, through the Shine and out into the central square.'''],
    ['''"But-"'''],
    ['''"Just go with it," says Elise, rolling her eyes. "There's no stopping her when she's in this mood."'''], ep1_tavern_scene(ep1_elise_dress_small)])
    else:
        ep1_elise_dress_small.quip = universal.format_text([['''"Aw, come on," says Carrie, slipping over next to''', name() + ".", '''"How are you supposed to''',
        '''find a cute boy if you're not dressed sexy? And girl, you're dressed sexy." Carrie gives''', names(), '''tightly-clad bum a light smack.'''],
        [universal.format_line(['''"Oww! Tender! Tender!" cries''', name(), '''her hands flying back to shield her throbbing bottom.''']) if p.PC.numSpankings > 0 else
            universal.format_line(['''"Please don't spank me," says''', name() + ".", '''"I'm enjoying having a bottom that isn't throbbing, thank you''',
            '''very much."'''])],
        ['''"Sorry," says Carrie. "But come on, you get the point right?"'''],
        ['''"You know there's more to life than boys, right?" asks''', name(), '''absently rubbing the sting from her bum.'''],
        ['''"Well, yeah obviously," says Carrie. "But not tonight! Tonight, it's all about finding a good solid tree and giving it a good''',
            '''hard planting."'''],
        ['''"Carrie!" cries Elise, slapping Carrie's bottom. "If Sister Samantha caught you talking like that, she'd paddle you senseless!"'''],
        ['''"Oww! Tender! Tender!" yelps Carrie, her hands snapping back to shield her bottom. "Come on, I just wanna have a little fun."''' 
            if 'Samantha_saw_Carries_dress' in keywords() else '''"Oh come on. I just want to have a little fun," says Carrie, grinning.'''],
        ['''Elise rolls her eyes. "Sometimes I think you like getting spanked."'''],
        ['''"Hmm, if it's by a big, sexy man," says Carrie, smiling sensually. "With nice, cupped hands, and firm thighs. A few moderate slaps, just''',
        '''enough to build a bit of a sting, while I grind against his leg. Then some rubbing, oh yes, lots of rubbing."'''],
        ['''Elise rolls her eyes.'''],
        ['''"Oh, like Roland's never given you a sensual spanking before," says Carrie. "Remember when I walked in-"'''],
        ['''"Done talking, not listening, la la la!" yells Elise, shoving her fingers in her ears.'''],
        ['''"Whatever, let's go." Carrie grabs Elise's and''', names(), '''arms and starts dragging them from the Church. "The night may be young, but''',
        '''it ain't getting any younger!"'''],
        ['''"But-"'''],
        ['''"Just roll with it," says Elise, rolling her eyes. "When she gets like this, there's no stopping her."'''],
        ep1_tavern_scene(ep1_elise_dress_small)])
ep1_elise_dress_small.quip_function = ep1_elise_dress_small_qf

ep1_elise_dress_wonderful.comment = '''"I think it's sexy as sexy can be. Love what it does for my ass."'''
def ep1_elise_dress_wonderful_qf():
    ep1_elise_dress_wonderful.quip = universal.format_text([['''Elise rolls her eyes.'''],
        ['''"There, Elise you see?" says Carrie, slipping her arm around''', names(), '''shoulder. "I told you I'd found a kindred spirit."'''],
        ['''"You say that every time we meet someone," says Elise, rolling her eyes again. "It was inevitable you'd get it right eventually."'''],
        ['''"Elise is just jealous, because she's not allowed to have fun like us," says Carrie in a loud whisper. "What with her being engaged and''',
        '''all."'''],
        ['''"How terrible," says''', name(), '''in an equally loud whisper. "Truly, a fate worse than death."'''],
        ['''"You two hush, before I give you the slippering of your lives," says Elise, taking off her slipper, and shaking it at the two. The effect''',
            '''is ruined by a mirthful sparkle in her eye.'''],
        ['''"Well, then let's stop talking and start walking," cries Carrie, throwing her fist in the air. "There's a whole tavern full of hunky men''',
            '''just waiting for us, and it'd be a terrible crime to keep them waiting any longer!"'''],
        ['''"Yes!" says''', name() + ",", '''giving Carrie a high-five. Then the two grab Elise, and half carry, half drag her out of the Church.'''],
        ['''Elise just rolls her eyes, and goes with it.'''], ep1_tavern_scene(ep1_elise_dress_wonderful)])
ep1_elise_dress_wonderful.quip_function = ep1_elise_dress_wonderful_qf

    
        

ep1_elise_prank_angry = Node(271)
ep1_elise_prank_angry.comment = '''"Hah! I'll spit in La Madre's face before I let you spank me, you soft-bodied brat."'''
ep1_elise_prank_angry.children = [ep1_elise_samantha_refuse, ep1_elise_samantha_accept]
def ep1_elise_prank_angry_qf():
    ep1_elise_prank_angry.quip = ep1_elise_prank_sorry_catfight()
ep1_elise_prank_angry.quip_function = ep1_elise_prank_angry_qf
ep1_elise_prank.children = [ep1_elise_prank_sorry, ep1_elise_prank_angry]
ep1_elise_no_prank = Node(282)
ep1_elise_no_prank.comment = '''Just wait for Carrie and Elise to return.'''
def ep1_elise_no_prank_qf():
    ep1_elise_no_prank.music = [CARLITA, CARRIE]
    ep1_elise_no_prank.quip = universal.format_text([[name(), '''shrugs in the water. Probably shouldn't. It's not like it was that big of a deal anyway; she'd''',
        '''spent her whole life bathing in the public bath houses of Chengue, so nudity in front of other people (men and women!) is hardly new. Besides,''',
        '''Carrie's dress looks like it's made of wool. Well-made or not, dumping her in the warm tub runs a serious risk of clothing shrinkage.'''],
        ['''So,''', name(), '''floats in the water for a few minutes, letting the sweat, dirt, and dried blood slough off of her body. She lets out a long,''',
            '''deep sigh.'''],
        ['''\m"No, please I told you everything. Please you have to believe me, don't take me there, don't let them in my head. Please!"'''],
        [name(), '''jerks up in the tub, her reverie broken. Images of the first girl she fought flash through her mind. What is that girl going''',
        '''through right now? Probably sitting in chains in some dark,''',
            '''dirty, cold, cell. Probably clad in nothing but rags (if she's lucky), waiting for a puppeteer to-'''],
        [universal.format_line([name(), '''is floating in an empty abyss. "You and I are the greatest of friends-"''']) if 'charmed_by_Deidre' in keywords() else
            universal.format_line([name(), '''shakes her head. She half-wades, half-swims over to the edge of the tub, and grabs a nearby bar of soap. No. Don't''',
                '''think about it. She can't think about it. She begins cleaning herself with the soap. There's nothing she can do about it, and thinking about it would just ruin her evening. She throws the soap across the room and curses violently. Yeah, Madre forbid her wonderful''',
                '''evening dancing, drinking and getting hit on is ruined!'''])],
        ['''\mThe door bursts open, and Carrie and Elise return. Carrie comes in first, carrying a pile of black clothing. She is walking a little''',
            '''gingerly, and her eyes are bright with unshed tears. Elise follows right behind, a self-satisfied smirk on her face.'''],
        ['''"Hey''', name() + ",", '''we brought a dress for you try on," says Carrie, setting the outfit down on the bench. "And um, sorry''',
                '''for just stripping you like that. I should have asked for permission, or let you do it yourself."'''],
        ['''Elise's smile widens.'''],
        ['''"Oh it's not a big deal," says''', name(), '''absently, her thoughts still lingering on the girl. "Sure, I was annoyed for a second, but I've been bathing''',
            '''in public all my life. It's nothing to get worked up over."'''],
        ['''Elise's smile falters.'''],
        ['''Carrie rounds on her friend. "See? I told you! A bare bottom spanking was total overkill."'''],
        ['''"Well it wouldn't have been bare-bottom if your panties weren't nothing but a glorified string," retorts Elise.'''],
        ['''"Only the back," snaps Carrie. "And that's beside the point. The spanking was overkill, over panties or otherwise."'''],
        ['''Elise rolls her eyes. "Except you never listen to me unless I've tenderized your bottom a bit first."'''],
        ['''"That's because you're always whining. 'We really shouldn't do this.' 'Are you sure about that?' 'You're not really going to wear that''',
            '''are you?'" Carrie's voice takes on a falsetto pitch.'''],
        ['''"I do not sound like that," says Elise indignantly. She lifts her right hand, flat and hard. "Don't make me spank you again."'''],
        ['''"Go ahead and try, we'll see who ends up getting a bare spanking," retorts Carrie, crossing her arms and huffing.''']])
ep1_elise_no_prank.quip_function = ep1_elise_no_prank_qf

ep1_elise_watch = Node(283)
ep1_elise_interrupt = Node(284)
ep1_elise_do_nothing = Node(285)
ep1_elise_no_prank.children = [ep1_elise_watch, ep1_elise_interrupt, ep1_elise_do_nothing]

ep1_elise_watch.comment = '''Lie back and enjoy the show.'''

def ep1_elise_watch_qf():
    ep1_elise_watch.quip = universal.format_text([['''For a moment,''', name(), '''considers trying to stop the two, before things get ugly. But then, her eyes''',
        '''flick to Carrie's round, jiggly bottom clad in a tight minidress, and then to Elise's even rounder, jigglier bottom,''',
        '''clad in an only slightly looser dress. Her thoughts flash back to comments by Elise about glorified strings, and then to threats by Carrie about bare spankings.''']])
    if 'lesbian_in_denial' in keywords():
        ep1_elise_watch.quip = universal.format_text([ep1_elise_watch.quip, ['''Gah! What is she doing? She's not interested in that! Not at all!"'''],
        ['''"Ladies, please. We're supposed to be having fun tonight, not spanking each other. Besides, what'll happen''',
            '''if one of the other Sisters walks in?" says''', name(), '''quickly.'''],
        ep1_interrupt(ep1_elise_watch)])
    else:
        ep1_elise_watch.quip = universal.format_text([ep1_elise_watch.quip, ['''An evil grin spreads across''', names(), 
            '''face. Ugly? Au contraire. Things are about''',
        '''to get very, very lovely.'''],
        ['''Then,''', name(), '''feels a flash of guilt. Neither woman knows about her preferences. She gnaws uneasily on her''',
            '''lower lip, and neither would probably be particularly happy if they found out. Plus, it is kind of a creepy move to just sit here''',
            '''and get off on two voluptuous women spanking each other, no matter how round and prone to ripples their bottoms may be.''']])
        ep1_elise_watch.children = [ep1_elise_interrupt, ep1_elise_watch_anyway]
ep1_elise_watch.quip_function = ep1_elise_watch_qf
ep1_elise_watch_anyway = Node(286)

ep1_elise_watch_anyway.comment = '''Watch anyway.'''
def ep1_elise_watch_anyway_qf():
    ep1_elise_watch_anyway.quip = universal.format_text([['''Ah, who is she kidding? It's not like she's encouraging them. No, she's just a bystander. A perfectly''',
        '''innocent, if mildly perverted, bystander.'''],
        [name(), '''leans forward, and watches the two glare each other down. Who should she root for? Carrie. Definitely Carrie.''',
            '''Carrie's taller, and''',
            '''she's got righteous fury on her side. On the other hand, Elise's panties are probably pretty boring, while Carrie is apparently wearing''',
            '''a 'glorified string.' That could only mean good things if Carrie winds up with her dress-'''],
        ['''Elise sighs, and lowers her hand. "I suppose you're right, I overreacted. I'm sorry."'''],
        ['''"Ah, don't worry about it," says Carrie, flicking her wrist. "Honestly, you were right to be miffed.''', name(), '''seems ok with it, but''',
            '''not everyone would be, and stripping people without their permission for reasons other than a well-earned spanking is usually a bad''',
            '''thing."'''],
        ['''Well, curses.''']])
ep1_elise_watch_anyway.quip_function = ep1_elise_watch_anyway_qf
ep1_elise_goad = Node(288)
ep1_elise_roll_with_it = Node(289)
ep1_elise_watch_anyway.children = [ep1_elise_goad, ep1_elise_roll_with_it]

ep1_elise_goad.comment = '''"Wow, Carrie. You're a lot nicer than I am. If someone spanked me like that, I'd never let them get away with it."'''
def ep1_elise_goad_qf():
    add_keyword('goaded_Carrie')
    ep1_elise_goad.quip = universal.format_text([['''Carrie shrugs. "Trust me, we've done much worse to each other. It's not a big deal."'''],
        ['''"Not a big deal? Getting turned over your best friend's knee, having your skirt lifted, your tights lowered, and given a bare-bottom''',
            '''spanking for almost no reason? You'll be sitting tenderly all night, while she'll be comfortable as a babe in her mother's arms."'''],
        ['''Carrie and Elise exchange a look. Then, Carrie shrugs. "Eh, you're exaggerating. Elise doesn't hit very hard."'''],
        ['''"Hey!" says Elise, putting her hands on her hips.'''],
        [name(), '''fights a smile.'''],
        ['''"What? It's true," says Carrie. "Your spankings sting a little, but two hours from now, I'll just be a little sensitive." Carrie grins.''',
            '''"Which, if things turn out well, could only be a good thing."'''],
        ['''Elise looks like she's about to protest, but then she shrugs. "Yeah. Sister Samantha tells me the same thing." She turns to''', name() + ".", 
        '''"Come on,''', name() + ".", '''We've got places to be."'''],
        [name(), '''represses a sigh, and clambers out of the tub. She has got to work on her Evil Manipulator skills. Perhaps if they were a touch''',
        '''drunk first?'''],
        out_of_tub(ep1_elise_goad)])
ep1_elise_goad.quip_function = ep1_elise_goad_qf

ep1_elise_roll_with_it.comment = '''Resign yourself to the fact that the Universe is just one big tease.'''
def ep1_elise_roll_with_it_qf():
    ep1_elise_roll_with_it.quip = universal.format_text([['''Ah well. Such is life.''', name(), '''clambers out of the tub. "So, where's my outfit?"'''],
        ['''Carrie grins. "Right over here."'''],
        out_of_tub(ep1_elise_roll_with_it)])
ep1_elise_roll_with_it.quip_function = ep1_elise_roll_with_it_qf
        

ep1_elise_interrupt.comment = universal.format_line(['''"Ladies, please. We're supposed to be having fun tonight, not spanking each other. Besides, what'll happen''',
    '''if one of the other Sisters walks in?"'''])

def ep1_elise_interrupt_qf():
    ep1_elise_interrupt.quip = universal.format_text([['''"Oh relax," says Carrie, laughing. "We're not actually going to start spanking each other. We're just''',
        '''bitching. We do it all the time."'''],
        ['''Elise grins as well. "Though you're hardly the first person to be fooled. Remember that time Brother Lou nearly slippered the both of us?"'''],
        ['''"Which time?" says Carrie.'''],
        ['''"The only time where he just put the slipper back on his foot after taking it off," says Elise sardonically.'''],
        ['''Carrie's face screws up in thought for a moment. Then a grin breaks out. "Oh yes, I remember that! Whoo. That was a relief.''',
            '''Guy's spanks feel like he swapped arms with a giant."'''],
        [name(), '''clambers out of the tub. "Why do I get the feeling that if I let you two, you'd talk from now until we've all been reduced to dust?"'''],
        ['''"I don't know, why do you get that feeling?" asks Carrie innocently. "Anyway, get dried off. You'll love the outfit we picked out for you."'''],
        out_of_tub(ep1_elise_interrupt)])
ep1_elise_interrupt.quip_function = ep1_elise_interrupt_qf

ep1_elise_do_nothing.comment = '''Do nothing.'''
def ep1_elise_do_nothing_qf():
    ep1_elise_do_nothing.quip = universal.format_text([['''"I suppose you're right," says Elise, lowering her hand. "Maybe I did overreact."'''],
        ['''"Eh, don't worry about it," says Carrie. "Honestly, you were probably right to spank me.''', name(), '''apparently didn't care, but someone''',
            '''else may have. Now, as for you." Carrie turns her grinning gaze on''', name() + ".", '''"Quit dawdling and get out of that tub. We've''',
            '''got a cute little dress you'll love."'''],
        [name(), '''obligingly clambers out, wondering if Carrie's definition of 'little' lines up at all with everyone else's.'''],
        out_of_tub(ep1_elise_do_nothing)])
ep1_elise_do_nothing.quip_function = ep1_elise_do_nothing_qf

def out_of_tub(node):
    quip = ''
    if 'goaded_Carrie' in keywords():
        quip = universal.format_text([['''While Carrie guides''', name(), '''towards the bench with black outfit on it, Elise pulls the bench a bit further away''',
            '''from the wall, and shifts the black dress down a few inches. Odd, but whatever.'''],
            ['''"So, you gonna give me a towel, or what?" asks''', name(), '''shivering slightly. "Kind of chilly."'''],
            ['''"Oh don't worry, we'll fix that momentarily." A malicious grin flashes across Carrie's face. Suddenly, she and Elise grab''', name(), 
            '''on opposite sides and tip her over the bench, the hard wood pushing her naked bottom up into the air.'''],
            ['''"Hey!" cries''', name() + ".", '''"What are you doing?"'''],
            ['''"Elise and I couldn't help but notice you goading us." Carrie gives''', names(), '''damp left cheek a stinging slap. "Methinks you''',
                '''wanted to watch us fight."'''],
            ['''Elise gives''', name(), '''a matching slap to her right cheek. "Care to tell us why?"'''],
            ['''Because you both have asses to die for. No, no can't say that, can't say that! "Umm, I kind of thought it would be funny?"'''],
            ['''"Oh, she thought it would be funny," says Carrie. She slaps''', name(), '''right on the sitspot. "Do you know what I think is funny?''',
                '''When naughty brats who care more about a few short-term laughs, than about the well-being of her friends' relationships gets her''',
                '''naked fanny thoroughly spanked."'''],
            ['''"I think that sounds funny too," says Elise.'''],
            ['''"I don't," says''', name(), '''anxiously.'''],
            ['''"Sorry honey, two to one you lose," says Carrie, beginning to slap''', names(), '''left cheek. "Now, take your spanking like a''',
            '''good girl."''']])
        node.children = [ep1_elise_take_spanking, ep1_elise_fight_back]
    else:
        quip = ep1_elise_dressed(node)
    return quip

ep1_elise_take_spanking = Node(287)
ep1_elise_take_spanking.comment = '''Take the spanking like a good girl.'''
def ep1_elise_take_spanking_qf():
    increment_spankings_taken()
    ep1_elise_take_spanking.quip = universal.format_text([[name(), '''grimaces, but obediently pushes her bottom up. She had tried to goad them into a fight''',
        '''simply for her own pleasure, after all. If there was ever a time in which she deserved a solid spanking, it'd be now. "I'm sorry."'''],
        ['''"Good girl," says Carrie, smacking''', names(), '''right cheek. "Nothing wrong with being a jerk every now and then, so long as you own up''',
            '''to it."'''],
        ['''"My goodness, look at her bottom wobble," says Elise, spanking''', names(), '''right cheek. "Are we sure she's an adventurer?"'''],
            [universal.format_line(['''"Oh shut up," mutters''', name() + ",", '''wincing. "I'm working on it."''']) if 'mai_squat_thrusts' in keywords() else 
                universal.format_line(['''"Oh shut up," mutters''', name() + ", wincing."])],
        ['''With that, the two girls give''', name(), '''a brief but intense spanking. The two stagger their blows so that just as Carrie is''',
            '''lifting her hand off of''', names(), '''left cheek, Elise's hand is cracking into her right cheek, and just as Elise is lifting her''',
            '''hand off of''', names(), '''right cheek, Carrie's hand is slamming into her left cheek. There is neither rest nor recovery, just an''',
            '''endless rapidly building sting, magnified by the water still on her bum. It''','''isn't''',
            '''long before she is kicking and flailing, cries of pain bursting from her lips, her hips bucking against the bench, and swaying''',
            '''desperately. The bench grates across the stone floor, shifting it this way and that as''', name(), '''pushes against it.'''],
        ['''"Alright, I think that's enough," says Elise at last.'''],
        ['''"Oh bother, you're too soft."'''],
        ['''"I said, that's enough," says Elise much more sharply.'''],
        ['''"Fine, fine," mutters Carrie. "Alright,''', name() + ",", '''you're forgiven. Now, let's get you dressed."'''],
        ep1_elise_dressed(ep1_elise_take_spanking)])
ep1_elise_take_spanking.quip_function = ep1_elise_take_spanking_qf

ep1_elise_fight_back = Node(290)
ep1_elise_fight_back.comment = '''Fight back.'''
def ep1_elise_fight_back_qf():
    increment_spankings_taken()
    increment_spankings_given()
    add_keyword('elise_own_medicine')
    ep1_elise_fight_back.quip = universal.format_text([['''"No, let go of me, this isn't fair," cries''', name() + ".", 
        '''"I would never do something like that!"'''],
        ['''Carrie tsks, and gives''', name(), '''an extra hard slap to her sitspot. "Adding lying to your list of offenses. You're well on your way''',
            '''to a slippering young lady."'''],
        ['''"Oh, that's it," says''', name() + ".", '''She plants her hands against the ground, and unleashes a minor Spectral Push into the stone.''',
            '''The sudden force flings her up and off the bench. She hits the stone hard (landing right on her tender bottom), and scrambles to her''',
            '''feet.'''],
        ['''"You stupid brat-Hey!" cries Carrie, as''', name(), '''grabs the woman's arm.'''],
        ['"' + name() + '!"', '''cries Elise angrily. "Let her go this instant."'''],
        ['''"Try and stop me," says''', name() + ".", '''"And we'll see how your lifetime of learning how to heal people stacks up against my lifetime''',
            '''of learning how to fight."'''],
        [name(), '''sits down on the bench, and hauls the kicking and struggling Carrie over her knee. She hikes up the woman's skirt, and yanks down''',
            '''her tights, marveling as Carrie's plump, bouncy butt springs into view. At first,''', name(), '''thinks the woman isn't wearing''',
            '''any panties at all, but then she spies a thin string of cloth nestled between the woman's ample cheeks.'''],
        ['''"Unhand me this instance you miserable-oww!"'''],
        [names(), '''hand snaps down, and splats against Carrie's right cheek, her eyes lighting up as she watches it wobble''',
        '''beautifully.''', names(), '''hand rapidly snaps up and down, landing swift, painful slaps to the woman's rolling derrier. Carrie squirms and''',
        '''bounces. Her legs kicks kick frantically, and she pounds''', name(), '''uselessly on''', names(), '''shin with her fist.'''],
        ['''"Are you going to apologize for making up such disgusting lies?" asks''', name() + "."],
        ['''"We weren't lying and you know it!" cries Carrie.'''],
        ['''"A shame."''', name(), '''lands four more hard smacks, two to each sitspot. Carrie shrieks and jerks against''', names(), '''lap.'''],
        ['''"Stop, it! Stop it!" wails Carrie.'''],
        ['''"Maybe if Elise admits to your lies and is willing to take the punishment for both of you," says''', name() + ".", HeShe(), '''looks up.''',
            '''"Hey Elise-"'''],
        [name(), '''frowns. Odd. Where'd she-'''],
        ['''Fingers touch the back of''', names(), '''neck. An overwhelming, numbing weakness spreads across her body. "Wha-"'''],
        ['''"Here's how years of healer training stack up against fighter training," hisses Elise. "This is a ritual that weakens and numbs a person's''',
            '''body. Very useful before performing operations. It's too involved to cast in battle, but cast it while a cruel little brat is spanking''',
            '''your best friend? Easy peasy."'''],
        ['''Carrie slithers off of''', names(), '''lap,''', names(), '''loose grip barely slowing her down. She raises her tights back up, and lowers''',
            '''her dress, hissing as the cloth scrapes against her tender bottom.'''],
        ['''Elise grabs''', name(), '''around the shoulder, and flips her around, bending her back over the bench. She puts her lips next to''', names(),
        '''ears. "And here's another ritual, the dual of this one."'''],
        ['''For a few minutes nothing happens. Then,''', name(), '''gasps as a wave of sensation spreads across her bottom. She can feel each''',
            '''invidual drop of water slide down her tush. Even the air itself seems to be pressing against her exposed bottom.'''],
        ['''"This spell enhances sensitivity. It can also give someone a burst of energy," says Elise. "This could be a problem, except as I'm sure''',
        '''you're discovering, the effects can be localized."'''],
        ['''"I..." mumbles''', name(), "woozily."],
        ['''"You've lost the right to talk you insufferable little brat," says Elise. "Carrie, it has come to my attention that the leather soles of''',
        '''my slippers are wasted slapping against stone. Care to help me slap them against another, much more pliable surface?"'''],
        ['''"With pleasure," says Carrie in a menacing voice.'''],
        ['''Splat! Splat!'''],
        [name(), '''shrieks at the top of her lungs as first one slipper, then the other smack into her hyper-sensitive heinie. Or tries to. It comes''',
            '''out as nothing but a pained whimper. The two girls vigorously slipper''', names(), '''bottom, staggering their blows so that''',
            '''just as one slipper is leaving''', names(), '''cheek, the other is slapping into the other. Each blow sparks a blinding''',
            '''explosion of pain in''', names(), '''thrashed bottom; the impact of each heavy slipper enhanced a dozen times over by the super-sensitivity''',
            '''of''', names(), '''cheeks. Yet, despite the overwhelming agony,''', name(), '''can't do much more than twitch and moan. The whole rest''',
            '''of her body is numb. Her mind is fogged, except for the single point of white-hot agony that is her bottom. The only thing she can think''',
            '''about, the only thing she can feel are the heavy slaps of the slippers, and the waves of hot agony flowing from her bottom. Tears''',
            '''cascade down''', names(), '''cheeks, but she doesn't even have the strength to sob.'''],
        ['''"Alright, that's enough," says Elise. There's a hint of worry in her voice. "I hope I didn't make her too sensitive."'''],
        ['''Then, mercifully, the agony fades to a dull ache, and the strength returns to''', names(), '''limbs. She remains lying over the bench for''',
                '''a few moments more, sobbing brokenly.'''],
        ['''"Oh no, I did enhance it too much," says Elise. She sits down next to''', name(), '''and guides the other woman up, and then pulls her''',
                '''head into her lap. She runs one finger down''', names(), '''cheek, while the other glides soothingly over her hot bottom. "Hey, hey''',
                '''I'm sorry. I didn't mean to go overboard like that."'''],
        ['''After a few minutes, the pain in''', names(), '''bottom numbs.'''],
        ['''"I should have restored your bottom to normal sensitivity, not enhanced it," says Elise. "I'm so sorry."'''],
        ['''"It's OK, I deserved it," whispers''', name() + ".", '''"You were right, I was trying to goad you two, and then I tried to punish you''',
                '''for the crime of calling me out."'''],
        ['''"No, no you don't," says Elise. "I'm so very sorry. Look, I'm going to go to Sister Samantha tomorrow morning, and tell her what I did."'''],
        ['''"Elise," cries Carrie in a shocked voice. "If Sister Samantha finds out-"'''],
        ['''"She'll give me a dose of my own medicine," says Elise, her voice quavering slightly. "Well, I've earned it.''',
                '''I learned that spell to help me diagnose diseases, not get petty revenge. Now, let's help you get changed, and then we can go out''',
                '''and enjoy the night."'''],
        ep1_elise_dressed(ep1_elise_fight_back)])
ep1_elise_fight_back.quip_function = ep1_elise_fight_back_qf

def ep1_elise_dressed(node):
    node.children = [ep1_elise_dress_small, ep1_elise_dress_wonderful]
    quip = universal.format_text([['''With Elise's and Carrie's help,''', name(), '''slips into the black thong, low-cut black minidress and''',
        '''black slippers. Well, slipped isn't quite the right word (at least for the minidress). More like squeezed. The dress hugs''',
        names(), '''hips almost like a second-skin. The tightness and shortness has cut her stride length at least in half, maybe more. She grimaces,''',
        '''imagining what would happen if she got into a fight. Not that she'll have her weapon anyway, but still...'''],
        ['''Carrie, however, claps her hands together excitedly. "You look hotter than a wheat field in midsummer. You'll have 'em lining up out the''',
        '''door!"'''],
        ['''Elise rolls her eyes and sighs.'''],
        ['''"Oh hush. You're just jealous," says Carrie.'''],
        ['''"Why would I be jealous?" asks Elise, crossing her arms over her chest. "I'm marrying the youngest son of one of the most influential''',
        '''families in the city. He's kind, sensitive, and absolutely gorgeous."'''],
        ['''"Yeah, and he spanks like a mule kicks," says Carrie. "Least when my lovers spank me, it's because I want them to, it's light, and it's''',
        '''got a lot of rubbing involved."'''],
        ['''"How would you know? He's never spanked you," says Ellen.'''],
        ['''"No, but I've watched you howl under his hand," says Carrie. "Sure sounds like you're getting kicked by a mule."'''],
        ['''"You've only seen the one time, it was the first time so I didn't know what to expect, and it was all your fault anyway!" cries Elise.'''],
        [name(), '''rolls her eyes, and stands with her arms crossed, wondering if these two could go ten minutes without bickering.'''],
        ['''Carrie's expression turns sly. "So you're saying he's spanked you other times?"'''],
        ['''Elise blushes, and taps her fingertips together. "Well, maybe. Once or twice. Remember when we pulled an all-nighter preparing for that''',
            '''spectral test, because we kind of waited until the last minute before studying? Well, Roland knew how stressed I'd been about the test, so''',
            '''he'd gotten tickets for a play being shown after the test. I kind of slept''',
            '''through the first act. So, during intermission, Roland decided that a tender bum would help me stay awake. Then, after the play he''',
            '''found out about the all-nighter."'''],
        ['''Carrie laughs. "There you see? When I go to plays, I can sleep through them all I want."'''],
        ['''"What are you talking about? You never go to plays, you can't afford them," says Elise.'''],
        ['''"No, I don't go to plays, because they're boring!" retorts Carrie. "Seriously, you sit around and watch a bunch of people running around''',
        '''saying things that seem dramatic and deep, but when you actually think about what they're saying, you realize it's all just a mask for''',
        '''stupid people doing stupid things just to move the plot forward."'''],
        [name(), '''facepalms.'''],
        ['''"Uncultured swine," says Elise, scowling at Carrie.'''],
        ['''"Stuck-up brat," retorts Carrie, matching her scowl for scowl.'''],
        ['''"Am I going to need to spank the both of you?" asks''', name(), '''at last. "Or are we actually going to leave?"'''],
        ['''Both girls look a bit shamefaced.'''],
        ['''"She has a point," says Carrie. "Time's a wasting."'''],
        ['''"But, first I want to know what you think," says Elise, turning to''', name() + ".", '''"How's the outfit?"''']])
    return quip

def ep1_tavern_scene(node):
    try:
        node.music.append(CARRIE)
    except AttributeError:
        if node.music is None:
            node.music = [CARRIE]
        else:
            node.music = [node.music, CARRIE]
    quip = universal.format_text([['''\mThe three make their way down towards the south edge of town, between Avaricum Square and the middle class housing. They''',
        '''stop outside of a large wooden building. The building is brightly lit with small, hovering balls of multi-colored flames.''', 
        '''The high-pitched, fevered, yet faintly haunting sound of a well-played harpsichord wafts out of the building.'''],
        ['''"What spell is this?" mutters''', name() + ",", '''gingerly reaching a bright purple flame. Even inches away, the flame''',
            '''gives off no heat.'''],
        ['''"Just a fancy variant of Spectral Light," says Carrie dismissively. "A parlor trick that just about anyone with a minimum of spectral''',
            '''talent can learn. Come on!"'''],
        ['''The three push into the tavern. The place is filled to bursting with a variety of men and women, all Carnutians. The men are all dressed in''',
            '''practical, but well-maintained wool and leathers, while the women wear wool dresses, and skirts in a variety of colors and styles.''',
            '''Though none of them are quite as nice as Elise's or Carrie's, they're still very close.'''],
        ['''"Hey ladies," says the bouncer, a massive, muscle-bound man''' + (''' larger even than Peter.''' if 'visited_blacksmith' in keywords() else
            '''.'''), '''"You going to sing tonight, Miss Elise?"'''],
        ['''"She's a Sister now, Bruce," says Carrie with a grin. "We're here to celebrate her ascension!"'''],
        ['''Bruce blushes, and bows his head in apologoy. "Apologies, Sister Elise. And congratulations. How long before you become a Sister, Miss''',
            '''Carrie?"'''],
        ['''"As soon as she stops fantasising about boys all day, and actually focuses on her work," says Elise with a playful smirk.'''],
        ['''Carrie smacks Elise's bum. "I do not fantasize about boys all day."'''],
        ['''"Careful missy," says Elise with mock sternness. "Smacking a sister is a slippering offense."'''],
        ['''Carrie sticks her tongue out at Elise.'''],
        ['''"Anyway," says Bruce, a touch warily. "Whose your friend?"'''],
        ['''"Oh, this is''', name() + ',"', '''says Carrie, taking''', names(), '''arm. "Yeah, yeah''', heshe() + "'s", '''Taironan, but Elise will''',
            '''pay for''', hisher(), '''drinks, and''', heshe(), '''won't get in any fights or anything."'''],
        ['''"I will?" says Elise, blinking.'''],
        ['''"'I won't get in any fights or anything?'" says''', name(), '''sharply. "Excuse me? I'm not some violent thug."'''],
        ['''"Says the''', boygirl(), '''who walked into the Church wearing bloodstained, ragged clothing," says Carrie, rolling her eyes.'''],
        ['''"That wasn't my fault!" cries''', name() + "."],
        ['''"That's enough both of you," says Bruce. "I'm not going to throw anyone out for reasons other than them causing a ruckus. Anyway, are you''',
        '''planning on singing tonight Sister Elise? We always love it when you sing, and Carrie plays."'''],
        ['''Elise blushes. "Oh, I'm not that good."'''],
        ['''Carrie smacks Elise's bottom.'''],
        ['''"Oww! Hey!" yelps Elise. "What did I tell you about smacking Sisters?"'''],
        ['''"You know I hate it when you get that whole false modesty thing going," says Carrie, putting her fists on her hips.'''],
        ['''"It's not false," says Elise indignantly.'''],
        ['''"Then you're oblivious!" cries Carrie. "Either way, it's annoying."'''],
        ['''Bruce sighs.'''],
        ['''"So I have to ask," says''', name() + ".", '''"Are they always like this?"'''],
        ['''Bruce nods, his lips twisting. "There've been a few times where I've nearly had to throw them both out. They always seem to stay just''',
        '''shy of blows, though, thank the Parents."'''],
        ['''"Besides," Elise was saying. "Everytime I get up there and sing, I end up getting tipsy, and I end up singing 'Lady in the Hay,' and then''',
            '''Sister Samantha always finds out, and I get paddled."'''],
        ['''"Oh come on, that won't happen this time, I promise," says Carrie.'''],
        ['''"You say that every time!" cries Elise, throwing her hands in the air.'''],
        ['''Bruce rolls his eyes. "It's not that big a deal if you don't. Just have some fun tonight, and if you change your mind, let us know."'''],
        ['''"That sounds like a good idea," says Carrie. She grabs''', names(), '''arm. "Come on, let's get the party started!"'''],
        ['''How does''', name(), '''react to the crowded tavern?''']])
    node.children = [ep1_tavern_shy, ep1_tavern_outgoing]
    return quip

ep1_tavern_shy = Node(291)
ep1_tavern_shy.comment = '''Feel overwhelmed, and just find a corner to sit.'''
def ep1_tavern_shy_qf():
    add_keyword('introvert')
    ep1_tavern_shy.quip = universal.format_text([[name(), '''sways dizzily as the full force of the crowded tavern hits''', himher() + ".", '''People are''',
        '''crammed into every possible available space, to the point that one can't take a breath without bumping into someone else. People are yelling''',
        '''and screaming, and laughing, supersaturating the air with their obnoxious, drunken, horrific voices. A lute player, ''',
        '''rebec player, and drummer join the harpsichord player, adding their 'voices' to the cacophony. The only mercy is that the wretched instruments have''',
        '''drawn most people onto the dance floor, giving''', name(), '''just enough space to wiggle into a small corner, collapse at a table, and''',
        '''wish desperately for the Vengadores to attack, just so that''', heshe(), '''has something to take''', hisher(), '''mind off the noise,''',
        '''and the crowds, and the weird-ass lights.'''],
        ['''Something tugs at''', hisher(), '''arm.'''],
        [HeShe(), '''looks up with a scowl. "What?"'''],
        ['''"What are you doing here?" yells Carrie over the din. "Come on, let's hit the floor."''']])
    if p.PC.is_male():
        ep1_tavern_shy.quip = universal.format_text([ep1_tavern_shy.quip, ep1_tavern_shy_male(ep1_tavern_shy)])
    elif p.PC.is_female():
        ep1_tavern_shy.quip = universal.format_text([ep1_tavern_shy.quip, ep1_tavern_shy_female(ep1_tavern_shy)])
ep1_tavern_shy.quip_function = ep1_tavern_shy_qf

def ep1_tavern_shy_female(node):
    add_keyword('shy_female')
    try:
        node.music.append(PETER)
    except AttributeError:
        if node.music is None:
            node.music = [PETER]
        else:
            node.music = [node.music, PETER]
    quip = universal.format_text([[name(), '''shakes''', hisher(), '''head. "I don't think so."'''],
        ['''"Aww, come on why not?" yells Carrie, her voice almost completely lost in the din. "It'll be fun."'''],
        [name(), '''cranes''', hisher(), '''neck to look at the crowded floor. "I don't think so."'''],
        ['''Carrie looks hurt. "But I thought, you were so excited..."'''],
        ['''"It's too cursed loud!" yells''', name() + "."],
        ['''"Aww, come on, you'll get used to it," yells Carrie.'''],
        ['''"I don't want to get used to it!" snaps''', name() + "."],
        ['''"OK, OK," yells Carrie, holding up her hands. "Sorry."'''],
        ['''She turns and weaves onto the dance floor, joining Elise, who throws''', name(), '''a concerned look, before turning her attention to her''',
            '''friend and the music.'''],
        [name(), '''orders a drink, something that doesn't look too foul tasting, and slumps in her chair. Coming here was a mistake. Why did she''',
        '''always''', '''do''',
        '''this? Oh yeah, sounds like a lot of fun, until you get there, and you can't breathe, and you're barely there a minute before your ears''',
        '''are aching, and all you can think about is the sweet, cool, quiet, free nighttime air. And you long for some, nice, quiet conversation,''',
        '''not the drunken braying that so many people have deluded themselves into calling "fun."'''],
        [name(), '''puts her cheek in her hand, and fiddles with her drink. None of the men approach her. While''', name(), '''is fairly certain it has to do with her dark skin more than anything, she''',
            '''really doesn't care. She doesn't want to have to deflect any awkward, drunken passes anyway.''']])
    if 'flirting_with_Peter' in keywords() and 'flirting_spank_by_Peter' in keywords():
        quip = universal.format_text([quip, universal.format_text([['''\mInstead, she finds herself fantasizing about Peter. She squirms a little, as she imagines''',
        '''the burly''',
        '''blacksmith entering the tavern. He'd tower over everyone else, his blue eyes would seem the room and lock on her. He'd frown slightly,''',
        '''and start to push his way through the crowd. She'd notice his gaze, and begin gnawing on her lip nervously, while alternating between''',
        '''tugging on the top of her dress in a vain effort to make it cover more, and leaning forward, or arching her back in an effort to give''',
        '''him a good look.'''],
        ['''"What do you think you're doing?" he'd ask in a stern voice, his hands resting lightly on his thick leather belt.'''],
        ['''"What do you care?" she'd ask curtly.''']])])
        quip = universal.format_text([quip, universal.format_text([[universal.format_line(['''"I care, because I don't take kindly to my daughter's tutor getting shift-faced in a dress''',
            '''three sizes too small."''']) if 'teaching_Anne' in keywords() else '''"I care, because I don't take kindly to a close adult, female''',
            '''Taironan friend getting shit-faced in a dress three sizes too small."'''],
            ['''"What does that have anything to do with it?" she'd ask angrily.'''],
            ['''"Because you're a grown Taironan woman, and Anne doesn't have a mother. She'll look up to you, try to emulate you." He'd''',
                '''slam his hands onto the table. He'd lean over her, his breath hot on her face, his body blocking out everything else. She'd''',
                '''shrink back against her chair, nervously gnawing at her fingernails. "And I will not let my baby girl emulate some scantily-clad''',
                '''drunken bimbo!"'''],
            ['''"I am not a scantily clad, drunken bimbo!" she'd retort angrily. Then, she'd glance down at her half-bare, heaving chest. "Well, I'm''',
                '''not a drunken bimbo, at least."'''],
            ['''"And what's that in your hand?" he'd ask angrily.'''],
            ['''"What, this?" she'd say, looking down at her mostly empty tankard. "Just some foul-tasting alcoholic horsepiss."'''],
            ['''"If it's so bad tasting, why'd you drink it?" he'd ask.'''],
            ['''"Because..." At this point, she'd hesitate. An innocent smile would spread across her face. "Because, um, I like it?"'''],
            ['''"Even though it's foul-tasting," he'd say in a flat voice.'''],
            ['''"Um, yes?" she'd say.'''],
            ['''"Right." He'd grab her by the arms, and easily lift her in the air. Then, he'd spin her around, and bend her over the table.'''],
            ['''"Hey!" she'd squeal, as she'd feel her short dress ride up, and a blast of hot hair caresses her suddenly exposed lower buttocks.'''],
            ['''"You young lady have earned yourself such a spanking," he'd say, his hard hand smacking into her exposed lower cheeks.'''],
            ['''"But I didn't do anything!" she'd yelp, squirming against the table.'''],
            ['''"Your ass is peeking out from underneath your dress!" he'd roar, swatting her bottom with fast, heavy smacks. "You're drinking for the''',
                '''sole purpose of getting drunk! And you'd probably go home with some random guy you've never met, and have no reason to trust if I''',
                '''hadn't come in here! I think that qualifies as something!"'''],
            ['''She'd try to protest more, but her words would be smothered by her squeals of pain as his heavy hand lights a fire in her bum. She'd''',
                '''look around, and see the whole tavern watching, including Elise and Carrie, and she'd blush at being dominated so completely and''',
                '''so publicly.'''],
            ['''Then, he'd grab the hem of her dress and start to lift it up over her bottom.'''],
            ['''"Wait, no!" she'd yelp, wiggling desperately.'''],
            ['''"Oh hush," he'd say. "It's not like isn't already half-raised-" Then he'd see her panties. "What are these?"'''],
            ['''"Erm, my underwear?" she'd say fearfully.'''],
            ['''"A thong," he'd say in a flat voice. "You're wearing a thong underneath a dress that only covers your ass when the stars are aligned''',
                '''and the moon full."'''],
            ['''"It was Carrie's idea," she'd say.'''],
            ['''Then, a heavy hand would crash into her bare bum, and she'd squeal.'''],
            ['''"Young lady, you've just earned yourself the belt," he'd say, slipping the thick, leather beast free.'''],
            ['''"No, not the belt!" she'd cry, rocking her hips desperately. "Please sir, I'm sorry, it won't happen again, just don't use the belt!"'''],
            ['''Then, the belt would snap across her bare, bouncing cheeks, the thong doing absolutely nothing to defend her. And oh, how she would''',
                '''howl! She'd buck against the table so hard, that it would start to scrape against the ground, and Bruce would have to come over''',
                '''and tell her to go easy on the table, or he'd take a turn at her ass.'''],
            ['''The belt would snap across her bottom over and over again, covering every inch in thick welts. At first, she'd buck and howl, but then''',
                '''she'd eventually stop flailing. She'd slump across the table and sob, submissively sticking her bum further out to give him''',
                '''a better target, so that he could better administer her well-deserved punishment.'''],
            ['''Then, it would stop. He'd lay the belt on the table, and his hands, so hard before, now soft and gentle, would stroke her welts. He'd''',
                '''gather the thin material of her thong in his fist, and pull it down to her knees. There'd be the faint thump of his trousers''',
                '''hitting the floor. He'd take her hips in a firm grip, and she'd gasp as he pushes up against her, his member sliding easily inside''',
                '''her. She'd drive her hips back, grinding her hot bottom against his waste, panting and moaning as-'''],
            ['''As she had sex in the middle of a crowded tavern.'''],
            ['''The fantasy bursts, and''', name(), '''rolls her eyes at herself. Yeah, that'd happen. She's pretty sure a spanking that brutal''',
            '''probably wouldn't be as fun she's imagining, either. Besides, the guy could surely find better suitors than some poor''',
            '''adventurer.'''],
            ep1_elise_sing(node)])])
    elif 'flirting_with_Peter' in keywords() and not 'lesbian_in_denial' in keywords():
        quip = universal.format_text([quip, ['''\mInstead, she finds herself fantasizing about Peter. She squirms a little, as she imagines him entering the tavern.''',
            '''He'd tower over everyone else here. His eyes would sweep the room, and settle on her. He'd break into a grin and approach.'''],
            ['''"Fancy seeing you here," he'd say, towering over her.'''],
            ['''"Hi," she'd say. She'd slowly stand, making sure to lean forward, and press her chest against the table as she stands. She'd turn a''',
                '''slow half-circle, her hips swaying back and forth, stopping with her back to him. She'd lean against the table, wiggle her hips,''',
                '''and throw him a sultry smile. "So, how do I look?"'''],
            ['''He'd step up to her, his body pressed forcefully against hers. He'd slip his arms around her, and lather hot kisses on her neck.''',
                '''"Very very naughty."'''],
            ['''She'd flush, and moan, grinding her ass against his loins, feeling him harden against her. "Then maybe you should punish me."'''],
            ['''Then, he'd spin her around, and throw her over his shoulder like a sack of grain. She'd yelp in surprise, blushing as she feels her''',
                '''dress ride up, and expose her lower cheeks. He'd give those cheeks a light smack, and then carry her home, lightly smacking her''',
                '''bum the whole way. She'd grind her hips against his shoulder, making him smack her a little harder. But not too much harder. Just''',
                '''enough to build a light sting and a bit of heat by the time they got back to the smithy.'''],
            ['''Once they reached the smithy, he'd set her back down on her feet, spin her around, lift her up again, and bend her over''',
                '''the counter. He'd grab the hem of her dress, and yank it up, exposing her brown, bobbing, thong-clad ass.'''],
            ['''"Such naughty underwear," he'd say, lightly smacking her bare cheeks. "I think someone wants to get fucked."'''],
            ['''"Yes," she'd gasp, grinding her hips against the counter, and then pushing her ass out at him. "Take me, I'm yours."'''],
            ['''"Not yet," he'd say. There'd be a slight thump, as his trousers fall to his ankles. "But you will be."'''],
            ['''He'd gather the thin material of her thong in one fist, and with a savage yank, pull them down to her knees. She'd moan, and press''',
                '''her legs together, earning another swat to her completely bare buttocks. "Spread your legs, woman."'''],
            ['''She'd slowly open up, rocking her hips, and arching her back.'''],
            ['''He'd grab her hips and step up against her, his member sliding inside her.'''],
            ['''She'd gasp, as he pushes his way gently but firmly inside of her, her fingers curling around the far end of the counter. She'd push''',
            '''her hips back, taking more, grinding her bottom against him. He'd begin to move, alternating between firm thrusts, and sensual''',
            '''swaying. She'd move in tandem, pushing back as he thrusts forward, rocking her hips in time with his sways.'''],
            ['''Then his daughter would walk in, complaining of a bad dream.'''],
            [name(), '''snaps out of her fantasy. She scowls, and begins drumming her fingers on the table. Stupid overly realistic fantasy.'''],
            ep1_elise_sing(node)])
    else:
        quip = universal.format_text([quip, ['''Eventually,''', heshe(), '''can't take it anymore, and slips outside into the cool, night air.''', HeShe(), 
            '''takes long, slow, deep''',
            '''breaths, reveling in the fresh, (though still foul-smelling) air.''', HeShe(), '''feels a cool breeze waft across''', hisher(), 
            '''face, chilling''', hisher(), '''hot, sweaty face. She approaches a simple stone bench sitting outside the tavern, and plops down''' + 
            (universal.format_line([''', only to jump back up with a yelp, her hands flying back to her angrily buzzing bottom. She rubs her tender tushy for a minute, then''',
                '''much more gingerly sits down.''']) if p.PC.numSpankings > 0 else '''.''')],
            ['''She sits like that for a while, idly running her toe through the dirt, just reveling in the relative peace of the outside.'''],
            ['''"Hey," says Carrie, sticking her head out the door. "What are you doing out here, Miss Boring?"'''],
            ['''"Being boring," says''', name() + ".", '''"No matter how hard I try, crazy parties just don't do it for me."'''],
            ['''"That's because you haven't had anywhere near enough to drink," says Carrie cheerfully, her face flushed, and her eyes wide and''',
                '''bright.'''],
            [name(), '''grimaces. "If you need to be drunk to enjoy something, it's not enjoyable."'''],
            ['''"Oh pffsh," says Carrie, waving her hand. "Come on. Let's have some fun."'''],
            ['''"No."'''],
            ['''Carrie frowns. "Why not?"''']
            [name(), '''shrugs. "I don't do crowded, noisy places very well."'''],
            ['''"And yet you're an adventurer," says Carrie. "I'm pretty sure adventuring involves fighting, which often involves crowds, and definitely''',
                '''noise."'''],
            ['''"Yeah, but I have larger concerns when I'm fighting," says''', name() + ".", HeShe(), '''leans forward, and rests his forearms on his''',
            '''knees. "Like not getting stabbed too often. Besides, it's a part of the job. Every job has crappy aspects you just have to grit your teeth''',
            '''and work through. I shouldn't have to grit my teeth and work through my recreation, though."'''],
            ['''"But, but you'll get used to it, and it'll be fun," says Carrie.'''],
            ['''"But I don't want to get used to it, I see no reason to get used to it," says''', name() + ",", '''standing and beginning to pace.''',
                '''"And I don't call drunken gyrating and pointless declarations at the top of my lungs, or awkward comments about a woman's boobs to''',
                '''be 'fun.'"'''],
            ['''"Oh," says Carrie. "Then why'd you come?"'''],
            ['''"Because," says''', name() + ".", '''"I don't know. A part of me thought maybe this time it'd be different. Another part just wants''',
                '''some friends, and you and Elise seemed nice."'''],
            ['''"Well, you don't need to come out with us to be our friends," says Carrie. She smiles wryly. "I know it may be hard to believe, but''',
            '''there are other things in my life than just dresses, boys, toys."'''],
            ['''"Riight, we're going to slide right on past that," says''', name() + ".", '''"But thank you. That's good to know."'''],
            ['''"Hey, what are friends for?" says Carrie. "Besides, this way we can friends, and I don't have to worry about you poaching on my men."'''],
            ['''"Indeed, how lucky," says''', name() + ",", '''rolling her eyes.'''],
            ['''"Now come on," says Carrie. "We've finally convinced Elise to sing. Only took a dozen people pleading, and four drinks to do it, too.''',
                '''Girl's in a good mood tonight. You going to come listen?"'''],
            ['''"So long as I don't have to dance, or sing with her," says''', name() + "."],
            ['''"That's fine," says Carrie.'''],
            ep1_elise_sing(node)])
    return quip

def ep1_tavern_shy_male(node):
    add_keyword('shy_male')
    quip = universal.format_text([[name(), '''shakes''', hisher(), '''head. "I don't think so."'''],
        ['''"Aww, come on why not?" yells Carrie, her voice almost completely lost in the din. "It'll be fun."'''],
        [name(), '''cranes''', hisher(), '''neck to look at the crowded floor. "I don't think so."'''],
        ['''Carrie looks hurt. "But I thought, you were so excited..."'''],
        ['''"It's too cursed loud!" yells''', name() + "."],
        ['''"Aww, come on, you'll get used to it," yells Carrie.'''],
        ['''"I said no!" snaps''', name() + "."],
        ['''Carrie looks hurt. Then she lifts her head, and gives''', name(), '''a glare. "Fine. You can sit here and be an ass. I don't care."'''],
        ['''She turns and weaves onto the dance floor, joining Elise. Elise throws''', name(), '''a concerned look before turning her attention to her''',
            '''friend and the music.'''],
        [name(), '''orders a drink, something that doesn't look too foul tasting, and slumps in his chair. Coming here was a mistake. Why did he always do''',
            '''this? Oh yeah, sounds like a lot of fun, until you get there, and you can't breathe, and you're barely there a minute before your ears''',
            '''are aching, and all you can think about is the sweet, cool, quiet, free nighttime air. And you long for some, nice, quiet conversation,''',
            '''not the drunken braying that so many people have deluded themselves into calling "fun."'''],
        [name(), '''thinks he notices a few women glancing his way, but he ignores them. He finds himself with absolutely no desire to interact with''',
            '''anyone.'''],
        ['''Eventually,''', heshe(), '''can't take it anymore, and slips outside into the cool, night air.''', HeShe(), '''takes long, slow, deep''',
            '''breaths, reveling in the fresh, (though still foul-smelling) air.''', HeShe(), '''feels a cool breeze waft across''', hisher(), 
            '''face, chilling''', hisher(), '''hot, sweaty face. He approaches a simple stone bench sitting outside the tavern, and plops down.'''],
        ['''"Hey," says Carrie, stepping out into the night air. Her face is flushed, and sweat has made her dress extra-clingy. She shivers as''',
            '''another cool breeze wafts across her exposed skin. She sits down next to him, just shy of physical contact. "I saw you run out. You''',
            '''looked kind of freaked."'''],
        [name(), '''shrugs. "I don't do crowded, noisy places very well."'''],
        ['''"And yet you're an adventurer," says Carrie. "I'm pretty sure adventuring involves fighting, which often involves crowds, and definitely''',
            '''noise."'''],
        ['''"Yeah, but I have larger concerns when I'm fighting," says''', name() + ".", HeShe(), '''leans forward, and rests his forearms on his''',
        '''knees. "Like not getting stabbed too often. Besides, it's a part of the job. Every job has crappy aspects you just have to grit your teeth''',
        '''and work through. I shouldn't have to grit my teeth and work through my recreation, though."'''],
        ['''"But, but you'll get used to it, and it'll be fun," says Carrie.'''],
        ['''"But I don't want to get used to it, I see no reason to get used to it," says''', name() + ",", '''standing and beginning to pace.''',
            '''"And I don't call drunken gyrating and pointless declarations at the top of my lungs, or awkward comments about a woman's boobs to''',
            '''be 'fun.'"'''],
        ['''"But that's just because you're not drunk yet-"'''],
        ['''"If you have to be drunk to enjoy it, it's not fun."'''],
        ['''Carrie sits in silence for a moment.''', name(), '''sits down next to her, feeling slightly sheepish for his outburst.'''],
        ['''"Sorry," says Carrie at last.'''],
        ['''"For what?" asks''', name() + "."],
        ['''"For dragging you along to something you hate," she says.'''],
        ['''"Well, hate's a strong word," says''', name() + ",", '''leaning back and putting his arms on the backrest of the bench, his arm barely''',
            '''brushing Carrie's shoulders. "More of a strong dislike. Besides, it's not like I complained."'''],
        ['''"Why didn't you?" asks Carrie, shifting a few inches closer to him, her thigh just shy of brushing against his.'''],
        [name(), '''leans his head against the back of the bench, and looks up at the few stars he can see through the bright Spectral Lights around''',
            '''the tavern. "I don't know. Back home, my friends would always talk about it, like it was this great, big fun thing you should do, and''',
            '''were always so confused why I refused. But of course, every time I went I was miserable. But then, you know, new city, new life. Day's''',
            '''been kind of hellish. I figured I'd try again. Nope. Still can't stand it. I don't know if I'm disappointed, or relieved. On the one''',
            '''hand, having everyone think you're strange is annoying. On the other, I really don't have an interest in this kind of thing."'''],
        ['''"Oh," says Carrie. She shifts closer to him. Her leg is most definitely pressed against his now. She puts a hand on his thigh, and looks up at him. "I'm still sorry, and I don't think''',
            '''you're strange."'''],
        ['''"That's just cause you don't know me very well," says''', name() + "."]])
    node.children = [ep1_elise_drop_arm, ep1_elise_shift_away_slightly]
    return quip

ep1_elise_drop_arm = Node(292)
ep1_elise_drop_arm.comment = '''Lower arm onto Carrie's shoulder.'''
def ep1_elise_drop_arm_qf():
    add_keyword('flirting_with_Carrie')
    ep1_elise_drop_arm.quip = universal.format_text([[name(), '''hesitates a moment, then lets his arm slip over Carrie's shoulders. She smiles, and snuggles''',
        '''up against him.'''],
        ['''"About time," mutters Carrie. "I was getting chilly."'''],
        ['''"If you don't want to be cold, then you should wear a dress that actually covers your ass," says''', name(), '''sardonically.'''],
        ['''"Hey, my ass is totally covered," says Carrie with mock indignation. She jumps up, pushes her round, protruding, bouncy (covered) bottom at him, and gives it a wiggle.''',
        ''''"See? See? It's significant portions of my chest, shoulders, and''',
            '''arms, that are the problem."'''],
        ['''"I stand corrected," says''', name(), '''with a chuckle, grabbing her around the waist, and pulling her back down next to him.'''],
        ['''Carrie rests her head on his shoulder. "That outfit does look good on you by the way."'''],
        ['''"If you make a snarky comment about how it would look even better on your bedroom floor, I will smack your bottom," says''', name() + "."],
        ['''Carrie looks up at him, and flashes a cheeky smile. "But it'd look even better crumpled on my bedroom floor."'''],
        ['''"Brat!" cries''', name() + ".", '''He flips her over his knee, and begins lightly smacking the seat of her tight, purple dress.'''],
        ['''Carrie squeals playfully, and alternates between kicking her legs, and rubbing against''', names(), '''thighs, her bottom visibly rolling beneath her''',
        '''deliciosly tight skirt.'''],
        ['''Then, someone clears their throat.'''],
        [name(), '''looks towards the door, while Carrie cranes her neck over her shoulder.'''],
        ['''Elise is standing at the door of the tavern, her hands on her hips, her face is flushed, her eyes are wide and bright, and her hair is''',
        '''damp. "Remember how I said I didn't trust you taking him to the bathhouse alone? Now, do you see how very right I was?"'''],
        ['''"Oh hush," says Carrie, wiggling her hips. "We're just having a little fun."'''],
        ['''"Well, I'm feeling a need to sing, and I need you on the harpsichord. So come on," says Elise.'''],
        ['''"Aww, poop," says Carrie, pouting. "And just when things were getting good."'''],
        ['''Elise rolls her eyes. "Thank the Mother I came out when I did, or it would have been the summer incident all over again."'''],
        ['''"Still don't remember it," says Carrie, clambering off of''', names(), '''lap. "You coming in,''', name() + '?"'],
        ['''"Yeah, just give me a minute," says''', name(), '''awkwardly crossing his legs.'''],
        ['''Carrie smirks, while Elise blushes. "Don't dawdle." She turns and follows Elise in, throwing an extra sway into her hips as they go.'''],
        ['''"Brat," mutters''', name() + ",", '''smiling.'''],
        ep1_elise_sing(ep1_elise_drop_arm)])
ep1_elise_drop_arm.quip_function = ep1_elise_drop_arm_qf

ep1_elise_shift_away_slightly = Node(296)
ep1_elise_shift_away_slightly.comment = '''Remove arm, and shift ever so slightly away.'''
def ep1_elise_shift_away_slightly_qf():
    ep1_elise_shift_away_slightly.quip = universal.format_text([[name(), '''slips''', hisher(), '''arm off the back of the bench, and shifts ever so slightly''',
    '''to the right, away from Carrie.'''],
        ['''A briefest of frowns cross Carrie's face. "You must think I'm pretty silly for enjoying this so much. Just another half-drunk bimbo."''']])
ep1_elise_shift_away_slightly.quip_function = ep1_elise_shift_away_slightly_qf

ep1_elise_bullshit = Node(293)
ep1_elise_pretty_much = Node(294)
ep1_elise_evasion = Node(295)
ep1_elise_shift_away_slightly.children = [ep1_elise_bullshit, ep1_elise_evasion, ep1_elise_pretty_much]

ep1_elise_bullshit.comment = '''"Bullshit."'''
def ep1_elise_bullshit_qf():
    add_keyword('flirting_with_Carrie')
    ep1_elise_bullshit.quip = universal.format_text([['''Carrie's eyes widen at the intensity of''', names(), '''tone.'''],
        ['''"Having fun does not make you a 'half-drunk bimbo,'" says''', name() + ",", '''his lips turning down into a scowl. "Just because I rank''',
            '''drunken parties somewhere between eating babies, and cleaning up after a dragon, does not mean you have to, or should, or that you're''',
            '''somehow 'inadequate' because of it. I mean, you're a month away from becoming a full Sister of the Matirian Church, and my Nana taught''',
            '''me enough about Sisters of the Matirian Church to know you don't become one by being a dummy. So, you ever say anything like that again, even in jest, and I will smack your bottom." He leans in close''',
            '''to Carrie. "And it won't be fun."'''],
        ['''"Yes, sir," says Carrie in a small voice.'''],
        [name(), '''suddenly gets a sheepish look on his face. He leans back, and awkwardly rubs the back of his head. "Erm, sorry about that. I get kind of intense''',
        '''sometimes."'''],
        ['''"That's fine. Intense is good. Nothing wrong with intense," says Carrie, her eyes still wide.'''],
        ['''The two sit in silence for a moment.'''],
        ['''"Did you really mean that?" asks Carrie hesitantly, looking down at her lap, and gnawing on a strand of hair. "I mean, you hardly know me, and I've been trying to get in your pants from the moment''',
        '''we met."'''],
        ['''"Yes, I really mean it," says''', name() + ".", '''"Do you really think I'd lie about something like that?"'''],
        ['''"I dunno," mutters Carrie, chomping more intensely on her hair. "I mean, I don't really know you that well."'''],
        ['''"Well, I wouldn't," says''', name() + "."],
        ['''At that moment, Elise comes out. "Huh. And here I expected you two to be tongue-kissing by now."'''],
        [name(), '''blinks at Elise.'''],
        ['''"She becomes a lot more forward when she's tipsy," says Carrie in a loud whisper.'''],
        ['''Elise sticks her tongue out at Carrie, who sticks her tongue out right back.'''],
        ['''"Anyway," says Elise. "I'm feeling the need to sing, and I need you on harpsichord."'''],
        ['''"But''', name(), '''and I are having a moment," says Carrie indignantly.'''],
        ['''"You'll have plenty of moments later. Right now, let's make some music!" Elise shouts the last word up to the sky.'''],
        ['''"Cock blocker," mutters Carrie, getting to her feet.'''],
        ['''"Nymphomaniac," says Elise.'''],
        ['''"So you coming?" asks Carrie, looking at''', name(),  '''hopefully.'''],
        ['''"Of course," says''', name()  + ",", '''standing. "I'm sure it'll be great."'''],
        ep1_elise_sing(ep1_elise_bullshit)])
ep1_elise_bullshit.quip_function = ep1_elise_bullshit_qf

ep1_elise_evasion.comment = '''"Well, I mean I hardly know you. Be a little quick to pass judgement like that, don't you think?"'''
def ep1_elise_evasion_qf():
    ep1_elise_evasion.quip = universal.format_text([['''Carrie smiles. "Does that mean you want to get to know me better?"'''],
        ['''"If only so that I can properly judge the ever-loving hell of you," says''', name(), ''' with excessive sobriety. "When I look down on''',
        '''people, I like to do it right."'''],
        ['''Carrie's grin widens. "Great. Because you have a fine ass."'''],
        [universal.format_text([['''"What did I say about excessive flirting?" asks''', name(), '''sternly.'''],
            ['''"That you find it flattering, and fun?" says Carrie, smiling innocently.'''],
            ['''"Seriously," says''', name() + ".", '''"Stop it. Or I will give you a very not fun spanking."'''],
            ['''"Oh, alright," says Carrie morosely.''']])
            if 'bothered_by_Carries_flirting' in keywords() else
            universal.format_line(['''"So great to know you've got your priorities straight," says''', name(), '''dryly, rolling his eyes.'''])],
        ['''Then, Elise comes out. "What, no tongue kissing?"'''],
        [name(), '''narrows one eye.'''],
        ['''"Oh don't mind her," says Carrie in a loud whisper. "She's downright blunt when she gets tipsy."'''],
        ['''"Come on, Carrie. I feel like singing, and I need you on harpsichord," says Elise, ignoring Carrie's jab for what must surely be the''',
            '''very first time in the history of ever.'''],
        ['''"Alright, alright," says Carrie, standing. She flashes''', name(), '''a grin. "You coming to listen? Don't worry, Elise'll make everyone''',
            '''shut up so fast, your ears'll pop."'''],
        ['''"Sure," says''', name() + ",", '''standing. "Let's hear it."'''],
        ep1_elise_sing(ep1_elise_evasion)])
ep1_elise_evasion.quip_function = ep1_elise_evasion_qf
            
ep1_elise_pretty_much.comment = '''"Pretty much."'''
def ep1_elise_pretty_much_qf():
    add_keyword('insulted_Carrie')
    ep1_elise_pretty_much.quip = universal.format_text([['''Carrie gives''', name(), '''a bewildered look. "What?"'''],
        ['''"I said pretty much," says''', name() + ",", '''standing and taking a few steps away from Carrie. "All you seem to care about is partying''',
            '''clothing, and sex. If that doesn't scream 'bimbo' I don't know what does."'''],
        ['''"But...but you've known me for only a few hours," says Carrie in a small voice. "How could you possibly know what I'm like."'''],
        ['''"Exactly," says''', name() + ",", '''sticking up one finger. "Only a few hours, and yet you've been trying to sleep with me literally''',
            '''from the moment we met. I think your actions are speaking loud and clear, don't you?"'''],
        ['''"I..." Carrie stands, and dashes back into the tavern.'''],
        [name(), '''stands for a moment, feeling a warm sense of smugness.'''],
        ['''Then Elise comes charging out. "You! Get your ass back to the Church, get your own wretched clothing back, and leave us the fuck alone!"'''],
        [name(), '''stares at Elise. "But-"'''],
        ['''"You are an inconsiderate, smug, judgmental jackass, and I want nothing to do with you," snarls Elise. "And to think Maria's been looking''',
            '''forward to seeing you for weeks. I didn't think her taste was this fucking bad."'''],
        ['''"Oh you can't seriously be-"'''],
        ['''"I. Said. OUT!" Elise points her finger down the road.'''],
        ['''Bruce comes out, his hand resting lightly on a cudgel swinging at his hip. "There a problem, Sister Elise?"'''],
        ['''"That depends," says Elise, crossing her arms and glaring at''', name() + "."],
        ['''"Fine, whatever," says''', name() + ",", '''turning in the direction of the Church. "I'll go."'''],
        ['''"Then, no, I don't think there will be a problem," says Elise, turning back to the tavern. "Now, I've got to go comfort my friend."''']])
    return (universal.acknowledge, [townmode.go, avaricumSquare])
ep1_elise_pretty_much.quip_function = ep1_elise_pretty_much_qf

ep1_tavern_outgoing = Node(297)
ep1_tavern_outgoing.comment = '''Hit the dance floor like it insulted Nana.'''
def ep1_tavern_outgoing_qf():
    add_keyword('extrovert')
    ep1_tavern_outgoing.quip = universal.format_text([[name(), '''Carrie, and Elise, all wind their way down to the crowded dance floor, pushing themselves into''',
        '''the mass of hot, sweaty bodies gyrating to the music.''']])
    if p.PC.is_male():
        ep1_tavern_outgoing.quip = universal.format_text([ep1_tavern_outgoing.quip, ep1_tavern_outgoing_male(ep1_tavern_outgoing)])
    elif p.PC.is_female():
        ep1_tavern_outgoing.quip = universal.format_text([ep1_tavern_outgoing.quip, ep1_tavern_outgoing_female(ep1_tavern_outgoing)])
ep1_tavern_outgoing.quip_function = ep1_tavern_outgoing_qf

def ep1_tavern_outgoing_female(node):
    quip = universal.format_text([['''Unfortunately, no matter how''', name(), '''swivels and wiggles, none of the men seem particularly interested in dancing with her. Carrie''',
        '''notices this, and tries to push a few men towards her, but none of them seem particularly interested.''', 
        universal.format_line([name(), '''deflates a little, and''']) if not 'lesbian_in_denial' in keywords() else universal.format_line([name(), '''isn't particularly bothered by that,''',
            '''except''']), '''as she glances''',
        '''about the dance floor, crowded to bursting with white men and women, she becomes acutely aware of her own dark skin. She starts to make her way off''',
        '''the dance floor, but then Elise grabs her, and pulls her into a dance with the Sister. Elise is apparently having trouble finding a partner too. So, the two women spend the night dancing and drinking together instead.''',
        '''Before too long,''', name(), '''starts getting a little bit too tipsy to dance and keep her feet, so she winds her way to a nearby table.''',
        '''Meanwhile, Elise yanks Carrie from the arms of some slender guy, and pulls her towards the stage.'''],
        ep1_elise_sing(node)])
    return quip

def ep1_tavern_outgoing_male(node):
    quip = universal.format_text([['''The three are barely on the dance floor, before Carrie is pressing her back against''', names(), '''chest. She begins to''',
        '''sway and weave, her substantial bottom grinding against''', names(), '''loins.''']])
    node.children = [ep1_tavern_outgoing_male_rub, ep1_tavern_outgoing_dont_rub]
    return quip

ep1_tavern_outgoing_male_rub = Node(298)
ep1_tavern_outgoing_male_rub.comment = '''Wrap your arms around Carrie, and pull her tight.'''
def ep1_tavern_outgoing_male_rub_qf():
    add_keyword('flirting_with_Carrie')
    ep1_tavern_outgoing_male_rub.quip = universal.format_text([[name(), '''puts an arm around Carrie's waist, and pulls her tight, rocking his hips against''',
    '''hers.'''],
    ['''She leans back against him, one hand going up to cup his face, while the other wraps itself around his hand. Carrie's soft bottom pushes against''',
        names(), '''loins, and''', names(), '''loins push back.''', '''He leans his head against Carrie's, getting a nice look down the front''',
        '''of her low-cut dress and deep into her heaving breasts. She notices his look, and gives him a playful swat on the side of the head. He responds''',
        '''by smacking her bottom. She hops a little, her bum bouncing and tightening beautifully. She flashes him a sultry grin, before''',
        '''getting back into the rhythm. The two move about''',
        '''the dance floor, their bodies swaying in perfect harmony, like two puzzle pieces come together.'''],
    ['''Right up until the moment when''', names(), '''boot scrapes against Carrie's ankle.'''],
    ['''Carrie flinches, and hops forward, grimacing.''', name(), '''winces. He leans forward and shouts "Sorry" into Carrie's year.'''],
    ['''Carrie flashes him a forgiving smile. Her face is flushed, and streaked with sweat. Her eyes are bright, and her lips slightly parted. She''',
    '''is breathing deeply, just shy of panting, her half-naked breasts bobbing up and down.  She gives him a quick peck on the lips, leaving a''',
    '''tingling fire on his mouth.'''],
    ['''"...mudskin....Carrie all to himself..."'''],
    [name(), '''tenses, and he straightens, his eyes sweeping the other dancers, looking for the bastard who-'''],
    ['''Soft hands touch his face, and pull him around to look down. Carrie has turned to face him, her breasts mashed against his chest, and her''',
        '''groin rubbing against his. There is a hint of worry in her eyes, and she slightly shakes her head.'''],
    [name(), '''grimaces, but wraps his hands around her hips, and pulls her into a slower dance, as the musicians shift into a less intense song.''',
        '''She's right of course. The men in here are likely craftsmen, lumberjacks, maybe servants of nobility: working stiffs with no combat''',
        '''training. However, there are a lot of them, and he isn't skilled enough to guarantee that he can defeat them without hurting''',
        '''them. Far better to ignore the racist twat, and focus on the voluptuous young woman pressing her breasts, legs, hips, and everything else''',
        '''against him.'''],
    ['''She smiles, and rests her head against his chest.'''],
    ['''Another hour or so passes in a blur of dancing, drinking, and fondling.'''],
    ['''Before long, however, things start getting a little bit too tilty for''', name(), '''to keep dancing, so he makes his way to an empty table''',
        '''and flops down''' +  (''', only to wince, and nearly jump back to his feet as his welts flare. Stupid crappy day.''' if p.PC.numSpankings > 0 
            else '''.'''),
        '''Carrie comes right after, plopping down in his lap. He pulls her against his chest, and runs a hand down her''',
        '''tights-clad thigh. She responds by squirming a little, her plump bottom rubbing deliciously against his lap.'''],
    ['''"Quit the squirming, you seductive minx," yells''', name(), '''into Carrie's ears. "Or I'll be forced to give that naughty bottom of yours a''',
        '''good spanking."'''],
    ['''Carrie leans back, flashes him a cheeky grin and proceeds to writhe around on his lap.'''],
    ['''A few seconds later, she's on her feet, half-yelping, half-moaning, while''', name(), '''holds her arm with one hand, and lightly slaps her bottom with the other, her''',
        '''cheeks visibly rolling beneath her tight clothing.'''],
    ['''"Hey, you two, quit the hanky-panky," yells Elise, coming up to their table. Like just about everyone else in the tavern, she's more than a''',
        '''little sweaty, causing her dress to cling even more seductively to her significant curves. "Carrie, come on. I'm going to sing, and I need''',
        '''you at harpsichord."'''],
    ['''Carrie pouts. "But-"'''],
    [name(), '''smacks her wobbling ass again. "Go join your friend, before I really spank your bottom."'''],
    ['''Carrie presses her finger against her mouth, and bats her wide eyes at''', name() + ".", '''"Do I really have to choose?"'''],
    ['''"Oh for the love of..." Elise grabs Carrie's hand and drags her down to the raised dais where the band is situated.'''],
    ep1_elise_sing(ep1_tavern_outgoing_male_rub)])
ep1_tavern_outgoing_male_rub.quip_function = ep1_tavern_outgoing_male_rub_qf

ep1_tavern_outgoing_dont_rub = Node(313)
ep1_tavern_outgoing_dont_rub.comment = '''Dance, but not necessarily with Carrie.'''
def ep1_tavern_outgoing_dont_rub_qf():
    ep1_tavern_outgoing_dont_rub.quip = universal.format_text([[name(), '''dances with Carrie for a time, before moving on, and trying to find other girls to dance with.'''],
        ['''Unfortunately, all the women would take one look at him, and prompty find someone else to dance with. He considers going back to dancing with Carrie, but''',
            '''she's having no problem finding dance partners, many of the men all leaping at the chance to dance with the curvy blonde. Fortunately, Elise is also''',
            '''having a bit of trouble finding dance partners (apparently her status as someone's fiancee is well known), so''', name(), '''spends much of the night''',
            '''dancing with her. While she doesn't try to fuse with her dance partner in the same manner as Carrie, as the night wears on''',
            '''and she has a few more drinks, she does start to dance in a very risque manner for a soon-to-be-married woman.''', name(), '''starts to suspect her''',
            '''difficulty finding dance partners is partially a sense of propriety, but mostly a desire for self-preservation.'''],
        ['''Eventually,''', name(), '''weaves back to a table, and plops down, too tired to keep dancing. Elise, meanwhile, grabs Carrie, practically yanking her out''',
            '''of the arms of a slender fellow, and drags her up to the stage.'''],
        ep1_elise_sing(ep1_tavern_outgoing_dont_rub)])
ep1_tavern_outgoing_dont_rub.quip_function = ep1_tavern_outgoing_dont_rub_qf
        

def ep1_elise_sing(node):
    songs = [ELISE, OMINOUS, ROLAND, CARLITA, GUARDS, CATALIN, CARLITA, ROLAND, CATALIN, ROLAND, CARLITA, ELISE, CARRIE, ROLAND, CARRIE]  
    try:
        node.music.extend(songs)
    except AttributeError:
        if node.music is None:
            node.music = songs
        else:
            node.music = [node.music] + songs
    quip = universal.format_text([
    ['''\mElise gets up on the stage, while Carrie takes the harpsichordist's place. She clears her throat, and begins to speak, her voice amplified by''',
        '''a touch of magic. "Hello everyone. For those of you who don't know me, my name is Elise. I wasn't planning on singing tonight, but all you schmucks wore me''',
        '''down, so''',
        '''I've decided to sing a few songs for you."'''],
    ['''There's a cheer from the regulars.'''],
    ['''Elise flushes, and she gives a broad grin. "I'm not that good."'''],
    ['''Carrie rolls her eyes and says something.''', name(), '''doesn't hear it, but Elise clearly does; her embarassed blush deepens.'''],
    ['''"Anyway," says Elise quickly. "I'll be singing three songs tonight."'''],
    ['''There's a groan.'''],
    ['''"Well if you want fewer-"'''],
    ['''"More!" shouts a rather slender, pale man.'''],
    ['''"But I'm not that-"'''],
    ['''Carrie says something, and holds her flat hand up.'''],
    ['''"Sorry," says Elise, clearly flustered. The tavern laughs good-naturedly. "But I'm kind of tired, and I think I'll stick to three. Don't worry though, at least''',
    '''two of them will be rather long. We'll start with a rendition of the Song of Roland, thirty-second song of the Second Canto of the Pandemonium Cycle, in honor''',
    '''of my fiance who, thankfully, isn't here. He wouldn't have taken''',
    '''too kindly to how I was dancing a few minutes ago."'''],
    ['''There's another chuckle.'''],
    ['''\mElise takes a deep breath, and glances back at Carrie, and the other band members. Carrie''',
        '''begins a tense, haunting, desperate melody. The other players gradually join in, adding their own instruments to the dread music.'''],
    ['''Elise closes her eyes, her hips swaying to the slow beat. The tavern goes completely quiet.'''],
    ['''She throws up her hands. A small sphere of golden light appears in the air above her head, surrounded by jagged, grey lines of light. A mass of dark, ugly red''',
    '''is making its way through the grey towards the sphere.'''],
    ['''She begins to sing. The song is an epic poem, taking place during the darkest time of the Pandemonium Wars. The Tyrant has driven the Mother's forces all the''',
    '''way back to to the Last Hope Fortress, a small, wretched thing nestled deep in the mountains. His massive army is marching through the Dread Pass, preparing to''',
    '''crush the Mother and Her forces once and for all.''', '''Elise throws up her hands, pushing the golden sphere, and red mass up higher. She creates a single, long''',
    '''line with a hint of womanly figure, along with other, small golden lines.'''],
    ['''The Mother and Her sixteen advisors work desperately on a solution. They decide that there is a small valley in the Dread Pass that the Tyrant's armies must''',
    '''pass''',
        '''through. If the Mother can trigger a rockslide on both sides of the valley, then the Tyrant's army will be trapped, and they will freeze in the rapidly''',
        '''approaching winter. But the Mother is still weak from the Crossing of the White. She will need to travel to the valley, and it will take her time to work''',
        '''Her magic. Far too much time.'''],
    ['''\mElise creates a long, slender blue line. Longer than the advisors, not as long as the Mother. The music shifts into an intense, rapid, valiant melody. General Roland steps forward. He offers to lead a group of''',
        '''volunteers, two hundred fifty-six strong, to meet the Tyrant's army. He will keep them in the valley long enough for the Mother to work Her magic. The long, golden''',
        '''line wavers. The Mother''',
        '''is distraught. Not only will he be outnumbered two hundred fifty-six to one, but he and his men will be trapped in the valley with the Tyrant's armies. But''',
        '''Roland is''',
        '''firm. Only he has the tactical skill to hold the Tyrant's army at bay with two hundred fifty-six men, and that is the most the Mother's army can spare. Still, the''',
        '''Mother refuses. The slender blue line flares. Roland speaks of the refugees: the innocent men, women, and children''',
        '''under the Mother's protection. He speaks of the murder of the men and boys, the rape of the women and girls that will ensue if the Tyrant takes Last Hope.''',
        '''He speaks of the two thousand twenty four years of darkness that will encircle the world if the Mother falls here. What is the lives of a mere two hundred''',
        '''fifty seven against that?'''],
    ['''The long, golden line shortens a little, before lengthening once more, and flaring. The Mother agrees.'''],
    ['''\mThe music takes on a sweet, sorrowful melody. Elise sweeps away the long golden lines. In their place, she creates another line, slightly shorter than Roland.''',
    '''It too is golden, but of a darker hue. Beside''',
    '''it is another, very short golden line with traces of blue. Roland is overlooking the city, his wife, Aleyna, next to him, their daughter Rachel in her arms. She''',
    '''asks why he must abandon them. Why he cannot send someone else to die. And he responds that he is. He is sending two hundred fifty-six to die. He must lead them,''',
    '''else they will fail, and the fortress will fall. He must go, he must fall, so that Rachel may grow and live. So that she may live a life of peace, and''',
    '''happiness. The blue and golden lines mingle. Roland pulls Aleyna tight, one last embrace.'''],
    ['''\mThen, those two lines are swept away. A small mass of blue emerges from the sphere of gold and marches to meet the overwhelming mass of red. All''',
        '''instruments fall silent, save the drums. The red and blue masses meet.'''],
    ['''\mA dark, intimidating, floor-shaking melody begins. Elise zooms in on the two masses. At the front of the red is a massive, painfully bright, pulsing line of''',
        '''black and red. The long blue line in front of the blue mass seems painfully dim, and short in comparison. The Tyrant laughs at Roland's showing, mocking''',
        '''his resistance. The Mother must have truly given up if this was the best army She could scrape together. Still, He has seen Roland's skill firsthand. He''',
        '''offers the general the chance to join Him. All the riches, women, and respect in the world will''',
        '''be his. The dark tones are overwhelming. The cause is hopeless. To fight means death. \mBut then, weaving its way through''',
        '''the dark tones is the same, sweet, sorrowful melody played before. The bright blue line flares daringly. Roland laughs in the Tyrant's face. The only''',
        '''riches he needs are food, clothing, and shelter for his family. The only woman he needs is his wife, and the only respect he needs is his daughter's.''',
        '''\mRoland draws his sword, and his army surges forward. The music shifts into the intense, rapid, valiant melody.'''],
    ['''The red and blue masses mingle and surge. For four days, and four nights the two armies battle. For every man that Roland loses, the Tyrant loses sixteen.'''],
    ['''But the Tyrant's army does not outnumber Roland's sixteen to one. It outnumbers Roland's two hundred fifty-six to one. Roland's army is pushed back, back to the''',
    '''very''',
            '''edge of the valley. His men cannot hold more than two hours. He receives a message. The Mother needs sixteen more.'''],
    ['''\mThe red mass has almost completely consumed the blue. The valiant melody fades away to the Tyrant's overwhelming march.'''],
    ['''A single, small point in the blue remnants flares. Roland stands up in his stirrups. He removes a golden crystal given to him by his wife, enchanted by the''',
            '''Mother. He shatters it, and the enchantment washes over him. He unleashes a great shout, his voice magnified one hundred and twenty eight times. He''',
            '''extolls his shoulders. He reminds them of the innocent men, women and children, the refugees of the Tyrant's greed. He''',
            '''describes the suffering that will wash over the land if they do not hold their ground. He speaks of their fallen comrades, the great''',
            '''sacrifices they made to stop the Tyrant. All their sacrifices will be in vain if they do not hold their ground. He speaks of their wives, husbands, sons,''',
            '''and daughters. Of their grim fates if they do not hold their ground.'''],
    ['''\mThe blue mass flares until its light is blinding. The valiant music surges, overwhelming the Tyrant's march.'''],
    ['''They hold for sixteen hours.'''],
    ['''The mountains begin to rumble. Peaks crumble. The Tyrant unleashes a scream of rage! Only now, when''',
            '''it is too late, does He understand their plan. He charges through the fighting men, and rams His twisted spear through Roland's chest. Roland screams out''',
            '''to his wife and daughter, and brings his blade down upon the Tyrant's head, shattering the weapon, forever scarring the Tyrant.'''],
    ['''\mThe trimphant music fades, replaced by the sweet, sorrowful melody. The red and blue masses fade, replaced by the dark gold line with the''',
    '''very very small gold line. Aleyna stands upon the ramparts, her eyes filled with tears. She clutches her child to her breast, her ears still ringing with Roland's final, defiant''',
    '''cry. She lifts Rachel up to see the first rays of the new day, a day she never expected her baby to see. The sorrowful melody fades''',
    '''ending on a single, uplifted, hopeful note.'''],
    ['''\mElise takes a deep breath. The bartender offers her and the musicians a drink, which they all gladly take. For a moment, the tavern is silent. Then, a great''',
    '''uproarious applause fills it.'''],
    ['''Elise smiles, and bows, her face bright red. "OK, that was kind of grim, I'll admit. So, how about something a bit more light-hearted? Like when the Trickster''',
            '''gave us fire?"'''],
    ['''\mElise then launches into a much more upbeat, light-hearted song about how the Trickster, on a whim, decided to learn how to control fire, and then teach it to''',
            '''humanity. Of course, She teaches it first to a couple of children, who promptly burn themselves. They then teach it to their parents, who promptly burn''',
            '''themselves. And so on down the line, until every person on Earth has been burned. The Mother is furious with the Trickster. The Trickster insists that once they''',
            '''get the hang of it, fire will benefit them, but the Mother is having none of it, and gives Her a solid switching.'''],
    ['''But then, the Trickster is proven right. People get the hang of fire, and use it to build better homes, to keep them warm in the winter, to craft better tools,''',
            '''to cook their food. The Trickster points this out, but the Mother refuses to admit to wrongdoing. Unfortunately for Her, the Father takes the Trickster's''',
            '''side, and gives the Mother a switching of Her own.'''],
    ['''While the story itself is fairly innocuous, Elise sings it in such a way that she makes the Mother look very silly and stubborn, and the Trickster''',
            '''very self-sacrificng and valiant.''', name(), '''is caught a bit off-guard by how irreverently Elise, a Sister of the Matirian Church, portrays the''',
            '''Goddess she has dedicated her life to. At the point where the Mother is being switched, she even goes so far as to stick her butt out, squirm and''',
            '''yelp''',
            '''as if she were the one being punished (needless to say, quite a few of the men enjoyed that display quite a bit). On the other hand, the woman's eyes''',
            '''are unusually wide and bright, and her face is very red. The girl might be''',
            '''more than a little bit tipsy at this point.'''],
    ['''Elise takes a deep breath, and another drink. A broad grin is on her face. Carrie leans in and says something to her. At first, Elise looks a bit reluctant, but''',
            '''a few more words from Carrie, and she's grinning broadly, and nodding.'''],
    ['''"Alright boys and girls," says Elise. "I feel a little bit bad that I'm only giving you three songs tonight. So for my last song, how about 'Lady in the Hay?'"'''],
    ['''There is a great shout of agreement and encouragement.'''],
    ['''Without further ado, Elise launches into the song, dancing sinuously to the rapid beat. It's a bawdy tavern song about a noblewoman''',
    '''who is very frustrated by her less than''',
            '''well-endowed (or resilient) nobleman husband. Unfortunately, none of the other noblemen, made soft and weak by generations of easy-living,''',
            '''can meet her needs either. Then, one day she stumbles upon the stableboy in the middle of relieving himself. Her eyes widen, and her lips part as she''',
            '''sees just how very well endowed the rough peasant is. As soon as he finishes, she swoops in on him, drags him to the stable, hauls him up into the''',
            '''hayloft, and convinces him to do all sorts of unseemly things to her. Her husband never catches on, never''',
            '''even considers the possibility that she could find satisfaction with such a lowborn, smelly, rough man. She thus has many male babies with the''',
            '''stableboy. They all grow to be equally well-endowed, making her family *the* family to marry into.'''],
    ['''There is a great wave of laughter, applause, and declarations of agreement from the tavern crowd once the song ends. Elise, her face bright red, and a broad''',
            '''grin on her face, bows over and over again.'''],
    ['''\m"Impressive!" shouts a rather tall, lean man as he steps up onto the stage. He is wearing a finely made blue shirt and matching trousers. He has a thick''',
            '''beard, and short-cut hair. He stands straighter than a post, and he carries himself with an easy, athletic grace. At first,''', name(), 
            '''doesn't recognize the man without his armor, but then''', heshe(), '''realizes with a start that it's the captain of the guard, the one from the guild. "Especially that last song. What was that you were saying about noblemen?"'''],
    ['''Carrie starts to laugh.'''],
    ['''Elise's smile turns sickly. "Hi, honey. Um, how, how long have you been here?"'''],
    ['''"Came in just when you made that quip about your dancing, and my approval," says the man. His voice turns stern. "Or lack thereof."'''],
    ['''The crowd laughs uneasily. A nobleman showing up was bad enough, but the Captain of the Guard?'''],
    ['''"So, you heard me sing the Song of Roland?" asks Elise, clearly trying to salvage the situation. "What did you think of the streams of light?''',
            '''It's my first time trying that in an actual performance."'''],
    ['''"Astounding," says Roland. He pulls Elise into a hug. "Added a whole new level to the performance. I've heard that song so many times I can recite it from''',
            '''memory, and I still got a bit teary-eyed at the end."'''],
    ['''Roland gives Elise a deep kiss, and the whole tavern cheers. Then he whispers something in her ear, and she squirms a little.'''],
    ['''"Well, that's it for tonight folks," says Elise, turning to the crowd. "Sorry, but I think I'll be going to enjoy a drink or two with my fiance."'''],
    ['''"So long as that drink is very watered down," interjects Roland. "Looks like you've had enough of the strong stuff for one night."'''],
    ['''Elise smiles innocently as the two walk off the stage, followed by Carrie.'''],
    ['''\mThe three make their way towards''', names(), '''table. Carrie slides in next to''', name() + ",", universal.format_line(['''her foot beginning to play with''', hishers()
        + "."]) if 'flirting_with_Carrie' in keywords() else universal.format_line(['''flashing''', himher(), '''a smile in the process.'''])],
    ['"' + name(), '''this is my fiance, Sir Roland Silverstone. Roland, this is''', name() + ".", HeShe(), '''is a childhood friend of Maria's, who just arrived''',
        '''in Avaricum."'''],
    ['''"Yes, the new adventurer," says Roland. He sits down in a nearby chair, and pulls Elise into his lap. Elise leans back against him, one hand idly fiddling with his beard. "Adrian told me you fought well at the Guild today. Said he hasn't''',
        '''been this impressed by someone since Maria walked through his door."'''],
    [name(), '''shrugs, not quite sure how to handle this man, Captain of the Guard, leader of the mind-controlling Puppeteers, the one man in the city ever Taironan''',
        '''with a brain stayed well away from. Now, here he was, sitting with''', names(), '''new friend Elise in his lap, complimenting the young adventurer.'''],
    ['''"We may have to hire you at some point," says Roland. "Hired Maria a few times, and she's always performed admirably."''']])
    node.children = [ep1_roland_despite_taironan, ep1_roland_how_meet_elise, ep1_taironan_no]
    return quip

ep1_roland_despite_taironan = Node(299)
ep1_roland_despite_taironan.comment =  '''"Even though I'm Taironan?"'''

def ep1_roland_despite_taironan_qf():
    ep1_roland_despite_taironan.quip = universal.format_text([['''Roland sighs, and shifts Elise a little in his lap. "I know you'll find this hard to believe, and for that''',
        '''I'm sorry, but we're not really out to get Taironans. My job is to defend everyone. However, there are a few problems: One, many of the Taironans living''',
        '''here are much poorer, and much more desperate, especially the Potion-addicted ones. Desperate people are more likely to commit crimes. This of course''',
        '''makes your average Carnutian distrust Taironans, which makes Taironans more desperate, which feeds itself in a vicious cycle. Two, I can't send my guards''',
        '''into the slums very often, because if I send them in groups of less than twenty, they get swarmed by Taironan gangs.''',
        '''Even if they don't attack, we get firebolts and other spells slung at us.''',
        '''Finally, even if we do try to investigate a crime committed against a Taironan, all the other Taironans clam up. Cooperating with the guards is only barely''', 
        '''above''',
        '''eating babies in their eyes. So, we can't solve any of those crimes. So, we stop wasting time trying, and so the only time we interact with Taironans is''',
        '''when we're investigating a crime committed by one against a Carnutian."'''],
        ['''Roland massages his forehead. "It's a horrible situation, and I don't know how to fix it. And now, we've got these lunatics who've convinced''',
        '''themselves that all their problems are our cursed fault, rather than a combination of bad circumstances, our mistakes, and their mistakes."'''],
        ['''"Calm down, baby." Elise pulls Roland into a quick, comforting kiss. "Let's not think about that tonight."'''],
        ['''Roland sighs, and gives Elise's leg a pat. "You're right. Don't know what I'd do without you."'''],
        ['''"Probably go crazy and kill everyone," says Carrie, putting her cheek in her hand and smirking at the couple. "And it's all thanks to me."'''],
        ['''Roland rolls his eyes, while Elise blushes and starts to fidget.'''],
        ['''"Is this another one of Carrie's boasts?" asks''', name(), '''sardonically.'''],
        [universal.format_line(['''Carrie lightly smacks''', name(), '''upside the head, and then yelps when he pulls her to her feet and smacks her bum a few times.''']) if 
            'flirting_with_Carrie' in keywords() else universal.format_line(['''"I don't boast," says Carrie with exaggerated indignation. "I always tell the complete truth."'''])],
        ['''"While Carrie is exagerating a little bit, she's not that far off," says Roland. "See-"'''],
        ['''"Oh, do we really have to talk about it?" asks Elise. "It's embarassing."'''],
        ['''"Then think of it as part of your punishment for your actions tonight," says Roland.'''],
        ['''Elise pouts, but doesn't say anything else.'''],
        ep1_elise_meeting_roland(ep1_roland_despite_taironan)])
ep1_roland_despite_taironan.quip_function = ep1_roland_despite_taironan_qf

def ep1_elise_meeting_roland(node):
    try:
        node.music.append(ELISE)
    except AttributeError:
        node.music = [ELISE] if node.music is None else [node.music, ELISE]
    quip = universal.format_text([['''\mRoland leans back in his chair. "Let's see, it was what, three years ago?"'''],
        ['''Elise rolls her eyes. "Four, oh loving fiance."'''],
        ['''"Excessive beauty messes with a guy's sense of time, alright?" says Roland.'''],
        ['''"Nice save," says Carrie.'''],
        ['''"It would be," says Elise sardonically. "Except he's used it before."'''],
        ['''"Anyway," says Roland quickly. "We were all at the Lowen Monastery, a few days to the north, for the summer. Gorgeous place. Rolling hills, lots of forested''',
            '''paths, and in a fairly safe, prosperous region. I was reading a treatise by Brother Vincent, when Elise starts tearing into Vincent's work like he'd''',
            '''insulted the Mother."'''],
        ['''"Called his work a load of hogwash, I believe," says Elise, lightly tapping her lip. "I was being charitable, too."'''],
        ['''"Anyway, she starts going on in detail about all the ways his work is wrong, incoherent, or downright contradictory," says Roland, a large grin on his face.''',
            '''"She then starts rattling through a list of authors who she claimed did know what they were talking about. But then-"'''],
        ['''"I sneaked up behind Roland, and dumped a bucket of hogwash all over him," says Carrie, her eyes gleaming.'''],
        ['''"You're kidding," says''', name() + "."], 
        ['''"Nope. See, we were spending the summer at the Monastery''',
        '''as part of our training, and at one point we met Roland. He was a handsome devil, so naturally I was being my normal, flirtatious self. And he rebuffed me!''',
        '''Very rudely too, I might add," says Carrie indignantly.'''],
        ['''"Well what did you expect?" asks Roland defensively. "You were acting like a male-obsessed bimbo. I can't stand male-obsessed bimbos."'''],
        ['''"I was not," retorts Carrie.'''],
        ['''"Anyway," says Elise loudly. "That was bad enough, but I managed to turn the conversation to more philosophical topics, and it came up that Roland was a fan''',
            '''of Brother Vincent."'''],
        ['''"I was young and stupid, alright?" says Roland. "And besides, my master from way back when I was a squire had been a fan of Vincent's work. I just hadn't''',
            '''had an opportunity to explore other scholars in more detail."'''],
        ['''"You don't need to explore other scholars in more detail to know he was nothing but a mysogynistic, incompetent louse whose work could only possibly appeal''',
        '''to either the ignorant, or all the other mysogynistic incompetent louses," says Elise angrily.'''],
        ['''"So, needless to say," interjects Carrie. "Elise and I were both a little miffed with him. Then, one day I spied him sitting on a bench, reading''',
            '''some treatise of Brother Vincent's. I hatched a daring plan. I got some hogwash from our chores earlier in the day, and sent Elise to distract him''',
            '''while I snuck up and dumped it all over him. As soon as I dumped it, Elise ran in one direction, while I ran in the''',
            '''other, so Roland could only chase after one of us. We figured he'd chase after me, because you know, I did the dumping."'''],
        ['''"But he chased after me instead!" cries Elise, shifting a little on Roland's lap. "The big brute ran me down, hauled me over his knee,''',
            '''flipped up my skirt, and spanked me over my panties, right there in front of everyone. And I didn't even do anything but insult his''',
            '''precious Brother Vincent!"'''],
        ['''"Oh come on," says Roland. "It was blatantly obvious that you were involved in the prank. For one thing, Sister Samantha had warned me about you two when''',
            '''she saw us chatting the first time. For another, you bolted like a jack rabbit as soon as the hogwash hit. Maybe if you'd stayed still and acted shocked,''',
            '''I would have''',
            '''thought only Carrie was guilty."'''],
        ['''"But she's the one who dumped the hogwash on you," says Elise.'''],
        ['''"And you were using a fascinating, insightful discussion as nothing but a distraction," says Roland.'''],
        ['''"You know, you could have just scolded me," mutters Elise, squirming in Roland's lap.'''],
        ['''Roland rolls his eyes. "Anyway, once I was finished, I dragged her by her ear back to my room. I got changed, shoved my ruined clothing at her, and marched''',
            '''her to a nearby stream."'''],
        ['''"And he made me clean his clothing!" cries Elise. "Of all the-"'''],
        ['''"'Completely just and appropriate punishments there could possibly be, it's a good thing he only made me wash his clothing, instead of baring my bottom and''',
            '''giving me the slipper,'" says Roland, a smirk tugging at his lip. "That is what you were going to say, right?"'''],
        ['''"Something like that," mutters Elise petulantly. "Fortunately, Sister Samantha caught wind of what happened, caught Carrie, and dragged her bright red''',
            '''bottom down to help me."'''],
        ['''"How is that fortunate?" cries Carrie, reaching back to clutch her bottom.'''],
        ['''"If I had to get spanked, it's only appropriate that you did too," says Elise.'''],
        ['''"Anyway, fortunately for the both of them, I'd set the book down when Elise came over and started lecturing me. Carrie angled the hogwash so that it''',
            '''missed the book. Aside from a few easily cleaned off droplets, the book was dry," says Roland.'''],
        ['''"Well, yeah. Ruining a book is the only thing that will get a student a caning," says Carrie. "I'm mischievous, not stupid."'''],
        ['''"After they finished, I invited Elise to join me at the library, so that she could show me some of the scholars she was talking about," says Roland. A broad''',
            '''grin spreads across his face. "We spent much of the summer in the library together, discussing and exploring various works. It was wonderful."'''],
        ['''Elise leans back against Roland's chest, a matching smile on her face. "Best summer I ever had. Once my bum healed, anyway."'''],
        ['''"Mother's love, you two are so boring," says Carrie, plopping her forehead against the table. "How did I ever become friends with you?"'''],
        ['''"Boundless optimisim," says Elise.'''],
        ['''"Anyway," says Roland, lifting Elise up, and setting her on her feet. "It's getting late, so we should probably get back to the Shrine, and get your spanking''',
        '''over with."'''],
        ['''A panicked expression contorts Elise's face.'''],
        ['''Roland rolls his eyes, and stands. "Oh come on. You knew you were destined to a tender bottom the minute I stepped on the stage. Let's just go and get it''',
        '''over with."'''],
        ['''Elise pouts, but obediently follows after him, Carrie and''', name(), '''bringing up the rear.'''],
        ep1_return_to_Church(node)])
    return quip

        

ep1_roland_how_meet_elise = Node(300)
ep1_roland_how_meet_elise.comment = '''"How did you meet Elise?"'''
def ep1_roland_how_meet_elise_qf():
    ep1_roland_how_meet_elise.quip = ep1_elise_meeting_roland(ep1_roland_how_meet_elise)
ep1_roland_how_meet_elise.quip_function = ep1_roland_how_meet_elise_qf

ep1_taironan_no = Node(301)
ep1_taironan_no.comment = '''"Over my dead body."'''
def ep1_taironan_no_qf():
    add_keyword('Carlitas_fate')
    ep1_taironan_no.quip = universal.format_text([['"' + name() + '-"', '''begins Elise.'''],
        ['''"Don't tell me to calm down," snaps''', name() + ".", HeShe(), '''points an accusatory finger at Roland. "I will sooner be put in the ground than work with''',
            '''a mind-raping, heartless piece of-"''']])
    if 'tried_to_help_Carlita' in keywords():
        ep1_taironan_no.quip = universal.format_text([ep1_taironan_no.quip, ['''"This is about that girl, isn't it?" cuts in Roland. "The one with the birthmark."'''],
            ['''"What?" asks Elise.'''],
            ['''Roland scowls, and leans back in his chair. He gestures at''', name() + ".", '''"This idiot tried to interfere with our efforts to take in one of the''',
                '''Vengadores-"'''],
            ['''"The only reason she joined-"'''],
            ['''"You have no idea why she joined!" roars Roland, slamming his fist on the table. "And it doesn't matter anyway. Either way, she attacked a group of''',
                '''law-abiding citizens with zero justification. You're lucky I didn't have you arrested for interfering with her arrest!"'''],
            ['''"She's nothing but slinger fodder," spits''', name() + ".", ''''"She doesn't know anything about the Vengadores. She doesn't know where their hideout is''',
                '''or who their leader is. She's just some poor, half-starved girl who got dragged into someone else's war!"'''],
            ['''"You don't know that," snaps Roland. "Unless you're a puppeteer-"'''],
            ['''"No, I respect other people's basic decency," says''', name() + "."],
            ['''Roland takes a deep breath. "Look. What will happen is we'll hold her for a few weeks, maybe a month, until we can get a''',
                '''puppeteer to look at her. Then if she doesn't know anything like you claim, we'll plant a few hooks in her to keep her from rejoining the Vengadores,''',
                '''and release her."'''],
            ['''"Hooks?" says Elise, aghast. "Roland-"'''],
            ['''"Don't you dare try to chastise me, woman," snarls Roland. Elise shrinks down, her fists starting to twist in her dress. He sighs, and takes''',
            '''a deep breath. He gives Elise a hug.''',
                '''"Sorry, honey. Look, either we plant a few hooks in her, or we lock away in a dungeon to rot. I think she'd prefer the former, don't you?"'''],
            ['''"I guess," says Elise. "But still-"'''],
            ['''"She's a criminal," says Roland sharply. "End of story. I am being exceptionally merciful as it is. Many think I'm being too merciful. So please, don't''',
                '''push me to be more."''']])
    else:
        ep1_taironan_no.quip = universal.format_text([ep1_taironan_no.quip, ['''"How in the Mother's name is upholding the law  heartless?" snaps Roland.'''],
            ['''"Honey-"'''],
            ['''"Oh I don't know, how about arresting a bunch of half-starved Taironans who were nothing more than slinger fodder, and patting yourself on the back-"'''],
            ['"' + name() + '-"'],
            ['''"I didn't 'pat myself on the back!'" roars Roland. "Do you think I enjoy dragging people kicking and screaming into the dungeons? DO you think I like''',
                '''watching my puppeteers dig into the deepest corners of their soul-"'''],
            ['''"Well you sure as curses don't seem to be losing any sleep over it!"'''],
            ['''"I will not let my job consume my life!"'''],
            ['''"Guys, please-"'''],
            ['''"'Your job?' That's all it is? We're talking about people's lives!"'''],
            ['''"Oh really? Wow, I never would have known that if it wasn't for you standing here, pointing it out-"'''],
            ['''"Is there a problem?" asks Bruce, stepping up next to the table.'''],
            [name(), '''glances about, and realizes with a start that the entire tavern has gone silent, everyone staring at''', name(), '''and Roland. Well, mostly''',
                '''staring at''', himher() + ".", name(), '''begins to feel acutely uneasy as''', heshe(), '''considers the hostility in some of those stares.'''],
            ['''Roland takes a deep breath. "No. No problem. Just an argument between friends."'''],
            ['''"I see," says Bruce. He gestures at''', name() + ".", '''"Well, if''', heshe(), '''gives you any trouble. Let me know."'''],
            ['''"And what if he gives me any trouble?" asks''', name(), '''angrily.'''],
            ['''"If he gives you trouble, it'll because it's guard business, and I don't get involved in guard business," says Bruce, walking away.'''],
            ['''"I think it's best that we stop, before we trigger a bar fight," says Roland, glancing at everyone.'''],
            ['''"Fine, but this isn't over," says''', name() + "."],
            ['''Roland rolls his eyes. "Indeed. I wish it was. Honey, you can stop twisting your dress. The moment of crisis is past."''']])
    ep1_taironan_no.quip = universal.format_text([ep1_taironan_no.quip, ['''Elise nods, and frees her fists from her dress.'''],
            ['''"You really need to stop doing that," says Roland. "It is exceptionally unladylike, and it will ruin your dress."'''],
            ['''"Sister Samantha says the same thing," says Carrie.'''],
            ['''"Sister Samantha is an exceptionally intelligent woman," says Roland. He gives Elise a kiss on the cheek. "Seriously, honey. I really don't want to have''',
                '''to start smacking your bottom to make you break the habit, but I will if I have to."'''],
            ['''"You know," says Elise coyly. "I think I'd do a better job if you rewarded me everytime I get nervous, but don't do it."'''],
            ['''"Oh really?" says Roland with a chuckle. "And what did you have in mind?"'''],
            ['''Elise glances at her friends, then leans in and whispers something to Roland.'''],
            ['''Roland's face heats, and then he laughs. "I guess we can do that. But until you break the habit, you'll only get that when you're nervous, and don't''',
                '''twist your dress."'''],
            ['''"OK," says Elise, snuggling up against Roland's chest. "Guess I'll have to break the habit pretty quickly."'''],
            ['''Carrie laughs, and glances at''', name() + ",", '''but''', heshe(), '''doesn't join in.''', HisHer(), '''thoughts are still on that girl.'''],
            ['''"Hey," says Carrie, leaning forward. "You know what would make a great story? Telling''', name(), '''how we all met."'''],
            ['''"That sounds like a great idea," says Roland.'''],
            ['''"Do we have to?" asks Elise. "It's so embarassing."'''],
            ['''"Then think of it as part of your punishment for tonight," says Roland, patting Elise on the thigh.'''],
            ['''Elise pouts.'''],
            ['''"You know, I don't particularly care," says''', name() + ",", '''standing. "I think it's best if I just leave, now."'''],
            ['''"That's probably for the best anyway," says Roland, setting Elise on her feet, and standing.'''],
            ['''A panicked expression contorts Elise's face.'''],
            ['''Roland rolls his eyes, and stands. "Oh come on. You knew you were destined to a tender bottom the minute I stepped on the stage. Let's just go and get it''',
        '''over with before it gets too late."'''],
            ['''Elise pouts, but obediently follows after him. Carrie and''', name(), '''bring up the rear.'''],
            ep1_return_to_Church(ep1_taironan_no)])
ep1_taironan_no.quip_function = ep1_taironan_no_qf

def ep1_return_to_Church(node):
    quip = universal.format_text([['''"I still don't see why I'm getting spanked," mutters Elise as the four make their way back to the Church. "I was just having fun."'''],
        ['''"Where to begin," says Roland, raising his eyes to the sky. "I know, how about we start with the location. Talan's Tavern-"'''],
        ['''"Carrie and I have been going there for years," says Elise, skipping around a rather foul smelling pit of ... something. "Sister Samantha's never had a''',
            '''problem with that."'''],
        ['''"Because there is nothing wrong with an orphan-turned-Sister-in-training going there, so long as she behaves herself," says Roland. "It's probably not''',
            '''even a problem for an orphan-turned-Sister to go there. However, that's not what you are anymore. You are the fiancee of a lord of the Silverstone''',
            '''family. Granted, I'm probably the least important member of our family, but I'm still Silverstone. And the fiancee of a Silverstone does not spend her''',
            '''time at Talan's Tavern. We talked about this already. You knew what would happen if I caught you there."'''],
        ['''"I know," says Elise. She kicks a stone against a nearby building. "It's not fair."'''],
        ['''"I know," says Roland. He puts an arm around her shoulders and gives them a squeeze. "But Sister or not, your past is going to make it exceptionally''',
            '''difficult for you to earn the respect of the other families. If they find out you were writhing around on the stage of a craftman's tavern like a''',
            '''drunken tavern wench, it'll be all but impossible."'''],
        ['''"Well you certainly made it easy for them, didn't you?" asks Elise tartly, pushing away from Roland's grip. "Stepping up on stage in your fancy Silverstone''',
            '''outfit like that."'''],
        ['''"They were going to find out anyway," says Roland. "Only now, they'll also hear that I caught you. Also, in the next few days, I'll make sure word gets''',
            '''out of the very intense spanking I'm going to give you.''',
            '''Now, instead of being some low-born brat with delusions of standing whose successfully pulled the wool over her fiance's eyes, you're a low-born brat''',
            '''whose a little rough around the edges, but whose fiance is working tirelessly to help her achieve her potential as a Sister and a lady."'''],
        ['''"Well, maybe I don't care what they think." Elise stops, crosses her arms over her chest, and pouts. "Maybe they can all go get buried."'''],
        ['''Roland also stops and sighs patiently. "Honey, do you want our future children to be respected? Do you want them to have friends, find good spouses, and live''',
        '''fulfilling lives?"'''],
        ['''"Yes," says Elise hesitantly, sensing a trap.'''],
        ['''"Then you'll have to earn these people's respect. Well, those who matter anyway," says Roland, offering his arm for Elise to take. "Some people will''',
        '''hate you anyway, but people are like that, and those types are rarely particularly important."'''],
        ['''"But do you have to spank me?" asks Elise, reaching out to take her fiance's arm. "Couldn't you just 'get the word out-'"'''],
        ['''The words are barely out of her mouth before she's tucked under Roland's arm, his heavy hand smashing into her rolling bottom.'''],
        ['''"If you ever suggest I lie for you like that again," says Roland in a tight, angry, but controlled voice. "Then I will bare your''',
            '''bottom and spank you with your own slipper right then and there. Do you understand me?"'''],
        ['''"Yes, yes!" cries Elise, rocking her hips and stomping her feet. "I'm sorry, I'm sorry I wasn't thinking!"'''],
        ['''"That's another thing you'll have to learn to deal with," says Roland. There is still a trace of anger in his voice, but he is clearly working to make it as''',
        '''gentle as he can. He lets Elise straighten, and gives her bottom a rub. "You won't believe''',
        '''how out-of-hand a single''',
            '''thoughtless comment can get."'''],
        ['''"I hate the nobility already," mutters Elise, sniffing and rubbing her bottom.'''],
        ['''Roland pulls her into a hug, and kisses her on the forehead. "Yeah, me too. Why do you think I spend so much time at the guardhouse, or became a paladin''',
            '''of the Church? Believe me, I hate this as much as you, maybe even more, but we have to play the game if we want our kids to be successful."'''],
        ['''Elise hugs Roland back, and nuzzles her face against his chest.'''],
        ['''The four resume walking. Carrie leans in close to''', name() + ".", '''"See? Never marry into the nobility. Sure you get a pampered lifestyle, lots of''',
            '''fancy dresses, and food to die for, but your husband is always looming over you, ready to smack your bottom for the smallest of missteps."'''],
        [universal.format_text([['''"I don't know, that might do you some good," teases''', name() + ".", '''"Might finally learn to behave yourself."'''],
            ['''Carrie punches''', names(), '''arm, then yelps when''', hisher(), '''hand snaps down and cracks against her bottom.'''],
            ['''"See?" says''', name(), '''playfully.'''],
            ['''Carrie sticks her tongue out at''', himher() + "."]]) if'flirting_with_Carrie' in keywords() else universal.format_line([name(), '''nods. "Good to know."'''])], 
        ['''"Now, where were we?" asks Roland. "Well, there's your dress and dancing style-"'''],
        ['''"But you got this for me," cries Elise. "You said I look lovely in it."'''],
        ['''"Oh Mother's mercy do you ever," says Roland. "But that doesn't mean you can wear something like that when going out without me. It's rather inappropriate''',
            '''for a wife to wear when she's out with just her friends. And your dancing. Even if we ignore the stuff I didn't see on the dance floor, the way you were''',
            '''wiggling on the stage is not how a lady should dance. At least, not when she's in public. Nobleladys are supposed to be elegant, smooth. Hinting''',
            '''at their sexuality, not shoving it in everyone's face for a hundred kilometers in every direction. And that leads to the last thing.''',
            '''Singing 'Lady in the Hay.'"'''],
        ['''"Oh come on," says Elise. "It's just a song. It just pokes fun at the nobility. Not a big deal."'''],
        ['''Roland stops, and spins Elise around to face him. "Elise, what is that song about?"'''],
        ['''"A noblewoman who'd rather sleep with a commoner than a nobleman," says Elise uneasily.'''],
        ['''"And what are you on the verge of becoming?"'''],
        ['''"A noblewoman..."'''],
        ['''"And what are they?"'''],
        ['''"Commoners." Elise's eyes widen, as the source of Roland's concern dawns on her. "Roland, I've spoken with many of those men. They would never...It's just''',
                '''all in good fun..."'''],
        ['''"I know. They're likely all good, honest, hardworking men. But they're also drunk. And all it would take is one man whose a little bit too drunk, and a''',
                '''little bit too much of a scoundrel, for things to go a direction you never wanted it to go." Roland pulls Elise tight, and rests his forehead against''',
                '''hers. "Baby, I just don't want you hurt."'''],
        ['''"So I'm going to get spanked because you're afraid that one of those men might maybe someday take that song the wrong way," says Elise, pulling away from''',
        '''Roland and scowling.'''],
        ['''"No. You're going to get spanked for your first two offenses," says Roland. "Which essentially boil down to conduct unbefitting a Sister and a''',
                '''noblewoman. The last one just scares the shit out of me, and I wanted to talk to you about it."'''],
        ['''"I hate it when you're all reasonable like this," says Elise, turning and stomping a few steps farther down the street. "Hate it when you convince me that''',
                '''I made a mistake and should be punished. Why can't you just yell and spank me like other spouses?"'''],
        ['''"Because I don't want to have to spank you again," says Roland. "I hate spanking you. Well, these kinds of spankings anyway. The other kinds, the ones''',
                '''with the rubbing are lots of fun."'''],
        ['''Elise flashes him a smile, and lets him take her hand. The four finish the trip to the Church, Carrie getting visibly nervous as they get closer.''']])
    if 'flirting_with_Carrie' in keywords():
        quip = universal.format_text([quip, ['''"So, Elise," says Carrie, taking''', names(), '''arm. "Could you let Sister Samantha know that I'm going home with''', name(), 
            '''tonight? I'll see her tomorrow."''']])
        node.children = [ep1_carrie_home, ep1_carrie_too_fast]
        return quip
    else:
        quip = universal.format_text([quip, ['''Carrie is furiously chomping on her hair as the four start to ascend the Church steps. "Roland, do you really have to tell''',
            '''Sister Samantha that we went to Talan's? Between that and helping play 'Lady in the Hay,' I'll be in so much trouble."'''],
            ['''Roland frowns. "I've never heard of Sister Samantha having a problem with you going to Talan's."'''],
            ['''Carrie smiles weakly. "Well, earlier today, Sister Samantha told me directly not to take Elise to Talan's because it wasn't appropriate for a girl''',
                '''of her rising station. I may have ignored her."'''],
            ['''"Yeah, that's not happening," says Roland. He points the rest of the way up the stairs. "Up you go."'''],
            ['''"But Roland-"'''],
            ['''"You have a choice," says Roland curtly. "We can tell Sister Samantha and let her deal with it, or you can be punished by my Master Servant. He is''',
                '''very strong, and very, very good at making experienced brats like you squeal like a virgin-bottomed eighteen year old getting her first ever''',
                '''spanking."'''],
            ['''Carrie's face pales. "Um, no, I guess we can tell Sister Samantha."'''],
            ep1_sister_samantha(node)])
        return quip
  
ep1_carrie_home = Node(302)
ep1_carrie_home.comment = '''"Yes. Yes, Elise tell Sister Samantha Carrie will see her tomorrow."'''

def ep1_carrie_home_qf():
    add_keyword('taking_Carrie_home')
    person.get_party().add_member(carrie)
    ep1_carrie_home.quip = universal.format_text([['''"You can go home with''', name(), '''after we've spoken to Sister Samantha."'''],
        ['''"But Roland-"'''],
        ['''"Alternatively," says Roland curtly. "I can drag you back to my place, and have my Master Servant spank you. I can assure you he is much stronger''',
            '''than Sister Samantha, and is very very good at making experienced brats squeal like virgin-bottomed eighteen year olds getting their first ever''',
            '''spanking."'''],
        ['''Carrie hangs her head, and nods.'''],
        ep1_sister_samantha(ep1_carrie_home)])
ep1_carrie_home.quip_function = ep1_carrie_home_qf

ep1_carrie_too_fast = Node(303)
ep1_carrie_too_fast.comment = universal.format_line(['''"Hang on, Carrie, look. You are a lovely woman, and I would love to get to know you better, in erm, all sorts of ways.''',
'''But we just met today. That's a little bit too fast for me."'''])
def ep1_carrie_too_fast_qf():
    ep1_carrie_too_fast.quip = universal.format_text([['''Carrie lets out an annoyed sigh. "Figures you'd be the relationship type. Oh all right, fine. Time to go take my medicine."'''],
        ['''"It wouldn't have mattered anyway," says Roland. "We still would have gone in to see Sister Samantha."'''],
        ['''"Yeah, but at least that way, I'd get some comfort afterwards," mutters Carrie, sticking her tongue out at''', name() + "."],
        ['''"You know, I'm getting very tempted to spank you myself," says''', name() + ".", HisHer(), '''tone darkens. "After Sister Samantha is finished."'''],
        ['''Carrie slips a bit of hair in her mouth, smiles uneasily, then turns and walks rapidly up the steps.'''],
        ep1_sister_samantha(ep1_carrie_home)])
ep1_carrie_too_fast.quip_function = ep1_carrie_too_fast_qf

def ep1_sister_samantha(node):
    quip = universal.format_text([['''\mThe four climb up into the Shrine. Sitting inside are Maria and Sister Samantha.''', '''Sitting next to the two are a pair of''',
    '''wide, flat-backed hairbrushes, one bone and the other wood.''',
    '''The two go silent as the four enter.''']])
    node.add_song(MARIA)
    if 'lied_about_name' in keywords() or 'lied_about_Bonda' in keywords():
        quip = universal.format_text([quip, maria_lied(node)])
    elif 'slapped_Maria' in keywords() or 'disowned_Maria' in keywords():
        quip = universal.format_text([quip, maria_slap(node)])
    else:
        quip = universal.format_text([quip, maria_no_problems(node)])
    return quip


def maria_no_problems_qf(node):
    quip = universal.format_text([['''"Hey,''', name() + ",", '''says Maria, smiling broadly. She glances at''', names(), '''companions: Carrie, gnawing anxiously on a strand''',
        '''of hair, Elise anxiously twsting her skirts while Roland keeps a firm grip on her arms, and Roland's grim expression. "I see you three had fun."'''],
        ['''"Oh yes," says Roland flatly. "A wonderful night filled to bursting with irreverent songs, lewd dancing, and stable references."'''],
        ['''Sister Samantha sighs and rolls her eyes. "I swear, I could spank the both of you until you're fifty and you still wouldn't learn."'''],
        ['''"So, maybe you should try a different strategy?" suggests Carrie hopefully.'''],
        ['''Sister Samantha raises an eyebrow. "And what strategy would that be?"'''],
        ['''"Sending us to bed without supper?" suggests Carrie.'''],
        ['''"Making us clean the stables," pipes in Elise.'''],
        ['''"Making us write lines?" says Elise.'''],
        ['''Sister Samantha raises her other eyebrow. "So you're saying you want to be treated like children? An adult Sister on the verge of becoming a noblewoman''',
        '''would rather be cleaning out the stables like a pre-teen student caught putting a pinecone on her sister's chair. An equally adult student on the verge''',
        '''of becoming a Sister going to bed without supper, or writing lines, like a five year old calling her mothera butthead. That's what you want?"'''],
        ['''The two women exchange uneasy glances.'''],
        ['''"Well, no," says Carrie at last. "But aren't there other adult punishments that don't hurt quite so bad?"'''],
        ['''"I shouldn't be punishing you at all!" cries Sister Samantha. "You're an adult. Start acting like it!"'''],
        ['''Carrie shrinks away from Sister Samantha's sharp words. "Sorry, Sister."'''],
        ['''"If you're truly sorry, then you're going to march over there, raise your skirt, and bend over my knee," says Sister Samantha sharply, pointing towards''',
            '''the far corner. "Now, march young lady."'''],
        ['''Carrie nods morosely, and walks towards the corner, slipping another strand of hair in her mouth.'''],
        ['''Roland gives Elise a meaningful look, who sighs, and follows him towards a different corner, her hands drifting back to her soon-to-be-exposed bum.'''],
        ['''Maria's lips quirk. "Those two are quite a handful aren't they? Glad I'm neither Roland nor Sister Samantha." She takes''', names(), '''hand. "Come on.''',
            '''Let's step outside and give them some privacy. I heard you've had quite an interesting day. Why don't you tell me about it?"'''],
        ['''Maria leads''', name(), '''outside into the chilly evening air, pulling the door closed as the first sounds of two solid spankings begin to assault''',
            names(), '''ears. "So, I hear a group of Taironans attacked the guild not thirty seconds after you signed up."'''],
        ['''"Pretty much," says''', name() + ".", universal.format_line([HeShe(), '''considers sitting down. A twinge of pain from''', hisher(), '''aching bottom encourages''',
            himher(), '''to lean against the door instead.''']) if p.PC.numSpankings > 0 else universal.format_line([name(), '''plops down on one of the stairs, and sighs.'''])],
        ['''"So tell me about it," says Maria, half-sitting, half-leaning on the large stone railing.'''],
        [name(), '''launches into a brief outline of the events, focusing in particular on the swordswoman who originally attacked''', himher() + ",", 
            '''the young girl''', heshe(), '''beat at the very beginning, and the woman''', heshe(), '''fought in the armory.'''],
        ['''Maria shakes her head. "Ballsy move. Never imagined they'd attack the armory."'''],
        ['''"You know about them?" says''', name(), '''sharply.'''],
        ['''"Every Taironan in the city knows about them," says Maria. "You could hear the rumblings for months now. A strange, secretive group recruiting anyone with''',
            '''two arms, two legs, and a grudge against both the Carnutians, and the Potion Lords. Drug mules deserting, grown children vanishing, only to reappear a''',
            '''few weeks later armed to the teeth, and full of revolutionary zeal. Older folk growing worried, not letting their kids go out at night, reminiscing about''',
            '''the Riots. Skilled, eloquent men and women making speeches on street corners, deep in the slums and far away from the guards. A powerful slinger taking''',
            '''down dozens of Potion Lord lackeys."'''],
        ['''"So, what they were saying, about 'freeing us.' They were telling the truth?" asks''', name() + "."],
        ['''"As near as I can tell, they're sincere," says Maria uneasily. "Though I fail to see how sparking a two-front war with Avaricum and the Potion''',
        '''Lords 'frees' anybody."'''],
        ['''Before''', name(), '''can respond, the door opens up, and Elise and Roland come out. Elise's face is streaked with tears. She is holding Roland's hand''',
            '''with her right, while her left is clutching gingerly at her bottom.'''],
        ['''"Hey," says Maria, smiling. "Get through your spanking ok?"'''],
        ['''"Well, I'm still breathing," says Elise. "Hurts like a curse though. Roland's such a jerk."'''],
        ['''Roland rolls his eyes. "Oh please. Just be glad I let you seduce me into comforting you tonight."'''],
        ['''Elise grins, despite the hint of tears in her eyes. "Oh I am. I am."'''],
        ['''Maria chuckles as Roland Elise make their down the steps and towards the Inner Circle.''']])
    if 'taking_Carrie_home' in keywords():
        quip = universal.format_text([quip, ['''Carrie limps out a few seconds later. Her eyes light up when she sees''', name() + ".", '''"Hey''', name() + "!", '''Good news.''',
        '''Sister''',
            '''Samantha is letting you take me home. Just so long as we use protection, have a safeword if things get rough, and she told me to tell you that if I''',
            '''tell you to stop, and you don't, she will rob you of your manhood in the most violent manner imaginable. Also, Maria needs to be nearby, in case''',
            '''you turn out a bit less pleasant, and a bit more violent than I thought."'''],
            ['''"Good to know," says''', name() + ".", '''"Shall we go?"'''],
            ['''"Do you even have a place to sleep?" asks Maria. "Because you can come live with me, if you'd like. I live in a bit of a hole, on the edge of the slums.''',
            '''But if we live together, we can upgrade a bit and still only pay fifty coins a month each. For now, the place will be a bit crowded, but I can''',
            '''go for a walk, and give you two some privacy for a while."'''],
            ['''"Isn't that a little bit dangerous?" asks Carrie.'''],
            ['''"I'm not actually in the slums," says Maria. "Plus, I've been a successful adventurer for ten years. People know not to mess with me."''']])
        if 'boarding_with_Adrian' in keywords():
            quip = universal.format_text([['''"Actually, I've already got a room with Adrian," says''', name() + "."],
                ['''"Oh." Maria's smile slips a little bit. "I guess that's probably better anyway. Rooms are nicer, and all. I'll see you around."''']])
            ep1_maria_live.comment = '''"Eh, you know? I think I'd rather live with you. I'm sure Adrian won't mind."'''
            ep1_maria_dont_live.comment = '''"Yeah. But we'll see a lot of each other, still right? What with you working for Adrian, and all."'''
    else:
        quip = universal.format_text([['''"They're a cute couple," says Maria.'''],
            [name(), '''shrugs.'''], ep1_maria_live_question()])

maria_no_problems = Node(314)
maria_no_problems.quip_function = maria_no_problems_qf
ep1_maria_live = Node(307)
ep1_maria_dont_live = Node(306)
maria_no_problems.children = [ep1_maria_live, ep1_maria_dont_live]




def maria_lied(node):
    increment_spankings_taken()
    try:
        node.music.append(MARIA)
    except AttributeError:
        node.music = [MARIA] if node.music is None else [node.music, MARIA]
    quip = universal.format_text([['''\m"Well," says Maria. Her voice is tight, and her hand closes around the handle of the bone hairbrush. "Look who's here.''', 
        p.PC.fakeName if 'lied_about_name' in keywords() else name(), '''born in Chengue, right?''' if 'lied_about_Bonda' in keywords() else '''born in Bonda, right?''',
        '''See, that's really funny, because the last time I checked, you were''', name(), '''born in Bonda. I wonder how I could possibly have been mistaken?"''']])
    if 'Elise_shows_you_around' in keywords():
        quip = universal.format_text([quip, ['''Roland guides Elise to the northwest corner of the Shrine, while Sister Samantha, wooden hairbrush firmly in hand, takes Carrie's ear and drags her to''',
        '''the southeast corner.''']])
    quip = universal.format_text([quip, ['''"That's how that woman knew my real name," says''', name(), '''in horror. "You told her. Why?"'''],
        ['''"Well, for one thing, you never told me you used a fake name," snaps Maria, beginning to tap the bone hairbrush against her palm.'''],
        ['''"But why go to them in the first place?" asks''', name() + "."],
        ['''"I didn't go to them," says Maria. "They came to me. They saw you and I talk in the square, and decided to ask me a few questions. It didn't''',
            '''take long to find out that you lied to them for absolutely no reason!"'''],
        ['''"It was none of their cursed business," says''', name() + ",", '''crossing''', hisher(), '''arms and scowling.''']])
    if 'Elise_shows_you_around' in keywords():
        quip = universal.format_text([quip, ['''There is a sharp crack, and a cry of pain. Roland has hauled Elise over his knee and lifted her dress, exposing a pair of thin, frilly green''',
        '''panties that leave the lower quarter of her bottom exposed. Roland is vigorously smacking the rolling swells of Elise's curvy cheeks, focusing in particular on''',
        '''that exposed lower fourth.''']])

    quip = universal.format_text([quip, ['''"Do you have any idea how close they were to arresting you when they found out?" cries Maria. She stands, and grabs''', names(), '''upper arm in an iron''',
            '''grip. "It took every shred of what minimal influence I have to convince them that''',
            '''you're not a threat, just a stupid brat!"'''],
        ['''"Influence? What do you mean influence?" asks''', name() + ",", '''tugging away from Maria.'''],
        ['''"Nevermind that," says Maria. She sits down in a pew, and begins to tug''', name(), '''towards her. "The point is that you very nearly had your stupid ass thrown in the dungeons, and a Mother-cursed puppeteer crawling around''',
            '''inside your head for absolutely no reason! Now, I am sure as death going to make sure you never do something that stupid again. Get over my knee!"''']])
    if 'Elise_shows_you_around' in keywords():
        quip = universal.format_text([quip, ['''There is a solid thwack, and a cry. Sister Samantha has yanked Carrie over her lap, rolled up her dress, and tugged down her tights,''',
            '''exposing the young woman's round, plump orbs, encased in nothing more than a teeny tiny string thong.''' if not 'Samantha_saw_Carries_dress' in keywords() else
            universal.format_line(['''revealing a surprisingly modest pair of purple panties. However Sister Samantha also pulled down the panties, exposing the young woman's''',
                '''round, plump orbs, still very red and sore looking from her earlier spanking.''']), '''Now, Samantha is beating a rapid tattoo on Carrie's''',
            '''rippling cheeks.''']]) 
    node.children = [ep1_maria_submit, ep1_maria_resist]
    return quip


ep1_maria_submit = Node(304)
ep1_maria_submit.comment = '''Bend over Maria's lap.'''
def ep1_maria_submit_qf():
    ep1_maria_submit.quip = universal.format_text([[name(), '''swallows uneasily, but lets Maria pull''', himher(), '''over the older Taironan's knee.''', HeShe(), 
        '''tenses as Maria''', universal.format_line(['''grabs the waistband of his trousers, and yanks them down to his knees, exposing a pair of cotton underdrawers. Those''',
            '''also come down, exposing''', names(), '''muscular bottom.''']) if p.PC.is_male() else universal.format_line(['''tugs''', names(), 
                '''tight skirt up over her hips, exposing her protruding, bouncy cheeks, her tiny black thong doing nothing to contain them.'''])],
            ['''"You are in such trouble, young''', manlady() + ',"', '''says Maria, rubbing the bone hairbrush in small circles over''', names(), '''right cheek.'''],
            ['''"Yes, Maria."''', names(), '''exposed bottom clenches apprehensively. The harsh slaps and cries from Elise's and Carrie's spankings pound at''',
                hisher(), '''ears.'''],
            ep1_maria_hairbrushing(ep1_maria_submit),
            ep1_maria_temper(ep1_maria_submit)])
ep1_maria_submit.quip_function = ep1_maria_submit_qf

ep1_maria_resist = Node(307)
ep1_maria_resist.comment = '''Resist.'''
def ep1_maria_resist_qf():
    ep1_maria_resist.quip = universal.format_text([['''"No, let go of me!" cries''', name() + ".", HeShe(), '''digs''', hisher(), '''heels into the floor, and strains back''',
        '''against Maria's grip. "This isn't fair, let go!"'''],
        ['''"It doesn't matter how fair it is," snaps Maria. She kicks''', name(), '''right leg out from under''', himher() + ".", '''When''', name(), '''stumbles, Maria''',
            '''yanks''', himher(), '''across her lap. She grabs''', universal.format_line(['''the waistband of''', names(), '''trousers and underpants, and yanks them both down''',
            '''to his knees.''']) if p.PC.is_male() else universal.format_line(['''the hem of''', names(), '''dress, and pulls it over her hips, exposing her round bottom and tiny''',
            '''black thong.''']), '''"What matters is that you never do something that stupid again!"'''],
        ['''"Let go of me!" screams''', name(), '''flailing uselessly. The harsh slaps and cries from Elise's and Carrie's spankings pound at''',
                hisher(), '''ears.'''],
            ep1_maria_hairbrushing(ep1_maria_resist)])
    if 'Elise_shows_you_around' in keywords():
            ep1_maria_resist.quip = universal.format_text([ep1_maria_resist.quip, ep1_maria_temper(ep1_maria_resist)])
    else:
        ep1_maria_resist.quip = universal.format_text([ep1_maria_resist.quip, ep1_maria_temper_continue(ep1_maria_resist)])
ep1_maria_resist.quip_function = ep1_maria_resist_qf

def ep1_maria_hairbrushing(node):
    quip = universal.format_text([['''A heavy thwack crashes against''', names(), '''ears, and''', heshe(), '''howls as pain blossoms across''', hisher(), 
        '''battered right cheek''' if 
                p.PC.numSpankings > 0 else '''unblemished right cheek.'''],
            ['''"Nana told me you could be a trouble maker," says Maria, pounding''', names(), '''vulnerable bottom with the back of the hairbrush. "But I never''',
                '''once imagined you were this stupid!"'''],
            [name(), '''doesn't respond.''', HeShe(), '''merely bucks and screeches as the hard hairbrush bites deeply into''', hisher(), '''bottom. Maria is putting''',
                '''the full force of her muscular, battle-honed arms into each swing, and the horrible pain goes deep,''',
                '''far deeper than any other spanking''', heshe(), '''has ever experienced. Tears flow freely down''', hisher(), '''face.''', HeShe(), 
                '''begs and pleads for Maria to stop, or even just not hit as hard, but Maria is deaf to''', hisher(), '''cries.''']])
    return quip

def ep1_maria_temper_continue(node):
    quip = universal.format_text([['''The paddling continues unabated, and it isn't long before''', name(), '''sags brokenly across Maria's lap, howling and crying as the''',
        '''hairbrush continues to batter''', hisher(), '''bottom. Maria is saying something, but it's nothing more than incomprehensible murmurs beneath the heavy''',
        '''thwacks of the hairbrush.'''],
        ['''Then, finally, mercifully, the hairbrush stops falling. Slowly,''', name(), '''reaches back to clutch at''', hisher(), '''throbbing bottom.'''],
        ['''"Oh Mother," whispers Maria. Her fingers lightly trace one of''', names(), '''blisters. "Mother, Mother, Mother. I've gone too far. I'm sorry,''', name()
            + '."'],
        ['''Maria helps''', name(), '''clamber off her lap.''', name(), '''hobbles away from the other Taironan,''', hisher(), '''hands gingerly rubbing''', hisher(),
            '''ravaged bottom.'''],
        ['''"Sorry, sorry, sorry," says Maria, following after''', name(), '''a few steps. "It's just, I've never been so scared in my life, as when the guards''',
        '''started talking about arresting you."''']])
    node.children = [ep1_maria_temper_forgive, ep1_maria_temper_refuse, ep1_maria_temper_spank]

def ep1_maria_temper(node):
    node.add_song(CHURCH)
    node.add_song(MARIA)
    quip = universal.format_text([['''Then, suddenly, the blows stop falling.''', name(), '''takes a deep, sobbing breath,''', hisher(), '''entire body quivering.'''],
            ['''"Sister Samantha what-"'''],
            ['''"That's enough." Sister Samantha's sharp, commanding voice rings out right next to''', name() + ".", HeShe(), '''cranes around and looks over''', 
                hisher(), '''shoulder. Sister Samantha is standing above Maria and''', name() + ",", '''tightly holding onto Maria's upraised arm. Carrie is standing''',
                '''nearby, her hands gingerly cupping her bottom, and her bloodshot eyes watching the scene unfold. Even Roland has stopped spanking Elise, and is''',
                '''watching, one of Elise's slippers lightly resting on her fully exposed bottom. Elise has twisted around to look, absently wiping tears''',
               '''from her face.'''],
            ['''"But-"'''],
            ['''"You've lost your temper," says Sister Samantha sharply. "You never, ever administer a spanking when you've lost your temper. Ever. Look at the poor''',
                boygirl() + ".", '''If you keep this up, you'll trigger''', hisher(), '''health."'''],
            ['''"But''', heshe(), '''almost-"'''],
            ['''"Yes, yes''', heshe(), '''said something stupid to the guards, not fully understanding how paranoid they are," says Sister Samantha. "While''',
                '''that may be a paddling offense, you're taking it way too far."'''],
            ['''"No, don't you understand?" cries Maria. There is a hint of panic in her voice. "Don't you understand what would have happened to''', himher() + "?",
                '''What they would have done? No, of course you don't, because-"'''],
            ['''"Maria, I understand your fear," says Sister Samantha. "But you need to calm down."'''],
            ['''"No!" Maria tries (and fails) to wrench her arm free. "I'm going to make sure''', heshe(), '''never even considers lying to them again!"'''],
            ['''"Very well.''', name() + ",", '''get up," says Sister Samantha, her voice taking on a grim tone.'''],
            ['''Maria tightens her hold on''', name() + ".", '''"But I'm not done-"'''],
            ['''"Yes, yes you are. Let''', himher(), '''go, or so help me I will switch you everyday for the next week."'''],
            ['''Maria slumps, and lets''', name(), '''up, who quickly clambers to''', hisher(), '''feet, hissing and rubbing''', hisher(), '''swollen bottom. "I just''',
                '''don't want''', himher(), '''hurt."'''],
            ['''"I know," says Sister Samantha. "But you run the risk of doing exactly that." The Sister turns her attention to''', name() + ".", '''She points towards''',
                '''the western wall. "I want you with your nose against the wall, and your arms on your head. Keep that bottom bare, and absolutely no rubbing."'''],
            [name(), '''considers protesting, but the long day, and brutal paddling have drained all hints of a fight out of''', himher() + ".", HeShe(), '''merely''',
                '''nods, and''', '''waddles''' if p.PC.is_male() else '''gingerly walks''', '''over to the wall.''', HeShe(), '''puts''', hisher(), '''hands on''',
                hisher(), '''head, and stares glumly at the wall, desperately trying to resist the urge to rub''', hisher(), '''throbbing bottom.'''],
            ['''"Now, Maria. I want your skirt up, your shorts down, and bent over that pew. I'll see to you when I've finished with Carrie."'''],
            ['''Then, the sounds of spankings resume: the sharp crack of slipper to flesh, followed by Elise's high-pitched squeals, and the deeper thwack of hairbrush''',
                '''to flesh, followed by Carrie's throatier howls.'''],
            ['''A few minutes later, the two young women join''', name(), '''at the wall, sniffling and quietly sobbing.'''],
            ['''"Now, Maria. Over my knee." Sister Samantha's stern, sharp voice makes''', names(), '''ravaged bottom reflexively clench.'''],
            ['''There is a slight shifting, and then a heavy thwack. Maria cries out.'''],
            ['''Over and over again, the solid thwack of hairbrush to naked bottom batters''', names(), '''ears. Maria's cries echo throughout the small Shrine. Sister''',
                '''Samantha's scolding makes''', names() ,'''ears burn, even though it isn't directed at''', himher() + "."],
            ['''After a seeming eternity, Maria joins the other three young people. Of the four, she is clearly crying the hardest, her sobs drowning out the sniffles''',
                '''of the other three.'''],
            ['''The four stand with their noses against the wall for several minutes.'''],
            ['''\mEventually, when''', names(), '''legs are burning with fatigue, Sister Samantha's voice rings out. "All right you four, cover yourselves and turn''',
                '''around."'''],
            [name(), '''hikes his pants back up,''' if p.PC.is_male() else '''tugs her skirt back down,''', '''whimpering as the rough fabric scrapes against''', 
                hisher(), '''swelled bottom.''', HeShe(), '''turns to find Sister Samantha giving all four of them a stern look. Roland stands behind her with his''',
                '''arms crossed, looking equally stern (though his attention is focused more on Elise).'''],
            ['''"Alright, Younger Sister Elise, what have you learned?" asks Sister Samantha. "And look me in the eye when you answer, girl."'''],
            ['''"Not to go to craftsmen level taverns, dress inappropriately, sing inappropriate songs, or dance inappropriately," says Elise. "Basically, not to have''',
                '''fun."'''],
            ['''Roland grimaces uneasily.'''],
            ['''"Excuse me?" says Sister Samantha.'''],
            ['''"Nothing, Sister," says Elise. "I said nothing."'''],
            ['''"I see," says Sister Samantha, before turning to Carrie. "And you, Carrie?"'''],
            ['''"Not to take Elise to inappropriate places, or wear clothing that's too inappropriate," says Carrie. She looks like she's about to say more, but just''',
                    '''closes her mouth.'''],
            ['''Sister Samantha turns her baleful glare on''', name() + ".", '''"And you,''', name() + "?"],
            ['''"Not to lie to the guards, ma'am," says''', name()  + "."],
            ['''Sister Samantha nods, and turns to Maria. "And you, Maria?"'''],
            ['''"Not to spank in anger, ma'am," says Maria.'''],
            ['''Sister Samantha nods. One by one, she gives the four a hug and a kiss on the forehead. "I'm sorry you all had to be spanked like that. But it's for''',
                    '''your own goods, I promise. Well, except maybe Carrie. I've given up all hope on her."'''],
            ['''"Hey!" cries Carrie, putting her hands on her hips. "Then why do you keep spanking me?"'''],
            ['''Sister Samantha shrugs. "It's relaxing."'''],
            ['''Carrie scowls. "Jerk."'''],
            ['''Sister Samantha chuckles, and gives Carrie another squeeze. "I'm just teasing you, you silly girl. Now, why don't you go off to bed."'''],
            [universal.format_text([['''"Actually..." Carrie smiles a bit nervously. "Um, I'm going to spend the night with, erm,''', name() + '."'],
                ['''Sister Samantha looks between''', name(), '''and Carrie. She grimaces. "Carrie, are you sure that's a good idea? You hardly know''', name() + '."'],
                ['''"But Sister-" whines Carrie'''],
                ['''"I didn't say no. It just seems risky to me," says Sister Samantha. "The trouble with trouble, is it starts out fun."'''],
                ['''"Don't worry Sister," says Maria. "I can stay close enough to hear Carrie if she needs me."'''],
                ['''"Hearing nothing," says Sister Samantha. "Carrie, you remember the spell Spectral Signal?"'''],
                ['''Carrie nods. "Yes ma'am."'''],
                ['''"Good. Use protection, setup a safeword if you plan to get rough, and I swear''', 
                    '''in the Mother's name,''', name() + ",", 
                '''if Carrie says stop, and you don't, I will kill you."'''],
                [name(), '''backs up a step, as if distance can lessen the heat of the dangerous look Sister Samantha gives him. "Sister Samantha, I would never..."'''],
                ['''"Good," says Sister Samantha. She smiles. "Regardless, I want Maria relatively close by, close enough to detect a Spectral Signal from Carrie."'''],
                ['''Maria nods. "Yes ma'am."'''],
                ['''The other tow chime in their own "Yes ma'ams."''']]) if 
                    'taking_Carrie_home' in keywords() else universal.format_line(['''"Yes ma'am," says Carrie, yawning. She rubs her bottom. "Assuming I can fall''',
                    '''asleep,''',
                    '''considering how much my butt hurts."'''])],
                ['''"You should be going to bed too, Elise," says Roland tenderly, giving his fiancee a kiss.'''],
                ['''Elise pouts prettily, and pushes her hips against Roland. "Aren't you going to comfort me? I mean, you spanked me so hard. I think I deserve''',
                '''a little comfort."'''],
                ['''Roland raises an eyebrow. "Sultry minx. The only thing you deserve is the right to sleep on your stomach."'''],
                ['''Elise's pout deepens, and she bats her eyelashes at him.'''],
                ['''"Curse you, puppy-dog eyes. Curse you, I say," cries Roland, his eyes to the ceiling. "Fine, fine. Let's go."'''],
                ['''"You are such a softie," says Sister Samantha, a strange mixture of annoyance and humor in her voice. "Six months from now, she's going to be as big a trouble-maker as Carrie."'''],
                [universal.format_line([names(), '''feels a flash of jealousy. Wish she was getting comforted by someone tonight. Like say, a certain blacksmith.''']) if
                    'flirting_with_Peter' in keywords() and not 'lesbian_in_denial' in keywords() else universal.format_line([names(), '''lips quirk.'''])],
                ['''\mMaria touches''', names(), '''shoulder. "I really am sorry, about losing control like that. It's just, I've never been more scared in my life, than''',
                    '''when the guards started talking about taking you. Can, can we talk a little?"''']])
    node.children = [ep1_maria_temper_forgive, ep1_maria_temper_refuse]
    return quip

ep1_maria_temper_forgive = Node(305)
ep1_maria_temper_forgive.comment = universal.format_line(['''"I'm sorry, too. I never wanted to scare you, and I definitely don't want to be mind-controlled. I just felt''',
'''uncomfortable with the guard's questions."'''])
def ep1_maria_temper_forgive_qf():
    ep1_maria_temper_forgive.quip = universal.format_text([['''Maria smiles, and gives''', name(), '''a hug. "I know, it's not right. But there's not really anything we can do''',
        '''about it.''', ep1_maria_live_question()]])
ep1_maria_temper_forgive.quip_function = ep1_maria_temper_forgive_qf
ep1_maria_temper_forgive.children = [ep1_maria_live, ep1_maria_dont_live]

def ep1_maria_live_question():
    quip = universal.format_line(['''Anyway, I was wondering if you'd like to live with me. It's not much, but it's a home. In fact, we could even upgrade a little, and still only''',
        '''cost us each fifty coins a month."'''])
    if 'boarding_with_Adrian' in keywords(): 
        quip = universal.format_text([quip, ['''"Sorry," says''', name() + ".", '''"But I'm already boarding with Adrian."'''],
            ['''"Oh." Maria's hesitant smile fades. "Well, OK. I mean, you certainly don't have to live with me. Probably safer to live with Adrian, anyway."''']])
        ep1_maria_live.comment = '''"Eh, you know? I think I'd rather live with you. I'm sure Adrian won't mind."'''
        ep1_maria_dont_live.comment = '''"Yeah. But we'll see a lot of each other, still right? What with you working for Adrian, and all."'''
    return quip

ep1_maria_live.comment = '''"Sure."'''
def ep1_maria_live_qf():
    add_keyword('boarding_with_Maria')
    mariasHome.boarding = True
    remove_keyword('boarding_with_Adrian')
    guildBedroom.boarding = False
    ep1_maria_live.quip = universal.format_text([['''Maria grins. "Excellent."''']])
    if not 'Marias_home' in keywords(): 
        ep1_maria_live.quip += format_line([''' You can find my place right on the edge of the slums, near the Adventurer's Guild."'''])
    add_keyword('Marias_home')
    if 'taking_Carrie_home' in keywords() and not ('lied_about_name' in keywords() or 'lied_about_Bonda' in keywords()):
        ep1_maria_live.quip = universal.format_text([ep1_maria_live.quip, ['''Carrie limps out a few seconds later. Her eyes light up when she sees''', name() + ".", '''"Hey''', name() + "!", 
            '''Good news. Sister''',
            '''Samantha is letting you take me home. Just so long as we use protection, have a safeword if things get rough, and she told me to tell you that if I''',
            '''tell you to stop, and you don't, she will rob you of your manhood in the most violent manner imaginable." Carrie grimaces. "Also, she wants''',
            '''Maria nearby in case things turn ugly."'''],
            ['''"Good to know," says''', name() + ".", '''Though he feels a bit insulted that Sister Samantha would think him capable of such a thing, a little bit of''',
                '''caution is probably called for. "Shall we go?"''']])
    if 'Elise_shows_you_around' in keywords():
        return (universal.acknowledge, [townmode.go, avaricumSquare])
    else:
        return (universal.acknowledge, [townmode.go, mariasHome])
ep1_maria_live.quip_function = ep1_maria_live_qf        

ep1_maria_dont_live.comment = '''"Sorry, but I think I'll look for something else. Something a bit safer."'''
def ep1_maria_dont_live_qf():
    add_keyword('Marias_home')
    if not 'boarding_with_Adrian' in keywords():
        ep1_maria_dont_live.quip = universal.format_text([['''"That's understandable," says Maria with a nod. "I'd recommend talking to Adrian. He often lets adventurers board''',
            '''with him for very low rates and a few chores. Plus, the rooms are quite nice, and the Guild is fairly safe. Well, it was, anyway."'''],
            ['''"Ok, I will," says''', name() + ".", '''"I'll see you around, I guess."'''],
            ['''"Yeah. I'll see you." Maria leaves.''']])
    else:
        ep1_maria_dont_live.quip = universal.format_text([['''"Yeah. I guess we will," says Maria. She gives''', name(), '''a brief hug.''']])
        if not 'mariasHome' in keywords(): 
            ep1_maria_dont_live.quip += format_line([''' "Anyway, you can find me in at the edge''',
            '''of the slums, just past the Adventurer's Guild. It's good to see you. Try to stay out of trouble."'''],
            [name(), '''returns the hug.'''])
    if 'taking_Carrie_home' in keywords():
        ep1_maria_dont_live.quip = universal.format_text([ep1_maria_dont_live.quip, ['''Carrie limps out a few seconds later. Her eyes light up when she sees''', name() + ".", '''"Hey''', name() + "!", 
            '''Good news. Sister''',
            '''Samantha is letting you take me home. Just so long as we use protection, have a safeword if things get rough, and she told me to tell you that if I''',
            '''tell you to stop, and you don't, she will rob you of your manhood in the most violent manner imaginable. Also, Maria needs to be nearby, so that she''',
            '''can help me in case you turn out less pleasant than you appear, so to speak."'''],
            ['''"Good to know," says''', name() + ".", '''"Shall we go?"''']])
    if 'Elise_shows_you_around' in keywords():
        return (universal.acknowledge, [townmode.go, avaricumSquare])
ep1_maria_dont_live.quip_function = ep1_maria_dont_live_qf

ep1_maria_temper_refuse = Node(308)
ep1_maria_temper_refuse.comment = '''"Oh, go get buried. I want nothing more to do with you."'''
def ep1_maria_temper_refuse_qf():
    ep1_maria_temper_refuse.quip = universal.format_text([[name(), '''turns''', hisher(), '''back on Maria.'''],
        ['''There is a quiet, heartbroken sob, then a faint scrambling, then the slam of the door opening and closing.''']])
ep1_maria_temper_refuse.quip_function = ep1_maria_temper_refuse_qf

ep1_maria_chase = Node(309)
ep1_maria_dont_chase = Node(310)
ep1_maria_temper_refuse.children = [ep1_maria_chase, ep1_maria_dont_chase]
ep1_maria_chase.comment = '''Chase after her.'''
def ep1_maria_chase_qf():
    ep1_maria_chase.quip = universal.format_text([[name(), '''gnaws on a fingernail. Maria's single, broken sob rings in''', hisher(), '''ears.''', 
        HeShe(), '''turns and bolts outside. "Maria, Maria wait! Maria!"'''],
        ['''Maria is almost out of sight. She stops and turns to face''', name() + "."],
        ['''"I'm sorry," says''', name() + ".", '''"I don't want you to get buried. Please. Come back inside."'''],
        ['''Maria smiles, at first hesitantly, but then more broadly. She makes her way back across the Square, and up the steps.'''],
        [name(), '''wraps the other Taironan in a hug. "I never meant to scare you, and I don't want to lose you. I've waited too long to see you again, for that."'''],
        ['''Maria returns the hug fiercely, then goes back inside  with''', name() + "."]])
    if 'Elise_shows_you_around' in keywords():
        ep1_maria_chase.quip = universal.format_text([ep1_maria_chase.quip, ['''Elise breathes a sigh of relief as the two return. "Thank the Mother. I was bit worried there. Is everything OK?"'''],
        ['''"Well, I don't know that everything is completely ok," says''', name() + ",", '''rubbing''', hisher(), '''ravaged bottom. "But I want it to be."'''],
        ep1_maria_live_question()])
        
ep1_maria_chase.quip_function = ep1_maria_chase_qf
ep1_maria_chase.children = [ep1_maria_live, ep1_maria_dont_live]

ep1_maria_dont_chase.comment = '''Dont chase after her.'''
def ep1_maria_dont_chase_qf():
    add_keyword('grudge_against_Maria')
    if 'Elise_shows_you_around' in keywords():
        ep1_maria_dont_chase.quip = universal.format_text([[name(), '''crosses''', hisher(), '''arms and gives the others a challenging glare. While Carrie and Elise exchange''',
            '''uncomfortable glances, nobody actually says anything.'''],
            ['''After a few minutes of awkward silence, Roland and Elise say their good-nights and leave.''']])
        if 'taking_Carrie_home' in keywords():
            ep1_maria_dont_chase.quip = universal.format_text([ep1_maria_dont_chase.quip, ep1_taking_carrie_home(ep1_maria_dont_chase)])
        else:
            ep1_maria_dont_chase.quip = universal.format_text([ep1_maria_dont_chase.quip, ['''Carrie and Sister Samantha say their good-nights as well, and leave, leaving''', name(),
                '''alone.''']])
        return(townmode.go, [shrine])
    else:
        ep1_maria_dont_chase.quip = universal.format_text([[name(), '''turns and leaves Maria's home.''']])
        return (townmode.go, [slums])
ep1_maria_dont_chase.quip_function = ep1_maria_dont_chase_qf


def maria_slap(node):
    quip = universal.format_text([['''Maria chews anxiously on her lower lip. Her face is drawn and tearstained. Her fingers twist anxiously around each other. "Umm. Hi,''', name() + '."']])
    if 'Elise_shows_you_around' in keywords():
        quip = universal.format_text([quip, ['''Sister Samantha exchanges a look with Roland, then grabs Carrie by the ear and drags her off to the corner, while Roland guides Elise to a different corner.''']])
    quip = universal.format_text([quip, ['''"Get buried," says''', name() + ",", '''turning towards the door. "I'm going back to the Guild and finding a bed."''']])
    if 'Elise_shows_you_around' in keywords():
        quip = universal.format_text([quip, [name(), '''approaches the Shrine door, accompanied by the intense murmur of Sister Samantha's scolding, Carrie's abashed answers, and the sharp smack of''',
        '''hand to bottom as Roland begins''',
            '''spanking Elise.''']])
    else:
        quip = universal.format_text([quip, ['''"Why did you come here?" asks Maria.'''],
            ['''"I don't know."''', name(), '''opens the door. "But it was a mistake."''']])
    quip = universal.format_text([quip, ['"' + name(), '''wait," says Maria, rushing forward. "Please, can't we talk?"''']])
    node.children = [ep1_maria_ignore, ep1_maria_talk, ep1_maria_about_what]
    return quip

ep1_maria_ignore = Node(311)
ep1_maria_ignore.comment = '''Ignore Maria.'''
def ep1_maria_ignore_qf():
    add_keyword('grudge_against_Maria')
    ep1_maria_ignore.quip = universal.format_text([[name(), '''pulls open the door, and leaves. Maria doesn't follow.''']])
    if 'taking_Carrie_home' in keywords():
        ep1_maria_ignore.quip = universal.format_text([['''After a few minutes, Carrie comes out. Her eyes are bright, her face is tear-stained, and she's more waddling than''',
            '''walking, but she's smiling. "Hey. Saw Maria run into the back of the Church. What happened?"'''],
            ['''"I don't want to talk about it," says''', name(), curtly],
            ['''"OK," says Carrie. "I guess we could both use a distraction, huh? Ready to go?"'''],
            ['''"Yeah. Let's go."'''],
            ['''"You do have a bed right?"'''],
            [name(), '''grins. Carrie groans.''']])
    if 'Elise_shows_you_around' in keywords():
        return (townmode.go, [avaricumSquare])
    else:
        return (townmode.go, [slums])
ep1_maria_ignore.quip_function = ep1_maria_ignore_qf

ep1_maria_talk = Node(312)
ep1_maria_talk.comment = '''"Yeah. Yeah, we can talk."'''
def ep1_maria_talk_qf():
    ep1_maria_talk.quip = universal.format_text([[name(), '''waits.'''],
        ['''Maria rolls her palm across the hilt of her dagger. She taps her thumb against it, and slides her fingertips across the sheathed blade. She''',
            '''glances at''', name(), '''several times, and opens her mouth. Then she looks away.''']])
    if 'Elise_shows_you_around' in keywords():
        ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, ['''There is a solid thwack, and a howl of pain. Sister Samantha has pulled Carrie's skirt up over her hips,''', '''and pulled down the young woman's''',
            '''rather modest panties.''' if 'Samantha_saw_Carries_dress' in keywords() else '''exposing a (very!) small purple thong.''', '''Now, she is vigorously''',
            '''paddling Carrie's bare, wobbling cheeks, while the younger woman kicks and wails.''']])
    ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, [name(), '''considers sitting down, but instead leans against the wall.'''],
        ['''"I'm sorry," says Maria in Taironan, her voice barely audible. She sits down, and starts picking at her skirt. "I just''',
            '''don't want you hurt."''']])
    if 'Elise_shows_you_around' in keywords():
        ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, ['''There is a sharp thwack, and a particularly loud wail.''', name(), '''glances towards Roland and Elise. Roland has yanked down Elise's thin, lacy panties,''',
        '''and''',
            '''removed one of her slippers. He is cracking the sole of the slipper against her voluptuous bum, making her buck kick and squeal.''']])
    ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, [name(), '''waits for Maria to say more.'''],
        ['''Maria says nothing, just shifts her glance between her lap and''', name() + "."],
        ['''"Shouldn't that be up to me?" asks''', name(), '''in a quiet voice.''']]) 
    if 'Elise_shows_you_around' in keywords():
        ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, ['''Carrie lets out a particularly loud shriek, and''', name(), '''winces a little. Girl's''',
            '''got an impressive set of lungs.'''],
        ['''"Oh stop milking it," snaps Sister Samantha, cracking the hairbrush against Carrie's right sitspot. "I'm not paddling you that hard."''']])
    ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, ['''"But you don't understand the situation," says Maria. She stands and begins to pace. "It's not like you're going to go off, get too drunk, and get in a''',
            '''fight and spend the night in the dungeon. You'd be ostracized."'''],
        ['''"But I didn't do anything," says''', name() + "."],
        ['''"I know. But it doesn't matter. People still won't trust you," says Maria, anxiously tapping her dagger hilt. "And good luck getting a job. Even Adrian''',
        '''wouldn't touch you if he knew."'''],
        ['''"You don't know that," says''', name() + ".", '''"And even if that's true maybe it's worth it? Maybe it'll do some good."'''],
        ['''Maria laughs bitterly. "Speaking out won't do any good until a noble has been wrongly controlled, and trust me, that's not going to happen anytime soon. Nobles''',
            '''have a special priviledge in Avaricum: even when suspected of a crime, they can refuse to be controlled."'''],
        ['''"You're kidding," says''', name() + "."],
        ['''Maria shakes her head. "Nope. You can be controlled for breathing wrong. They could murder their own mother, and the most the guard would do is ask a few polite''',
            '''questions about her sudden and rapid deterioration. Do you see what you're dealing with here? Nobody cares."''']])
    if 'Elise_shows_you_around' in keywords():
            ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, ['''"Now wait just a minute."''', name(), '''turns towards Roland, and begins speaking in Carnutian. "Roland! What's this garbage about nobles not being''',
        '''controlled even if they're suspected of a''','''crime?"'''],
        ['''"You idiot!" hisses Maria, her eyes wide.'''],
        ['''"What?" asks''', name(), '''angrily. "I can't ask a simple question?"'''],
        ['''Roland growls. "Don't even get me started on that. I've been fighting it for years, but the rest of the nobility refuse to admit that they could''',
            '''possibly do anything remotely illegal, or questionable, or evil. So in all cases, looking inside their heads is unwarranted and unnecessary."'''],
        ['''"Then why the hell do you MC everyone else?" asks''', name() + "."],
        ['''"Because I have a job to do," says Roland curtly. "Yes, charming is a little invasive, but it's accurate, reliable, and painless. If I have to choose''',
            '''between putting an innocent man behind bars, and poking inside his mind before letting him go, I'll poke in his mind every day of the week."'''],
        ['''For a moment,''', name(), '''considers pushing. But then,''', heshe(), '''sees Maria's slightly panicked expression.''', '''The Taironan nods. "I see."'''],
        ['''"It sucks, and in a perfect world it wouldn't be necessary. But that's not the world we live in. Now if you'll excuse me?" Roland raises the slipper.'''],
        ['''"Right, sorry," says''', name() + "."],
        ['''Roland returns to Elise's slippering.'''],
        ['''"There, you see?" says Maria. "Make as big a stink as you want, and Roland'll just shrug it off."'''],
        [name(), '''grimaces. "I suppose you're right."'''],
        '''"''' + ep1_maria_live_question()])
    else:
        ep1_maria_talk.quip = format_text([ep1_maria_talk.quip, [name(), '''runs a hand through''', hisher(), '''hair. "So, what are we?"'''],
            ['''"Dirt," says Maria. She laughs bitterly. "Or mud, if you prefer."'''],
            ['''"And you just accept it?" asks''', name() + "."],
            ['''Maria's eyes turn haunted. "I didn't once. Catalin and I, we tried to make things better. Got involved in a group agitating for better treatment. Things''',
                '''got violent. It didn't end well."'''],
            ['''"What happened? And where's Catalin?" asks''', name() + "."],
            ['''Maria shakes her head. "I don't know where Cat went. As for a what happened, I don't want to talk about it."'''],
            ['''"But-"'''],
            ['''"Please," says Maria. "Please just let it lie."'''],
            [name(), '''nods reluctantly.'''],
            ['''"''' + ep1_maria_live_question()]])


ep1_maria_talk.quip_function = ep1_maria_talk_qf
ep1_maria_talk_right = Node(313) 
ep1_maria_talk_wrong = Node(314)
ep1_maria_talk.children = [ep1_maria_talk_right, ep1_maria_talk_wrong]

ep1_maria_talk_right.comment = '''"I don't know, maybe you're right. But did you have to spank me like that?"'''
def ep1_maria_talk_right_qf():
    ep1_maria_talk_right.quip = universal.format_text([['''Maria's lips twist. "I don't remember you being overly reasonable at the time. You seemed on the verge of running''',
    '''outside and spilling your secret right then and there."'''],
    [name(), '''crosses''', hisher(), '''arms. "Just because I didn't want to keep silent, it doesn't mean I was going to go out right and then and there and tell''',
        '''everyone about it."'''],
    ['''"I guess," says Maria. "I'm sorry, I just panicked. I tend to overreact, as both Aunt Reyna and Sister Samantha have pointed out."'''],
    [name(), '''shrugs. "I may have overreacted as well. I was just scared, and hurt, and angry. I needed a friend, and I didn't feel like youe were being one."'''],
    ['''Maria stands, and takes''', names(), '''hands. "Of course I'm your friend. I've always been your friend, and I've wanted to support you from the minute you''',
        '''told me. I just... as your friend I couldn't let you make such a terrible mistake."'''],
    [name(), '''nods.'''], ep1_maria_live_question()])
ep1_maria_talk_right.quip_function = ep1_maria_talk_qf
ep1_maria_talk.children = [ep1_maria_live, ep1_maria_dont_live]

ep1_maria_talk_wrong.comment = ''''"I'm sorry, but I can't accept that. I just can't."'''
def ep1_maria_talk_wrong_qf():
    ep1_maria_talk_wrong.quip = universal.format_text([['''"Just, just give it a year," says Maria. "Please, if after a year of living here, after you understand your situation''',
        '''both as a Taironan, and someone whose been MC'd, you still want to protest it, then I'll help you. Just, please, look before you leap, because it's a long''',
        '''way down."'''],
        [name(), '''grimaces, but nods reluctantly. "Alright. I'll do it your way, for now."'''],
        ['''Maria sighs in relief. "Thank you. Thank you so much."'''],
        [name(), '''shrugs. "I still don't like."'''],
        ['''"In that respect at least, we agree," says Maria sardonically.''', ep1_maria_live_question()]])
ep1_maria_talk_wrong.quip_function = ep1_maria_talk_wrong_qf
ep1_maria_talk_wrong.children = [ep1_maria_live, ep1_maria_dont_live]


ep1_maria_about_what = Node(315)
ep1_maria_about_what.comment = '''"About what? About how you manhandled me?"'''
def ep1_maria_about_what_qf():
    ep1_maria_about_what.quip = universal.format_text([['''Maria winces. "Yeah. About that."'''],
        ['''"I said all I wanted to say this morning."''', name(), '''goes back outside.'''],
        ['"' + name(), '''please," says Maria, following''', himher(), '''out, and touching''', names(), '''shoulder. "I just want to help-"'''],
        ['''"Help?" cries''', name() + ",", '''rounding on the other Taironan. "How? How in La Madre's name does keeping quiet help?"'''],
        ['''Maria glances about, looking to see if there's anyone eavesdropping. The streets seem empty, however.'''],
        ['''"How about by keeping you out of the dungeons? Does that count as helping?" asks Maria.'''],
        ['''"That's not helping, that's hiding," says''', name(), '''angrily.'''],
        ['''"You know, you keep talking like you have a choice," says Maria, her voice rising. "Well guess what oh Courageous Crusader, you don't! The only''',
            '''thing you'll do is make yourself disappear for a while. Then, one day, after everyone's forgotten about you, you'll reappear with no memory of where''',
            '''you were, or what you were doing, and a sick dread every time you think about mind control. Is that what you want?"'''],
        ['''"Maybe if it can help others-"'''],
        ['''"But that's just it," says Maria, slamming the back of her right hand into her left palm. "It won't help anyone. You'll ruin your life for absolutely no''',
            '''reason! Mother's love, I've told you all this already, why won't you listen to me?"'''],
        ['''"Because I can't accept this," says''', name() + ".", '''"I can't believe that Avaricum is so rife with injustice. I just can't!"'''],
        ['''"So in other words, you're willing to throw away the warnings of someone who has lived in this city for ten years, because you can't accept that sometimes''',
        '''life sucks sweaty donkey balls?" asks Maria. "I thought Nana raised you better than that."'''],
        ['''"She also raised me to fight," says''', name() + ".", '''"To not just bend over and take it! I thought she taught you the same!"'''],
        ['''Maria looks away. "She did."'''],
        ['''"Then why-"'''],
        ['''"Because I tried once already," says Maria in quiet voice. "When Catalin and I first arrived. We saw what was going on, we saw how poorly Taironans are''',
            '''treated, and we joined a movement to reclaim our dignity. It was a disaster. Afterwards, I lost track of Catalin. I still don't know where she is, or''',
            '''what she's doing. Curses, she could be dead for all I know."'''],
        ['''The two Taironans stand in silence for a moment.'''],
        ['''"Maria-"'''],
        ['''"I just don't want you to make the same mistake we did," says Maria. She walks a few paces away, and kicks absently at a small stone. "Maybe there''',
            '''is a way to make things better, I don't know. But I do know vocal protests aren't the way to do it."'''],
        ['''"Maybe it'll be different this time," says''', name(), '''weakly, rubbing''', hisher(), '''arm.'''],
        ['''Maria shakes her head. "No. Things have only gotten worse. Taironans are tolerated even less than they were when we started."'''],
        [name(), '''doesn't respond. Instead,''', heshe(), '''tries to digest the events of the day, and to figure out what to do about them, if anything.'''],
        '"' + ep1_maria_live_question()])
ep1_maria_about_what.quip_function = ep1_maria_about_what_qf
ep1_maria_about_what.children = [ep1_maria_live, ep1_maria_dont_live]

def ep1_carrie_sex():
    music.play_music(ELISE)
    universal.say(universal.format_text([[name(), '''plops down on''', hisher(), ('''blankets''' if 'boarding_with_Maria' else '''bed''') + 
        (''', wincing as his sore bottom brushes against the blankets.''' if p.PC.numSpankings >0 else '''.'''),
        '''Carrie lays facedown across his lap, grinding''',
        '''her hips against his leg.'''],
        ['''"Umm..." says''', name() + ",", '''suddenly becoming very conscious of certain bits of his anatomy.'''],
        ['''Carrie looks over her shoulder at him and pouts. She reaches back, and very slowly tugs her dress up over her hips, revealing her red, bruised, angry,''',
        '''round, succulent bottom (which her tiny thong does nothing to obscure). "Look at what Sister Samantha did to me! Isn't she just the meanest thing you ever''',
        '''did see?"'''],
        ['''"Maybe," says''', name() + ",", '''smiling playfully. He begins gently rubbing Carrie's warm, soft, ravaged cheeks. "But you are the brattiest thing I''',
        '''ever did see.''',
            '''Seems to me like you two belong together."'''],
        ['''Carrie's pout deepens. Her bottom pushes up against''', names(), '''hand. "You're mean too. I think you should make it up to me, by cooling my bottom a''',
            '''little."'''],
        ['\p'],
        ['''1. Rub her bottom.'''],
        ['''2. Lightly spank (and rub) the impertinent brat.''']]), justification=0)
    universal.set_command_interpreter(ep1_carrie_sex_rub_spank_interpreter)

def ep1_carrie_sex_rub_spank_interpreter(keyEvent):
    try:
        num = int(pygame.key.name(keyEvent.key))
    except ValueError:
        return
    if num == 1:
        universal.say(universal.format_text([[name(), '''gently rubs Carrie's bottom, using just a touch of magic to draw some of the heat from her skin. The effect is similar to''',
            '''pressing a very soft and flexible block of (wrapped) ice against her skin. Carrie squeaks and jumps a little when''', names(), '''cool hand touches her''',
            '''skin, but soon she is moaning and pumping her hips. Her legs open, giving''', name(), '''a nice look. Alas, that region happens to be''',
            '''the only thing her panties actually cover.'''],
            [name(), '''slips his hand between her legs, and begins stroking her warm, soft labia.'''],
            ['''Carrie squeaks. "Hey, I didn't ask you to rub that!"'''],
            [name(), '''pulls his hand away, and returns to stroking Carrie's bum. "Shall I stop?"'''],
            ['''"Well, I didn't ask you to do that either," says Carrie, her legs opening more.'''],
            ['''"I don't know," says''', name() + ".", '''"That sounded like a request to stop to me."'''],
            ['''"Well, well it wasn't!" cries Carrie. Her hip bumps gently against''',
                names(), '''member. As soon as she touches it, she begins rocking against''', names(), '''body, rubbing her mostly bare hip against him.'''],
            [name(), '''closes his eyes and groans, his fingers gently kneading Carrie's bum. The woman's throaty moan meets his own. "It seems we have a''',
                '''miscommunication. I think the only way to be sure, is for you to beg me to stroke you there again."'''],
            ['''"I think you just want to hear me beg," says Carrie breathlessly. One hand reaches down, and begins stroking''', names(), '''leg, while the other''',
                '''cups one of her breasts.'''],
            [name(), '''leans over a little, and pulls Carrie's hand away from her breast, replacing it with his own. He begins gently rubbing his palm against''',
                '''her, feeling her harden through the thin cloth of her dress. His other hand begins softly stroking her inner thigh, his fingers only inches from''',
                '''her quivering sex. "Well, if you don't want me to-"'''],
            ['''"Please!" moans Carrie. She pumps against his leg and torso, her wobbling bottom a feast for his eyes, the grinding of her warm hips and''',
                '''flat belly''',
            '''chipping at his self-control. "Please touch me. Please, I beg you."'''],
            ['''"Touch you where?" asks''', name() + ",", '''his fingers inching closer to her sex, his fingertips just barely brushing against her lower lips.'''],
            ['''"There," gasps Carrie. "Between my legs, my legs, my bottom, that whole area. Please!"'''],
            ['''His fingers press against her, stroking her lips through the thin cloth of her rapidly dampening panties. Carrie moans and bucks against''', names(),
                '''fingers. He pulls her off his lap, plops her down on her back on the blankets, and leans over her. He pushes his body against hers, her breasts''',
                '''pressing against his chest, his groin grinding against hers, their legs intertwining. He presses his lips against hers. Her mouth opens, and his''',
                '''tongue slips inside. Her scent, a mixture of sweat, and a hint of flowers, fills his''',
                '''nostrils. His hands''',
                '''slide down and grip her fleshy bottom, pulling her tight against him. She''',
                '''moans, and rocks forward and back, her entire body sliding beneath his. She kicks off her slippers, and wraps her bare legs around one of his. His''',
                '''hands slide up, pushing her dress up and up. He pumps his hips against hers, while her hands fumble at his waist. She begins sliding his''',
                lower_clothing().name, '''down his legs.'''],
            ['''He pulls away. She stares up at him, her breath coming in gasps, her breasts heaving, threatening to burst from her low-cut dress. She arcs her''',
                '''back and pushes her hips against his.'''],
            ['''"Why'd you stop?" she breathes.'''],
            ['''"Raise your arms," he says."'''],
            ['''She pouts sexily. "You didn't answer my question."'''],
            ['''He presses himself against her, and kisses her again. "Your dress is in the way."'''],
            ['''She obediently raises her arms, and''', name(), '''slides her dress up over her head, watching with wide eyes and a large grin as her breasts bounce''',
                '''free. He pauses, and stares at her smooth, bare body, the only scrap of cloth a tiny purple thong. His eyes glide across her long blonde hair, her''',
                '''wide, sparkling brown eyes, her sensually smiling mouth, her delicious neck, her full heaving breasts, her flat stomach, her round hips, still clad''',
                '''in a strip of cloth, her long,''',
                '''warm legs. With shaking hands, he grabs the offending scrap of cloth and pulls it down over her legs. She grins, and writhes sinuously beneath him,''',
                '''while kicking her panties off her ankles. She reaches up and grabs his shirt.'''],
            ['''"My turn," she says quietly. She pulls his shirt off, then finishes tugging off his trousers''' + (''', his underwear following quickly after.''' if 
                wearing_underwear() else '''.'''), '''His member bursts into the air, ready and willing.'''],
            ['''She reaches down and gently strokes her exposed sex.''', name(), '''can detect a hint of magic bleeding from her fingertips and into her lower lips.''',
                '''"Sterilizes your seed as it enters."'''],
            ['''"Hmm," says''', name()  + ".", '''"I don't know. How do I know you cast it correctly? Better make sure it tastes right."'''],
            ['''"But it doesn't-" Carrie's words are interrupted by a throaty moan, as''', name(), '''puts his face against her crotch, and slides his tongue along her''',
                '''outer folds. Her moans become a cry as his tongue slips inside her, sliding against her walls and ceiling. She tightens her legs,''',
                '''and bucks against his mouth, while her fingers tangle themselves in his hair. Once she is thoroughly wet, he plants his hands against the blankets,''',
                '''and begins sliding up, trailing kisses across her belly and breasts. He pauses, and slips his mouth around first one nipple, then the other, his''',
                '''tongue gently teasing them.'''],
            ['''"Ohhh," gasps Carrie. "Fuck me. Fuck me, please, I need you to-"'''],
            ['''Her pleas are silenced by a fierce kiss. Her legs open wide, then wrap around his waist. He pushes his chest against hers, and grabs her hips in a''',
                    '''tight grip. She tries to push her hips up, but he keeps her held firmly down.'''],
            ['''He stops the kiss, and presses his cheek against hers, his mouth inches from her ear. "Oh no. I'm going to enter you when I decide. You are going to lie''',
                    '''there and take it like a good girl."'''],
            ['''"Well, you know what they say," she gasps back. "Close your eyes and think of Mother Avaricum."'''],
            ['''He gently bites her neck, as he slowly slides inside her. She gasps as he enters. he moans as he feels her open wide to accept him. The fingers of''',
            '''one hand dig''',
                    '''painfully into his back, while the fingers of the other tangle themselves thoroughly in his hair. She tugs on his head, pulling him up to meet her''',
                    '''desperate, seeking mouth. He pushes his tongue inside her mouth, as his hips begins swaying and thrusting. She moans and rocks her hips.''',
                    '''He thrusts a few times, using her hips as an anchor, before relaxing his grip. One hand slides up her back, while the other works its way between''',
                    '''her bum cheeks, sliding lightly across the sensitive skin between.'''],
            ['''She moans against his mouth, her tongue working desperately against his. Her legs tighten around his waist, pulling him tighter against her, deeper''',
                    '''inside her.'''],
            ['''He grinds his hips against hers, and presses his chest against hers, pushing her deep into the blankets. His fingers find her tight anus, and he begins''',
                    '''to very carefully work his pinkie into the small, tight hole.'''],
            ['''Carrie moans and writhes beneath him as his finger pushes inside her. Her mouth breaks away from his. "Yes, oh yes. Oh-"'''],
            [name(), '''presses his lips against hers again, forcing his tongue back inside her mouth. He pumps his hips and fingers, driving down with his''',
                    '''hips while pushing up with his hand and finger. His kisses become fierce, and forceful, almost frantic. An overwhelming pressure builds inside''',
                    '''him, demanding immediate release. His entire body tenses, his free fingers digging into her bottom and back, as he fights the need.''', 
                    '''Carrie bucks her hips against his hips and finger. She grinds her hips against his for a moment, taking as much of him as she can,''', 
                    '''before pushing back down onto his finger. Her tongue presses against his, before sliding past it and into his mouth. Her entire body tenses.'''],
            [name(), '''gives one last thrust, driving her into the bed sheets, before the wall crumbles. He thrusts frantically as his lower body spasmes in ecstasy.''',
                    '''Carrie's moans reach a fever pitch, and then her entire body spasms. Her body thrashes beneath him, grinding against finger and member both.''',
                    '''She grabs his hair in a painful grip and crushes her lips against his. Their bodies press desperately against each other, as if nothing short''',
                    '''of complete fusion will satisfy them.'''],
            ['''Their mouths separate, and for a few seconds they clutch at each other, before''', name(), '''rolls off, his right hand continuing to glide absently''',
                    '''across Carrie's thigh.'''], ep1_carrie_pillow_talk()]))
    elif num == 2:
        universal.say(universal.format_text([['''"You impertinent brat," says''', name(), '''playfully, lightly swatting Carrie's right cheek. Carrie yelps, but the yelp turns swiftly into''',
            '''a moan as''', name(), '''strokes her tender cheek. "You want mean? I'll show you mean!"'''],
            ['''"Wait," says Carrie breathlessly. "Remember what Sister Samantha said? Play rough, need a safeword."'''],
            ['''"Do you have one in mind?" asks''', name(), '''lightly stroking Carrie's left cheek.'''],
            ['''"How about 'green' for 'keep doing what you're doing,' 'yellow' for 'getting kind of close to my limits' and 'red' for 'stop now?'" asks Carrie.'''],
            ['''"That works."'''],
            [name(), '''begins lightly swatting Carrie's bottom, intermingled with a heavy amount of stroking, and kneading. Carrie gasps, yelps, and writhes throughout''',
                '''the swats, her bottom pushing up eagerly (and rounding even more beautifully) both for the swats, and the subsequent rubbing.''', name(), 
                '''tightens his grip on Carrie, and loops one leg aroun hers, more to enhance contact, and push her bottom further up, than to still her nonexistent''',
                '''kicking. His eyes light up as he watches her curvy, protruding cheeks roll beneath his hand. Carrie rubs against his leg, her legs opening and''',
                '''closing as much as possible. She cups a breast with one hand, and manages to slip her other down the front of her panties. Her moaning and''',
                '''bucking increases as her fingers work in tandem with''', names(), '''swats.'''],
            ['''"What's this?" cries''', name(), '''with mock outrage. "I'm sitting right here, ready to pleasure you, and you're pleasuring yourself?"'''],
            ['''Carrie only moans in response.'''],
            ['''"Clearly, someone needs to be taught a lesson!" declares''', name() + ".", '''He pulls her off his lap, and pushes her facedown against the blankets. He''',
                '''grabs her dress and pulls it off of her, leaving her completely naked except for her tiny purple thong.'''],
            ['''Carrie pushes her face and breasts into the blankets, and arches her back, sticking her butt up high into the air, giving her nether regions to him to''',
                '''do as he wishes. She slips her finger inside her panties, and runs a hand along her lower lips.''', name(), '''can detect a faint hint of magic''',
                '''bleeding into her sex. Birth control, most likely. "Yes, I'm so naughty, so very naughty. Please, teach me a lesson."'''],
            ['''"Oh, you'll learn a lesson alright," he says as he pulls off his shirt, and''', lower_clothing().name + (''', his underwear coming down soon after''' if
                wearing_underwear() else '''.'''), '''"A lesson you won't soon forget."'''],
            ['''He gets onto his knees behind her, and grabs her thong. With a fierce tug, he yanks them down to her knees, fully exposing her labia to him. He takes''',
                '''a moment to stroke it, watching as a shiver of delight runs through her body.'''],
            ['''"That doesn't feel like a lesson," breathes Carrie.'''],
            [name(), '''slaps her right cheek. "Cheeky brat. You want your lesson? Fine, I'll give it to you. I'll give it to you hard."'''],
            ['''He grabs her hips and pushes forward, even as he pulls her hips back, his member driving forcefully inside her. She cries out in''',
                '''pleasure (and perhaps a hint of pain), her hips pushing back eagerly against him. He drives thrusts vigorously, marveling at the''',
                '''ripples that spread across her body. Occasionally, he'll push in deep, then rock back and forth, reveling in the warmth of''',
                '''her sex, and the feel of her soft, ample bum rubbing against him. She soon settles into lockstep with him, rocking her hips in tandem with his''',
                '''pulling her hips forward, and pushing back in time with his thrusts. She writhes on the ground beneath him, rubbing her sensitive breasts against''',
                '''his blankets, her hands tightly gripping the thin cloth. At one point, her head starts to come up, and her ass down.'''],
            ['''"Get your head back down, and your ass back up!" snaps''', name() + ",", '''slapping her left cheek, and giving a particularly hard thrust. "Don't forget''',
                '''I'm teaching you a lesson here."'''],
            ['''"What lesson is that, sir?" cries Carrie as she presses her face into the blankets, and drives her bottom up and back against him.'''],
            ['''"You belong to me," says''', name() + ",", '''giving her cheeks a hearty squeeze. "That I can do to you whatever I want, whenever I want. I tell''',
            '''you to bend over, you turn around and bend over. I tell you to kneel, you kneel. Understand?"'''],
            ['''"Yes sir," says Carrie.'''],
            ['''An enormous pressure batters at''', names(), '''senses. His entire body tenses, his fingers dig into Carrie's hips as he fights against it. "Then say''',
                '''it!"'''],
            ['''"Oh oh oh," moans Carrie, her hips writhing in the air, and grinding against him.'''],
            ['''"I said say it, woman," says''', name(), '''his thrusts and rocking turning desperate.'''],
            ['''"I'm yours!" cries Carrie, as the barrier drops, and spasms of ectasy race through''', names(), '''body. He drives deep inside her, as his seed pumps''',
                '''into her body.'''],
            ['''Carrie thrashes, squealing joyfully as spasms of her own pleasure rip through her body.'''],
            ['''The two remain still and silent, save for their panting, as the aftershocks ripple through them. Then,''', name(), '''slowly pulls out, and lies down''',
                '''next to her.'''],
            ['''Carrie sighs, and flattens. "Ooh, I'll be tender, tomorrow."'''],
            ['''"Oh. Sorry," says''', name() + ".", '''"Didn't mean to hurt you."'''],
            ['''Carrie rolls onto her side, and gives''', name(), '''a kiss. "It's a good kind of tender. The tender that comes from a good, hard fuck."'''],
            ['''"You know those were just words, right?" says''', name(), '''uneasily. "You don't actually 'belong' to me, and if you actually did obey me like that''',
                '''it'd probably freak me out a little."'''],
            ['''"I know," says Carrie, snuggling up against him. "Though, a bit of roleplay might be nice in the future."'''],
            ['''"Yeah," says''', name(), '''putting his arm around her shoulders.'''],
            ep1_carrie_pillow_talk()]), justification=0)
    ep1_catalin()


def ep1_carrie_pillow_talk():
    return universal.format_text([['''The two lie in silence for a while.'''],
        ['''"So," says''', name(), '''at last. "I probably shouldn't ask this now. It'll probably kill the mood, but is this just a one night thing, or..."'''],
        ['''Carrie pulls away from''', names(), '''hold, and sits up. "I don't know. I do want to see more of you. Spend time with you, but..."'''],
        ['''"But..." prompts''', name() + "."],
        ['''"You might not have noticed, but there were a lot of people at the tavern who weren't particularly happy about how much time I spent with you," says''',
            '''Carrie uneasily. "Didn't like the idea of me spending time with a Taironan."'''],
        [name(), '''snorts. "What do they matter?"'''],
        ['''"They don't. Not really," says Carrie. She starts gnawing on a sweaty strand of hair. "It's just...I don't know, I'm worried. Worried if we make a big deal''',
            '''about seeing each other, you might get hurt."'''],
        ['''"Oh come on, I'll be-"'''],
        ['''"No, listen to me," says Carrie sharply, turning and giving''', name(), '''an intense look. "I work in the hospital remember? I've seen it happen. Some''',
            '''poor Taironan brought in beaten half to death because he hooked up with some Carnutian girl, and her 'friends' didn't like it. Course, it's happened the''',
            '''other way too. Still, the point is it might be dangerous, and I don't want you hurt."'''],
        ['''"Carrie, I'm an adventurer," says''', name() + ".", '''"My job revolves around me being hurt."'''],
        ['''"I know, but this is different," says Carrie anxiously. "I don't know why, it just is."'''],
        ['''"Look, we don't have to rush into anything. I'm not even really asking if you want a 'deep meaningful relationship' or something. We can keep it casual.''',
            '''Spend time together, some casual sex. Not a big deal. Maybe we don't advertise it, but we don't have to stop. Assuming you want to continue."'''],
        ['''"Of course I do." Carrie lays back down, and snuggles up against him. "I just worry. I don't like how the city feels right now. Not at all."'''],
        ['''"We'll be fine," says''', name() + ".", '''He gives her a light kiss on the forehead. "Just go to sleep."'''],
        ['''Carrie nods. She puts her head against''', names(), '''chest, and closes her eyes.''', name(), '''does the same.'''],
        '\p'])

        
ep1_maria_home = Node(316)            
def ep1_maria_home_qf():
    music.play_music(MARIA)
    if 'lied_about_name' in keywords() or 'lied_about_Bonda' in keywords():
        quip = maria_lied(ep1_maria_home)
    elif 'slapped_Maria' in keywords() or 'disowned_Maria' in keywords():
        quip = maria_slap(ep1_maria_home)
    else:
        quip = universal.format_text([['''"Hey," says Maria, her eyes lighting up. "Good to see you found your way here."'''],
            [name(), '''shrugs. "Wasn't too hard. You gave pretty good directions."'''],
            ['''Maria grins. "So, I hear you had an interesting day."'''],
            ['''"Ugh, to say the least," says''', name() + ".", HeShe(), '''plops down next to the firepit and launches into a description of''', hisher(), '''day.'''],
        ['''Maria shakes her head when''', name(), '''finishes. "Ballsy move. Never imagined they'd attack the armory."'''],
        ['''"You know about them?" says''', name(), '''sharply.'''],
        ['''"Every Taironan in the city knows about them," says Maria. "You could hear the rumblings for months now. A strange, secretive group recruiting anyone with''',
            '''two arms, two legs, and a grudge against both the Carnutians, and the Potion Lords. Drug mules deserting, grown children vanishing, only to reappear a''',
            '''few weeks later armed to the teeth, and full of revolutionary zeal. Older folk growing worried, not letting their kids go out at night, reminiscing about''',
            '''the Riots. Skilled, eloquent men and women making speeches on street corners, deep in the slums and far away from the guards. A powerful slinger taking''',
            '''down dozens of Potion Lord lackeys."'''],
        ['''"So, what they were saying, about 'freeing us.' They were telling the truth?" asks''', name() + "."],
        ['''"As near as I can tell, they're sincere," says Maria uneasily. "Though I fail to see how sparking a two-front war with Avaricum and the Potion''',
        '''Lords 'frees' anybody."'''],
        [name(), '''nods thoughtfully.'''],
        ['''Maria stares down at the stew for a moment. Then, she shakes her head. '''],
        ep1_maria_live_question()])
    ep1_maria_home.quip = quip
ep1_maria_home.quip_function = ep1_maria_home_qf

ep1_maria_temper_spank = Node(317)
ep1_maria_temper_spank.comment = '''"If you really are sorry, you'll give me that wretched hairbrush and bend over!"'''
def ep1_maria_temper_spank_qf():
    increment_spankings_given()
    ep1_maria_temper_spank.quip = universal.format_text([['''Maria gnaws on her lip for a moment. Then, she nods. She hands the bone hairbrush to''', name() + ",", 
    '''turns around, and bends over to grasp her ankles.''']])
ep1_maria_spank_light = Node(318)
ep1_maria_spank_hard = Node(320)
ep1_maria_temper_spank.children = [ep1_maria_spank_light, ep1_maria_spank_hard]

ep1_maria_spank_light.comment = '''Spank her relatively lightly over her skirt.'''
def ep1_maria_spank_light_qf():
    ep1_maria_spank_light.quip = universal.format_text([[name(), '''considers Maria's bottom for a moment, then glances down at the hairbrush. "Were you really scared for me?"'''],
        ['''"Yes," says Maria, her voice thick.'''],
        ['''"Why?" asks''', name() + "."],
        ['''"Because you're like a little''', brothersister(), '''to me, and your stupid lie very nearly screwed you over for years at best, your whole cursed life''',
            '''at worst," says Maria.'''],
        [name(), '''taps the hairbrush against''', hisher(), '''palm.''', HeShe(), '''reaches back and massages''', hisher(), '''throbbing bottom. "Maybe I shouldn't''',
            '''have lied like that. But you shouldn't have spanked me so cursed hard!"'''],
        ['''"I know, I know," says Maria. "I'm sorry, I lost my temper."'''],
        ['''"Well, maybe this'll teach you to think twice before losing your temper," says''', name() + ",", '''drawing back the hairbrush.'''],
        [name(), '''administers a short paddling over Maria's skirt. By the end of it, Maria is squirming, and she cries out faintly after the last blow.'''] ,
        ['''"Alright," says''', name() + ",", '''setting the hairbrush on the ground. "We're done."'''],
        ['''Maria stands, rubbing her stinging bottom. "That felt a little bit lenient, don't you think?"'''],
        ['''"Yeah, but I just couldn't bring myself to paddle you any harder," says''', name() + ".", HeShe(), '''gives Maria a brief, forgiving hug. "You went too far''',
            '''but you did have my own good in mind."'''],
        ['''Maria gratefully returns the hug. "Thank you."'''],
        ['''"Just don't do it again," says''', name() + "."],
        ep1_maria_live_question(ep1_maria_spank_light)])
ep1_maria_spank_light.quip_function = ep1_maria_spank_light_qf

ep1_maria_spank_light.children = [ep1_maria_live, ep1_maria_dont_live]

ep1_maria_spank_hard.comment = '''Bare her bottom, and give her a thorough paddling.'''
def ep1_maria_spank_hard_qf():
    ep1_maria_spank_hard.quip = universal.format_text([[name(), '''brusquely flips up Maria's skirt, and yanks her shorts halfway down her thighs, exposing her''',
        '''small, muscled bottom. Maria clenches and unclenches anxiously, her fingers tightening around her ankles.''', HeShe(), '''taps the back of the hairbrush''',
        '''against''', hisher(), '''palm, while positioning''', himselfherself(), '''next to Maria's bent-over form.'''],
        [HeShe(), '''slowly draws the hairbrush back, and then snaps it down against Maria's right cheek. Maria cries out, rocking forward a little beneath the blow''',
        '''her small bottom jumping beneath the hard bone.''', name(), '''puts''', hisher(), '''left hand on the small of Maria's back for support, and lays it on''',
        '''good and hard, vigorously paddling Maria's small bottom. Maria squirms and bobs beneath the blows, sharp cries of pain bursting from her lips.'''],
        ['''"Keep still," scolds''', name(), '''as''', heshe(), '''cracks the hairbrush against Maria's bottom. "Or do you want me to accidentally strike your''',
        '''back?"'''],
        ['''Maria locks her knees and pushes her butt out, desperately trying to stay still while''', name(), '''darkens her naughty bottom.'''],
        ['''Eventually,''', name(), '''stops.''', HeShe(), '''takes a deep breath, and tosses the hairbrush on Maria's small pile of blankets. "Alright, I'm done."'''],
        ['''Maria slowly straightens, hissing and clutching at her sore bottom. She pulls her shorts up, hissing a second time as the tight material rubs against her''',
            '''tanned tushy. Then, she lets the skirt fall back down. She turns to''', name() + ",", '''wiping the tears from her face, and gives''', himher(), 
            '''a hesitant smile. "So, are we good?"'''],
        ['''"We're good," says''', name() + ",", '''giving Maria a hug. "Just don't do something like that again."'''],
        ['''"Just so long as you have a cursed good reason for lying to the guards next time," says Maria.'''],
        ['''"Of course. I'll make sure to warn you about it too," says''', name() + "."],
        ['''"Yes," says Maria uneasily.'''],
        ep1_maria_live_question(ep1_maria_spank_hard)])
ep1_maria_spank_hard.quip_function = ep1_maria_spank_hard_qf
ep1_maria_spank_hard.children = [ep1_maria_live, ep1_maria_dont_live]

def ep1_catalin():            
    universal.say(universal.format_text([['''\m"Hey. Hey, wakeup. Come on,''', name() + ".", '''Wake up."'''],
        [name(), '''stirs. "Who the-?''', '''Carrie, you have thirty seconds to be quiet and go back to sleep before I spank you silly.''' if 'taking_Carrie_home' in keywords() else
            '''Go away, 'fore I paddle your bottom."'''],
        ['''"Now is that any way to treat your sister after ten years?" asks the voice with more than a little mirth.'''],
        ['''"Sis-"''', names(), '''eyes fly open, and''', heshe(), '''bolts upright.'''],
        ['''There's a small flare of magic, and soon a small ball of light appears in the air in front of''', name() + ",", '''making''', himher(), 
        '''squint against the sudden, harsh glare.'''],
        ['''Crouched above''', himher(), '''is a Taironan woman in her early thirties. Her hair is cropped boy-short. She is curvier than Maria, but much more athletic than Elise. She is wearing a ragged bright red shirt, and''',
            '''an equally ragged pair of pale blue trousers. A sword is strapped to her back, its naked blade gleaming in the dim light. She smiles crookedly.'''],
        ['''"Cat..." says''', name(), '''in a quiet, breathless voice. "Oh, Cat!"'''],
        [name(), '''grabs''', hisher(), '''older sister Catalin in a fierce hug. "Amor de la Madre, I've missed you so much!"'''],
        ['''"I missed you too," says Catalin, returning the hug fiercely. "Oh Madre, how I've missed you. You and Nana both. Even Maria."''']]), justification=0, 
        music=[CATALIN])
    if 'taking_Carrie_home' in keywords() and 'boarding_with_Maria' in keywords():
        universal.say(universal.format_text([['''\n\n"Hey, Carrie, wake up," says''', name(), '''reaching over and giving Carrie a shove. "You need to meet my sister. Hey, Maria, look whose''',
            '''here!"'''],
            ['''Neither woman responds.'''],
            [name(), '''frowns, and gives Carrie another shake. "Carrie? Carrie!"'''],
            ['''"Relax," says Catalin in a comforting voice, reaching out and grabbing''', names(), '''hand. "They're just stunned. I don't want our talk to be''',
                '''interrupted is all."'''],
            ['''"What, you couldn't just ask to see me in private?" asks''', name(), '''sharply.'''],
            ['''Catalin grimaces. "I'd really rather neither of them sees me, or even learn I was here, alright?"'''],
            [name(), '''frowns. "Cat, what's this about?"''']]), justification=0)
    elif 'taking_Carrie_home' in keywords():
        universal.say(universal.format_text([['''\n\n"Hey, Carrie, wake up," says''', name(), '''reaching over and giving Carrie a shove. "You need to meet my sister."'''],
            ['''Carrie doesn't respond. Her body flops lifelessly on the bed.'''],
            [name(), '''frowns, and gives Carrie another shake. "Carrie? Carrie!"'''],
            ['''"Relax," says Catalin in a comforting voice, reaching out and grabbing''', names(), '''hand. "She's just stunned. I don't want our talk to be''',
                '''interrupted is all."'''],
            ['''"What, you couldn't just ask to see me in private?" snaps''', name() + "."],
            ['''Catalin grimaces. "I'd really rather she doesn't see me, or even learn I'm here, alright?"'''],
            [name(), '''frowns. "Cat, what's this about?"''']]), justification=0)
    elif 'boarding_with_Maria' in keywords():
        universal.say(universal.format_text([['''\n\n"Hey, Maria! Look whose here!" calls''', name(), '''to the small shape at the other end of the room.'''],
            ['''Maria doesn't respond, or even stir.'''],
            [name(), '''frowns. "Maria? Maria!"'''],
            ['''"Relax," says Catalin in a comforting voice, reaching out and grabbing''', names(), '''hand. "She's just stunned. I don't want our talk to be''',
                '''interrupted is all."'''],
            ['''"What, you couldn't just ask to see me in private?" snaps''', name() + "."],
            ['''Catalin grimaces. "I'd really rather she doesn't see me, or even learn I'm here, alright?"'''],
            [name(), '''frowns. "Cat, what's this about?"''']]), justification=0)
    universal.say(universal.format_text([['''\n\n"So, I hear you had an interesting day," says Catalin, sitting down on''', names(), '''bed.''' if 'boarding_with_Adrian' in keywords() else '''blankets.''',
        '''"Fighting Vengadores,''', '''lying to guards,''' if 'lied_about_Bonda' in keywords() or 'lied_about_name' in keywords() else '''getting interrogated by''',
        '''guards,''',
        '''partying with Sisters, and meeting the Captain of the Guard himself."''' if 'Elise_shows_you_around' in keywords() else 
        universal.format_line(['''getting a close up look at the Captain of the Guard himself."'''])],
        ['''"Indeed," says''', name(), '''suddenly wary. "You seem to know quite a bit about my day, even though we haven't seen each other at all."'''],
        ['''"I know people who pay attention," says Catalin.''']]), justification=0)
    if 'chastised_warslinger' in keywords():
        universal.say(universal.format_text([[''' "I've also heard that you're not particularly happy with the Vengadores."'''],
            ['''Thoughts of the first girl''', name(), '''fought flashes through''', hisher(), '''head.''', HeShe(), '''fingers''', hisher(), weapon().name + ".", 
            '''"There's an understatement. The next time I see one of those lunatics, I'm going to gut them."'''],
            ['''"Why?" asks Catalin, taken aback by''', names(), '''vehemence.'''],
            ['''"Because of what they did!" cries''', name() + ".", '''"Attacking the Guild like that is bad enough, but using a bunch of innocent men and women as''',
                '''slinger fodder? How many of them are rotting in some dungeon right now, for the crime of letting those crazies take advantage of their shitty lives?"'''],
            ['''"You're making a lot of assumptions there," says Catalin, a dangerous edge in her voice. "For one, you're assuming the majority of the attackers were 'tricked.' All the Vengadores''',
                '''did was convince them that their lives can be better. For another-"'''],
            ['''"Oh don't give me that," says''', name() + ".", '''"If that were the case, the Vengador brass would have actually bothered to train them before''',
                '''attacking the Guild."'''],
            ['''"Perhaps they had good reason for not training them much," says Catalin.'''],
            [name(), '''rolls''', hisher(), '''eyes. "Yeah? Like what?"'''],
            ['''Catalin shrugs. "I don't know."'''],
            [name(), '''grimaces and flops back down into''', hisher(), '''blankets. "Look, I love seeing you, but couldn't you come back at a reasonable hour? I'm''',
                '''tired."'''],
            ['''"I can't," says Catalin, looking uneasy for the first time. "I'm too busy."'''],
            ['''"Busy? With-"''', names(), '''eyes widen. "Padre de la Madre. You're one of them, aren't you? You're one of those pig-"'''],
            ['''"Now wait just a minute-" begins Catalin angrily.''']]), justification=0)
        universal.say(ep1_roland(), justification=0, music=[ROLAND])
    elif 'wimpy' in keywords():
        universal.say(universal.format_text([[''' "I've also heard you got a little bit beggy today in the Guild." Catalin's eyes sparkle with mirth.'''],
            [name(), '''grimaces. "I wasn't begging. I just didn't want to get dragged into some stupid war between the city guard and a gang with delusions of''',
            '''grandeur."'''],
            ['''"You may not have a choice," says Catalin, her mirth vanishing. "And I wouldn't call them delusions."'''],
            [name(), '''laughs scornfully. "You don't really think they have a chance do you? A bunch of poorly-fed, poorly-equipped, poorly-trained, Potion-addicted''',
                '''Taironans against the Avaricum Guard?"'''],
            ['''"If they're careful, smart, and have a little bit of luck, yes," says Catalin. She stands, and starts to pace. "Roland's competent, but he's not''',
                '''spectacular. Plus, his apparent honesty has not made him particularly popular with the other nobility. With a bit of careful politicking-"'''],
            ep1_roland()]),
            justification=0, music=[ROLAND])
    elif 'mercenary' in keywords():
        universal.say(universal.format_text([['''"So I hear you're more than a little interested in the Vengadores," says Catalin, smiling.'''],
            [name(), '''shrugs. "Maybe, but they didn't seem particularly interested in me."'''],
            ['''"They don't trust you," says Catalin, rubbing her hands together.'''],
            [name(), '''frowns. "Are you-"'''],
            ['''Catalin's smile widens. "Do me a favor, alright? Befriend Sister Elise. Get to know-"'''], ep1_roland()]), justification=0, music=[ROLAND])
    p.PC.currentEpisode.end_episode()

def ep1_roland():
    return universal.format_text([[''' She stops. Her eyes narrow, and she spins to face the door, her notched''',
        '''blade in one fist, the other bursting into flame.''', '''\mThe door slams open, and four city guards charge in. Standing in their midst, his''',
    '''superbly-crafted''',
            '''blade gripped in both hands, is Roland, the Captain of the Avaricum City Guard. Standing next to him is the woman who interrogated''', name(), '''in the guild.'''],
                ['''"What in-"'''],
                ['''"You, Catalin of Chengue," says Roland, pointing his blade at Catalin. "Are under arrest for terrorist actions against the City of Avaricum. Drop''',
                    '''your sword and surrender, or face the consequences."'''],
                ['''Catalin glances between the guards, and''', name() + ",", '''her eyes wide. "They've hooked you haven't they?"'''],
                ['''"I-"'''],
                ['''"I said, surrender now!" barks Roland. "This is your last warning."'''],
                ['''Catalin sags. The tip of her blade touches the ground, and the flames wreathing her fist go out. "Very well. Can you at least give me a minute to say good-bye to my''', brothersister() + '?"'],
                ['''Roland grimaces, but slowly nods. "No sudden movements."'''],
                ['''Catalin nods. She leans down, and kisses''', name(), '''lightly on the forehead. "I'll find a way to free you. I promise."'''],
                ['''Then, she pivots towards the guards, her hand sweeping in front of her. A wave of spectral magic slams into the guards' legs, toppling them. She''',
                    '''bolts for the door, kicking one guard in the face, while blocking an awkward thrust from Roland.''', names(),  '''interrogator manages to grab her''',
                    '''leg, but a knee to the nose slams the puppeteer against the wall.'''],
                ['''Roland swears as the light-footed Taironan dashes out. "After her! Now!"'''],
                ['''The other three guards scramble to their feet, and bolt after her, while Roland regains his feet more slowly. "Wretched plate."'''],
                ['''"What in La Madre's name are you doing here?" cries''', name(), '''angrily,''', hisher(), '''fist clenched around''', hisher(), '''weapon.'''],
                ['''Roland sheathes his sword, and straightens his cape. "When we learned who you were, and who your sister was, we figured it'd only be a matter of''',
                '''time before she''',
                    '''dropped in and said hi. So I had a couple of my people tail you."''' + 
                    (''' His lips twist. "It's how I found out about Elise's little escapade, incidentally."''' if 'Elise_shows_you_around' in keywords() else '')],
                ['''"How did you find out about my sister?" asks''', name() + ".", '''"I never-"'''],
                ['''"I am very good at my job," says Roland sharply. "Best remember that, if you ever consider trying to join her. Enjoy the rest of your night."'''],
                ['''Roland turns on his bootheel and leaves. Catalin's light orb winks out, and the room is once more bathed in darkness.''']])
                    
#-----------------------------------------------End Episode 1: Tension---------------------------------------------------------------------
episode1 = episode.Episode(1, 'Tension', scenes=[episode1Scene1, episode1Scene2, episode1Scene3], titleTheme=VENGADOR) 

#----------------------------------------------Episode 2: Back Alleys-------------------------------------------------------------------
def initialize_episode_2():
    pass

def start_scene_1_episode_2(loading=False):
    universal.say_title('Next time on Pandemonium Cycle: The Potion Wars')
    universal.say(['\m\n\n' + p.PC.name, 'finally receives', hisher(), 'first job:', heshe(p.PC), 'must travel deep into the slums and track down a thief.''',
    '''Not so unusual, except''', heshe(), '''has to protect the thief once''', heshe(), '''finds her! Who is this thief, and why does somebody want her protected''',
    '''so badly?\n\n''',
        'Meanwhile, Carrie is becoming a full Sister! Will', p.PC.name, 'be able to attend the ceremony (or at least make it to the after party)? Will', heshe(p.PC), 'even want to?\n\n Tune in next time to learn the answers to these questions and more!'], music=[music.THEME])
    universal.set_commands('Press Enter to save')
    universal.set_command_interpreter(end_content_interpreter)

def end_content_interpreter(keyEvent):    
    townmode.go(offStage)
    clear_screen()
    if keyEvent.key == K_RETURN:
        townmode.save(end_content_mode)

def end_content_mode():
    universal.say(universal.format_line(['''That's the end of the content, I hope you've enjoyed playing this far. If you have any comments, criticisms, questions, bug reports, or anything else, either comment on my blog''',
            '''spankingrpgs.blogspot.com, or send me an e-mail at sprpgs@gmail.com (please post bug reports on the blog however, so that others can see them). Criticisms are welcome, however please keep them constructive. Saying "This game''',
            '''sucks!" tells me nothing except that you didn't like it. Saying "Your combat system felt unbalanced. The magic was way too powerful." tells  me much much more.''']))
    universal.set_commands(['(Esc) To exit'])
    universal.set_command_interpreter(quit_interpreter)
            

        
def end_scene_1_episode_2():
    pass

episode2Scene1 = episode.Scene('Episode 2 Scene 1', start_scene_1_episode_2, end_scene_1_episode_2)
episode2 = episode.Episode(2, 'Back Alleys', scenes=[episode2Scene1])
#--------------------------------------------End Episode 2: Back Alleys-------------------------------------------------------------------------
episode1.nextEpisode = episode2
import logging, logging.handlers
errorLog = logging.getLogger("errors")
errorLog.setLevel(logging.ERROR)
with open("errors.log", 'w') as f:
    pass
errorLog.addHandler(logging.FileHandler("errors.log"))
try:
    eng.begin_game(episode1)
except Exception, e:
    errorLog.exception("My life is pain!")
    raise
